var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "home_location",
            merge: false,
            personal: true
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER_HOME_LOCATION"
        });
        return Model;
    }
};

model = Alloy.M("home_location", exports.definition, []);

collection = Alloy.C("home_location", exports.definition, model);

exports.Model = model;

exports.Collection = collection;