var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        },
        background: true
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: url.USER_LAST_LOCATION
        });
        return Model;
    }
};

model = Alloy.M("last_location", exports.definition, []);

collection = Alloy.C("last_location", exports.definition, model);

exports.Model = model;

exports.Collection = collection;