var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            activePromoCode: function(promoCode, options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").PROMO_CODE, {
                    code: promoCode
                });
                options.lat && (options.url = options.url + "?lat=" + options.lat);
                options.lon && (options.url = options.url + "&lon=" + options.lon);
                return this.save(null, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("promo_code", exports.definition, []);

collection = Alloy.C("promo_code", exports.definition, model);

exports.Model = model;

exports.Collection = collection;