var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "RIDE_HISTORY",
            parse: function(response) {
                return response;
            }
        });
        return Model;
    }
};

model = Alloy.M("ride_history", exports.definition, []);

collection = Alloy.C("ride_history", exports.definition, model);

exports.Model = model;

exports.Collection = collection;