var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "TRIP_REQUEST_URL",
            method: "FACEBOOK"
        });
        return Model;
    }
};

model = Alloy.M("share_request", exports.definition, []);

collection = Alloy.C("share_request", exports.definition, model);

exports.Model = model;

exports.Collection = collection;