var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        },
        urlMap: {
            POST: "SIGN_UP_URL",
            PUT: "USER"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            idAttribute: "userId"
        });
        return Model;
    }
};

model = Alloy.M("signup", exports.definition, []);

collection = Alloy.C("signup", exports.definition, model);

exports.Model = model;

exports.Collection = collection;