var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "STATIC_MAP"
        });
        return Model;
    }
};

model = Alloy.M("static_map", exports.definition, []);

collection = Alloy.C("static_map", exports.definition, model);

exports.Model = model;

exports.Collection = collection;