var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            addCard: function(userId, paymentProvider, userPaymentToken, options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").STRIPE_PAYMENT_PROVIDER, {
                    userId: userId,
                    paymentProvider: paymentProvider
                });
                return this.save(userPaymentToken, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("stripe_add_card", exports.definition, []);

collection = Alloy.C("stripe_add_card", exports.definition, model);

exports.Model = model;

exports.Collection = collection;