var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            redeem: function(code, options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").REDEEM, {
                    userId: "SELF",
                    code: code
                });
                options.url = options.url + "?addAsFavourite=true";
                options.lat && (options.url = options.url + "&lat=" + options.lat);
                options.lon && (options.url = options.url + "&lon=" + options.lon);
                return this.save(null, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("user_redeem", exports.definition, []);

collection = Alloy.C("user_redeem", exports.definition, model);

exports.Model = model;

exports.Collection = collection;