function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.activity/" + s : s.substring(0, index) + "/ma.car.app.activity/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.activity");
    this.__widgetId = "ma.car.app.activity";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "activity_window";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.activityWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        height: "100%",
        top: Alloy.Globals.Style.Size.Height.pct99,
        visible: false,
        backgroundColor: "#FFF",
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "activityWindow"
    });
    $.__views.activityWindow && $.addTopLevelView($.__views.activityWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    !function() {
        var navigation = Alloy.Globals.Nav.Activity = Alloy.createController("navigation");
        var widget = null;
        widget = Alloy.createWidget("ma.car.app.activity", "feed");
        $.activityWindow.addEventListener("open", function handler() {
            $.activityWindow.removeEventListener("open", handler);
            setTimeout(function() {
                widget.init();
                $.activityWindow.addEventListener("close", function handler() {
                    Alloy.Globals.Nav.Activity = null;
                    $.activityWindow.removeEventListener("close", handler);
                    widget.onDestroy();
                    widget = null;
                    $.activityWindow = null;
                });
            }, 500);
        });
        var resourceOwner = require("services/resource_owner_service").singleton(), title = "";
        title = L("widget_activity_feed_header");
        navigation.init({
            index: widget,
            historyLimit: 20,
            mainWindow: $.activityWindow,
            modal: true,
            handleClose: args.handleClose,
            transition: "none",
            title: title.toUpperCase()
        });
        navigation = null;
        $.activityWindow.addAppEventListener("carma:open.conversation", function() {
            $.activityWindow.close();
        });
    }();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;