function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.activity/" + s : s.substring(0, index) + "/ma.car.app.activity/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.activity");
    this.__widgetId = "ma.car.app.activity";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "feed";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.feedContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        id: "feedContainer"
    });
    $.__views.feedContainer && $.addTopLevelView($.__views.feedContainer);
    $.__views.feedWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        id: "feedWrapper"
    });
    $.__views.feedContainer.add($.__views.feedWrapper);
    $.__views.loading = Ti.UI.createActivityIndicator({
        top: "60dp",
        style: Ti.UI.ActivityIndicatorStyle.PLAIN,
        id: "loading"
    });
    $.__views.feedWrapper.add($.__views.loading);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var os = require("/platform/os");
    exports = new (require("/carmalib/controller").extend($, {
        events: {},
        _widget: null,
        initialize: function() {
            $.loading.show();
        },
        init: function() {
            this._widget = Alloy.createWidget("ma.car.app.activity", "listView");
            $.feedWrapper.add(this._widget.getView());
            $.feedWrapper.remove($.loading);
            this._widget.load();
        },
        _customizeIOS6: function() {
            $.feedWrapper.width = "100%";
        },
        onDestroy: function() {
            this._widget.onDestroy();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;