function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.activity/" + s : s.substring(0, index) + "/ma.car.app.activity/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.activity");
    this.__widgetId = "ma.car.app.activity";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "listView";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    var __alloyId723 = {};
    var __alloyId726 = [];
    var __alloyId728 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId729 = [];
            var __alloyId731 = {
                type: "Ti.UI.Label",
                bindId: "date",
                properties: {
                    color: Alloy.Globals.Style.Color.Orange,
                    width: "91.66666666666666%",
                    font: {
                        fontSize: "12dp"
                    },
                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                    bindId: "date"
                }
            };
            __alloyId729.push(__alloyId731);
            var __alloyId733 = {
                type: "Ti.UI.View",
                properties: {
                    bottom: 0,
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray
                }
            };
            __alloyId729.push(__alloyId733);
            return __alloyId729;
        }(),
        properties: {
            width: "100%",
            height: "30dp",
            top: "0dp",
            backgroundColor: "transparent"
        }
    };
    __alloyId726.push(__alloyId728);
    var __alloyId725 = {
        properties: {
            width: "100%",
            height: "30dp",
            backgroundColor: "transparent",
            name: "timestampHeaderTemplate"
        },
        childTemplates: __alloyId726
    };
    __alloyId723["timestampHeaderTemplate"] = __alloyId725;
    var __alloyId736 = [];
    var __alloyId738 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId739 = [];
            var __alloyId741 = {
                type: "Ti.UI.Label",
                bindId: "carCount",
                properties: {
                    color: Alloy.Globals.Style.Color.Orange,
                    font: {
                        fontSize: "36dp"
                    },
                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                    left: 0,
                    width: "48dp",
                    bindId: "carCount"
                }
            };
            __alloyId739.push(__alloyId741);
            var __alloyId743 = {
                type: "Ti.UI.Label",
                bindId: "detail",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "12dp"
                    },
                    left: "60dp",
                    height: "60dp",
                    right: "90dp",
                    bindId: "detail"
                }
            };
            __alloyId739.push(__alloyId743);
            var __alloyId745 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId746 = [];
                    var __alloyId747 = {
                        type: "Ti.UI.Label",
                        properties: {
                            color: "#333",
                            font: {
                                fontSize: "15dp"
                            },
                            left: "12dp",
                            right: "12dp",
                            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                            width: Ti.UI.SIZE,
                            text: L("widget_activity_lbl_share"),
                            title: "Share"
                        }
                    };
                    __alloyId746.push(__alloyId747);
                    return __alloyId746;
                }(),
                properties: {
                    right: 0,
                    width: "88dp",
                    height: "40dp",
                    top: "9dp",
                    bottom: "9dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit3,
                    borderColor: Alloy.Globals.Style.Color.DarkGray,
                    borderWidth: "1px"
                }
            };
            __alloyId739.push(__alloyId745);
            return __alloyId739;
        }(),
        properties: {
            top: 0,
            left: 0,
            right: 0,
            height: "60dp",
            backgroundColor: "transparent"
        }
    };
    __alloyId736.push(__alloyId738);
    var __alloyId749 = {
        type: "Ti.UI.View",
        properties: {
            bottom: 0,
            height: "1px",
            backgroundColor: Alloy.Globals.Style.Color.DarkGray
        }
    };
    __alloyId736.push(__alloyId749);
    var __alloyId735 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "carsOffRoadTemplate"
        },
        childTemplates: __alloyId736
    };
    __alloyId723["carsOffRoadTemplate"] = __alloyId735;
    var __alloyId752 = [];
    var __alloyId754 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId755 = [];
            var __alloyId757 = {
                type: "Ti.UI.ImageView",
                bindId: "avatar",
                properties: {
                    defaultImage: "/images/default_photo_male-rounded.png",
                    backgroundColor: "#fff",
                    borderColor: "#fff",
                    borderWidth: 1,
                    left: 0,
                    width: "48dp",
                    height: "48dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit24,
                    bindId: "avatar"
                }
            };
            __alloyId755.push(__alloyId757);
            var __alloyId759 = {
                type: "Ti.UI.Label",
                bindId: "role",
                properties: {
                    color: "#ff6600",
                    font: {
                        fontFamily: "splinico",
                        fontSize: "12dp"
                    },
                    height: "18dp",
                    width: "15dp",
                    zIndex: 99,
                    left: "59dp",
                    top: "5dp",
                    visible: false,
                    bindId: "role"
                }
            };
            __alloyId755.push(__alloyId759);
            var __alloyId761 = {
                type: "Ti.UI.Label",
                bindId: "name",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    left: "59dp",
                    right: "96dp",
                    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
                    top: "4dp",
                    height: "20dp",
                    ellipsize: true,
                    wordWrap: false,
                    zIndex: 1,
                    bindId: "name"
                }
            };
            __alloyId755.push(__alloyId761);
            var __alloyId763 = {
                type: "Ti.UI.Label",
                bindId: "message",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    left: "59dp",
                    top: "21dp",
                    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
                    bottom: "5dp",
                    bindId: "message"
                }
            };
            __alloyId755.push(__alloyId763);
            return __alloyId755;
        }(),
        properties: {
            top: 0,
            left: 0,
            right: 0,
            height: "60dp",
            backgroundColor: "transparent"
        }
    };
    __alloyId752.push(__alloyId754);
    var __alloyId765 = {
        type: "Ti.UI.View",
        properties: {
            bottom: 0,
            height: "1px",
            backgroundColor: Alloy.Globals.Style.Color.DarkGray
        }
    };
    __alloyId752.push(__alloyId765);
    var __alloyId751 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "carpoolTripTemplate"
        },
        childTemplates: __alloyId752
    };
    __alloyId723["carpoolTripTemplate"] = __alloyId751;
    var __alloyId768 = [];
    var __alloyId770 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId771 = [];
            var __alloyId773 = {
                type: "Ti.UI.ImageView",
                bindId: "avatar",
                properties: {
                    defaultImage: "/images/default_photo_male-rounded.png",
                    backgroundColor: "#fff",
                    borderColor: "#fff",
                    borderWidth: 1,
                    left: 0,
                    width: "48dp",
                    height: "48dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit24,
                    bindId: "avatar"
                }
            };
            __alloyId771.push(__alloyId773);
            var __alloyId775 = {
                type: "Ti.UI.Label",
                bindId: "name",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    left: "59dp",
                    right: "96dp",
                    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
                    top: "4dp",
                    height: "20dp",
                    ellipsize: true,
                    wordWrap: false,
                    zIndex: 1,
                    bindId: "name"
                }
            };
            __alloyId771.push(__alloyId775);
            var __alloyId777 = {
                type: "Ti.UI.Label",
                bindId: "message",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    left: "59dp",
                    top: "21dp",
                    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
                    right: "96dp",
                    height: "19dp",
                    ellipsize: true,
                    wordWrap: false,
                    bottom: "5dp",
                    bindId: "message"
                }
            };
            __alloyId771.push(__alloyId777);
            var __alloyId779 = {
                type: "Ti.UI.View",
                bindId: "welcomeContainer",
                childTemplates: function() {
                    var __alloyId780 = [];
                    var __alloyId781 = {
                        type: "Ti.UI.Label",
                        bindId: "welcome",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            left: "12dp",
                            right: "12dp",
                            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                            width: Ti.UI.SIZE,
                            text: L("widget_activity_feed_welcome_button"),
                            bindId: "welcome"
                        }
                    };
                    __alloyId780.push(__alloyId781);
                    var __alloyId782 = {
                        type: "Ti.UI.ActivityIndicator",
                        bindId: "progress",
                        properties: {
                            visible: false,
                            style: Ti.UI.ActivityIndicatorStyle.PLAIN,
                            bindId: "progress"
                        }
                    };
                    __alloyId780.push(__alloyId782);
                    return __alloyId780;
                }(),
                properties: {
                    right: 0,
                    width: "88dp",
                    height: "40dp",
                    top: "9dp",
                    bottom: "9dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit3,
                    borderColor: Alloy.Globals.Style.Color.DarkGray,
                    borderWidth: 0,
                    backgroundColor: "#ff6600",
                    bindId: "welcomeContainer"
                }
            };
            __alloyId771.push(__alloyId779);
            var __alloyId784 = {
                type: "Ti.UI.Label",
                bindId: "welcomeMessage",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "12dp"
                    },
                    right: "96dp",
                    left: "59dp",
                    verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
                    bottom: "4dp",
                    bindId: "welcomeMessage"
                }
            };
            __alloyId771.push(__alloyId784);
            return __alloyId771;
        }(),
        properties: {
            top: 0,
            left: 0,
            right: 0,
            height: "60dp",
            backgroundColor: "transparent"
        }
    };
    __alloyId768.push(__alloyId770);
    var __alloyId786 = {
        type: "Ti.UI.View",
        properties: {
            bottom: 0,
            height: "1px",
            backgroundColor: Alloy.Globals.Style.Color.DarkGray
        }
    };
    __alloyId768.push(__alloyId786);
    var __alloyId767 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "newUserTemplate"
        },
        childTemplates: __alloyId768
    };
    __alloyId723["newUserTemplate"] = __alloyId767;
    var __alloyId789 = [];
    var __alloyId791 = {
        type: "Ti.UI.Label",
        properties: {
            color: Alloy.Globals.Style.Color.DarkGray,
            width: "91.66666666666666%",
            font: {
                fontSize: "12dp"
            },
            text: L("widget_activity_no_data"),
            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
        }
    };
    __alloyId789.push(__alloyId791);
    var __alloyId788 = {
        properties: {
            backgroundColor: "#80333333",
            height: "40dp",
            left: 0,
            name: "noActivityTemplate"
        },
        childTemplates: __alloyId789
    };
    __alloyId723["noActivityTemplate"] = __alloyId788;
    $.__views.tripFeedSection = Alloy.createWidget("ma.car.app.activity", "tripFeed", {
        id: "tripFeedSection",
        __parentSymbol: __parentSymbol
    });
    var __alloyId792 = [];
    __alloyId792.push($.__views.tripFeedSection.getViewEx({
        recurse: true
    }));
    $.__views.list = Ti.UI.createListView({
        defaultItemTemplate: "carpoolTripTemplate",
        backgroundColor: "transparent",
        top: 0,
        left: 0,
        right: 0,
        showVerticalScrollIndicator: false,
        separatorColor: "transparent",
        needPullRefresh: true,
        height: Ti.UI.SIZE,
        sections: __alloyId792,
        templates: __alloyId723,
        id: "list"
    });
    $.__views.list && $.addTopLevelView($.__views.list);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var os = require("/platform/os"), trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager");
    exports = new (require("/carmalib/controller").extend($, {
        _tripFeedController: null,
        _executingAction: false,
        events: {
            "itemclick list": "_listItemClicked"
        },
        initialize: function() {
            _.bindAll(this, "_loaded", "_reload");
            $.tripFeedSection.list = $.list;
            this._tripFeedController = $.tripFeedSection;
            $.list.addEventListener("didTriggeredRefresh", this._reload);
        },
        onDestroy: function() {
            $.list.removeEventListener("didTriggeredRefresh", this._reload);
        },
        load: function() {
            this._tripFeedController.loadCache();
        },
        reloadFeed: function() {
            this._tripFeedController.load();
        },
        _reload: function(argument) {
            var self = this;
            this._tripFeedController.load(true).finally(function() {
                self._loaded();
            });
        },
        _loaded: function() {
            $.list.cmMarkRefreshFinished && $.list.cmMarkRefreshFinished();
        },
        _listItemClicked: function(e) {
            var item = e.section.getItemAt(e.itemIndex);
            item.backgroundColor = "transparent";
            if (this._executingAction) return;
            if ("noActivityTemplate" === item.template || "timestampHeaderTemplate" === item.template) {
                this._executingAction = false;
                return;
            }
            if (!e.bindId) {
                this.executingAction = false;
                return;
            }
            this._executingAction = true;
            if ("welcome" === e.bindId || "welcomeContainer" === e.bindId) {
                this._sendWelcome(item.properties.username, item.properties.firstName, item.properties.userId, item, e.itemIndex, e.section);
                this._executingAction = false;
                return;
            }
            if ("avatar" === e.bindId || "name" === e.bindId || "message" === e.bindId || "role" === e.bindId) {
                this._openUserProfile(item.properties.userId);
                this.executingAction = false;
                return;
            }
            this._executingAction = false;
        },
        _openUserProfile: function(userId) {
            if (!userId) return;
            Ti.App.fireEvent("carma:profile.open", {
                userId: userId
            });
            var self = this;
            setTimeout(function() {
                self._executingAction = false;
            }, 500);
            TM.push(function() {
                analytics.track(trackingEvent.ACTIVITY_FEED_VIEW_PROFILE, {
                    targetUserId: userId
                });
            }, process.backgroundDomain);
        },
        _sendWelcome: function(username, firstName, targetUserId, listItem, itemIndex, section) {
            var personalisedMessage = String.format(L("widget_activity_default_welcome_message_personal"), firstName);
            var welcome = Alloy.createModel("welcome_user", {
                urlParams: {
                    userId: targetUserId
                }
            });
            welcome.set("body", personalisedMessage);
            listItem.progress.visible = true;
            listItem.welcome.visible = false;
            section.updateItemAt(itemIndex, listItem);
            return welcome.save().then(function(data) {
                listItem.properties.numWelcomes++;
                var welcomeMessage = "";
                welcomeMessage = 1 === listItem.properties.numWelcomes ? String.format(L("widget_activity_feed_one_welcome"), "" + listItem.properties.numWelcomes) : String.format(L("widget_activity_feed_multiple_welcomes"), "" + listItem.properties.numWelcomes);
                listItem.welcomeMessage.text = welcomeMessage;
                listItem.welcomeContainer.visible = false;
                section.updateItemAt(itemIndex, listItem);
                TM.push(function() {
                    analytics.track(trackingEvent.ACTIVITY_FEED_WELCOME, {
                        targetUserId: targetUserId
                    });
                }, process.backgroundDomain);
                setTimeout(function() {
                    section.updateItemAt(itemIndex, listItem);
                    require("services/activity_service").findAll();
                }, 300);
            }).catch(function() {
                LOGGER.error("Error sending welcome message");
            });
        },
        _customizeIOS6: function() {
            this._tripFeedController.customizeIOS6();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;