function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.activity/" + s : s.substring(0, index) + "/ma.car.app.activity/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

module.exports = [ {
    isApi: true,
    priority: 1000.0035,
    key: "Label",
    style: {
        color: "#fff"
    }
}, {
    isApi: true,
    priority: 1000.0101,
    key: "TextField",
    style: {
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        }
    }
}, {
    isApi: true,
    priority: 1000.0102,
    key: "TextArea",
    style: {
        paddingLeft: "10dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        }
    }
}, {
    isApi: true,
    priority: 1000.0122,
    key: "Window",
    style: {
        orientationModes: [ Ti.UI.PORTRAIT ]
    }
}, {
    isApi: true,
    priority: 1000.0201,
    key: "ImageView",
    style: {
        defaultImage: "/images/none.png"
    }
}, {
    isClass: true,
    priority: 10000.0001,
    key: "orange",
    style: {
        color: Alloy.Globals.Style.Color.Orange
    }
}, {
    isClass: true,
    priority: 10000.0002,
    key: "link",
    style: {
        color: "#003366"
    }
}, {
    isClass: true,
    priority: 10000.0003,
    key: "light-blue",
    style: {
        color: Alloy.Globals.Style.Color.LightBlue
    }
}, {
    isClass: true,
    priority: 10000.0004,
    key: "dark-blue",
    style: {
        color: Alloy.Globals.Style.Color.DarkBlue
    }
}, {
    isClass: true,
    priority: 10000.0005,
    key: "black",
    style: {
        color: "#000"
    }
}, {
    isClass: true,
    priority: 10000.0006,
    key: "white",
    style: {
        color: "#fff"
    }
}, {
    isClass: true,
    priority: 10000.0007,
    key: "ios-blue",
    style: {
        color: "007aff"
    }
}, {
    isClass: true,
    priority: 10000.0008,
    key: "dark-gray",
    style: {
        color: Alloy.Globals.Style.Color.DarkGray
    }
}, {
    isClass: true,
    priority: 10000.0009,
    key: "col-rel-1",
    style: {
        width: "8.333333333333332%"
    }
}, {
    isClass: true,
    priority: 10000.001,
    key: "col-rel-2",
    style: {
        width: "16.666666666666664%"
    }
}, {
    isClass: true,
    priority: 10000.0011,
    key: "col-rel-3",
    style: {
        width: "25%"
    }
}, {
    isClass: true,
    priority: 10000.0012,
    key: "col-rel-4",
    style: {
        width: "33.33333333333333%"
    }
}, {
    isClass: true,
    priority: 10000.0013,
    key: "col-rel-5",
    style: {
        width: "41.66666666666667%"
    }
}, {
    isClass: true,
    priority: 10000.0014,
    key: "col-rel-6",
    style: {
        width: "50%"
    }
}, {
    isClass: true,
    priority: 10000.0015,
    key: "col-rel-7",
    style: {
        width: "58.333333333333336%"
    }
}, {
    isClass: true,
    priority: 10000.0016,
    key: "col-rel-8",
    style: {
        width: "66.66666666666666%"
    }
}, {
    isClass: true,
    priority: 10000.0017,
    key: "col-rel-9",
    style: {
        width: "75%"
    }
}, {
    isClass: true,
    priority: 10000.0018,
    key: "col-rel-10",
    style: {
        width: "83.33333333333334%"
    }
}, {
    isClass: true,
    priority: 10000.0019,
    key: "col-rel-11",
    style: {
        width: "91.66666666666666%"
    }
}, {
    isClass: true,
    priority: 10000.002,
    key: "col-rel-12",
    style: {
        width: "100%"
    }
}, {
    isClass: true,
    priority: 10000.0021,
    key: "col-abs-1",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid1
    }
}, {
    isClass: true,
    priority: 10000.0022,
    key: "col-abs-2",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid2
    }
}, {
    isClass: true,
    priority: 10000.0023,
    key: "col-abs-3",
    style: {
        width: Alloy.Globals.Style.Size.Width.pct25
    }
}, {
    isClass: true,
    priority: 10000.0024,
    key: "col-abs-4",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid4
    }
}, {
    isClass: true,
    priority: 10000.0025,
    key: "col-abs-5",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid5
    }
}, {
    isClass: true,
    priority: 10000.0026,
    key: "col-abs-6",
    style: {
        width: Alloy.Globals.Style.Size.Width.pct50
    }
}, {
    isClass: true,
    priority: 10000.0027,
    key: "col-abs-7",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid7
    }
}, {
    isClass: true,
    priority: 10000.0028,
    key: "col-abs-8",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid8
    }
}, {
    isClass: true,
    priority: 10000.0029,
    key: "col-abs-9",
    style: {
        width: Alloy.Globals.Style.Size.Width.pct75
    }
}, {
    isClass: true,
    priority: 10000.003,
    key: "col-abs-10",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid10
    }
}, {
    isClass: true,
    priority: 10000.0031,
    key: "col-abs-11",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid11
    }
}, {
    isClass: true,
    priority: 10000.0032,
    key: "col-abs-12",
    style: {
        width: Alloy.Globals.Style.Size.Width.pct100
    }
}, {
    isClass: true,
    priority: 10000.0033,
    key: "col-auto-size",
    style: {
        width: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0034,
    key: "fill",
    style: {
        width: Ti.UI.FILL
    }
}, {
    isClass: true,
    priority: 10000.0036,
    key: "text-muted",
    style: {
        color: Alloy.Globals.Style.Color.LightGrey
    }
}, {
    isClass: true,
    priority: 10000.0037,
    key: "lbl-smallest",
    style: {
        font: {
            fontSize: "10dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0038,
    key: "lbl-smallest-bold",
    style: {
        font: {
            fontSize: "10dp",
            fontWeight: "bold"
        }
    }
}, {
    isClass: true,
    priority: 10000.0039,
    key: "lbl-small",
    style: {
        font: {
            fontSize: "12dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.004,
    key: "lbl-small-bold",
    style: {
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        }
    }
}, {
    isClass: true,
    priority: 10000.0041,
    key: "lbl-medium",
    style: {
        font: {
            fontSize: "15dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0042,
    key: "lbl-medium-bold",
    style: {
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        }
    }
}, {
    isClass: true,
    priority: 10000.0043,
    key: "lbl-large",
    style: {
        font: {
            fontSize: "18dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0044,
    key: "lbl-large-bold",
    style: {
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        }
    }
}, {
    isClass: true,
    priority: 10000.0045,
    key: "lbl-largest",
    style: {
        font: {
            fontSize: "36dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0046,
    key: "lbl-shadow",
    style: {
        shadowColor: "#70000000",
        shadowOffset: {
            x: 1,
            y: 1
        }
    }
}, {
    isClass: true,
    priority: 10000.0047,
    key: "icon",
    style: {
        font: {
            fontFamily: "splinico"
        }
    }
}, {
    isClass: true,
    priority: 10000.0048,
    key: "icon-arrow-left",
    style: {
        text: "e",
        title: "e"
    }
}, {
    isClass: true,
    priority: 10000.0049,
    key: "icon-arrow-down",
    style: {
        text: "L",
        title: "L"
    }
}, {
    isClass: true,
    priority: 10000.005,
    key: "icon-ok",
    style: {
        text: "c"
    }
}, {
    isClass: true,
    priority: 10000.0051,
    key: "icon-camera",
    style: {
        text: "a"
    }
}, {
    isClass: true,
    priority: 10000.0052,
    key: "icon-facebook",
    style: {
        text: "f"
    }
}, {
    isClass: true,
    priority: 10000.0053,
    key: "icon-envelope",
    style: {
        text: "b"
    }
}, {
    isClass: true,
    priority: 10000.0054,
    key: "icon-angle-right",
    style: {
        text: "d"
    }
}, {
    isClass: true,
    priority: 10000.0055,
    key: "icon-play",
    style: {
        text: "g"
    }
}, {
    isClass: true,
    priority: 10000.0056,
    key: "icon-play-reverse",
    style: {
        text: "v"
    }
}, {
    isClass: true,
    priority: 10000.0057,
    key: "icon-cancel",
    style: {
        text: "h"
    }
}, {
    isClass: true,
    priority: 10000.0058,
    key: "icon-location-pointer",
    style: {
        text: "k"
    }
}, {
    isClass: true,
    priority: 10000.0059,
    key: "icon-gear",
    style: {
        text: "u"
    }
}, {
    isClass: true,
    priority: 10000.006,
    key: "icon-heart-full",
    style: {
        text: "j"
    }
}, {
    isClass: true,
    priority: 10000.0061,
    key: "icon-heart-empty",
    style: {
        text: "i"
    }
}, {
    isClass: true,
    priority: 10000.0062,
    key: "icon-trip",
    style: {
        text: "s"
    }
}, {
    isClass: true,
    priority: 10000.0063,
    key: "icon-piggy-bank",
    style: {
        text: "t"
    }
}, {
    isClass: true,
    priority: 10000.0064,
    key: "icon-rating-star-full",
    style: {
        text: "p"
    }
}, {
    isClass: true,
    priority: 10000.0065,
    key: "icon-group",
    style: {
        text: "q"
    }
}, {
    isClass: true,
    priority: 10000.0066,
    key: "icon-car",
    style: {
        text: "r"
    }
}, {
    isClass: true,
    priority: 10000.0067,
    key: "icon-prev",
    style: {
        text: "m"
    }
}, {
    isClass: true,
    priority: 10000.0068,
    key: "icon-next",
    style: {
        text: "l"
    }
}, {
    isClass: true,
    priority: 10000.0069,
    key: "icon-bookmark",
    style: {
        text: "w"
    }
}, {
    isClass: true,
    priority: 10000.007,
    key: "icon-poke",
    style: {
        text: "x"
    }
}, {
    isClass: true,
    priority: 10000.0071,
    key: "icon-arrow-up",
    style: {
        text: "y"
    }
}, {
    isClass: true,
    priority: 10000.0072,
    key: "icon-calendar",
    style: {
        text: "z"
    }
}, {
    isClass: true,
    priority: 10000.0073,
    key: "icon-circle",
    style: {
        text: ""
    }
}, {
    isClass: true,
    priority: 10000.0074,
    key: "icon-circunference",
    style: {
        text: ""
    }
}, {
    isClass: true,
    priority: 10000.0075,
    key: "icon-wifi",
    style: {
        text: "A"
    }
}, {
    isClass: true,
    priority: 10000.0076,
    key: "icon-driver",
    style: {
        text: "B"
    }
}, {
    isClass: true,
    priority: 10000.0077,
    key: "icon-rider",
    style: {
        text: "C"
    }
}, {
    isClass: true,
    priority: 10000.0078,
    key: "icon-stop-sq",
    style: {
        text: "D"
    }
}, {
    isClass: true,
    priority: 10000.0079,
    key: "icon-home",
    style: {
        text: "E"
    }
}, {
    isClass: true,
    priority: 10000.008,
    key: "icon-confirm",
    style: {
        text: "I"
    }
}, {
    isClass: true,
    priority: 10000.0081,
    key: "icon-tip",
    style: {
        text: "I"
    }
}, {
    isClass: true,
    priority: 10000.0082,
    key: "icon-twitter",
    style: {
        text: "J"
    }
}, {
    isClass: true,
    priority: 10000.0083,
    key: "icon-vertical-expand",
    style: {
        text: "K"
    }
}, {
    isClass: true,
    priority: 10000.0084,
    key: "icon-vertical-collapse",
    style: {
        text: "M"
    }
}, {
    isClass: true,
    priority: 10000.0085,
    key: "icon-magni-glass",
    style: {
        text: "H"
    }
}, {
    isClass: true,
    priority: 10000.0086,
    key: "icon-home-tab",
    style: {
        text: "O"
    }
}, {
    isClass: true,
    priority: 10000.0087,
    key: "icon-home-tab-selected",
    style: {
        text: "Q"
    }
}, {
    isClass: true,
    priority: 10000.0088,
    key: "icon-bubble-message",
    style: {
        text: "R"
    }
}, {
    isClass: true,
    priority: 10000.0089,
    key: "icon-bubble-message-selected",
    style: {
        text: "S"
    }
}, {
    isClass: true,
    priority: 10000.009,
    key: "icon-plantrip",
    style: {
        text: "T"
    }
}, {
    isClass: true,
    priority: 10000.0091,
    key: "icon-plantrip-selected",
    style: {
        text: "U"
    }
}, {
    isClass: true,
    priority: 10000.0092,
    key: "icon-profile",
    style: {
        text: "V"
    }
}, {
    isClass: true,
    priority: 10000.0093,
    key: "icon-profile-selected",
    style: {
        text: "W"
    }
}, {
    isClass: true,
    priority: 10000.0094,
    key: "icon-starttrip",
    style: {
        text: "P"
    }
}, {
    isClass: true,
    priority: 10000.0095,
    key: "icon-starttrip-selected",
    style: {
        text: "P"
    }
}, {
    isClass: true,
    priority: 10000.0096,
    key: "icon-search-people",
    style: {
        text: "Z"
    }
}, {
    isClass: true,
    priority: 10000.0097,
    key: "icon-menu",
    style: {
        text: "0"
    }
}, {
    isClass: true,
    priority: 10000.0098,
    key: "icon-forbid",
    style: {
        text: "1"
    }
}, {
    isClass: true,
    priority: 10000.0099,
    key: "icon-pencil",
    style: {
        text: "2"
    }
}, {
    isClass: true,
    priority: 10000.01,
    key: "icon-rounded-add",
    style: {
        text: "3",
        title: "3"
    }
}, {
    isClass: true,
    priority: 10000.0104,
    key: "table-row",
    style: {
        backgroundColor: "#80333333"
    }
}, {
    isClass: true,
    priority: 10000.0105,
    key: "btn",
    style: {
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3
    }
}, {
    isClass: true,
    priority: 10000.0106,
    key: "btn-dark",
    style: {
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3
    }
}, {
    isClass: true,
    priority: 10000.0107,
    key: "btn-lg",
    style: {
        height: "60dp",
        font: {
            fontSize: "18dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0108,
    key: "button-layout",
    style: {
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0109,
    key: "button-content",
    style: {
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal"
    }
}, {
    isClass: true,
    priority: 10000.011,
    key: "button-separator",
    style: {
        width: "16dp",
        height: "44dp"
    }
}, {
    isClass: true,
    priority: 10000.0111,
    key: "btn-icon-small",
    style: {
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
    }
}, {
    isClass: true,
    priority: 10000.0112,
    key: "btn-icon-default",
    style: {
        font: {
            fontFamily: "splinico",
            fontSize: "28dp"
        },
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
    }
}, {
    isClass: true,
    priority: 10000.0113,
    key: "btn-primary",
    style: {
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none"
    }
}, {
    isClass: true,
    priority: 10000.0114,
    key: "btn-gray",
    style: {
        normalColor: Alloy.Globals.Style.Color.DarkGray,
        selectedColor: "#2a2a2a",
        backgroundImage: "none"
    }
}, {
    isClass: true,
    priority: 10000.0115,
    key: "btn-blue",
    style: {
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none"
    }
}, {
    isClass: true,
    priority: 10000.0116,
    key: "btn-fb-blue",
    style: {
        normalColor: "#4a6ea9",
        selectedColor: "#31538b",
        backgroundImage: "none"
    }
}, {
    isClass: true,
    priority: 10000.0117,
    key: "btn-twitter-blue",
    style: {
        normalColor: "#00aced",
        selectedColor: "#0084b4",
        backgroundImage: "none"
    }
}, {
    isClass: true,
    priority: 10000.0118,
    key: "btn-transparent",
    style: {
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2
    }
}, {
    isClass: true,
    priority: 10000.0119,
    key: "btn-transparent-dark",
    style: {
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2
    }
}, {
    isClass: true,
    priority: 10000.0121,
    key: "img-thumbnail",
    style: {
        width: "46dp",
        height: "46dp"
    }
}, {
    isClass: true,
    priority: 10000.0123,
    key: "nav-window",
    style: {
        navBarHidden: true
    }
}, {
    isClass: true,
    priority: 10000.0125,
    key: "modal-window",
    style: {
        navBarHidden: true,
        height: "100%",
        top: Alloy.Globals.Style.Size.Height.pct99,
        visible: false
    }
}, {
    isClass: true,
    priority: 10000.0128,
    key: "pull-bottom",
    style: {
        bottom: 0,
        left: 0
    }
}, {
    isClass: true,
    priority: 10000.0129,
    key: "hidden",
    style: {
        visible: false
    }
}, {
    isClass: true,
    priority: 10000.013,
    key: "photo",
    style: {
        borderColor: "#fff",
        borderWidth: "1px"
    }
}, {
    isClass: true,
    priority: 10000.0131,
    key: "online",
    style: {
        backgroundColor: "#b1ec11"
    }
}, {
    isClass: true,
    priority: 10000.0132,
    key: "recent_online",
    style: {
        backgroundColor: "#f4dd5e"
    }
}, {
    isClass: true,
    priority: 10000.0133,
    key: "offline",
    style: {
        backgroundColor: "#bebebe"
    }
}, {
    isClass: true,
    priority: 10000.0134,
    key: "dotted",
    style: {
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0
    }
}, {
    isClass: true,
    priority: 10000.0135,
    key: "orange-background",
    style: {
        backgroundColor: "#ff6600"
    }
}, {
    isClass: true,
    priority: 10000.0136,
    key: "blue-background",
    style: {
        backgroundColor: "#6699ff"
    }
}, {
    isClass: true,
    priority: 10000.0137,
    key: "gray-background",
    style: {
        backgroundColor: "#CCC"
    }
}, {
    isClass: true,
    priority: 10000.0138,
    key: "dark-green-background",
    style: {
        backgroundColor: "#003333"
    }
}, {
    isClass: true,
    priority: 10000.0139,
    key: "dark-gray-background",
    style: {
        backgroundColor: "#3C3C3C"
    }
}, {
    isClass: true,
    priority: 10000.014,
    key: "dark-blue-background",
    style: {
        backgroundColor: "#003333"
    }
}, {
    isClass: true,
    priority: 10000.0141,
    key: "round-border",
    style: {
        borderColor: "#fff",
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit5
    }
}, {
    isClass: true,
    priority: 10000.0142,
    key: "horizontal-wrap-content-container",
    style: {
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal"
    }
}, {
    isClass: true,
    priority: 10000.0143,
    key: "left-top-corner",
    style: {
        left: "14dp",
        top: "14dp"
    }
}, {
    isClass: true,
    priority: 10000.0144,
    key: "right-top-corner",
    style: {
        right: "14dp",
        top: "14dp"
    }
}, {
    isClass: true,
    priority: 10000.0145,
    key: "left-bottom-corner",
    style: {
        left: "14dp",
        bottom: "14dp"
    }
}, {
    isClass: true,
    priority: 10000.0146,
    key: "right-bottom-corner",
    style: {
        right: "14dp",
        bottom: "14dp"
    }
}, {
    isClass: true,
    priority: 10000.0147,
    key: "carmaCard",
    style: {
        visible: "false",
        height: Ti.UI.SIZE,
        top: 0,
        left: "8dp",
        right: "8dp",
        layout: "vertical",
        borderRadius: "3dp",
        backgroundColor: "#fff"
    }
}, {
    isClass: true,
    priority: 10000.0148,
    key: "carmaCardTitleBar",
    style: {
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: "30dp"
    }
}, {
    isClass: true,
    priority: 10000.0149,
    key: "carmaCardTitleLabel",
    style: {
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
    }
}, {
    isClass: true,
    priority: 10000.015,
    key: "carmaCardHeader",
    style: {
        height: "33dp",
        backgroundColor: "#727272",
        layout: "horizontal"
    }
}, {
    isClass: true,
    priority: 10000.0151,
    key: "carmaCardLeftColumn",
    style: {
        left: "10dp",
        width: "70dp"
    }
}, {
    isClass: true,
    priority: 10000.0152,
    key: "carmaCardHeaderIcon",
    style: {
        left: 0,
        width: "80dp",
        height: Ti.UI.FILL,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp",
            fontWeight: "bold"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE
    }
}, {
    isClass: true,
    priority: 10000.0153,
    key: "carmaCardHeaderTitle",
    style: {
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        font: {
            fontSize: "15dp"
        },
        text: "Trip Confirmed",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE
    }
}, {
    isClass: true,
    priority: 10000.0154,
    key: "carmaCardBigTitle",
    style: {
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "22dp"
        },
        color: "#333",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE
    }
}, {
    isClass: true,
    priority: 10000.0155,
    key: "carmaCardBigText",
    style: {
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "13dp"
        },
        color: "#aaa",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE
    }
}, {
    isClass: true,
    priority: 10000.0156,
    key: "carmaCardHeaderBorder1",
    style: {
        height: "1dp",
        backgroundColor: "#5c92ff"
    }
}, {
    isClass: true,
    priority: 10000.0157,
    key: "carmaCardHeaderBorder2",
    style: {
        height: "1dp",
        backgroundColor: "#8cb2ff"
    }
}, {
    isClass: true,
    priority: 10000.0158,
    key: "carmaCardRow",
    style: {
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal"
    }
}, {
    isClass: true,
    priority: 10000.0159,
    key: "carmCardIconSpacer",
    style: {
        height: "88dp"
    }
}, {
    isClass: true,
    priority: 10000.016,
    key: "carmaCardOverlayImage",
    style: {
        top: "30dp",
        width: "140dp",
        height: "140dp"
    }
}, {
    isClass: true,
    priority: 10000.0161,
    key: "carmaCardAddressRow",
    style: {
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0162,
    key: "carmaCardAddressRightColum",
    style: {
        left: "82dp"
    }
}, {
    isClass: true,
    priority: 10000.0163,
    key: "carmaCardRowSpace",
    style: {
        top: "6dp"
    }
}, {
    isClass: true,
    priority: 10000.0164,
    key: "carmaStandardPadding",
    style: {
        top: "16dp"
    }
}, {
    isClass: true,
    priority: 10000.0165,
    key: "btn-carma-card-wrapper",
    style: {
        layout: "composite",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        bottom: "10dp"
    }
}, {
    isClass: true,
    priority: 10000.0166,
    key: "left",
    style: {
        left: 0
    }
}, {
    isClass: true,
    priority: 10000.0167,
    key: "right",
    style: {
        right: 0
    }
}, {
    isClass: true,
    priority: 10000.0168,
    key: "btn-carma-card-single",
    style: {
        left: "2%",
        width: "96%",
        color: "#555",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        borderRadius: Alloy.Globals.Style.Unit.unit2,
        height: "44dp"
    }
}, {
    isClass: true,
    priority: 10000.0169,
    key: "btn-carma-card",
    style: {
        width: "48%",
        color: "#555",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp"
    }
}, {
    isClass: true,
    priority: 10000.017,
    key: "btn-carma-card-orange",
    style: {
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp"
    }
}, {
    isClass: true,
    priority: 10000.0171,
    key: "carmaOrangeButton",
    style: {
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp"
    }
}, {
    isClass: true,
    priority: 10000.0172,
    key: "carmaButtonTextColour",
    style: {
        color: "#555"
    }
}, {
    isClass: true,
    priority: 10000.0173,
    key: "carmaTextColour",
    style: {
        color: "#666"
    }
}, {
    isClass: true,
    priority: 10000.0174,
    key: "carmaCardTitle",
    style: {
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0175,
    key: "carmaCardText",
    style: {
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0176,
    key: "carmaCardMessage",
    style: {
        height: Ti.UI.SIZE,
        color: "#666",
        font: {
            fontSize: "15dp"
        }
    }
}, {
    isClass: true,
    priority: 10000.0177,
    key: "carmaCardItalicsText",
    style: {
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp",
            fontFamily: "HelveticaNeue-Italic"
        }
    }
}, {
    isClass: true,
    priority: 10000.0178,
    key: "carmaCardTimeContainer",
    style: {
        width: "86dp"
    }
}, {
    isClass: true,
    priority: 10000.0179,
    key: "carmaCardLocationContainer",
    style: {
        width: Ti.UI.FILL
    }
}, {
    isClass: true,
    priority: 10000.018,
    key: "button-with-indicator",
    style: {
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true"
    }
}, {
    isClass: true,
    priority: 10000.0181,
    key: "button-with-dark-indicator",
    style: {
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true"
    }
}, {
    isClass: true,
    priority: 10000.0184,
    key: "card-title",
    style: {
        text: "CARD",
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent"
    }
}, {
    isClass: true,
    priority: 10000.0185,
    key: "card-title-spacing",
    style: {
        width: Ti.UI.SIZE,
        height: "50dp",
        backgroundColor: "transparent"
    }
}, {
    isClass: true,
    priority: 10000.0186,
    key: "card-container",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0187,
    key: "card-container-invisible",
    style: {
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: 0,
        visible: false
    }
}, {
    isClass: true,
    priority: 10000.0188,
    key: "card",
    style: {
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        backgroundColor: "#fff"
    }
}, {
    isClass: true,
    priority: 10000.0189,
    key: "list-row",
    style: {
        height: "60dp",
        backgroundColor: "#ffffffff"
    }
}, {
    isClass: true,
    priority: 10000.0191,
    key: "list-row-container",
    style: {
        top: 0,
        left: "13dp",
        right: "13dp",
        height: "60dp",
        backgroundColor: "transparent"
    }
}, {
    isClass: true,
    priority: 10000.0192,
    key: "avatar-container",
    style: {
        left: 0,
        width: "50dp",
        height: "50dp",
        top: "6dp"
    }
}, {
    isClass: true,
    priority: 10000.0193,
    key: "btn-right-action",
    style: {
        right: 0,
        width: Ti.UI.SIZE,
        height: "40dp",
        top: "9dp",
        bottom: "9dp"
    }
}, {
    isClass: true,
    priority: 10000.0194,
    key: "btn-right-action-textfield",
    style: {
        left: "12dp",
        right: "12dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0196,
    key: "avatar",
    style: {
        backgroundColor: "#fff",
        borderColor: "#fff",
        borderWidth: 1,
        defaultImage: "/images/default_photo_male-rounded.png",
        left: 0
    }
}, {
    isClass: true,
    priority: 10000.0197,
    key: "avatar-tiny",
    style: {
        width: "32dp",
        height: "32dp",
        borderRadius: Alloy.Globals.Style.Unit.unit16
    }
}, {
    isClass: true,
    priority: 10000.0198,
    key: "avatar-small",
    style: {
        width: "48dp",
        height: "48dp",
        borderRadius: Alloy.Globals.Style.Unit.unit24
    }
}, {
    isClass: true,
    priority: 10000.0199,
    key: "avatar-medium",
    style: {
        width: "60dp",
        height: "60dp",
        borderRadius: Alloy.Globals.Style.Unit.unit30
    }
}, {
    isClass: true,
    priority: 10000.02,
    key: "avatar-large",
    style: {
        width: "64dp",
        height: "64dp",
        borderRadius: Alloy.Globals.Style.Unit.unit32
    }
}, {
    isClass: true,
    priority: 10000.0202,
    key: "overlap",
    style: {
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0203,
    key: "horizontal",
    style: {
        layout: "horizontal",
        height: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10000.0204,
    key: "vertical",
    style: {
        layout: "vertical"
    }
}, {
    isClass: true,
    priority: 10000.0205,
    key: "vfit",
    style: {
        height: Ti.UI.SIZE
    }
}, {
    isClass: true,
    priority: 10101.012,
    key: "btn-transparent",
    style: {
        disableAnimation: true
    }
}, {
    isClass: true,
    priority: 10101.0126,
    key: "root-window",
    style: {
        exitOnClose: true
    }
}, {
    isClass: true,
    priority: 10101.0127,
    key: "auto-focus-fix",
    style: {
        width: "1px",
        height: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS
    }
}, {
    isClass: true,
    priority: 10101.0183,
    key: "button-with-dark-indicator",
    style: {
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK
    }
}, {
    isId: true,
    priority: 100000.124,
    key: "feedContainer",
    style: {
        width: "100%",
        height: "100%",
        left: 0,
        top: 0
    }
}, {
    isId: true,
    priority: 100000.1241,
    key: "loading",
    style: {
        top: "60dp"
    }
}, {
    isId: true,
    priority: 100101.1243,
    key: "loading",
    style: {
        style: Ti.UI.ActivityIndicatorStyle.PLAIN
    }
} ];