function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "biography";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.biography = Ti.UI.createView({
        top: 0,
        left: 0,
        bottom: "50dp",
        width: "100%",
        hintText: L("widget_add_commute_biography_placeholder"),
        id: "biography"
    });
    $.__views.biography && $.addTopLevelView($.__views.biography);
    $.__views.biographyContainer = Ti.UI.createView({
        width: "91.66666666666666%",
        layout: "vertical",
        height: Ti.UI.SIZE,
        bottom: "0dp",
        id: "biographyContainer"
    });
    $.__views.biography.add($.__views.biographyContainer);
    $.__views.__alloyId4 = Ti.UI.createLabel({
        color: "#fff",
        "with": Ti.UI.SIZE,
        text: L("widget_add_commute_biography"),
        bottom: "10dp",
        id: "__alloyId4"
    });
    $.__views.biographyContainer.add($.__views.__alloyId4);
    $.__views.biography = Ti.UI.createTextArea({
        paddingLeft: "10dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        height: "120dp",
        hintText: L("widget_add_commute_biography_placeholder"),
        id: "biography"
    });
    $.__views.biographyContainer.add($.__views.biography);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Navigation = Alloy.Globals.Nav.AddComute, BaseController = require("/carmalib/controller"), URL = require("/carmalib/url");
    var Controller = BaseController.extend($, {
        TAG: "biography",
        events: {
            "focus biography": "onFocus",
            "blur biography": "onBlur"
        },
        initialize: function() {
            _.bindAll(this, "onNext");
            Navigation.addEventListener("nav.bar.right.clicked", this.onNext);
            Navigation.enableRightAction();
        },
        onDestroy: function() {
            Navigation.removeEventListener("nav.bar.right.clicked", this.onNext);
        },
        onFocus: function() {
            var positioning = function() {
                $.biographyContainer.top = 0;
                $.biographyContainer.bottom = "auto";
            };
            setTimeout(positioning, 200);
        },
        onBlur: function() {
            var positioning = function() {
                $.biographyContainer.top = "auto";
                $.biographyContainer.bottom = 0;
            };
            setTimeout(positioning, 200);
        },
        onNext: function() {
            var ResourceOwner = require("services/resource_owner_service").singleton(), userId = ResourceOwner.get("userId"), email = ResourceOwner.get("email"), bio = $.biography.value;
            var user = Alloy.createModel("user", {
                id: userId
            });
            user.save({
                userId: userId,
                bio: bio,
                email: email
            });
            var nextWidget = Alloy.createWidget("ma.car.app.addcommute", "pickPhoto");
            Navigation.open(nextWidget);
        }
    });
    exports = new Controller();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;