function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.addCommuteWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStatePan,
        id: "addCommuteWindow"
    });
    $.__views.addCommuteWindow && $.addTopLevelView($.__views.addCommuteWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    !function() {
        var navigation = Alloy.Globals.Nav.AddComute = Alloy.createController("navigation"), steps = args.requirePhoto ? 5 : 4, stepsWidget = Alloy.createWidget("ma.car.app.addcommute", "steps", {
            steps: steps
        });
        Alloy.Globals.StepsWidget = stepsWidget;
        var widget = args.requirePhoto ? Alloy.createWidget("ma.car.app.addcommute", "pickPhoto") : Alloy.createWidget("ma.car.app.addcommute", "selectRole", {
            firstStep: true
        });
        $.addCommuteWindow.addEventListener("close", function() {
            Alloy.Globals.Nav.AddComute = null;
            Alloy.Globals.StepsWidget.destroy();
            Alloy.Globals.StepsWidget = null;
        });
        args.justSignup && navigation.set("justSignup", true);
        var onNavExited = function() {
            require("ma.car.ti.module.android.utils").moveTaskToBack(true);
            return true;
        };
        navigation.init({
            index: widget,
            historyLimit: 20,
            mainWindow: $.addCommuteWindow,
            title: L("widget_add_commute_title"),
            coverImage: "/images/background.png",
            stepsWidget: stepsWidget,
            disableBack: true,
            theme: "white",
            around: {
                exit: onNavExited
            }
        });
        $.addCommuteWindow.addEventListener("androidback", function() {
            navigation.back();
        });
    }();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;