function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "blueScreen";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.blueScreen = Ti.UI.createView({
        width: "100%",
        height: "100%",
        zIndex: 1,
        id: "blueScreen"
    });
    $.__views.blueScreen && $.addTopLevelView($.__views.blueScreen);
    $.__views.backgroundImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "100%",
        height: "100%",
        image: "/images/background.png",
        id: "backgroundImage"
    });
    $.__views.blueScreen.add($.__views.backgroundImage);
    $.__views.__alloyId38 = Ti.UI.createView({
        width: "100%",
        height: "100%",
        layout: "vertical",
        id: "__alloyId38"
    });
    $.__views.blueScreen.add($.__views.__alloyId38);
    $.__views.navBar = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "50dp",
        id: "navBar"
    });
    $.__views.__alloyId38.add($.__views.navBar);
    $.__views.navBarTitle = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        height: "24dp",
        bottom: "11dp",
        left: "72dp",
        right: "72dp",
        ellipsize: true,
        wordWrap: false,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("widget_crew_title1"),
        minimumFontSize: "10dp",
        id: "navBarTitle"
    });
    $.__views.navBar.add($.__views.navBarTitle);
    $.__views.contentWrapper = Ti.UI.createView({
        id: "contentWrapper"
    });
    $.__views.__alloyId38.add($.__views.contentWrapper);
    $.__views.connectionIndicator = require("/ui/common/connection_indicator").createView({
        id: "connectionIndicator"
    });
    $.__views.contentWrapper.add($.__views.connectionIndicator);
    $.__views.content = Ti.UI.createView({
        id: "content"
    });
    $.__views.contentWrapper.add($.__views.content);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var onBack = null, Q = require("/vendor/q");
    var Controller = require("/v6/infrastructure/Controller");
    exports = new (require("/carmalib/controller").extend($, {
        boardingStateMachine: null,
        events: {
            "click backArrow": "_onBack"
        },
        setTitle: function(title) {
            if (title) {
                $.navBarTitle.text = title;
                $.navBar.opacity = 1;
            } else {
                $.navBarTitle.text = "";
                $.navBar.opacity = 0;
            }
        },
        enableBack: function(enable) {},
        handleNetwork: function(data) {
            $.connectionIndicator.handleNetwork(data);
            $.content.top = $.connectionIndicator.getBarHeight();
        },
        initialize: function() {},
        _onBack: function() {
            onBack && onBack();
        },
        slideContentOutDownwards: function(view) {
            var deferred = Q.defer();
            $.navBar.animate({
                opacity: 0,
                duration: 300
            });
            view.animate({
                top: Ti.Platform.displayCaps.platformHeight,
                duration: 300
            });
            setTimeout(function() {
                $.navBar.opacity = 0;
                view.top = Ti.Platform.displayCaps.platformHeight;
                deferred.resolve();
            }, 400);
            return deferred.promise;
        },
        slideContentInUpwards: function(view) {
            var deferred = Q.defer();
            $.navBar.animate({
                opacity: 1,
                duration: 300
            });
            view.animate({
                top: 0,
                duration: 300
            }, function() {
                $.navBar.opacity = 1;
                view.top = 0;
            });
            setTimeout(function() {
                $.navBar.opacity = 1;
                view.top = 0;
                deferred.resolve();
            }, 400);
            return deferred.promise;
        },
        setBack: function(onBackCB) {
            onBack = onBackCB;
        },
        addView: function(view) {
            $.content.add(view);
        },
        removeView: function(view) {
            $.content.remove(view);
        },
        setStateMachine: function(sm) {
            this.boardingStateMachine = sm;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;