function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "location_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.location_row = Ti.UI.createTableViewRow({
        height: "64dp",
        id: "location_row"
    });
    $.__views.location_row && $.addTopLevelView($.__views.location_row);
    $.__views.container = Ti.UI.createView({
        height: "58dp",
        id: "container"
    });
    $.__views.location_row.add($.__views.container);
    $.__views.locationName = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp"
        },
        left: "20dp",
        id: "locationName"
    });
    $.__views.container.add($.__views.locationName);
    $.__views.indicator = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        right: "10dp",
        width: "30dp",
        height: "30dp",
        borderRadius: Alloy.Globals.Style.Unit.unit15,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "indicator"
    });
    $.__views.container.add($.__views.indicator);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var url = require("/carmalib/url"), location = arguments[0] || {};
    exports = new (require("/carmalib/controller").extend($, {
        initialize: function() {
            this._renderDriverRow();
        },
        selectRow: function() {
            $.indicator.applyProperties({
                text: "c",
                backgroundColor: Alloy.Globals.Style.Color.LightBlue
            });
        },
        deselectRow: function() {
            $.indicator.applyProperties({
                text: "",
                backgroundColor: "transparent"
            });
        },
        _renderDriverRow: function() {
            $.locationName.applyProperties({
                text: location.address
            });
        },
        getLocation: function() {
            return location;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;