function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "onboard";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.screen = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "screen"
    });
    $.__views.screen && $.addTopLevelView($.__views.screen);
    $.__views.topContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        top: 0,
        bottom: "88dp",
        id: "topContainer"
    });
    $.__views.screen.add($.__views.topContainer);
    $.__views.__alloyId48 = Ti.UI.createView({
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "__alloyId48"
    });
    $.__views.topContainer.add($.__views.__alloyId48);
    $.__views.topAnimation = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "topAnimation"
    });
    $.__views.__alloyId48.add($.__views.topAnimation);
    $.__views.countdown = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        id: "countdown"
    });
    $.__views.topAnimation.add($.__views.countdown);
    $.__views.countDownAnimationContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "230dp",
        id: "countDownAnimationContainer"
    });
    $.__views.countdown.add($.__views.countDownAnimationContainer);
    $.__views.inCar = Ti.UI.createView({
        width: Ti.UI.FILL,
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "inCar"
    });
    $.__views.topAnimation.add($.__views.inCar);
    $.__views.finishTripView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: "246dp",
        id: "finishTripView"
    });
    $.__views.inCar.add($.__views.finishTripView);
    $.__views.darkBorder = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "180dp",
        height: "180dp",
        image: "/images/trans_black.png",
        id: "darkBorder"
    });
    $.__views.finishTripView.add($.__views.darkBorder);
    $.__views.whiteBorder = Ti.UI.createView({
        borderWidth: "4dp",
        borderColor: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit75,
        width: "150dp",
        height: "150dp",
        zIndex: 1,
        id: "whiteBorder"
    });
    $.__views.finishTripView.add($.__views.whiteBorder);
    $.__views.whiteBorderAnim = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "150dp",
        height: "150dp",
        opacity: .5,
        image: "/images/white.png",
        id: "whiteBorderAnim"
    });
    $.__views.finishTripView.add($.__views.whiteBorderAnim);
    $.__views.bckgButton = Ti.UI.createLabel({
        color: "#25ffffff",
        text: "",
        font: {
            fontFamily: "radio-buttons",
            fontSize: "205dp"
        },
        zIndex: 2,
        id: "bckgButton"
    });
    $.__views.finishTripView.add($.__views.bckgButton);
    $.__views.counterContainer = Ti.UI.createView({
        zIndex: 3,
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "counterContainer"
    });
    $.__views.finishTripView.add($.__views.counterContainer);
    $.__views.lblHours = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "26dp",
            fontWeight: "bold"
        },
        text: "00",
        id: "lblHours"
    });
    $.__views.counterContainer.add($.__views.lblHours);
    $.__views.__alloyId49 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "26dp",
            fontWeight: "bold"
        },
        text: ":",
        id: "__alloyId49"
    });
    $.__views.counterContainer.add($.__views.__alloyId49);
    $.__views.lblMinutes = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "26dp",
            fontWeight: "bold"
        },
        text: "00",
        id: "lblMinutes"
    });
    $.__views.counterContainer.add($.__views.lblMinutes);
    $.__views.__alloyId50 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "26dp",
            fontWeight: "bold"
        },
        text: ":",
        id: "__alloyId50"
    });
    $.__views.counterContainer.add($.__views.__alloyId50);
    $.__views.lblSeconds = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "26dp",
            fontWeight: "bold"
        },
        text: "00",
        id: "lblSeconds"
    });
    $.__views.counterContainer.add($.__views.lblSeconds);
    $.__views.avatarContainer = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "avatarContainer"
    });
    $.__views.__alloyId48.add($.__views.avatarContainer);
    $.__views.driverAvatarContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE,
        id: "driverAvatarContainer"
    });
    $.__views.avatarContainer.add($.__views.driverAvatarContainer);
    $.__views.boardingDots = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        text: "...",
        top: 0,
        left: 0,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        id: "boardingDots"
    });
    $.__views.driverAvatarContainer.add($.__views.boardingDots);
    $.__views.driverName = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: 0,
        id: "driverName"
    });
    $.__views.driverAvatarContainer.add($.__views.driverName);
    $.__views.driverPhoto = require("/ui/common/profile").createView({
        width: "48dp",
        height: "48dp",
        top: "30dp",
        bottom: Alloy.Globals.Style.Size.Width.halfGrid,
        defaultImage: "/images/none.png",
        image: "/images/none.png",
        id: "driverPhoto"
    });
    $.__views.driverAvatarContainer.add($.__views.driverPhoto);
    $.__views.favoriteIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "62dp",
        left: "22dp",
        width: "24dp",
        height: "24dp",
        image: "/images/favouriteicon.png",
        visible: false,
        id: "favoriteIcon"
    });
    $.__views.driverAvatarContainer.add($.__views.favoriteIcon);
    $.__views.freeRiderIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "62dp",
        left: "22dp",
        width: "24dp",
        height: "24dp",
        image: "/images/freetripscoin.png",
        visible: false,
        id: "freeRiderIcon"
    });
    $.__views.driverAvatarContainer.add($.__views.freeRiderIcon);
    $.__views.passengersList = Ti.UI.createView({
        height: "117dp",
        visible: false,
        id: "passengersList"
    });
    $.__views.avatarContainer.add($.__views.passengersList);
    $.__views.bottomContainer = Ti.UI.createView({
        height: Ti.UI.SIZE,
        bottom: "20dp",
        left: "20dp",
        right: "20dp",
        width: Ti.UI.FILL,
        id: "bottomContainer"
    });
    $.__views.screen.add($.__views.bottomContainer);
    $.__views.timerButtons = Ti.UI.createView({
        layout: "horizontal",
        height: Ti.UI.SIZE,
        id: "timerButtons"
    });
    $.__views.bottomContainer.add($.__views.timerButtons);
    $.__views.__alloyId51 = Ti.UI.createView({
        width: "49.9%",
        height: Ti.UI.SIZE,
        id: "__alloyId51"
    });
    $.__views.timerButtons.add($.__views.__alloyId51);
    $.__views.btnStartTrip = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        disableAnimation: true,
        right: "7dp",
        title: "",
        id: "btnStartTrip"
    });
    $.__views.__alloyId51.add($.__views.btnStartTrip);
    $.__views.__alloyId52 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId52"
    });
    $.__views.btnStartTrip.add($.__views.__alloyId52);
    $.__views.__alloyId53 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "g",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        right: "7dp",
        id: "__alloyId53"
    });
    $.__views.__alloyId52.add($.__views.__alloyId53);
    $.__views.start_trip_countdown_start = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: "12dp",
        bottom: "12dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        height: Ti.UI.SIZE,
        text: L("start_trip_countdown_start"),
        id: "start_trip_countdown_start"
    });
    $.__views.__alloyId52.add($.__views.start_trip_countdown_start);
    $.__views.__alloyId54 = Ti.UI.createView({
        width: "49.9%",
        height: Ti.UI.SIZE,
        id: "__alloyId54"
    });
    $.__views.timerButtons.add($.__views.__alloyId54);
    $.__views.btnCancelTrip = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        disableAnimation: true,
        left: "7dp",
        title: "",
        id: "btnCancelTrip"
    });
    $.__views.__alloyId54.add($.__views.btnCancelTrip);
    $.__views.__alloyId55 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId55"
    });
    $.__views.btnCancelTrip.add($.__views.__alloyId55);
    $.__views.__alloyId56 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "h",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        right: "7dp",
        id: "__alloyId56"
    });
    $.__views.__alloyId55.add($.__views.__alloyId56);
    $.__views.start_trip_countdown_cancel = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: "12dp",
        bottom: "12dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        height: Ti.UI.SIZE,
        text: L("start_trip_countdown_cancel"),
        id: "start_trip_countdown_cancel"
    });
    $.__views.__alloyId55.add($.__views.start_trip_countdown_cancel);
    $.__views.endTripButtons = Ti.UI.createView({
        layout: "horizontal",
        height: Ti.UI.SIZE,
        id: "endTripButtons"
    });
    $.__views.bottomContainer.add($.__views.endTripButtons);
    $.__views.btnEndTrip = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: Ti.UI.FILL,
        height: "44dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        title: "",
        id: "btnEndTrip"
    });
    $.__views.endTripButtons.add($.__views.btnEndTrip);
    $.__views.endTripWrapper = Ti.UI.createView({
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "endTripWrapper"
    });
    $.__views.btnEndTrip.add($.__views.endTripWrapper);
    $.__views.stopIcon = Ti.UI.createLabel({
        color: "white",
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "D",
        id: "stopIcon"
    });
    $.__views.endTripWrapper.add($.__views.stopIcon);
    $.__views.lblFinishTrip = Ti.UI.createLabel({
        color: "white",
        touchEnabled: false,
        backgroundColor: "transparent",
        font: {
            fontSize: "18dp"
        },
        text: L("widget_boarding_button_finish"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        shadowColor: "#40000000",
        shadowOffset: {
            x: 0,
            y: -1
        },
        id: "lblFinishTrip"
    });
    $.__views.endTripWrapper.add($.__views.lblFinishTrip);
    $.__views.endTripOptions = Ti.UI.createOptionDialog({
        id: "endTripOptions"
    });
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("/vendor/q"), Controller = require("/v6/infrastructure/Controller"), AnimationManager = require(WPATH("count_down_animator")), driveHelper = require("/v6/boarding/helpers/DriveHelper"), utils = require("utils/utils"), errorCodes = require("services/error_codes"), errorHandler = require("/utils/errorHandler"), Soundplayer = require("/utils/appSound"), Location = require(WPATH("location")), PublicProfile = require("/services/public_profile_service"), BoardingDisplayHelper = require(WPATH("BoardingDisplayHelper"));
    var ROLES = {
        RIDER: 0,
        DRIVER: 1
    };
    var OnBoardController = function($, args, currentUser, boardingService, boardingBgService, summaryService, profileService, bookingService, networkService, tabgroup) {
        var SCREEN_HEIGHT = utils.defaultToDp(Ti.Platform.displayCaps.platformHeight), SCREEN_WIDTH = utils.defaultToDp(Ti.Platform.displayCaps.platformWidth), IS_SMALL_SCREEN = 535 > SCREEN_HEIGHT;
        var _role = null, _ERROR_ALREADY_HANDLED = "_ERROR_ALREADY_HANDLED", _animationManager = AnimationManager.get(), _countdownClicked = false, _endTripClicked = false, _currentTrip = null, _currentDrive = null, _completedDrive = null, _animPlaying = 0, _counterInterval = null, _startTripTimestamp = null, _driverProfile = null, _passengersListWidget = null, _isServerAwareOfRide = false;
        var container = null, boardingStateMachine = null, summaryWidget = null, blueScreen = null, displayHelper = new BoardingDisplayHelper(profileService);
        var self = {
            events: {
                "click btnStartTrip": "_onStartNowClick",
                "click btnCancelTrip": "_onCancel",
                "click btnEndTrip": "_onEndTrip"
            },
            clearBoardingDots: function() {
                $.boardingDots.text = "";
            },
            updateBoardingDots: function() {
                if ($.driverName.rect && ($.driverName.rect.right || $.driverName.rect.width)) {
                    $.boardingDots.left = $.driverName.rect.x + $.driverName.rect.width;
                    var newContent = $.boardingDots.text + ".";
                    $.boardingDots.text = "...." === newContent ? "" : newContent;
                } else $.boardingDots.text = "";
            },
            _prepareAnimation: function(animToPlay) {
                $.whiteBorderAnim.applyProperties({
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    }),
                    opacity: .5
                });
                $.darkBorder.applyProperties({
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    }),
                    opacity: 1
                });
                this._startAnimation(animToPlay);
            },
            _startAnimation: function(animToPlay) {
                if (_role === ROLES.RIDER) {
                    if (_isServerAwareOfRide) self.clearBoardingDots(); else {
                        var currentDrive = boardingService.getCurrentDrive();
                        if (currentDrive) {
                            _isServerAwareOfRide = driveHelper.isServerAwareOfRide(currentDrive.rides[0]);
                            if (_isServerAwareOfRide) {
                                self.clearBoardingDots();
                                _driverProfile && self._setProfile(_driverProfile);
                            } else {
                                self.updateBoardingDots();
                                setTimeout(function() {
                                    self.updateBoardingDots();
                                }, 1e3);
                            }
                        } else self.clearBoardingDots();
                    }
                    if (IS_SMALL_SCREEN) {
                        _isServerAwareOfRide || _animPlaying === animToPlay && setTimeout(function() {
                            self._startAnimation(animToPlay);
                        }, 2e3);
                        return;
                    }
                } else if (IS_SMALL_SCREEN) return;
                $.whiteBorderAnim.animate({
                    duration: 1500,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1.7
                    }),
                    opacity: 0
                });
                $.darkBorder.animate({
                    duration: 1900,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1.3
                    }),
                    opacity: .1
                });
                setTimeout(function() {
                    _animPlaying === animToPlay && self._resetAnimation(animToPlay);
                }, 2e3);
            },
            _resetAnimation: function(animToPlay) {
                if (_role === ROLES.RIDER && !_isServerAwareOfRide) {
                    var currentDrive = boardingService.getCurrentDrive();
                    if (currentDrive) {
                        _isServerAwareOfRide = driveHelper.isServerAwareOfRide(currentDrive.rides[0]);
                        if (_isServerAwareOfRide) {
                            self.clearBoardingDots();
                            _driverProfile && self._setProfile(_driverProfile);
                        } else {
                            self.updateBoardingDots();
                            setTimeout(function() {
                                self.updateBoardingDots();
                            }, 1e3);
                        }
                    } else self.clearBoardingDots();
                }
                $.whiteBorderAnim.animate({
                    duration: 1500,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    }),
                    opacity: .5
                });
                $.darkBorder.animate({
                    duration: 1900,
                    opacity: 1,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    })
                });
                setTimeout(function() {
                    _animPlaying === animToPlay && self._startAnimation(animToPlay);
                }, 2e3);
            },
            ShowOnBoardClock: function() {
                var deferred = Q.defer();
                $.countdown.animate({
                    opacity: 0,
                    duration: 300
                });
                $.inCar.applyProperties({
                    visible: true
                });
                $.inCar.animate({
                    opacity: 1,
                    duration: 300
                });
                setTimeout(function() {
                    $.countdown.opacity = 0;
                    $.inCar.opacity = 1;
                    deferred.resolve();
                }, 400);
                return deferred.promise;
            },
            startRiding: function() {
                return self.ShowOnBoardClock();
            },
            startDriving: function() {
                return self.ShowOnBoardClock();
            },
            setupDriving: function() {
                var trip = Alloy.createModel("trip_state", {
                    startTimestamp: networkService.getTime(Date.now()),
                    role: "DRIVER",
                    driver: {
                        id: currentUser.id
                    }
                });
                var deferred = Q.defer();
                Location.getContactLocation(trip, true).then(function(location) {
                    location = location || {};
                    trip.set("startLocation", {
                        latitude: location.lat,
                        longitude: location.lon,
                        accuracy: location.accuracy
                    });
                    _currentTrip = trip;
                }).then(function() {
                    deferred.resolve();
                }).catch(function(e) {
                    deferred.reject(e);
                });
                return deferred.promise;
            },
            _getDriverAlias: function(profile) {
                var alias = "";
                if (profile && profile.alias) alias = profile.alias; else if (profile && profile.name) alias = profile.name; else {
                    var driverPhone = _currentTrip.get("phone");
                    alias = driverPhone ? driverPhone : L("widget_boarding_unknown_driver");
                }
                return alias;
            },
            _setProfile: function(profile) {
                _driverProfile = profile;
                var alias = this._getDriverAlias(profile);
                _currentTrip.get("driver").name = alias;
                _isServerAwareOfRide = boardingService.getCurrentDrive() ? driveHelper.isServerAwareOfRide(boardingService.getCurrentDrive().rides[0]) : false;
                $.driverName.text = boardingStateMachine.getCurrentState() !== boardingStateMachine._STATES.RIDE_TIMER && boardingStateMachine.getCurrentState() !== boardingStateMachine._STATES.IN_TRANSITION && _isServerAwareOfRide ? String.format(L("widget_boarding_now_in_car"), alias) : String.format(L("widget_boarding_joining_car"), alias);
                $.driverPhoto.setUser(profile && profile.userId && profile.userId > 0 ? _.extend(profile, {
                    disableProfile: false,
                    hideStatus: true,
                    layout: "circular-small"
                }) : _.extend({}, {
                    disableProfile: true,
                    hideStatus: true,
                    layout: "circular-small"
                }));
                $.driverPhoto.visible = true;
                if (profile && profile.isFavourite) {
                    $.favoriteIcon.left = Math.floor(SCREEN_WIDTH / 2 - 42) + "dp";
                    $.favoriteIcon.visible = true;
                } else $.favoriteIcon.visible = false;
                if (profile && profile.canUserGiveFreeDrive) {
                    $.freeRiderIcon.left = Math.floor(SCREEN_WIDTH / 2 - 42) + "dp";
                    $.freeRiderIcon.visible = true;
                } else $.freeRiderIcon.visible = false;
            },
            _setDriverAvatar: function() {
                $.driverAvatarContainer.visible = true;
                var driverId = _currentTrip.get("driver").id;
                if (driverId) {
                    var profile = profileService.getCachedProfile(driverId);
                    Q().then(function() {
                        return null === profile ? profileService.getProfile(driverId, profileService.BASIC_DETAIL) : profile;
                    }).then(function(profile) {
                        self._setProfile(profile);
                        TM.push(function() {
                            displayHelper.getUserAvatarImage(driverId);
                        });
                    }).catch(function(error) {
                        self._setProfile(error);
                    });
                } else {
                    _driverProfile = null;
                    var driverPhone = _currentTrip.get("driver").phone;
                    $.driverName.text = driverPhone ? String.format(L("widget_boarding_joining_car"), driverPhone) : L("widget_boarding_joining_car_generic");
                    $.driverPhoto.setUser({
                        disableProfile: true,
                        hideStatus: true,
                        layout: "circular-small"
                    });
                    $.driverPhoto.visible = true;
                }
            },
            _startTrip: function(tripStartTime) {
                if (_role === ROLES.RIDER) try {
                    var location = _currentTrip.get("startLocation");
                    if (boardingStateMachine.getCurrentState() === boardingStateMachine._STATES.RIDE_TIMER) {
                        var timeNow = networkService.getTime(Date.now());
                        tripStartTime ? tripStartTime > timeNow && (tripStartTime = timeNow) : tripStartTime = timeNow;
                        _currentTrip.set("startTimestamp", tripStartTime);
                        _currentDrive = boardingService.joinCar({
                            riderId: currentUser.id,
                            driverId: _currentTrip.get("driver").id ? _currentTrip.get("driver").id : null,
                            driverPhoneNumber: _currentTrip.get("phone") ? _currentTrip.get("phone") : null,
                            timestamp: _currentTrip.get("startTimestamp"),
                            lat: location ? location.latitude : null,
                            lon: location ? location.longitude : null,
                            accuracy: location ? location.accuracy : null
                        });
                        boardingBgService.sync();
                    }
                    _animPlaying++;
                    self._prepareAnimation(_animPlaying);
                    self._setCounter();
                    $.timerButtons.visible = false;
                    $.endTripButtons.visible = true;
                    tabgroup._startTripIconUpdate();
                    if (_role === ROLES.RIDER) {
                        _isServerAwareOfRide = driveHelper.isServerAwareOfRide(boardingService.getCurrentDrive().rides[0]);
                        if (_driverProfile) $.driverName.text = String.format(L(_isServerAwareOfRide ? "widget_boarding_now_in_car" : "widget_boarding_joining_car"), _driverProfile.alias); else {
                            var driverPhone = _currentTrip.get("driver").phone;
                            driverPhone && ($.driverName.text = String.format(L(_isServerAwareOfRide ? "widget_boarding_now_in_car" : "widget_boarding_joining_car"), driverPhone));
                        }
                    }
                    boardingStateMachine.getCurrentState() === boardingStateMachine._STATES.RIDE_TIMER ? boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.TIMER_COMPLETE) : self.ShowOnBoardClock();
                } catch (e) {
                    LOGGER.error(JSON.stringify(e));
                    errorHandler.noticeError({
                        action: "join_car",
                        errorCode: e.errorCode
                    });
                    boardingStateMachine.resetAllState();
                    return;
                } else try {
                    var location = _currentTrip.get("startLocation");
                    if (boardingStateMachine.getCurrentState() === boardingStateMachine._STATES.DRIVE_TIMER) {
                        var timeNow = networkService.getTime(Date.now());
                        tripStartTime ? tripStartTime > timeNow && (tripStartTime = timeNow) : tripStartTime = timeNow;
                        _currentTrip.set("startTimestamp", tripStartTime);
                        _currentDrive = boardingService.startDrive({
                            driverId: _currentTrip.get("driver").id,
                            driverPhoneNo: null,
                            timestamp: _currentTrip.get("startTimestamp"),
                            lat: location ? location.latitude : null,
                            lon: location ? location.longitude : null,
                            accuracy: location ? location.accuracy : null,
                            freeRide: null
                        });
                        boardingBgService.sync();
                    }
                    _animPlaying++;
                    self._prepareAnimation(_animPlaying);
                    self._setCounter();
                    $.timerButtons.visible = false;
                    $.endTripButtons.visible = true;
                    tabgroup._startTripIconUpdate();
                    boardingStateMachine.getCurrentState() === boardingStateMachine._STATES.DRIVE_TIMER ? boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.TIMER_COMPLETE) : self.ShowOnBoardClock();
                } catch (e) {
                    LOGGER.error(JSON.stringify(e));
                    errorHandler.noticeError({
                        action: "start_solo_drive",
                        errorCode: e.errorCode
                    });
                    boardingStateMachine.resetAllState();
                }
            },
            _onStartNow: function(tripStartTime) {
                if (boardingStateMachine.isInTransition() || _countdownClicked) return;
                _countdownClicked = true;
                _animationManager.stop();
                self._startTrip(tripStartTime);
            },
            _onStartNowClick: function() {
                self._onStartNow(0);
            },
            _stopAnimation: function() {
                _animationManager.stop();
            },
            _onCancel: function() {
                if (boardingStateMachine.isInTransition() || _countdownClicked) return;
                _countdownClicked = true;
                boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.BACK);
            },
            showDropOffConfirmation: function(passengerName, passengerId, isRider) {
                var deferred = Q.defer();
                var confirmDropOff = Alloy.createWidget("ma.car.app.boardingv6", "confirm_dropoff", {
                    isRider: isRider
                });
                confirmDropOff.init(passengerName);
                container.add(confirmDropOff.getView());
                var cbWrapper = function(e) {
                    confirmDropOff.cancel.removeEventListener("click", cbWrapper);
                    confirmDropOff.confirm.removeEventListener("click", cbWrapper);
                    container && container.remove(confirmDropOff.getView());
                    "confirm" === e.source.id ? deferred.resolve({
                        passengerId: passengerId,
                        isFree: confirmDropOff.freeRideTicker.visible
                    }) : deferred.reject(_ERROR_ALREADY_HANDLED);
                };
                confirmDropOff.cancel.addEventListener("click", cbWrapper);
                confirmDropOff.confirm.addEventListener("click", cbWrapper);
                return deferred.promise;
            },
            showMultiDropOffConfirmation: function() {
                var options = [];
                var cancelOptionOrder = -1;
                var riders = _passengersListWidget.getPassengerTrips();
                for (var i = 0; i < riders.length; i++) options.push(String.format(L("widget_passenger_end_trip_for"), riders[i].get("firstName")));
                options.push(L("widget_passenger_end_trip_for_all"));
                cancelOptionOrder = -1;
                var deferred = Q.defer();
                $.endTripOptions.applyProperties({
                    options: options,
                    cancel: cancelOptionOrder
                });
                $.endTripOptions.addEventListener("click", function onClick(e) {
                    $.endTripOptions.removeEventListener("click", onClick);
                    var selectedOption = $.endTripOptions.options[e.index];
                    if (selectedOption === L("widget_passenger_end_trip_for_all")) {
                        deferred.resolve({
                            passengerId: null,
                            isFree: false
                        });
                        return;
                    }
                    for (var i = 0; i < riders.length; i++) {
                        var predictedString = String.format(L("widget_passenger_end_trip_for"), riders[i].get("firstName"));
                        if (predictedString === selectedOption) {
                            deferred.resolve({
                                passengerId: riders[i].get("rider").id,
                                isFree: false
                            });
                            return;
                        }
                    }
                    deferred.reject(_ERROR_ALREADY_HANDLED);
                });
                $.endTripOptions.show();
                return deferred.promise;
            },
            _onEndTrip: function() {
                if (boardingStateMachine.isInTransition() || _endTripClicked) return;
                var currentDrive = null, selectedRiderId = null;
                _endTripClicked = true;
                if (_role === ROLES.RIDER) {
                    var promise;
                    try {
                        _currentTrip.set("endTimestamp", networkService.getTime(Date.now()));
                        var avatar = self._getDriverAlias(_currentTrip.get("driver"));
                        promise = self.showDropOffConfirmation(avatar, null, _role === ROLES.RIDER);
                    } catch (e) {
                        _endTripClicked = false;
                        throw e;
                    }
                    promise.then(function() {
                        return Location.getContactLocation(_currentTrip, false);
                    }).then(function(location) {
                        location = location || {};
                        _currentTrip.set("endLocation", {
                            latitude: location.lat,
                            longitude: location.lon,
                            accuracy: location.accuracy
                        });
                    }).then(function() {
                        try {
                            var location = _currentTrip.get("endLocation");
                            currentDrive = boardingService.getCurrentDrive(), boardingService.leaveCar({
                                riderId: currentUser.id,
                                driverId: _currentTrip.get("phone") ? null : _currentTrip.get("driver").id,
                                timestamp: _currentTrip.get("endTimestamp"),
                                lat: location ? location.latitude : null,
                                lon: location ? location.longitude : null,
                                accuracy: location ? location.accuracy : null
                            });
                        } catch (e) {
                            LOGGER.error("LeaveCar Exception: " + JSON.stringify(e));
                        }
                    }).then(function() {
                        tabgroup._endTripIconUpdate();
                        _animPlaying++;
                        self._stopCounter();
                        _role = null;
                        _completedDrive = _currentDrive;
                        boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.END_TRIP);
                    }).finally(function() {
                        _endTripClicked = false;
                    });
                } else {
                    var promise = Q();
                    try {
                        _currentTrip.set("endTimestamp", networkService.getTime(Date.now()));
                        var passengerCount = _passengersListWidget.getOnboardPassengerCount();
                        if (0 === passengerCount) promise = Q({
                            passengerId: null,
                            isFree: false
                        }); else if (1 === passengerCount) {
                            var avatar = _passengersListWidget.getPassengerTrips()[0].get("alias");
                            promise = self.showDropOffConfirmation(avatar, null, _role === ROLES.RIDER);
                        } else promise = self.showMultiDropOffConfirmation();
                    } catch (e) {
                        _endTripClicked = false;
                        throw e;
                    }
                    promise.then(function(options) {
                        selectedRiderId = options.passengerId;
                    }).then(function() {
                        var currentDrive = boardingService.getCurrentDrive(), trips = null;
                        if (selectedRiderId) trips = [ Alloy.createModel("trip_state", {
                            startTimestamp: _currentTrip.get("startTimestamp"),
                            endTimestamp: _currentTrip.get("endTimestamp"),
                            role: "DRIVER",
                            driver: {
                                id: currentUser.id
                            },
                            rider: {
                                id: selectedRiderId
                            }
                        }) ]; else if (currentDrive.rides.length) {
                            var trips = [];
                            _.each(currentDrive.rides, function(ride) {
                                if (ride.state.done || null != ride.endTimestamp) return;
                                var trip = Alloy.createModel("trip_state", {
                                    startTimestamp: _currentTrip.get("startTimestamp"),
                                    endTimestamp: _currentTrip.get("endTimestamp"),
                                    role: "DRIVER",
                                    driver: {
                                        id: currentUser.id
                                    },
                                    rider: {
                                        id: ride.riderId
                                    }
                                });
                                trips.push(trip);
                            });
                        } else trips = [ _currentTrip ];
                        return Location.getContactLocation(trips, false);
                    }).then(function(location) {
                        location = location || {};
                        _currentTrip.set("endLocation", {
                            latitude: location.lat,
                            longitude: location.lon,
                            accuracy: location.accuracy
                        });
                    }).then(function() {
                        var location = _currentTrip.get("endLocation");
                        if (selectedRiderId) {
                            try {
                                boardingService.dropOff({
                                    riderId: selectedRiderId,
                                    driverId: currentUser.id,
                                    timestamp: _currentTrip.get("endTimestamp"),
                                    lat: location ? location.latitude : null,
                                    lon: location ? location.longitude : null,
                                    accuracy: location ? location.accuracy : null
                                });
                            } catch (e) {
                                LOGGER.error("LeaveCar Exception: " + JSON.stringify(e));
                            }
                            boardingBgService.sync();
                            _passengersListWidget.deletePassenger(selectedRiderId);
                        } else try {
                            boardingService.endDrive({
                                driverId: currentUser.id,
                                timestamp: _currentTrip.get("endTimestamp"),
                                lat: location ? location.latitude : null,
                                lon: location ? location.longitude : null,
                                accuracy: location ? location.accuracy : null
                            });
                        } catch (e) {
                            LOGGER.error("LeaveCar Exception: " + JSON.stringify(e));
                        }
                    }).then(function() {
                        if (!selectedRiderId) {
                            tabgroup._endTripIconUpdate();
                            _animPlaying++;
                            self._stopCounter();
                            _role = null;
                            _completedDrive = _currentDrive;
                            boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.END_TRIP);
                        }
                    }).finally(function() {
                        _endTripClicked = false;
                    });
                }
            },
            completeCurrentDrive: function(drive) {
                if (boardingStateMachine.isInTransition() || _endTripClicked) {
                    LOGGER.error("UNEXPECTED: Received a completeCurrentDrive in the middle of a transition!");
                    return;
                }
                try {
                    _endTripClicked = true;
                    tabgroup._endTripIconUpdate();
                    _animPlaying++;
                    self._stopCounter();
                    _role = null;
                    _completedDrive = _currentDrive;
                    boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.END_TRIP);
                } finally {
                    _endTripClicked = false;
                }
            },
            setCurrentRiderDrive: function(drive) {
                _currentDrive = drive;
                if (!drive.rides.length) return;
                var tripInfo = Alloy.createModel("trip_state", {
                    role: "RIDER",
                    inCar: true,
                    startTimestamp: drive.rides[0].startTimestamp,
                    rider: {
                        id: drive.rides[0].riderId
                    },
                    driver: {
                        id: drive.driverId
                    },
                    journeyId: drive.rides[0].journeyId
                });
                carmaCrew.setStartTripInfo(tripInfo);
                _role = null;
                boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.EXTERNAL_PICKUP);
            },
            setCurrentDriverDrive: function(drive) {
                _currentDrive = drive;
                _currentTrip = Alloy.createModel("trip_state", {
                    role: "DRIVER",
                    inCar: true,
                    startTimestamp: drive.startTimestamp,
                    driver: {
                        id: drive.driverId
                    },
                    journeyId: drive.journeyId
                });
                _role = null;
                var self = this;
                boardingStateMachine.transition(boardingStateMachine._TRANSITIONS.EXTERNAL_JOIN).then(function() {
                    self.updateCurrentDriverDrive(drive);
                });
            },
            updateCurrentRiderDrive: function(drive) {
                _currentDrive = drive;
                if (!_currentTrip.get("driver").id && drive.driverId) {
                    _currentTrip.set("driver", {
                        id: drive.driverId
                    });
                    self._setDriverAvatar();
                }
            },
            updateCurrentDriverDrive: function(drive) {
                _currentDrive = drive;
                _passengersListWidget.getPassengers().forEach(function(passenger) {
                    if ("booking" === passenger.type) return;
                    var found = null;
                    drive.rides.forEach(function(ride) {
                        ride.riderId === passenger.id && (found = ride);
                    });
                    (found && (found.endTimestamp || found.state.done) || !found) && _passengersListWidget.deletePassenger(passenger.id);
                });
                drive.rides.forEach(function(ride) {
                    if (!ride.endTimestamp && !ride.state.done) {
                        var tripInfo = Alloy.createModel("trip_state", {
                            role: "RIDER",
                            inCar: true,
                            startTimestamp: ride.startTimestamp,
                            rider: {
                                id: ride.riderId
                            },
                            journeyId: ride.journeyId
                        });
                        _passengersListWidget._createPassengerRiderRow(tripInfo);
                        TM.push(function() {
                            displayHelper.getUserAvatarImage(ride.riderId);
                        });
                    }
                });
                _passengersListWidget.isPassangersEmpty() ? driveHelper.isDriveStartedSolo(drive.driverId, drive) ? blueScreen.setTitle(L("widget_recording_solo")) : self._onEndTrip() : blueScreen.setTitle("");
            },
            _onAppPaused: function() {
                var state = boardingStateMachine.getCurrentState();
                if (state === boardingStateMachine._STATES.RIDING || state === boardingStateMachine._STATES.DRIVING || state === boardingStateMachine._STATES.DRIVING_SOLO) {
                    LOGGER.info("ONBOARD ANIMATION PAUSED ");
                    _animPlaying = 0;
                    self._stopAnimation();
                } else if (state === boardingStateMachine._STATES.RIDE_TIMER || state === boardingStateMachine._STATES.DRIVE_TIMER) {
                    LOGGER.info("RIDE START FORCED ON PAUSE ");
                    _animationManager.completeNow();
                }
            },
            _onAppResumed: function() {
                var state = boardingStateMachine.getCurrentState();
                if (state === boardingStateMachine._STATES.RIDING || state === boardingStateMachine._STATES.DRIVING || state === boardingStateMachine._STATES.DRIVING_SOLO) {
                    LOGGER.info("ONBOARD ANIMATION RESUMED");
                    _animPlaying = 2;
                    self._startAnimation(2);
                }
            },
            initialize: function() {
                _.bindAll(this, "_onStartNow", "_onStartNowClick", "_onCancel", "_onEndTrip", "_startAnimation", "_resetAnimation", "_startCounter");
                _passengersListWidget = Alloy.createWidget("ma.car.app.boardingv6", "passengers_list");
                $.passengersList.add(_passengersListWidget.getView());
                _passengersListWidget.getView().addAppEventListener("end.trip", self._initEndTripProcess);
                Ti.App.addAppEventListener("carma:life.cycle.pause", self._onAppPaused);
                Ti.App.addAppEventListener("carma:life.cycle.resume", self._onAppResumed);
                LOGGER.info("ONBOARD INITIALISED");
                IS_SMALL_SCREEN && this._customizeForSmallScreen();
            },
            destroy: function() {
                LOGGER.info("ONBOARD DESTROYED");
                Ti.App.removeAppEventListener("carma:life.cycle.pause", self._onAppPaused);
                Ti.App.removeAppEventListener("carma:life.cycle.resume", self._onAppResumed);
            },
            _customizeForSmallScreen: function() {
                $.bottomContainer.applyProperties({
                    right: "13dp",
                    bottom: "13dp",
                    left: "13dp"
                });
                $.topContainer.bottom = "74dp";
                $.inCar.height = "190dp";
                $.countDownAnimationContainer.height = "190dp";
            },
            _loadBookings: function() {
                bookingService.findAll(true).then(function(data) {
                    data && data.paginator && data.paginator.totalResults && _passengersListWidget.appendBookings(data.rideBookings);
                });
            },
            reset: function() {
                _startTripTimestamp = null;
                $.countdown.opacity = 1;
                $.inCar.applyProperties({
                    opacity: 0,
                    visible: false
                });
                _countdownClicked = false;
                _endTripClicked = false;
                _isServerAwareOfRide = false;
                _animationManager.stop();
                self.clearBoardingDots();
                _animPlaying++;
                $.driverPhoto.visible = false;
                $.favoriteIcon.visible = false;
                $.freeRiderIcon.visible = false;
                $.driverAvatarContainer.visible = false;
                $.timerButtons.visible = true;
                $.endTripButtons.visible = false;
                $.driverName.text = "";
                $.passengersList.visible = false;
                _driverProfile = null;
            },
            popCompletedDrive: function() {
                var completedDrive = _completedDrive;
                _completedDrive = null;
                return completedDrive;
            },
            setup: function(role, isExternal) {
                _role = role;
                role === ROLES.RIDER && (_currentTrip = carmaCrew.getStartTripInfo());
                isExternal || (_currentDrive = null);
                self.reset();
                if (role === ROLES.RIDER) self._setDriverAvatar(); else {
                    _passengersListWidget.reset();
                    self._loadBookings();
                    $.passengersList.visible = true;
                    _currentDrive && self.updateCurrentDriverDrive(_currentDrive);
                }
                if (isExternal) self._onStartNow(); else {
                    var tripStartTime = networkService.getTime(Date.now()) + 3e3;
                    Q().then(function() {
                        return _animationManager.start($.countDownAnimationContainer);
                    }).then(function() {
                        self._onStartNow(tripStartTime);
                    }).catch(function() {}).done();
                }
                Soundplayer.prepare("endtrip");
            },
            _setCounter: function() {
                _counterInterval && self._stopCounter();
                if (!_currentTrip) return;
                _startTripTimestamp = _currentTrip.get("startTimestamp");
                if (!_counterInterval) {
                    self._startCounter();
                    _counterInterval = setInterval(self._startCounter, 1e3);
                }
            },
            _startCounter: function() {
                if (!_startTripTimestamp) return;
                var startTimestamp = moment(_startTripTimestamp), current = moment(networkService.getTime(Date.now()));
                var diffHours = current.diff(startTimestamp, "hours");
                var diffMinutes = current.diff(startTimestamp, "minutes") % 60;
                var diffSeconds = current.diff(startTimestamp, "seconds") % 60;
                diffHours = 0 > diffHours ? 0 : diffHours;
                diffMinutes = 0 > diffMinutes ? 0 : diffMinutes;
                diffSeconds = 0 > diffSeconds ? 0 : diffSeconds;
                $.lblHours.setText(("0" + diffHours).slice(-2));
                $.lblMinutes.setText(("0" + diffMinutes).slice(-2));
                $.lblSeconds.setText(("0" + diffSeconds).slice(-2));
            },
            _stopCounter: function() {
                _startTripTimestamp = null;
                if (_counterInterval) {
                    clearInterval(_counterInterval);
                    _counterInterval = null;
                }
            },
            isDriving: function() {
                return _role === ROLES.DRIVER;
            },
            isRiding: function() {
                return _role === ROLES.RIDER;
            },
            getCurrentDrive: function() {
                return _currentDrive;
            },
            setCarmaCrew: function(crew) {
                carmaCrew = crew;
            },
            setBlueScreen: function(view) {
                blueScreen = view;
            },
            setContainer: function(view) {
                container = view;
            },
            setStateMachine: function(sm) {
                boardingStateMachine = sm;
            }
        };
        return self;
    };
    OnBoardController.$inject = [ "View", "Arguments", "CurrentUserService", "BoardingService", "BoardingBgService", "SummaryService", "ProfileService", "bookingService", "NetworkService", "TabGroup" ];
    Controller.initialize(OnBoardController, $, arguments);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;