function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "summary";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.winSummary = Ti.UI.createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        backgroundColor: "#000",
        navBarHidden: true,
        id: "winSummary"
    });
    $.__views.winSummary && $.addTopLevelView($.__views.winSummary);
    $.__views.mainContent = Ti.UI.createView({
        top: 0,
        opacity: 1,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#FFF",
        id: "mainContent"
    });
    $.__views.winSummary.add($.__views.mainContent);
    $.__views.loadingView = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: "90%",
        height: Ti.UI.FILL,
        id: "loadingView"
    });
    $.__views.mainContent.add($.__views.loadingView);
    $.__views.loadingContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: "130dp",
        layout: "vertical",
        id: "loadingContainer"
    });
    $.__views.loadingView.add($.__views.loadingContainer);
    $.__views.messageContainer = Ti.UI.createView({
        width: "90%",
        height: Ti.UI.SIZE,
        color: "#000",
        layout: "vertical",
        zIndex: 2,
        id: "messageContainer"
    });
    $.__views.loadingContainer.add($.__views.messageContainer);
    $.__views.loadingMessage1 = Ti.UI.createLabel({
        color: "#333333",
        font: {
            fontSize: "20dp",
            fontWeight: "bold"
        },
        text: L("loading_word"),
        id: "loadingMessage1"
    });
    $.__views.messageContainer.add($.__views.loadingMessage1);
    $.__views.loadingMessage2 = Ti.UI.createLabel({
        color: "#666666",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_summary_loading_message1"),
        width: "75%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "loadingMessage2"
    });
    $.__views.messageContainer.add($.__views.loadingMessage2);
    $.__views.loadingMessage3 = Ti.UI.createLabel({
        color: "#666666",
        font: {
            fontSize: "15dp"
        },
        text: "",
        top: "-21dp",
        id: "loadingMessage3"
    });
    $.__views.messageContainer.add($.__views.loadingMessage3);
    $.__views.loadingPadding = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: "32dp",
        id: "loadingPadding"
    });
    $.__views.loadingContainer.add($.__views.loadingPadding);
    $.__views.loadingIndicator = Ti.UI.createActivityIndicator({
        visible: true,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "loadingIndicator"
    });
    $.__views.loadingContainer.add($.__views.loadingIndicator);
    $.__views.__alloyId57 = Ti.UI.createView({
        id: "__alloyId57"
    });
    $.__views.loadingView.add($.__views.__alloyId57);
    $.__views.__alloyId58 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "__alloyId58"
    });
    $.__views.__alloyId57.add($.__views.__alloyId58);
    $.__views.btnLoadingDone = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        width: Ti.UI.FILL,
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnLoadingDone"
    });
    $.__views.__alloyId58.add($.__views.btnLoadingDone);
    $.__views.__alloyId59 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId59"
    });
    $.__views.btnLoadingDone.add($.__views.__alloyId59);
    $.__views.__alloyId60 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId60"
    });
    $.__views.__alloyId59.add($.__views.__alloyId60);
    $.__views.btnLoadingDoneLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: "Check it later!",
        id: "btnLoadingDoneLabel"
    });
    $.__views.__alloyId60.add($.__views.btnLoadingDoneLabel);
    $.__views.summaryView = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#FFF",
        zIndex: 1,
        id: "summaryView"
    });
    $.__views.mainContent.add($.__views.summaryView);
    $.__views.shareContent = Ti.UI.createView({
        id: "shareContent"
    });
    $.__views.summaryView.add($.__views.shareContent);
    $.__views.topContent = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        backgroundColor: "#FFF",
        id: "topContent"
    });
    $.__views.shareContent.add($.__views.topContent);
    $.__views.detailsContainer = Ti.UI.createView({
        top: 0,
        height: "80dp",
        width: Ti.UI.FILL,
        color: "#fff",
        id: "detailsContainer"
    });
    $.__views.topContent.add($.__views.detailsContainer);
    $.__views.money = Ti.UI.createView({
        width: "33.33333333333333%",
        top: 0,
        height: "80dp",
        left: 0,
        backgroundColor: "#1FA086",
        id: "money"
    });
    $.__views.detailsContainer.add($.__views.money);
    $.__views.amount = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "32dp"
        },
        height: "36dp",
        top: "15dp",
        text: "--",
        id: "amount"
    });
    $.__views.money.add($.__views.amount);
    $.__views.moneySubtitle = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: "50dp",
        text: "cost/earning",
        id: "moneySubtitle"
    });
    $.__views.money.add($.__views.moneySubtitle);
    $.__views.time = Ti.UI.createView({
        width: "33.33333333333333%",
        top: 0,
        height: "80dp",
        backgroundColor: "#835A85",
        right: 0,
        id: "time"
    });
    $.__views.detailsContainer.add($.__views.time);
    $.__views.timeAmount = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "32dp"
        },
        height: "36dp",
        top: "15dp",
        text: "--",
        id: "timeAmount"
    });
    $.__views.time.add($.__views.timeAmount);
    $.__views.timeSubtitle = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: "50dp",
        text: L("widget_rating_minutes_label"),
        id: "timeSubtitle"
    });
    $.__views.time.add($.__views.timeSubtitle);
    $.__views.distance = Ti.UI.createView({
        width: "33.33333333333333%",
        top: 0,
        height: "80dp",
        backgroundColor: "#E54E41",
        id: "distance"
    });
    $.__views.detailsContainer.add($.__views.distance);
    $.__views.distanceAmount = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "32dp"
        },
        height: "36dp",
        top: "15dp",
        text: "--",
        id: "distanceAmount"
    });
    $.__views.distance.add($.__views.distanceAmount);
    $.__views.distanceSubtitle = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: "50dp",
        text: L("widget_rating_miles_label"),
        id: "distanceSubtitle"
    });
    $.__views.distance.add($.__views.distanceSubtitle);
    $.__views.subShareContent = Ti.UI.createView({
        top: "80dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        backgroundColor: "#FFF",
        layout: "vertical",
        id: "subShareContent"
    });
    $.__views.shareContent.add($.__views.subShareContent);
    $.__views.badgeContainer = Ti.UI.createView({
        top: "8dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "badgeContainer"
    });
    $.__views.subShareContent.add($.__views.badgeContainer);
    $.__views.badgeScrollContainer = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "badgeScrollContainer"
    });
    $.__views.badgeContainer.add($.__views.badgeScrollContainer);
    $.__views.badgeName = Ti.UI.createLabel({
        color: "#333333",
        font: {
            fontSize: "20dp"
        },
        width: "90%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "badgeName"
    });
    $.__views.badgeContainer.add($.__views.badgeName);
    $.__views.badgeDescription = Ti.UI.createLabel({
        color: "#666666",
        font: {
            fontSize: "15dp"
        },
        width: "90%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "badgeDescription"
    });
    $.__views.badgeContainer.add($.__views.badgeDescription);
    $.__views.summaryContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "summaryContainer"
    });
    $.__views.subShareContent.add($.__views.summaryContainer);
    $.__views.originDestination = Ti.UI.createView({
        left: 0,
        height: Ti.UI.SIZE,
        top: "8dp",
        bottom: "8dp",
        id: "originDestination"
    });
    $.__views.summaryContainer.add($.__views.originDestination);
    $.__views.origin = Ti.UI.createLabel({
        color: "#1FA086",
        font: {
            fontSize: "15dp"
        },
        left: "20dp",
        top: "0dp",
        width: "40%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        height: "72dp",
        id: "origin"
    });
    $.__views.originDestination.add($.__views.origin);
    $.__views.arrow = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        visible: false,
        width: "33dp",
        height: "12dp",
        id: "arrow"
    });
    $.__views.originDestination.add($.__views.arrow);
    $.__views.destination = Ti.UI.createLabel({
        color: "#E54E41",
        font: {
            fontSize: "15dp"
        },
        right: "10dp",
        width: "40%",
        height: "72dp",
        top: "0dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        id: "destination"
    });
    $.__views.originDestination.add($.__views.destination);
    $.__views.bottomContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        backgroundColor: "#FFF",
        bottom: 0,
        id: "bottomContainer"
    });
    $.__views.summaryView.add($.__views.bottomContainer);
    $.__views.reviseDetailsLabel = Ti.UI.createLabel({
        color: "#666666",
        font: {
            fontSize: "15dp"
        },
        visible: false,
        left: Alloy.Globals.Style.Size.Width.pct4,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: Alloy.Globals.Style.Size.Width.pct92,
        text: L("widget_boarding_details_label"),
        id: "reviseDetailsLabel"
    });
    $.__views.bottomContainer.add($.__views.reviseDetailsLabel);
    $.__views.detailsWrongLine = Ti.UI.createView({
        visible: false,
        backgroundColor: "#666666",
        height: "1dp",
        width: "160dp",
        bottom: "8dp",
        id: "detailsWrongLine"
    });
    $.__views.bottomContainer.add($.__views.detailsWrongLine);
    $.__views.buttonContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "buttonContainer"
    });
    $.__views.bottomContainer.add($.__views.buttonContainer);
    $.__views.btnShare = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnShare"
    });
    $.__views.buttonContainer.add($.__views.btnShare);
    $.__views.__alloyId61 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId61"
    });
    $.__views.btnShare.add($.__views.__alloyId61);
    $.__views.__alloyId62 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId62"
    });
    $.__views.__alloyId61.add($.__views.__alloyId62);
    $.__views.btnShareLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_activity_lbl_share"),
        id: "btnShareLabel"
    });
    $.__views.__alloyId62.add($.__views.btnShareLabel);
    $.__views.btnDone = require("/ui/common/custom_button").createButton({
        right: 0,
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btnDone"
    });
    $.__views.buttonContainer.add($.__views.btnDone);
    $.__views.__alloyId63 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId63"
    });
    $.__views.btnDone.add($.__views.__alloyId63);
    $.__views.__alloyId64 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId64"
    });
    $.__views.__alloyId63.add($.__views.__alloyId64);
    $.__views.btnDoneLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_done"),
        id: "btnDoneLabel"
    });
    $.__views.__alloyId64.add($.__views.btnDoneLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var i18n = require("i18n/i18n"), Q = require("/vendor/q"), Utils = require("utils/utils"), Controller = require("/v6/infrastructure/Controller"), soundplayer = require("/utils/appSound"), macarnativecode = require("ma.car.nativecode"), SummaryBadgeWidgetFactory = require(WPATH("SummaryBadgeWidgetFactory")), BoardingDisplayHelper = require(WPATH("BoardingDisplayHelper")), BoardingLogMessages = require("/v6/boarding/helpers/BoardingLogMessages");
    var VIEW_TRANSITION_DURATION = 500;
    var animate = function(control, options) {
        var dfd = Q.defer();
        control.animate(options, function() {
            dfd.resolve();
        });
        return dfd.promise;
    };
    var SummaryController = function($, args, currentUser, boardingBgService, profileService, loggingService) {
        var screenWidthPixels = Ti.Platform.displayCaps.platformWidth, screenHeightPixels = Ti.Platform.displayCaps.platformHeight, screenWidthDP = Utils.defaultToDp(screenWidthPixels), screenHeightDP = Utils.defaultToDp(screenHeightPixels), displayHelper = new BoardingDisplayHelper(profileService), badgeFactory = new SummaryBadgeWidgetFactory(profileService);
        var logger = loggingService.logger("boarding");
        var badges = [];
        var currentlySelectedBadge = null;
        var slideView = null;
        var latestSummaryJSON = null;
        var clickCount = 0;
        var onHiddenClick = function() {
            ++clickCount >= 5 && latestSummaryJSON && "" != latestSummaryJSON && alert(latestSummaryJSON);
        };
        var onSummaryHidedCallback = null;
        var isInTransit = false;
        var resetContainersPositions = function() {
            $.mainContent.applyProperties({
                top: 0,
                left: 0,
                transform: Ti.UI.create2DMatrix().rotate(0)
            });
            $.loadingView.applyProperties({
                top: 0,
                left: 0,
                visible: true
            });
            $.summaryView.applyProperties({
                top: 0,
                left: screenWidthPixels,
                visible: false
            });
        };
        var takeScreenshot = function(view) {
            return view.toImage();
        };
        var disposeBadges = function() {
            var view = $.badgeScrollContainer, toRemove = [];
            for (var i = view.children.length; i > 0; i--) toRemove.push(view.children[i - 1]);
            for (var i = 0; i < toRemove.length; i++) {
                toRemove[i].viewContainer && (view.viewContainer = null);
                view.remove(toRemove[i]);
            }
            if (slideView) {
                slideView.removeEventListener("touchMoveEnd", onTouchMoveEnd);
                slideView = null;
            }
            badges = [];
            currentlySelectedBadge = null;
        };
        var onTouchMoveEnd = function(res) {
            var index = res.currentPage;
            if (index < badges.length) {
                currentlySelectedBadge = badges[index];
                $.badgeName.text = badges[index].name || "";
                $.badgeDescription.text = badges[index].description || "";
            } else currentlySelectedBadge = null;
        };
        var createBadges = function(summary) {
            summary = summary || {};
            summary.rides = summary.rides || [];
            summary.achievements = summary.achievements || [];
            summary.rewards = summary.rewards || [];
            summary.rewardTotals = summary.rewardTotals || [];
            var badgeMetrics = displayHelper.getBadgeMetrics();
            badges = [];
            summary.isError ? badges.push(badgeFactory.createErrorBadge(summary, badgeMetrics)) : summary.isPendingData && badges.push(badgeFactory.createOfflineBadge(summary, badgeMetrics));
            if (!summary.isError && summary.rewards && summary.rewards.length > 0) {
                _.each(summary.rewards, function(reward, i) {
                    "TOLL" == reward.type && badges.push(badgeFactory.createTollRewardBadge(summary, reward, badgeMetrics));
                });
                _.each(summary.rewards, function(reward, i) {
                    "PARKING" == reward.type && badges.push(badgeFactory.createParkingRewardBadge(summary, reward, badgeMetrics));
                });
                _.each(summary.rewards, function(reward) {
                    "INVITEE_SIGNUP" == reward.type && badges.push(badgeFactory.createInviteeRewardBadge(reward, badgeMetrics));
                });
            }
            summary.isError || summary.isPendingData || (summary.achievements && summary.achievements.length > 0 ? _.each(summary.achievements, function(achievement) {
                badges.push(badgeFactory.createAchievementBadge(achievement, badgeMetrics));
            }) : badges.push(badgeFactory.createAllOKBadge(summary, badgeMetrics)));
            (!summary.isError || summary.unrealisticCause) && (summary.drive.driverId == currentUser.id ? _.each(summary.rides, function(ride) {
                badges.push(badgeFactory.createBuddyBadge(summary, ride.riderId, null, badgeMetrics));
            }) : badges.push(badgeFactory.createBuddyBadge(summary, summary.drive.driverId, summary.drive.driverPhoneNumber, badgeMetrics)));
            if (summary.isError) {
                $.btnShare.visible = false;
                $.btnDone.left = 0;
                $.btnDone.width = null;
                $.btnDone.right = 0;
            } else {
                $.btnShare.visible = true;
                $.btnDone.left = null;
                $.btnDone.width = "48%";
                $.btnDone.right = 0;
            }
            slideView = null;
            $.badgeScrollContainer.height = badgeMetrics.containerHeightDP;
            var container;
            slideView = macarnativecode.createSlideView({
                color: "#0c0c0c0c",
                top: 0,
                left: 0,
                width: screenWidthDP + "dp",
                height: badgeMetrics.containerHeightDP,
                pageWidth: badgeMetrics.badgeContainerWidthDP
            });
            _.each(badges, function(badge, index) {
                var view = badge.controller.getView();
                slideView.add(view);
            });
            currentlySelectedBadge = badges.length > 0 ? badges[0] : null;
            slideView.addEventListener("touchMoveEnd", onTouchMoveEnd);
            $.badgeName.text = badges[0].name;
            $.badgeDescription.text = badges[0].description;
            $.badgeScrollContainer.add(slideView);
        };
        var bindSummaryData = function(options) {
            options = options || {};
            options.id = options.id || "";
            options.startAddress = options.startAddress || L("widget_summary_address_not_available");
            options.endAddress = options.endAddress || L("widget_summary_address_not_available");
            options.startTimestamp = options.startTimestamp || 0;
            options.endTimestamp = options.endTimestamp || 0;
            options.distance = null != options.distance ? options.distance : "--";
            options.duration = null != options.duration ? options.duration : "--";
            options.earning = options.earning || null;
            options.rides = options.rides || [];
            options.achievements = options.achievements || [];
            options.rewards = options.rewards || [];
            options.rewardTotals = options.rewardTotals || [];
            options.drive = options.drive || {};
            options.isError = !!options.isError;
            options.isPendingData = !!options.isPendingData;
            $.moneySubtitle.text = L(options.drive.driverId == currentUser.id ? "widget_rating_earned_label" : "widget_rating_cost_label");
            if (!options.isPendingData) {
                $.reviseDetailsLabel.visible = true;
                $.detailsWrongLine.visible = true;
                if (options.startTimestamp && options.startAddress && options.endTimestamp && options.endAddress) {
                    $.arrow.visible = true;
                    $.origin.text = i18n.formatTime(moment(options.startTimestamp)) + "\n" + options.startAddress;
                    $.destination.text = i18n.formatTime(moment(options.endTimestamp)) + "\n" + options.endAddress;
                }
                $.distanceSubtitle.text = i18n.getDistanceUnitDisplayString();
                options.distance >= 0 && ($.distanceAmount.text = i18n.formatDistanceFromMeters(options.distance));
                if (options.earning) {
                    $.amount.text = options.earning.amount ? options.earning.amount : "0.0";
                    var minutes = Math.round((options.endTimestamp - options.startTimestamp) / 6e4);
                    $.timeAmount.text = minutes;
                    1 == minutes && ($.timeSubtitle.text = L("widget_rating_minute_label"));
                }
            }
            createBadges(options);
            latestSummaryJSON = JSON.stringify(options);
            clickCount = 0;
            setTimeout(function() {
                soundplayer.play("endtrip");
            }, 500);
        };
        var showSummary = function(summary, onSummaryHided) {
            if (logger && logger.log) {
                logger.log("UI summary.showSummary()");
                logger.log(function() {
                    return BoardingLogMessages.fullSummaryLogMessage(summary);
                });
            }
            $.summaryView.applyProperties({
                visible: true
            });
            $.topContent.applyProperties({
                height: "100dp",
                top: "-100dp"
            });
            $.winSummary.show();
            Q().then(function() {
                var dfd = Q.defer();
                require("services/user_service").countRides(currentUser.id).then(function(carpoolCount) {
                    dfd.resolve(carpoolCount);
                }).catch(function() {
                    dfd.resolve(0);
                });
                return dfd.promise;
            }).then(function(carpoolCount) {
                summary.carpoolCount = carpoolCount;
                bindSummaryData(summary);
            }).then(function() {
                $.mainContent.applyProperties({
                    left: -screenWidthPixels
                });
            }).timeout(VIEW_TRANSITION_DURATION).catch(function(e) {
                console.log(e);
            }).then(function() {}).then(function() {
                $.topContent.applyProperties({
                    top: 0
                });
            }).timeout(500).catch(function(e) {
                console.log(e);
            }).then(function() {}).done();
        };
        var self = {
            events: {
                "click btnDone": "onDoneClick",
                "click btnErrorDone": "onDoneClick",
                "click btnOfflineDone": "onDoneClick",
                "click reviseDetailsLabel": "onReviseDetailsClick",
                "click btnShare": "onShareClick",
                "click btnLoadingDone": "onCheckLaterClick"
            },
            initialize: function() {
                require(WPATH("BoardingPopupState")).setPopupOpen();
                require("/ui/windowManager").trackWindow($.winSummary);
                $.mainContent.applyProperties({
                    top: 0,
                    left: 0,
                    transform: Ti.UI.create2DMatrix().rotate(0)
                });
                $.loadingView.width = screenWidthPixels;
                $.summaryView.width = screenWidthPixels;
                $.arrow.image = WPATH("images/arrow_trip.png");
                $.mainContent.applyProperties({
                    transform: Ti.UI.create2DMatrix().rotate(0)
                });
                $.topContent.applyProperties({
                    transform: Ti.UI.create2DMatrix().rotate(0)
                });
                resetContainersPositions();
                $.timeSubtitle.addEventListener("click", onHiddenClick);
            },
            setLoading: function(onSummaryHided) {
                $.winSummary.show();
                resetContainersPositions();
            },
            setSummary: function(summary, onSummaryHided) {
                summary = summary || {};
                onSummaryHidedCallback = function() {
                    onSummaryHided && onSummaryHided();
                };
                isInTransit = !!summary.isInTransit;
                showSummary(summary);
            },
            onDoneClick: function() {
                isInTransit ? $.winSummary.show() : $.winSummary.close();
                try {
                    onSummaryHidedCallback && onSummaryHidedCallback();
                } catch (e) {
                    LOGGER.error(e);
                }
            },
            onCheckLaterClick: function() {
                isInTransit ? $.winSummary.show() : $.winSummary.close();
            },
            onReviseDetailsClick: function() {
                var emailDialog = Ti.UI.createEmailDialog();
                if (emailDialog.isSupported()) {
                    emailDialog.toRecipients = [ "support@car.ma" ];
                    emailDialog.subject = L("widget_summary_incorrect_trip_details_subject");
                    emailDialog.messageBody = this.emailBody;
                    emailDialog.open();
                } else alert(L("widget_summary_incorrect_trip_details_noemail"));
            },
            onShareClick: function() {
                if (!currentlySelectedBadge) return;
                var summShareWidget = Alloy.createWidget("ma.car.app.boardingv6", "summaryShare", {});
                summShareWidget.getView().open();
                summShareWidget.show({
                    getBadge: function() {
                        return currentlySelectedBadge;
                    },
                    getScreenshot: function() {
                        return takeScreenshot($.shareContent);
                    },
                    getSmallScreenshot: function() {
                        return takeScreenshot($.subShareContent);
                    }
                });
            },
            destroy: function() {
                if (!$) return;
                disposeBadges();
                onSummaryHidedCallback = null;
                args = null;
                currentUser = null;
                require(WPATH("BoardingPopupState")).setPopupClosed();
            },
            resetSummary: function() {
                resetContainersPositions();
                disposeBadges();
            }
        };
        return self;
    };
    SummaryController.$inject = [ "View", "Arguments", "CurrentUserService", "BoardingBgService", "ProfileService", "LoggingService" ];
    Controller.initialize(SummaryController, $, _.toArray(arguments));
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;