function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "summaryBadge";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.badgeContainer = Ti.UI.createView({
        width: "200dp",
        height: "200dp",
        id: "badgeContainer"
    });
    $.__views.badgeContainer && $.addTopLevelView($.__views.badgeContainer);
    $.__views.badgeImage = Ti.UI.createImageView({
        defaultImage: "/images/default_photo_male-rounded.png",
        width: "170dp",
        height: "170dp",
        image: "/images/default_photo_male-rounded.png",
        left: "15dp",
        right: "15dp",
        top: "15dp",
        bottom: "15dp",
        id: "badgeImage"
    });
    $.__views.badgeContainer.add($.__views.badgeImage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), i18n = require("i18n/i18n"), Utils = require("utils/utils"), Avatar = require("/ui/common/Avatar"), Controller = require("/v6/infrastructure/Controller"), PhotoCache = require("/utils/photoCache"), PhotoURL = require("/utils/photoURL");
    var SummaryBadgeController = function($, args) {
        if (!args || !args.length) throw new Error("SummaryBadgeController arguments are missing");
        args = args[0];
        args.localImage = args.localImage || "";
        args.remoteImage = args.remoteImage || "";
        if (!args.badgeMetrics) throw new Error("SummaryBadgeController badgeMetrics argument is missing");
        var renderRemoteImage = function(url) {
            url = PhotoURL.toURL(url, {
                width: 170,
                height: 170
            });
            var photoPath = PhotoCache.getCached(url);
            photoPath && renderLocalImage(photoPath);
            PhotoCache.downloadAvatar(url).then(function(purl) {
                var photoPath1 = PhotoCache.getCached(url);
                renderLocalImage(photoPath1 ? photoPath1 : purl);
            }).done();
        };
        var renderLocalImage = function(image) {
            $.badgeImage.image = image;
            $.badgeImage.applyProperties({
                borderRadius: args.badgeMetrics.badgeImageBorderRadius
            });
        };
        var self = {
            events: {},
            initialize: function() {
                $.badgeContainer.applyProperties({
                    width: args.badgeMetrics.badgeContainerWidthDP,
                    height: args.badgeMetrics.badgeContainerHeightDP
                });
                $.badgeImage.applyProperties({
                    width: args.badgeMetrics.badgeImageWidthDP,
                    height: args.badgeMetrics.badgeImageHeightDP
                });
                args.localImage ? renderLocalImage(args.localImage) : args.remoteImage && renderRemoteImage(args.remoteImage);
            },
            setLocalImage: function(localImage) {
                renderLocalImage(localImage);
            }
        };
        return self;
    };
    SummaryBadgeController.$inject = [ "View", "Arguments" ];
    Controller.initialize(SummaryBadgeController, $, _.toArray(arguments));
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;