function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.coachmarks/" + s : s.substring(0, index) + "/ma.car.app.coachmarks/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.coachmarks");
    this.__widgetId = "ma.car.app.coachmarks";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "coach_stripe";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.wrapper = Ti.UI.createView({
        height: "100%",
        width: "100%",
        backgroundColor: "transparent",
        opacity: 1,
        id: "wrapper"
    });
    $.__views.wrapper && $.addTopLevelView($.__views.wrapper);
    $.__views.__alloyId616 = Ti.UI.createView({
        layout: "vertical",
        top: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId616"
    });
    $.__views.wrapper.add($.__views.__alloyId616);
    $.__views.__alloyId617 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId617"
    });
    $.__views.__alloyId616.add($.__views.__alloyId617);
    $.__views.__alloyId618 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId618"
    });
    $.__views.__alloyId616.add($.__views.__alloyId618);
    $.__views.__alloyId619 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId619"
    });
    $.__views.__alloyId616.add($.__views.__alloyId619);
    $.__views.lblPiggyBank = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontFamily: "splinico",
            fontSize: "80dp"
        },
        text: "t",
        id: "lblPiggyBank"
    });
    $.__views.__alloyId616.add($.__views.lblPiggyBank);
    $.__views.__alloyId620 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId620"
    });
    $.__views.__alloyId616.add($.__views.__alloyId620);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        width: "90%",
        text: L("widget_coach_stripe_title"),
        textAlign: "center",
        font: {
            fontSize: "26dp"
        },
        id: "lblTitle"
    });
    $.__views.__alloyId616.add($.__views.lblTitle);
    $.__views.__alloyId621 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId621"
    });
    $.__views.__alloyId616.add($.__views.__alloyId621);
    $.__views.lblCaption = Ti.UI.createLabel({
        color: "#fff",
        width: "90%",
        text: L("widget_coach_stripe_info"),
        textAlign: "center",
        font: {
            fontSize: "16dp"
        },
        id: "lblCaption"
    });
    $.__views.__alloyId616.add($.__views.lblCaption);
    $.__views.__alloyId622 = Ti.UI.createView({
        layout: "vertical",
        bottom: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId622"
    });
    $.__views.wrapper.add($.__views.__alloyId622);
    $.__views.buttonContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "buttonContainer"
    });
    $.__views.__alloyId622.add($.__views.buttonContainer);
    $.__views.buttonSpacer = Ti.UI.createView({
        height: "60dp",
        width: "6%",
        id: "buttonSpacer"
    });
    $.__views.buttonContainer.add($.__views.buttonSpacer);
    $.__views.btnDone = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "17dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        title: L("widget_coachmark_button_done"),
        height: "60dp",
        width: "41%",
        id: "btnDone"
    });
    $.__views.buttonContainer.add($.__views.btnDone);
    handleDone ? $.__views.btnDone.addEventListener("click", handleDone) : __defers["$.__views.btnDone!click!handleDone"] = true;
    $.__views.buttonSpacer = Ti.UI.createView({
        height: "60dp",
        width: "6%",
        id: "buttonSpacer"
    });
    $.__views.buttonContainer.add($.__views.buttonSpacer);
    $.__views.btnCheckItOut = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "17dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("widget_coach_stripe_checkitout"),
        height: "60dp",
        width: "41%",
        id: "btnCheckItOut"
    });
    $.__views.buttonContainer.add($.__views.btnCheckItOut);
    handleCheckItOut ? $.__views.btnCheckItOut.addEventListener("click", handleCheckItOut) : __defers["$.__views.btnCheckItOut!click!handleCheckItOut"] = true;
    $.__views.__alloyId623 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId623"
    });
    $.__views.__alloyId622.add($.__views.__alloyId623);
    $.__views.__alloyId624 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId624"
    });
    $.__views.__alloyId622.add($.__views.__alloyId624);
    $.__views.__alloyId625 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId625"
    });
    $.__views.__alloyId622.add($.__views.__alloyId625);
    $.__views.imgMastercard = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/cards/MasterCard.png",
        width: "50dp",
        height: "32dp",
        id: "imgMastercard"
    });
    $.__views.__alloyId625.add($.__views.imgMastercard);
    $.__views.__alloyId626 = Ti.UI.createLabel({
        color: "#fff",
        text: " ",
        font: {
            fontSize: "26dp"
        },
        id: "__alloyId626"
    });
    $.__views.__alloyId625.add($.__views.__alloyId626);
    $.__views.imgVisa = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/cards/Visa.png",
        width: "50dp",
        height: "32dp",
        id: "imgVisa"
    });
    $.__views.__alloyId625.add($.__views.imgVisa);
    $.__views.__alloyId627 = Ti.UI.createLabel({
        color: "#fff",
        text: " ",
        font: {
            fontSize: "26dp"
        },
        id: "__alloyId627"
    });
    $.__views.__alloyId625.add($.__views.__alloyId627);
    $.__views.imgAmex = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/cards/American_Express.png",
        width: "50dp",
        height: "32dp",
        id: "imgAmex"
    });
    $.__views.__alloyId625.add($.__views.imgAmex);
    $.__views.__alloyId628 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId628"
    });
    $.__views.__alloyId622.add($.__views.__alloyId628);
    $.__views.__alloyId629 = Ti.UI.createView({
        height: "3dp",
        id: "__alloyId629"
    });
    $.__views.__alloyId622.add($.__views.__alloyId629);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, funClose = args.close, utils = require("utils/utils");
    var handleDone = function() {
        dissmiss();
    };
    var handleCheckItOut = function() {
        dissmiss();
        var resourceOwner = require("services/resource_owner_service").singleton();
        Alloy.createModel("user", {
            userId: resourceOwner.get("userId")
        }).fetch().then(function(profile) {
            var navigation = Alloy.createController("navigation");
            var wrapperWindow = Alloy.createController("simpleWindow").getView();
            var stripeView = Alloy.createWidget("ma.car.app.stripePayments", "widget", {
                __parentSymbol: $.getView()
            });
            stripeView.showProfile(profile);
            navigation.init({
                index: stripeView,
                historyLimit: 20,
                mainWindow: wrapperWindow,
                transition: "none",
                modal: true
            });
            wrapperWindow.addEventListener("close", function handler() {
                wrapperWindow.removeEventListener("close", handler);
                Alloy.Globals.Nav.Profile = null;
            });
            wrapperWindow.open();
        });
    };
    var dissmiss = function() {
        $.wrapper.animate({
            opacity: 0,
            duration: 600
        }, function() {
            funClose();
        });
    };
    __defers["$.__views.btnDone!click!handleDone"] && $.__views.btnDone.addEventListener("click", handleDone);
    __defers["$.__views.btnCheckItOut!click!handleCheckItOut"] && $.__views.btnCheckItOut.addEventListener("click", handleCheckItOut);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;