function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.coachmarks/" + s : s.substring(0, index) + "/ma.car.app.coachmarks/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.coachmarks");
    this.__widgetId = "ma.car.app.coachmarks";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "coach_txtag";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.wrapper = Ti.UI.createView({
        height: "100%",
        width: "100%",
        backgroundColor: "transparent",
        id: "wrapper"
    });
    $.__views.wrapper && $.addTopLevelView($.__views.wrapper);
    $.__views.inner = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        id: "inner"
    });
    $.__views.wrapper.add($.__views.inner);
    $.__views.profilePlaceholder = Ti.UI.createView({
        height: "40dp",
        width: "55dp",
        top: "5dp",
        left: 0,
        id: "profilePlaceholder"
    });
    $.__views.inner.add($.__views.profilePlaceholder);
    $.__views.messagesPlaceholder = Ti.UI.createView({
        height: "40dp",
        width: "55dp",
        top: "5dp",
        right: 0,
        id: "messagesPlaceholder"
    });
    $.__views.inner.add($.__views.messagesPlaceholder);
    $.__views.container = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "45dp",
        height: Ti.UI.SIZE,
        id: "container"
    });
    $.__views.inner.add($.__views.container);
    $.__views.upArrow = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontFamily: "splinico",
            fontSize: "30dp"
        },
        text: "y",
        height: "15dp",
        width: "30dp",
        top: 0,
        left: 0,
        id: "upArrow"
    });
    $.__views.container.add($.__views.upArrow);
    $.__views.blueContainer = Ti.UI.createView({
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        layout: "vertical",
        height: Ti.UI.SIZE,
        left: 0,
        top: "15dp",
        id: "blueContainer"
    });
    $.__views.container.add($.__views.blueContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_txtag_coach_bold"),
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        top: "5dp",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        id: "lblTitle"
    });
    $.__views.blueContainer.add($.__views.lblTitle);
    $.__views.lblDescription = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "12dp"
        },
        text: L("widget_txtag_coach_text"),
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        height: Ti.UI.SIZE,
        id: "lblDescription"
    });
    $.__views.blueContainer.add($.__views.lblDescription);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, funClose = args.close, utils = require("utils/utils"), os = require("/platform/os"), dimension = require("/platform/dimension");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[android] profilePlaceholder": "_openProfile",
            "click[ios] profilePlaceholder": "_openProfile",
            "click[android] messagesPlaceholder": "_openConversations",
            "click[ios] messagesPlaceholder": "_openConversations",
            "click[android] container": "_openProfile",
            "click[ios] container": "_openProfile",
            "click[android] wrapper": "_dissmiss",
            "click[ios] wrapper": "_dissmiss"
        },
        initialize: function() {
            if (os.isIOS7Plus()) {
                var statusBarHeight = dimension.statusBarHeightInSystemUnit();
                $.inner.top = statusBarHeight;
            }
        },
        _openProfile: function() {
            this._dissmiss();
            Alloy.createWidget("ma.car.app.profile").getView().open();
        },
        _openConversations: function() {
            this._dissmiss();
            Alloy.createWidget("ma.car.app.messenger").getView().open();
        },
        _dissmiss: function() {
            $.wrapper.animate({
                opacity: 0,
                duration: 600
            }, function() {
                funClose();
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;