function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.common.phone/" + s : s.substring(0, index) + "/ma.car.app.common.phone/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.common.phone");
    this.__widgetId = "ma.car.app.common.phone";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "codePicker";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var countries = require("/utils/countries");
    var options = arguments[0] || {};
    var selected = options.selected;
    var selectedIndex = 0;
    var data = [];
    _.each(countries.countriesWith("dialingCode"), function(country, index) {
        country.dialingCode === selected && (selectedIndex = index);
        data.push(String.format(L("widget_phonenumber_code_picker_row"), country.name, country.dialingCode));
    });
    var dialog = Ti.UI.createOptionDialog({
        title: L("widget_phonenumber_code_picker_title"),
        options: data,
        destructive: 0,
        selectedIndex: selectedIndex
    });
    dialog.addEventListener("click", function() {
        handleDone();
    });
    var _open = function() {
        dialog.show();
    };
    var _close = function() {
        dialog.hide();
    };
    var _selected = function() {
        var index = dialog.getSelectedIndex();
        var row = countries.countriesWith("dialingCode")[index];
        return {
            name: row.name,
            dialingCode: row.dialingCode,
            cca2: row.cca2,
            cca3: row.cca3
        };
    };
    var handleDone = function() {
        options.done && options.done(_selected());
        _close();
    };
    var handleCancel = function() {
        options.cancel && options.cancel();
        _close();
    };
    exports = {
        open: function() {
            _open();
        },
        close: function() {
            _close();
        },
        getSelected: function() {
            return _selected();
        }
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;