function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.common.phone/" + s : s.substring(0, index) + "/ma.car.app.common.phone/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.common.phone");
    this.__widgetId = "ma.car.app.common.phone";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.viewPhonenumberWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "60dp",
        layout: "vertical",
        id: "viewPhonenumberWrapper"
    });
    $.__views.viewPhonenumberWrapper && $.addTopLevelView($.__views.viewPhonenumberWrapper);
    $.__views.viewPhonenumber = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "0dp",
        height: "60dp",
        id: "viewPhonenumber"
    });
    $.__views.viewPhonenumberWrapper.add($.__views.viewPhonenumber);
    $.__views.activityIndicatorWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "25%",
        zIndex: 1,
        backgroundColor: "transparent",
        height: "60dp",
        id: "activityIndicatorWrapper"
    });
    $.__views.viewPhonenumber.add($.__views.activityIndicatorWrapper);
    $.__views.activityIndicator = Ti.UI.createActivityIndicator({
        width: Titanium.UI.SIZE,
        height: Titanium.UI.SIZE,
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "activityIndicator"
    });
    $.__views.activityIndicatorWrapper.add($.__views.activityIndicator);
    $.__views.txtCode = Ti.UI.createLabel({
        color: "#666",
        top: 0,
        left: 0,
        width: "25%",
        height: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        borderRadius: 0,
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "txtCode"
    });
    $.__views.viewPhonenumber.add($.__views.txtCode);
    $.__views.__alloyId33 = Ti.UI.createView({
        top: 0,
        left: "25%",
        width: "1px",
        backgroundColor: "#c8c7cd",
        height: "60dp",
        zIndex: 10,
        id: "__alloyId33"
    });
    $.__views.viewPhonenumber.add($.__views.__alloyId33);
    $.__views.txtNumber = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "75%",
        top: 0,
        left: "25%",
        hintText: L("widget_signup_input_hint_phone"),
        keyboardType: Ti.UI.KEYBOARD_PHONE_PAD,
        id: "txtNumber"
    });
    $.__views.viewPhonenumber.add($.__views.txtNumber);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var ui = require("/utils/ui");
    var countries = require("/utils/countries");
    var args = arguments[0] || {};
    $.txtNumber.applyProperties(args);
    var DEFAULT_COUNTRY_CODE = "US";
    var DEFAULT_DIALING_CODE = "1";
    var selected = null;
    var setupCountryCode = function(cca2) {
        var countryCode = _.find(countries.countries, function(country) {
            return cca2 === country.cca2;
        });
        countryCode || (countryCode = _.find(countries.countries, function(country) {
            return DEFAULT_COUNTRY_CODE === country.cca2;
        }));
        selected = countryCode;
        $.activityIndicatorWrapper.visible = false;
        $.txtCode.text = "+" + countryCode.dialingCode;
    };
    var _init = function() {
        $.activityIndicator.show();
        setupCountryCode(GeoIPCountryCode);
        var flexSpace;
        var doneButton;
    };
    var txtCodeEventName = "click";
    $.txtCode.addEventListener(txtCodeEventName, function() {
        $.txtNumber.focus();
        $.txtNumber.blur();
        var picker = Widget.createWidget("ma.car.app.common.phone", "codePicker", {
            window: ui.getWindow($.viewPhonenumberWrapper),
            parent: $.viewPhonenumberWrapper,
            selected: selected && selected.dialingCode ? selected.dialingCode : DEFAULT_DIALING_CODE,
            done: function(value) {
                selected = value;
                $.txtCode.text = "+" + value.dialingCode;
            }
        });
        picker.open();
    });
    $.activityIndicatorWrapper.addEventListener("click", function() {
        $.activityIndicatorWrapper.visible = false;
        $.txtCode.fireEvent(txtCodeEventName);
    });
    exports = {
        getCode: function() {
            var value = $.txtCode.text;
            return value ? value.trim() : "";
        },
        getNumber: function() {
            var value = $.txtNumber.value;
            return value ? value.trim() : "";
        },
        getSelectedCountry: function() {
            return selected;
        },
        txtNumber: $.txtNumber,
        txtCode: $.txtCode,
        viewPhonenumber: $.viewPhonenumber
    };
    _init();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;