function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.favorites/" + s : s.substring(0, index) + "/ma.car.app.favorites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.favorites");
    this.__widgetId = "ma.car.app.favorites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.favoritesContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        backgroundColor: "#FFF",
        id: "favoritesContainer"
    });
    $.__views.favoritesContainer && $.addTopLevelView($.__views.favoritesContainer);
    $.__views.loading = Ti.UI.createActivityIndicator({
        color: Alloy.Globals.Style.Color.DarkGray,
        message: L("loading_spinner"),
        height: "50dp",
        width: Ti.UI.FILL,
        top: 0,
        left: 0,
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "loading"
    });
    $.__views.favoritesContainer.add($.__views.loading);
    $.__views.scrollView = Ti.UI.createScrollView({
        top: 0,
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        backgroundColor: "transparent",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        visible: false,
        needPullRefresh: true,
        id: "scrollView"
    });
    $.__views.favoritesContainer.add($.__views.scrollView);
    $.__views.__alloyId994 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "__alloyId994"
    });
    $.__views.scrollView.add($.__views.__alloyId994);
    $.__views.favoriteUserWrapper = Ti.UI.createView({
        height: "100dp",
        layout: "horizontal",
        visible: false,
        id: "favoriteUserWrapper"
    });
    $.__views.__alloyId994.add($.__views.favoriteUserWrapper);
    $.__views.addFavorite = Ti.UI.createView({
        width: "33.3%",
        height: "90dp",
        id: "addFavorite"
    });
    $.__views.favoriteUserWrapper.add($.__views.addFavorite);
    $.__views.addFavoriteImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "4dp",
        width: "60dp",
        height: "60dp",
        borderRadius: Alloy.Globals.Style.Unit.unit30,
        borderColor: "#fff",
        borderWidth: "2dp",
        image: "/images/addFreeRider.png",
        backgroundColor: Alloy.Globals.Style.Color.Orange,
        id: "addFavoriteImage"
    });
    $.__views.addFavorite.add($.__views.addFavoriteImage);
    $.__views.addFavoriteText = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        top: "68dp",
        text: L("widget_profile_favorite_add"),
        font: {
            fontSize: "13dp"
        },
        id: "addFavoriteText"
    });
    $.__views.addFavorite.add($.__views.addFavoriteText);
    $.__views.actionsForFavorites = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        top: "15dp",
        bottom: 0,
        id: "actionsForFavorites"
    });
    $.__views.__alloyId994.add($.__views.actionsForFavorites);
    $.__views.btnRemoveFavorites = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        text: L("widget_profile_favorite_remove_favorites"),
        width: "150dp",
        height: "30dp",
        font: {
            fontSize: "13dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "btnRemoveFavorites"
    });
    $.__views.actionsForFavorites.add($.__views.btnRemoveFavorites);
    $.__views.btnEditFavoriteDone = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        text: L("btn_done"),
        width: "150dp",
        height: "30dp",
        font: {
            fontSize: "13dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        visible: false,
        id: "btnEditFavoriteDone"
    });
    $.__views.actionsForFavorites.add($.__views.btnEditFavoriteDone);
    $.__views.__alloyId995 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "__alloyId995"
    });
    $.__views.scrollView.add($.__views.__alloyId995);
    $.__views.__alloyId996 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "__alloyId996"
    });
    $.__views.__alloyId995.add($.__views.__alloyId996);
    $.__views.__alloyId997 = Ti.UI.createLabel({
        color: "black",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        text: L("widget_profile_favorite_freerider_subtitle"),
        height: "50dp",
        id: "__alloyId997"
    });
    $.__views.__alloyId996.add($.__views.__alloyId997);
    $.__views.__alloyId998 = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_profile_favorite_freerider_description_1"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "__alloyId998"
    });
    $.__views.__alloyId996.add($.__views.__alloyId998);
    $.__views.__alloyId999 = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_profile_favorite_freerider_description_2"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "__alloyId999"
    });
    $.__views.__alloyId996.add($.__views.__alloyId999);
    $.__views.freeRiders = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "7dp",
        id: "freeRiders"
    });
    $.__views.__alloyId995.add($.__views.freeRiders);
    $.__views.addFreeRiders = Ti.UI.createView({
        width: "33.3%",
        height: "90dp",
        backgroundColor: "#fff",
        id: "addFreeRiders"
    });
    $.__views.freeRiders.add($.__views.addFreeRiders);
    $.__views.addFreeRidersImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "4dp",
        width: "60dp",
        height: "60dp",
        borderRadius: Alloy.Globals.Style.Unit.unit30,
        borderColor: "#fff",
        borderWidth: "2dp",
        image: "/images/addFreeRider.png",
        backgroundColor: "#4a8e35",
        id: "addFreeRidersImage"
    });
    $.__views.addFreeRiders.add($.__views.addFreeRidersImage);
    $.__views.__alloyId1000 = Ti.UI.createLabel({
        color: "#4a8e35",
        top: "68dp",
        text: L("widget_profile_favorite_add_free_rider"),
        font: {
            fontSize: "13dp"
        },
        id: "__alloyId1000"
    });
    $.__views.addFreeRiders.add($.__views.__alloyId1000);
    $.__views.actionsForFreeRiders = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        top: "15dp",
        bottom: "16dp",
        id: "actionsForFreeRiders"
    });
    $.__views.__alloyId995.add($.__views.actionsForFreeRiders);
    $.__views.btnRemoveFreeRiders = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        text: L("widget_profile_favorite_remove_free_riders"),
        width: "150dp",
        height: "30dp",
        font: {
            fontSize: "13dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "btnRemoveFreeRiders"
    });
    $.__views.actionsForFreeRiders.add($.__views.btnRemoveFreeRiders);
    $.__views.btnEditFreeRidersDone = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        text: L("btn_done"),
        width: "150dp",
        height: "30dp",
        font: {
            fontSize: "13dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        visible: false,
        id: "btnEditFreeRidersDone"
    });
    $.__views.actionsForFreeRiders.add($.__views.btnEditFreeRidersDone);
    $.__views.scrollViewMask = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: "100%",
        visible: false,
        id: "scrollViewMask"
    });
    $.__views.favoritesContainer.add($.__views.scrollViewMask);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, utils = require("utils/utils"), Globals = require("/v6/infrastructure/Globals"), favouriteUserService = Globals.IOC.get("favoriteUserService"), freeRiderService = Globals.IOC.get("freeRiderService"), userService = require("services/user_service"), FlowLayoutHelper = require("/ui/common/FlowLayoutHelper"), navigation = args.navigation || Alloy.Globals.Nav.Profile;
    var MODE_BROWSE = "browse", MODE_EDIT = "edit", TYPE_FAVORITE = "favorite", TYPE_FREE_RIDER = "freeRider";
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click addFavoriteImage": "_addFavorite",
            "click btnRemoveFavorites": "_enterEditModeSmoothly",
            "click btnEditFavoriteDone": "_exitEditMode",
            "click addFreeRidersImage": "_addFreeRider",
            "click btnRemoveFreeRiders": "_enterEditModeSmoothly",
            "click btnEditFreeRidersDone": "_exitEditMode"
        },
        TAG: "Favorites",
        favoriteUsersLayout: null,
        cachedFavoriteUsers: [],
        favoriteMode: MODE_BROWSE,
        freeRidersLayout: null,
        cachedFreeRiders: [],
        freeRiderMode: MODE_BROWSE,
        _openingAdd: false,
        initialize: function() {
            _.bindAll(this, "_addFavorite", "_addFreeRider", "_onFavoriteAdded", "_onFavoriteToggled", "_onFreeRiderAdded", "_onFreeRiderRemoved", "onRefresh", "_addOpenCallback");
            this._initUI();
            this.favoriteUsersLayout = new FlowLayoutHelper($.favoriteUserWrapper);
            this.freeRidersLayout = new FlowLayoutHelper($.freeRiders);
            this.parentWindow = require("utils/ui").getWindow($.favoritesContainer);
            this.initEventListeners();
        },
        initEventListeners: function() {
            var self = this;
            if (this.parentWindow) {
                this.parentWindow.addAppEventListener("carma:favourite.users.toggle", this._onFavoriteToggled);
                this.parentWindow.addAppEventListener("carma:free.rider.removed", this._onFreeRiderRemoved);
            } else LOGGER.warn("[Favorite] - Can not get window for favorites screen, and will ignore favorite toggle event...");
            $.favoritesContainer.addEventListener("postlayout", function onPostLayout() {
                $.favoritesContainer.removeEventListener("postlayout", onPostLayout);
                self._load();
            });
            $.scrollView.addEventListener("didTriggeredRefresh", this.onRefresh);
        },
        onRefresh: function() {
            this._load();
        },
        onDestroy: function() {
            this.cachedFavoriteUsers = [];
            this.cachedFreeRiders = [];
            this.favoriteUsersLayout.clear();
            this.freeRidersLayout.clear();
            this._cleanUp();
        },
        _load: function() {
            this._loadFavoriteUsers();
            this._loadFreeRiders();
        },
        _onRefreshDone: function() {
            if (!$.scrollView.cmMarkRefreshFinished) return;
            $.scrollView.cmMarkRefreshFinished();
        },
        _loadFavoriteUsers: function() {
            var self = this;
            favouriteUserService.getCache().then(function(cache) {
                var isCached = cache && cache.length > 0;
                self._onDataChanged(isCached, true);
                isCached && self._renderFavorites(cache, false);
                favouriteUserService.fetchAll().then(function(favorites) {
                    self._onDataChanged(false, false);
                    self._renderFavorites(favorites, true);
                }).catch(function(e) {
                    LOGGER.error("Unknown Error on fetching favorites: " + JSON.stringify(e));
                }).finally(function() {
                    self._onRefreshDone();
                }).done();
            }).catch(function(e) {
                LOGGER.error("Unknown Error on fetching cached favorites: " + JSON.stringify(e));
            }).done();
        },
        _loadFreeRiders: function() {
            var self = this;
            freeRiderService.getFreeRiders().progress(function(users) {
                self._renderFreeRiders(users, false);
            }).then(function(users) {
                self._renderFreeRiders(users, true);
            }).catch(function(e) {
                LOGGER.error("Unkown error on fetching free riders : " + JSON.stringify(e));
            }).done();
        },
        _renderFavorites: function(favorites, shortCircuit) {
            this._renderFavoritesLayout(favorites.length, shortCircuit);
            var delta = favouriteUserService.compares(this.cachedFavoriteUsers, favorites), self = this;
            _.each(delta.added, function(favorite) {
                var favoriteFrame = Alloy.createWidget("ma.car.app.favorites", "frame", {
                    type: TYPE_FAVORITE,
                    user: favorite
                });
                self.favoriteUsersLayout.add(favorite.userId, favoriteFrame);
            });
            _.each(delta.updated, function(favorite) {
                var favoriteFrame = self.favoriteUsersLayout.findById(favorite.userId);
                favoriteFrame.update(favorite);
            });
            _.each(delta.deleted, function(favorite) {
                var widget = self.favoriteUsersLayout.remove(favorite.userId);
                widget && widget.destroy();
            });
            this.cachedFavoriteUsers = favorites;
        },
        _renderFreeRiders: function(users, shortCircuit) {
            this._renderFreeRidersLayout(users.length, shortCircuit);
            var delta = freeRiderService.compares(this.cachedFreeRiders, users), self = this;
            _.each(delta.added, function(user) {
                self.freeRidersLayout.add(user.userId, Alloy.createWidget("ma.car.app.favorites", "frame", {
                    type: TYPE_FREE_RIDER,
                    user: user
                }));
            });
            _.each(delta.updated, function(user) {
                var widget = self.freeRidersLayout.findById(user.userId);
                widget.update(user);
            });
            _.each(delta.deleted, function(user) {
                self.freeRidersLayout.remove(user.userId);
            });
            this.cachedFreeRiders = users;
        },
        _addFavorite: function() {
            if (this.favoriteMode !== MODE_BROWSE || this._openingAdd) return;
            this._openingAdd = true;
            var widget = Alloy.createWidget("ma.car.app.favorites", "add_user", {
                navigation: navigation,
                type: TYPE_FAVORITE
            });
            widget.on("added", this._onFavoriteAdded);
            navigation.open(widget, {
                title: L("widget_profile_favorite_add")
            }, this._addOpenCallback);
        },
        _addFreeRider: function() {
            if (this.freeRiderMode !== MODE_BROWSE || this._openingAdd) return;
            this._openingAdd = true;
            var widget = Alloy.createWidget("ma.car.app.favorites", "add_user", {
                navigation: navigation,
                type: TYPE_FREE_RIDER
            });
            widget.on("added", this._onFreeRiderAdded);
            navigation.open(widget, {
                title: L("widget_profile_favorite_add_free_rider")
            }, this._addOpenCallback);
        },
        _addOpenCallback: function() {
            this._openingAdd = false;
        },
        _onFavoriteAdded: function(favorite) {
            this.cachedFavoriteUsers.push(favorite);
            this._renderFavoritesLayout(this.cachedFavoriteUsers.length, true);
            $.scrollView.scrollToBottom();
            var widget = Alloy.createWidget("ma.car.app.favorites", "frame", {
                type: TYPE_FAVORITE,
                user: favorite
            }), view = widget.getView();
            view.visible = false;
            this.favoriteUsersLayout.add(favorite.userId, widget);
            this._showSmoothly(view);
        },
        _onFreeRiderAdded: function(user) {
            this.cachedFreeRiders.push(user);
            this._renderFreeRidersLayout(this.cachedFreeRiders.length, true);
            $.scrollView.scrollToBottom();
            var widget = Alloy.createWidget("ma.car.app.favorites", "frame", {
                type: TYPE_FREE_RIDER,
                user: user
            }), view = widget.getView();
            view.visible = false;
            this.freeRidersLayout.add(user.userId, widget);
            this._showSmoothly(view);
        },
        _onFavoriteRemoved: function(favorite) {
            var removedFavorite = favouriteUserService.removeByUserId(this.cachedFavoriteUsers, favorite.userId);
            if (!removedFavorite) return;
            this.favoriteUsersLayout.remove(removedFavorite.userId);
            0 === this.cachedFavoriteUsers.length && this._exitEditMode({
                source: $.btnEditFavoriteDone
            });
            this._renderFavoritesLayout(this.cachedFavoriteUsers.length, true);
        },
        _onFreeRiderRemoved: function(user) {
            var removedUser = freeRiderService.removeByUserId(this.cachedFreeRiders, user.userId);
            if (!removedUser) return;
            this.freeRidersLayout.remove(removedUser.userId);
            0 === this.cachedFreeRiders.length && this._exitEditMode({
                source: $.btnEditFreeRidersDone
            });
            this._renderFreeRidersLayout(this.cachedFreeRiders.length, true);
        },
        _onFavoriteToggled: function(event) {
            if (!event) return;
            if ("add" === event.action) {
                this._onFavoriteAdded(event.user);
                return;
            }
            if ("remove" === event.action) {
                this._onFavoriteRemoved(event.user);
                return;
            }
            LOGGER.error("Can not parse event[" + JSON.stringify(event) + "] on FavoriteToggle event.");
        },
        _initUI: function(argument) {
            var screenWidth = utils.pixelToDp(Ti.Platform.displayCaps.platformWidth);
            var left = Math.floor((screenWidth - 260) / 2);
            var screenHeight = utils.pixelToDp(Ti.Platform.displayCaps.platformHeight);
            $.favoriteUserWrapper.height = screenHeight - 120 + "dp";
            Alloy.Globals.setUnderline($.btnRemoveFavorites, true);
            Alloy.Globals.setUnderline($.btnEditFavoriteDone, true);
            Alloy.Globals.setUnderline($.btnRemoveFreeRiders, true);
            Alloy.Globals.setUnderline($.btnEditFreeRidersDone, true);
        },
        _onDataChanged: function(isCached, isSyning) {
            if (!isCached && isSyning) {
                $.scrollView.top = "50dp";
                $.loading.show();
                $.scrollView.visible = false;
                return;
            }
            $.loading.hide();
            $.scrollView.top = 0;
            $.scrollView.visible = true;
        },
        _showSmoothly: function(view) {
            _.delay(function() {
                view.transform = Ti.UI.create2DMatrix().scale(.1);
                view.visible = true;
                view.animate({
                    duration: 200,
                    transform: Ti.UI.create2DMatrix({
                        scale: 1.2
                    })
                }, function() {
                    view.animate({
                        duration: 100,
                        transform: Ti.UI.create2DMatrix({
                            scale: 1
                        })
                    }, function() {
                        view.transform = Ti.UI.create2DMatrix().scale(1);
                    });
                });
                setTimeout(function() {
                    view.transform = Ti.UI.create2DMatrix().scale(1);
                }, 1e3);
            }, 500);
        },
        _renderFavoritesLayout: function(count, shortCircuit) {
            $.favoriteUserWrapper.visible = count > 0 || $.favoriteUserWrapper.visible || !!shortCircuit;
            $.addFavorite.width = 0 === count ? "100%" : "33.3%";
            $.favoriteUserWrapper.height = 90 * Math.ceil((count + 1) / 3) + "dp";
            $.actionsForFavorites.visible = 0 !== count;
        },
        _renderFreeRidersLayout: function(count, shortCircuit) {
            $.freeRiders.visible = count > 0 || $.freeRiders.visible || !!shortCircuit;
            $.addFreeRiders.width = 0 === count ? "100%" : "33.3%";
            $.freeRiders.height = 90 * Math.ceil((count + 1) / 3) + "dp";
            $.actionsForFreeRiders.visible = 0 !== count;
        },
        _enterEditModeSmoothly: function(e) {
            if ("btnRemoveFavorites" === e.source.id) {
                this.favoriteMode = MODE_EDIT;
                var animation = Ti.UI.createAnimation({
                    duration: 300,
                    opacity: .6
                });
                var favoriteWidgets = this.favoriteUsersLayout.getAll();
                $.addFavoriteImage.animate(animation);
                for (var i = 0; i < favoriteWidgets.length; i++) favoriteWidgets[i].enterEditModeSmoothly();
                this._onModeChanged(TYPE_FAVORITE, true);
                return;
            }
            if ("btnRemoveFreeRiders" === e.source.id) {
                this.freeRiderMode = MODE_EDIT;
                var animation = Ti.UI.createAnimation({
                    duration: 300,
                    opacity: .6
                });
                var widgets = this.freeRidersLayout.getAll();
                $.addFreeRidersImage.animate(animation);
                for (var i = 0; i < widgets.length; i++) widgets[i].enterEditModeSmoothly();
                this._onModeChanged(TYPE_FREE_RIDER, true);
                return;
            }
        },
        _exitEditMode: function(e) {
            if ("btnEditFavoriteDone" === e.source.id) {
                var widgets = this.favoriteUsersLayout.getAll();
                $.addFavoriteImage.opacity = 1;
                for (var i = 0; i < widgets.length; i++) widgets[i].exitEditMode();
                this._onModeChanged(TYPE_FAVORITE, false);
                this.favoriteMode = MODE_BROWSE;
                return;
            }
            if ("btnEditFreeRidersDone" === e.source.id) {
                var widgets = this.freeRidersLayout.getAll();
                $.addFreeRidersImage.opacity = 1;
                for (var i = 0; i < widgets.length; i++) widgets[i].exitEditMode();
                this._onModeChanged(TYPE_FREE_RIDER, false);
                this.freeRiderMode = MODE_BROWSE;
                return;
            }
        },
        _onModeChanged: function(type, isEditMode) {
            if ("favorite" === type) {
                $.btnRemoveFavorites.visible = !isEditMode;
                $.btnEditFavoriteDone.visible = !!isEditMode;
                return;
            }
            if ("freeRider" === type) {
                $.btnRemoveFreeRiders.visible = !isEditMode;
                $.btnEditFreeRidersDone.visible = !!isEditMode;
                return;
            }
        },
        _cleanUp: function() {
            this.favoriteUsersLayout = null;
            this.freeRidersLayout = null;
            this.favoriteMode = null;
            this.freeRiderMode = null;
            if (this.parentWindow) {
                this.parentWindow.removeAppEventListener("carma:favourite.users.toggle", this._onFavoriteToggled);
                this.parentWindow.removeAppEventListener("carma:free.rider.removed", this._onFreeRiderRemoved);
            }
            this.parentWindow = null;
            this.TAG = null;
            args = null;
            navigation = null;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;