function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bestMatches";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.matchesContainer = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        left: 0,
        top: 0,
        backgroundColor: "white",
        id: "matchesContainer"
    });
    $.__views.matchesContainer && $.addTopLevelView($.__views.matchesContainer);
    $.__views.loading = Ti.UI.createActivityIndicator({
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        top: "120dp",
        zIndex: 2,
        id: "loading"
    });
    $.__views.matchesContainer.add($.__views.loading);
    $.__views.refreshingLayout = Ti.UI.createView({
        backgroundColor: "#70ffffff",
        height: 0,
        width: "100%",
        top: 0,
        left: 0,
        zIndex: 1,
        id: "refreshingLayout"
    });
    $.__views.matchesContainer.add($.__views.refreshingLayout);
    $.__views.emptyMatchesList = Ti.UI.createView({
        height: 0,
        width: "100%",
        top: 0,
        left: 0,
        layout: "vertical",
        id: "emptyMatchesList"
    });
    $.__views.matchesContainer.add($.__views.emptyMatchesList);
    $.__views.emptyMatchesImage = Ti.UI.createImageView({
        defaultImage: "/images/nomatches.png",
        width: "83.33333333333334%",
        height: "auto",
        image: "/images/nomatches.png",
        id: "emptyMatchesImage"
    });
    $.__views.emptyMatchesList.add($.__views.emptyMatchesImage);
    $.__views.emptyMatchesMessage = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        width: "83.33333333333334%",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_future_empty_match_message"),
        height: Ti.UI.SIZE,
        top: "20dp",
        bottom: "20dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "emptyMatchesMessage"
    });
    $.__views.emptyMatchesList.add($.__views.emptyMatchesMessage);
    $.__views.inviteFriendsButton = require("/ui/common/custom_button").createButton({
        width: "50%",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("widget_samantha_nomatches_btn"),
        bottom: "20dp",
        height: "40dp",
        id: "inviteFriendsButton"
    });
    $.__views.emptyMatchesList.add($.__views.inviteFriendsButton);
    $.__views.enableTripsView = Ti.UI.createView({
        height: 0,
        width: "100%",
        top: 0,
        left: 0,
        layout: "vertical",
        id: "enableTripsView"
    });
    $.__views.matchesContainer.add($.__views.enableTripsView);
    $.__views.notripsImage = Ti.UI.createImageView({
        defaultImage: "/images/tripsdisabled.png",
        width: "83.33333333333334%",
        height: "auto",
        image: "/images/tripsdisabled.png",
        id: "notripsImage"
    });
    $.__views.enableTripsView.add($.__views.notripsImage);
    $.__views.notripsMessage = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        width: "83.33333333333334%",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_tripdisabled_message"),
        height: Ti.UI.SIZE,
        top: "20dp",
        bottom: "20dp",
        id: "notripsMessage"
    });
    $.__views.enableTripsView.add($.__views.notripsMessage);
    $.__views.matchesListView = Ti.UI.createView({
        layout: "vertical",
        height: Ti.UI.SIZE,
        top: 0,
        id: "matchesListView"
    });
    $.__views.matchesContainer.add($.__views.matchesListView);
    $.__views.dayTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        backgroundColor: Alloy.Globals.Style.Color.Grey,
        height: 0,
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_BOTTOM,
        id: "dayTitle"
    });
    $.__views.matchesListView.add($.__views.dayTitle);
    $.__views.roleTabs = Alloy.createWidget("ma.car.app.future2", "roleTabs", {
        id: "roleTabs",
        __parentSymbol: $.__views.matchesListView
    });
    $.__views.roleTabs.setParent($.__views.matchesListView);
    $.__views.matchesListContainer = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        id: "matchesListContainer"
    });
    $.__views.matchesListView.add($.__views.matchesListContainer);
    $.__views.matchesBuffer1 = Alloy.createWidget("ma.car.app.future2", "bestMatchesBuffer", {
        id: "matchesBuffer1",
        __parentSymbol: $.__views.matchesListContainer
    });
    $.__views.matchesBuffer1.setParent($.__views.matchesListContainer);
    $.__views.matchesBuffer2 = Alloy.createWidget("ma.car.app.future2", "bestMatchesBuffer", {
        id: "matchesBuffer2",
        __parentSymbol: $.__views.matchesListContainer
    });
    $.__views.matchesBuffer2.setParent($.__views.matchesListContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Globals = require("/v6/infrastructure/Globals"), Q = require("/vendor/q"), exploreService = Globals.IOC.get("exploreService"), inviteService = Globals.IOC.get("inviteService");
    exports = new (require("/carmalib/controller").extend($, {
        _loading: false,
        _buffers: {
            matchesBuffer1: $.matchesBuffer1,
            matchesBuffer2: $.matchesBuffer2
        },
        _bufferId: null,
        _isFirstCall: true,
        _batchData: null,
        events: {
            "click inviteFriendsButton": "_inviteFriendsAction"
        },
        initialize: function() {
            _.bindAll(this, "loadBestMatches", "_renderBestMatches", "_handleError", "_renderDayTitle", "_flipBuffers", "_updateBuffer", "_renderTabsInfo", "_renderNoTripsEnabledView", "_renderEmptyMatchesList");
        },
        initWidget: function() {
            return this.loadBestMatches({
                localOnly: true
            });
        },
        setBatchData: function(data, options) {
            this._batchData = data;
            this.loadBestMatches(options);
        },
        loadBestMatches: function(options) {
            options = options || {};
            if (this._loading) return;
            this._loading = true;
            if (options.nextTripUpdated) {
                $.dayTitle.hide();
                $.roleTabs.getView().hide();
                this._buffers && this._bufferId && this._buffers[this._bufferId].hideBuffer();
            }
            var self = this;
            $.refreshingLayout.height = "100%";
            $.loading.show();
            return Q().then(function() {
                return self._getData(options);
            }).then(this._checkGlobalMatches).then(this._renderDayTitle).then(this._renderTabsInfo).then(function(data) {
                self._updateBuffer();
                var tripType = self._getSearchType() || data.rideMatches.tripMatchedAgainst.baseTrip.type;
                "DRIVE" === tripType ? $.roleTabs._riderTabClick() : $.roleTabs._driverTabClick();
                return data;
            }).then(this._renderBestMatches).catch(this._handleError).finally(this._flipBuffers).finally(function() {
                self._loading = false;
                if (options.localOnly) return;
                $.loading.hide();
                $.refreshingLayout.height = 0;
            }).catch(function(error) {
                LOGGER.error("[bestMatches] - " + error);
            });
        },
        _getData: function(options) {
            options = options || {};
            if (options.localOnly) return exploreService.getBestMatches(options);
            if (this._batchData) {
                var data = this._batchData;
                this._batchData = null;
                return data;
            }
            return exploreService.getBestDriversAndRidersMatches();
        },
        _checkGlobalMatches: function(data) {
            if (!data || 522 === data.status) throw data;
            var rideMatches = data.rideMatches, driveMatches = data.driveMatches;
            if (!rideMatches && !driveMatches || !rideMatches.paginator.totalResults && !driveMatches.paginator.totalResults || !rideMatches.tripMatchedAgainst && !driveMatches.tripMatchedAgainst) throw data;
            return data;
        },
        _renderDayTitle: function(data) {
            var rideMatches = data.rideMatches, driveMatches = data.driveMatches, tripMatchedAgainst = rideMatches.tripMatchedAgainst || driveMatches.tripMatchedAgainst;
            $.dayTitle.applyProperties({
                text: require("i18n/i18n").formatTodayDate(tripMatchedAgainst.baseTrip.schedule.effectiveTime).toUpperCase(),
                height: "30dp"
            });
            $.dayTitle.show();
            return data;
        },
        _renderTabsInfo: function(data) {
            $.roleTabs.renderTabsInfo(data);
            $.roleTabs.getView().show();
            return data;
        },
        _renderBestMatches: function(data) {
            this._renderMatchesContainer();
            return this._buffers[this._bufferId].renderMatches(data);
        },
        _handleError: function(error) {
            if (!error || 522 === error.status) return;
            var rideMatches = error.rideMatches, driveMatches = error.driveMatches;
            if (!rideMatches || !driveMatches) {
                this._renderEmptyMatchesList();
                return;
            }
            if (!rideMatches.tripMatchedAgainst && !driveMatches.tripMatchedAgainst) {
                0 === rideMatches.numEnabledTrips && (rideMatches.numDisabledTrips > 0 ? this._renderNoTripsEnabledView(L("widget_samantha_tripdisabled_message"), false) : this._renderNoTripsEnabledView(L("widget_future_no_trips_message"), true));
                return;
            }
            if (!rideMatches.paginator.totalResults && !driveMatches.paginator.totalResults) {
                this._renderEmptyMatchesList();
                return;
            }
            LOGGER.error("[bestMatches.js] - " + error.toString());
        },
        _updateBuffer: function() {
            this._bufferId = "matchesBuffer1" === this._bufferId ? "matchesBuffer2" : "matchesBuffer1";
        },
        _flipBuffers: function() {
            if (this._bufferId) {
                this._buffers[this._bufferId].showBuffer();
                "matchesBuffer1" === this._bufferId ? $.matchesBuffer2.hideBuffer() : $.matchesBuffer1.hideBuffer();
            }
            if (this._isFirstCall) {
                this._isFirstCall = false;
                setTimeout(function() {
                    $.matchesListContainer.opacity = 1;
                }, 350);
                $.matchesListContainer.animate({
                    opacity: 1,
                    duration: 300
                });
            }
        },
        _renderEmptyMatchesList: function() {
            $.emptyMatchesList.applyProperties({
                height: Ti.UI.SIZE,
                opacity: 0
            });
            $.matchesListView.height = 0;
            $.enableTripsView.height = 0;
            this._fadeInView($.emptyMatchesList);
        },
        _renderMatchesContainer: function() {
            $.matchesListView.applyProperties({
                height: Ti.UI.SIZE
            });
            $.emptyMatchesList.height = 0;
            $.enableTripsView.height = 0;
        },
        _renderNoTripsEnabledView: function(text, noTrips) {
            $.notripsMessage.text = text;
            $.emptyMatchesList.height = 0;
            $.matchesListView.height = 0;
            $.notripsImage.applyProperties({
                image: noTrips ? "/images/notrips.png" : "/images/tripsdisabled.png",
                defaultImage: noTrips ? "/images/notrips.png" : "/images/tripsdisabled.png"
            });
            if (0 !== $.enableTripsView.height) return;
            $.enableTripsView.applyProperties({
                height: Ti.UI.SIZE,
                opacity: 0
            });
            this._fadeInView($.enableTripsView);
        },
        _fadeInView: function(view) {
            setTimeout(function() {
                view.opacity = 1;
            }, 300);
            view.animate({
                opacity: 1,
                duration: 300
            });
        },
        _inviteFriendsAction: function() {
            inviteService.inviteFriend();
        },
        _getSearchType: function() {
            var searchType = exploreService.getSearchType();
            if (!searchType) return;
            return "RIDE" === searchType ? "DRIVE" : "RIDE";
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;