function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "matchRow";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.rowContainer = Ti.UI.createView({
        width: "91.66666666666666%",
        height: "60dp",
        backgroundColor: "#ffffffff",
        id: "rowContainer"
    });
    $.__views.rowContainer && $.addTopLevelView($.__views.rowContainer);
    $.__views.userAvatar = require("/ui/common/profile").createView({
        backgroundColor: "#fff",
        borderColor: "#fff",
        borderWidth: 1,
        defaultImage: "/images/default_photo_male-rounded.png",
        left: 0,
        width: "48dp",
        height: "48dp",
        borderRadius: Alloy.Globals.Style.Unit.unit24,
        id: "userAvatar"
    });
    $.__views.rowContainer.add($.__views.userAvatar);
    $.__views.departureName = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        height: "19dp",
        left: "60dp",
        right: "55dp",
        top: "4dp",
        ellipsize: true,
        id: "departureName"
    });
    $.__views.rowContainer.add($.__views.departureName);
    $.__views.departureAddress = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        height: "19dp",
        left: "60dp",
        right: "55dp",
        top: "21dp",
        ellipsize: true,
        id: "departureAddress"
    });
    $.__views.rowContainer.add($.__views.departureAddress);
    $.__views.arrivalAddress = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        height: "19dp",
        left: "60dp",
        right: "55dp",
        top: "38dp",
        ellipsize: true,
        id: "arrivalAddress"
    });
    $.__views.rowContainer.add($.__views.arrivalAddress);
    $.__views.btnAsk = require("/ui/common/ask").createView({
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        right: 0,
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "btnAsk"
    });
    $.__views.rowContainer.add($.__views.btnAsk);
    $.__views.__alloyId1088 = Ti.UI.createView({
        width: "100%",
        height: "1px",
        left: 0,
        bottom: 0,
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId1088"
    });
    $.__views.rowContainer.add($.__views.__alloyId1088);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, moment = require("/vendor/moment");
    exports = new (require("/carmalib/controller").extend($, {
        _matchData: null,
        _userTripId: null,
        events: {
            "click departureName": "_openUserProfile",
            "click departureAddress": "_openUserProfile",
            "click arrivalAddress": "_openUserProfile"
        },
        initialize: function() {
            this._matchData = args.match;
            this._populateData();
        },
        _populateData: function() {
            if (!this._matchData) return;
            this._matchData.user.layout = "circular-small";
            $.userAvatar.setUser(this._matchData.user);
            $.departureName.text = require("i18n/i18n").formatTime(moment(this._matchData.effectiveTime)) + " - " + this._matchData.user.alias;
            $.departureAddress.text = this._matchData.origin.address;
            $.arrivalAddress.text = String.format(L("widget_future_to_destination"), this._matchData.destination.address);
            $.btnAsk.setData({
                trip: {
                    id: this._matchData.matchedTripId,
                    origin: this._matchData.origin,
                    destination: this._matchData.destination,
                    type: this._matchData.type,
                    effectiveTime: this._matchData.effectiveTime,
                    user: {
                        userId: this._matchData.user.userId,
                        firstName: this._matchData.user.firstName
                    }
                },
                groupingKey: args.groupingKey
            }, false);
            this._userTripId = this._matchData.matchedTripId + "-" + this._matchData.baseEffectiveTime;
        },
        _setRoleIcon: function() {
            $.roleIcon.applyProperties({
                image: "RIDE" === this._matchData.type ? "/images/rider-outlined.png" : "/images/driver-outlined.png",
                defaultImage: "RIDE" === this._matchData.type ? "/images/rider-outlined.png" : "/images/driver-outlined.png"
            });
        },
        _openUserProfile: function() {
            $.userAvatar.fireEvent("click");
        },
        getUserTripId: function() {
            return this._userTripId;
        },
        setBookingObject: function(booking) {
            if (!booking) return;
            $.btnAsk.setBooking(booking);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;