function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.exploreWin = require("/ui/common/child_window").createView({
        top: 0,
        left: 0,
        bottom: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "white",
        id: "exploreWin"
    });
    $.__views.exploreWin && $.addTopLevelView($.__views.exploreWin);
    $.__views.__alloyId1090 = Ti.UI.createView({
        backgroundColor: Alloy.Globals.Style.Color.Orange,
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        zIndex: 99,
        id: "__alloyId1090"
    });
    $.__views.exploreWin.add($.__views.__alloyId1090);
    $.__views.nextTripBarWrapper = Ti.UI.createView({
        borderWidth: 0,
        height: Ti.UI.SIZE,
        top: "6dp",
        bottom: "6dp",
        left: 0,
        right: 0,
        id: "nextTripBarWrapper"
    });
    $.__views.__alloyId1090.add($.__views.nextTripBarWrapper);
    $.__views.nextTrip = Alloy.createWidget("ma.car.app.future2", "nextTrip", {
        id: "nextTrip",
        isMaster: "true",
        __parentSymbol: $.__views.nextTripBarWrapper
    });
    $.__views.nextTrip.setParent($.__views.nextTripBarWrapper);
    $.__views.scrollView = Ti.UI.createScrollView({
        top: "62dp",
        left: 0,
        bottom: 0,
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.Orange,
        needPullRefresh: true,
        id: "scrollView"
    });
    $.__views.exploreWin.add($.__views.scrollView);
    $.__views.scrollViewBackgroundContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        bottom: 0,
        backgroundColor: "white",
        id: "scrollViewBackgroundContainer"
    });
    $.__views.scrollView.add($.__views.scrollViewBackgroundContainer);
    $.__views.scrollViewWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "scrollViewWrapper"
    });
    $.__views.scrollView.add($.__views.scrollViewWrapper);
    $.__views.bookings = Alloy.createWidget("ma.car.app.future2", "bookings", {
        id: "bookings",
        __parentSymbol: $.__views.scrollViewWrapper
    });
    $.__views.bookings.setParent($.__views.scrollViewWrapper);
    $.__views.bestMatches = Alloy.createWidget("ma.car.app.future2", "bestMatches", {
        id: "bestMatches",
        __parentSymbol: $.__views.scrollViewWrapper
    });
    $.__views.bestMatches.setParent($.__views.scrollViewWrapper);
    $.__views.tripsList = Alloy.createWidget("ma.car.app.future2", "tripsList", {
        id: "tripsList",
        __parentSymbol: $.__views.exploreWin
    });
    $.__views.tripsList.setParent($.__views.exploreWin);
    $.__views.noInternetView = Ti.UI.createView({
        top: 0,
        left: 0,
        height: 0,
        width: "100%",
        zIndex: 100,
        backgroundColor: "white",
        id: "noInternetView"
    });
    $.__views.exploreWin.add($.__views.noInternetView);
    $.__views.noInternetWrapper = Ti.UI.createView({
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "noInternetWrapper"
    });
    $.__views.noInternetView.add($.__views.noInternetWrapper);
    $.__views.noInternetAvatar = Ti.UI.createImageView({
        defaultImage: "/images/offline.png",
        width: "100%",
        height: "auto",
        image: "/images/offline.png",
        bottom: "10dp",
        id: "noInternetAvatar"
    });
    $.__views.noInternetWrapper.add($.__views.noInternetAvatar);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        width: "75%",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_no_internet_title"),
        bottom: "10dp",
        id: "labelTitle"
    });
    $.__views.noInternetWrapper.add($.__views.labelTitle);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        width: "75%",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_no_internet_label"),
        id: "labelMessage"
    });
    $.__views.noInternetWrapper.add($.__views.labelMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("/vendor/q"), Globals = require("/v6/infrastructure/Globals"), exploreService = Globals.IOC.get("exploreService"), exploreController = require("/v6/common/ExploreController"), bookingService = Globals.IOC.get("bookingService"), tripService = Globals.IOC.get("tripService"), globalEvents = require("/v6/common/GlobalEvents");
    exports = new (require("/carmalib/controller").extend($, {
        _tripListOpened: false,
        _refreshIntervalTime: 6e5,
        events: {},
        initialize: function() {
            _.bindAll(this, "_toggleTripsList", "_checkNetworkStatus", "handleBack", "_onNextTripUpdated", "_onBookingUpdated", "_onTripsUpdated", "_reloadMatchMeScreen", "onRefresh");
            this._initEventListeners();
            this._customiseUI();
            this._initWidgets();
            this._initRefreshInterval();
            Ti.Network.online || this._showNoInternetView();
        },
        _initEventListeners: function() {
            $.exploreWin.addAppEventListener("carma:network.change", this._checkNetworkStatus);
            $.scrollView.addEventListener("didTriggeredRefresh", this.onRefresh);
            exploreController.on(exploreController.MENU_BUTTON_CLICK, this._toggleTripsList);
            exploreService.on(exploreService.NEXT_TRIP_UPDATED, this._onNextTripUpdated);
            bookingService.on(bookingService.BOOKING_UPDATED, this._onBookingUpdated);
            tripService.on(tripService.TRIP_UPDATED_EVENT, this._onTripsUpdated);
            globalEvents.onTripFinished(this._onBookingUpdated);
        },
        _customiseUI: function() {
            var isIOS7Plus = require("/platform/os").isIOS7Plus();
            if (isIOS7Plus) {
                var top = parseInt($.nextTripBarWrapper.top, 10) + 20;
                $.nextTripBarWrapper.top = top;
                $.scrollView.top = parseInt($.scrollView.top, 10) + 20;
            }
        },
        _fetchExploreInfo: function(options) {
            return exploreService.fetchExploreInfo().then(function(data) {
                $.nextTrip.setBatchData(data.nextTripResponse);
                $.bestMatches.setBatchData(data.bestMatchesResponse, options);
                $.bookings.setBatchData(data.bookingsResponse);
            }).catch(function(error) {
                LOGGER.error("[Match me] - _fetchExploreInfo: " + error);
            });
        },
        _initWidgets: function() {
            Q.all([ $.nextTrip.initWidget(), $.bestMatches.initWidget() ]).finally(this._fetchExploreInfo).finally(function() {
                $.tripsList.initWidget();
            });
        },
        _initRefreshInterval: function() {
            setInterval(this._reloadMatchMeScreen, this._refreshIntervalTime);
        },
        onRefresh: function() {
            this._fetchExploreInfo({
                pullDownToRefresh: true
            }).finally(function() {
                $.scrollView.cmMarkRefreshFinished && $.scrollView.cmMarkRefreshFinished();
            });
        },
        onDestroy: function() {
            $.scrollView.removeEventListener("didTriggeredRefresh", this.onRefresh);
        },
        _onNextTripUpdated: function() {
            this._closeTripsListAndRotateMenuIcon();
            $.nextTrip.loadNextTrip();
            $.bestMatches.loadBestMatches({
                nextTripUpdated: true
            });
        },
        _onBookingUpdated: function() {
            $.bestMatches.loadBestMatches();
            $.bookings.loadBookings();
            $.nextTrip.refreshBookingsForNextTrip();
        },
        _onTripsUpdated: function(data) {
            $.bookings.checkTripEventType(data);
        },
        _reloadMatchMeScreen: function() {
            $.nextTrip.loadNextTrip();
            $.bestMatches.loadBestMatches();
        },
        _toggleTripsList: function(data) {
            data = data || {};
            data.open ? this._openTripsList() : this._closeTripsList();
        },
        _openTripsList: function() {
            if (this._tripListOpened) return;
            $.tripsList.openTripsList();
            this._tripListOpened = true;
        },
        _closeTripsList: function() {
            if (!this._tripListOpened) return;
            $.tripsList.closeTripsList();
            this._tripListOpened = false;
        },
        _closeTripsListAndRotateMenuIcon: function() {
            if (!this._tripListOpened || exploreController.isSliding()) return;
            exploreController.setSliding(true);
            this._closeTripsList();
            $.nextTrip.pointArrowDown();
            setTimeout(function() {
                exploreController.setSliding(false);
            }, exploreController.SLIDE_DOWN_ANIMATION_TIME);
        },
        _checkNetworkStatus: function(state) {
            if (state.connected) {
                this._hideNoInternetView();
                return;
            }
            this._showNoInternetView();
        },
        _showNoInternetView: function() {
            $.noInternetView.height = "100%";
        },
        _hideNoInternetView: function() {
            $.noInternetView.height = 0;
        },
        openMyTripsMenu: function() {
            this._openTripsList();
            $.nextTrip.pointArrowUp();
        },
        reset: function() {
            $.tripsList.closeTripsList();
            $.nextTrip.pointArrowDown();
            this._tripListOpened = false;
        },
        handleBack: function() {
            if (this._tripListOpened) {
                this._closeTripsList();
                $.nextTrip.pointArrowDown();
            } else Ti.App.fireEvent("carma:home.tab");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;