function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.help/" + s : s.substring(0, index) + "/ma.car.app.help/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.help");
    this.__widgetId = "ma.car.app.help";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "card";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.cardContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        backgroundColor: "transparent",
        layout: "vertical",
        height: "100%",
        id: "cardContainer"
    });
    $.__views.cardContainer && $.addTopLevelView($.__views.cardContainer);
    $.__views.imageView = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "10dp",
        bottom: "10dp",
        height: "200dp",
        id: "imageView"
    });
    $.__views.cardContainer.add($.__views.imageView);
    $.__views.title = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "15dp"
        },
        width: "95%",
        top: "8dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        id: "title"
    });
    $.__views.cardContainer.add($.__views.title);
    $.__views.text = Ti.UI.createLabel({
        color: "#000",
        font: {
            fontSize: "15dp"
        },
        width: "95%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        top: "8dp",
        id: "text"
    });
    $.__views.cardContainer.add($.__views.text);
    $.__views.footer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "footer"
    });
    $.__views.cardContainer.add($.__views.footer);
    $.__views.action = require("/ui/common/custom_button").createButton({
        height: Ti.UI.SIZE,
        font: {
            fontSize: "18dp"
        },
        width: Ti.UI.SIZE,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        bottom: "70dp",
        visible: false,
        title: "",
        id: "action"
    });
    $.__views.footer.add($.__views.action);
    $.__views.__alloyId704 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        top: "10dp",
        bottom: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId704"
    });
    $.__views.action.add($.__views.__alloyId704);
    $.__views.actionLabel = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        id: "actionLabel"
    });
    $.__views.__alloyId704.add($.__views.actionLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Queue = require("/utils/queue"), BaseController = require("/carmalib/controller");
    var Controller = BaseController.extend($, {
        _id: args.id,
        _title: args.title,
        _text: args.text,
        _image: args.image,
        _action: args.action || "",
        _actionFn: args.actionFn || function() {},
        _ui: new Queue({
            name: "ui",
            timeout: 500
        }),
        events: {
            "click[android] action": "onActionClick",
            "singletap[ios] action": "onActionClick"
        },
        initialize: function() {
            this._ui.bind(this, "onActionClick", {
                unique: true
            });
            $.title.text = this._title;
            $.text.text = this._text;
            $.actionLabel.text = this._action;
            $.action.visible = this._action ? true : false;
            if (this._image) $.imageView.image = WPATH("/images/" + this._image); else {
                $.imageView.width = $.imageView.height = 0;
                $.imageView.visible = false;
            }
        },
        onActionClick: function() {
            if (!this._action) return;
            return this._actionFn();
        }
    });
    exports = new Controller();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;