function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.help/" + s : s.substring(0, index) + "/ma.car.app.help/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.help");
    this.__widgetId = "ma.car.app.help";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.helpWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        height: Ti.UI.FILL,
        top: Alloy.Globals.Style.Size.Height.pct99,
        visible: false,
        width: Ti.UI.FILL,
        backgroundColor: "#FFF",
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "helpWindow"
    });
    $.__views.helpWindow && $.addTopLevelView($.__views.helpWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, BaseController = require("/carmalib/controller");
    var Controller = BaseController.extend($, {
        events: {},
        initialize: function() {
            var navigation = Alloy.createController("navigation"), widget = Alloy.createWidget("ma.car.app.help", "help");
            navigation.init({
                index: widget,
                historyLimit: 20,
                mainWindow: $.helpWindow,
                modal: true,
                transition: "none",
                title: L("widget_howto_title"),
                navBarColor: "#FFF"
            });
            $.helpWindow.addEventListener("close", function closeHandler() {
                $.helpWindow.removeEventListener("close", closeHandler);
                widget.onDestroy();
                widget = null;
            });
        },
        destroy: function() {}
    });
    exports = new Controller();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;