function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.intro/" + s : s.substring(0, index) + "/ma.car.app.intro/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.intro");
    this.__widgetId = "ma.car.app.intro";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.introWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        left: 0,
        height: "100%",
        width: "100%",
        backgroundImage: "/images/background.png",
        navBarHidden: true,
        id: "introWindow"
    });
    $.__views.introWindow && $.addTopLevelView($.__views.introWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), builder = require(WPATH("/builder_android"));
    builder.initialise($.getView());
    builder.createScreens($.introWindow);
    $.introWindow.addEventListener("androidback", function() {
        $.introWindow.close();
        var activity = Ti.Android.currentActivity;
        activity.finish();
    });
    var duration = 0;
    $.introWindow.addEventListener("open", function handler() {
        $.introWindow.removeEventListener("open", handler);
        $.introWindow.backgroundImage = Ti.App.Properties.getString("lastBlurredBackgroundImagePath", "/images/background.png");
        analytics.track(event.PAGE_HIT, {
            view: "scrollIntro"
        });
        duration = Date.now();
        Ti.App.fireEvent("carma:scroller.build.complete", {});
    });
    $.introWindow.addEventListener("blur", function handler() {
        $.introWindow.removeEventListener("blur", handler);
        analytics.track(event.SCROLL_INTRO_DISPLAY, {
            duration: Date.now() - duration
        });
    });
    exports = {
        lockViews: function() {
            builder.addListeners();
        }
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;