function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.invites/" + s : s.substring(0, index) + "/ma.car.app.invites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.invites");
    this.__widgetId = "ma.car.app.invites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "inviteeRewardShare";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.inviteeRewardShare = Ti.UI.createView({
        backgroundColor: "white",
        width: "100%",
        height: "100%",
        id: "inviteeRewardShare"
    });
    $.__views.inviteeRewardShare && $.addTopLevelView($.__views.inviteeRewardShare);
    $.__views.__alloyId1070 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        layout: "vertical",
        top: "50dp",
        bottom: "177dp",
        left: "13dp",
        right: "13dp",
        id: "__alloyId1070"
    });
    $.__views.inviteeRewardShare.add($.__views.__alloyId1070);
    $.__views.__alloyId1071 = Ti.UI.createView({
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        bottom: "15dp",
        top: "15dp",
        width: "100%",
        height: "200dp",
        id: "__alloyId1071"
    });
    $.__views.__alloyId1070.add($.__views.__alloyId1071);
    $.__views.avatar = Ti.UI.createImageView({
        defaultImage: "/images/default_photo_male-rounded.png",
        width: "170dp",
        height: "170dp",
        borderRadius: Alloy.Globals.Style.Unit.unit85,
        image: "/images/default_photo_male-rounded.png",
        id: "avatar"
    });
    $.__views.__alloyId1071.add($.__views.avatar);
    $.__views.rewardSourceTitle = Ti.UI.createLabel({
        color: "#333333",
        font: {
            fontSize: "20dp"
        },
        width: "90%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "rewardSourceTitle"
    });
    $.__views.__alloyId1070.add($.__views.rewardSourceTitle);
    $.__views.rewardSourceDescription = Ti.UI.createLabel({
        color: "#666666",
        font: {
            fontSize: "15dp"
        },
        width: "90%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "rewardSourceDescription"
    });
    $.__views.__alloyId1070.add($.__views.rewardSourceDescription);
    $.__views.__alloyId1072 = Ti.UI.createView({
        height: "120dp",
        width: "100%",
        bottom: "57dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "__alloyId1072"
    });
    $.__views.inviteeRewardShare.add($.__views.__alloyId1072);
    $.__views.__alloyId1073 = Ti.UI.createLabel({
        color: "#1fa086",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_invite_reward_share_desc"),
        left: "13dp",
        right: "13dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "__alloyId1073"
    });
    $.__views.__alloyId1072.add($.__views.__alloyId1073);
    $.__views.buttonContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: "44dp",
        layout: "composite",
        left: "10dp",
        right: "10dp",
        bottom: "13dp",
        id: "buttonContainer"
    });
    $.__views.inviteeRewardShare.add($.__views.buttonContainer);
    $.__views.btnShare = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnShare"
    });
    $.__views.buttonContainer.add($.__views.btnShare);
    $.__views.__alloyId1074 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1074"
    });
    $.__views.btnShare.add($.__views.__alloyId1074);
    $.__views.__alloyId1075 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1075"
    });
    $.__views.__alloyId1074.add($.__views.__alloyId1075);
    $.__views.btnShareLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_activity_lbl_share"),
        id: "btnShareLabel"
    });
    $.__views.__alloyId1075.add($.__views.btnShareLabel);
    $.__views.btnDone = require("/ui/common/custom_button").createButton({
        right: 0,
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btnDone"
    });
    $.__views.buttonContainer.add($.__views.btnDone);
    $.__views.__alloyId1076 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1076"
    });
    $.__views.btnDone.add($.__views.__alloyId1076);
    $.__views.__alloyId1077 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1077"
    });
    $.__views.__alloyId1076.add($.__views.__alloyId1077);
    $.__views.btnDoneLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_done"),
        id: "btnDoneLabel"
    });
    $.__views.__alloyId1077.add($.__views.btnDoneLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, utils = require("utils/utils"), navigation = args.navigation, trackingEvent = require("/tracking/tracking_event"), userservice = require("services/user_service"), analytics = require("/tracking/tracking_manager");
    var SCREEN_HEIGHT = require("utils/utils").pixelToDp(Ti.Platform.displayCaps.platformHeight);
    var REWARD_CONSTANT = "$10";
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click btnDone": "dismiss",
            "click avatar": "showInvitee",
            "click btnShare": "openNativeShare"
        },
        _inviteCode: null,
        _inviteId: null,
        _shareOpening: false,
        initialize: function(argument) {
            _.bindAll(this, "openNativeShare", "openShare");
            this._renderInvitee();
        },
        _renderInvitee: function(argument) {
            var self = this;
            this._loadPublicProfile(args.invitee).then(function(profile) {
                self._renderBadge(profile.photoUrl);
                if (args.noReward) {
                    $.rewardSourceTitle.text = L("widget_stripe_payments_enter_promo_success");
                    $.rewardSourceDescription.text = String.format(L("native_share_referral_enter_des"), profile.firstName);
                } else {
                    $.rewardSourceTitle.text = String.format(L("widget_invite_reward_source_title"), REWARD_CONSTANT);
                    $.rewardSourceDescription.text = String.format(L("widget_invite_reward_source_des"), profile.firstName, self.getTextByGenderAndLanguage(profile.gender));
                }
            });
        },
        _loadPublicProfile: function(inviteeId) {
            return Alloy.createModel("public_profile", {
                userId: inviteeId
            }).fetch();
        },
        dismiss: function() {
            args.window && args.window.close();
        },
        showInvitee: function() {
            Ti.App.fireEvent("carma:profile.open", {
                userId: args.invitee
            });
        },
        getTextByGenderAndLanguage: function(gender) {
            var language = Ti.Locale.getCurrentLanguage();
            if (!language) return "";
            if (0 === language.search("no") || 0 === language.search("nb") || 0 === language.search("nn")) return "f" === gender ? "henne" : "hans";
            if (0 === language.search("en")) return "f" === gender ? "her" : "his";
            return "";
        },
        _renderBadge: function(photoUrl) {
            var photoCache = require("/utils/photoCache"), url = require("/utils/photoURL").toURL(photoUrl, {
                width: 170,
                height: 170
            });
            var photoPath = photoCache.getCached(url);
            if (photoPath) {
                this._renderImage(photoPath);
                return;
            }
            var self = this;
            photoCache.downloadAvatar(url).then(function(purl) {
                var photoPath1 = photoCache.getCached(url);
                self._renderImage(photoPath1 ? photoPath1 : purl);
            });
        },
        _renderImage: function(image) {
            if (!image) return;
            $.avatar.image = image;
        },
        openNativeShare: function() {
            this._inviteCode = userservice.getCachReferralCode();
            var self = this;
            this._inviteId && this._inviteCode ? this.openShare() : this._inviteId ? this._inviteCode ? this.openShare() : userservice.getReferralCode().then(function(data) {
                userservice.cachReferralCode(data.referralCode);
                self._inviteCode = data.referralCode;
                self.openShare();
            }) : Alloy.createModel("invitation").generate({
                method: "REFERRAL_CODE",
                entity: "user"
            }).then(function(data) {
                self._inviteId = data.id;
                self._inviteCode ? self.openShare() : userservice.getReferralCode().then(function(data) {
                    userservice.cachReferralCode(data.referralCode);
                    self._inviteCode = data.referralCode;
                    self.openShare();
                });
            });
        },
        openShare: function() {
            require("ui/common/sharing").openShare({
                type: "invitefriends",
                inviteId: this._inviteId,
                inviteCode: this._inviteCode,
                subject: L(args.noReward ? "native_share_referral_enter_subject" : "native_share_referral_notification_subject")
            }, this);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;