function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.invites/" + s : s.substring(0, index) + "/ma.car.app.invites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.invites");
    this.__widgetId = "ma.car.app.invites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.referralContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        backgroundColor: "#FFF",
        id: "referralContainer"
    });
    $.__views.referralContainer && $.addTopLevelView($.__views.referralContainer);
    $.__views.referralWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "100%",
        id: "referralWrapper"
    });
    $.__views.referralContainer.add($.__views.referralWrapper);
    $.__views.invitecode = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        height: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        id: "invitecode"
    });
    $.__views.referralWrapper.add($.__views.invitecode);
    $.__views.inviteCodeTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "15dp",
        text: L("widget_stripe_payments_enter_promo_code_below"),
        id: "inviteCodeTitle"
    });
    $.__views.invitecode.add($.__views.inviteCodeTitle);
    $.__views.textField = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: "15dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        hintText: "EG. SARAHW14",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1px",
        id: "textField"
    });
    $.__views.invitecode.add($.__views.textField);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "100%",
        top: "10dp",
        title: "Submit invite code",
        id: "submit"
    });
    $.__views.invitecode.add($.__views.submit);
    $.__views.howWorksDescripTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        top: "20dp",
        text: L("widget_stripe_payments_promo_code_descrip_title"),
        id: "howWorksDescripTitle"
    });
    $.__views.invitecode.add($.__views.howWorksDescripTitle);
    $.__views.howWorkDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        width: "100%",
        text: "When you enter a referral code, both you and your friend will get $10 after your first carpool trip.\n\nThis $10 will be added to your Carma balance, which you can view at any time in your profile.",
        id: "howWorkDetails"
    });
    $.__views.invitecode.add($.__views.howWorkDetails);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, utils = require("utils/utils"), navigation = args.navigation || Alloy.Globals.Nav.Profile;
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click submit": "_handleSubmit"
        },
        TAG: "ReferralCode",
        initialize: function() {
            var screenWidth = utils.pixelToDp(Ti.Platform.displayCaps.platformWidth);
            var screenHeight = utils.pixelToDp(Ti.Platform.displayCaps.platformHeight);
            var _window = require("utils/ui").getWindow($.referralContainer);
            _window && LOGGER.info("[Favorite] - get windows");
        },
        onDestroy: function() {
            args.navigation;
        },
        _handleSubmit: function() {
            alert("Deal with promo code");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;