function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.loading/" + s : s.substring(0, index) + "/ma.car.app.loading/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function show(_message, _cancelable) {
        if (ctrl && ctrl.hasFocus) {
            ctrl.update(_message, _cancelable);
            return;
        }
        var newCtrl = Widget.createController("window", {
            message: _message,
            cancelable: _cancelable
        });
        newCtrl.open();
        ctrl && hide();
        ctrl = newCtrl;
    }
    function hide() {
        if (ctrl) {
            ctrl.close();
            ctrl = null;
        }
        return;
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.loading");
    this.__widgetId = "ma.car.app.loading";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {}, ctrl;
    Object.defineProperty($, "visible", {
        get: function() {
            return ctrl && ctrl.hasFocus;
        },
        set: function(visible) {
            return visible ? show() : hide();
        }
    });
    exports.show = show;
    exports.hide = hide;
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;