function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.messenger/" + s : s.substring(0, index) + "/ma.car.app.messenger/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function handleLongPress(data) {
        exports.copyMessageToClipboard(data);
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.messenger");
    this.__widgetId = "ma.car.app.messenger";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "chat";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        zIndex: 1,
        width: "100%",
        height: "100%",
        top: 0,
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.overlay = Ti.UI.createView({
        zIndex: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "transparent",
        id: "overlay"
    });
    $.__views.layout.add($.__views.overlay);
    $.__views.indicator = Ti.UI.createActivityIndicator({
        top: "50dp",
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "indicator"
    });
    $.__views.overlay.add($.__views.indicator);
    var __alloyId68 = {};
    var __alloyId71 = [];
    var __alloyId73 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId74 = [];
            var __alloyId76 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId77 = [];
                    var __alloyId79 = {
                        type: "Ti.UI.View",
                        bindId: "avatarStyle",
                        childTemplates: function() {
                            var __alloyId80 = [];
                            var __alloyId81 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: "#5b85df",
                                    top: "5dp",
                                    left: "-2dp",
                                    font: {
                                        fontSize: "14dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "g",
                                    width: "16dp",
                                    height: "16dp"
                                }
                            };
                            __alloyId80.push(__alloyId81);
                            var __alloyId83 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/none.png",
                                    height: "40dp",
                                    width: "40dp",
                                    right: 0,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId80.push(__alloyId83);
                            return __alloyId80;
                        }(),
                        properties: {
                            top: 0,
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            bindId: "avatarStyle"
                        }
                    };
                    __alloyId77.push(__alloyId79);
                    var __alloyId85 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId86 = [];
                            var __alloyId88 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId89 = [];
                                    var __alloyId91 = {
                                        type: "Ti.UI.Label",
                                        bindId: "messageIcon",
                                        properties: {
                                            color: "#fff",
                                            width: "0",
                                            height: "0",
                                            font: {
                                                fontSize: "16dp",
                                                fontFamily: "splinico"
                                            },
                                            text: "x",
                                            top: "14dp",
                                            left: "5dp",
                                            bindId: "messageIcon"
                                        }
                                    };
                                    __alloyId89.push(__alloyId91);
                                    var __alloyId93 = {
                                        type: "Ti.UI.TextArea",
                                        bindId: "message",
                                        properties: {
                                            paddingLeft: "10dp",
                                            autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
                                            borderRadius: Alloy.Globals.Style.Unit.unit4,
                                            color: "#fff",
                                            backgroundColor: "transparent",
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            top: "5dp",
                                            left: "5dp",
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            autocorrect: false,
                                            autoLink: Ti.UI.AUTOLINK_NONE,
                                            editable: false,
                                            handleLinks: false,
                                            scrollable: false,
                                            touchEnabled: true,
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId89.push(__alloyId93);
                                    return __alloyId89;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: 0,
                                    backgroundColor: "#5b85df"
                                }
                            };
                            __alloyId86.push(__alloyId88);
                            var __alloyId95 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: null,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    right: 0,
                                    bindId: "date"
                                }
                            };
                            __alloyId86.push(__alloyId95);
                            return __alloyId86;
                        }(),
                        properties: {
                            top: 0,
                            right: "55dp",
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical"
                        }
                    };
                    __alloyId77.push(__alloyId85);
                    return __alloyId77;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId74.push(__alloyId76);
            return __alloyId74;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: 0,
            backgroundColor: "transparent"
        }
    };
    __alloyId71.push(__alloyId73);
    var __alloyId70 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "messageTemplate"
        },
        events: {
            longpress: handleLongPress
        },
        childTemplates: __alloyId71
    };
    __alloyId68["messageTemplate"] = __alloyId70;
    var __alloyId98 = [];
    var __alloyId100 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId101 = [];
            var __alloyId103 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId104 = [];
                    var __alloyId106 = {
                        type: "Ti.UI.View",
                        bindId: "avatarStyle",
                        childTemplates: function() {
                            var __alloyId107 = [];
                            var __alloyId109 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/none.png",
                                    height: "40dp",
                                    width: "40dp",
                                    right: null,
                                    left: 0,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId107.push(__alloyId109);
                            var __alloyId110 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: "#303037",
                                    top: "5dp",
                                    left: null,
                                    font: {
                                        fontSize: "18dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "v",
                                    width: "16dp",
                                    height: "16dp",
                                    right: "-3dp"
                                }
                            };
                            __alloyId107.push(__alloyId110);
                            return __alloyId107;
                        }(),
                        properties: {
                            top: 0,
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0,
                            bindId: "avatarStyle"
                        }
                    };
                    __alloyId104.push(__alloyId106);
                    var __alloyId112 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId113 = [];
                            var __alloyId115 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId116 = [];
                                    var __alloyId118 = {
                                        type: "Ti.UI.Label",
                                        bindId: "messageIcon",
                                        properties: {
                                            color: "#fff",
                                            width: "0",
                                            height: "0",
                                            font: {
                                                fontSize: "16dp",
                                                fontFamily: "splinico"
                                            },
                                            text: "x",
                                            top: "14dp",
                                            left: "5dp",
                                            bindId: "messageIcon"
                                        }
                                    };
                                    __alloyId116.push(__alloyId118);
                                    var __alloyId120 = {
                                        type: "Ti.UI.TextArea",
                                        bindId: "message",
                                        properties: {
                                            paddingLeft: "10dp",
                                            autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
                                            borderRadius: Alloy.Globals.Style.Unit.unit4,
                                            color: "#fff",
                                            backgroundColor: "transparent",
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            top: "5dp",
                                            left: "5dp",
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            autocorrect: false,
                                            autoLink: Ti.UI.AUTOLINK_NONE,
                                            editable: false,
                                            handleLinks: false,
                                            scrollable: false,
                                            touchEnabled: true,
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId116.push(__alloyId120);
                                    return __alloyId116;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "#303037",
                                    left: 0
                                }
                            };
                            __alloyId113.push(__alloyId115);
                            var __alloyId122 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId113.push(__alloyId122);
                            return __alloyId113;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId104.push(__alloyId112);
                    return __alloyId104;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId101.push(__alloyId103);
            return __alloyId101;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: 0,
            backgroundColor: "transparent"
        }
    };
    __alloyId98.push(__alloyId100);
    var __alloyId97 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "leftMessageTemplate"
        },
        events: {
            longpress: handleLongPress
        },
        childTemplates: __alloyId98
    };
    __alloyId68["leftMessageTemplate"] = __alloyId97;
    var __alloyId125 = [];
    var __alloyId127 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId128 = [];
            var __alloyId130 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    top: "1px"
                }
            };
            __alloyId128.push(__alloyId130);
            var __alloyId132 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId133 = [];
                    var __alloyId135 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId136 = [];
                            var __alloyId138 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/none.png",
                                    height: "40dp",
                                    width: "40dp",
                                    right: null,
                                    left: 0,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId136.push(__alloyId138);
                            return __alloyId136;
                        }(),
                        properties: {
                            top: "4dp",
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0
                        }
                    };
                    __alloyId133.push(__alloyId135);
                    var __alloyId140 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId141 = [];
                            var __alloyId143 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId144 = [];
                                    var __alloyId146 = {
                                        type: "Ti.UI.Label",
                                        bindId: "message",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            top: 0,
                                            left: 0,
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            backgroundColor: "transparent",
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId144.push(__alloyId146);
                                    return __alloyId144;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "transparent",
                                    left: "3dp"
                                }
                            };
                            __alloyId141.push(__alloyId143);
                            var __alloyId148 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId141.push(__alloyId148);
                            return __alloyId141;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId133.push(__alloyId140);
                    return __alloyId133;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId128.push(__alloyId132);
            var __alloyId150 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    bottom: "1px"
                }
            };
            __alloyId128.push(__alloyId150);
            return __alloyId128;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: "5dp",
            backgroundColor: "transparent",
            bottom: "5dp"
        }
    };
    __alloyId125.push(__alloyId127);
    var __alloyId124 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bookingMessageTemplate"
        },
        childTemplates: __alloyId125
    };
    __alloyId68["bookingMessageTemplate"] = __alloyId124;
    var __alloyId153 = [];
    var __alloyId155 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId156 = [];
            var __alloyId158 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    top: "1px"
                }
            };
            __alloyId156.push(__alloyId158);
            var __alloyId160 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId161 = [];
                    var __alloyId163 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId164 = [];
                            var __alloyId166 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: Alloy.Globals.Style.Color.DarkGray,
                                    font: {
                                        fontSize: "18dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "c",
                                    width: "42dp",
                                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                                    left: 0
                                }
                            };
                            __alloyId164.push(__alloyId166);
                            return __alloyId164;
                        }(),
                        properties: {
                            top: "4dp",
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0
                        }
                    };
                    __alloyId161.push(__alloyId163);
                    var __alloyId168 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId169 = [];
                            var __alloyId171 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId172 = [];
                                    var __alloyId174 = {
                                        type: "Ti.UI.Label",
                                        bindId: "message",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            top: 0,
                                            left: 0,
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            backgroundColor: "transparent",
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId172.push(__alloyId174);
                                    return __alloyId172;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "transparent",
                                    left: "3dp"
                                }
                            };
                            __alloyId169.push(__alloyId171);
                            var __alloyId176 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId169.push(__alloyId176);
                            return __alloyId169;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId161.push(__alloyId168);
                    return __alloyId161;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId156.push(__alloyId160);
            var __alloyId178 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    bottom: "1px"
                }
            };
            __alloyId156.push(__alloyId178);
            return __alloyId156;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: "5dp",
            backgroundColor: "transparent",
            bottom: "5dp"
        }
    };
    __alloyId153.push(__alloyId155);
    var __alloyId152 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bookingAcceptedMessageTemplate"
        },
        childTemplates: __alloyId153
    };
    __alloyId68["bookingAcceptedMessageTemplate"] = __alloyId152;
    var __alloyId181 = [];
    var __alloyId183 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId184 = [];
            var __alloyId186 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    top: "1px"
                }
            };
            __alloyId184.push(__alloyId186);
            var __alloyId188 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId189 = [];
                    var __alloyId191 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId192 = [];
                            var __alloyId194 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: Alloy.Globals.Style.Color.DarkGray,
                                    font: {
                                        fontSize: "18dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "h",
                                    width: "42dp",
                                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                                    left: 0
                                }
                            };
                            __alloyId192.push(__alloyId194);
                            return __alloyId192;
                        }(),
                        properties: {
                            top: "4dp",
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0
                        }
                    };
                    __alloyId189.push(__alloyId191);
                    var __alloyId196 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId197 = [];
                            var __alloyId199 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId200 = [];
                                    var __alloyId202 = {
                                        type: "Ti.UI.Label",
                                        bindId: "message",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            top: 0,
                                            left: 0,
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            backgroundColor: "transparent",
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId200.push(__alloyId202);
                                    return __alloyId200;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "transparent",
                                    left: "3dp"
                                }
                            };
                            __alloyId197.push(__alloyId199);
                            var __alloyId204 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId197.push(__alloyId204);
                            return __alloyId197;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId189.push(__alloyId196);
                    return __alloyId189;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId184.push(__alloyId188);
            var __alloyId206 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    bottom: "1px"
                }
            };
            __alloyId184.push(__alloyId206);
            return __alloyId184;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: "5dp",
            backgroundColor: "transparent",
            bottom: "5dp"
        }
    };
    __alloyId181.push(__alloyId183);
    var __alloyId180 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bookingCancelledMessageTemplate"
        },
        childTemplates: __alloyId181
    };
    __alloyId68["bookingCancelledMessageTemplate"] = __alloyId180;
    var __alloyId209 = [];
    var __alloyId211 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId212 = [];
            var __alloyId214 = {
                type: "Ti.UI.Label",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    text: L("widget_messenger_load_earlier_messages"),
                    top: "5dp",
                    bottom: "5dp",
                    font: {
                        fontSize: "14dp"
                    }
                }
            };
            __alloyId212.push(__alloyId214);
            return __alloyId212;
        }(),
        properties: {
            color: Alloy.Globals.Style.Color.DarkGray,
            borderRadius: Alloy.Globals.Style.Unit.unit3,
            height: "60dp",
            font: {
                fontSize: "18dp"
            },
            normalColor: "#00333333",
            selectedColor: "#70333333",
            backgroundImage: "none",
            borderColor: Alloy.Globals.Style.Color.DarkGray,
            borderWidth: 2,
            indicator: "true",
            touchEnabled: "false",
            top: "5dp",
            bottom: "10dp",
            width: "90%"
        }
    };
    __alloyId209.push(__alloyId211);
    var __alloyId208 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "loadMoreTemplate"
        },
        childTemplates: __alloyId209
    };
    __alloyId68["loadMoreTemplate"] = __alloyId208;
    var __alloyId217 = [];
    var __alloyId219 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId220 = [];
            var __alloyId222 = {
                type: "Ti.UI.Label",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    text: L("widget_messenger_load_earlier_messages"),
                    top: "5dp",
                    bottom: "5dp",
                    font: {
                        fontSize: "14dp"
                    }
                }
            };
            __alloyId220.push(__alloyId222);
            return __alloyId220;
        }(),
        properties: {
            color: Alloy.Globals.Style.Color.DarkGray,
            borderRadius: Alloy.Globals.Style.Unit.unit3,
            height: "60dp",
            font: {
                fontSize: "18dp"
            },
            normalColor: "#00333333",
            selectedColor: "#70333333",
            backgroundImage: "none",
            borderColor: Alloy.Globals.Style.Color.DarkGray,
            borderWidth: 2,
            opacity: .3,
            indicator: "true",
            touchEnabled: "false",
            top: "5dp",
            bottom: "10dp",
            width: "90%"
        }
    };
    __alloyId217.push(__alloyId219);
    var __alloyId216 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "loadingMoreTemplate"
        },
        childTemplates: __alloyId217
    };
    __alloyId68["loadingMoreTemplate"] = __alloyId216;
    var __alloyId225 = [];
    var __alloyId227 = {
        type: "Ti.UI.View",
        bindId: "empty",
        properties: {
            bindId: "empty"
        }
    };
    __alloyId225.push(__alloyId227);
    var __alloyId224 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bottomTemplate"
        },
        childTemplates: __alloyId225
    };
    __alloyId68["bottomTemplate"] = __alloyId224;
    $.__views.__alloyId230 = Ti.UI.createView({
        height: "50dp",
        id: "__alloyId230"
    });
    $.__views.messages1 = Ti.UI.createListSection({
        footerView: $.__views.__alloyId230,
        id: "messages1"
    });
    var __alloyId231 = [];
    __alloyId231.push($.__views.messages1);
    $.__views.bottom1 = Ti.UI.createListSection({
        id: "bottom1"
    });
    __alloyId231.push($.__views.bottom1);
    $.__views.listview1 = Ti.UI.createListView({
        backgroundColor: "#fff",
        separatorColor: "transparent",
        showVerticalScrollIndicator: false,
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        sections: __alloyId231,
        templates: __alloyId68,
        id: "listview1",
        defaultItemTemplate: "messageTemplate"
    });
    $.__views.layout.add($.__views.listview1);
    var __alloyId233 = {};
    var __alloyId236 = [];
    var __alloyId238 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId239 = [];
            var __alloyId241 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId242 = [];
                    var __alloyId244 = {
                        type: "Ti.UI.View",
                        bindId: "avatarStyle",
                        childTemplates: function() {
                            var __alloyId245 = [];
                            var __alloyId246 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: "#5b85df",
                                    top: "5dp",
                                    left: "-2dp",
                                    font: {
                                        fontSize: "14dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "g",
                                    width: "16dp",
                                    height: "16dp"
                                }
                            };
                            __alloyId245.push(__alloyId246);
                            var __alloyId248 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/none.png",
                                    height: "40dp",
                                    width: "40dp",
                                    right: 0,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId245.push(__alloyId248);
                            return __alloyId245;
                        }(),
                        properties: {
                            top: 0,
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            bindId: "avatarStyle"
                        }
                    };
                    __alloyId242.push(__alloyId244);
                    var __alloyId250 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId251 = [];
                            var __alloyId253 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId254 = [];
                                    var __alloyId256 = {
                                        type: "Ti.UI.Label",
                                        bindId: "messageIcon",
                                        properties: {
                                            color: "#fff",
                                            width: "0",
                                            height: "0",
                                            font: {
                                                fontSize: "16dp",
                                                fontFamily: "splinico"
                                            },
                                            text: "x",
                                            top: "14dp",
                                            left: "5dp",
                                            bindId: "messageIcon"
                                        }
                                    };
                                    __alloyId254.push(__alloyId256);
                                    var __alloyId258 = {
                                        type: "Ti.UI.TextArea",
                                        bindId: "message",
                                        properties: {
                                            paddingLeft: "10dp",
                                            autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
                                            borderRadius: Alloy.Globals.Style.Unit.unit4,
                                            color: "#fff",
                                            backgroundColor: "transparent",
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            top: "5dp",
                                            left: "5dp",
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            autocorrect: false,
                                            autoLink: Ti.UI.AUTOLINK_NONE,
                                            editable: false,
                                            handleLinks: false,
                                            scrollable: false,
                                            touchEnabled: true,
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId254.push(__alloyId258);
                                    return __alloyId254;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: 0,
                                    backgroundColor: "#5b85df"
                                }
                            };
                            __alloyId251.push(__alloyId253);
                            var __alloyId260 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: null,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    right: 0,
                                    bindId: "date"
                                }
                            };
                            __alloyId251.push(__alloyId260);
                            return __alloyId251;
                        }(),
                        properties: {
                            top: 0,
                            right: "55dp",
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical"
                        }
                    };
                    __alloyId242.push(__alloyId250);
                    return __alloyId242;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId239.push(__alloyId241);
            return __alloyId239;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: 0,
            backgroundColor: "transparent"
        }
    };
    __alloyId236.push(__alloyId238);
    var __alloyId235 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "messageTemplate"
        },
        events: {
            longpress: handleLongPress
        },
        childTemplates: __alloyId236
    };
    __alloyId233["messageTemplate"] = __alloyId235;
    var __alloyId263 = [];
    var __alloyId265 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId266 = [];
            var __alloyId268 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId269 = [];
                    var __alloyId271 = {
                        type: "Ti.UI.View",
                        bindId: "avatarStyle",
                        childTemplates: function() {
                            var __alloyId272 = [];
                            var __alloyId274 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/none.png",
                                    height: "40dp",
                                    width: "40dp",
                                    right: null,
                                    left: 0,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId272.push(__alloyId274);
                            var __alloyId275 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: "#303037",
                                    top: "5dp",
                                    left: null,
                                    font: {
                                        fontSize: "18dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "v",
                                    width: "16dp",
                                    height: "16dp",
                                    right: "-3dp"
                                }
                            };
                            __alloyId272.push(__alloyId275);
                            return __alloyId272;
                        }(),
                        properties: {
                            top: 0,
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0,
                            bindId: "avatarStyle"
                        }
                    };
                    __alloyId269.push(__alloyId271);
                    var __alloyId277 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId278 = [];
                            var __alloyId280 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId281 = [];
                                    var __alloyId283 = {
                                        type: "Ti.UI.Label",
                                        bindId: "messageIcon",
                                        properties: {
                                            color: "#fff",
                                            width: "0",
                                            height: "0",
                                            font: {
                                                fontSize: "16dp",
                                                fontFamily: "splinico"
                                            },
                                            text: "x",
                                            top: "14dp",
                                            left: "5dp",
                                            bindId: "messageIcon"
                                        }
                                    };
                                    __alloyId281.push(__alloyId283);
                                    var __alloyId285 = {
                                        type: "Ti.UI.TextArea",
                                        bindId: "message",
                                        properties: {
                                            paddingLeft: "10dp",
                                            autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
                                            borderRadius: Alloy.Globals.Style.Unit.unit4,
                                            color: "#fff",
                                            backgroundColor: "transparent",
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            top: "5dp",
                                            left: "5dp",
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            autocorrect: false,
                                            autoLink: Ti.UI.AUTOLINK_NONE,
                                            editable: false,
                                            handleLinks: false,
                                            scrollable: false,
                                            touchEnabled: true,
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId281.push(__alloyId285);
                                    return __alloyId281;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "#303037",
                                    left: 0
                                }
                            };
                            __alloyId278.push(__alloyId280);
                            var __alloyId287 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId278.push(__alloyId287);
                            return __alloyId278;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId269.push(__alloyId277);
                    return __alloyId269;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId266.push(__alloyId268);
            return __alloyId266;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: 0,
            backgroundColor: "transparent"
        }
    };
    __alloyId263.push(__alloyId265);
    var __alloyId262 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "leftMessageTemplate"
        },
        events: {
            longpress: handleLongPress
        },
        childTemplates: __alloyId263
    };
    __alloyId233["leftMessageTemplate"] = __alloyId262;
    var __alloyId290 = [];
    var __alloyId292 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId293 = [];
            var __alloyId295 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    top: "1px"
                }
            };
            __alloyId293.push(__alloyId295);
            var __alloyId297 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId298 = [];
                    var __alloyId300 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId301 = [];
                            var __alloyId303 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/none.png",
                                    height: "40dp",
                                    width: "40dp",
                                    right: null,
                                    left: 0,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId301.push(__alloyId303);
                            return __alloyId301;
                        }(),
                        properties: {
                            top: "4dp",
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0
                        }
                    };
                    __alloyId298.push(__alloyId300);
                    var __alloyId305 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId306 = [];
                            var __alloyId308 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId309 = [];
                                    var __alloyId311 = {
                                        type: "Ti.UI.Label",
                                        bindId: "message",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            top: 0,
                                            left: 0,
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            backgroundColor: "transparent",
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId309.push(__alloyId311);
                                    return __alloyId309;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "transparent",
                                    left: "3dp"
                                }
                            };
                            __alloyId306.push(__alloyId308);
                            var __alloyId313 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId306.push(__alloyId313);
                            return __alloyId306;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId298.push(__alloyId305);
                    return __alloyId298;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId293.push(__alloyId297);
            var __alloyId315 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    bottom: "1px"
                }
            };
            __alloyId293.push(__alloyId315);
            return __alloyId293;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: "5dp",
            backgroundColor: "transparent",
            bottom: "5dp"
        }
    };
    __alloyId290.push(__alloyId292);
    var __alloyId289 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bookingMessageTemplate"
        },
        childTemplates: __alloyId290
    };
    __alloyId233["bookingMessageTemplate"] = __alloyId289;
    var __alloyId318 = [];
    var __alloyId320 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId321 = [];
            var __alloyId323 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    top: "1px"
                }
            };
            __alloyId321.push(__alloyId323);
            var __alloyId325 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId326 = [];
                    var __alloyId328 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId329 = [];
                            var __alloyId331 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: Alloy.Globals.Style.Color.DarkGray,
                                    font: {
                                        fontSize: "18dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "c",
                                    width: "42dp",
                                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                                    left: 0
                                }
                            };
                            __alloyId329.push(__alloyId331);
                            return __alloyId329;
                        }(),
                        properties: {
                            top: "4dp",
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0
                        }
                    };
                    __alloyId326.push(__alloyId328);
                    var __alloyId333 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId334 = [];
                            var __alloyId336 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId337 = [];
                                    var __alloyId339 = {
                                        type: "Ti.UI.Label",
                                        bindId: "message",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            top: 0,
                                            left: 0,
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            backgroundColor: "transparent",
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId337.push(__alloyId339);
                                    return __alloyId337;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "transparent",
                                    left: "3dp"
                                }
                            };
                            __alloyId334.push(__alloyId336);
                            var __alloyId341 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId334.push(__alloyId341);
                            return __alloyId334;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId326.push(__alloyId333);
                    return __alloyId326;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId321.push(__alloyId325);
            var __alloyId343 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    bottom: "1px"
                }
            };
            __alloyId321.push(__alloyId343);
            return __alloyId321;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: "5dp",
            backgroundColor: "transparent",
            bottom: "5dp"
        }
    };
    __alloyId318.push(__alloyId320);
    var __alloyId317 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bookingAcceptedMessageTemplate"
        },
        childTemplates: __alloyId318
    };
    __alloyId233["bookingAcceptedMessageTemplate"] = __alloyId317;
    var __alloyId346 = [];
    var __alloyId348 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId349 = [];
            var __alloyId351 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    top: "1px"
                }
            };
            __alloyId349.push(__alloyId351);
            var __alloyId353 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId354 = [];
                    var __alloyId356 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId357 = [];
                            var __alloyId359 = {
                                type: "Ti.UI.Label",
                                properties: {
                                    color: Alloy.Globals.Style.Color.DarkGray,
                                    font: {
                                        fontSize: "18dp",
                                        fontFamily: "splinico"
                                    },
                                    text: "h",
                                    width: "42dp",
                                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                                    left: 0
                                }
                            };
                            __alloyId357.push(__alloyId359);
                            return __alloyId357;
                        }(),
                        properties: {
                            top: "4dp",
                            right: 0,
                            height: "40dp",
                            width: "55dp",
                            left: 0
                        }
                    };
                    __alloyId354.push(__alloyId356);
                    var __alloyId361 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId362 = [];
                            var __alloyId364 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId365 = [];
                                    var __alloyId367 = {
                                        type: "Ti.UI.Label",
                                        bindId: "message",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            top: 0,
                                            left: 0,
                                            right: "5dp",
                                            bottom: "5dp",
                                            width: Ti.UI.SIZE,
                                            height: Ti.UI.SIZE,
                                            font: {
                                                fontSize: "14dp"
                                            },
                                            backgroundColor: "transparent",
                                            bindId: "message"
                                        }
                                    };
                                    __alloyId365.push(__alloyId367);
                                    return __alloyId365;
                                }(),
                                properties: {
                                    height: Ti.UI.SIZE,
                                    width: Ti.UI.SIZE,
                                    top: 0,
                                    right: null,
                                    backgroundColor: "transparent",
                                    left: "3dp"
                                }
                            };
                            __alloyId362.push(__alloyId364);
                            var __alloyId369 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#a4a4a4",
                                    bottom: "5dp",
                                    left: 0,
                                    height: "14dp",
                                    font: {
                                        fontSize: "10dp"
                                    },
                                    bindId: "date"
                                }
                            };
                            __alloyId362.push(__alloyId369);
                            return __alloyId362;
                        }(),
                        properties: {
                            top: 0,
                            right: null,
                            height: Ti.UI.SIZE,
                            width: Ti.UI.SIZE,
                            layout: "vertical",
                            left: "55dp"
                        }
                    };
                    __alloyId354.push(__alloyId361);
                    return __alloyId354;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    top: "5dp",
                    bottom: "5dp",
                    left: "5dp",
                    right: "5dp"
                }
            };
            __alloyId349.push(__alloyId353);
            var __alloyId371 = {
                type: "Ti.UI.View",
                properties: {
                    width: "100%",
                    height: "1px",
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    bottom: "1px"
                }
            };
            __alloyId349.push(__alloyId371);
            return __alloyId349;
        }(),
        properties: {
            height: Ti.UI.SIZE,
            left: 0,
            top: "5dp",
            backgroundColor: "transparent",
            bottom: "5dp"
        }
    };
    __alloyId346.push(__alloyId348);
    var __alloyId345 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bookingCancelledMessageTemplate"
        },
        childTemplates: __alloyId346
    };
    __alloyId233["bookingCancelledMessageTemplate"] = __alloyId345;
    var __alloyId374 = [];
    var __alloyId376 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId377 = [];
            var __alloyId379 = {
                type: "Ti.UI.Label",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    text: L("widget_messenger_load_earlier_messages"),
                    top: "5dp",
                    bottom: "5dp",
                    font: {
                        fontSize: "14dp"
                    }
                }
            };
            __alloyId377.push(__alloyId379);
            return __alloyId377;
        }(),
        properties: {
            color: Alloy.Globals.Style.Color.DarkGray,
            borderRadius: Alloy.Globals.Style.Unit.unit3,
            height: "60dp",
            font: {
                fontSize: "18dp"
            },
            normalColor: "#00333333",
            selectedColor: "#70333333",
            backgroundImage: "none",
            borderColor: Alloy.Globals.Style.Color.DarkGray,
            borderWidth: 2,
            indicator: "true",
            touchEnabled: "false",
            top: "5dp",
            bottom: "10dp",
            width: "90%"
        }
    };
    __alloyId374.push(__alloyId376);
    var __alloyId373 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "loadMoreTemplate"
        },
        childTemplates: __alloyId374
    };
    __alloyId233["loadMoreTemplate"] = __alloyId373;
    var __alloyId382 = [];
    var __alloyId384 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId385 = [];
            var __alloyId387 = {
                type: "Ti.UI.Label",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    text: L("widget_messenger_load_earlier_messages"),
                    top: "5dp",
                    bottom: "5dp",
                    font: {
                        fontSize: "14dp"
                    }
                }
            };
            __alloyId385.push(__alloyId387);
            return __alloyId385;
        }(),
        properties: {
            color: Alloy.Globals.Style.Color.DarkGray,
            borderRadius: Alloy.Globals.Style.Unit.unit3,
            height: "60dp",
            font: {
                fontSize: "18dp"
            },
            normalColor: "#00333333",
            selectedColor: "#70333333",
            backgroundImage: "none",
            borderColor: Alloy.Globals.Style.Color.DarkGray,
            borderWidth: 2,
            opacity: .3,
            indicator: "true",
            touchEnabled: "false",
            top: "5dp",
            bottom: "10dp",
            width: "90%"
        }
    };
    __alloyId382.push(__alloyId384);
    var __alloyId381 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "loadingMoreTemplate"
        },
        childTemplates: __alloyId382
    };
    __alloyId233["loadingMoreTemplate"] = __alloyId381;
    var __alloyId390 = [];
    var __alloyId392 = {
        type: "Ti.UI.View",
        bindId: "empty",
        properties: {
            bindId: "empty"
        }
    };
    __alloyId390.push(__alloyId392);
    var __alloyId389 = {
        properties: {
            height: Ti.UI.SIZE,
            backgroundColor: "transparent",
            backgroundSelectedColor: "transparent",
            name: "bottomTemplate"
        },
        childTemplates: __alloyId390
    };
    __alloyId233["bottomTemplate"] = __alloyId389;
    $.__views.__alloyId395 = Ti.UI.createView({
        height: "50dp",
        id: "__alloyId395"
    });
    $.__views.messages2 = Ti.UI.createListSection({
        footerView: $.__views.__alloyId395,
        id: "messages2"
    });
    var __alloyId396 = [];
    __alloyId396.push($.__views.messages2);
    $.__views.bottom2 = Ti.UI.createListSection({
        id: "bottom2"
    });
    __alloyId396.push($.__views.bottom2);
    $.__views.listview2 = Ti.UI.createListView({
        backgroundColor: "#fff",
        separatorColor: "transparent",
        showVerticalScrollIndicator: false,
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        visible: false,
        sections: __alloyId396,
        templates: __alloyId233,
        id: "listview2",
        defaultItemTemplate: "messageTemplate"
    });
    $.__views.layout.add($.__views.listview2);
    $.__views.compose = Ti.UI.createView({
        zIndex: 3,
        bottom: 0,
        height: Ti.UI.SIZE,
        width: "100%",
        backgroundColor: "#a4a4a4",
        layout: "vertical",
        id: "compose"
    });
    $.__views.layout.add($.__views.compose);
    $.__views.__alloyId398 = Ti.UI.createView({
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId398"
    });
    $.__views.compose.add($.__views.__alloyId398);
    $.__views.__alloyId399 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId399"
    });
    $.__views.compose.add($.__views.__alloyId399);
    $.__views.composeWrapper = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        left: "13dp",
        right: "13dp",
        top: "5dp",
        bottom: "5dp",
        id: "composeWrapper"
    });
    $.__views.compose.add($.__views.composeWrapper);
    $.__views.__alloyId400 = Ti.UI.createView({
        width: "83.33333333333334%",
        height: Ti.UI.SIZE,
        id: "__alloyId400"
    });
    $.__views.composeWrapper.add($.__views.__alloyId400);
    $.__views.messageField = Ti.UI.createTextArea({
        paddingLeft: "10dp",
        autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_SENTENCES,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "15dp"
        },
        autocorrect: true,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        right: "13dp",
        softKeyboardOnFocus: Titanium.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS,
        id: "messageField"
    });
    $.__views.__alloyId400.add($.__views.messageField);
    $.__views.buttonSend = require("/ui/common/custom_button").createButton({
        width: "16.666666666666664%",
        font: {
            fontSize: "12dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("btn_send"),
        height: "35dp",
        indicator: "true",
        id: "buttonSend"
    });
    $.__views.composeWrapper.add($.__views.buttonSend);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Q = require("vendor/q"), BaseController = require("/carmalib/controller"), appSound = require("/utils/appSound"), ListItemFactory = require("widget/messenger/ListItemFactory"), navigation = Alloy.Globals.Nav.Messages, rootWindow = TABS_HELPER.rootWindow(), Globals = require("/v6/infrastructure/Globals"), MessageService = Globals.IOC.get("messageService"), ProfileService = Globals.IOC.get("ProfileService");
    var Internal = {};
    var LOADING_PROGRESS = 0, LOADING_RESULT = 1, LOADING_MANUAL = 2;
    Internal.NO_ANIMATION = {
        animated: false
    };
    Internal.NO_ANIMATION_NO_MOVE = {
        animated: false
    };
    Internal.convertUserListToObject = function(users) {
        users = users || [];
        var result = {};
        _.each(users, function(user) {
            result[user.userId] = user;
        });
        return result;
    };
    var ChatController = BaseController.extend($, {
        _messageFactory: null,
        _refreshTimeInterval: null,
        _recipient: null,
        _threadId: null,
        _isGroupChat: false,
        _dispayedMessages: {},
        _isSyncing: false,
        events: {
            "click[android] buttonSend": "onSendMessage",
            "click[ios] buttonSend": "onSendMessage",
            "itemclick listview1": "onListItemClicked",
            "itemclick listview2": "onListItemClicked",
            "focus messageField": "onEditorFocus",
            "blur messageField": "onEditorBlur"
        },
        initialize: function() {
            _.bindAll(this, "onCheckUnread", "initMarkThreadAsRead", "onListItemClicked", "onEditorFocus", "onEditorBlur", "onBeforeHide");
            $.currentListview = $.listview1;
            $.currentMessages = $.messages1;
            $.currentBottom = $.bottom1;
            $.invisibleListview = $.listview2;
            $.invisibleMessages = $.messages2;
            $.invisibleBottom = $.bottom2;
            this._messageFactory = new ListItemFactory();
            this.initEditor(args.message);
        },
        ensureViewVisible: function() {
            $.currentListview.setVisible(true);
            TM.push(function() {
                $.invisibleListview.setVisible(false);
            });
        },
        flipFlop: function() {
            if ($.currentListview === $.listview1) {
                $.currentListview = $.listview2;
                $.currentMessages = $.messages2;
                $.currentBottom = $.bottom2;
                $.invisibleListview = $.listview1;
                $.invisibleMessages = $.messages1;
                $.invisibleBottom = $.bottom1;
            } else {
                $.currentListview = $.listview1;
                $.currentMessages = $.messages1;
                $.currentBottom = $.bottom1;
                $.invisibleListview = $.listview2;
                $.invisibleMessages = $.messages2;
                $.invisibleBottom = $.bottom2;
            }
            this.ensureViewVisible();
        },
        loadChat: function(params) {
            params = params || {};
            this._dispayedMessages = {};
            $.currentListview.sections[0].setItems([], {
                animated: false
            });
            params.title && navigation.setTitle(params.title.toUpperCase());
            this._threadId = params.threadId;
            Alloy.Globals.currentMessageThreadId = this._threadId;
            this.initThread();
            params.title || this.updateTitle();
            this.setBottomPadding();
            $.currentMessages.items && $.currentMessages.items.count && $.currentMessages.deleteItemsAt(0, $.currentMessages.items.count, Internal.NO_ANIMATION);
            $.invisibleMessages.items && $.invisibleMessages.items.count && $.invisibleMessages.deleteItemsAt(0, $.invisibleMessages.items.count, Internal.NO_ANIMATION);
            rootWindow.addAppEventListener("carma:messages.count.change", this.onCheckUnread);
            var self = this;
            var deferred = this.loadChatMessages(true);
            deferred.then(function() {
                self.startRefresh();
            }).finally(self.initMarkThreadAsRead).done();
            return deferred;
        },
        initMarkThreadAsRead: function() {
            var self = this;
            return MessageService.markThreadRead({
                threadId: self._threadId
            }).catch(function(e) {
                LOGGER.error("[Chat] " + JSON.stringify(e));
            });
        },
        initThread: function() {
            if (-1 === this._threadId.indexOf("_")) {
                this._isGroupChat = true;
                return;
            }
            this._isGroupChat = false;
            var ids = this._threadId.split("_");
            var myUserId = require("services/resource_owner_service").singleton().get("userId");
            this._recipient = ids[0].toString() === myUserId.toString() ? ids[1] : ids[0];
        },
        initEditor: function(defaultMessage) {
            $.messageField.applyProperties({
                autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_SENTENCES,
                autocorrect: true
            });
            $.messageField.value = defaultMessage || "";
        },
        initEventListeners: function() {},
        onTouchStart: function(labelMessage) {},
        onBeforeHide: function() {
            Ti.App.fireEvent("carma:chat.close", {
                threadId: this._threadId
            });
            $.buttonSend.stopIndicator();
            this._threadId = null;
            rootWindow.removeAppEventListener("carma:messages.count.change", this.onCheckUnread);
            rootWindow.addEventListener("nav.backcomplete", function onHidden() {
                rootWindow.removeEventListener("nav.backcomplete", onHidden);
                $.currentMessages.setItems([], Internal.NO_ANIMATION);
                $.currentListview.setVisible(false);
            });
            Alloy.Globals.currentMessageThreadId = null;
            this.stopRefresh();
            this.resetEditor();
        },
        onDestroy: function() {},
        onEditorFocus: function() {
            var self = this;
            setTimeout(function() {
                self.scrollToBottom();
            }, 500);
        },
        onEditorBlur: function() {
            var self = this;
            setTimeout(function() {
                self.scrollToBottom();
            }, 500);
        },
        onMessagesResponse: function(response, loadFromTop, loadingState) {
            var prevMessages = $.currentMessages.getItems();
            if (!response) {
                prevMessages.length && prevMessages[0].isLoadingMore && loadingState === LOADING_RESULT && $.currentMessages.replaceItemsAt(0, 1, [ self._messageFactory.createLoadButton() ], Internal.NO_ANIMATION_NO_MOVE);
                return;
            }
            var ResourceOwner = require("services/resource_owner_service").singleton(), hasNextPage = MessageService.chatHasNextPage();
            var data = {};
            data.associatedUsers = response.associatedUsers || [];
            data.messages = response.messages || {};
            data.messages.notifications = response.messages ? response.messages.notifications : [ response ];
            data.associatedUsers.push({
                userId: ResourceOwner.get("userId"),
                photoUrl: ResourceOwner.get("photoUrl")
            });
            var self = this, users = Internal.convertUserListToObject(data.associatedUsers), messages = [], notifications = data.messages.notifications;
            _.each(notifications, function(message, index) {
                if (self._dispayedMessages["msg_" + message.id]) return;
                self._dispayedMessages["msg_" + message.id] = true;
                var previous = null;
                index ? previous = notifications[index - 1] : prevMessages.length && (previous = prevMessages[prevMessages.length - 1]);
                message.user = users[message.sendingUser];
                var item = self._messageFactory.create(message, {
                    isGroupChat: this._isGroupChat,
                    previous: previous
                });
                messages.push(item);
                item.isAvatarLoaded || TM.push(function() {
                    self.loadMessageAvatar(item);
                });
            });
            var needLoadMoreButton = messages.length >= MessageService.getPageSize() && (0 === prevMessages.length || !prevMessages[0].isLoadMore && !prevMessages[0].isLoadingMore);
            if ((needLoadMoreButton || loadFromTop && messages.length) && prevMessages.length) {
                var data = [];
                var insertLocation = 0;
                if (needLoadMoreButton) {
                    data.push(loadingState === LOADING_PROGRESS ? self._messageFactory.createLoadingButton() : self._messageFactory.createLoadButton());
                    insertLocation = 1;
                }
                if (loadFromTop) {
                    data = data.concat(messages);
                    data = data.concat($.currentMessages.items.slice(1));
                } else {
                    data = data.concat($.currentMessages.items);
                    data = data.concat(messages);
                }
                $.invisibleMessages.items && $.invisibleMessages.items.count && $.invisibleMessages.deleteItemsAt(0, $.invisibleMessages.items.count, Internal.NO_ANIMATION);
                $.invisibleMessages.setItems(data, Internal.NO_ANIMATION);
                if (loadFromTop) {
                    var newTopIndex = insertLocation + messages.length - 1;
                    newTopIndex >= 0 && $.invisibleListview.scrollToItem(0, newTopIndex, Internal.NO_ANIMATION);
                } else $.invisibleListview.scrollToItem(1, 0, Internal.NO_ANIMATION);
                TM.push(function() {
                    self.flipFlop();
                });
            } else if (messages.length > 0) {
                needLoadMoreButton ? messages.unshift(loadingState === LOADING_PROGRESS ? self._messageFactory.createLoadingButton() : self._messageFactory.createLoadButton()) : prevMessages.length && prevMessages[0].isLoadingMore && loadingState === LOADING_RESULT && $.currentMessages.replaceItemsAt(0, 1, [ self._messageFactory.createLoadButton() ], Internal.NO_ANIMATION_NO_MOVE);
                $.currentMessages.appendItems(messages, Internal.NO_ANIMATION);
                this.scrollToBottom();
                self.ensureViewVisible();
            } else prevMessages.length && prevMessages[0].isLoadingMore && loadingState === LOADING_RESULT && $.currentMessages.replaceItemsAt(0, 1, [ self._messageFactory.createLoadButton() ], Internal.NO_ANIMATION_NO_MOVE);
        },
        onSendMessage: function() {
            var self = this, message = $.messageField.value || "";
            message = message.trim();
            if (!message || message.length < 1) return;
            this.resetEditor();
            var send = this._isGroupChat ? MessageService.sendGroup : MessageService.send;
            var from = this._isGroupChat ? this._threadId : this._recipient;
            send.apply(MessageService, [ from, message ]).then(function(data) {
                data.id = data.response;
                self.onMessagesResponse(data, false, LOADING_MANUAL);
                appSound.play("swish");
            }).catch(function(e) {
                Ti.UI.createAlertDialog({
                    title: L("error_title").toUpperCase(),
                    message: "Failed to send. Try again later..."
                }).show();
                LOGGER.error("[Chat] " + JSON.stringify(e));
            }).finally(function() {
                TM.push(function() {
                    $.buttonSend.stopIndicator();
                });
            }).done();
        },
        onListItemClicked: function(e) {
            var item = e.section.getItemAt(e.itemIndex);
            if ("avatar" === e.bindId) {
                Ti.App.fireEvent("carma:profile.open", {
                    userId: item.sendingUser
                });
                return;
            }
            if (("message" === e.bindId || "messageIcon" === e.bindId) && item.link && item.link.href) {
                this.openURL(item.link.href);
                return;
            }
            $.messageField.blur();
            if (item.isLoadMore) {
                var indicator = this._messageFactory.createLoadingButton();
                $.currentMessages.replaceItemsAt(0, 1, [ indicator ], Internal.NO_ANIMATION);
                this.loadNextChatMessages().done();
            }
        },
        openURL: function(link) {
            if (!link) return false;
            var deepLinker = require("/bootstrap/deepLinker");
            deepLinker.canHandleUrl(link) ? deepLinker.handleUrl(link) : Ti.Platform.openURL(link);
        },
        onOpenLink: function(e) {
            var item = e.section.getItemAt(e.itemIndex);
            var dialog = Ti.UI.createOptionDialog({
                options: [ L("widget_msg_copy_message"), L("widget_msg_open_url"), L("btn_cancel") ],
                cancel: 2
            });
            var self = this;
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                switch (e.index) {
                  case 0:
                    Ti.UI.Clipboard.setText(item.message.value || item.message.text);
                    break;

                  case 1:
                    self.openURL(item.link.href);
                }
            });
            dialog.show();
        },
        onCheckUnread: function(options) {
            var self = this, threadId = this._threadId, numberOfNewMessages = null;
            if (this._isSyncing) return;
            this._isSyncing = true;
            MessageService.countThreadUnread({
                threadId: self._threadId
            }).then(function(data) {
                self.validateThread(threadId);
                numberOfNewMessages = Number(data.response);
            }).then(function() {
                if (numberOfNewMessages > 0) {
                    self.initMarkThreadAsRead();
                    options && "notification" != options.source && appSound.play("snuffle");
                    return self.loadChatMessages(false);
                }
            }).catch(function(e) {
                LOGGER.error("[Chat] " + JSON.stringify(e));
            }).finally(function() {
                self._isSyncing = false;
            }).done();
        },
        validateThread: function(threadId) {
            if (this._threadId != threadId) throw new Error("Thread has been closed");
        },
        loadMessageAvatar: function(message) {
            if (!message) return;
            var updateMessagesFromUser = function(userId) {
                if (!userId) return;
                var messages = $.currentMessages.getItems();
                _.each(messages, function(message, index) {
                    if (message.sendingUser == userId) {
                        var before = message.avatar.image;
                        message.loadAvatar(true);
                        before != message.avatar.image && $.currentMessages.updateItemAt(index, message, Internal.NO_ANIMATION);
                    }
                });
            };
            return message.loadAvatar().then(function(message) {
                message = message || {};
                return updateMessagesFromUser(message.sendingUser);
            });
        },
        loadChatMessages: function(firstLoad) {
            var self = this, threadId = this._threadId;
            var deferred = Q.defer();
            Q().then(function() {
                self.validateThread(threadId);
                return MessageService.getChatMessages({
                    threadId: self._threadId,
                    always_call_progress: true
                });
            }).progress(function(data) {
                self.validateThread(threadId);
                if (firstLoad) try {
                    data ? self.onMessagesResponse(data, false, LOADING_PROGRESS) : firstLoad && self.setLoading();
                } finally {
                    deferred.notify();
                }
            }).then(function(data) {
                self.validateThread(threadId);
                self.onMessagesResponse(data, false, LOADING_RESULT);
            }).catch(function(e) {
                LOGGER.error("[Chat] " + JSON.stringify(e));
            }).finally(function() {
                try {
                    self.validateThread(threadId);
                    self.unsetLoading();
                } catch (e) {
                    LOGGER.error("[Chat] " + JSON.stringify(e));
                } finally {
                    deferred.resolve();
                }
            });
            return deferred.promise;
        },
        loadNextChatMessages: function() {
            var self = this, threadId = this._threadId;
            return Q().then(function() {
                self.validateThread(threadId);
                return MessageService.getNextChatMessagesPage();
            }).then(function(data) {
                self.validateThread(threadId);
                return self.onMessagesResponse(data, true, LOADING_RESULT);
            }).catch(function(e) {
                LOGGER.error("[Chat] " + JSON.stringify(e));
            }).finally(function() {
                self.validateThread(threadId);
            });
        },
        updateTitle: function() {
            navigation.setTitle("");
            var id = parseInt(this._recipient);
            var cached = ProfileService.getCachedProfile(id);
            null == cached ? ProfileService.getProfile(id, ProfileService.BASIC_DETAIL).then(function(user) {
                user = user || {};
                navigation.setTitle(user.alias);
            }).done() : navigation.setTitle(cached.alias);
        },
        setBottomPadding: function(padding) {
            padding = padding || "10dp";
            $.currentBottom.setItems([ {
                template: "bottomTemplate",
                empty: {
                    height: padding
                }
            } ], Internal.NO_ANIMATION);
            $.invisibleBottom.setItems([ {
                template: "bottomTemplate",
                empty: {
                    height: padding
                }
            } ], Internal.NO_ANIMATION);
        },
        resetEditor: function() {
            $.messageField.blur();
            $.messageField.value = "";
        },
        scrollToBottom: function() {
            $.currentListview.scrollToItem(1, 0, Internal.NO_ANIMATION);
            TM.push(function() {
                $.currentListview.scrollToItem(1, 0, Internal.NO_ANIMATION);
            });
        },
        scrollToPos: function(pos) {
            $.currentListview.scrollToItem(0, pos, Internal.NO_ANIMATION);
            TM.push(function() {
                $.currentListview.scrollToItem(0, pos, Internal.NO_ANIMATION);
            });
        },
        setLoading: function() {
            $.currentListview.setVisible(false);
            $.indicator.show();
        },
        unsetLoading: function(timeout) {
            $.indicator.hide();
            $.currentListview.setVisible(true);
        },
        startRefresh: function() {
            if (!this._threadId) return;
            this._refreshTimeInterval || (this._refreshTimeInterval = setInterval(this.onCheckUnread, 1e4));
        },
        stopRefresh: function() {
            if (this._refreshTimeInterval) {
                clearInterval(this._refreshTimeInterval);
                this._refreshTimeInterval = null;
            }
        },
        copyMessageToClipboard: function(data) {
            var itemIndex = data.itemIndex, item = $.currentListview.sections[0].getItemAt(itemIndex);
            var message = item.message.value;
            if ("USER_POKE" === item.messageType) {
                var resourceOwner = require("services/resource_owner_service").singleton();
                message = L(item.sendingUser === resourceOwner.get("userId") ? "widget_messenger_you_poked" : "widget_messenger_poked_you");
            }
            if (!message || "" === message) return;
            var dialog = Ti.UI.createOptionDialog({
                options: [ L("widget_msg_copy_message") ],
                cancel: 1
            });
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                switch (e.index) {
                  case 0:
                    Ti.UI.Clipboard.setText(message);
                }
            });
            dialog.show();
        }
    });
    exports = new ChatController();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;