function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.messenger/" + s : s.substring(0, index) + "/ma.car.app.messenger/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.messenger");
    this.__widgetId = "ma.car.app.messenger";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "listView";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    var __alloyId403 = {};
    var __alloyId406 = [];
    var __alloyId408 = {
        type: "Ti.UI.View",
        bindId: "bckgHolder",
        childTemplates: function() {
            var __alloyId409 = [];
            var __alloyId411 = {
                type: "Ti.UI.ImageView",
                bindId: "avatar",
                properties: {
                    defaultImage: "/images/default_photo_male-rounded.png",
                    backgroundColor: "#fff",
                    borderColor: "#fff",
                    borderWidth: 1,
                    left: 0,
                    width: "48dp",
                    height: "48dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit24,
                    bindId: "avatar"
                }
            };
            __alloyId409.push(__alloyId411);
            var __alloyId413 = {
                type: "Ti.UI.Label",
                bindId: "name",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    left: "59dp",
                    right: "100dp",
                    height: "20dp",
                    wordWrap: false,
                    ellipsize: true,
                    top: "4dp",
                    bindId: "name"
                }
            };
            __alloyId409.push(__alloyId413);
            var __alloyId415 = {
                type: "Ti.UI.Label",
                bindId: "date",
                properties: {
                    color: "#999999",
                    font: {
                        fontSize: "15dp"
                    },
                    top: "4dp",
                    right: 0,
                    bindId: "date"
                }
            };
            __alloyId409.push(__alloyId415);
            var __alloyId417 = {
                type: "Ti.UI.Label",
                bindId: "message",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "21dp",
                    right: "20dp",
                    left: "59dp",
                    bindId: "message"
                }
            };
            __alloyId409.push(__alloyId417);
            var __alloyId419 = {
                type: "Ti.UI.Label",
                bindId: "unread",
                properties: {
                    color: "#fff",
                    backgroundColor: "#189BCC",
                    borderRadius: 4,
                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                    bottom: "5dp",
                    right: 0,
                    font: {
                        fontSize: "10dp"
                    },
                    width: "13dp",
                    height: "13dp",
                    borderWidth: 1,
                    bindId: "unread"
                }
            };
            __alloyId409.push(__alloyId419);
            var __alloyId421 = {
                type: "Ti.UI.View",
                properties: {
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    width: "100%",
                    height: "1px",
                    bottom: 0,
                    left: 0
                }
            };
            __alloyId409.push(__alloyId421);
            return __alloyId409;
        }(),
        properties: {
            width: Ti.UI.FILL,
            height: "100%",
            left: "13dp",
            right: "13dp",
            top: 0,
            backgroundColor: "transparent",
            bindId: "bckgHolder"
        }
    };
    __alloyId406.push(__alloyId408);
    var __alloyId405 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "messageTemplate"
        },
        childTemplates: __alloyId406
    };
    __alloyId403["messageTemplate"] = __alloyId405;
    var __alloyId424 = [];
    var __alloyId426 = {
        type: "Ti.UI.View",
        bindId: "bckgHolder",
        childTemplates: function() {
            var __alloyId427 = [];
            var __alloyId429 = {
                type: "Ti.UI.ImageView",
                bindId: "avatar",
                properties: {
                    defaultImage: "/images/default_photo_male-rounded.png",
                    backgroundColor: "#fff",
                    borderColor: "#fff",
                    borderWidth: 1,
                    left: 0,
                    width: "48dp",
                    height: "48dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit24,
                    bindId: "avatar"
                }
            };
            __alloyId427.push(__alloyId429);
            var __alloyId431 = {
                type: "Ti.UI.Label",
                bindId: "name",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    left: "59dp",
                    right: "100dp",
                    height: "20dp",
                    wordWrap: false,
                    ellipsize: true,
                    top: "4dp",
                    bindId: "name"
                }
            };
            __alloyId427.push(__alloyId431);
            var __alloyId433 = {
                type: "Ti.UI.Label",
                bindId: "date",
                properties: {
                    color: "#999999",
                    font: {
                        fontSize: "15dp"
                    },
                    top: "4dp",
                    right: 0,
                    bindId: "date"
                }
            };
            __alloyId427.push(__alloyId433);
            var __alloyId435 = {
                type: "Ti.UI.Label",
                bindId: "iconPoke",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "16dp",
                        fontFamily: "splinico"
                    },
                    text: "x",
                    top: "23dp",
                    left: "59dp",
                    bindId: "iconPoke"
                }
            };
            __alloyId427.push(__alloyId435);
            var __alloyId437 = {
                type: "Ti.UI.Label",
                bindId: "message",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "22dp",
                    left: "80dp",
                    bindId: "message"
                }
            };
            __alloyId427.push(__alloyId437);
            var __alloyId439 = {
                type: "Ti.UI.Label",
                bindId: "unread",
                properties: {
                    color: "#fff",
                    backgroundColor: "#189BCC",
                    borderRadius: 4,
                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                    bottom: "5dp",
                    right: 0,
                    font: {
                        fontSize: "10dp"
                    },
                    width: "13dp",
                    height: "13dp",
                    borderWidth: 1,
                    bindId: "unread"
                }
            };
            __alloyId427.push(__alloyId439);
            var __alloyId441 = {
                type: "Ti.UI.View",
                properties: {
                    backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                    width: "100%",
                    height: "1px",
                    bottom: 0,
                    left: 0
                }
            };
            __alloyId427.push(__alloyId441);
            return __alloyId427;
        }(),
        properties: {
            width: Ti.UI.FILL,
            height: "100%",
            left: "13dp",
            right: "13dp",
            top: 0,
            backgroundColor: "transparent",
            bindId: "bckgHolder"
        }
    };
    __alloyId424.push(__alloyId426);
    var __alloyId423 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "pokeTemplate"
        },
        childTemplates: __alloyId424
    };
    __alloyId403["pokeTemplate"] = __alloyId423;
    var __alloyId444 = [];
    var __alloyId446 = {
        type: "Ti.UI.View",
        bindId: "bckgHolder",
        childTemplates: function() {
            var __alloyId447 = [];
            var __alloyId449 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId450 = [];
                    var __alloyId452 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId453 = [];
                            var __alloyId455 = {
                                type: "Ti.UI.ImageView",
                                bindId: "avatar",
                                properties: {
                                    defaultImage: "/images/default_photo_male-rounded.png",
                                    backgroundColor: "#fff",
                                    borderColor: "#fff",
                                    borderWidth: 1,
                                    left: 0,
                                    width: "48dp",
                                    height: "48dp",
                                    borderRadius: Alloy.Globals.Style.Unit.unit24,
                                    bindId: "avatar"
                                }
                            };
                            __alloyId453.push(__alloyId455);
                            var __alloyId457 = {
                                type: "Ti.UI.Label",
                                bindId: "name",
                                properties: {
                                    color: Alloy.Globals.Style.Color.DarkGray,
                                    font: {
                                        fontSize: "15dp",
                                        fontWeight: "bold"
                                    },
                                    left: "59dp",
                                    right: "100dp",
                                    height: "20dp",
                                    wordWrap: false,
                                    ellipsize: true,
                                    top: "4dp",
                                    bindId: "name"
                                }
                            };
                            __alloyId453.push(__alloyId457);
                            var __alloyId459 = {
                                type: "Ti.UI.Label",
                                bindId: "date",
                                properties: {
                                    color: "#999999",
                                    font: {
                                        fontSize: "15dp"
                                    },
                                    top: "4dp",
                                    right: 0,
                                    bindId: "date"
                                }
                            };
                            __alloyId453.push(__alloyId459);
                            var __alloyId461 = {
                                type: "Ti.UI.Label",
                                bindId: "message",
                                properties: {
                                    color: Alloy.Globals.Style.Color.DarkGray,
                                    font: {
                                        fontSize: "15dp"
                                    },
                                    top: "26dp",
                                    right: "20dp",
                                    left: "59dp",
                                    bindId: "message"
                                }
                            };
                            __alloyId453.push(__alloyId461);
                            return __alloyId453;
                        }(),
                        properties: {
                            height: Ti.UI.SIZE,
                            top: 0,
                            left: 0
                        }
                    };
                    __alloyId450.push(__alloyId452);
                    var __alloyId463 = {
                        type: "Ti.UI.View",
                        childTemplates: function() {
                            var __alloyId464 = [];
                            var __alloyId466 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId467 = [];
                                    var __alloyId469 = {
                                        type: "Ti.UI.Label",
                                        bindId: "btnAccept",
                                        properties: {
                                            color: "#fff",
                                            font: {
                                                fontSize: "15dp"
                                            },
                                            borderRadius: Alloy.Globals.Style.Unit.unit3,
                                            normalColor: "#ff6600",
                                            selectedColor: "#de5900",
                                            backgroundImage: "none",
                                            width: Ti.UI.FILL,
                                            height: "39dp",
                                            borderWidth: "1dp",
                                            text: L("btn_yes"),
                                            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                                            backgroundColor: "#ff6600",
                                            borderColor: "#ff6600",
                                            right: "5dp",
                                            top: "1dp",
                                            backgroundSelectedColor: "#de5900",
                                            backgroundFocusedColor: "#de5900",
                                            bindId: "btnAccept"
                                        }
                                    };
                                    __alloyId467.push(__alloyId469);
                                    var __alloyId471 = {
                                        type: "Ti.UI.ActivityIndicator",
                                        bindId: "btnAcceptIndicator",
                                        properties: {
                                            style: Ti.UI.ActivityIndicatorStyle.DARK,
                                            height: "41dp",
                                            width: "41dp",
                                            zIndex: 10,
                                            bindId: "btnAcceptIndicator"
                                        }
                                    };
                                    __alloyId467.push(__alloyId471);
                                    return __alloyId467;
                                }(),
                                properties: {
                                    width: "49.9%",
                                    height: "41dp"
                                }
                            };
                            __alloyId464.push(__alloyId466);
                            var __alloyId473 = {
                                type: "Ti.UI.View",
                                childTemplates: function() {
                                    var __alloyId474 = [];
                                    var __alloyId476 = {
                                        type: "Ti.UI.Label",
                                        bindId: "btnDecline",
                                        properties: {
                                            color: Alloy.Globals.Style.Color.DarkGray,
                                            font: {
                                                fontSize: "15dp"
                                            },
                                            borderRadius: Alloy.Globals.Style.Unit.unit3,
                                            normalColor: "#00333333",
                                            selectedColor: "#70333333",
                                            backgroundImage: "none",
                                            borderColor: Alloy.Globals.Style.Color.DarkGray,
                                            borderWidth: "1dp",
                                            width: Ti.UI.FILL,
                                            height: "39dp",
                                            text: L("btn_no"),
                                            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                                            left: "6dp",
                                            right: 0,
                                            top: "1dp",
                                            backgroundSelectedColor: "#2a2a2a",
                                            backgroundFocusedColor: "#2a2a2a",
                                            bindId: "btnDecline"
                                        }
                                    };
                                    __alloyId474.push(__alloyId476);
                                    var __alloyId478 = {
                                        type: "Ti.UI.ActivityIndicator",
                                        bindId: "btnDeclineIndicator",
                                        properties: {
                                            style: Ti.UI.ActivityIndicatorStyle.DARK,
                                            height: "41dp",
                                            width: "41dp",
                                            zIndex: 10,
                                            bindId: "btnDeclineIndicator"
                                        }
                                    };
                                    __alloyId474.push(__alloyId478);
                                    return __alloyId474;
                                }(),
                                properties: {
                                    width: "49.9%",
                                    height: "41dp"
                                }
                            };
                            __alloyId464.push(__alloyId473);
                            return __alloyId464;
                        }(),
                        properties: {
                            layout: "horizontal",
                            top: "18dp",
                            height: Ti.UI.SIZE,
                            bottom: "18dp"
                        }
                    };
                    __alloyId450.push(__alloyId463);
                    var __alloyId480 = {
                        type: "Ti.UI.View",
                        bindId: "hr",
                        properties: {
                            backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                            width: "100%",
                            height: "1px",
                            bottom: 0,
                            left: 0,
                            bindId: "hr"
                        }
                    };
                    __alloyId450.push(__alloyId480);
                    return __alloyId450;
                }(),
                properties: {
                    height: Ti.UI.SIZE,
                    backgroundColor: "transparent",
                    layout: "vertical",
                    width: Ti.UI.FILL,
                    left: "13dp",
                    right: "13dp"
                }
            };
            __alloyId447.push(__alloyId449);
            return __alloyId447;
        }(),
        properties: {
            backgroundColor: "#eeeeee",
            left: 0,
            right: 0,
            width: Ti.UI.FILL,
            height: Ti.UI.SIZE,
            bindId: "bckgHolder"
        }
    };
    __alloyId444.push(__alloyId446);
    var __alloyId443 = {
        properties: {
            backgroundColor: "transparent",
            height: Ti.UI.SIZE,
            name: "bookingTemplate"
        },
        childTemplates: __alloyId444
    };
    __alloyId403["bookingTemplate"] = __alloyId443;
    var __alloyId483 = [];
    var __alloyId485 = {
        type: "Ti.UI.View",
        bindId: "bckgHolder",
        childTemplates: function() {
            var __alloyId486 = [];
            var __alloyId488 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId489 = [];
                    var __alloyId491 = {
                        type: "Ti.UI.ImageView",
                        bindId: "avatar",
                        properties: {
                            defaultImage: "/images/default_photo_male-rounded.png",
                            backgroundColor: "#eeeeee",
                            borderColor: "#eeeeee",
                            borderWidth: 1,
                            left: 0,
                            width: "48dp",
                            height: "48dp",
                            borderRadius: Alloy.Globals.Style.Unit.unit24,
                            bindId: "avatar"
                        }
                    };
                    __alloyId489.push(__alloyId491);
                    var __alloyId493 = {
                        type: "Ti.UI.Label",
                        bindId: "name",
                        properties: {
                            color: Alloy.Globals.Style.Color.DarkGray,
                            font: {
                                fontSize: "15dp",
                                fontWeight: "bold"
                            },
                            left: "59dp",
                            right: "100dp",
                            height: "20dp",
                            wordWrap: false,
                            ellipsize: true,
                            top: "4dp",
                            bindId: "name"
                        }
                    };
                    __alloyId489.push(__alloyId493);
                    var __alloyId495 = {
                        type: "Ti.UI.Label",
                        bindId: "message",
                        properties: {
                            color: Alloy.Globals.Style.Color.DarkGray,
                            top: "21dp",
                            right: "20dp",
                            left: "59dp",
                            font: {
                                fontSize: "15dp"
                            },
                            text: L("widget_notifications_rating_msg"),
                            width: "175dp",
                            bindId: "message"
                        }
                    };
                    __alloyId489.push(__alloyId495);
                    var __alloyId497 = {
                        type: "Ti.UI.Label",
                        bindId: "btnRate",
                        properties: {
                            color: Alloy.Globals.Style.Color.DarkGray,
                            borderRadius: Alloy.Globals.Style.Unit.unit3,
                            normalColor: "#00333333",
                            selectedColor: "#70333333",
                            backgroundImage: "none",
                            borderColor: Alloy.Globals.Style.Color.DarkGray,
                            borderWidth: 2,
                            text: L("widget_rating_button_rate_now"),
                            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                            right: "8dp",
                            width: "50dp",
                            height: "30dp",
                            font: {
                                fontSize: "11dp"
                            },
                            bindId: "btnRate"
                        }
                    };
                    __alloyId489.push(__alloyId497);
                    var __alloyId499 = {
                        type: "Ti.UI.View",
                        properties: {
                            backgroundColor: Alloy.Globals.Style.Color.DarkGray,
                            width: "100%",
                            height: "1px",
                            bottom: 0,
                            left: 0
                        }
                    };
                    __alloyId489.push(__alloyId499);
                    return __alloyId489;
                }(),
                properties: {
                    width: Ti.UI.FILL,
                    left: "13dp",
                    right: "13dp"
                }
            };
            __alloyId486.push(__alloyId488);
            return __alloyId486;
        }(),
        properties: {
            width: Ti.UI.FILL,
            height: Ti.UI.SIZE,
            left: 0,
            right: 0,
            top: 0,
            backgroundColor: "#eeeeee",
            bindId: "bckgHolder"
        }
    };
    __alloyId483.push(__alloyId485);
    var __alloyId482 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "rateTemplate"
        },
        childTemplates: __alloyId483
    };
    __alloyId403["rateTemplate"] = __alloyId482;
    var __alloyId502 = [];
    var __alloyId504 = {
        type: "Ti.UI.ActivityIndicator",
        bindId: "activityIndicator",
        properties: {
            color: Alloy.Globals.Style.Color.DarkGray,
            message: L("loading_spinner"),
            height: Ti.UI.SIZE,
            width: "100%",
            left: 0,
            style: Ti.UI.ActivityIndicatorStyle.DARK,
            bindId: "activityIndicator"
        }
    };
    __alloyId502.push(__alloyId504);
    var __alloyId501 = {
        properties: {
            height: "60dp",
            backgroundColor: "#ffffffff",
            name: "loadingTemplate"
        },
        childTemplates: __alloyId502
    };
    __alloyId403["loadingTemplate"] = __alloyId501;
    var __alloyId507 = [];
    var __alloyId509 = {
        type: "Ti.UI.Label",
        properties: {
            color: "#fff",
            width: "91.66666666666666%",
            font: {
                fontSize: "12dp"
            },
            text: L("widget_messenger_no_messages"),
            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
        }
    };
    __alloyId507.push(__alloyId509);
    var __alloyId506 = {
        properties: {
            backgroundColor: "#80a4a4a4",
            height: "40dp",
            left: 0,
            name: "noMessagesTemplate"
        },
        childTemplates: __alloyId507
    };
    __alloyId403["noMessagesTemplate"] = __alloyId506;
    var __alloyId512 = [];
    var __alloyId514 = {
        type: "Ti.UI.Label",
        properties: {
            color: "#fff",
            width: "91.66666666666666%",
            font: {
                fontSize: "12dp"
            },
            text: L("widget_messenger_no_notifications"),
            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER
        }
    };
    __alloyId512.push(__alloyId514);
    var __alloyId511 = {
        properties: {
            backgroundColor: "#80a4a4a4",
            height: "40dp",
            left: 0,
            name: "noNotificationsTemplate"
        },
        childTemplates: __alloyId512
    };
    __alloyId403["noNotificationsTemplate"] = __alloyId511;
    $.__views.notificationsSection = Alloy.createWidget("ma.car.app.messenger", "notifications", {
        id: "notificationsSection",
        __parentSymbol: __parentSymbol
    });
    var __alloyId515 = [];
    __alloyId515.push($.__views.notificationsSection.getViewEx({
        recurse: true
    }));
    $.__views.conversationsSection = Alloy.createWidget("ma.car.app.messenger", "conversations", {
        id: "conversationsSection",
        __parentSymbol: __parentSymbol
    });
    __alloyId515.push($.__views.conversationsSection.getViewEx({
        recurse: true
    }));
    $.__views.list = Ti.UI.createListView({
        defaultItemTemplate: "messageTemplate",
        backgroundColor: "transparent",
        top: 0,
        left: 0,
        showVerticalScrollIndicator: false,
        separatorColor: "transparent",
        needPullRefresh: true,
        height: Ti.UI.SIZE,
        sections: __alloyId515,
        templates: __alloyId403,
        id: "list"
    });
    $.__views.list && $.addTopLevelView($.__views.list);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), errorHandler = require("/utils/errorHandler"), os = require("/platform/os"), Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService");
    exports = new (require("/carmalib/controller").extend($, {
        _conversationsController: null,
        _notificationsController: null,
        _executingAction: false,
        events: {
            "itemclick list": "_listItemClicked"
        },
        initialize: function() {
            _.bindAll(this, "_handleRateOK", "_handleRateError", "_handleRateCancel", "_loaded", "_reload", "_openChatEventHandler");
            $.conversationsSection.list = $.list;
            $.notificationsSection.list = $.list;
            this._conversationsController = $.conversationsSection;
            this._notificationsController = $.notificationsSection;
            $.list.addEventListener("didTriggeredRefresh", this._reload);
        },
        onDestroy: function() {
            $.list.removeEventListener("didTriggeredRefresh", this._reload);
            Ti.App.removeEventListener("carma:chat.opened", this._openChatEventHandler);
        },
        _reload: function() {
            var self = this, count = 0;
            this._conversationsController.load().then(function(data) {
                -1 !== data && _.each(data, function(thread) {
                    thread.unreadMessageCount > 0 && (count += thread.unreadMessageCount);
                });
                return self._notificationsController.load();
            }).then(function(data) {
                -1 !== data && (count += data.count);
            }).catch(function(e) {}).finally(function() {
                count > 0 && Ti.App.fireEvent("carma:overall.count.change", {
                    count: count
                });
                self._loaded();
            });
        },
        _loaded: function() {
            $.list.cmMarkRefreshFinished && $.list.cmMarkRefreshFinished();
        },
        load: function() {
            this._notificationsController.loadCache();
            this._conversationsController.loadCache();
            Ti.App.fireEvent("carma:update.overall.counter");
        },
        reloadMessages: function() {
            this._conversationsController.load();
        },
        reloadNotifications: function() {
            this._notificationsController.load();
        },
        reset: function() {
            if (!$.list.sections) return;
            $.list.scrollToTop();
            return;
            var i;
            var section;
        },
        _listItemClicked: function(e) {
            if (this._executingAction) return;
            this._executingAction = true;
            var item = e.section.getItemAt(e.itemIndex);
            if (!item || "noNotificationsTemplate" === item.template || "noMessagesTemplate" === item.template) {
                this._executingAction = false;
                return;
            }
            var self = this;
            TM.push(function() {
                self._playClickAnimation(e);
            });
            switch (e.bindId) {
              case "avatar":
                if (item.properties.userId) {
                    this._openUserProfile(item.properties.userId);
                    return;
                }
                break;

              case "btnAccept":
                item.btnAcceptIndicator.visible = true;
                e.section.updateItemAt(e.itemIndex, item);
                this._replyBooking(item, e.itemIndex, true, e.section);
                return;

              case "btnDecline":
                item.btnDeclineIndicator.visible = true;
                e.section.updateItemAt(e.itemIndex, item);
                this._replyBooking(item, e.itemIndex, false, e.section);
                return;

              case "btnRate":
                this._rateUser(item, e.itemIndex);
                return;
            }
            switch (item.properties.rowType) {
              case "booking":
              case "rating":
                this._executingAction = false;
                break;

              case "conversation":
                this._openChat(item.properties.threadId, item.properties.title);
                break;

              default:
                this._executingAction = false;
            }
        },
        _playClickAnimation: function(event) {
            var item = event.section.getItemAt(event.itemIndex);
            if ("bookingTemplate" === item.template) return;
            item.bckgHolder = item.bckgHolder || {};
            var bckg = item.bckgHolder.backgroundColor || ("rateTemplate" === item.template ? "#eeeeee" : "transparent");
            item.bckgHolder.backgroundColor = "#80cccccc";
            (item.bckgHolder.avatar || {}).backgroundColor = "#80cccccc";
            event.section.updateItemAt(event.itemIndex, item);
            setTimeout(function() {
                item.bckgHolder.backgroundColor = bckg;
                (item.bckgHolder.avatar || {}).backgroundColor = bckg;
                event.section.updateItemAt(event.itemIndex, item);
            }, 300);
        },
        _openChat: function(threadId, title) {
            var self = this;
            Ti.App.addEventListener("carma:chat.opened", this._openChatEventHandler);
            Ti.App.fireEvent("carma:open.conversation", {
                threadId: threadId,
                title: title
            });
        },
        _openChatEventHandler: function() {
            Ti.App.removeEventListener("carma:chat.opened", this._openChatEventHandler);
            this._executingAction = false;
        },
        _openUserProfile: function(userId) {
            if (!userId) {
                this._executingAction = false;
                return;
            }
            Ti.App.fireEvent("carma:profile.open", {
                userId: userId
            });
            var self = this;
            setTimeout(function() {
                self._executingAction = false;
            }, 500);
        },
        _rateUser: function(item, index) {
            var online = require("bootstrap/network").isConnected();
            if (!online) {
                self._executingAction = false;
                return;
            }
            var self = this;
            var window = Alloy.createWidget("ma.car.app.rating", {
                journeyId: item.properties.journeyId,
                target: item.properties.targetUser,
                ok: function() {
                    self._handleRateOK(item.properties.notificationId, index);
                    self._updateNotificationsCounter();
                    self._executingAction = false;
                },
                cancel: this._handleRateCancel,
                error: function(e) {
                    self._handleRateError(e, item, index);
                }
            }).getView();
            window.addEventListener("open", function handler() {
                window.removeEventListener("open", handler);
                var event = require("/tracking/tracking_event");
                require("/tracking/tracking_manager").track(event.PAGE_HIT, {
                    view: "rating"
                });
            });
            window.addEventListener("close", function handler() {
                window.removeEventListener("close", handler);
                self._executingAction = false;
            });
            window.open();
        },
        _handleRateOK: function(id, index) {
            $.list.sections[0].deleteItemsAt(index, 1, {
                animated: false
            });
            require("services/notification_service").updateCache(id, "dropoffNotifications");
        },
        _handleRateCancel: function() {
            this._executingAction = false;
        },
        _handleRateError: function(e, item, index) {
            this._executingAction = false;
            if (e && "already_reviewed" === e.errorCode) {
                this._deleteRatingNotification(item.properties.notificationId);
                $.list.sections[0].deleteItemsAt(index, 1, {
                    animated: false
                });
                this._updateNotificationsCounter();
                require("services/notification_service").updateCache(item.properties.notificationId, "dropoffNotifications");
            }
        },
        _deleteRatingNotification: function(id) {
            TM.push(function() {
                require("services/notification_service").deleteDropOff(id);
            });
        },
        _replyBooking: function(item, index, accept, section) {
            var self = this;
            (function() {
                return accept ? self._acceptBooking(item.properties.notificationId, item.properties.initiator) : self._declineBooking(item.properties.notificationId, item.properties.initiator);
            })().then(function() {
                $.list.sections[0].deleteItemsAt(index, 1, {
                    animated: false
                });
                self._updateNotificationsCounter();
                self._executingAction = false;
                if (accept) {
                    Ti.App.fireEvent("carma:booking.changed");
                    bookingService.emit(bookingService.BOOKING_UPDATED);
                }
            }).catch(function(e) {
                self._executingAction = false;
                errorHandler.noticeError(_.extend({
                    action: accept ? "USER_RIDE_BOOKING_ACCEPT" : "USER_RIDE_BOOKING_CANCEL",
                    callback: function() {
                        Ti.App.fireEvent("carma:booking.changed");
                        bookingService.emit(bookingService.BOOKING_UPDATED);
                    }
                }, e));
            }).finally(function() {
                item.btnAcceptIndicator.visible = false;
                item.btnDeclineIndicator.visible = false;
                section.updateItemAt(index, item);
            });
        },
        _acceptBooking: function(id, initiator) {
            var deferred = Q.defer();
            var online = require("bootstrap/network").isConnected();
            online ? require("services/booking_service").accept(id, initiator.firstName).then(function() {
                Ti.App.fireEvent("carma:booking.changed", {
                    bookingId: id,
                    state: "ACCEPTED"
                });
                bookingService.emit(bookingService.BOOKING_UPDATED);
                deferred.resolve();
            }).catch(function(e) {
                deferred.reject(e);
            }) : deferred.reject();
            return deferred.promise;
        },
        _declineBooking: function(id, initiator) {
            var deferred = Q.defer();
            var online = require("bootstrap/network").isConnected();
            online ? require("services/booking_service").decline(id, initiator.firstName).then(function() {
                Ti.App.fireEvent("carma:booking.changed", {
                    bookingId: id,
                    state: "CANCELLED"
                });
                bookingService.emit(bookingService.BOOKING_UPDATED);
                deferred.resolve();
            }).catch(function(e) {
                deferred.reject(e);
            }) : deferred.reject();
            return deferred.promise;
        },
        _updateNotificationsCounter: function() {
            Ti.App.fireEvent("carma:update.overall.counter");
        },
        _customizeIOS6: function() {
            this._conversationsController.customizeIOS6();
            this._notificationsController.customizeIOS6();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;