function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.messenger/" + s : s.substring(0, index) + "/ma.car.app.messenger/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.messenger");
    this.__widgetId = "ma.car.app.messenger";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "messageCenter";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.conversationsContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        id: "conversationsContainer"
    });
    $.__views.conversationsContainer && $.addTopLevelView($.__views.conversationsContainer);
    $.__views.conversationsWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        id: "conversationsWrapper"
    });
    $.__views.conversationsContainer.add($.__views.conversationsWrapper);
    $.__views.loading = Ti.UI.createActivityIndicator({
        top: "60dp",
        style: Ti.UI.ActivityIndicatorStyle.PLAIN,
        id: "loading"
    });
    $.__views.conversationsWrapper.add($.__views.loading);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var os = require("/platform/os"), rootWindow = TABS_HELPER.rootWindow();
    exports = new (require("/carmalib/controller").extend($, {
        events: {},
        _listViewWidget: null,
        initialize: function() {
            $.loading.show();
            this._initEventListeners();
        },
        _initEventListeners: function() {
            var self = this;
            rootWindow.addAppEventListener("carma:messages.count.change", function(data) {
                self.reloadMessages();
            });
            rootWindow.addAppEventListener("carma:notifications.count.change", function(data) {
                self.reloadNotifications();
            });
        },
        init: function() {
            this._listViewWidget = Alloy.createWidget("ma.car.app.messenger", "listView");
            $.conversationsWrapper.add(this._listViewWidget.getView());
            $.conversationsWrapper.remove($.loading);
            this._listViewWidget.load();
        },
        onDestroy: function() {
            this._listViewWidget.onDestroy();
        },
        reloadMessages: function() {
            this._listViewWidget.reloadMessages();
        },
        reloadNotifications: function() {
            this._listViewWidget.reloadNotifications();
        },
        _customizeIOS6: function() {
            $.conversationsWrapper.width = "100%";
        },
        reset: function() {
            this._listViewWidget && this._listViewWidget.reset();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;