function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.messenger/" + s : s.substring(0, index) + "/ma.car.app.messenger/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.messenger");
    this.__widgetId = "ma.car.app.messenger";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tblRowMessage";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tableRow = Ti.UI.createTableViewRow({
        backgroundColor: "transparent",
        backgroundImage: "none",
        id: "tableRow"
    });
    $.__views.tableRow && $.addTopLevelView($.__views.tableRow);
    $.__views.rowWrapper = Ti.UI.createView({
        height: Ti.UI.SIZE,
        layout: "vertical",
        bottom: "7dp",
        id: "rowWrapper"
    });
    $.__views.tableRow.add($.__views.rowWrapper);
    $.__views.borderTop = Ti.UI.createView({
        width: "100%",
        height: "2px",
        backgroundColor: "#fff",
        visible: false,
        bottom: "1dp",
        id: "borderTop"
    });
    $.__views.rowWrapper.add($.__views.borderTop);
    $.__views.inner = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        bottom: "7dp",
        height: Ti.UI.SIZE,
        id: "inner"
    });
    $.__views.rowWrapper.add($.__views.inner);
    $.__views.avatarContainer = Ti.UI.createView({
        width: "55dp",
        height: Ti.UI.SIZE,
        left: 0,
        top: 0,
        id: "avatarContainer"
    });
    $.__views.inner.add($.__views.avatarContainer);
    $.__views.arrow = Ti.UI.createLabel({
        color: "#5b85df",
        left: 0,
        top: "6dp",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "10dp",
            fontFamily: "splinico"
        },
        text: "g",
        id: "arrow"
    });
    $.__views.avatarContainer.add($.__views.arrow);
    $.__views.profile = require("/ui/common/profile").createView({
        top: 0,
        left: 0,
        bottom: "1dp",
        id: "profile"
    });
    $.__views.avatarContainer.add($.__views.profile);
    $.__views.textContainer = Ti.UI.createView({
        left: "53dp",
        top: 0,
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "textContainer"
    });
    $.__views.inner.add($.__views.textContainer);
    $.__views.messageContainer = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        backgroundColor: "#303037",
        top: 0,
        left: 0,
        id: "messageContainer"
    });
    $.__views.textContainer.add($.__views.messageContainer);
    $.__views.borderBottom = Ti.UI.createView({
        width: "100%",
        height: "2px",
        backgroundColor: "#fff",
        visible: false,
        bottom: "1dp",
        id: "borderBottom"
    });
    $.__views.rowWrapper.add($.__views.borderBottom);
    exports.destroy = function() {};
    _.extend($, $.__views);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;