function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.people/" + s : s.substring(0, index) + "/ma.car.app.people/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.people");
    this.__widgetId = "ma.car.app.people";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.peopleWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        width: Alloy.Globals.Style.Size.Width.pct100,
        navBarHidden: true,
        height: "100%",
        top: Alloy.Globals.Style.Size.Height.pct99,
        visible: false,
        backgroundColor: "white",
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "peopleWindow"
    });
    $.__views.peopleWindow && $.addTopLevelView($.__views.peopleWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    !function() {
        var navigation = Alloy.Globals.Nav.People = Alloy.createController("navigation");
        var widget = Alloy.createWidget("ma.car.app.people", "people");
        $.peopleWindow.addEventListener("open", function handler() {
            $.peopleWindow.removeEventListener("open", handler);
            setTimeout(function() {
                $.peopleWindow.addEventListener("close", function handler() {
                    Alloy.Globals.Nav.People = null;
                    $.peopleWindow.removeEventListener("close", handler);
                    $.destroy();
                    widget.onDestroy && widget.onDestroy();
                });
            }, 500);
            $.peopleWindow.addAppEventListener("carma:open.conversation", function handleConflitWindow() {
                $.peopleWindow.close();
            });
        });
        navigation.init({
            index: widget,
            historyLimit: 20,
            mainWindow: $.peopleWindow,
            modal: true,
            transition: "none",
            title: L("widget_profile_search_people")
        });
    }();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;