function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bio";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.bioContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "10dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "bioContainer"
    });
    $.__views.bioContainer && $.addTopLevelView($.__views.bioContainer);
    $.__views.bioMessage = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: 0,
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "bioMessage"
    });
    $.__views.bioContainer.add($.__views.bioMessage);
    $.__views.url = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "12dp"
        },
        left: 0,
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "url"
    });
    $.__views.bioContainer.add($.__views.url);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click url": "_openURL"
        },
        initialize: function() {
            $.bioContainer.top = 0;
            $.bioContainer.height = 0;
            $.bioMessage.height = 0;
            $.url.height = 0;
        },
        showProfile: function(profile) {
            if (profile.bio) {
                $.bioMessage.text = profile.bio;
                $.bioMessage.height = Ti.UI.SIZE;
                $.bioContainer.height = Ti.UI.SIZE;
                $.bioContainer.top = "10dp";
            } else $.bioMessage.height = 0;
            if (profile.webpage) {
                $.url.text = profile.webpage;
                $.url.height = Ti.UI.SIZE;
                $.bioContainer.height = Ti.UI.SIZE;
                $.bioContainer.top = "10dp";
            } else $.url.height = 0;
            if ($.bioMessage.height + $.url.height === 0) {
                $.bioContainer.top = 0;
                $.bioContainer.top = 0;
            }
        },
        _openURL: function() {
            var url = $.url.text;
            url && Ti.Platform.openURL(url);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;