function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bottom_action";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.actions_wrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "90dp",
        id: "actions_wrapper"
    });
    $.__views.actions_wrapper && $.addTopLevelView($.__views.actions_wrapper);
    $.__views.settingsBtn = Ti.UI.createButton({
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        width: "47%",
        left: 0,
        title: L("widget_profile_settings"),
        id: "settingsBtn"
    });
    $.__views.actions_wrapper.add($.__views.settingsBtn);
    $.__views.logoutBtn = Ti.UI.createButton({
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        width: "47%",
        right: 0,
        title: L("widget_profile_log_out"),
        id: "logoutBtn"
    });
    $.__views.actions_wrapper.add($.__views.logoutBtn);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var navigation = Alloy.Globals.Nav.Profile;
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] logoutBtn": "_logout",
            "click[android] logoutBtn": "_logout",
            "click[ios] settingsBtn": "_openSettings",
            "click[android] settingsBtn": "_openSettings"
        },
        initialize: function() {},
        showProfile: function() {},
        _openEditProfile: function() {
            var path = "#myprofile", shell = Alloy.createController("shell", {
                path: path
            }).getView();
            shell.open();
            shell = null;
            path = null;
        },
        _openSettings: function() {
            var path = "settings";
            Alloy.createController("shell", {
                path: path
            }).getView().open();
        },
        _logout: function() {
            Ti.App.fireEvent("carma:logout");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;