function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "trophy_table";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.trophyTable = Ti.UI.createTableView({
        top: "10dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        right: Alloy.Globals.Style.Size.Width.pct4,
        height: 0,
        backgroundColor: "transparent",
        separatorColor: "#80333333",
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndicator: false,
        visible: true,
        id: "trophyTable"
    });
    $.__views.trophyTable && $.addTopLevelView($.__views.trophyTable);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    exports = new (require("/carmalib/controller").extend($, {
        _achievements: [],
        events: {},
        initialize: function() {
            LOGGER.info("[TROPHY TABLE INIT]");
        },
        showProfile: function(profile) {
            LOGGER.info("[TROPHY TABLE SHOW PROFILE]");
            if (profile.achievements) {
                this._achievements = profile.achievements;
                var tableHeight = 60 * this._achievements.length, tableHeightDP = tableHeight + "dp";
                $.trophyTable.setHeight(tableHeightDP);
                this._createTableRows();
            }
        },
        _createTableRows: function() {
            var tableDatas = [];
            for (var i = 0; i < this._achievements.length; i++) {
                var rowController = Widget.createController("trophy_row", this._achievements[i]);
                rowController.selectionStyle = "none";
                tableDatas.push(rowController.getView());
            }
            $.trophyTable.setData(tableDatas);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;