function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.rate/" + s : s.substring(0, index) + "/ma.car.app.rate/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function setRating(value) {
        _rating = value;
        LOGGER.info("rate value = " + _rating);
        $.val = parseInt(_rating, 10);
        var i = 1, star;
        for (i; 5 >= i; i++) {
            star = $["star" + i];
            if (_rating >= i) {
                star.applyProperties({
                    text: on
                });
                last = i;
            } else star.applyProperties({
                text: off
            });
        }
    }
    function starClicked(e) {
        var index = e.source.index;
        setRating(index);
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.rate");
    this.__widgetId = "ma.car.app.rate";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.starContainer = Ti.UI.createView({
        layout: "horizontal",
        top: "5dp",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "starContainer"
    });
    $.__views.starContainer && $.addTopLevelView($.__views.starContainer);
    $.__views.starView1 = Ti.UI.createView({
        height: Alloy.Globals.Style.Size.Width.pct25,
        width: Alloy.Globals.Style.Size.Width.pct17,
        layout: "vertical",
        id: "starView1"
    });
    $.__views.starContainer.add($.__views.starView1);
    $.__views.star1 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontFamily: "stars",
            fontSize: Alloy.Globals.Style.Size.Width.pct15
        },
        height: Alloy.Globals.Style.Size.Width.pct15,
        text: "",
        right: 1,
        index: 1,
        id: "star1"
    });
    $.__views.starView1.add($.__views.star1);
    starClicked ? $.__views.star1.addEventListener("click", starClicked) : __defers["$.__views.star1!click!starClicked"] = true;
    $.__views.star1Subtitle = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "15dp"
        },
        height: "30dp",
        width: Alloy.Globals.Style.Size.Width.pct18,
        top: "3dp",
        text: L("widget_rating_bad_label"),
        textAlign: "left",
        left: Alloy.Globals.Style.Size.Width.pct2,
        id: "star1Subtitle"
    });
    $.__views.starView1.add($.__views.star1Subtitle);
    $.__views.starView2 = Ti.UI.createView({
        height: Alloy.Globals.Style.Size.Width.pct25,
        width: Alloy.Globals.Style.Size.Width.pct17,
        layout: "vertical",
        id: "starView2"
    });
    $.__views.starContainer.add($.__views.starView2);
    $.__views.star2 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontFamily: "stars",
            fontSize: Alloy.Globals.Style.Size.Width.pct15
        },
        height: Alloy.Globals.Style.Size.Width.pct15,
        text: "",
        right: 1,
        index: 2,
        id: "star2"
    });
    $.__views.starView2.add($.__views.star2);
    starClicked ? $.__views.star2.addEventListener("click", starClicked) : __defers["$.__views.star2!click!starClicked"] = true;
    $.__views.starView3 = Ti.UI.createView({
        height: Alloy.Globals.Style.Size.Width.pct25,
        width: Alloy.Globals.Style.Size.Width.pct17,
        layout: "vertical",
        id: "starView3"
    });
    $.__views.starContainer.add($.__views.starView3);
    $.__views.star3 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontFamily: "stars",
            fontSize: Alloy.Globals.Style.Size.Width.pct15
        },
        height: Alloy.Globals.Style.Size.Width.pct15,
        text: "",
        right: 1,
        index: 3,
        id: "star3"
    });
    $.__views.starView3.add($.__views.star3);
    starClicked ? $.__views.star3.addEventListener("click", starClicked) : __defers["$.__views.star3!click!starClicked"] = true;
    $.__views.starView4 = Ti.UI.createView({
        height: Alloy.Globals.Style.Size.Width.pct25,
        width: Alloy.Globals.Style.Size.Width.pct17,
        layout: "vertical",
        id: "starView4"
    });
    $.__views.starContainer.add($.__views.starView4);
    $.__views.star4 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontFamily: "stars",
            fontSize: Alloy.Globals.Style.Size.Width.pct15
        },
        height: Alloy.Globals.Style.Size.Width.pct15,
        text: "",
        right: 1,
        index: 4,
        id: "star4"
    });
    $.__views.starView4.add($.__views.star4);
    starClicked ? $.__views.star4.addEventListener("click", starClicked) : __defers["$.__views.star4!click!starClicked"] = true;
    $.__views.starView5 = Ti.UI.createView({
        height: Alloy.Globals.Style.Size.Width.pct25,
        width: Alloy.Globals.Style.Size.Width.pct17,
        layout: "vertical",
        id: "starView5"
    });
    $.__views.starContainer.add($.__views.starView5);
    $.__views.star5 = Ti.UI.createLabel({
        color: "white",
        font: {
            fontFamily: "stars",
            fontSize: Alloy.Globals.Style.Size.Width.pct15
        },
        height: Alloy.Globals.Style.Size.Width.pct15,
        text: "",
        right: 1,
        index: 5,
        id: "star5"
    });
    $.__views.starView5.add($.__views.star5);
    starClicked ? $.__views.star5.addEventListener("click", starClicked) : __defers["$.__views.star5!click!starClicked"] = true;
    $.__views.star5Subtitle = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "15dp"
        },
        height: "30dp",
        width: Alloy.Globals.Style.Size.Width.pct18,
        top: "3dp",
        text: L("widget_rating_super_label"),
        textAlign: "right",
        right: Alloy.Globals.Style.Size.Width.pct2,
        id: "star5Subtitle"
    });
    $.__views.starView5.add($.__views.star5Subtitle);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var off = "", on = "";
    _.extend($.starContainer, args);
    var _rating = 0;
    args.rate && setRating(args.rating);
    $.star1.addEventListener("error", function(e) {
        LOGGER.error("error loading " + e.image);
    });
    exports.setVisible = function(visible) {
        $.starContainer.visible = visible;
    };
    exports.getRating = function() {
        return _rating;
    };
    exports.setRating = setRating;
    __defers["$.__views.star1!click!starClicked"] && $.__views.star1.addEventListener("click", starClicked);
    __defers["$.__views.star2!click!starClicked"] && $.__views.star2.addEventListener("click", starClicked);
    __defers["$.__views.star3!click!starClicked"] && $.__views.star3.addEventListener("click", starClicked);
    __defers["$.__views.star4!click!starClicked"] && $.__views.star4.addEventListener("click", starClicked);
    __defers["$.__views.star5!click!starClicked"] && $.__views.star5.addEventListener("click", starClicked);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;