function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "expiredTripMatch";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        font: {
            fontSize: "12dp"
        },
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        visible: "false",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_your_next_trip_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.containerWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "containerWrapper"
    });
    $.__views.layoutContainer.add($.__views.containerWrapper);
    $.__views.myTripAwesomeAnimationContainer = Ti.UI.createView({
        height: "60dp",
        top: 0,
        zIndex: 2,
        id: "myTripAwesomeAnimationContainer"
    });
    $.__views.containerWrapper.add($.__views.myTripAwesomeAnimationContainer);
    $.__views.myTripContainer = Ti.UI.createView({
        height: "55dp",
        layout: "vertical",
        top: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "myTripContainer"
    });
    $.__views.myTripAwesomeAnimationContainer.add($.__views.myTripContainer);
    $.__views.myTripBriefContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "55dp",
        backgroundColor: "#fff",
        layout: "horizontal",
        id: "myTripBriefContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripBriefContainer);
    $.__views.__alloyId907 = Ti.UI.createView({
        width: "86dp",
        id: "__alloyId907"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId907);
    $.__views.myTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "10dp",
        id: "myTripDepartureTime"
    });
    $.__views.__alloyId907.add($.__views.myTripDepartureTime);
    $.__views.myTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        bottom: "10dp",
        id: "myTripRole"
    });
    $.__views.__alloyId907.add($.__views.myTripRole);
    $.__views.__alloyId908 = Ti.UI.createView({
        width: Ti.UI.FILL,
        id: "__alloyId908"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId908);
    $.__views.myTripOrigin = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        left: "0",
        top: "10dp",
        id: "myTripOrigin"
    });
    $.__views.__alloyId908.add($.__views.myTripOrigin);
    $.__views.myTripDestination = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        left: "0",
        bottom: "10dp",
        id: "myTripDestination"
    });
    $.__views.__alloyId908.add($.__views.myTripDestination);
    $.__views.myTripMapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        backgroundColor: "#fff",
        height: "60dp",
        id: "myTripMapWrapper"
    });
    $.__views.myTripContainer.add($.__views.myTripMapWrapper);
    $.__views.myTripMap = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "myTripMap"
    });
    $.__views.myTripMapWrapper.add($.__views.myTripMap);
    $.__views.myTripActionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        backgroundColor: "#fff",
        id: "myTripActionsContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripActionsContainer);
    $.__views.myTripActionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        text: L("widget_samantha_driver_trip_note"),
        top: "10dp",
        id: "myTripActionsBrief"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActionsBrief);
    $.__views.myTripActions = Ti.UI.createView({
        height: "50dp",
        top: "10dp",
        id: "myTripActions"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActions);
    $.__views.changeDetailsButton = require("/ui/common/custom_button").createButton({
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "0",
        title: L("widget_samantha_trip_edit_trip"),
        id: "changeDetailsButton"
    });
    $.__views.myTripActions.add($.__views.changeDetailsButton);
    $.__views.confirmTripButton = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        font: {
            fontSize: "14dp"
        },
        width: "45%",
        right: "10dp",
        top: "0",
        title: L("btn_yes"),
        height: "44dp",
        id: "confirmTripButton"
    });
    $.__views.myTripActions.add($.__views.confirmTripButton);
    $.__views.tripMatchIndicator = Ti.UI.createView({
        height: "40dp",
        color: "#fff",
        top: "-6dp",
        zIndex: 1,
        id: "tripMatchIndicator"
    });
    $.__views.containerWrapper.add($.__views.tripMatchIndicator);
    $.__views.downArrowWrapper = Ti.UI.createLabel({
        color: "#ffffff",
        text: "L",
        title: "L",
        font: {
            fontFamily: "splinico",
            fontSize: "56dp"
        },
        top: "-28dp",
        id: "downArrowWrapper"
    });
    $.__views.tripMatchIndicator.add($.__views.downArrowWrapper);
    $.__views.indicatorMessage = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_expired_trip_match_title"),
        width: Ti.UI.SIZE,
        height: "20dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        top: "10dp",
        id: "indicatorMessage"
    });
    $.__views.tripMatchIndicator.add($.__views.indicatorMessage);
    $.__views.tripRequestedContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        backgroundColor: "#fff",
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        zIndex: 0,
        id: "tripRequestedContainer"
    });
    $.__views.containerWrapper.add($.__views.tripRequestedContainer);
    $.__views.tripBriefContainer = Ti.UI.createView({
        height: "75dp",
        top: 0,
        layout: "horizontal",
        id: "tripBriefContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.tripBriefContainer);
    $.__views.tripBriefContainerLeftColumn = Ti.UI.createView({
        width: "25%",
        id: "tripBriefContainerLeftColumn"
    });
    $.__views.tripBriefContainer.add($.__views.tripBriefContainerLeftColumn);
    $.__views.matchedTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "15dp"
        },
        left: "10dp",
        top: "10dp",
        id: "matchedTripDepartureTime"
    });
    $.__views.tripBriefContainerLeftColumn.add($.__views.matchedTripDepartureTime);
    $.__views.matchedTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "15dp"
        },
        top: "28dp",
        left: "10dp",
        id: "matchedTripRole"
    });
    $.__views.tripBriefContainerLeftColumn.add($.__views.matchedTripRole);
    $.__views.tripBriefContainerRightColumn = Ti.UI.createView({
        width: "74%",
        id: "tripBriefContainerRightColumn"
    });
    $.__views.tripBriefContainer.add($.__views.tripBriefContainerRightColumn);
    $.__views.matchedTripOwner = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        top: "10dp",
        left: "10dp",
        id: "matchedTripOwner"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripOwner);
    $.__views.matchedTripOrigin = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "25dp",
        left: "10dp",
        id: "matchedTripOrigin"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripOrigin);
    $.__views.matchedTripDestination = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "40dp",
        left: "10dp",
        id: "matchedTripDestination"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripDestination);
    $.__views.userPhoto = require("/ui/common/profile").createView({
        top: "10dp",
        right: "10dp",
        width: "48dp",
        height: "48dp",
        id: "userPhoto"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.userPhoto);
    $.__views.mapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        height: "60dp",
        id: "mapWrapper"
    });
    $.__views.tripRequestedContainer.add($.__views.mapWrapper);
    $.__views.map = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "map"
    });
    $.__views.mapWrapper.add($.__views.map);
    $.__views.actionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        id: "actionsContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.actionsContainer);
    $.__views.actionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "12dp"
        },
        height: "40dp",
        id: "actionsBrief"
    });
    $.__views.actionsContainer.add($.__views.actionsBrief);
    $.__views.actions = Ti.UI.createView({
        height: "60dp",
        id: "actions"
    });
    $.__views.actionsContainer.add($.__views.actions);
    $.__views.btnOK = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        left: "10dp",
        top: "0",
        title: L("btn_ok"),
        id: "btnOK"
    });
    $.__views.actions.add($.__views.btnOK);
    $.__views.btnMessage = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        right: "10dp",
        top: "0",
        title: L("widget_samantha_booking_message"),
        id: "btnMessage"
    });
    $.__views.actions.add($.__views.btnMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), args = arguments[0] || {}, utils = require("utils/utils"), moment = require("/vendor/moment"), samanthaService = require("services/samantha_service"), css = require("/ui/css"), samantha = args.samantha;
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "expiredTripMatch",
        customAnimation: false,
        _isMyTripCollapsed: true,
        _isTripRequestCollapsed: false,
        _availableScreenHeight: 0,
        _isTripMatchDriver: false,
        _trip: null,
        _booking: null,
        waitUntilReady: true,
        _alertShowed: false,
        events: {
            "click[ios] mapWrapper": "_openMapEvent",
            "click[android] mapWrapper": "_openMapEvent",
            "click myTripMapWrapper": "_openMyMapEvent",
            "click[ios] btnMessage": "_message",
            "click[android] btnMessage": "_message",
            "click[ios] btnOK": "_dismiss",
            "click[android] btnOK": "_dismiss",
            "click[ios] myTripBriefContainer": "_expandMyTrip",
            "click[ios] tripRequestedContainer": "_expandTripRequest",
            "click[android] myTripBriefContainer": "_expandMyTrip",
            "click[android] tripRequestedContainer": "_expandTripRequest",
            "click changeDetailsButton": "_changeMyTripDetails",
            "click confirmTripButton": "_confirmMyTrip"
        },
        initialize: function() {
            _.bindAll(this, "_getNextBooking", "_renderBookingInfo", "_openMapEvent");
        },
        configure: function() {},
        _dismiss: function() {
            var self = this;
            $.tripMatchIndicator.hide();
            $.tripRequestedContainer.applyProperties({
                width: $.tripRequestedContainer.size.width
            });
            $.tripRequestedContainer.animate({
                left: "-100%",
                duration: 300
            }, function() {
                $.tripRequestedContainer.applyProperties({
                    height: 0,
                    left: "-100%",
                    visible: false
                });
                $.layoutContainer.applyProperties({
                    height: "110dp"
                });
                samanthaService.bookingsRecord().markAsRead(self._booking.id, self._booking.trip.baseTrip.schedule.baseEffectiveTime);
                samantha.updateSamanthaContent({
                    forceUpdate: true
                });
            });
        },
        _message: function(e) {
            var userId = require("services/resource_owner_service").singleton().get("userId"), targetUser = this._isTripMatchDriver ? this._booking.driver : this._booking.rider, targetUserId = targetUser.userId, alias = targetUser.alias, threadId = targetUserId > userId ? targetUserId + "_" + userId : userId + "_" + targetUserId;
            targetUserId !== userId && Ti.App.fireEvent("carma:open.conversation", {
                threadId: threadId,
                alias: alias
            });
        },
        prepareView: function(options) {
            $.layoutContainer.applyProperties({
                height: Ti.UI.SIZE
            });
            $.tripRequestedContainer.applyProperties({
                height: Ti.UI.SIZE
            });
            var trip = options.trip, dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment), myUserId = require("services/resource_owner_service").singleton().get("userId");
            $.myTripDepartureTime.setText(dateTime);
            $.myTripRole.setText(L("widget_decision_samantha_" + trip.type));
            $.myTripOrigin.setText(trip.origin.address);
            $.myTripDestination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            this._availableScreenHeight = options.availableScreenHeight;
            this._isTripMatchDriver = this._booking.rider.userId === myUserId;
            this._layoutTripMatch(this._isTripMatchDriver);
            trip.schedule.confirmed && this._markTripConfirmed();
            var mapHeight = this._calculateMapHeight(options.availableScreenHeight, false);
            $.mapWrapper.height = mapHeight + "dp";
            mapHeight = this._calculateMapHeight(options.availableScreenHeight, true);
            $.myTripMapWrapper.height = mapHeight + "dp";
            this._renderBookingInfo();
            this._renderMap(trip, $.myTripMapWrapper, $.myTripMap);
            options.availableScreenHeight > 0 && $.containerWrapper.applyProperties({
                height: options.availableScreenHeight + "dp"
            });
            this._markTripMatchState();
            this._animateInTripMatch();
        },
        _markTripMatchState: function() {
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = this._booking.rider.userId === myUserId ? this._booking.driver : this._booking.rider;
            if ("DECLINED" === this._booking.tripMatchState) {
                css.setStyle($, {
                    "#actions": {
                        classes: "btn-carma-card-wrapper",
                        "#btnOK": "btn-carma-card-single"
                    },
                    "#btnMessage": {
                        width: 0
                    },
                    "#indicatorMessage": {
                        text: L("widget_samantha_declined_trip_match_title")
                    },
                    "#actionsBrief": {
                        classes: "carmaTextColour",
                        text: String.format(L("widget_samantha_declined_trip_match_caption"), coordinator.alias)
                    }
                });
                if (!this._alertShowed) {
                    this._alertShowed = true;
                    Ti.UI.createAlertDialog({
                        title: L("widget_samantha_declined_trip_match_subtitle"),
                        message: String.format(L("widget_samantha_declined_trip_match_caption"), coordinator.alias)
                    }).show();
                }
            } else if ("CANCELLED" === this._booking.tripMatchState) {
                css.setStyle($, {
                    "#actions": {
                        classes: "btn-carma-card-wrapper",
                        "#btnOK": "btn-carma-card-single"
                    },
                    "#btnMessage": {
                        width: 0
                    },
                    "#indicatorMessage": {
                        text: L("widget_samantha_cancelled_trip_match_title")
                    },
                    "#actionsBrief": {
                        classes: "carmaTextColour",
                        text: String.format(L("widget_samantha_cancelled_trip_match_caption"), coordinator.alias)
                    }
                });
                if (!this._alertShowed) {
                    this._alertShowed = true;
                    Ti.UI.createAlertDialog({
                        title: L("widget_samantha_cancelled_trip_match_subtitle"),
                        message: String.format(L("widget_samantha_cancelled_trip_match_caption"), coordinator.alias)
                    }).show();
                }
            } else if ("EXPIRED" === this._booking.tripMatchState) {
                $.removeClass($.actions, "btn-carma-card-wrapper");
                css.setStyle($, {
                    "#btnOK": "btn-carma-card btn",
                    "#btnMessage": "btn-carma-card btn",
                    "#indicatorMessage": {
                        text: L("widget_samantha_expired_trip_match_title")
                    },
                    "#actionsBrief": {
                        classes: "carmaTextColour",
                        text: String.format(L("widget_samantha_expired_trip_match_caption"), coordinator.alias)
                    }
                });
                if (!this._alertShowed) {
                    this._alertShowed = true;
                    Ti.UI.createAlertDialog({
                        title: L("widget_samantha_expired_trip_match_subtitle"),
                        message: String.format(L("widget_samantha_expired_trip_match_caption"), coordinator.alias)
                    }).show();
                }
            }
        },
        _layoutTripMatch: function(isDriver) {
            if (isDriver) {
                $.matchedTripDepartureTime.show();
                $.matchedTripRole.show();
                $.tripBriefContainerLeftColumn.remove($.userPhoto);
                $.tripBriefContainerRightColumn.add($.userPhoto);
                $.userPhoto.applyProperties({
                    right: "10dp",
                    left: null
                });
            } else {
                $.matchedTripDepartureTime.hide();
                $.matchedTripRole.hide();
                $.tripBriefContainerRightColumn.remove($.userPhoto);
                $.tripBriefContainerLeftColumn.add($.userPhoto);
                $.userPhoto.applyProperties({
                    left: "10dp",
                    right: null
                });
            }
        },
        _animateInTripMatch: function() {
            if (!$.tripRequestedContainer.visible || 0 !== parseFloat($.tripRequestedContainer.top) || parseFloat($.tripRequestedContainer.left) < 0) {
                $.tripRequestedContainer.applyProperties({
                    top: 0,
                    left: 0,
                    visible: true
                });
                $.tripMatchIndicator.show();
            }
        },
        _markTripConfirmed: function() {
            css.setStyle($, {
                "#myTripBriefContainer": {
                    classes: "orange-background",
                    "#myTripDepartureTime": "white",
                    "#myTripRole": "white",
                    "#myTripOrigin": "carmaCardText white",
                    "#myTripDestination": "carmaCardText white"
                },
                "#myTripActionsContainer": {
                    visible: false,
                    height: 0
                },
                "#downArrowWrapper": "orange"
            });
        },
        finishDisplay: function() {
            this._animateInTripMatch();
            $.layoutContainer.show();
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this._booking = options.bookings[0];
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
        },
        displayWithAnimation: function() {},
        disappear: function() {
            $.layoutContainer.hide();
            samantha.removeCard(this.cardName);
        },
        disappearWithAnimation: function() {},
        _calculateMapHeight: function(availableHeight, isMyTripMap) {
            if (!availableHeight) return;
            var mapHeight;
            mapHeight = isMyTripMap ? availableHeight - 2 * parseFloat($.myTripBriefContainer.height, 10) - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.myTripActionsContainer.height, 10) : availableHeight - parseFloat($.tripBriefContainer.height, 10) - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.myTripBriefContainer.height, 10) - parseFloat($.actionsContainer.height, 10);
            return mapHeight;
        },
        _loadBookingData: function() {
            require("/services/samantha_service").findBookings(false).then(this._getNextBooking).then(this._renderBookingInfo);
        },
        _getNextBooking: function(bookings) {
            var self = this;
            _.each(bookings.rideBookings, function(booking) {
                "AUTOMATIC" === booking.trigger && (!self._booking || booking.bookingDate < self._booking.bookingDate) && (self._booking = booking);
            });
        },
        _renderBookingInfo: function() {
            if (!Alloy.Globals.Map) return;
            if (!this._booking) return;
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = this._booking.rider.userId === myUserId ? this._booking.driver : this._booking.rider;
            var trip = this._booking.trip.ownerUid === myUserId ? this._booking.sourceTrip.baseTrip : this._booking.trip.baseTrip;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.matchedTripDepartureTime.setText(dateTime);
            $.matchedTripRole.setText(L("widget_decision_samantha_" + trip.type));
            $.matchedTripOwner.setText(coordinator.alias);
            $.matchedTripOrigin.setText(trip.origin.address);
            $.matchedTripDestination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            $.actionsBrief.setText(String.format(L("widget_samantha_expired_trip_match_caption"), coordinator.alias));
            $.userPhoto.setUser(_.extend({}, coordinator, {
                layout: "circular-small"
            }));
            this._renderMap(trip, $.mapWrapper, $.map);
        },
        _renderMap: function(trip, mapWrapper, mapView) {
            var self = this;
            if (0 === parseFloat(mapWrapper.size.width)) {
                _.delay(function() {
                    self._renderMap(trip, mapWrapper, mapView);
                }, 2e3);
                return;
            }
            var mapWidth = mapWrapper.rect.width, mapHeight = parseFloat(mapWrapper.height), units = require("/platform/units");
            utils.createMapUrl(trip, units.pixelToDip(mapWidth), mapHeight).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
                mapView.applyProperties({
                    height: mapHeight + "dp",
                    image: localPath
                });
            }).catch(function(e) {});
        },
        _openMyMapEvent: function(e) {
            if (!this._trip) return;
            samantha.whisper("samantha.open.map", {
                trip: this._trip
            });
        },
        _openMapEvent: function(e) {
            if (!this._booking) return;
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), booking = this._booking, amIARider = booking.rider.userId === myUserId, requestedTrip = amIARider ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            LOGGER.error("[expiredTripMatch] - map trip: " + JSON.stringify(trip));
            samantha.whisper("samantha.open.map", {
                trip: requestedTrip,
                dontUseTime: !amIARider
            });
        },
        _expandMyTrip: function() {
            if (!this._isMyTripCollapsed) return;
            css.setStyle($, {
                "#downArrowWrapper": "white"
            });
            this._isMyTripCollapsed = false;
            this._isTripRequestCollapsed = true;
            this._showTripRequestByCardType("simple");
            this._showMyTripByCardType("detailed");
            this._playBounceAnimation($.myTripContainer, 5);
        },
        _expandTripRequest: function() {
            if (!this._isTripRequestCollapsed) return;
            var colorClass = "white";
            this._trip.schedule.confirmed && (colorClass = "orange");
            css.setStyle($, {
                "#downArrowWrapper": colorClass
            });
            this._isMyTripCollapsed = true;
            this._isTripRequestCollapsed = false;
            this._showMyTripByCardType("simple");
            this._showTripRequestByCardType("detailed");
            this._playBounceAnimation($.tripRequestedContainer, 5);
        },
        _playBounceAnimation: function(element, extremePoint) {
            element.animate({
                top: extremePoint + "dp",
                duration: 100
            }, function() {
                element.applyProperties({
                    top: extremePoint + "dp"
                });
                element.animate({
                    top: 0,
                    duration: 100
                }, function() {
                    element.applyProperties({
                        top: 0
                    });
                });
            });
        },
        _showMyTripByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.myTripContainer.applyProperties({
                    height: "55dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: "60dp"
                });
            } else {
                var height = this._availableScreenHeight - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.tripRequestedContainer.height, 10) - 5;
                $.myTripContainer.applyProperties({
                    height: height + "dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: height + 5 + "dp"
                });
            }
        },
        _showTripRequestByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.matchedTripOwner.applyProperties({
                    top: 0,
                    height: 0,
                    visible: false
                });
                $.matchedTripOrigin.applyProperties({
                    top: "10dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "27dp"
                });
                $.tripRequestedContainer.applyProperties({
                    height: "55dp"
                });
                this._isTripMatchDriver && $.userPhoto.applyProperties({
                    visible: false,
                    touchEnabled: false
                });
            } else {
                $.matchedTripOwner.applyProperties({
                    top: "10dp",
                    height: Ti.UI.SIZE,
                    visible: true
                });
                $.matchedTripOrigin.applyProperties({
                    top: "27dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "45dp"
                });
                var height = this._availableScreenHeight - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.myTripContainer.height, 10) - 5;
                $.tripRequestedContainer.applyProperties({
                    height: height + "dp"
                });
                $.userPhoto.applyProperties({
                    visible: true,
                    touchEnabled: true
                });
            }
        },
        _changeMyTripDetails: function() {
            samantha.whisper("samantha.editTripAction.dialog");
        },
        _confirmMyTrip: function() {
            var booking = this._booking, myUserId = require("services/resource_owner_service").singleton().get("userId"), trip = booking.trip.ownerUid === myUserId ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            samantha.whisper("samantha.confirm.trip", {
                trip: trip,
                callback: function() {}
            });
            var self = this;
            TM.push(function() {
                analytics.track(trackingEvent.SAMANTHA_CONFIRM_TRIP, {
                    tripId: trip.id
                });
            }, process.backgroundDomain);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;