function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "noMatches";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        visible: "false",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.labelBigTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_tripcard_nomatch_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "labelBigTitle"
    });
    $.__views.layout.add($.__views.labelBigTitle);
    $.__views.layoutContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: "3dp",
        backgroundColor: "#fff",
        id: "layoutContainer"
    });
    $.__views.layout.add($.__views.layoutContainer);
    $.__views.__alloyId923 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId923"
    });
    $.__views.layoutContainer.add($.__views.__alloyId923);
    $.__views.__alloyId924 = Ti.UI.createImageView({
        defaultImage: "/images/nomatches.png",
        width: "100%",
        height: "auto",
        image: "/images/nomatches.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        id: "__alloyId924"
    });
    $.__views.__alloyId923.add($.__views.__alloyId924);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "layoutInner"
    });
    $.__views.layoutContainer.add($.__views.layoutInner);
    $.__views.__alloyId925 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId925"
    });
    $.__views.layoutInner.add($.__views.__alloyId925);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_nomatches_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId925.add($.__views.labelTitle);
    $.__views.__alloyId926 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId926"
    });
    $.__views.layoutInner.add($.__views.__alloyId926);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_nomatches_message"),
        id: "labelMessage"
    });
    $.__views.__alloyId926.add($.__views.labelMessage);
    $.__views.__alloyId927 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId927"
    });
    $.__views.layoutInner.add($.__views.__alloyId927);
    $.__views.btn = require("/ui/common/custom_button").createButton({
        width: Ti.UI.FILL,
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btn",
        indicator: "true"
    });
    $.__views.__alloyId927.add($.__views.btn);
    $.__views.__alloyId928 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId928"
    });
    $.__views.btn.add($.__views.__alloyId928);
    $.__views.__alloyId929 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId929"
    });
    $.__views.__alloyId928.add($.__views.__alloyId929);
    $.__views.btnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_nomatches_btn"),
        id: "btnLabel"
    });
    $.__views.__alloyId929.add($.__views.btnLabel);
    $.__views.__alloyId930 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId930"
    });
    $.__views.layoutInner.add($.__views.__alloyId930);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var MessageController = require(WPATH("messageControllerBuilder")), trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), userservice = require("services/user_service"), args = arguments[0] || {}, _inviteId = null, _inviteCode = null, samantha = args.samantha;
    var dialog = MessageController.create($, samantha, "noMatches");
    _.extend(dialog, {
        _shareOpening: false,
        _btnClickHandler: function() {
            $.btn.stopIndicator();
            var self = this;
            _inviteCode = userservice.getCachReferralCode();
            _inviteId && _inviteCode ? this._openShare() : _inviteId ? _inviteCode ? this._openShare() : userservice.getReferralCode().then(function(data) {
                _inviteCode = data.referralCode;
                userservice.cachReferralCode(_inviteCode);
                self._openShare();
            }) : Alloy.createModel("invitation").generate({
                method: "UNKNOWN",
                entity: "user"
            }).then(function(data) {
                _inviteId = data.id;
                _inviteCode ? self._openShare() : userservice.getReferralCode().then(function(data) {
                    _inviteCode = data.referralCode;
                    userservice.cachReferralCode(_inviteCode);
                    self._openShare();
                });
            });
        },
        _openShare: function() {
            require("ui/common/sharing").openShare({
                type: "invitefriends",
                inviteId: _inviteId,
                inviteCode: _inviteCode,
                subject: L("native_share_no_matches_subject")
            }, this);
        }
    });
    exports = dialog;
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;