function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "noSamanthaReplies";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        visible: "false",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_noreplies_title_bar"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layout.add($.__views.lblTitle);
    $.__views.containerWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "containerWrapper"
    });
    $.__views.layout.add($.__views.containerWrapper);
    $.__views.myTripBriefContainer = Ti.UI.createView({
        backgroundColor: "#003333",
        height: Ti.UI.SIZE,
        layout: "vertical",
        top: 0,
        id: "myTripBriefContainer"
    });
    $.__views.containerWrapper.add($.__views.myTripBriefContainer);
    $.__views.date = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.myTripBriefContainer.add($.__views.date);
    $.__views.__alloyId931 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId931"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId931);
    $.__views.tripTime = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId931.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#fff",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "origin"
    });
    $.__views.__alloyId931.add($.__views.origin);
    $.__views.__alloyId932 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId932"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId932);
    $.__views.tripType = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId932.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#fff",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "destination"
    });
    $.__views.__alloyId932.add($.__views.destination);
    $.__views.__alloyId933 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId933"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId933);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        backgroundColor: "#fff",
        id: "layoutInner"
    });
    $.__views.containerWrapper.add($.__views.layoutInner);
    $.__views.__alloyId934 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId934"
    });
    $.__views.layoutInner.add($.__views.__alloyId934);
    $.__views.__alloyId935 = Ti.UI.createImageView({
        defaultImage: "/images/nomatches.png",
        width: "100%",
        height: "auto",
        image: "/images/nomatches.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        id: "__alloyId935"
    });
    $.__views.layoutInner.add($.__views.__alloyId935);
    $.__views.__alloyId936 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId936"
    });
    $.__views.layoutInner.add($.__views.__alloyId936);
    $.__views.lblCaption = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_noreplies_caption"),
        left: "2.5%",
        width: "95%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        id: "lblCaption"
    });
    $.__views.__alloyId936.add($.__views.lblCaption);
    $.__views.__alloyId937 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId937"
    });
    $.__views.layoutInner.add($.__views.__alloyId937);
    $.__views.actions = Ti.UI.createView({
        height: Ti.UI.SIZE,
        layout: "horizontal",
        left: "10dp",
        right: "10dp",
        top: "10dp",
        id: "actions"
    });
    $.__views.layoutInner.add($.__views.actions);
    $.__views.btnPlanTripButton = require("/ui/common/custom_button").createButton({
        width: "100%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btnPlanTripButton"
    });
    $.__views.actions.add($.__views.btnPlanTripButton);
    $.__views.btnPlanTrip = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_noreplies_view_all_matches"),
        id: "btnPlanTrip"
    });
    $.__views.btnPlanTripButton.add($.__views.btnPlanTrip);
    $.__views.__alloyId938 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId938"
    });
    $.__views.layoutInner.add($.__views.__alloyId938);
    $.__views.__alloyId939 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId939"
    });
    $.__views.layoutInner.add($.__views.__alloyId939);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), utils = require("utils/utils"), args = arguments[0] || {}, samantha = args.samantha;
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "noSamanthaReplies",
        _trip: null,
        events: {
            "click btnPlanTripButton": "_openPlanTrip",
            "click btnEditTripButton": "_editTrip"
        },
        configure: function() {},
        prepareView: function(options) {
            var trip = options.trip;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.date.text = moment(trip.schedule.effectiveTime).format("Do MMM");
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.address);
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            if ("CANCELLED" === options.state) {
                $.lblTitle.text = L("widget_samantha_title_booking_canceled");
                $.lblCaption.text = L("RIDE" === trip.type ? "widget_samantha_des_no_confirmed_driver" : "widget_samantha_des_no_confirmed_rider");
            } else {
                $.lblTitle.text = L("RIDE" === trip.type ? "widget_samantha_title_no_driver_found" : "widget_samantha_title_no_rider_found");
                $.lblCaption.text = L("RIDE" === trip.type ? "widget_samantha_des_no_driver_found" : "widget_samantha_des_no_rider_found");
            }
            if (samantha.tripMatchFound) {
                $.lblTitle.text = L("widget_samantha_title_booking_canceled");
                $.lblCaption.text = "RIDE" === trip.type ? String.format(L("widget_samantha_des_booking_canceled_rider"), samantha.lastMatchUserName) : String.format(L("widget_samantha_des_booking_canceled_driver"), samantha.lastMatchUserName);
            }
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layout.show();
        },
        disappear: function() {
            $.layout.hide();
            samantha.removeCard(this.cardName);
        },
        _openPlanTrip: function() {
            Ti.App.fireEvent("carma:plantrip.tab");
        },
        _editTrip: function() {
            samantha.whisper("samantha.editTripAction.dialog");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;