function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "noTrips";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        visible: "false",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_notrip_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layout.add($.__views.lblTitle);
    $.__views.layoutContainer = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundColor: "#fff",
        id: "layoutContainer"
    });
    $.__views.layout.add($.__views.layoutContainer);
    $.__views.__alloyId940 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId940"
    });
    $.__views.layoutContainer.add($.__views.__alloyId940);
    $.__views.__alloyId941 = Ti.UI.createImageView({
        defaultImage: "/images/notrips.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/notrips.png",
        id: "__alloyId941"
    });
    $.__views.__alloyId940.add($.__views.__alloyId941);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "layoutInner"
    });
    $.__views.layoutContainer.add($.__views.layoutInner);
    $.__views.__alloyId942 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId942"
    });
    $.__views.layoutInner.add($.__views.__alloyId942);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_notrip_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId942.add($.__views.labelTitle);
    $.__views.__alloyId943 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId943"
    });
    $.__views.layoutInner.add($.__views.__alloyId943);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_notrip_message"),
        id: "labelMessage"
    });
    $.__views.__alloyId943.add($.__views.labelMessage);
    $.__views.__alloyId944 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId944"
    });
    $.__views.layoutInner.add($.__views.__alloyId944);
    $.__views.btn = require("/ui/common/custom_button").createButton({
        width: Ti.UI.FILL,
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btn",
        indicator: "true"
    });
    $.__views.__alloyId944.add($.__views.btn);
    $.__views.__alloyId945 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId945"
    });
    $.__views.btn.add($.__views.__alloyId945);
    $.__views.__alloyId946 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId946"
    });
    $.__views.__alloyId945.add($.__views.__alloyId946);
    $.__views.btnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_notrip_btn"),
        id: "btnLabel"
    });
    $.__views.__alloyId946.add($.__views.btnLabel);
    $.__views.__alloyId947 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId947"
    });
    $.__views.layoutInner.add($.__views.__alloyId947);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var MessageController = require(WPATH("messageControllerBuilder")), args = arguments[0] || {}, samantha = args.samantha;
    exports = MessageController.create($, samantha, "noTrips");
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;