function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripBookings";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        visible: "false",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        top: 0,
        layout: "vertical",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_your_next_trip_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.__alloyId948 = Ti.UI.createView({
        top: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundColor: "#fff",
        id: "__alloyId948"
    });
    $.__views.layoutContainer.add($.__views.__alloyId948);
    $.__views.header = Ti.UI.createView({
        backgroundColor: "#003333",
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "header"
    });
    $.__views.__alloyId948.add($.__views.header);
    $.__views.date = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.header.add($.__views.date);
    $.__views.__alloyId949 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId949"
    });
    $.__views.header.add($.__views.__alloyId949);
    $.__views.tripTime = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId949.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#fff",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        width: "72%",
        id: "origin"
    });
    $.__views.__alloyId949.add($.__views.origin);
    $.__views.__alloyId950 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId950"
    });
    $.__views.header.add($.__views.__alloyId950);
    $.__views.tripType = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId950.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#fff",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        width: "72%",
        id: "destination"
    });
    $.__views.__alloyId950.add($.__views.destination);
    $.__views.__alloyId951 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId951"
    });
    $.__views.header.add($.__views.__alloyId951);
    $.__views.profileContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "profileContainer"
    });
    $.__views.__alloyId948.add($.__views.profileContainer);
    $.__views.__alloyId952 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId952"
    });
    $.__views.__alloyId948.add($.__views.__alloyId952);
    $.__views.__alloyId953 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "__alloyId953"
    });
    $.__views.__alloyId948.add($.__views.__alloyId953);
    $.__views.btnChangeDetail = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnChangeDetail"
    });
    $.__views.__alloyId953.add($.__views.btnChangeDetail);
    $.__views.__alloyId954 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId954"
    });
    $.__views.btnChangeDetail.add($.__views.__alloyId954);
    $.__views.__alloyId955 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId955"
    });
    $.__views.__alloyId954.add($.__views.__alloyId955);
    $.__views.btnFirstLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_trip_edit_trip"),
        id: "btnFirstLabel"
    });
    $.__views.__alloyId955.add($.__views.btnFirstLabel);
    $.__views.btnViewMap = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        right: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnViewMap"
    });
    $.__views.__alloyId953.add($.__views.btnViewMap);
    $.__views.__alloyId956 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId956"
    });
    $.__views.btnViewMap.add($.__views.__alloyId956);
    $.__views.__alloyId957 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId957"
    });
    $.__views.__alloyId956.add($.__views.__alloyId957);
    $.__views.btnSecondLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_booking_view_map"),
        id: "btnSecondLabel"
    });
    $.__views.__alloyId957.add($.__views.btnSecondLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), utils = require("utils/utils"), args = arguments[0] || {}, samanthaService = require("services/samantha_service"), samantha = args.samantha;
    exports = new (require(WPATH("cardTemplate")).extend($, {
        samantha: samantha,
        cardName: "tripBookings",
        customAnimation: false,
        _bookings: null,
        _trip: null,
        _rows: [],
        _isEditing: false,
        _newBookingBuddies: [],
        _rowsToRemove: [],
        _rowsToAdd: [],
        _rowsToUpdate: [],
        _rowsToPop: [],
        _cancelCount: 0,
        opening: false,
        initialized: false,
        events: {
            "click btnViewMap": "_rightButtonEvent",
            "click btnChangeDetail": "_changeDetail"
        },
        configure: function() {
            _.bindAll(this, "_rowAction", "_nextBookingPop", "_cancelTripEvent", "_editEvent", "_editTripAction");
            samantha.on("tripBookings.toggle.editing", this._cancelTripEvent);
        },
        _changeDetail: function(e) {
            if (this.opening) return;
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            if (this._isRiderTrip()) {
                var buttons = [ L("widget_samantha_booking_cancel_trip_warning_no"), L("widget_samantha_booking_cancel_trip_warning_yes") ], cancelIndex = 0, self = this;
                buttons = [ L("widget_samantha_booking_cancel_trip_warning_yes"), L("widget_samantha_booking_cancel_trip_warning_no") ];
                cancelIndex = 1;
                var buddyName = this._bookings[0].buddy.firstName;
                var dialog = Ti.UI.createAlertDialog({
                    cancel: cancelIndex,
                    buttonNames: buttons,
                    title: L("widget_samantha_booking_cancel_trip_warning_title"),
                    message: String.format(L("widget_samantha_booking_cancel_trip_warning_message"), buddyName)
                });
                dialog.addEventListener("click", function(e) {
                    e.index !== cancelIndex && self._cancelTripEvent();
                });
                dialog.show();
            } else this._editEvent();
        },
        _editEvent: function() {
            var opts = {};
            if (this._bookings.length > 2) {
                var cancel1 = String.format(L("widget_samantha_cancel_trip_with"), this._bookings[0].buddy.firstName);
                var cancel2 = String.format(L("widget_samantha_cancel_trip_with"), this._bookings[1].buddy.firstName);
                var cancel3 = String.format(L("widget_samantha_cancel_trip_with"), this._bookings[2].buddy.firstName);
                opts.options = [ L("widget_decision_edittrip_delay5"), L("widget_decision_edittrip_delay15"), L("widget_decision_edittrip_delay60"), cancel1, cancel2, cancel3, L("widget_samantha_cancel_entire_trip") ];
                opts.cancel = -1;
            } else if (this._bookings.length > 1) {
                var cancel1 = String.format(L("widget_samantha_cancel_trip_with"), this._bookings[0].buddy.firstName);
                var cancel2 = String.format(L("widget_samantha_cancel_trip_with"), this._bookings[1].buddy.firstName);
                opts.options = [ L("widget_decision_edittrip_delay5"), L("widget_decision_edittrip_delay15"), L("widget_decision_edittrip_delay60"), cancel1, cancel2, L("widget_samantha_cancel_entire_trip") ];
                opts.cancel = -1;
            } else {
                opts.options = [ L("widget_decision_edittrip_delay5"), L("widget_decision_edittrip_delay15"), L("widget_decision_edittrip_delay60"), L("widget_decision_edittrip_cancel_trip") ];
                opts.cancel = -1;
            }
            var editTripDialog = Ti.UI.createOptionDialog(opts);
            editTripDialog.addEventListener("click", this._editTripAction);
            editTripDialog.show();
        },
        _editTripAction: function(params) {
            switch (params.index) {
              case 0:
                this._deviateCurrentTrip(this._trip, 5);
                break;

              case 1:
                this._deviateCurrentTrip(this._trip, 15);
                break;

              case 2:
                this._deviateCurrentTrip(this._trip, 60);
                break;

              case 3:
                if (this._bookings.length > 0) {
                    var buddy = this._bookings[0].buddy, bookingId = this._bookings[0].id;
                    this._cancelBookingConfirm(bookingId, buddy);
                }
                break;

              case 4:
                if (this._bookings.length > 1) {
                    var buddy = this._bookings[1].buddy, bookingId = this._bookings[1].id;
                    this._cancelBookingConfirm(bookingId, buddy);
                }
                break;

              case 5:
                if (this._bookings.length > 2) {
                    var buddy = this._bookings[1].buddy, bookingId = this._bookings[1].id;
                    this._cancelBookingConfirm(bookingId, buddy);
                } else this._cancelAllBookingsConfirm();
                break;

              case 6:
                this._bookings.length > 2 && this._cancelAllBookingsConfirm();
            }
        },
        _cancelAllBookingsConfirm: function() {
            var buttons = [ L("widget_samantha_booking_cancel_trip_warning_no"), L("widget_samantha_booking_cancel_trip_warning_yes") ], cancelIndex = 0, self = this;
            buttons = [ L("widget_samantha_booking_cancel_trip_warning_yes"), L("widget_samantha_booking_cancel_trip_warning_no") ];
            cancelIndex = 1;
            var buddyName = "";
            this._bookings.length > 2 ? buddyName = this._bookings[0].buddy.firstName + ", " + this._bookings[1].buddy.firstName + " " + L("widget_home_msg_and") + " " + this._bookings[2].buddy.firstName : this._bookings.length > 1 && (buddyName = this._bookings[0].buddy.firstName + " " + L("widget_home_msg_and") + " " + this._bookings[1].buddy.firstName);
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                title: L("widget_samantha_booking_cancel_trip_warning_title"),
                message: String.format(L("widget_samantha_booking_cancel_trip_warning_message"), buddyName)
            });
            dialog.addEventListener("click", function(e) {
                if (e.index !== cancelIndex) for (var i = 0; i < self._bookings.length; i++) self._cancelBooking(self._bookings[i].id, self._bookings[i].buddy);
            });
            dialog.show();
        },
        _cancelBookingConfirm: function(bookingId, buddy) {
            var buttons = [ L("widget_samantha_booking_cancel_trip_warning_no"), L("widget_samantha_booking_cancel_trip_warning_yes") ], cancelIndex = 0, self = this;
            buttons = [ L("widget_samantha_booking_cancel_trip_warning_yes"), L("widget_samantha_booking_cancel_trip_warning_no") ];
            cancelIndex = 1;
            var buddyName = buddy.firstName;
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                title: L("widget_samantha_booking_cancel_trip_warning_title"),
                message: String.format(L("widget_samantha_booking_cancel_trip_warning_message"), buddyName)
            });
            dialog.addEventListener("click", function(e) {
                e.index !== cancelIndex && self._cancelBooking(bookingId, buddy);
            });
            dialog.show();
        },
        _deviateCurrentTrip: function(trip, deviationMins) {
            Alloy.createModel("trip_deviation").deviate(trip.id, trip.schedule.baseEffectiveTime, deviationMins).then(function(data) {
                Ti.App.fireEvent("app.carma.profile.change");
            }).catch(function(e) {
                LOGGER.error("[samantha] - deviateCurrentTrip: " + JSON.stringify(e));
                samantha.whisper("samantha.show.ErrorDialog", _.extend({
                    action: "USER_TRIP_DEVIATION"
                }, e));
            }).finally(function() {
                TM.push(function() {
                    analytics.track(trackingEvent.SAMANTHA_DEVIATE_TRIP, {
                        minutes: deviationMins,
                        tripId: trip.id
                    });
                }, process.backgroundDomain);
            }).done();
        },
        _openMapEvent: function() {
            if (this.opening) return;
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            var buddies = [];
            _.each(this._bookings, function(booking) {
                buddies.push(_.extend({}, booking.buddy));
            });
            samantha.whisper("samantha.open.map", {
                trip: this._trip,
                buddies: buddies
            });
        },
        _isRiderTrip: function() {
            var bookings = this._bookings, myUserId = require("services/resource_owner_service").singleton().get("userId");
            if (1 === bookings.length) {
                var booking = bookings[0];
                if (booking.driver.userId !== myUserId) return true;
            }
            return false;
        },
        _cancelTripEvent: function(e) {
            if (this._bookings.length > 1) this._toggleEditing(true); else if (this._bookings.length > 0) {
                var buddy = this._bookings[0].buddy, bookingId = this._bookings[0].id;
                this._cancelBooking(bookingId, buddy);
            }
        },
        _rightButtonEvent: function(e) {
            this._isEditing ? this._toggleEditing(false) : this._openMapEvent();
        },
        _openMessage: function(targetUserId, alias) {
            var userId = require("services/resource_owner_service").singleton().get("userId"), threadId = targetUserId > userId ? targetUserId + "_" + userId : userId + "_" + targetUserId;
            targetUserId !== userId && Ti.App.fireEvent("carma:open.conversation", {
                threadId: threadId,
                alias: alias
            });
        },
        _cancelBooking: function(bookingId, buddy, button) {
            var self = this;
            require("services/booking_service").decline(bookingId, buddy.firstName).then(function() {
                samantha.setLastMatchUserName(buddy.firstName);
                self._cancelCount++;
                if (self._cancelCount >= self._bookings.length) samantha.whisper("samantha.cancel.trip", {
                    trip: self._trip
                }); else {
                    Ti.App.fireEvent("carma:booking.changed");
                    var Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService");
                    bookingService.emit(bookingService.BOOKING_UPDATED);
                }
            }).catch(function(e) {
                samantha.whisper("samantha.show.ErrorDialog", _.extend({
                    action: "USER_RIDE_BOOKING_CANCEL"
                }, e));
            }).finally(function() {
                button && button.stopIndicator && button.stopIndicator();
            });
        },
        _rowAction: function(buddy, isDriver, button) {
            if (this._isEditing) {
                if (buddy.bookingId) {
                    this._cancelBooking(buddy.bookingId, buddy, button);
                    return;
                }
            } else {
                var myUserId = require("services/resource_owner_service").singleton().get("userId");
                myUserId !== buddy.userId && this._openMessage(buddy.userId, buddy.alias);
            }
            button && button.stopIndicator && setTimeout(function() {
                button.stopIndicator();
            }, 300);
        },
        prepareView: function(options) {
            var bookings = this._bookings, trip = options.trip, bookedTrip = bookings[0] && bookings[0].trip && bookings[0].trip.baseTrip || null, availableScreenHeight = options.availableScreenHeight;
            if (!trip || !bookedTrip) throw new Error("no booking trip found!");
            var showBookedTrip = false;
            for (var i = 0; i < bookings.length; i++) "ACCEPTED" === bookings[i].state && (showBookedTrip = true);
            if (showBookedTrip) {
                var dateMoment = moment(bookedTrip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
                $.date.text = dateMoment.format("Do MMM");
                $.tripTime.setText(dateTime);
                $.tripType.setText(L("widget_decision_samantha_" + trip.type));
                $.origin.setText(bookedTrip.origin.address);
                $.destination.setText(String.format(L("widget_decision_samantha_destination"), bookedTrip.destination.address));
                $.btnViewMap.visible = true;
                $.btnChangeDetail.applyProperties({
                    width: "48%"
                });
            } else {
                var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
                $.date.text = dateMoment.format("Do MMM");
                $.tripTime.setText(dateTime);
                $.tripType.setText(L("widget_decision_samantha_" + trip.type));
                $.origin.setText(trip.origin.alias && trip.origin.alias.length > 0 ? trip.origin.alias : trip.origin.address);
                var des = trip.destination.alias && trip.destination.alias.length > 0 ? trip.destination.alias : trip.destination.address;
                $.destination.setText(String.format(L("widget_decision_samantha_destination"), des));
                $.btnViewMap.visible = false;
                $.btnChangeDetail.applyProperties({
                    width: "100%"
                });
            }
            $.profileContainer.removeAllChildren();
            var userProfile = require("services/resource_owner_service").singleton().toJSON();
            var profiles = [];
            if (bookings.length > 1) {
                userProfile.isDriver = true;
                profiles.push(userProfile);
                _.each(bookings, function(booking, index) {
                    "ACCEPTED" !== booking.state && (booking.buddy.waitingForResponse = true);
                    booking.buddy.bookingId = booking.id;
                    booking.buddy.isDriver = booking.driver.userId === booking.buddy.userId;
                    profiles.push(booking.buddy);
                });
            } else {
                var _driver = bookings[0].driver, _rider = bookings[0].rider;
                "ACCEPTED" !== bookings[0].state && (_driver.userId === userProfile.userId ? _rider.waitingForResponse = true : _driver.waitingForResponse = true);
                _driver.userId === userProfile.userId ? _rider.bookingId = bookings[0].id : _driver.bookingId = bookings[0].id;
                _rider.isDriver = false;
                _driver.isDriver = true;
                profiles.push(_driver);
                profiles.push(_rider);
            }
            $.profileContainer.height = 60 * profiles.length + "dp";
            var self = this;
            this._rows = [];
            _.each(profiles, function(profile) {
                self._addProfileInfo(profile, profile.isDriver);
            });
            $.btnFirstLabel.setText(L(this._isRiderTrip() ? "widget_btn_cancel_booking_button" : "widget_samantha_trip_edit_trip"));
            _.each(bookings, function(booking) {
                var bookingRow = _.find(self._rows, function(row) {
                    return row.profile.userId === booking.buddy.userId;
                });
                if (bookingRow) {
                    console.log(booking.id + " isBookingPop:" + samanthaService.isBookingPop(booking.id));
                    if (!samanthaService.isBookingPop(booking.id) && "ACCEPTED" === booking.state) {
                        samanthaService.markBookingAsPop(booking.id, booking.trip.baseTrip.schedule.baseEffectiveTime);
                        self._rowsToPop.push(bookingRow);
                    }
                }
            });
            this._nextBookingPop();
        },
        _addProfileInfo: function(buddy, isDriver) {
            if (!buddy) return;
            var profileRow = {}, myUserId = require("services/resource_owner_service").singleton().get("userId"), state = L(isDriver ? "mode_driver" : "mode_rider");
            myUserId !== buddy.userId && (state = L(isDriver ? "widget_samantha_booking_confirmed_driver" : "widget_samantha_booking_confirmed_rider"));
            buddy.waitingForResponse && (state = L("widget_samantha_booking_waiting_response"));
            if (!buddy.waitingForResponse && myUserId !== buddy.userId) {
                $.lblTitle.text = L("widget_samantha_carpool_cofirmed_title");
                samantha.setTripMatchFound(true);
            }
            buddy.hideStatus = true;
            buddy.disableProfile = true;
            var container = Ti.UI.createView(), profile = require("/ui/common/profile").createView({
                user: _.extend({}, buddy, {
                    layout: "circular-small"
                })
            }), info = Ti.UI.createView(), lblName = Ti.UI.createLabel(), lblState = Ti.UI.createLabel({
                text: state
            }), actionStylePros = $.createStyle({
                classes: "action",
                apiName: "Button",
                title: L("widget_samantha_booking_message"),
                indicator: false,
                disableAnimation: true
            }), action = require("/ui/common/custom_button").createButton(actionStylePros), border = Ti.UI.createView();
            $.addClass(container, "profileInfo");
            $.addClass(profile, "picture");
            $.addClass(info, "info");
            $.addClass(lblName, "lbl-medium-bold name carmaTextColour");
            $.addClass(lblState, "lbl-small role carmaTextColour");
            $.addClass(border, "bottomBorder");
            container.add(profile);
            info.add(lblName);
            info.add(lblState);
            container.add(info);
            myUserId !== buddy.userId && container.add(action);
            container.add(border);
            this._isEditing && buddy.bookingId && action.setStyle($.createStyle({
                classes: "cancel-action",
                apiName: "Button"
            }));
            if (buddy.waitingForResponse) {
                var cover = Ti.UI.createView({
                    top: 0,
                    left: 0,
                    width: Ti.UI.FILL,
                    height: Ti.UI.FILL,
                    backgroundColor: "#ccc",
                    opacity: .3,
                    touchEnabled: false
                });
                container.add(cover);
                cover = null;
            }
            container.addEventListener("click", function(e) {
                Ti.App.fireEvent("carma:profile.open", {
                    userId: buddy.userId
                });
            });
            var self = this;
            action.addEventListener("click", function(e) {
                self._rowAction(buddy, isDriver, profileRow.action);
            });
            profile.imageView.applyProperties({
                left: 0
            });
            lblName.setText(buddy.alias);
            profileRow.state = lblState;
            profileRow.action = action;
            profileRow.profile = buddy;
            this._rows.push(profileRow);
            $.profileContainer.add(container);
            info = null;
            lblName = null;
            lblState = null;
            profile = null;
            action = null;
            actionStylePros = null;
            container = null;
        },
        _toggleEditing: function(toggle) {
            this._isEditing = toggle;
            if (this._isEditing) {
                _.each(this._rows, function(row) {
                    row.action && (row.profile.bookingId ? row.action.setStyle($.createStyle({
                        classes: "cancel-action",
                        apiName: "Button"
                    })) : row.action.hide());
                });
                $.resetClass($.btnSecondLabel, "col-auto-size lbl-medium-bold white", {
                    text: L("widget_samantha_booking_button_done")
                });
                $.btnViewMap.setStyle($.createStyle({
                    classes: "btn-carma-card-orange btn-transparent right",
                    apiName: "Button"
                }));
            } else {
                _.each(this._rows, function(row, index) {
                    if (row.action) {
                        row.action.setStyle($.createStyle({
                            classes: "message-action",
                            apiName: "Button"
                        }));
                        row.action.show();
                    }
                });
                $.resetClass($.btnSecondLabel, "col-auto-size lbl-medium-bold carmaButtonTextColour", {
                    text: L("widget_samantha_booking_view_map")
                });
                $.btnViewMap.setStyle($.createStyle({
                    classes: "btn-carma-card btn-transparent right",
                    apiName: "Button"
                }));
            }
            $.btnViewMap.touchEnabled = true;
        },
        _nextBookingPop: function() {
            if (this._rowsToPop && this._rowsToPop.length > 0) {
                var bookingRow = this._rowsToPop.shift();
                bookingRow && bookingRow.profile && this._newBookingPop(bookingRow.profile);
            }
        },
        _newBookingPop: function(profile) {
            $.lblTitle.text = L("widget_samantha_carpool_cofirmed_title");
            var tripMatchPop = Alloy.createWidget("ma.car.app.samantha", "tripMatchPop", {
                profile: profile,
                isDriver: profile.isDriver,
                samantha: samantha
            });
            tripMatchPop.on("dismiss", this._nextBookingPop);
            samantha.addPopUp(tripMatchPop);
            samantha.setTripMatchFound(true);
        },
        _reorderBookings: function(bookings, requests) {
            var reorderedBookings = bookings.slice(0);
            _.each(requests, function(request) {
                reorderedBookings.push(request);
            });
            return reorderedBookings;
        },
        display: function(options, callback) {
            if (!options.bookings || options.bookings.length < 1 && options.requests.length < 1 || !options.trip) return;
            if (!this.initialized) {
                $.layoutContainer.hide();
                this.initialized = true;
            }
            $.layoutContainer.touchEnabled = false;
            var requests = options.requests || [];
            this._bookings = this._reorderBookings(options.bookings, requests);
            this._trip = options.trip;
            this.prepareView(options);
            setTimeout(function() {
                callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
                $.layoutContainer.touchEnabled = true;
            }, 300);
        },
        cleanUp: function() {
            samantha.off("tripBookings.toggle.editing", this._cancelTripEvent);
        },
        delayTripTime: function(deviationMins) {
            if ("DRIVE" === trip.type) {
                this._trip.schedule.effectiveTime += 60 * deviationMins * 1e3;
                var dateTime = i18n.formatTime(moment(this._trip.schedule.effectiveTime));
                $.tripTime.setText(dateTime);
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;