function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripRequest";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        font: {
            fontSize: "12dp"
        },
        layout: "vertical",
        height: Ti.UI.SIZE,
        visible: "false",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_your_next_trip_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.myTripBriefContainer = Ti.UI.createView({
        backgroundColor: "#003333",
        height: Ti.UI.SIZE,
        layout: "vertical",
        top: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "myTripBriefContainer"
    });
    $.__views.layoutContainer.add($.__views.myTripBriefContainer);
    $.__views.date = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.myTripBriefContainer.add($.__views.date);
    $.__views.__alloyId975 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId975"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId975);
    $.__views.tripTime = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId975.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#fff",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        width: "72%",
        id: "origin"
    });
    $.__views.__alloyId975.add($.__views.origin);
    $.__views.__alloyId976 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId976"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId976);
    $.__views.tripType = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId976.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#fff",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        width: "72%",
        id: "destination"
    });
    $.__views.__alloyId976.add($.__views.destination);
    $.__views.__alloyId977 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId977"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId977);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, i18n = require("i18n/i18n"), samantha = args.samantha, Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService");
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "tripRequest",
        customAnimation: false,
        _openPopup: false,
        waitUntilReady: true,
        _trip: null,
        _tripRequest: null,
        _type: null,
        prepareView: function(options) {
            if (!this._openPopup) {
                this._openPopup = true;
                this._openMatchPopup(options);
            }
            var trip = options.trip, dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.date.text = moment(trip.schedule.effectiveTime).format("Do MMM");
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.alias && trip.origin.alias.length > 0 ? trip.origin.alias : trip.origin.address);
            var des = trip.destination.alias && trip.destination.alias.length > 0 ? trip.destination.alias : trip.destination.address;
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), des));
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._type = options.type;
            this._trip = options.trip;
            this._tripRequest = "driver" === this._type ? options.bookings[0] : options.booking;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
        },
        disappear: function(callback) {
            $.layoutContainer.hide();
            samantha.removeCard(this.cardName);
            callback && _.isFunction(callback) && callback();
        },
        _openMatchPopup: function(options) {
            options.samanthaCard = this;
            options.samantha = samantha;
            var popUpWidget = Alloy.createWidget("ma.car.app.samantha", "newMatchFoundPop", options);
            samantha.addPopUp(popUpWidget);
        },
        _declineBooking: function() {
            var self = this;
            if ("driver" === this._type) samantha.whisper("samantha.deny.booking", {
                booking: this._tripRequest,
                callback: function() {
                    self._openPopup = false;
                    samantha.checkPopUps();
                }
            }); else {
                var requestor = this._tripRequest[this._tripRequest.initiator.toLowerCase()];
                require("/services/samantha_service").declineBooking(this._tripRequest.id, requestor.alias).then(function() {
                    self._openPopup = false;
                    samantha.checkPopUps();
                    Ti.App.fireEvent("carma:booking.changed");
                    bookingService.emit(bookingService.BOOKING_UPDATED);
                }).catch(function(e) {
                    self._openPopup = false;
                    samantha.checkPopUps();
                    samantha.whisper("samantha.show.ErrorDialog", _.extend({
                        action: "USER_RIDE_BOOKING_CANCEL"
                    }, e));
                });
                TM.push(function() {
                    analytics.track(trackingEvent.SAMANTHA_TRIP_REQUEST_DENIED_BY_RIDER, {
                        bookingId: self._booking.id
                    });
                }, process.backgroundDomain);
            }
        },
        _acceptBooking: function() {
            var self = this;
            if ("driver" === this._type) samantha.whisper("samantha.accept.booking", {
                booking: this._tripRequest,
                confirmTrip: true,
                trip: this._trip,
                callback: function() {
                    self._openPopup = false;
                    samantha.checkPopUps();
                }
            }); else {
                var requestor = this._tripRequest[this._tripRequest.initiator.toLowerCase()], myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = this._tripRequest.rider.userId === myUserId ? this._tripRequest.driver : this._tripRequest.rider;
                require("/services/samantha_service").acceptBooking(this._tripRequest.id, requestor.alias).then(function() {
                    self._openPopup = false;
                    samantha.checkPopUps();
                    Ti.App.fireEvent("carma:booking.changed");
                    bookingService.emit(bookingService.BOOKING_UPDATED);
                }).catch(function(e) {
                    self._openPopup = false;
                    samantha.checkPopUps();
                    samantha.whisper("samantha.show.ErrorDialog", _.extend({
                        action: "USER_RIDE_BOOKING_CANCEL"
                    }, e));
                });
            }
        },
        _tripMatchPop: function(profile, isDriver) {
            var popUpWidget = Alloy.createWidget("ma.car.app.samantha", "tripMatchPop", {
                profile: profile,
                isDriver: isDriver,
                samantha: samantha
            });
            samantha.addPopUp(popUpWidget);
            samantha.setTripMatchFound(true);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;