function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripsDisabled";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        visible: "false",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_tripdisabled_title1"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layout.add($.__views.lblTitle);
    $.__views.layoutContainer = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundColor: "#fff",
        id: "layoutContainer"
    });
    $.__views.layout.add($.__views.layoutContainer);
    $.__views.__alloyId985 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId985"
    });
    $.__views.layoutContainer.add($.__views.__alloyId985);
    $.__views.__alloyId986 = Ti.UI.createImageView({
        defaultImage: "/images/tripsdisabled.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/tripsdisabled.png",
        id: "__alloyId986"
    });
    $.__views.__alloyId985.add($.__views.__alloyId986);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        backgroundColor: "#fff",
        id: "layoutInner"
    });
    $.__views.layoutContainer.add($.__views.layoutInner);
    $.__views.__alloyId987 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId987"
    });
    $.__views.layoutInner.add($.__views.__alloyId987);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_tripdisabled_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId987.add($.__views.labelTitle);
    $.__views.__alloyId988 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId988"
    });
    $.__views.layoutInner.add($.__views.__alloyId988);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_tripdisabled_message"),
        id: "labelMessage"
    });
    $.__views.__alloyId988.add($.__views.labelMessage);
    $.__views.__alloyId989 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId989"
    });
    $.__views.layoutInner.add($.__views.__alloyId989);
    $.__views.btn = require("/ui/common/custom_button").createButton({
        width: Ti.UI.FILL,
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btn",
        indicator: "true"
    });
    $.__views.__alloyId989.add($.__views.btn);
    $.__views.__alloyId990 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId990"
    });
    $.__views.btn.add($.__views.__alloyId990);
    $.__views.__alloyId991 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId991"
    });
    $.__views.__alloyId990.add($.__views.__alloyId991);
    $.__views.btnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_tripdisabled_btn"),
        id: "btnLabel"
    });
    $.__views.__alloyId991.add($.__views.btnLabel);
    $.__views.__alloyId992 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId992"
    });
    $.__views.layoutInner.add($.__views.__alloyId992);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var MessageController = require(WPATH("messageControllerBuilder")), args = arguments[0] || {}, samantha = args.samantha;
    exports = MessageController.create($, samantha, "tripsDisabled");
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;