function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.shell/" + s : s.substring(0, index) + "/ma.car.app.shell/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.shell");
    this.__widgetId = "ma.car.app.shell";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.widget = Ti.UI.createView({
        id: "widget"
    });
    $.__views.widget && $.addTopLevelView($.__views.widget);
    $.__views.shell = Alloy.createWidget("ma.car.app.webview", "widget", {
        id: "shell",
        __parentSymbol: $.__views.widget
    });
    $.__views.shell.setParent($.__views.widget);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var webview = $.shell.webview;
    var bridge = require(WPATH("/bridge"));
    var bridge_manager = require("bridge/bridge_manager");
    var args = arguments[0] || {};
    bridge.init(webview);
    bridge_manager.init(webview);
    var _open = function() {
        var url = require("bootstrap/env").getNativeWrapperUrl();
        var resourceOwner = require("services/resource_owner_service").singleton();
        resourceOwner.has("userId") && resourceOwner.has("token") && (url += "?id=" + resourceOwner.get("userId") + "&token=" + resourceOwner.get("token").token + "&path=" + encodeURIComponent(args.path));
        $.shell.openURL(url);
    };
    var _openPath = function(path) {
        var _webview = webview;
        if (0 === path.indexOf("#")) {
            _webview.native2web("(function(path){ window.location.hash = path;})", [ path ]);
            return;
        }
        0 !== path.indexOf("/") && (path = "/" + path);
        var url = require("bootstrap/env").getWebHybridURL();
        _webview.native2web("(function(url){ window.location = url;})", [ url + path ]);
        _webview = null;
    };
    webview.openPath = function(path) {
        _openPath(path);
    };
    _open();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;