function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.signup/" + s : s.substring(0, index) + "/ma.car.app.signup/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.signup");
    this.__widgetId = "ma.car.app.signup";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "signup";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.signupContainer = Ti.UI.createScrollView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: "5dp",
        id: "signupContainer"
    });
    $.__views.signupContainer && $.addTopLevelView($.__views.signupContainer);
    $.__views.__alloyId26 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId26"
    });
    $.__views.signupContainer.add($.__views.__alloyId26);
    $.__views.signupView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: Alloy.Globals.Style.Size.Width.pct4,
        layout: "vertical",
        height: "570dp",
        id: "signupView"
    });
    $.__views.signupContainer.add($.__views.signupView);
    $.__views.__alloyId27 = Ti.UI.createView({
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "__alloyId27"
    });
    $.__views.signupView.add($.__views.__alloyId27);
    $.__views.firstName = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: 0,
        left: 0,
        hintText: L("widget_signup_input_hint_first_name"),
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "firstName"
    });
    $.__views.__alloyId27.add($.__views.firstName);
    $.__views.__alloyId28 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#c8c7cd",
        id: "__alloyId28"
    });
    $.__views.__alloyId27.add($.__views.__alloyId28);
    $.__views.lastName = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: 0,
        left: 0,
        hintText: L("widget_signup_input_hint_last_name"),
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "lastName"
    });
    $.__views.__alloyId27.add($.__views.lastName);
    $.__views.__alloyId29 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#c8c7cd",
        id: "__alloyId29"
    });
    $.__views.__alloyId27.add($.__views.__alloyId29);
    $.__views.genderWrapper = Ti.UI.createView({
        width: "100%",
        top: 0,
        left: 0,
        borderRadius: 0,
        height: "60dp",
        backgroundColor: "#fff",
        id: "genderWrapper"
    });
    $.__views.__alloyId27.add($.__views.genderWrapper);
    $.__views.gender = require("/ui/common/custom_label").createLabel({
        color: "#666",
        left: "10dp",
        height: "60dp",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        hintText: L("widget_signup_input_hint_gender"),
        id: "gender"
    });
    $.__views.genderWrapper.add($.__views.gender);
    $.__views.genderHint = Ti.UI.createLabel({
        color: "#ccc",
        left: "10dp",
        height: "60dp",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        text: L("widget_signup_input_hint_gender"),
        id: "genderHint"
    });
    $.__views.genderWrapper.add($.__views.genderHint);
    $.__views.__alloyId30 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#c8c7cd",
        id: "__alloyId30"
    });
    $.__views.__alloyId27.add($.__views.__alloyId30);
    $.__views.wgtPhoneWrapper = Ti.UI.createView({
        top: 0,
        height: "60dp",
        backgroundColor: "#111",
        id: "wgtPhoneWrapper"
    });
    $.__views.__alloyId27.add($.__views.wgtPhoneWrapper);
    $.__views.wgtPhone = Alloy.createWidget("ma.car.app.common.phone", "widget", {
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "wgtPhone",
        __parentSymbol: $.__views.wgtPhoneWrapper
    });
    $.__views.wgtPhone.setParent($.__views.wgtPhoneWrapper);
    $.__views.whyPhoneNumberPlaceholder = Ti.UI.createView({
        height: "48dp",
        width: Ti.UI.FILL,
        id: "whyPhoneNumberPlaceholder"
    });
    $.__views.signupView.add($.__views.whyPhoneNumberPlaceholder);
    $.__views.whyPhoneNumber = Ti.UI.createLabel({
        color: "#003366",
        font: {
            fontSize: "12dp"
        },
        right: 0,
        text: L("widget_signup_popup_link_why_phone_number"),
        id: "whyPhoneNumber"
    });
    $.__views.whyPhoneNumberPlaceholder.add($.__views.whyPhoneNumber);
    $.__views.__alloyId31 = Ti.UI.createView({
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "__alloyId31"
    });
    $.__views.signupView.add($.__views.__alloyId31);
    $.__views.email = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: 0,
        left: 0,
        hintText: L("widget_signup_input_hint_email"),
        keyboardType: Ti.UI.KEYBOARD_EMAIL,
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "email"
    });
    $.__views.__alloyId31.add($.__views.email);
    $.__views.__alloyId32 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#c8c7cd",
        id: "__alloyId32"
    });
    $.__views.__alloyId31.add($.__views.__alloyId32);
    $.__views.password = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: 0,
        left: 0,
        hintText: L("widget_signup_input_hint_password"),
        passwordMask: true,
        returnKeyType: Titanium.UI.RETURNKEY_NEXT,
        id: "password"
    });
    $.__views.__alloyId31.add($.__views.password);
    $.__views.showPasswordContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "50dp",
        id: "showPasswordContainer"
    });
    $.__views.signupView.add($.__views.showPasswordContainer);
    $.__views.showPassword = Ti.UI.createLabel({
        color: "#fff",
        top: "10dp",
        left: 0,
        width: "20dp",
        height: "20dp",
        zIndex: 3,
        backgroundColor: "transparent",
        borderColor: "#fff",
        borderWidth: "2dp",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "showPassword"
    });
    $.__views.showPasswordContainer.add($.__views.showPassword);
    $.__views.showPasswordTicker = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontFamily: "splinico",
            fontSize: "14dp"
        },
        text: "c",
        visible: false,
        top: "10dp",
        left: "3dp",
        width: "20dp",
        height: "20dp",
        zIndex: 5,
        id: "showPasswordTicker"
    });
    $.__views.showPasswordContainer.add($.__views.showPasswordTicker);
    $.__views.showPasswordHint = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "12dp"
        },
        top: "13dp",
        left: "30dp",
        width: Alloy.Globals.Style.Size.Width.pct70,
        text: L("widget_signup_checkbox_show_password"),
        id: "showPasswordHint"
    });
    $.__views.showPasswordContainer.add($.__views.showPasswordHint);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        width: "100%",
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: 0,
        left: 0,
        title: L("widget_signup_button_submit"),
        id: "submit"
    });
    $.__views.signupView.add($.__views.submit);
    $.__views.genderDialog = Ti.UI.createOptionDialog({
        title: L("widget_signup_input_hint_gender"),
        options: [ L("widget_signup_gender_other"), L("widget_signup_gender_female"), L("widget_signup_gender_male") ],
        id: "genderDialog"
    });
    $.__views.genderDialog && $.addTopLevelView($.__views.genderDialog);
    $.__views.whyPhoneNumberPopup = Ti.UI.createAlertDialog({
        title: L("widget_signup_popup_title_why_phone_number"),
        message: L("widget_signup_popup_message_why_phone_number"),
        id: "whyPhoneNumberPopup"
    });
    $.__views.whyPhoneNumberPopup && $.addTopLevelView($.__views.whyPhoneNumberPopup);
    $.__views.phoneNumberConfirmPopup = Ti.UI.createAlertDialog({
        title: L("widget_signup_popup_title_phone_number_confirm"),
        buttonNames: [ L("widget_signup_popup_edit_phone_number_confirm"), L("widget_signup_popup_yes_phone_number_confirm") ],
        id: "phoneNumberConfirmPopup"
    });
    $.__views.phoneNumberConfirmPopup && $.addTopLevelView($.__views.phoneNumberConfirmPopup);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), FieldsRoller = require("/ui/common/fields_roller"), PasswordToggle = require("/ui/common/password_toggle"), ErrorDialog = require("/ui/common/validation_error"), Validator = require("/validator/validator_factory"), URL = require("/carmalib/url"), countries = require("utils/countries"), PhoneNumberFormatter = require("/vendor/phone_format"), trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), link = require("/ui/link"), phoneNumberModule = null;
    var Globals = require("/v6/infrastructure/Globals"), LoggingService = Globals.IOC.get("LoggingService");
    phoneNumberModule = require("ma.car.module.phone.number");
    exports = new (require("/carmalib/controller").extend($, {
        _signupRequest: null,
        _needToShowErrorDialog: false,
        events: {
            "click[ios] genderWrapper": "_showGenderOptionDialog",
            "click[android] genderWrapper": "_showGenderOptionDialog",
            "click[ios] whyPhoneNumber": "_showWhyPhoneNumberAlert",
            "click[android] whyPhoneNumber": "_showWhyPhoneNumberAlert",
            "click genderDialog": "_selectGender",
            "click[ios] submit": "_validateSignup",
            "click[android] submit": "_validateSignup",
            "return password": "_validateSignup",
            "click phoneNumberConfirmPopup": "_confirmPhoneNumber",
            "click showPasswordContainer": "_trackShowPassword"
        },
        initialize: function() {
            _.bindAll(this, "_signup", "_signupSuccess", "_getOAuthToken", "_signupError", "_stopSpinner", "_showGenderOptionDialog");
            this._setupFieldsRoller();
            this._setupPasswordToggle();
            this._populatePhoneNumber();
            this._signupRequest = Alloy.createModel("signup");
            var _window = require("utils/ui").getWindow($.signupContainer);
            _window.addEventListener("postlayout", function onPostLayout() {
                _window.removeEventListener("postlayout", onPostLayout);
                link.makeUnderlinedLink($.whyPhoneNumber);
            });
        },
        configure: function() {
            var aop = require("/vendor/meld");
            aop.after(this, "_signupSuccess", function() {
                analytics.track(trackingEvent.SIGNUP);
            });
            aop.after(this, "_showWhyPhoneNumberAlert", function() {
                analytics.track(trackingEvent.SIGNUP_WHY_ENTER_PHONE_NUMBER);
            });
        },
        _setupFieldsRoller: function() {
            new FieldsRoller([ {
                from: $.firstName,
                to: $.lastName
            }, {
                from: $.lastName,
                to: $.gender,
                next: this._showGenderOptionDialog
            }, {
                from: $.wgtPhone.txtNumber,
                to: $.email
            }, {
                from: $.email,
                to: $.password
            } ]);
        },
        _setupPasswordToggle: function() {
            new PasswordToggle($.showPasswordContainer, $.password, $.showPassword, $.showPasswordTicker);
        },
        _populatePhoneNumber: function() {
            if (!phoneNumberModule) return;
            var phoneNumber = phoneNumberModule.findPhoneNumber();
            phoneNumber && $.wgtPhone.txtNumber.setValue(phoneNumber);
        },
        _showGenderOptionDialog: function() {
            this._blurFields();
            $.gender.clearError();
            "" === $.gender.text && $.genderHint.applyProperties({
                visible: true
            });
            $.genderDialog.show();
        },
        _showWhyPhoneNumberAlert: function() {
            $.whyPhoneNumberPopup.show();
        },
        _selectGender: function(e) {
            if (e.index < 0) return;
            $.genderHint.applyProperties({
                visible: false
            });
            $.gender.text = $.genderDialog.options[e.index];
            $.wgtPhone.txtNumber.focus();
        },
        _validateSignup: function() {
            this._clearError();
            this._blurFields();
            if (!Ti.Network.online) {
                Ti.UI.createAlertDialog({
                    message: L("widget_signup_error_offline")
                }).show();
                return;
            }
            var isValidSignup = !Validator.form().checkCustomTextFieldsEmpty([ $.firstName, $.lastName, $.gender, $.wgtPhone.txtNumber, $.email, $.password ]);
            if (!isValidSignup) {
                $.gender.isError() && $.genderHint.applyProperties({
                    visible: false
                });
                ErrorDialog.show();
                return;
            }
            var email = $.email.value;
            if (!Validator.string().isEmpty(email) && !Validator.email().isEmail(email)) {
                $.email.showError(L("widget_signup_error_invalid_email"));
                isValidSignup = false;
            }
            if (!isValidSignup) {
                ErrorDialog.show();
                return;
            }
            var password = $.password.value;
            if (!Validator.string().isEmpty(password) && password.length < 6) {
                ErrorDialog.show(null, L("widget_signup_error_invalid_password"));
                return;
            }
            this._showPhoneNumberConfirmation();
        },
        _showPhoneNumberConfirmation: function() {
            var cca2 = $.wgtPhone.getSelectedCountry().cca2, e164 = PhoneNumberFormatter.formatE164(cca2, $.wgtPhone.getNumber()), internationalFormat = PhoneNumberFormatter.formatInternational(cca2, e164);
            $.phoneNumberConfirmPopup.message = "\n" + internationalFormat + "\n\n" + L("widget_signup_popup_message_phone_number_confirm");
            $.phoneNumberConfirmPopup.show();
        },
        _confirmPhoneNumber: function(e) {
            if (0 === e.index) {
                $.wgtPhone.txtNumber.focus();
                return;
            }
            analytics.track(trackingEvent.SIGNUP_PHONE_VALIDATED);
            this._startSignup();
        },
        _startSignup: function() {
            this._needToShowErrorDialog = false;
            this._startSpinner().then(this._signup).then(this._getOAuthToken).then(this._signupSuccess).then(this._userFetchSuccess).catch(this._signupError).finally(this._stopSpinner);
        },
        _startSpinner: function() {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return true;
            });
        },
        _signup: function() {
            var firstName = $.firstName.value, lastName = $.lastName.value, gender = $.gender.text, country = $.wgtPhone.getSelectedCountry(), phoneNumber = $.wgtPhone.txtNumber.value, email = $.email.value, password = $.password.value;
            gender = gender === L("widget_signup_gender_male") ? "m" : gender === L("widget_signup_gender_female") ? "f" : "o";
            var userId = this._signupRequest.get("userId");
            this._signupRequest.clear();
            var signupData = {
                userId: userId,
                firstName: firstName,
                lastName: lastName,
                gender: gender,
                country: country.cca3,
                phoneNumber: phoneNumber,
                email: email,
                password: password
            };
            var invite = Ti.App.Properties.getObject("invite");
            invite && invite.id && _.extend(signupData, {
                inviteId: invite.id
            });
            return this._signupRequest.save(signupData);
        },
        _getOAuthToken: function() {
            var deferred = Q.defer();
            var self = this;
            var client = Ti.Network.createHTTPClient({
                cache: false,
                enableKeepAlive: false,
                timeout: 6e4,
                onload: function() {
                    var response = JSON.parse(client.responseText);
                    var token = {
                        token: response.access_token,
                        expiresIn: response.expires_in
                    };
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    resourceOwner.save({
                        userId: self._signupRequest.get("userId"),
                        token: token
                    });
                    deferred.resolve();
                },
                onerror: function(response) {
                    LOGGER.error("failed to get oauth token");
                    LOGGER.error(response.data);
                    deferred.reject({
                        status: 500
                    });
                }
            });
            client.open("POST", URL.OAUTH_TOKEN);
            LoggingService.log("network", URL.OAUTH_TOKEN);
            client.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            var oauth = require("bootstrap/env").getOAuth();
            var data = [ "grant_type=password", "client_id=" + oauth.clientId, "client_secret=" + oauth.clientSecret, "scope=rtr", "username=" + $.email.value, "password=" + $.password.value ];
            client.send(data.join("&"));
            return deferred.promise;
        },
        _signupSuccess: function() {
            return Alloy.createModel("user", {
                userId: "SELF"
            }).fetch().then(function(data) {
                var countryInfo = _.findWhere(countries.countries, {
                    cca3: data.country
                });
                countryInfo && (data.country2chars = countryInfo.cca2);
                var resourceOwner = require("services/resource_owner_service").singleton();
                resourceOwner.save(data);
            });
        },
        _userFetchSuccess: function() {
            Alloy.Globals.Nav.Signup.open(Alloy.createWidget("ma.car.app.verification", {
                __parentSymbol: $.getView(),
                requirePhoto: true,
                nav: Alloy.Globals.Nav.Signup
            }), {
                title: L("widget_signup_title_verify"),
                disableBack: true
            });
        },
        _signupError: function(error) {
            if (!error.hasOwnProperty("status")) {
                this._needToShowErrorDialog = true;
                return;
            }
            406 === error.status ? this._userAlreadyExists() : 403 === error.status && "telephone_number_already_registered" === error.errorCode ? this._phoneNumberAlreadyInUsed() : 400 === error.status ? error.errorDetails && error.errorDetails.errorFields ? this._fieldError(error.errorDetails.errorFields) : ErrorDialog.show(null, error.description) : this._needToShowErrorDialog = true;
        },
        _phoneNumberAlreadyInUsed: function() {
            $.wgtPhone.txtNumber.showError(L("widget_signup_error_duplicated_phone_number"));
            ErrorDialog.show();
        },
        _userAlreadyExists: function() {
            $.email.showError(L("widget_signup_error_duplicated_email"));
            ErrorDialog.show();
        },
        _fieldError: function(fields) {
            fields.forEach(function(field) {
                switch (field) {
                  case "FIRST_NAME":
                    $.firstName.showError(L("widget_signup_error_invalid_name"));
                    break;

                  case "LAST_NAME":
                    $.lastName.showError(L("widget_signup_error_invalid_name"));
                    break;

                  case "GENDER":
                    $.gender.showError(L("widget_signup_error_invalid_gender"));
                    $.genderHint.applyProperties({
                        visible: false
                    });
                    break;

                  case "PHONE_NUMBER":
                    $.wgtPhone.txtNumber.showError(L("widget_signup_error_invalid_phone_number"));
                    break;

                  case "EMAIL":
                    $.email.showError(L("widget_signup_error_invalid_email"));
                    break;

                  case "PASSWORD":
                    $.password.showError(L("widget_signup_error_invalid_password"));
                }
            });
        },
        _showGeneralErrorMessage: function() {
            this._needToShowErrorDialog && Carma.UI.createAlertWindow({
                message: L("widget_signup_error")
            }).show();
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _clearError: function() {
            $.firstName.clearError();
            $.lastName.clearError();
            $.gender.clearError();
            $.wgtPhone.txtNumber.clearError();
            $.email.clearError();
            $.password.clearError();
            "" === $.gender.text && $.genderHint.applyProperties({
                visible: true
            });
        },
        _blurFields: function() {
            $.firstName.blur();
            $.lastName.blur();
            $.wgtPhone.txtNumber.blur();
            $.email.blur();
            $.password.blur();
            Ti.UI.Android.hideSoftKeyboard();
        },
        _trackShowPassword: function() {
            analytics.track(trackingEvent.SIGNUP_SHOW_PASSWORD);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;