function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "card_table";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.cardTable = Ti.UI.createTableView({
        top: "10dp",
        height: "100%",
        backgroundColor: "transparent",
        separatorColor: "transparent",
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndicator: false,
        visible: true,
        id: "cardTable"
    });
    $.__views.cardTable && $.addTopLevelView($.__views.cardTable);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    exports = new (require("/carmalib/controller").extend($, {
        _cards: [],
        events: {},
        initialize: function() {},
        showCards: function(cards) {
            this._cards = cards;
            var tableHeight = 60 * this._cards.length, tableHeightDP = tableHeight + "dp";
            $.cardTable.setHeight(tableHeightDP);
            this._createTableRows();
        },
        _createTableRows: function() {
            var tableDatas = [];
            for (var i = 0; i < this._cards.length; i++) {
                var rowController = Widget.createController("card_row", this._cards[i]);
                rowController.selectionStyle = "none";
                var rowView = rowController.getView();
                rowView.editAction = rowController.editAction;
                rowView.doneAction = rowController.doneAction;
                tableDatas.push(rowView);
            }
            $.cardTable.setData(tableDatas);
        },
        emptyTable: function() {
            $.cardTable.setData([]);
        },
        editAction: function() {
            var rows = $.cardTable.getData().length && $.cardTable.getData()[0].getRows();
            for (var i = 0; i < rows.length; ++i) rows[i].editAction();
        },
        doneAction: function() {
            var rows = $.cardTable.getData().length && $.cardTable.getData()[0].getRows();
            for (var i = 0; i < rows.length; ++i) rows[i].doneAction();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;