function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "topup";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.topupContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        top: 0,
        left: 0,
        id: "topupContainer"
    });
    $.__views.topupContainer && $.addTopLevelView($.__views.topupContainer);
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: "false",
        showHorizontalScrollIndicator: "false",
        height: Ti.UI.SIZE,
        width: "100%",
        top: 0,
        left: 0,
        id: "scrollView"
    });
    $.__views.topupContainer.add($.__views.scrollView);
    $.__views.topupView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        id: "topupView"
    });
    $.__views.scrollView.add($.__views.topupView);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: "#ff6600",
        font: {
            fontSize: "36dp"
        },
        top: 0,
        height: "40dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "totalBalance"
    });
    $.__views.topupView.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        top: "45dp",
        height: "30dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "balanceDetails"
    });
    $.__views.topupView.add($.__views.balanceDetails);
    $.__views.topupAmounts = Ti.UI.createView({
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit5,
        height: "60dp",
        top: "105dp",
        id: "topupAmounts"
    });
    $.__views.topupView.add($.__views.topupAmounts);
    $.__views.amount = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "10dp",
        visible: false,
        id: "amount"
    });
    $.__views.topupAmounts.add($.__views.amount);
    $.__views.range = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        top: "33dp",
        visible: false,
        id: "range"
    });
    $.__views.topupAmounts.add($.__views.range);
    $.__views.__alloyId713 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        font: {
            fontFamily: "splinico",
            fontSize: "24dp"
        },
        right: "15dp",
        transform: Alloy.Globals.Style.Rotate.rt90,
        id: "__alloyId713"
    });
    $.__views.topupAmounts.add($.__views.__alloyId713);
    $.__views.amountLoader = Ti.UI.createActivityIndicator({
        width: "20dp",
        height: "20dp",
        style: Ti.UI.ActivityIndicatorStyle.PLAIN,
        visible: false,
        id: "amountLoader"
    });
    $.__views.topupAmounts.add($.__views.amountLoader);
    $.__views.cardLoader = Ti.UI.createActivityIndicator({
        width: "20dp",
        height: "20dp",
        style: Ti.UI.ActivityIndicatorStyle.PLAIN,
        visible: false,
        top: "200dp",
        id: "cardLoader"
    });
    $.__views.topupView.add($.__views.cardLoader);
    $.__views.card = Ti.UI.createView({
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit5,
        height: "60dp",
        top: "190dp",
        visible: false,
        id: "card"
    });
    $.__views.topupView.add($.__views.card);
    $.__views.cardBrand = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        left: "8dp",
        id: "cardBrand"
    });
    $.__views.card.add($.__views.cardBrand);
    $.__views.cardAlias = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        left: "100dp",
        id: "cardAlias"
    });
    $.__views.card.add($.__views.cardAlias);
    $.__views.__alloyId714 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        font: {
            fontFamily: "splinico",
            fontSize: "24dp"
        },
        right: "15dp",
        transform: Alloy.Globals.Style.Rotate.rt90,
        id: "__alloyId714"
    });
    $.__views.card.add($.__views.__alloyId714);
    $.__views.cardForm = Ti.UI.createView({
        top: "190dp",
        height: Ti.UI.SIZE,
        width: "100%",
        visible: false,
        id: "cardForm"
    });
    $.__views.topupView.add($.__views.cardForm);
    $.__views.btnBuy = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        title: L("widget_stripe_payments_buy_now"),
        top: "275dp",
        bottom: "30dp",
        id: "btnBuy"
    });
    $.__views.topupView.add($.__views.btnBuy);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, PickerController = require(WPATH("/pickerController_android")), ui = require("/utils/ui"), parentWindow = TABS_HELPER.isUsingNativeTabs() ? TABS_HELPER.rootWindow() : ui.getWindow(args.__parentSymbol), popupWindow = require("/ui/common/popupWindow"), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService"), TransactionService = Globals.IOC.get("TransactionService"), network = require("/bootstrap/network"), Q = require("vendor/q");
    exports = new (require("/carmalib/controller").extend($, {
        _profile: null,
        _amounts: {},
        _range: {
            KILOMETRES: [ 50, 100, 250, 500 ],
            MILES: [ 31, 62, 155, 310 ]
        },
        _currentAmountIndex: 0,
        _currentCardIndex: 0,
        _cards: [],
        _distanceUnit: null,
        _distanceUnitShort: null,
        _cardForm: null,
        _updateUserProfile: false,
        _amountsInitializedFlag: false,
        _cardsInitializedFlag: false,
        TOPUP_TIMEOUT: 1e4,
        _topupTimeoutId: null,
        events: {
            "click[ios] topupContainer": "_blurFields",
            "click[android] topupContainer": "_blurFields",
            "click[ios] topupAmounts": "_openAmountDialog",
            "click[android] topupAmounts": "_openAmountDialog",
            "click[ios] card": "_openCardsDialog",
            "click[android] card": "_openCardsDialog",
            "click[ios] btnBuy": "_startTopup",
            "click[android] btnBuy": "_startTopup"
        },
        initialize: function() {
            _.bindAll(this, "showTopup", "_updateAmountRange", "_updateCard", "_confirmTopupRequest", "_scrollToDateInput", "_topupSuccess", "_topupError", "_topupTimeoutHandler");
            this._distanceUnit = require("services/cached_preferences_service").singleton().getPreferredDistanceUnit() || "MILES";
            this._distanceUnitShort = L("MILES" === this._distanceUnit ? "unit_miles" : "unit_kilometers");
        },
        showTopup: function(profile, updateUserProfile) {
            this._updateBuyButton();
            this._topupTimedout = false;
            if (!profile.creditBalance) {
                profile.creditBalance = profile.creditBalances[0];
                profile.credit = profile.credits;
            }
            this._profile = profile;
            this._updateUserProfile = updateUserProfile;
            this._showMyCreditBalance(profile.creditBalance, profile.credit);
            this._initAmounts();
            this._initRange();
            this._initCards();
            if (!network.isConnectionGood()) {
                $.card.visible = false;
                $.cardForm.visible = false;
                $.btnBuy.visible = false;
                $.topupAmounts.visible = false;
                this._profile || ($.topupView.visible = false);
                return;
            }
            parentWindow.addAppEventListener("picker.show", this._scrollToDateInput);
            parentWindow.addAppEventListener("picker.hide", this._scrollToTop);
        },
        _showMyCreditBalance: function(creditBalance, credit) {
            var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
            if (creditBalance) {
                var currencySymbol = creditBalance.currencySymbol;
                totalBalance = parseFloat(creditBalance.totalBalance).toFixed(2);
                var payableBalance = parseFloat(creditBalance.payableBalance).toFixed(2), bonusBalance = parseFloat(creditBalance.bonusBalance).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_details"), currencySymbol, payableBalance, bonusBalance);
            } else {
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = "";
            }
        },
        _initAmounts: function() {
            if (this._amountsInitialized()) return;
            var currency = this._profile.creditBalance.currency, self = this;
            TransactionService.getAvailableTopup().then(function(data) {
                self._amounts[currency] = [];
                for (var i = 0; i < data.topups.length; ++i) self._amounts[currency].push(data.topups[i].topupAmount);
                self._renderDefaultAmount();
                self._amountsInitializedFlag = true;
                self._updateBuyButton();
            }).catch(function() {
                LOGGER.debug("[topup.js] - get available topups error");
            });
        },
        _renderDefaultAmount: function() {
            $.amountLoader.hide();
            $.amount.visible = true;
            $.range.visible = true;
            var amounts = this._amounts[this._profile.creditBalance.currency], currencySymbol = this._profile.creditBalance.currencySymbol;
            $.amount.text = currencySymbol + amounts[0].toFixed(2);
        },
        _openAmountDialog: function() {
            if (!this._amountsInitialized()) {
                LOGGER.debug("[topup.js] - amounts not initialized can't open dialog");
                return;
            }
            var range = this._range[this._distanceUnit], amounts = this._amounts[this._profile.creditBalance.currency], currencySymbol = this._profile.creditBalance.currencySymbol, data = [], stringSeparator = "\n";
            for (var i = 0; i < amounts.length; ++i) data.push({
                value: amounts[i],
                title: currencySymbol + amounts[i].toFixed(2) + stringSeparator + L("widget_stripe_payments_range_approx") + " " + range[i] + " " + this._distanceUnitShort + ")"
            });
            var picker = new PickerController($.topupContainer, data, {
                selectedIndex: this._currentAmountIndex
            });
            picker.addEventListener("change", this._updateAmountRange);
            picker.show();
        },
        _amountsInitialized: function() {
            return this._amountsInitializedFlag;
        },
        _isReadyToBuy: function() {
            return this._amountsInitializedFlag && this._cardsInitializedFlag;
        },
        _updateBuyButton: function() {
            $.btnBuy.setEnabled(this._isReadyToBuy());
            $.btnBuy.toggleClick(this._isReadyToBuy());
        },
        _initRange: function() {
            var range = this._range[this._distanceUnit];
            $.range.text = L("widget_stripe_payments_range_approx") + " " + range[0] + " " + this._distanceUnitShort;
        },
        _updateAmountRange: function(data) {
            var currencySymbol = this._profile.creditBalance.currencySymbol, range = this._range[this._distanceUnit];
            this._currentAmountIndex = _.indexOf(this._amounts[this._profile.creditBalance.currency], data.value, true);
            var newRange = range[this._currentAmountIndex];
            $.amount.text = currencySymbol + data.value.toFixed(2);
            $.range.text = L("widget_stripe_payments_range_approx") + " " + newRange + " " + this._distanceUnitShort;
        },
        _initCards: function() {
            var self = this;
            if (this._profile.cards) {
                this._cards = this._profile.cards;
                this._cardsInitializedFlag = true;
                this._updateBuyButton();
                this._updateCard();
            } else Alloy.createModel("stripe_card").getCards().then(function(data) {
                ProfileService.updateCards(self._profile.userId, data.tokens);
                self._updateProfileObject(ProfileService.getCachedProfile(self._profile.userId));
                self._cards = data.tokens;
                self._cardsInitializedFlag = true;
                self._updateBuyButton();
            }).then(this._updateCard);
        },
        _updateCard: function(data) {
            $.cardLoader.hide();
            if (!this._cards.length) {
                this._renderCardForm();
                return;
            }
            if (this._cardForm) {
                this._cardForm.visible = false;
                this._cardForm.getView().applyProperties({
                    height: 0,
                    visible: false
                });
                $.btnBuy.top = "275dp";
            }
            data && (this._currentCardIndex = data.value);
            $.card.visible = true;
            var card = this._cards[this._currentCardIndex];
            $.cardBrand.image = "/images/cards/" + card.brand.replace(" ", "_") + ".png";
            $.cardAlias.text = "•••• •••• •••• " + card.alias;
        },
        _renderCardForm: function() {
            this._cardForm = Alloy.createWidget("ma.car.app.stripePayments", "card_form", {
                __parentSymbol: $.getView()
            });
            this._cardForm.visible = true;
            $.card.visible = false;
            $.cardForm.add(this._cardForm.getView());
            $.cardForm.visible = true;
            $.btnBuy.top = "580dp";
            $.scrollView.height = Ti.UI.SIZE;
        },
        _openCardsDialog: function() {
            var data = [];
            for (var i = 0; i < this._cards.length; ++i) data.push({
                value: i,
                title: this._cards[i].brand + " •••• " + this._cards[i].alias
            });
            var picker = new PickerController($.topupContainer, data, {
                selectedIndex: this._currentCardIndex
            });
            picker.addEventListener("change", this._updateCard);
            picker.show();
        },
        _startTopup: require("/bootstrap/patch").debounce(function() {
            if (!this._isReadyToBuy()) return;
            var self = this;
            this._startSpinner();
            this._getToken().then(this._confirmTopupRequest).catch(function(e) {
                self._stopSpinner();
                $.btnBuy.stopIndicator();
                alert(L("widget_stripe_payments_failed"));
                console.log("[topup.js] problems getting token: " + e);
            });
        }, 250),
        _getToken: function() {
            if (this._cards.length) {
                var card = this._cards[this._currentCardIndex];
                if ("VALID" !== card.status) {
                    alert(L("widget_stripe_card_invalid"));
                    return Q.fcall(function() {
                        throw Error("Invalid card");
                    });
                }
                return Q.fcall(function() {
                    return {
                        token: card.token,
                        brand: card.brand,
                        alias: card.alias
                    };
                });
            }
            var deferred = Q.defer();
            if (!this._cardForm) {
                deferred.reject();
                return deferred.promise;
            }
            var values = this._cardForm.getFieldValues(), self = this, params = {
                "card[number]": values.number,
                "card[exp_month]": values.exp_month,
                "card[exp_year]": values.exp_year,
                "card[name]": values.name,
                "card[cvc]": values.cvc
            };
            Alloy.createModel("stripe_api").addCard(params).then(function(data) {
                deferred.resolve({
                    token: data.id,
                    brand: data.card.type,
                    alias: data.card.last4,
                    storePaymentDetails: values.storePaymentDetails
                });
            }).catch(function() {
                deferred.reject();
            });
            return deferred.promise;
        },
        _updateCards: function() {
            var self = this;
            Alloy.createModel("stripe_card").getCards().then(function(data) {
                LOGGER.debug("[Stripe payment] -card data " + data.tokens);
                ProfileService.updateCards(self._profile.userId, data.tokens);
                self._updateProfileObject(ProfileService.getCachedProfile(self._profile.userId));
                Ti.App.fireEvent("app.carma.profile.change", self._profile);
            }).catch(function(e) {
                LOGGER.error("[Stripe payment] -card data " + JSON.stringify(e));
            }).finally(function() {}).done();
        },
        _confirmTopupRequest: function(cardInfo) {
            if (!cardInfo) {
                this._stopSpinner();
                $.btnBuy.stopIndicator();
                return;
            }
            var amount = this._amounts[this._profile.creditBalance.currency][this._currentAmountIndex], currencySymbol = this._profile.creditBalance.currencySymbol;
            var options = {
                token: cardInfo.token,
                amount: amount,
                currencyCode: this._profile.creditBalance.currency,
                storePaymentDetails: cardInfo.storePaymentDetails
            };
            var dialog = Ti.UI.createAlertDialog({
                cancel: 1,
                buttonNames: [ L("widget_boarding_no_credits_buy_now"), L("btn_cancel") ],
                message: String.format(L("widget_stripe_payments_topup_confirm_dialog_message"), currencySymbol + amount, cardInfo.brand, cardInfo.alias),
                title: L("widget_stripe_payments_topup_confirm_dialog_title")
            });
            var self = this;
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                if (e.index !== e.source.cancel) {
                    self._executeTopupRequest(options);
                    return;
                }
                $.btnBuy.stopIndicator();
                self._stopSpinner();
            });
            dialog.show();
        },
        _executeTopupRequest: function(options) {
            var timeoutHandled = false;
            var self = this;
            Alloy.createModel("stripe_transaction").topup(options).then(function(data) {
                if (timeoutHandled) return;
                clearTimeout(self._topupTimeoutId);
                self._topupSuccess(data);
            }).catch(function(error) {
                if (timeoutHandled) return;
                clearTimeout(self._topupTimeoutId);
                self._topupError(error);
            }).done();
            this._topupTimeoutId = setTimeout(function() {
                timeoutHandled = true;
                self._topupTimeoutHandler();
            }, this.TOPUP_TIMEOUT);
        },
        _topupSuccess: function(data) {
            if ("Completed" !== data.transactionStatus) throw data;
            var self = this;
            var onSuccess = function() {
                self._stopSpinner();
                $.btnBuy.stopIndicator();
                var callback = function() {
                    Ti.App.fireEvent("topup.successful");
                    TM.push(function() {
                        Alloy.Globals.Nav.Profile.back();
                        Ti.App.fireEvent("paymentRefreshBalance", {
                            bonusBalance: data.amount
                        });
                    });
                };
                new popupWindow().show(true, L("widget_stripe_payments_recharge_success"), {
                    callback: callback
                });
            };
            if (this._cardForm && this._cardForm.visible) {
                var values = this._cardForm.getFieldValues();
                values.storePaymentDetails && this._updateCards();
            }
            this._updateUserProfile ? require("services/user_service").findOwn().then(function(data) {
                Ti.App.fireEvent("app.carma.profile.change", data);
            }).finally(function() {
                onSuccess();
            }) : onSuccess();
        },
        _topupError: function(error) {
            LOGGER.debug("[topup.js] - error performing top up operation");
            var errorMessage = "";
            if (error) if (error.failureCode) switch (error.failureCode) {
              case "card_declined":
              case "expired_card":
              case "incorrect_number":
              case "invalid_number":
              case "invalid_expiry_month":
              case "invalid_expiry_year":
              case "invalid_cvc":
              case "incorrect_cvc":
              case "incorrect_zip":
                errorMessage = L("widget_stripe_error_" + error.failureCode);
                break;

              default:
                errorMessage = L("widget_stripe_card_details_problem");
            } else errorMessage = L("widget_stripe_payments_error");
            this._stopSpinner();
            $.btnBuy.stopIndicator();
            new popupWindow().show(false, L("widget_stripe_payments_recharge_issue"), {
                details: errorMessage
            });
        },
        _topupTimeoutHandler: function() {
            var globalEvents = require("/v6/common/GlobalEvents");
            globalEvents.onTopupTimeoutResponse(function(data) {
                alert(data.success ? String.format(L("widget_stripe_topup_timeout_success"), data.amount) : L("widget_stripe_topup_timeout_failed"));
            }, true);
            alert(L("widget_stripe_topup_timeout"));
            this._stopSpinner();
            $.btnBuy.stopIndicator();
            Alloy.Globals.Nav.Profile.backTo(0);
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _blurFields: function(e) {
            if (!this._cardForm) return;
            this._cardForm.blurFields(e);
        },
        _scrollToDateInput: function() {
            return;
            var coords;
            var screenHeight;
        },
        _scrollToTop: function() {
            $.scrollView.scrollTo(0, 0);
        },
        onOpened: function() {
            Alloy.Globals.Nav.Profile.hideEditButton();
        },
        onDestroy: function() {
            parentWindow.removeAppEventListener("picker.show", this._scrollToDateInput);
            parentWindow.removeAppEventListener("picker.hide", this._scrollToTop);
        },
        _updateProfileObject: function(newProfile) {
            if (!newProfile) return;
            this._profile = _.extend({}, this._profile, newProfile);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;