function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tolltag/" + s : s.substring(0, index) + "/ma.car.app.tolltag/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tolltag");
    this.__widgetId = "ma.car.app.tolltag";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "toll_tag_howitworks";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.darkBckg = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        backgroundColor: "#80a4a4a4",
        layout: "vertical",
        id: "darkBckg"
    });
    $.__views.darkBckg && $.addTopLevelView($.__views.darkBckg);
    $.__views.textContainer = Ti.UI.createView({
        width: "91.66666666666666%",
        top: "15dp",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "textContainer"
    });
    $.__views.darkBckg.add($.__views.textContainer);
    $.__views.howItWorksTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: 0,
        text: L("widget_txtag_how_it_works_title"),
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        height: "16dp",
        width: "100%",
        id: "howItWorksTitle"
    });
    $.__views.textContainer.add($.__views.howItWorksTitle);
    $.__views.howItWorksDescription = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: 0,
        text: L("widget_txtag_how_it_works_desc"),
        height: Ti.UI.SIZE,
        width: "100%",
        id: "howItWorksDescription"
    });
    $.__views.textContainer.add($.__views.howItWorksDescription);
    $.__views.oneYearProgram = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        text: L("widget_txtag_one_year_program"),
        height: Ti.UI.SIZE,
        width: "100%",
        top: "5dp",
        bottom: "11dp",
        id: "oneYearProgram"
    });
    $.__views.textContainer.add($.__views.oneYearProgram);
    $.__views.programTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: 0,
        text: L("widget_txtag_program_title"),
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        width: "100%",
        height: "16dp",
        id: "programTitle"
    });
    $.__views.textContainer.add($.__views.programTitle);
    $.__views.programDescription = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: 0,
        text: L("widget_txtag_program_description"),
        bottom: "11dp",
        height: Ti.UI.SIZE,
        id: "programDescription"
    });
    $.__views.textContainer.add($.__views.programDescription);
    $.__views.questionTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: 0,
        text: L("widget_txtag_question_title"),
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        width: "100%",
        height: "16dp",
        id: "questionTitle"
    });
    $.__views.textContainer.add($.__views.questionTitle);
    $.__views.questionDescription = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: 0,
        text: L("widget_txtag_question_description"),
        bottom: "11dp",
        left: 0,
        height: Ti.UI.SIZE,
        id: "questionDescription"
    });
    $.__views.textContainer.add($.__views.questionDescription);
    $.__views.emailUs = require("/ui/common/custom_button").createButton({
        width: "75%",
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        bottom: "20dp",
        title: L("widget_txtag_question_button"),
        id: "emailUs"
    });
    $.__views.textContainer.add($.__views.emailUs);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[android] emailUs": "_handleQuestion",
            "click[ios] emailUs": "_handleQuestion"
        },
        _isTxTag: true,
        txtagText: function() {
            this._isTxTag = true;
            $.howItWorksDescription.applyProperties({
                text: L("widget_txtag_how_it_works_desc")
            });
            $.programDescription.applyProperties({
                text: L("widget_txtag_program_description")
            });
            $.oneYearProgram.applyProperties({
                visible: true,
                height: Ti.UI.SIZE
            });
        },
        fastrakText: function() {
            this._isTxTag = false;
            var bayBridgeTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("bayBridgeTollRewards");
            var goldenGateBridgeTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("enableGoldenGateTollRefund");
            var allSFTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("enableSFBridgeTollRefunds");
            var howItWorks = L(allSFTollRewardsOn ? "widget_fastrak_how_it_works_desc_all_bridges" : bayBridgeTollRewardsOn && goldenGateBridgeTollRewardsOn ? "widget_fastrak_how_it_works_desc_baybridge_goldengate" : bayBridgeTollRewardsOn ? "widget_fastrak_how_it_works_desc" : "widget_fastrak_how_it_works_desc_goldengate");
            howItWorks = howItWorks.replace(/\n\n/g, "\n");
            $.howItWorksDescription.applyProperties({
                text: howItWorks
            });
            var description = L(allSFTollRewardsOn ? "widget_fastrak_program_description_all_bridges" : bayBridgeTollRewardsOn && goldenGateBridgeTollRewardsOn ? "widget_fastrak_program_description_baybridge_goldengate" : bayBridgeTollRewardsOn ? "widget_fastrak_program_description" : "widget_fastrak_program_description_goldengate");
            description = description.replace(/\n\n/g, "\n");
            $.programDescription.applyProperties({
                text: description
            });
            $.oneYearProgram.applyProperties({
                visible: false,
                height: 0
            });
        },
        _handleQuestion: function() {
            var emailDialog = Ti.UI.createEmailDialog();
            var recipient = this._isTxTag ? "austin@car.ma" : "support@car.ma";
            var subject = L(this._isTxTag ? "widget_txtag_question_subject" : "widget_fastrak_question_subject");
            var alertMsg = L(this._isTxTag ? "widget_txtag_question_no_email_support" : "widget_fastrak_question_no_email_support");
            if (emailDialog.isSupported()) {
                emailDialog.toRecipients = [ recipient ];
                emailDialog.subject = subject;
                emailDialog.messageBody = "";
                emailDialog.open();
            } else alert(alertMsg);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;