function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tolltag/" + s : s.substring(0, index) + "/ma.car.app.tolltag/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tolltag");
    this.__widgetId = "ma.car.app.tolltag";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "toll_tag_list";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    var __alloyId687 = {};
    var __alloyId690 = [];
    var __alloyId692 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId693 = [];
            var __alloyId695 = {
                type: "Ti.UI.Label",
                bindId: "txtagNumber",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "18dp"
                    },
                    top: 0,
                    height: "50dp",
                    bindId: "txtagNumber"
                }
            };
            __alloyId693.push(__alloyId695);
            var __alloyId697 = {
                type: "Ti.UI.Label",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontFamily: "splinico",
                        fontSize: "18dp"
                    },
                    text: "d",
                    top: "16dp",
                    right: "20dp"
                }
            };
            __alloyId693.push(__alloyId697);
            return __alloyId693;
        }(),
        properties: {
            top: 0,
            bottom: 0,
            height: "50dp"
        }
    };
    __alloyId690.push(__alloyId692);
    var __alloyId689 = {
        properties: {
            height: "50dp",
            backgroundColor: "transparent",
            name: "txtagItemTemplate"
        },
        childTemplates: __alloyId690
    };
    __alloyId687["txtagItemTemplate"] = __alloyId689;
    $.__views.__alloyId700 = Ti.UI.createView({
        top: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "__alloyId700"
    });
    $.__views.tollPic = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: 0,
        bottom: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        image: "/images/txtag.png",
        id: "tollPic"
    });
    $.__views.__alloyId700.add($.__views.tollPic);
    $.__views.title = Ti.UI.createLabel({
        color: "#ff6600",
        top: "10dp",
        text: L("widget_txtag_list_title"),
        font: {
            fontSize: "30dp",
            fontWeight: "bold"
        },
        id: "title"
    });
    $.__views.__alloyId700.add($.__views.title);
    $.__views.__alloyId701 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: 0,
        text: L("widget_txtag_list_subtitle"),
        id: "__alloyId701"
    });
    $.__views.__alloyId700.add($.__views.__alloyId701);
    $.__views.footerContainer = Ti.UI.createView({
        top: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "footerContainer"
    });
    $.__views.addTxtag = require("/ui/common/custom_button").createButton({
        width: "75%",
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        top: "10dp",
        bottom: "20dp",
        title: L("widget_txtag_add_txtag"),
        id: "addTxtag"
    });
    $.__views.footerContainer.add($.__views.addTxtag);
    $.__views.howItWorks = Alloy.createWidget("ma.car.app.tolltag", "toll_tag_howitworks", {
        id: "howItWorks",
        __parentSymbol: $.__views.footerContainer
    });
    $.__views.howItWorks.setParent($.__views.footerContainer);
    $.__views.txtagSection = Ti.UI.createListSection({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        headerView: $.__views.__alloyId700,
        footerView: $.__views.footerContainer,
        id: "txtagSection"
    });
    var __alloyId703 = [];
    __alloyId703.push($.__views.txtagSection);
    $.__views.txtagList = Ti.UI.createListView({
        top: 0,
        left: 0,
        defaultItemTemplate: "txtagItemTemplate",
        showVerticalScrollIndicator: false,
        backgroundColor: "transparent",
        separatorColor: "transparent",
        width: "100%",
        height: "100%",
        sections: __alloyId703,
        templates: __alloyId687,
        id: "txtagList"
    });
    $.__views.txtagList && $.addTopLevelView($.__views.txtagList);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var navigation = Alloy.Globals.Nav.Profile, args = arguments[0] || {};
    var refreshDone = false;
    exports = new (require("/carmalib/controller").extend($, {
        _txtags: null,
        _btnAddTxtag: null,
        _isLoading: false,
        _isTxTag: false,
        events: {
            "itemclick txtagList": "_itemClicked",
            "click addTxtag": "_addNewTxtag"
        },
        initialize: function() {
            args.isTxTag && (this._isTxTag = true);
            args.isTxTag ? this._txTagAppearance() : this._fasTrakAppearance();
            this._showTxtag(args.txtags);
            this._initEventListener();
        },
        _txTagAppearance: function() {
            $.title.applyProperties({
                text: L("widget_txtag_list_title")
            });
            $.tollPic.applyProperties({
                image: "/images/txtag.png"
            });
            $.howItWorks.txtagText();
        },
        _fasTrakAppearance: function() {
            $.title.applyProperties({
                text: L("widget_fastrak_list_title")
            });
            $.tollPic.applyProperties({
                image: "/images/fastrak.png"
            });
            $.howItWorks.fastrakText();
        },
        _showTxtag: function(txtags) {
            Ti.API.info("ARI _showTxtag");
            this._txtags = _.sortBy(txtags, function(txtag) {
                return txtag.id;
            });
            var title = "";
            if (this._txtags) {
                title = L(0 === this._txtags.length ? this._isTxTag ? "widget_txtag_add_txtag" : "widget_fastrak_add_fastrak" : this._isTxTag ? "widget_txtag_add_second_txtag" : "widget_fastrak_add_second_fastrak");
                $.addTxtag.applyProperties(this._txtags.length > 1 ? {
                    visibility: false,
                    height: 0
                } : {
                    visibility: true,
                    height: "50dp"
                });
                $.addTxtag.setTitle(title);
            }
            $.footerContainer.hide();
            $.txtagSection.setItems(this._composeItems(this._txtags));
            $.footerContainer.show();
            this._isLoading = false;
            if (0 == this._txtags.length) {
                if (!refreshDone) {
                    Ti.API.info("ARI _showTxtag navigation.back()");
                    refreshDone = true;
                    navigation.back();
                }
            } else refreshDone = false;
        },
        _initEventListener: function() {
            var self = this;
            this._addUniqueEventListener("txtag.refresh", function() {
                Ti.API.info("ari txtag.refresh from toll_tag_list");
                self._isLoading = true;
            });
            this._addUniqueEventListener("txtag.refreshed", function(data) {
                Ti.API.info("ari txtag.refreshed from toll_tag_list");
                self._showTxtag(data.txtags);
            });
        },
        _addUniqueEventListener: function(name, listener) {
            var _eventListener = navigation.get("uniqueListener." + name);
            _eventListener && navigation.removeEventListener(name, _eventListener);
            _eventListener = listener;
            navigation.set("uniqueListener." + name, _eventListener);
            navigation.addEventListener(name, _eventListener);
        },
        _composeItems: function(txtags) {
            var items = [];
            for (var i = 0, length = txtags.length; length > i; i++) {
                var txtag = txtags[i];
                var prefix = "txtag" === txtag.tollTagType ? "TEX " : "";
                txtag.tollTagId && items.push({
                    template: "txtagItemTemplate",
                    txtagNumber: {
                        text: prefix + txtag.tollTagId
                    }
                });
            }
            return items;
        },
        _itemClicked: function(e) {
            refreshDone = false;
            var self = this;
            if (self._txtags && !self._isLoading) {
                var txtag = self._txtags[e.itemIndex];
                var title = self._isTxTag ? L("widget_txtag_title").toUpperCase() : L("widget_fastrak_title").toUpperCase();
                txtag && navigation.open(Alloy.createWidget("ma.car.app.tolltag", "toll_tag_detail", {
                    txtag: txtag,
                    isSecondOne: 1 === e.itemIndex,
                    isTxTag: self._isTxTag
                }), {
                    title: title
                });
            }
        },
        _addNewTxtag: function(e) {
            refreshDone = false;
            var self = this;
            if (this._isLoading) return;
            var title = self._isTxTag ? L("widget_txtag_title").toUpperCase() : L("widget_fastrak_title").toUpperCase();
            navigation.open(Alloy.createWidget("ma.car.app.tolltag", "toll_tag_detail", {
                isSecondOne: this._txtags.length > 0,
                isTxTag: self._isTxTag
            }), {
                title: title
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;