function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "debug/tblRow";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.row = Ti.UI.createTableViewRow({
        height: Ti.UI.SIZE,
        focusable: false,
        backgroundSelectedColor: "#bbb",
        id: "row",
        className: "tblRow"
    });
    $.__views.row && $.addTopLevelView($.__views.row);
    $.__views.wrapper = Ti.UI.createView({
        top: "2dp",
        bottom: "2dp",
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        borderRadius: Alloy.Globals.Style.Unit.unit5,
        backgroundColor: "#30CCCCCC",
        id: "wrapper"
    });
    $.__views.row.add($.__views.wrapper);
    $.__views.inner = Ti.UI.createView({
        top: "10dp",
        bottom: "10dp",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "inner"
    });
    $.__views.wrapper.add($.__views.inner);
    $.__views.lblDateTime = Ti.UI.createLabel({
        color: "#666",
        top: "0dp",
        left: "0dp",
        font: {
            fontSize: "10dp"
        },
        id: "lblDateTime"
    });
    $.__views.inner.add($.__views.lblDateTime);
    $.__views.lblMessage = Ti.UI.createLabel({
        color: "#333",
        top: "0dp",
        left: "0dp",
        textAlign: "left",
        width: Ti.UI.FILL,
        font: {
            fontSize: "12dp"
        },
        id: "lblMessage"
    });
    $.__views.inner.add($.__views.lblMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var record = arguments[0];
    $.lblDateTime.text = moment(record.timestamp).format("hh:mm:ss MM-DD-YYYY") + " - " + record.level;
    $.lblMessage.text = record.message;
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;