function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "log/widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        backgroundColor: "#fff",
        fullscreen: false,
        navBarHidden: "true",
        layout: "vertical",
        id: "win",
        modal: "true"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "60dp",
        width: Ti.UI.FILL,
        backgroundColor: "#34495e",
        id: "header"
    });
    $.__views.win.add($.__views.header);
    $.__views.title = Ti.UI.createLabel({
        color: "#fff",
        top: "30dp",
        width: Ti.UI.FILL,
        textAlign: "center",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "title",
        text: "Logging Level"
    });
    $.__views.header.add($.__views.title);
    $.__views.back = require("/ui/common/tactile_label").createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        left: "10dp",
        height: "60dp",
        id: "back",
        text: "Back"
    });
    $.__views.header.add($.__views.back);
    var __alloyId592 = [];
    $.__views.__alloyId593 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundColor: "white",
        type: "debug",
        className: "tblRow",
        id: "__alloyId593"
    });
    __alloyId592.push($.__views.__alloyId593);
    $.__views.__alloyId594 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId594"
    });
    $.__views.__alloyId593.add($.__views.__alloyId594);
    $.__views.__alloyId595 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Debug",
        id: "__alloyId595"
    });
    $.__views.__alloyId594.add($.__views.__alloyId595);
    $.__views.__alloyId596 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundColor: "white",
        type: "info",
        className: "tblRow",
        id: "__alloyId596"
    });
    __alloyId592.push($.__views.__alloyId596);
    $.__views.__alloyId597 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId597"
    });
    $.__views.__alloyId596.add($.__views.__alloyId597);
    $.__views.__alloyId598 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Info",
        id: "__alloyId598"
    });
    $.__views.__alloyId597.add($.__views.__alloyId598);
    $.__views.__alloyId599 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundColor: "white",
        type: "warning",
        className: "tblRow",
        id: "__alloyId599"
    });
    __alloyId592.push($.__views.__alloyId599);
    $.__views.__alloyId600 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId600"
    });
    $.__views.__alloyId599.add($.__views.__alloyId600);
    $.__views.__alloyId601 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Warning",
        id: "__alloyId601"
    });
    $.__views.__alloyId600.add($.__views.__alloyId601);
    $.__views.__alloyId602 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundColor: "white",
        type: "error",
        className: "tblRow",
        id: "__alloyId602"
    });
    __alloyId592.push($.__views.__alloyId602);
    $.__views.__alloyId603 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId603"
    });
    $.__views.__alloyId602.add($.__views.__alloyId603);
    $.__views.__alloyId604 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Error",
        id: "__alloyId604"
    });
    $.__views.__alloyId603.add($.__views.__alloyId604);
    $.__views.__alloyId605 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundColor: "white",
        type: "",
        className: "tblRow",
        id: "__alloyId605"
    });
    __alloyId592.push($.__views.__alloyId605);
    $.__views.__alloyId606 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId606"
    });
    $.__views.__alloyId605.add($.__views.__alloyId606);
    $.__views.__alloyId607 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Disable",
        id: "__alloyId607"
    });
    $.__views.__alloyId606.add($.__views.__alloyId607);
    $.__views.tableView = Ti.UI.createTableView({
        top: "0dp",
        allowsSelection: true,
        data: __alloyId592,
        id: "tableView"
    });
    $.__views.win.add($.__views.tableView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    var index;
    var rows = [ "debug", "info", "warning", "error", "" ];
    $.header.remove($.back);
    $.win.addEventListener("androidback", function() {
        if ($.win) {
            $.win.close();
            args.onClose();
        }
    });
    $.tableView.addEventListener("click", function(e) {
        var type = e.rowData.type;
        if (Alloy.Globals.LOG_LEVEL != type) {
            $.tableView.getSections()[0].getRows()[index].setBackgroundColor(Alloy.Globals.Style.Color.White);
            Alloy.Globals.LOG_LEVEL = type;
            index = rows.indexOf(type);
            $.tableView.getSections()[0].getRows()[index].setBackgroundColor(Alloy.Globals.Style.Color.Orange);
        }
    });
    var level = Alloy.Globals.LOG_LEVEL ? Alloy.Globals.LOG_LEVEL : "";
    index = rows.indexOf(level);
    $.tableView.getSections()[0].getRows()[index].setBackgroundColor(Alloy.Globals.Style.Color.Orange);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;