function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "server/tblRow";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.row = Ti.UI.createTableViewRow({
        height: Ti.UI.SIZE,
        focusable: false,
        backgroundColor: "white",
        id: "row",
        className: "tblRow"
    });
    $.__views.row && $.addTopLevelView($.__views.row);
    $.__views.wrapper = Ti.UI.createView({
        top: "2dp",
        bottom: "2dp",
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "wrapper"
    });
    $.__views.row.add($.__views.wrapper);
    $.__views.lblName = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblName"
    });
    $.__views.wrapper.add($.__views.lblName);
    $.__views.lblWebURL = Ti.UI.createLabel({
        color: "#999",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "12dp"
        },
        id: "lblWebURL"
    });
    $.__views.wrapper.add($.__views.lblWebURL);
    $.__views.lblAPIURL = Ti.UI.createLabel({
        color: "#999",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "12dp"
        },
        id: "lblAPIURL"
    });
    $.__views.wrapper.add($.__views.lblAPIURL);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var profile = arguments[0];
    $.lblName.text = profile.name;
    $.lblWebURL.text = profile.webURL;
    $.lblAPIURL.text = profile.apiURL;
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;