function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        backgroundColor: "#fff",
        fullscreen: false,
        navBarHidden: "true",
        layout: "vertical",
        id: "win",
        modal: "true"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "60dp",
        width: Ti.UI.FILL,
        backgroundColor: "#34495e",
        id: "header"
    });
    $.__views.win.add($.__views.header);
    $.__views.title = Ti.UI.createLabel({
        color: "#fff",
        top: "30dp",
        width: Ti.UI.FILL,
        textAlign: "center",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "title",
        text: "Tools"
    });
    $.__views.header.add($.__views.title);
    $.__views.back = require("/ui/common/tactile_label").createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        left: "10dp",
        height: "60dp",
        id: "back",
        text: "Close"
    });
    $.__views.header.add($.__views.back);
    $.__views.reload = require("/ui/common/tactile_label").createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        right: "10dp",
        height: "60dp",
        id: "reload",
        text: "Reload"
    });
    $.__views.header.add($.__views.reload);
    var __alloyId560 = [];
    $.__views.__alloyId561 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId561"
    });
    __alloyId560.push($.__views.__alloyId561);
    $.__views.__alloyId562 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId562"
    });
    $.__views.__alloyId561.add($.__views.__alloyId562);
    $.__views.lblAppRevision = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblAppRevision",
        text: "unknown"
    });
    $.__views.__alloyId562.add($.__views.lblAppRevision);
    $.__views.__alloyId563 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId563"
    });
    __alloyId560.push($.__views.__alloyId563);
    $.__views.__alloyId564 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId564"
    });
    $.__views.__alloyId563.add($.__views.__alloyId564);
    $.__views.lblAppVersion = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblAppVersion",
        text: "unknown"
    });
    $.__views.__alloyId564.add($.__views.lblAppVersion);
    $.__views.__alloyId565 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId565"
    });
    __alloyId560.push($.__views.__alloyId565);
    $.__views.__alloyId566 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId566"
    });
    $.__views.__alloyId565.add($.__views.__alloyId566);
    $.__views.lblAppTimestamp = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblAppTimestamp",
        text: "unknown"
    });
    $.__views.__alloyId566.add($.__views.lblAppTimestamp);
    $.__views.__alloyId567 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId567"
    });
    __alloyId560.push($.__views.__alloyId567);
    $.__views.__alloyId568 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId568"
    });
    $.__views.__alloyId567.add($.__views.__alloyId568);
    $.__views.lblBundleId = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblBundleId",
        text: "unknown"
    });
    $.__views.__alloyId568.add($.__views.lblBundleId);
    $.__views.__alloyId569 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId569"
    });
    __alloyId560.push($.__views.__alloyId569);
    $.__views.__alloyId570 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId570"
    });
    $.__views.__alloyId569.add($.__views.__alloyId570);
    $.__views.lblSTO = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblSTO",
        text: "unknown"
    });
    $.__views.__alloyId570.add($.__views.lblSTO);
    $.__views.__alloyId571 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId571"
    });
    __alloyId560.push($.__views.__alloyId571);
    $.__views.__alloyId572 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId572"
    });
    $.__views.__alloyId571.add($.__views.__alloyId572);
    $.__views.lblSMODE = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblSMODE",
        text: "unknown"
    });
    $.__views.__alloyId572.add($.__views.lblSMODE);
    $.__views.__alloyId573 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "info",
        className: "tblRow",
        id: "__alloyId573"
    });
    __alloyId560.push($.__views.__alloyId573);
    $.__views.__alloyId574 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId574"
    });
    $.__views.__alloyId573.add($.__views.__alloyId574);
    $.__views.lblDisableUnlikely = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblDisableUnlikely",
        text: "unknown"
    });
    $.__views.__alloyId574.add($.__views.lblDisableUnlikely);
    $.__views.__alloyId575 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "server",
        className: "tblRow",
        hasChild: "true",
        id: "__alloyId575"
    });
    __alloyId560.push($.__views.__alloyId575);
    $.__views.__alloyId576 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId576"
    });
    $.__views.__alloyId575.add($.__views.__alloyId576);
    $.__views.lblEnv = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblEnv",
        text: "unknown"
    });
    $.__views.__alloyId576.add($.__views.lblEnv);
    $.__views.__alloyId577 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "featuretoggle",
        className: "tblRow",
        hasChild: "true",
        id: "__alloyId577"
    });
    __alloyId560.push($.__views.__alloyId577);
    $.__views.__alloyId578 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId578"
    });
    $.__views.__alloyId577.add($.__views.__alloyId578);
    $.__views.lblFeatureToggle = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblFeatureToggle",
        text: "Feature Toggles"
    });
    $.__views.__alloyId578.add($.__views.lblFeatureToggle);
    $.__views.__alloyId579 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "logger",
        className: "tblRow",
        hasChild: "true",
        id: "__alloyId579"
    });
    __alloyId560.push($.__views.__alloyId579);
    $.__views.__alloyId580 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId580"
    });
    $.__views.__alloyId579.add($.__views.__alloyId580);
    $.__views.lblLog = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        id: "lblLog",
        text: "Logs All"
    });
    $.__views.__alloyId580.add($.__views.lblLog);
    $.__views.__alloyId581 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "debug",
        className: "tblRow",
        hasChild: "true",
        id: "__alloyId581"
    });
    __alloyId560.push($.__views.__alloyId581);
    $.__views.__alloyId582 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId582"
    });
    $.__views.__alloyId581.add($.__views.__alloyId582);
    $.__views.__alloyId583 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Logs All",
        id: "__alloyId583"
    });
    $.__views.__alloyId582.add($.__views.__alloyId583);
    $.__views.__alloyId584 = Ti.UI.createTableViewRow({
        height: "50dp",
        focusable: false,
        backgroundSelectedColor: "#f3f3f3",
        type: "debug",
        className: "tblRow",
        level: "error",
        hasChild: "true",
        id: "__alloyId584"
    });
    __alloyId560.push($.__views.__alloyId584);
    $.__views.__alloyId585 = Ti.UI.createView({
        left: "5dp",
        right: "5dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "__alloyId585"
    });
    $.__views.__alloyId584.add($.__views.__alloyId585);
    $.__views.__alloyId586 = Ti.UI.createLabel({
        color: "#444",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "16dp"
        },
        text: "Logs ERROR",
        id: "__alloyId586"
    });
    $.__views.__alloyId585.add($.__views.__alloyId586);
    $.__views.tableView = Ti.UI.createTableView({
        top: "0dp",
        allowsSelection: true,
        data: __alloyId560,
        id: "tableView"
    });
    $.__views.win.add($.__views.tableView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    Carma.Window.Tools = true;
    var args = arguments[0] || {};
    $.header.remove($.back);
    $.reload.addEventListener("click", function() {
        reload();
    });
    var reload = function(options) {
        options = options || {};
        if (options.exit) {
            Carma.Window.Tools = false;
            $.win.close();
            return;
        }
        var revision = Alloy.Globals.APP.REVISION;
        var version = Alloy.Globals.APP.VERSION;
        var timestamp = Alloy.Globals.APP.TIMESTAMP;
        var bundleId = Alloy.Globals.APP.BUNDLEID;
        var env = require("bootstrap/env").getProfile().id;
        var logger = Alloy.Globals.LOG_LEVEL ? Alloy.Globals.LOG_LEVEL : "disabled";
        var offset = Ti.App.Properties.getDouble("systemTimeOffset", 0);
        $.lblAppRevision.text = "Revision: " + revision;
        $.lblAppVersion.text = "Version: " + version;
        $.lblAppTimestamp.text = "Build at: " + moment(parseFloat(timestamp)).format("DD-MM-YYYY HH:mm");
        $.lblBundleId.text = "Bundle Id: " + bundleId;
        $.lblEnv.text = "Profile: " + env;
        $.lblLog.text = "Loging: " + logger;
        $.lblSTO.text = "System Time Offset: " + offset;
        $.lblSMODE.text = "SMode: " + ("undefined" != typeof shadowMode && shadowMode ? "Yes" : "No");
        $.lblDisableUnlikely.text = "Disable Unlikely Trips: " + (Ti.App.Properties.getBool("disableUnlikely", false) ? "true" : "false");
    };
    $.lblDisableUnlikely.addEventListener("click", function(e) {
        Ti.App.Properties.setBool("disableUnlikely", !Ti.App.Properties.getBool("disableUnlikely", false));
        $.lblDisableUnlikely.text = "Disable Unlikely Trips: " + (Ti.App.Properties.getBool("disableUnlikely", false) ? "true" : "false");
    });
    $.tableView.addEventListener("click", function(e) {
        if ("server" === e.rowData.type) return Widget.createController("server/widget", {
            onClose: reload
        }).getView().open();
        if ("logger" === e.rowData.type) return Widget.createController("log/widget", {
            onClose: reload
        }).getView().open();
        if ("debug" === e.rowData.type) {
            var level = e.rowData.level;
            var query = level ? {
                level: e.rowData.level || {}
            } : {};
            return Widget.createController("debug/widget", {
                query: query,
                onClose: reload
            }).getView().open();
        }
        if ("featuretoggle" === e.rowData.type) return Widget.createController("featuretoggle/widget", {
            onClose: reload
        }).getView().open();
    });
    $.win.addEventListener("close", function() {
        Carma.Window.Tools = false;
    });
    reload();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;