function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tos/" + s : s.substring(0, index) + "/ma.car.app.tos/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tos");
    this.__widgetId = "ma.car.app.tos";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tosWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        backgroundColor: "#fff",
        id: "tosWindow"
    });
    $.__views.tosWindow && $.addTopLevelView($.__views.tosWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var navigation = Alloy.Globals.Nav.TOS = Alloy.createController("navigation"), args = arguments[0] || {}, type = args.type || "terms";
    $.tosWindow.addEventListener("close", function() {
        Alloy.Globals.Nav.TOS = null;
    });
    navigation.init({
        index: Alloy.createWidget("ma.car.app.tos", "tos", {
            type: type
        }),
        mainWindow: $.tosWindow,
        historyLimit: 1,
        title: L("widget_tos_title_" + type),
        navBarColor: "white"
    });
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;