function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.trip/" + s : s.substring(0, index) + "/ma.car.app.trip/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.trip");
    this.__widgetId = "ma.car.app.trip";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "locationSelector";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.locationSelectorContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        top: 0,
        left: 0,
        id: "locationSelectorContainer"
    });
    $.__views.locationSelectorContainer && $.addTopLevelView($.__views.locationSelectorContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, navigation = args.navigation || Alloy.Globals.Nav.Trip;
    exports = new (require("/carmalib/controller").extend($, {
        initialize: function() {
            _.bindAll(this, "_locationSelected");
            this._initLocationWidget();
        },
        _initLocationWidget: function() {
            this._locationSelectionWidget = Alloy.createWidget("ma.car.app.location", {
                hintText: L(args.origin ? "widget_add_commute_origin_placeholder" : "widget_add_commute_destination_placeholder"),
                success: this._locationSelected,
                animated: false,
                hideLabel: true,
                darkTheme: args.darkTheme
            });
            this._locationSelectionWidget.setAddress(args.currentValue);
            this._locationSelectionWidget.focusTextfield();
            $.locationSelectorContainer.add(this._locationSelectionWidget.getView());
        },
        _locationSelected: function(location) {
            args.callback && args.callback(location);
            navigation.back();
        },
        onDestroy: function() {
            this._locationSelectionWidget.onDestroy();
            this._locationSelectionWidget = null;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;