function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.trip/" + s : s.substring(0, index) + "/ma.car.app.trip/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.trip");
    this.__widgetId = "ma.car.app.trip";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripsList";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripsListContainer = Ti.UI.createView({
        height: "100%",
        width: "100%",
        top: 0,
        left: 0,
        id: "tripsListContainer"
    });
    $.__views.tripsListContainer && $.addTopLevelView($.__views.tripsListContainer);
    $.__views.noTrips = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        width: "83.33333333333334%",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_trip_no_trips"),
        height: 0,
        visible: false,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "noTrips"
    });
    $.__views.tripsListContainer.add($.__views.noTrips);
    var __alloyId817 = {};
    var __alloyId820 = [];
    var __alloyId822 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId823 = [];
            var __alloyId825 = {
                type: "Ti.UI.Label",
                bindId: "selectedTrip",
                properties: {
                    color: Alloy.Globals.Style.Color.LightGrey,
                    text: "c",
                    visible: false,
                    top: "23dp",
                    left: "5dp",
                    font: {
                        fontSize: "20dp",
                        fontFamily: "splinico"
                    },
                    bindId: "selectedTrip"
                }
            };
            __alloyId823.push(__alloyId825);
            var __alloyId827 = {
                type: "Ti.UI.Label",
                bindId: "tripTime",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    top: "6dp",
                    left: "28dp",
                    bindId: "tripTime"
                }
            };
            __alloyId823.push(__alloyId827);
            var __alloyId829 = {
                type: "Ti.UI.Label",
                bindId: "roleText",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    top: "23dp",
                    left: "28dp",
                    bindId: "roleText"
                }
            };
            __alloyId823.push(__alloyId829);
            var __alloyId831 = {
                type: "Ti.UI.Label",
                bindId: "status",
                properties: {
                    color: "#fff",
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    left: "28dp",
                    top: "41dp",
                    bindId: "status"
                }
            };
            __alloyId823.push(__alloyId831);
            var __alloyId833 = {
                type: "Ti.UI.Label",
                bindId: "originAddress",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "6dp",
                    left: "94dp",
                    right: "70dp",
                    ellipsize: true,
                    height: "19dp",
                    horizontalWrap: false,
                    wordWrap: false,
                    bindId: "originAddress"
                }
            };
            __alloyId823.push(__alloyId833);
            var __alloyId835 = {
                type: "Ti.UI.Label",
                bindId: "destinationAddress",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "23dp",
                    left: "94dp",
                    right: "70dp",
                    ellipsize: true,
                    height: "19dp",
                    horizontalWrap: false,
                    wordWrap: false,
                    bindId: "destinationAddress"
                }
            };
            __alloyId823.push(__alloyId835);
            var __alloyId837 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId838 = [];
                    var __alloyId840 = {
                        type: "Ti.UI.Label",
                        bindId: "sundayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("sunday_single_capital"),
                            bindId: "sundayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId840);
                    var __alloyId842 = {
                        type: "Ti.UI.Label",
                        bindId: "mondayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("monday_single_capital"),
                            bindId: "mondayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId842);
                    var __alloyId844 = {
                        type: "Ti.UI.Label",
                        bindId: "tuesdayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("tuesday_single_capital"),
                            bindId: "tuesdayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId844);
                    var __alloyId846 = {
                        type: "Ti.UI.Label",
                        bindId: "wednesdayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("wednesday_single_capital"),
                            bindId: "wednesdayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId846);
                    var __alloyId848 = {
                        type: "Ti.UI.Label",
                        bindId: "thursdayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("thursday_single_capital"),
                            bindId: "thursdayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId848);
                    var __alloyId850 = {
                        type: "Ti.UI.Label",
                        bindId: "fridayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("friday_single_capital"),
                            bindId: "fridayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId850);
                    var __alloyId852 = {
                        type: "Ti.UI.Label",
                        bindId: "saturdayLabel",
                        properties: {
                            color: "#fff",
                            font: {
                                fontSize: "15dp"
                            },
                            right: "8dp",
                            text: L("saturday_single_capital"),
                            bindId: "saturdayLabel"
                        }
                    };
                    __alloyId838.push(__alloyId852);
                    return __alloyId838;
                }(),
                properties: {
                    layout: "horizontal",
                    top: "41dp",
                    left: "94dp"
                }
            };
            __alloyId823.push(__alloyId837);
            var __alloyId854 = {
                type: "Ti.UI.Label",
                bindId: "editBtn",
                properties: {
                    color: Alloy.Globals.Style.Color.Grey,
                    text: "2",
                    right: 0,
                    width: "50dp",
                    height: "45dp",
                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                    font: {
                        fontSize: "26dp",
                        fontFamily: "splinico"
                    },
                    bindId: "editBtn"
                }
            };
            __alloyId823.push(__alloyId854);
            return __alloyId823;
        }(),
        properties: {
            width: "100%"
        }
    };
    __alloyId820.push(__alloyId822);
    var __alloyId856 = {
        type: "Ti.UI.View",
        properties: {
            width: "91.66666666666666%",
            height: "1px",
            backgroundColor: "#666",
            bottom: 0
        }
    };
    __alloyId820.push(__alloyId856);
    var __alloyId819 = {
        properties: {
            backgroundColor: "transparent",
            height: "70dp",
            left: 0,
            name: "weeklyTemplate"
        },
        childTemplates: __alloyId820
    };
    __alloyId817["weeklyTemplate"] = __alloyId819;
    var __alloyId859 = [];
    var __alloyId861 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId862 = [];
            var __alloyId864 = {
                type: "Ti.UI.Label",
                bindId: "selectedTrip",
                properties: {
                    color: Alloy.Globals.Style.Color.LightGrey,
                    text: "c",
                    visible: false,
                    top: "23dp",
                    left: "5dp",
                    font: {
                        fontSize: "20dp",
                        fontFamily: "splinico"
                    },
                    bindId: "selectedTrip"
                }
            };
            __alloyId862.push(__alloyId864);
            var __alloyId866 = {
                type: "Ti.UI.Label",
                bindId: "tripTime",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    top: "6dp",
                    left: "28dp",
                    bindId: "tripTime"
                }
            };
            __alloyId862.push(__alloyId866);
            var __alloyId868 = {
                type: "Ti.UI.Label",
                bindId: "roleText",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    top: "23dp",
                    left: "28dp",
                    bindId: "roleText"
                }
            };
            __alloyId862.push(__alloyId868);
            var __alloyId870 = {
                type: "Ti.UI.Label",
                bindId: "status",
                properties: {
                    color: "#fff",
                    font: {
                        fontSize: "15dp",
                        fontWeight: "bold"
                    },
                    left: "28dp",
                    top: "41dp",
                    bindId: "status"
                }
            };
            __alloyId862.push(__alloyId870);
            var __alloyId872 = {
                type: "Ti.UI.Label",
                bindId: "originAddress",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "6dp",
                    left: "94dp",
                    right: "70dp",
                    ellipsize: true,
                    height: "19dp",
                    horizontalWrap: false,
                    wordWrap: false,
                    bindId: "originAddress"
                }
            };
            __alloyId862.push(__alloyId872);
            var __alloyId874 = {
                type: "Ti.UI.Label",
                bindId: "destinationAddress",
                properties: {
                    color: Alloy.Globals.Style.Color.DarkGray,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "23dp",
                    left: "94dp",
                    right: "70dp",
                    ellipsize: true,
                    height: "19dp",
                    horizontalWrap: false,
                    wordWrap: false,
                    bindId: "destinationAddress"
                }
            };
            __alloyId862.push(__alloyId874);
            var __alloyId876 = {
                type: "Ti.UI.Label",
                bindId: "dateLabel",
                properties: {
                    color: Alloy.Globals.Style.Color.LightBlue,
                    font: {
                        fontSize: "15dp"
                    },
                    top: "41dp",
                    left: "94dp",
                    bindId: "dateLabel"
                }
            };
            __alloyId862.push(__alloyId876);
            var __alloyId878 = {
                type: "Ti.UI.Label",
                bindId: "editBtn",
                properties: {
                    color: Alloy.Globals.Style.Color.Grey,
                    text: "2",
                    right: 0,
                    width: "50dp",
                    height: "45dp",
                    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
                    font: {
                        fontSize: "26dp",
                        fontFamily: "splinico"
                    },
                    bindId: "editBtn"
                }
            };
            __alloyId862.push(__alloyId878);
            return __alloyId862;
        }(),
        properties: {
            width: "100%"
        }
    };
    __alloyId859.push(__alloyId861);
    var __alloyId880 = {
        type: "Ti.UI.View",
        properties: {
            width: "91.66666666666666%",
            height: "1px",
            backgroundColor: "#666",
            bottom: 0
        }
    };
    __alloyId859.push(__alloyId880);
    var __alloyId858 = {
        properties: {
            backgroundColor: "transparent",
            height: "70dp",
            left: 0,
            name: "oneoffTemplate"
        },
        childTemplates: __alloyId859
    };
    __alloyId817["oneoffTemplate"] = __alloyId858;
    $.__views.myTripsSection = Ti.UI.createListSection({
        id: "myTripsSection"
    });
    var __alloyId882 = [];
    __alloyId882.push($.__views.myTripsSection);
    $.__views.myTripsList = Ti.UI.createListView({
        backgroundColor: "transparent",
        top: 0,
        left: 0,
        bottom: "80dp",
        showVerticalScrollIndicator: false,
        separatorColor: "transparent",
        height: Ti.UI.SIZE,
        sections: __alloyId882,
        templates: __alloyId817,
        id: "myTripsList"
    });
    $.__views.tripsListContainer.add($.__views.myTripsList);
    $.__views.buttonsContainer = Ti.UI.createView({
        width: "91.66666666666666%",
        height: "80dp",
        bottom: 0,
        layout: "vertical",
        id: "buttonsContainer"
    });
    $.__views.tripsListContainer.add($.__views.buttonsContainer);
    $.__views.btnAdd = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontFamily: "splinico",
            fontSize: "55dp"
        },
        text: "3",
        title: "3",
        top: 0,
        width: "55dp",
        height: "55dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "btnAdd"
    });
    $.__views.buttonsContainer.add($.__views.btnAdd);
    $.__views.titleAdd = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_trip_add_trip"),
        top: "6dp",
        id: "titleAdd"
    });
    $.__views.buttonsContainer.add($.__views.titleAdd);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, ErrorDialog = require("/ui/common/validation_error"), moment = require("vendor/moment"), os = require("/platform/os"), Globals = require("/v6/infrastructure/Globals"), TripService = Globals.IOC.get("tripService"), exploreService = Globals.IOC.get("exploreService"), exploreController = require("/v6/common/ExploreController");
    exports = new (require("/carmalib/controller").extend($, {
        _dialogOpened: false,
        _loading: false,
        _selectedTripIndex: -1,
        events: {
            "click[ios] btnAdd": "_addTrip",
            "click[android] btnAdd": "_addTrip",
            "itemclick myTripsList": "_listItemClicked"
        },
        initialize: function() {
            _.bindAll(this, "_loadTrips", "_refreshOneOffTrips");
            var top;
            this._loadTrips();
            TripService.on(TripService.TRIP_UPDATED_EVENT, this._loadTrips);
            exploreController.on(exploreController.MENU_BUTTON_CLICK, this._refreshOneOffTrips);
        },
        _loadTrips: function() {
            var self = this;
            TripService.loadTrips({
                relativeTime: Date.now() - 9e5
            }).then(function(data) {
                self._renderTrips(data);
            }).catch(function() {
                exploreService.clearSelectedTripEffectiveTime();
                LOGGER.debug("[tripsList.js] - error fetching trips");
            });
        },
        _renderTrips: function(trips) {
            if (!trips.paginator.totalResults) {
                exploreService.clearSelectedTripEffectiveTime();
                $.noTrips.applyProperties({
                    height: "80dp",
                    visible: true
                });
                return;
            }
            $.noTrips.applyProperties({
                height: 0,
                visible: false
            });
            var dataSet = this._buildDataSet(trips);
            $.myTripsList.sections[0].setItems(dataSet, {
                animated: false
            });
            this._checkNextTrip();
        },
        _buildDataSet: function(trips) {
            var dataSet = [], momentDate = null;
            _.each(trips.tripList, function(trip) {
                if ("REPEATING_WEEKLY" === trip.baseTrip.schedule.type) {
                    momentDate = moment(trip.baseTrip.schedule.effectiveTime);
                    dataSet.push({
                        selectedTrip: {
                            visible: false
                        },
                        tripTime: {
                            text: require("i18n/i18n").formatTime(momentDate)
                        },
                        roleText: {
                            text: L("DRIVE" === trip.baseTrip.type ? "widget_future_driving" : "widget_future_riding")
                        },
                        status: {
                            text: L(trip.baseTrip.enabled ? "widget_trip_on" : "widget_trip_off"),
                            color: trip.baseTrip.enabled ? Alloy.Globals.Style.Color.LightBlue : Alloy.Globals.Style.Color.LightGrey
                        },
                        originAddress: {
                            text: trip.baseTrip.origin.address,
                            visible: true
                        },
                        destinationAddress: {
                            text: String.format(L("widget_future_to_destination"), trip.baseTrip.destination.address),
                            visible: true
                        },
                        sundayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[0] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        mondayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[1] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        tuesdayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[2] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        wednesdayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[3] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        thursdayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[4] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        fridayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[5] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        saturdayLabel: {
                            color: trip.baseTrip.schedule.daysOfOperationv2[6] ? Alloy.Globals.Style.Color.LightBlue : "#a4a4a4"
                        },
                        template: "weeklyTemplate",
                        properties: {
                            tripId: trip.baseTrip.id,
                            attributes: {
                                type: trip.baseTrip.type,
                                alias: trip.baseTrip.alias,
                                origin: trip.baseTrip.origin,
                                destination: trip.baseTrip.destination,
                                schedule: {
                                    type: trip.baseTrip.schedule.type,
                                    daysOfOperationv2: trip.baseTrip.schedule.daysOfOperationv2,
                                    daysOfOperation: trip.baseTrip.schedule.daysOfOperation,
                                    effectiveTime: trip.baseTrip.schedule.effectiveTime,
                                    startTime: trip.baseTrip.schedule.startTime
                                },
                                enabled: trip.baseTrip.enabled
                            }
                        }
                    });
                } else {
                    momentDate = moment(trip.baseTrip.schedule.effectiveTime);
                    dataSet.push({
                        selectedTrip: {
                            visible: false
                        },
                        tripTime: {
                            text: require("i18n/i18n").formatTime(momentDate)
                        },
                        roleText: {
                            text: L("DRIVE" === trip.baseTrip.type ? "widget_future_driving" : "widget_future_riding")
                        },
                        status: {
                            text: L(trip.baseTrip.enabled ? "widget_trip_on" : "widget_trip_off"),
                            color: trip.baseTrip.enabled ? Alloy.Globals.Style.Color.LightBlue : Alloy.Globals.Style.Color.LightGrey
                        },
                        originAddress: {
                            text: trip.baseTrip.origin.address,
                            visible: true
                        },
                        destinationAddress: {
                            text: String.format(L("widget_future_to_destination"), trip.baseTrip.destination.address),
                            visible: true
                        },
                        dateLabel: {
                            text: require("i18n/i18n").formatTodayDate(trip.baseTrip.schedule.effectiveTime),
                            visible: true
                        },
                        template: "oneoffTemplate",
                        properties: {
                            tripId: trip.baseTrip.id,
                            attributes: {
                                type: trip.baseTrip.type,
                                alias: trip.baseTrip.alias,
                                origin: trip.baseTrip.origin,
                                destination: trip.baseTrip.destination,
                                schedule: {
                                    type: trip.baseTrip.schedule.type,
                                    daysOfOperationv2: trip.baseTrip.schedule.daysOfOperationv2,
                                    daysOfOperation: trip.baseTrip.schedule.daysOfOperation,
                                    effectiveTime: trip.baseTrip.schedule.effectiveTime,
                                    startTime: trip.baseTrip.schedule.startTime
                                },
                                enabled: trip.baseTrip.enabled
                            }
                        }
                    });
                }
            });
            return dataSet;
        },
        _checkNextTrip: function() {
            var items = $.myTripsList.sections[0].getItems();
            if (!items.length) {
                exploreService.clearSelectedTripEffectiveTime();
                return;
            }
            var nextSelectedTrip = exploreService.getSelectedTrip(), nextTrip = null, index = null;
            if (nextSelectedTrip) {
                var self = this;
                this._selectedTripIndex = -1;
                _.each(items, function(item, itemIndex) {
                    if (item.properties.tripId == nextSelectedTrip.tripId) {
                        self._selectedTripIndex = index;
                        if (item.properties.attributes.enabled) {
                            nextTrip = item;
                            index = itemIndex;
                        }
                    }
                });
            }
            if (!nextTrip) {
                var diff = Number.MAX_VALUE;
                _.each(items, function(item, itemIndex) {
                    if (item.properties.attributes.enabled) {
                        var thisDiff = item.properties.attributes.schedule.effectiveTime - Date.now();
                        if (thisDiff >= 0 && diff > thisDiff) {
                            diff = thisDiff;
                            nextTrip = item;
                            index = itemIndex;
                        } else if (0 > thisDiff) {
                            var absDiff = Math.abs(thisDiff);
                            if (9e5 > absDiff && diff > absDiff) {
                                diff = absDiff;
                                nextTrip = item;
                                index = itemIndex;
                            }
                        }
                    }
                });
            }
            if (!nextTrip) {
                exploreService.clearSelectedTripEffectiveTime();
                this._deselectTrips();
                return;
            }
            this._selectTrip(nextTrip, index, false);
        },
        _addTrip: function() {
            if (this._loading) return;
            this._loading = true;
            var self = this, loadingCallback = function() {
                self._loading = false;
            };
            this._openEditTripWidget(null, {
                title: L("widget_trip_add_trip").toUpperCase()
            }, loadingCallback);
        },
        _editTrip: function(item, index) {
            if (this._dialogOpened) return;
            this._dialogOpened = true;
            var turnOnMessage = L(item.properties.attributes.enabled ? "widget_trip_turn_off" : "widget_trip_turn_on");
            var opts = {
                cancel: 3,
                options: [ turnOnMessage, L("widget_trip_edit_trip_singular"), L("widget_trip_delete"), L("btn_cancel") ],
                selectedIndex: 1,
                destructive: 2
            };
            var dialog = Ti.UI.createOptionDialog(opts), self = this;
            dialog.addEventListener("click", function handler(data) {
                dialog.removeEventListener("click", handler);
                self._dialogOpened = false;
                switch (data.index) {
                  case 0:
                    self._toggleTrip(item, index);
                    break;

                  case 1:
                    self._openEditTripWidget({
                        tripId: item.properties.tripId
                    }, {
                        title: L("widget_trip_edit_title")
                    });
                    break;

                  case 2:
                    self._deleteTrip(item.properties.tripId, index);
                }
                dialog = null;
            });
            dialog.show();
        },
        _listItemClicked: function(e) {
            if (this._loading) return;
            this._loading = true;
            var item = e.section.getItemAt(e.itemIndex);
            switch (e.bindId) {
              case "editBtn":
                this._editTrip(item, e.itemIndex);
                this._loading = false;
                break;

              default:
                if (exploreController.isSliding()) {
                    this._loading = false;
                    return;
                }
                this._selectTrip(item, e.itemIndex, true);
                this._loading = false;
            }
        },
        _toggleTrip: function(item, index) {
            var tripAttributes = item.properties.attributes;
            if ("ONE_OFF" === tripAttributes.schedule.type && tripAttributes.schedule.effectiveTime < Date.now() - 9e5) {
                alert(L("widget_trip_too_old"));
                return;
            }
            var enabled = !tripAttributes.enabled, self = this;
            tripAttributes.id = item.properties.tripId;
            tripAttributes.enabled = enabled;
            this._updateEnableUI(item, enabled, index);
            TripService.saveTrip(tripAttributes).then(function() {}).catch(function() {
                ErrorDialog.showSimple(L("widget_trip_save_error"));
                self._updateEnableUI(item, !enabled, index);
            });
        },
        _updateEnableUI: function(item, enable, index) {
            _.extend(item.status, {
                color: enable ? Alloy.Globals.Style.Color.LightBlue : Alloy.Globals.Style.Color.LightGrey,
                text: L(enable ? "widget_trip_on" : "widget_trip_off")
            });
            item.properties.attributes.enabled = enable;
            $.myTripsList.sections[0].replaceItemsAt(index, 1, [ item ], {
                animated: false
            });
        },
        _deleteTrip: function(tripId, index) {
            this._startSpinner();
            var self = this;
            TripService.deleteTrip(tripId).then(function() {
                self._stopSpinner();
                $.myTripsList.sections[0].deleteItemsAt(index, 1, {
                    animated: false
                });
                var length = $.myTripsList.sections[0].getItems().length;
                length || $.noTrips.applyProperties({
                    height: "80dp",
                    visible: true
                });
                Ti.App.fireEvent("carma:booking.changed");
            }).catch(function(e) {
                LOGGER.error(e.toString());
                self._stopSpinner();
                ErrorDialog.showSimple(L("widget_trip_delete_error"));
            });
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _openEditTripWidget: function(widgetOptions, navigationOptions, callback) {
            widgetOptions = widgetOptions || {};
            navigationOptions = navigationOptions || {};
            var popupWindow = Alloy.createController("simpleWindow").getView(), navigation = Alloy.Globals.Nav.Trip = Alloy.createController("navigation"), widget = Alloy.createWidget("ma.car.app.trip", "editTrip", widgetOptions);
            popupWindow.applyProperties({
                backgroundColor: "#fff",
                top: 0,
                visible: false
            });
            popupWindow.addEventListener("close", function closeHandler() {
                popupWindow.addEventListener("close", closeHandler);
                widget.onDestroy();
                widget = null;
            });
            navigationOptions = _.extend({
                index: widget,
                historyLimit: 20,
                mainWindow: popupWindow,
                transition: "none",
                navBarVisible: true,
                modal: true,
                callback: callback
            }, navigationOptions);
            navigation.init(navigationOptions);
            popupWindow.open();
        },
        _selectTrip: function(item, index, humanTriggeredEvent) {
            item = item || {};
            var trip = item.properties || {};
            humanTriggeredEvent = humanTriggeredEvent || false;
            if (!(trip && trip.attributes && trip.attributes.schedule && trip.attributes.schedule.effectiveTime)) {
                LOGGER.error("[tripsList.js] - trip doesn't have a valid effetive time");
                return;
            }
            if (!trip.attributes.enabled && !humanTriggeredEvent) {
                LOGGER.error("[tripsList.js] - trip is disabled and it wasn't selected by user");
                return;
            }
            var tripPlus15 = trip.attributes.schedule.effectiveTime + 9e5;
            if (tripPlus15 < Date.now()) {
                var appSound = require("/utils/appSound");
                appSound.play("selectionerror");
                return;
            }
            var tripObject = {
                tripId: trip.tripId,
                origin: trip.attributes.origin,
                destination: trip.attributes.destination,
                schedule: trip.attributes.schedule,
                enabled: trip.attributes.enabled,
                type: trip.attributes.type
            };
            exploreService.setSelectedTripEffectiveTime(tripObject);
            this._markTripAsSelected(item, index);
        },
        _deselectTrips: function() {
            if (-1 === this._selectedTripIndex) return;
            var item = $.myTripsList.sections[0].getItemAt(this._selectedTripIndex);
            if (item && item.selectedTrip && item.selectedTrip.visible) {
                item.selectedTrip.visible = false;
                $.myTripsList.sections[0].replaceItemsAt(this._selectedTripIndex, 1, [ item ], {
                    animated: false
                });
                this._selectedTripIndex = -1;
            }
        },
        _markTripAsSelected: function(item, index) {
            this._deselectTrips();
            _.extend(item.selectedTrip, {
                visible: true
            });
            $.myTripsList.sections[0].replaceItemsAt(index, 1, [ item ], {
                animated: false
            });
            this._selectedTripIndex = index;
        },
        _refreshOneOffTrips: function() {
            var items = $.myTripsList.sections[0].getItems();
            if (!items.length) return;
            var oldTimeLimit = Date.now() - 9e5, update = false;
            _.each(items, function(item) {
                var effectiveTime = item.properties.attributes.schedule.effectiveTime;
                oldTimeLimit > effectiveTime && item.properties.attributes.enabled && (update = true);
            });
            update && this._loadTrips();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;