function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tripcard/" + s : s.substring(0, index) + "/ma.car.app.tripcard/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tripcard");
    this.__widgetId = "ma.car.app.tripcard";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "noTrips";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        width: "92%",
        height: Ti.UI.SIZE,
        visible: "false",
        layout: "vertical",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.labelBigTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_notrips_label"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "labelBigTitle"
    });
    $.__views.layout.add($.__views.labelBigTitle);
    $.__views.__alloyId1022 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        backgroundColor: "#fff",
        id: "__alloyId1022"
    });
    $.__views.layout.add($.__views.__alloyId1022);
    $.__views.__alloyId1023 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        id: "__alloyId1023"
    });
    $.__views.__alloyId1022.add($.__views.__alloyId1023);
    $.__views.__alloyId1024 = Ti.UI.createImageView({
        defaultImage: "/images/notrips.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/notrips.png",
        id: "__alloyId1024"
    });
    $.__views.__alloyId1023.add($.__views.__alloyId1024);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "layoutInner"
    });
    $.__views.__alloyId1022.add($.__views.layoutInner);
    $.__views.__alloyId1025 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1025"
    });
    $.__views.layoutInner.add($.__views.__alloyId1025);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_notrip_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId1025.add($.__views.labelTitle);
    $.__views.__alloyId1026 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1026"
    });
    $.__views.layoutInner.add($.__views.__alloyId1026);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_notrip_message"),
        id: "labelMessage"
    });
    $.__views.__alloyId1026.add($.__views.labelMessage);
    $.__views.__alloyId1027 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1027"
    });
    $.__views.layoutInner.add($.__views.__alloyId1027);
    $.__views.btn = require("/ui/common/custom_button").createButton({
        width: Ti.UI.FILL,
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "btn",
        indicator: "true"
    });
    $.__views.__alloyId1027.add($.__views.btn);
    $.__views.__alloyId1028 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1028"
    });
    $.__views.btn.add($.__views.__alloyId1028);
    $.__views.__alloyId1029 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1029"
    });
    $.__views.__alloyId1028.add($.__views.__alloyId1029);
    $.__views.btnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_notrip_btn"),
        id: "btnLabel"
    });
    $.__views.__alloyId1029.add($.__views.btnLabel);
    $.__views.__alloyId1030 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1030"
    });
    $.__views.layoutInner.add($.__views.__alloyId1030);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var MessageController = require(WPATH("messageControllerBuilder")), args = arguments[0] || {}, tripcard = args.tripcard;
    exports = MessageController.create($, tripcard, "noTrips");
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;