function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tripcard/" + s : s.substring(0, index) + "/ma.car.app.tripcard/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tripcard");
    this.__widgetId = "ma.car.app.tripcard";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripConfirmation";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        visible: "false",
        height: Ti.UI.SIZE,
        top: 0,
        layout: "vertical",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.tripCardTitle = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: 0,
        id: "tripCardTitle"
    });
    $.__views.layoutContainer.add($.__views.tripCardTitle);
    $.__views.cardContainer = Ti.UI.createView({
        height: Ti.UI.SIZE,
        top: "10dp",
        left: "8dp",
        right: "8dp",
        borderRadius: "3dp",
        id: "cardContainer"
    });
    $.__views.layoutContainer.add($.__views.cardContainer);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "55dp",
        width: Ti.UI.FILL,
        zIndex: 100,
        layout: "vertical",
        backgroundColor: "#fff",
        id: "header"
    });
    $.__views.cardContainer.add($.__views.header);
    $.__views.__alloyId1031 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1031"
    });
    $.__views.header.add($.__views.__alloyId1031);
    $.__views.__alloyId1032 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        top: "6dp",
        id: "__alloyId1032"
    });
    $.__views.header.add($.__views.__alloyId1032);
    $.__views.tripTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId1032.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#666",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "origin"
    });
    $.__views.__alloyId1032.add($.__views.origin);
    $.__views.__alloyId1033 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId1033"
    });
    $.__views.header.add($.__views.__alloyId1033);
    $.__views.tripType = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId1033.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#666",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "destination"
    });
    $.__views.__alloyId1033.add($.__views.destination);
    $.__views.container = Ti.UI.createView({
        top: "55dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        backgroundColor: "#fff",
        id: "container"
    });
    $.__views.cardContainer.add($.__views.container);
    $.__views.mapWrapper = Ti.UI.createView({
        top: "10dp",
        width: Ti.UI.FILL,
        borderRadius: 0,
        height: "60dp",
        id: "mapWrapper"
    });
    $.__views.container.add($.__views.mapWrapper);
    $.__views.mapImage = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "mapImage"
    });
    $.__views.mapWrapper.add($.__views.mapImage);
    $.__views.__alloyId1034 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1034"
    });
    $.__views.container.add($.__views.__alloyId1034);
    $.__views.__alloyId1035 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1035"
    });
    $.__views.container.add($.__views.__alloyId1035);
    $.__views.lblContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "lblContainer"
    });
    $.__views.container.add($.__views.lblContainer);
    $.__views.lblView = Ti.UI.createView({
        height: Ti.UI.SIZE,
        left: "10dp",
        width: "94%",
        layout: "horizontal",
        id: "lblView"
    });
    $.__views.lblContainer.add($.__views.lblView);
    $.__views.lblViewBack = Ti.UI.createView({
        visible: false,
        height: 0,
        id: "lblViewBack"
    });
    $.__views.lblContainer.add($.__views.lblViewBack);
    $.__views.__alloyId1036 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1036"
    });
    $.__views.container.add($.__views.__alloyId1036);
    $.__views.__alloyId1037 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "__alloyId1037"
    });
    $.__views.container.add($.__views.__alloyId1037);
    $.__views.btnEditTrip = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnEditTrip"
    });
    $.__views.__alloyId1037.add($.__views.btnEditTrip);
    $.__views.__alloyId1038 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1038"
    });
    $.__views.btnEditTrip.add($.__views.__alloyId1038);
    $.__views.__alloyId1039 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1039"
    });
    $.__views.__alloyId1038.add($.__views.__alloyId1039);
    $.__views.btnFirstLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_trip_edit_trip"),
        id: "btnFirstLabel"
    });
    $.__views.__alloyId1039.add($.__views.btnFirstLabel);
    $.__views.btnPlanTrip = require("/ui/common/custom_button").createButton({
        right: 0,
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        title: "",
        id: "btnPlanTrip"
    });
    $.__views.__alloyId1037.add($.__views.btnPlanTrip);
    $.__views.__alloyId1040 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1040"
    });
    $.__views.btnPlanTrip.add($.__views.__alloyId1040);
    $.__views.__alloyId1041 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1041"
    });
    $.__views.__alloyId1040.add($.__views.__alloyId1041);
    $.__views.btnSecondLabel = Ti.UI.createLabel({
        color: "white",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_decision_future_button"),
        id: "btnSecondLabel"
    });
    $.__views.__alloyId1041.add($.__views.btnSecondLabel);
    $.__views.__alloyId1042 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1042"
    });
    $.__views.container.add($.__views.__alloyId1042);
    $.__views.__alloyId1043 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId1043"
    });
    $.__views.container.add($.__views.__alloyId1043);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), utils = require("utils/utils"), appSound = require("/utils/appSound"), args = arguments[0] || {}, tripcard = args.tripcard;
    var _tripConfirmedSound = null;
    exports = new (require(WPATH("cardTemplate")).extend($, {
        tripcard: tripcard,
        cardName: "tripConfirmation",
        customAnimation: false,
        _trip: null,
        _bookings: null,
        events: {
            "click btnConfirm": "_confirmEvent",
            "click btnEditTrip": "_editEvent",
            "click mapWrapper": "_openMapEvent"
        },
        configure: function() {
            TM.push(function() {
                appSound.prepare("confirmed", "aac");
            });
            tripcard.on("tripcard.show.ErrorDialog", this._restoreButtonState);
        },
        _restoreButtonState: function() {
            $.btnPlanTrip.applyProperties({
                touchEnabled: true
            });
            $.btnPlanTrip.stopIndicator();
        },
        _openMapEvent: function(e) {
            tripcard.whisper("tripcard.open.map", {
                trip: this._trip
            });
        },
        _editEvent: function(e) {},
        _confirmEvent: function(e) {
            appSound.play("confirmed");
            var matrix;
            var _animation;
            var self;
        },
        prepareView: function(options) {
            var trip = options.trip, availableScreenHeight = options.availableScreenHeight;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.address);
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            if (this._bookings) {
                $.tripCardTitle.setText(L("widget_samantha_your_booked_trip_title"));
                this._createCaptionLabel(this._bookings);
            } else {
                $.tripCardTitle.setText(L("widget_samantha_your_next_trip_title"));
                this._createCaptionLabel(null);
            }
            this.requestStaticMapImgAndResizeMap(trip, availableScreenHeight);
            this._restoreButtonState();
        },
        display: function(options) {
            if (!options.trip) return;
            this._trip = options.trip;
            this._bookings = options.bookings;
            this.prepareView(options);
            $.layoutContainer.show();
        },
        disappearWithAnimation: function(callback) {
            var self = this;
            $.container.animate({
                top: "-" + $.container.size.height + "dp"
            }, function() {
                $.container.applyProperties({
                    top: "-" + $.container.size.height + "dp"
                });
                $.layoutContainer.hide();
                callback && _.isFunction(callback) && callback();
                tripcard.removeCard(self.cardName);
            });
        },
        _createCaptionLabel: function(bookings) {
            $.lblView.removeAllChildren();
            var self = this;
            if (bookings) if ("RIDE" === this._trip.type) {
                var booking = null;
                for (var i = 0; i < bookings.length; i++) bookings[i].trip.baseTrip.creationTime === this._trip.creationTime && (booking = bookings[i]);
                if (booking) {
                    var labelView1 = this.linkLabel(booking.driver.alias);
                    $.lblView.add(labelView1);
                    var label2 = this.textLabel(" is driving");
                    $.lblView.add(label2);
                    var userId = booking.driver.userId;
                    labelView1.addEventListener("click", function() {
                        self._openProfile(userId);
                    });
                }
            } else {
                var riders = [];
                for (var i = 0; i < bookings.length; i++) bookings[i].trip.baseTrip.creationTime == this._trip.creationTime && riders.indexOf(bookings[i].rider.userId) < 0 && riders.push(bookings[i].rider.userId);
                riders.length > 0 && ($.lblView.visible = false);
                for (var i = 0; i < riders.length; i++) {
                    var labelView1 = this.linkLabel(bookings[i].rider.alias);
                    $.lblView.add(labelView1);
                    labelView1.userId = bookings[i].rider.userId;
                    labelView1.addEventListener("click", function() {
                        self._openProfile(this.userId);
                    });
                    if (riders.length > 1) if (i < riders.length - 2) {
                        var label2 = this.textLabel(",");
                        $.lblView.add(label2);
                    } else if (i == riders.length - 2) {
                        var label2 = this.textLabel(" and ");
                        $.lblView.add(label2);
                    }
                }
                if (riders.length > 0) {
                    var text = "have booked this trip with you";
                    var words = text.split(" ");
                    for (var i = 0; i < words.length; i++) {
                        var label3 = this.textLabel(" " + words[i]);
                        $.lblViewBack.add(label3);
                    }
                    setTimeout(function() {
                        var children = $.lblViewBack.getChildren();
                        $.lblViewBack.removeAllChildren();
                        $.lblViewBack.setHeight(0);
                        var width = 0;
                        for (var i = 0; i < children.length; i++) $.lblView.add(children[i]);
                        $.lblView.visible = true;
                    }, 1e3);
                }
            } else {
                var labelView1 = this.linkLabel("Share your trip");
                $.lblView.add(labelView1);
                var label2 = this.textLabel(" with your friends");
                $.lblView.add(label2);
                labelView1.addEventListener("click", this._openNativeShare);
            }
        },
        textLabel: function(text) {
            var label = Ti.UI.createLabel({
                text: text,
                color: "#666",
                height: "15dp",
                width: Ti.UI.SIZE,
                wordwrap: true,
                font: {
                    fontSize: "15dp"
                }
            });
            return label;
        },
        linkLabel: function(text) {
            var label = Ti.UI.createLabel({
                top: 0,
                text: text,
                color: Alloy.Globals.Style.Color.LightBlue,
                font: {
                    fontSize: "15dp"
                }
            });
            var decoratedView = Titanium.UI.createView({
                width: Titanium.UI.SIZE,
                height: Titanium.UI.SIZE,
                layout: "vertical",
                left: 0
            });
            decoratedView.add(label);
            setTimeout(function() {
                var lineView = Titanium.UI.createView({
                    width: label.getSize().width,
                    left: label.left,
                    height: 1,
                    backgroundColor: label.color ? label.color : "white",
                    top: -1,
                    bottom: 0
                });
                decoratedView.add(lineView);
            }, 1e3);
            return decoratedView;
        },
        _openNativeShare: function() {
            require("/ui/common/sharing").shareByNative();
        },
        _openProfile: function(userId) {
            Ti.App.fireEvent("carma:profile.open", {
                userId: userId
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;