function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.verification/" + s : s.substring(0, index) + "/ma.car.app.verification/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.verification");
    this.__widgetId = "ma.car.app.verification";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.verifyContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "verifyContainer"
    });
    $.__views.verifyContainer && $.addTopLevelView($.__views.verifyContainer);
    $.__views.__alloyId34 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId34"
    });
    $.__views.verifyContainer.add($.__views.__alloyId34);
    $.__views.__alloyId35 = Ti.UI.createScrollView({
        id: "__alloyId35"
    });
    $.__views.verifyContainer.add($.__views.__alloyId35);
    $.__views.verifyView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        bottom: 0,
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: "320dp",
        id: "verifyView"
    });
    $.__views.__alloyId35.add($.__views.verifyView);
    $.__views.__alloyId36 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "90dp",
        left: 0,
        height: "50dp",
        text: L("widget_signup_verify_subtitle"),
        id: "__alloyId36"
    });
    $.__views.verifyView.add($.__views.__alloyId36);
    $.__views.verifyCode = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        top: "140dp",
        left: 0,
        keyboardType: Ti.UI.KEYBOARD_NUMBER_PAD,
        hintText: L("widget_signup_input_hint_verify"),
        id: "verifyCode"
    });
    $.__views.verifyView.add($.__views.verifyCode);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        width: "100%",
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "210dp",
        title: L("widget_signup_button_submit"),
        id: "submit"
    });
    $.__views.verifyView.add($.__views.submit);
    $.__views.__alloyId37 = Ti.UI.createView({
        top: "270dp",
        height: "50dp",
        width: "100%",
        id: "__alloyId37"
    });
    $.__views.verifyView.add($.__views.__alloyId37);
    $.__views.skip = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: 0,
        height: "50dp",
        text: L("widget_signup_button_skip"),
        id: "skip"
    });
    $.__views.__alloyId37.add($.__views.skip);
    $.__views.resend = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        right: 0,
        height: "50dp",
        text: L("widget_signup_sms_verify_resend"),
        id: "resend"
    });
    $.__views.__alloyId37.add($.__views.resend);
    $.__views.skipConfirm = Ti.UI.createAlertDialog({
        message: L("widget_signup_sms_verify_resend_alert"),
        buttonNames: [ L("btn_ok") ],
        id: "skipConfirm"
    });
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, ui = require("/utils/ui"), parentWindow = ui.getWindow(args.__parentSymbol), Q = require("vendor/q"), ErrorDialog = require("/ui/common/validation_error"), AnimatedBottomView = require("/ui/common/animated_bottom_view");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click submit": "_verify",
            "click skip": "_confirmSkip",
            "click skipConfirm": "_skip",
            "click resend": "_resendCode"
        },
        initialize: function() {
            _.bindAll(this, "_displayVerifyError", "_handleVerifyError");
            this._startAccountVerification();
            this._prepareView();
        },
        configure: function() {
            require("/vendor/meld").after(this, "_confirmSkip", function() {
                var event = require("/tracking/tracking_event");
                require("/tracking/tracking_manager").track(event.SIGNUP_SKIP_PHONE_VALIDATION);
            });
            var locale = Ti.Locale.getCurrentLocale();
            "string" == typeof locale && "-" === locale.charAt(2) && (locale = locale.substr(0, 2) + "_" + locale.substr(3));
            require("services/preferences_service").updateLanguage(locale).then(function() {
                LOGGER.info("preferences_service udpate langauage!");
            });
        },
        _prepareView: function() {
            return;
        },
        _verify: function() {
            this._startSpinner().then(this._confirmVerification).then(this._handleVerified).catch(this._handleVerifyError).finally(this._stopSpinner);
        },
        _confirmSkip: function() {
            $.skipConfirm.show();
        },
        _skip: function() {
            this._handleVerified();
        },
        _resendCode: function() {
            this._startAccountVerification();
        },
        _startSpinner: function() {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return true;
            });
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _handleRequestError: function() {
            Ti.UI.createAlertDialog({
                title: L("error_title"),
                message: L("widget_verification_msg_request_error")
            }).show();
            args.nav && args.nav.back();
        },
        _displayVerifyError: function() {
            $.verifyCode.showError(L("widget_verification_invalid_code"));
            ErrorDialog.show();
            parentWindow.removeAppEventListener("carma:progress.stopped", this._displayVerifyError);
        },
        _handleVerifyError: function() {
            parentWindow.addAppEventListener("carma:progress.stopped", this._displayVerifyError);
        },
        _handleVerified: function() {
            Alloy.createWidget("ma.car.app.addcommute", "widget", {
                requirePhoto: args.requirePhoto,
                justSignup: true
            }).getView().open();
            setTimeout(function() {
                var _window = require("/utils/ui").getWindow($.verifyContainer);
                _window && _window.close && _window.close();
            }, 3e3);
        },
        _requestVerification: function() {
            var resourceOwner = require("services/resource_owner_service").singleton();
            return Alloy.createModel("verification", {
                userId: resourceOwner.get("userId"),
                type: "PHONE_NUMBER"
            }).save();
        },
        _confirmVerification: function() {
            var resourceOwner = require("services/resource_owner_service").singleton(), code = $.verifyCode.value.trim();
            return Alloy.createModel("verification_confirm", {
                userId: resourceOwner.get("userId"),
                key: code
            }).fetch();
        },
        _startAccountVerification: function() {
            this._startSpinner().then(this._requestVerification).catch(this._handleRequestError).finally(this._stopSpinner);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;