"use strict";

var facebookManager = require("facebook/facebook_manager");

var loginWithFacebook = function(webview, accessToken, data) {
    webview.native2web("avego.rtr.utils.NativeAppConnector.facebookConnected", [ {
        accessToken: accessToken
    } ]);
    webview.native2web("avego.rtr.utils.NativeAppConnector.facebookMyInformationGot", [ data ]);
};

module.exports = {
    init: function(webview) {
        webview.addWeb2NativeHandler("webapppushtest://loginWithFacebook", function() {
            facebookManager.login({
                success: function(reponse) {
                    loginWithFacebook(webview, reponse.token, reponse.user);
                },
                error: function(e) {
                    LOGGER.error("[bridge_facebook] - facebook login error: " + JSON.stringify(e));
                }
            });
        });
    }
};