"use strict";

module.exports = {
    properties: {},
    init: function() {
        var file = null;
        if (true && Ti.Filesystem.isExternalStoragePresent()) var file = Ti.Filesystem.getFile(Ti.Filesystem.externalStorageDirectory, "instrument.json"); else var file;
        try {
            if (!file || !file.exists()) return;
            var blob = file.read();
            var content = blob.text;
            if (content) {
                this.properties = JSON.parse(content);
                console.log("INSTRUMENTING APP:\n" + content);
            }
            file = null;
            blob = null;
        } catch (e) {
            console.log(e);
        }
    }
};

module.exports.init();