"use strict";

function isIOSRetina() {
    return false;
}

function isIOSLowRes() {
    return false;
}

module.exports = {
    pixelToDip: function(pixel) {
        if (isIOSRetina()) return pixel / 2;
        if (isIOSLowRes()) return pixel;
        var dpi = Ti.Platform.displayCaps.dpi;
        if (dpi > 160) return Math.round(pixel / (dpi / 160));
        return pixel;
    },
    dipToPixel: function(dp) {
        if (isIOSRetina()) return 2 * dp;
        if (isIOSLowRes()) return dp;
        var dpi = Ti.Platform.displayCaps.dpi;
        if (dpi > 160) return Math.round(dp * (dpi / 160));
        return dp;
    },
    dipToSystemUnit: function(dp) {
        return module.exports.dipToPixel(dp);
    },
    SystemUnitToDip: function(dp) {
        return module.exports.pixelToDip(dp);
    }
};