"use strict";

module.exports = {
    getFavouriteLocations: function() {
        var resourceOwner = require("services/resource_owner_service").singleton(), userId = resourceOwner.get("userId");
        return Alloy.createModel("favourite_locations", {
            userId: userId
        }).fetch();
    },
    getOfflineFavouriteLocations: function() {
        var resourceOwner = require("services/resource_owner_service").singleton(), userId = resourceOwner.get("userId");
        return Alloy.createModel("favourite_locations", {
            userId: userId
        }).fetch({
            localOnly: true
        });
    }
};