"use strict";

module.exports = {
    tactile: function(component, targetComponent) {
        var target = targetComponent ? targetComponent : component;
        target.addEventListener("touchstart", function() {
            false !== target.enabled && "false" !== target.enabled && component.animate({
                autoreverse: true,
                duration: 100,
                transform: Ti.UI.create2DMatrix({
                    scale: .7
                })
            });
        });
    }
};