module.exports = {
    createAlertWindow: function(spec) {
        var win = Ti.UI.createWindow({
            navBarHidden: true,
            transparentBackground: true,
            backgroundColor: "transparent",
            backgroundImage: null,
            opacity: 1,
            modal: false
        });
        win.addEventListener("open", function(e) {
            var dialog = Ti.UI.createAlertDialog(spec);
            dialog.addEventListener("click", function(e) {
                win.close();
            });
            dialog.show();
        });
        win.show = function() {
            win.open();
        };
        return win;
    }
};