"use strict";

var PasswordToggle = function($container, $password, $toggle, $ticker) {
    var _isPasswordShown = false;
    var _togglePassword = function() {
        if ($password.isErrorState) return;
        $password.blur();
        setTimeout(function() {
            var password = $password.value;
            if (_isPasswordShown) {
                $toggle.backgroundColor = "transparent";
                $toggle.borderColor = "#fff";
                $ticker.visible = false;
                $password.passwordMask = true;
            } else {
                $toggle.backgroundColor = "#fff";
                $toggle.borderColor = Alloy.Globals.Style.Color.LightBlue;
                $ticker.visible = true;
                $password.passwordMask = false;
            }
            $password.setSelection(password.length, password.length);
            _isPasswordShown = !_isPasswordShown;
        }, 100);
    };
    $container.addEventListener("click", _togglePassword);
};

module.exports = PasswordToggle;