"use strict";

var RatingStars = function(args) {
    var view = Ti.UI.createView(args);
    for (var i = 0; 5 > i; i++) {
        var star = Ti.UI.createLabel({
            font: args.font,
            text: args.text,
            color: "#ccc"
        });
        view.add(star);
    }
    view.setRating = function(rating) {
        var ratingInStars = Math.round(5 * rating);
        if (1 > ratingInStars) return;
        for (var i = 0; ratingInStars > i; i++) this.children[i].color = Alloy.Globals.Style.Color.Yellow;
    };
    return view;
};

exports.createView = function(args) {
    return new RatingStars(args);
};