"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend");

var DriveCollection = Backbone.Collection.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "DriveCollection"
    },
    initialize: function() {
        this.comparator = function(drive) {
            return drive.get("startTimestamp");
        };
    },
    validate: function() {}
});

module.exports = DriveCollection;