"use strict";

var CurrentUserService = function() {
    Object.defineProperty(this, "id", {
        get: function() {
            return require("/services/resource_owner_service").singleton().get("userId");
        },
        set: function() {
            throw new Error("Can't set user Id");
        }
    });
    Object.defineProperty(this, "token", {
        get: function() {
            var token = require("/services/resource_owner_service").singleton().get("token");
            return token.token;
        },
        set: function() {
            throw new Error("Can't set user Token");
        }
    });
};

module.exports = CurrentUserService;