"use strict";

var _ = require("/vendor/underscore");

var ModelFactory = {
    getClass: function(moduleName, modelName) {
        var modulePath = _.template("/v6/<%= module %>/models/<%= name %>", {
            module: moduleName,
            name: modelName
        });
        var module = require(modulePath);
        return module;
    }
};

module.exports = ModelFactory;