"use strict";

var _ = require("/vendor/underscore");

var SerializedModel = function(options) {
    options = options || {};
    options.data = options.data || {};
    if ("string" != typeof options.model || !options.model) throw new Error("SerializedModel.model should be a valid string");
    if ("string" != typeof options.module || !options.module) throw new Error("SerializedModel.module should be a valid string");
    return {
        module: options.module,
        model: options.model,
        modelFactory: options.modelFactory,
        referenceOf: options.referenceOf,
        data: options.data
    };
};

module.exports = SerializedModel;