"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend");

var Schedule = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "profile",
        name: "Schedule",
        fields: {
            daysOfOperation: {
                literal: true
            }
        }
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    validate: function() {}
});

module.exports = Schedule;