"use strict";

var _ = require("/vendor/underscore"), APICallType = require("/v6/network/entity/APICallType"), UIMessageTypes = require("/v6/uiMessenger/entity/UIMessageTypes");

var ProfileApiResponseStrategies = function(currentUser) {
    var success = {}, error = {};
    success[APICallType.FullUserProfile] = function(apiCall, response) {
        return response;
    };
    error[APICallType.FullUserProfile] = function(apiCall, networkError) {};
    success[APICallType.BasicUserProfile] = function(apiCall, response) {
        return response;
    };
    error[APICallType.BasicUserProfile] = function(apiCall, networkError) {};
    success[APICallType.GetTrips] = function(apiCall, response) {
        return response;
    };
    error[APICallType.GetTrips] = function(apiCall, networkError) {};
    success[APICallType.GetCreditCards] = function(apiCall, response) {
        return response;
    };
    error[APICallType.GetCreditCards] = function(apiCall, networkError) {};
    return {
        success: success,
        error: error
    };
};

module.exports = ProfileApiResponseStrategies;