var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "AUTO_RIDE_ENABLE_PUSH_NOTIFICATION",
            enable: function() {
                var userId = require("services/resource_owner_service").singleton().get("userId"), options = _.extend({}, options, {
                    urlParams: {
                        userId: userId
                    }
                });
                return this.save({}, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("auto_ride_enable_push", exports.definition, []);

collection = Alloy.C("auto_ride_enable_push", exports.definition, model);

exports.Model = model;

exports.Collection = collection;