var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            cashOut: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").CASH_OUT, {
                    userId: require("/services/resource_owner_service").singleton().get("userId")
                });
                return this.save(null, options);
            }
        });
        return Model;
    }
};

model = Alloy.M("credit_withdrawal", exports.definition, []);

collection = Alloy.C("credit_withdrawal", exports.definition, model);

exports.Model = model;

exports.Collection = collection;