var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "favourite_locations",
            merge: false,
            personal: true
        },
        idAttribute: "userId"
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: url.USER_FAVOURITE_LOCATIONS,
            parse: function(response) {
                delete response.paginator;
                return response;
            }
        });
        return Model;
    }
};

model = Alloy.M("favourite_locations", exports.definition, []);

collection = Alloy.C("favourite_locations", exports.definition, model);

exports.Model = model;

exports.Collection = collection;