var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "FAVOURITE_USER_COUNT",
            parse: function(response) {
                return {
                    count: response && response.paginator ? response.paginator.totalResults : 0
                };
            }
        });
        return Model;
    }
};

model = Alloy.M("favourite_user_count", exports.definition, []);

collection = Alloy.C("favourite_user_count", exports.definition, model);

exports.Model = model;

exports.Collection = collection;