var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        },
        background: true
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "MESSAGE_STATISTICS"
        });
        return Model;
    }
};

model = Alloy.M("message_statistics", exports.definition, []);

collection = Alloy.C("message_statistics", exports.definition, model);

exports.Model = model;

exports.Collection = collection;