var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        },
        background: true
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "TRACKING_EVENT_CONFIG"
        });
        return Model;
    }
};

model = Alloy.M("tracking_config", exports.definition, []);

collection = Alloy.C("tracking_config", exports.definition, model);

exports.Model = model;

exports.Collection = collection;