var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

var url = require("/carmalib/url");

exports.definition = {
    config: {
        adapter: {
            type: "persistentrest",
            persistentType: "nosql",
            collectionName: "user",
            merge: false,
            personal: true
        },
        idAttribute: "userId"
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "USER"
        });
        return Model;
    }
};

model = Alloy.M("user", exports.definition, []);

collection = Alloy.C("user", exports.definition, model);

exports.Model = model;

exports.Collection = collection;