var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

"use strict";

exports.definition = {
    config: {
        adapter: {
            type: "restapi"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            url: "INFORMATION_CARDS",
            getCards: function(options) {
                options = options || {};
                options.url = _.template(require("/carmalib/url").INFORMATION_CARDS, {
                    userId: options.userId
                });
                options.lat && options.lon && (options.url = options.url + "?lat=" + options.lat + "&lon=" + options.lon);
                return this.fetch(options);
            }
        });
        return Model;
    }
};

model = Alloy.M("user_information_cards", exports.definition, []);

collection = Alloy.C("user_information_cards", exports.definition, model);

exports.Model = model;

exports.Collection = collection;