function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "schedule";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.scheduleContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        id: "scheduleContainer"
    });
    $.__views.scheduleContainer && $.addTopLevelView($.__views.scheduleContainer);
    $.__views.daysTimePicker = Ti.UI.createView({
        width: "91.66666666666666%",
        layout: "vertical",
        height: "180dp",
        bottom: "5dp",
        id: "daysTimePicker"
    });
    $.__views.scheduleContainer.add($.__views.daysTimePicker);
    $.__views.__alloyId5 = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_add_commute_schedule"),
        font: {
            fontSize: "18dp"
        },
        bottom: "15dp",
        left: 0,
        id: "__alloyId5"
    });
    $.__views.daysTimePicker.add($.__views.__alloyId5);
    $.__views.weekdays = Ti.UI.createView({
        layout: "horizontal",
        height: "50dp",
        id: "weekdays"
    });
    $.__views.daysTimePicker.add($.__views.weekdays);
    $.__views.sunday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "4dp",
        width: "38dp",
        height: "38dp",
        backgroundColor: "transparent",
        backgroundImage: "none",
        color: "#fff",
        title: L("sunday_single_capital"),
        id: "sunday"
    });
    $.__views.weekdays.add($.__views.sunday);
    $.__views.monday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "4dp",
        width: "38dp",
        height: "38dp",
        backgroundColor: "#fff",
        backgroundImage: "none",
        color: "#6699ff",
        title: L("monday_single_capital"),
        id: "monday",
        selected: "true"
    });
    $.__views.weekdays.add($.__views.monday);
    $.__views.tuesday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "4dp",
        width: "38dp",
        height: "38dp",
        backgroundColor: "#fff",
        backgroundImage: "none",
        color: "#6699ff",
        title: L("tuesday_single_capital"),
        id: "tuesday",
        selected: "true"
    });
    $.__views.weekdays.add($.__views.tuesday);
    $.__views.wednesday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "4dp",
        width: "38dp",
        height: "38dp",
        backgroundColor: "#fff",
        backgroundImage: "none",
        color: "#6699ff",
        title: L("wednesday_single_capital"),
        id: "wednesday",
        selected: "true"
    });
    $.__views.weekdays.add($.__views.wednesday);
    $.__views.thursday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "4dp",
        width: "38dp",
        height: "38dp",
        backgroundColor: "#fff",
        backgroundImage: "none",
        color: "#6699ff",
        title: L("thursday_single_capital"),
        id: "thursday",
        selected: "true"
    });
    $.__views.weekdays.add($.__views.thursday);
    $.__views.friday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: "4dp",
        width: "38dp",
        height: "38dp",
        backgroundColor: "#fff",
        backgroundImage: "none",
        color: "#6699ff",
        title: L("friday_single_capital"),
        id: "friday",
        selected: "true"
    });
    $.__views.weekdays.add($.__views.friday);
    $.__views.saturday = Ti.UI.createButton({
        borderColor: "#ffffff",
        borderWidth: 1,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        right: 0,
        width: "38dp",
        height: "38dp",
        backgroundColor: "transparent",
        backgroundImage: "none",
        color: "#fff",
        title: L("saturday_single_capital"),
        id: "saturday"
    });
    $.__views.weekdays.add($.__views.saturday);
    $.__views.timepickerContainer = Ti.UI.createView({
        layout: "horizontal",
        top: "6dp",
        height: "85dp",
        id: "timepickerContainer"
    });
    $.__views.daysTimePicker.add($.__views.timepickerContainer);
    $.__views.__alloyId6 = Ti.UI.createView({
        width: "41.66666666666667%",
        layout: "vertical",
        id: "__alloyId6"
    });
    $.__views.timepickerContainer.add($.__views.__alloyId6);
    $.__views.departureLabel = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_add_commute_departure"),
        left: 0,
        bottom: "6dp",
        font: {
            fontSize: "12dp"
        },
        id: "departureLabel"
    });
    $.__views.__alloyId6.add($.__views.departureLabel);
    $.__views.departureAM = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        editable: false,
        left: 0,
        id: "departureAM"
    });
    $.__views.__alloyId6.add($.__views.departureAM);
    $.__views.__alloyId7 = Ti.UI.createView({
        width: "8.333333333333332%",
        id: "__alloyId7"
    });
    $.__views.timepickerContainer.add($.__views.__alloyId7);
    $.__views.__alloyId8 = Ti.UI.createView({
        width: "41.66666666666667%",
        layout: "vertical",
        id: "__alloyId8"
    });
    $.__views.timepickerContainer.add($.__views.__alloyId8);
    $.__views.returnLabel = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_add_commute_return"),
        left: 0,
        bottom: "6dp",
        font: {
            fontSize: "12dp"
        },
        id: "returnLabel"
    });
    $.__views.__alloyId8.add($.__views.returnLabel);
    $.__views.departurePM = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        editable: false,
        right: 0,
        id: "departurePM"
    });
    $.__views.__alloyId8.add($.__views.departurePM);
    $.__views.timePicker = Alloy.createWidget("ma.car.app.picker", "widget", {
        id: "timePicker",
        pickerType: Ti.UI.PICKER_TYPE_TIME,
        __parentSymbol: $.__views.scheduleContainer
    });
    $.__views.timePicker.setParent($.__views.scheduleContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Controller = require("/v6/infrastructure/Controller"), executor = require("utils/executor"), Navigation = Alloy.Globals.Nav.AddComute, stepsWidget = Alloy.Globals.StepsWidget;
    var ScheduleController = function($, TripService) {
        return {
            _location: require("gps/location"),
            _24HoursFormat: Ti.Platform.is24HourTimeFormat(),
            _departureAMTime: new Date(),
            _departurePMTime: new Date(),
            _datePickerId: "",
            TAG: "schedule",
            Q: require("vendor/q"),
            events: {
                "click sunday": "_handleDayClick",
                "click monday": "_handleDayClick",
                "click tuesday": "_handleDayClick",
                "click wednesday": "_handleDayClick",
                "click thursday": "_handleDayClick",
                "click friday": "_handleDayClick",
                "click saturday": "_handleDayClick",
                "click departureAM": "_openPicker",
                "click departurePM": "_openPicker"
            },
            initialize: function() {
                this._attachEventsListeners();
                this._setDefaults();
                stepsWidget.enableRightAction();
            },
            _attachEventsListeners: function() {
                var self = this;
                $.timePicker.addEventListener("close", function(params) {
                    var value = params && params.value ? params.value : $.timePicker.getValue();
                    if (!value || 0 > value) return;
                    var date = new Date(value), dateObject = "departureAM" === self._datePickerId ? self._departureAMTime : self._departurePMTime;
                    self._modifyDateObject(dateObject, date);
                    self._modifyDateTextfield(self._datePickerId, date);
                });
            },
            onOpened: function() {
                stepsWidget.setCurrentController(this);
            },
            _setDefaults: function() {
                this._departureAMTime.setHours(8);
                this._departureAMTime.setMinutes(0);
                this._departurePMTime.setHours(18);
                this._departurePMTime.setMinutes(0);
                this._modifyDateTextfield("departureAM", this._departureAMTime);
                this._modifyDateTextfield("departurePM", this._departurePMTime);
            },
            _modifyDateObject: function(dateObject, date) {
                dateObject.setHours(date.getHours());
                dateObject.setMinutes(date.getMinutes());
            },
            _modifyDateTextfield: function(textFieldId, date) {
                var textField = "departureAM" === textFieldId ? $.departureAM : $.departurePM;
                var string = !this._24HoursFormat && date.getHours() > 12 ? date.getHours() - 12 : date.getHours();
                string += ":";
                string += ("0" + date.getMinutes()).slice(-2);
                if (!this._24HoursFormat) {
                    string += " ";
                    string += date.getHours() > 12 ? "PM" : "AM";
                }
                textField.setValue(string);
            },
            onRightActionClick: function() {
                var tripObject = Ti.App.Properties.getObject("tripObject");
                tripObject.daysOfOperation = [ "true" === $.sunday.selected, "true" === $.monday.selected, "true" === $.tuesday.selected, "true" === $.wednesday.selected, "true" === $.thursday.selected, "true" === $.friday.selected, "true" === $.saturday.selected ];
                this._createTrips(tripObject);
            },
            _handleDayClick: function(params) {
                var button = params.source;
                if ("true" === button.selected) {
                    button.applyProperties({
                        backgroundColor: "transparent",
                        color: "#fff"
                    });
                    button.selected = "false";
                    return;
                }
                button.applyProperties({
                    backgroundColor: "#fff",
                    color: "#6699ff"
                });
                button.selected = "true";
            },
            _openPicker: function(params) {
                var height;
                this._datePickerId = params.source.id;
                var currentTime = "departureAM" === this._datePickerId ? this._departureAMTime : this._departurePMTime;
                $.timePicker.applyProperties({
                    format24: this._24HoursFormat
                });
                $.timePicker.open(currentTime);
            },
            _createTrip: function(alias, type, daysOfOperation, selectTime, origin, destination) {
                var resourceOwner = require("services/resource_owner_service").singleton();
                return TripService.saveTrip({
                    urlParams: {
                        userId: resourceOwner.get("userId")
                    },
                    type: type,
                    alias: alias,
                    origin: origin,
                    destination: destination,
                    schedule: TripService.createSchedule(daysOfOperation, selectTime),
                    enabled: true
                }).then(function() {
                    LOGGER.info("[Schedule - Trip created]");
                }).catch(function() {
                    alert("Sorry, failed to save the trip...");
                });
            },
            _createTrips: function(tripObject) {
                var self = this;
                var funcs = [];
                funcs.push(function() {
                    return self._createTrip("Commute In", tripObject.type, tripObject.daysOfOperation, self._departureAMTime, tripObject.origin, tripObject.destination);
                });
                funcs.push(function() {
                    return self._createTrip("Commute Back", tripObject.type, tripObject.daysOfOperation, self._departurePMTime, tripObject.destination, tripObject.origin);
                });
                funcs.push(function() {
                    Ti.App.Properties.removeProperty("tripObject");
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    Ti.App.Properties.setBool("carma.notrip." + resourceOwner.get("userId"), false);
                });
                funcs.push(function() {
                    var showBonusCoachmark = !!Navigation.get("justSignup");
                    Ti.App.fireEvent("carma:login.success", {
                        showBonusCoachmark: showBonusCoachmark,
                        callback: function() {
                            var _window = require("/utils/ui").getWindow($.scheduleContainer);
                            _window && _window.close && _window.close();
                        }
                    });
                });
                executor(funcs).errorMessage("Failed to create trips...").run();
            }
        };
    };
    ScheduleController.$inject = [ "View", "tripService" ];
    Controller.initialize(ScheduleController, $, arguments);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;