function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "selectDestination";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.addressContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        bottom: 0,
        width: "100%",
        id: "addressContainer"
    });
    $.__views.addressContainer && $.addTopLevelView($.__views.addressContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Navigation = Alloy.Globals.Nav.AddComute, event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), stepsWidget = Alloy.Globals.StepsWidget;
    exports = new (require("/carmalib/controller").extend($, {
        TAG: "selectDestination",
        _locationSelectionWidget: null,
        initialize: function() {
            _.bindAll(this, "_locationSelected");
            this._initLocationWidget();
        },
        _initLocationWidget: function() {
            this._locationSelectionWidget = Alloy.createWidget("ma.car.app.location", {
                label: L("widget_add_commute_destination"),
                hintText: L("widget_add_commute_destination_placeholder"),
                success: this._locationSelected
            });
            $.addressContainer.add(this._locationSelectionWidget.getView());
        },
        onRightActionClick: function() {
            analytics.track(event.SIGNUP_DESTINATION_SELECTED, {});
            Navigation.open(Alloy.createWidget("ma.car.app.addcommute", "schedule"), {
                rightAction: L("widget_picker_done")
            });
        },
        onOpened: function() {
            stepsWidget.setCurrentController(this);
            var tripObject = Ti.App.Properties.getObject("tripObject", {});
            if ("destination" in tripObject) {
                this._locationSelectionWidget.setAddress(tripObject.destination.address);
                stepsWidget.enableRightAction();
                return;
            }
            stepsWidget.disableRightAction();
        },
        _locationSelected: function(location) {
            var tripObject = Ti.App.Properties.getObject("tripObject");
            tripObject.destination = {
                latitude: location.lat,
                longitude: location.lon,
                address: location.address
            };
            Ti.App.Properties.setObject("tripObject", tripObject);
            stepsWidget.enableRightAction();
            this.onRightActionClick();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;