function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "selectRole";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.roleContainer = Ti.UI.createView({
        width: "100%",
        bottom: 0,
        id: "roleContainer"
    });
    $.__views.roleContainer && $.addTopLevelView($.__views.roleContainer);
    $.__views.roleSelector = Ti.UI.createView({
        width: "91.66666666666666%",
        layout: "vertical",
        height: Ti.UI.SIZE,
        bottom: "-5dp",
        id: "roleSelector"
    });
    $.__views.roleContainer.add($.__views.roleSelector);
    $.__views.driveOrRide = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_add_commute_select_role"),
        font: {
            fontSize: "18dp"
        },
        bottom: "35dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        left: 0,
        id: "driveOrRide"
    });
    $.__views.roleSelector.add($.__views.driveOrRide);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Navigation = Alloy.Globals.Nav.AddComute, event = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), stepsWidget = Alloy.Globals.StepsWidget;
    exports = new (require("/carmalib/controller").extend($, {
        _radioButtons: Alloy.createWidget("ma.car.app.radiobutton", {
            scrollable: false
        }),
        TAG: "selectRole",
        initialize: function() {
            this._radioButtons.addRadioButton(L("widget_add_commute_driver_role"), "DRIVE");
            this._radioButtons.addRadioButton(L("widget_add_commute_rider_role"), "RIDE");
            $.roleSelector.add(this._radioButtons.getView());
            this._attachEventListeners();
        },
        onRightActionClick: function() {
            analytics.track(event.SIGNUP_ROLE_SELECTED, {});
            Navigation.open(Alloy.createWidget("ma.car.app.addcommute", "selectOrigin"));
        },
        _attachEventListeners: function() {
            var self = this;
            this._radioButtons.addEventListener("click", function(params) {
                stepsWidget.enableRightAction();
                self.onRightActionClick();
                var tripObject = Ti.App.Properties.getObject("tripObject", {});
                tripObject.type = params.selected.value;
                Ti.App.Properties.setObject("tripObject", tripObject);
            });
        },
        onOpened: function() {
            stepsWidget.setCurrentController(this);
            stepsWidget.hideLeftAction();
            args.firstStep && Navigation.hideBackButton();
            var tripObject = Ti.App.Properties.getObject("tripObject", {});
            if ("type" in tripObject) {
                stepsWidget.enableRightAction();
                this._radioButtons.select(tripObject.type);
                return;
            }
            stepsWidget.disableRightAction();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;