function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.addcommute/" + s : s.substring(0, index) + "/ma.car.app.addcommute/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.addcommute");
    this.__widgetId = "ma.car.app.addcommute";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "whereDoYouLive";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.whereDoYouLiveContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        bottom: "50dp",
        width: "100%",
        id: "whereDoYouLiveContainer"
    });
    $.__views.whereDoYouLiveContainer && $.addTopLevelView($.__views.whereDoYouLiveContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, Navigation = Alloy.Globals.Nav.AddComute, ResourceOwner = require("services/resource_owner_service").singleton();
    BaseController = require("/carmalib/controller"), URL = require("/carmalib/url");
    var Controller = BaseController.extend($, {
        TAG: "whereDoYouLive",
        _locationSelectionWidget: null,
        initialize: function() {
            _.bindAll(this, "_nextAction", "_locationSelected");
            this._initLocationWidget();
        },
        _initLocationWidget: function() {
            this._locationSelectionWidget = Alloy.createWidget("ma.car.app.location", {
                label: L("widget_add_commute_whereDoYouLive"),
                hintText: L("widget_add_commute_whereDoYouLive_placeholder"),
                success: this._locationSelected
            });
            $.whereDoYouLiveContainer.add(this._locationSelectionWidget.getView());
        },
        _attachEventHandlers: function() {
            Navigation.addEventListener("nav.bar.right.clicked", this._nextAction);
            Navigation.addEventListener("nav.opencomplete", this._setupStep);
            Navigation.addEventListener("nav.backcomplete", this._setupStep);
        },
        _locationSelected: function(location) {
            var self = this, userId = ResourceOwner.get("userId"), email = ResourceOwner.get("email");
            var homeLocation = Alloy.createModel("home_location"), data = {
                address: location.address,
                longitude: location.lon,
                latitude: location.lat,
                accuracy: location.accuracy
            };
            homeLocation.save(data, {
                url: _.template(URL.USER_HOME_LOCATION, {
                    userId: userId
                })
            }).then(function() {
                Navigation.enableRightAction();
                self._nextAction({
                    tag: this.TAG
                });
            }).catch(function(e) {
                alert("Sorry. An Error has occurred!");
            }).done();
        },
        _nextAction: function(params) {
            var nextWidget = Alloy.createWidget("ma.car.app.addcommute", "pickPhoto");
            Navigation.open(nextWidget);
        }
    });
    exports = new Controller();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;