function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "carmaCrew";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.carmaCrew = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#ffffff",
        zIndex: 1,
        id: "carmaCrew"
    });
    $.__views.carmaCrew && $.addTopLevelView($.__views.carmaCrew);
    $.__views.tableHeader = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "55dp",
        backgroundColor: "transparent",
        id: "tableHeader"
    });
    $.__views.__alloyId40 = Ti.UI.createView({
        left: 0,
        bottom: 0,
        height: "55dp",
        backgroundColor: "transparent",
        id: "__alloyId40"
    });
    $.__views.tableHeader.add($.__views.__alloyId40);
    $.__views.headerBar = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "55dp",
        backgroundColor: "#eee",
        id: "headerBar"
    });
    $.__views.__alloyId40.add($.__views.headerBar);
    $.__views.vPhoneNumberDesc = Ti.UI.createView({
        left: 0,
        top: 0,
        visible: true,
        id: "vPhoneNumberDesc"
    });
    $.__views.headerBar.add($.__views.vPhoneNumberDesc);
    $.__views.lblPhoneNumber = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        left: Alloy.Globals.Style.Size.Width.pct4,
        bottom: 0,
        height: "50dp",
        text: L("widget_crew_subtitle1"),
        id: "lblPhoneNumber"
    });
    $.__views.vPhoneNumberDesc.add($.__views.lblPhoneNumber);
    $.__views.phoneNumber = Ti.UI.createView({
        right: Alloy.Globals.Style.Size.Width.pct4,
        width: Ti.UI.SIZE,
        height: "39dp",
        backgroundColor: "transparent",
        borderColor: "#333",
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "phoneNumber"
    });
    $.__views.vPhoneNumberDesc.add($.__views.phoneNumber);
    $.__views.__alloyId41 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_crew_driver_phone_number_button"),
        left: "12dp",
        right: "12dp",
        width: Ti.UI.SIZE,
        id: "__alloyId41"
    });
    $.__views.phoneNumber.add($.__views.__alloyId41);
    $.__views.vEnterPhoneNumber = Ti.UI.createView({
        left: 0,
        top: 0,
        visible: false,
        id: "vEnterPhoneNumber"
    });
    $.__views.headerBar.add($.__views.vEnterPhoneNumber);
    $.__views.txtPhoneNumber = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "40dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "13dp"
        },
        width: Alloy.Globals.Style.Size.Width.pct70,
        top: "5dp",
        left: Alloy.Globals.Style.Size.Width.pct4,
        hintText: L("widget_crew_driver_phone_number_placeholder"),
        keyboardType: Ti.UI.KEYBOARD_PHONE_PAD,
        returnKeyType: Ti.UI.RETURNKEY_GO,
        borderColor: "#a4a4a4",
        borderWidth: 1,
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS,
        id: "txtPhoneNumber"
    });
    $.__views.vEnterPhoneNumber.add($.__views.txtPhoneNumber);
    $.__views.lblSubmit = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "14dp"
        },
        top: "5dp",
        right: Alloy.Globals.Style.Size.Width.pct4,
        width: "70dp",
        height: "40dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("widget_crew_driver_phone_number_submit"),
        id: "lblSubmit"
    });
    $.__views.vEnterPhoneNumber.add($.__views.lblSubmit);
    $.__views.tableFooter = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        backgroundColor: "#fff",
        id: "tableFooter"
    });
    $.__views.footerContainer = Ti.UI.createView({
        top: "5dp",
        bottom: "5dp",
        left: "5dp",
        right: "5dp",
        backgroundColor: "#fff",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "footerContainer"
    });
    $.__views.tableFooter.add($.__views.footerContainer);
    $.__views.footerCaption = Ti.UI.createLabel({
        color: "#333",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        text: L("widget_crew_boarding_caption"),
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "footerCaption"
    });
    $.__views.footerContainer.add($.__views.footerCaption);
    $.__views.footerInstruction = Ti.UI.createLabel({
        color: "#333",
        bottom: "10dp",
        left: "10dp",
        right: "10dp",
        height: Ti.UI.SIZE,
        text: L("widget_crew_boarding_instraction"),
        font: {
            fontSize: "15dp"
        },
        id: "footerInstruction"
    });
    $.__views.footerContainer.add($.__views.footerInstruction);
    $.__views.crewTable = Ti.UI.createTableView({
        top: 0,
        left: 0,
        height: Ti.UI.FILL,
        backgroundColor: "#ffffff",
        separatorColor: "#ffffff",
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndicator: false,
        visible: true,
        needPullRefresh: true,
        headerView: $.__views.tableHeader,
        footerView: $.__views.tableFooter,
        id: "crewTable"
    });
    $.__views.carmaCrew.add($.__views.crewTable);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Controller = require("/v6/infrastructure/Controller"), Q = require("/vendor/q"), Queue = require("/utils/queue"), Validator = require("/validator/validator_factory"), ErrorDialog = require("/ui/common/validation_error"), errorCodes = require("services/error_codes"), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService");
    exports = new (require("/carmalib/controller").extend($, {
        BOARD_BY_PHONE: "PHONE",
        BOARD_BY_ID: "UID",
        _rowControllers: [],
        _headerState: null,
        _toggleHeaderThreshold: 0,
        _startTripInfo: null,
        _boardingStateMachine: null,
        events: {
            "scroll crewTable": "_onScroll",
            "click phoneNumber": "_showBoardByNumber",
            "click lblSubmit": "_boardingByPhonenumber",
            "return[android] txtPhoneNumber": "_boardingByPhonenumber",
            "touchstart crewTable": "_closeBoardByNumber",
            "touchstart tableHeader": "_closeBoardByNumber"
        },
        initialize: function() {
            _.bindAll(this, "_renderCrew", "_renderError", "_showBoardByNumber", "_boardingByPhonenumber", "_refresh");
            $.crewTable.addEventListener("didTriggeredRefresh", this._refresh);
            var self = this;
            TM.push(function() {
                self._refresh();
            });
            TM.push(function() {
                require(WPATH("count_down_animator")).get();
            });
        },
        setup: function() {
            this._startTripInfo = null;
        },
        setStateMachine: function(sm) {
            this._boardingStateMachine = sm;
        },
        getStartTripInfo: function() {
            return this._startTripInfo;
        },
        setStartTripInfo: function(tripInfo) {
            this._startTripInfo = tripInfo;
        },
        _refresh: function() {
            this.loadCarmaCrew().finally(this._finishedRefresh);
        },
        _finishedRefresh: function() {
            $.crewTable.cmMarkRefreshFinished && $.crewTable.cmMarkRefreshFinished();
        },
        _fetchUserCrew: function() {
            return require("/services/crew_service").getUserCrew();
        },
        _roundDistance: function(member) {
            member.relativeDistance && (member.relativeDistance = member.relativeDistance > 1e6 ? 1e5 * Math.round(member.relativeDistance / 1e5) : member.relativeDistance > 1e5 ? 1e4 * Math.round(member.relativeDistance / 1e4) : member.relativeDistance > 1e4 ? 1e3 * Math.round(member.relativeDistance / 1e3) : 100 * Math.round(member.relativeDistance / 100));
        },
        _numRows: function() {
            return $.crewTable.data && $.crewTable.data[0] && $.crewTable.data[0].rows ? $.crewTable.data[0].rows.length : 0;
        },
        _lastRendered: null,
        _previousRemoteCrew: null,
        _renderCrew: function(members) {
            _.each(members, this._roundDistance);
            var streamedMembers = JSON.stringify(members);
            if (this._lastRendered && this._lastRendered === streamedMembers) {
                LOGGER.debug("Crew hasn't changed, skipping updating remote crew");
                return;
            }
            this._lastRendered = streamedMembers;
            var self = this;
            TM.push(function() {
                var rows = self._getCrewTableRows(members);
                TM.push(function() {
                    $.crewTable.setData(rows);
                }, process.backgroundDomain);
            }, process.backgroundDomain);
        },
        _getSortedRowPosition: function(id, sortedList) {
            for (var i = 0; i < sortedList.length; i++) if (sortedList[i].id === id) return i + 1;
        },
        _sortCrewList: function(list) {
            var bookings = _.filter(list, function(member) {
                return "BOOKING" === member.reason;
            });
            bookings.length > 1 && (bookings = _.sortBy(bookings, function(member) {
                return member.name;
            }));
            var others = _.filter(list, function(member) {
                return "BOOKING" !== member.reason;
            });
            var sortedList = _.sortBy(others, function(member) {
                return member.name;
            });
            sortedList = bookings.concat(sortedList);
            return sortedList;
        },
        _createTableRowsForCrewMembers: function(members) {
            if (!members || 0 === members.length) return [];
            var self = this;
            var handleDriverSelection = function(e) {
                var index = self._getRowIndex(e.data.driver);
                index > -1 && self._selectRow(index);
            };
            members = this._sortCrewList(members);
            var rows = [];
            this._rowControllers = [];
            for (var i = 0; i < members.length; i++) {
                var driver = members[i];
                var rowController = Alloy.createWidget("ma.car.app.boardingv6", "crew_row", {
                    driver: driver,
                    isLastOne: i === members.length - 1
                });
                rowController.handleDriverSelection = handleDriverSelection;
                rowController.getView().userId = driver.id;
                this._rowControllers.push(rowController);
                rows.push(rowController.getView());
            }
            return rows;
        },
        _renderError: function(error) {
            LOGGER.error(error);
        },
        _showBoardByNumber: function() {
            $.vPhoneNumberDesc.visible = false;
            $.vEnterPhoneNumber.visible = true;
            $.txtPhoneNumber.focus();
            _.defer(function() {
                $.crewTable.scrollToTop(0);
            }, 200);
        },
        _changeBoardNumber: function() {
            LOGGER.info("Changing boarding number...");
            var phoneNumberField = this._getHeaderViewObject("txtPhoneNumber"), value = "" + phoneNumberField.value;
            if (value.match(/\d+/) || value.match(/[A-Za-z]+/i) || "" === value) return;
            phoneNumberField.value = value.replace(/[A-Za-z]/g, "");
        },
        _closeBoardByNumber: function(e) {
            if (!e || "txtPhoneNumber" !== e.source.id && "phoneNumber" !== e.source.id && "lblSubmit" !== e.source.id) {
                $.txtPhoneNumber.blur();
                $.vEnterPhoneNumber.visible = false;
                $.vPhoneNumberDesc.visible = true;
                $.txtPhoneNumber.value = "";
            }
        },
        loadCarmaCrew: function() {
            LOGGER.info("Loading Carma Crew");
            return Q().then(this._fetchUserCrew).progress(this._renderCrew).then(this._renderCrew).catch(this._renderError);
        },
        updateCarmaCrew: function() {
            LOGGER.info("Updating Carma Crew");
            Q().then(this._fetchUserCrew).then(this._renderCrew).catch(this._renderError);
        },
        _selectRow: function(index) {
            if (this._boardingStateMachine.isInTransition()) return;
            this.boardDriver({
                type: this.BOARD_BY_ID,
                driver: this._rowControllers[index].getDriver()
            });
        },
        _getRowIndex: function(id) {
            for (var i = 0; i < this._rowControllers.length; i++) if (this._rowControllers[i].getDriver().id === id) return i;
            return -1;
        },
        _shouldFixHeader: function(e) {
            return 0 !== e.firstVisibleItem;
        },
        _boardingByPhonenumber: function() {
            if ("9876543210" == $.txtPhoneNumber.getValue()) {
                Carma.Window.Tools || Alloy.createWidget("ma.car.app.tools").getView().open();
                return;
            }
            if ($.txtPhoneNumber.isErrorState || Validator.form().checkCustomTextFieldsEmpty([ $.txtPhoneNumber ])) {
                var self = this;
                TM.push(function() {
                    self.showErrorOnPhoneNumberField(L("widget_boarding_invalid_phone_number"));
                });
                ErrorDialog.show();
                return;
            }
            var resource_owner = require("services/resource_owner_service").singleton();
            var phone = $.txtPhoneNumber.value;
            if (Validator.phone().matchPhoneNumber(resource_owner.get("phoneNumber"), phone)) {
                ErrorDialog.showSimple(L("widget_boarding_entered_own_number_title"));
                return;
            }
            this.boardDriver({
                type: this.BOARD_BY_PHONE,
                phone: phone
            });
        },
        _isBalanceRunningLow: function() {
            var resourceOwner = require("services/resource_owner_service").singleton(), userId = resourceOwner.get("userId");
            var profile = ProfileService.getCachedProfile(userId);
            return parseFloat(profile.credit) <= 1;
        },
        showErrorOnPhoneNumberField: function(msg) {
            $.txtPhoneNumber.blur();
            $.txtPhoneNumber.showError(msg);
        },
        lowCreditPopup: function() {
            var dfd = Q.defer();
            var buttons = [ L("btn_cancel"), L("widget_boarding_no_credits_buy_now") ], cancelIndex = 0;
            buttons = [ L("widget_boarding_no_credits_buy_now"), L("btn_cancel") ];
            cancelIndex = 1;
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                message: L("widget_boarding_no_credits_message")
            });
            var self = this;
            dialog.addEventListener("click", function onClick(e) {
                dialog.removeEventListener("click", onClick);
                if (e.index !== cancelIndex) {
                    Ti.App.fireEvent("carma:topup.open", {
                        tab: "startTrip"
                    });
                    dfd.reject(new Error(errorCodes.ERROR_NOT_ENOUGH_CREDIT));
                } else dfd.reject(new Error(errorCodes.ERROR_NOT_ENOUGH_CREDIT));
            });
            dialog.show();
            return dfd.promise;
        },
        boardValidateLowCredit: function(driver) {
            if (!this._isBalanceRunningLow()) return Q();
            if (driver.type === this.BOARD_BY_PHONE) return this.lowCreditPopup();
            var dfd = Q.defer();
            var self = this;
            var checkProfile = function(driverProfile) {
                driverProfile && driverProfile.canUserGiveFreeDrive ? dfd.resolve() : Q().then(self.lowCreditPopup).then(function() {
                    dfd.resolve();
                }).catch(function(e) {
                    dfd.reject(new Error(errorCodes.ERROR_NOT_ENOUGH_CREDIT));
                });
                return dfd.promise;
            };
            var Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService");
            var cachedProfile = ProfileService.getCachedProfile(driver.driver.id);
            if (cachedProfile) return checkProfile(cachedProfile);
            ProfileService.getProfile(driver.driver.id, ProfileService.FULL_DETAIL).then(function(profile) {
                checkProfile(profile);
            }).catch(function(e) {
                dfd.reject(new Error(errorCodes.ERROR_NOT_ENOUGH_CREDIT));
            });
            return dfd.promise;
        },
        doBoard: function(trip) {
            TM.push(function() {
                Ti.Media.vibrate();
            });
            this._startTripInfo = trip;
            this._closeBoardByNumber();
            this._boardingStateMachine.transition(this._boardingStateMachine._TRANSITIONS.START_RIDE_TIMER);
        },
        boardDriver: function(driver) {
            var trip = Alloy.createModel("trip_state", {
                startTimestamp: Date.now(),
                role: "RIDER"
            });
            if (driver.type === this.BOARD_BY_PHONE) {
                trip.set("phone", driver.phone);
                trip.set("driver", {
                    phone: driver.phone
                });
            } else trip.set("driver", driver.driver);
            var self = this;
            Q().then(function() {
                return require(WPATH("location")).getContactLocation(trip, true);
            }).then(function(location) {
                if (location) {
                    location.latitude = location.latitude || location.lat;
                    location.longitude = location.longitude || location.lon;
                    delete location.lat;
                    delete location.lon;
                }
                trip.set("startLocation", location);
            }).then(function() {
                return self.boardValidateLowCredit(driver);
            }).then(function() {
                self.doBoard(trip);
            });
        },
        _getCrewTableRows: function(members) {
            members = members || [];
            var rows = [];
            var createSpacingRow = function() {
                var rowHeight = 60, height = 138;
                _.each(members, function() {
                    height -= rowHeight;
                    return height > 0;
                });
                if (0 >= height) return;
                var row = Ti.UI.createTableViewRow();
                row.visible = false;
                row.height = height + "dp";
                row.backgroundColor = "#fff";
                return row;
            };
            var createNoCrewRow = function() {
                var row = Ti.UI.createTableViewRow();
                row.visible = false;
                row.height = "200dp";
                row.backgroundColor = "#fff";
                var image = Ti.UI.createImageView({
                    image: "images/samantha-disguise-2-clear.png"
                });
                row.add(image);
                return row;
            };
            var showEmptyCaption = function(show) {
                $.footerCaption.top = show ? 0 : "5dp";
                $.footerCaption.visible = show ? false : true;
            };
            rows = rows.concat(this._createTableRowsForCrewMembers(members));
            if (rows.length > 0) {
                var spacingRow = createSpacingRow();
                spacingRow && rows.push(spacingRow);
            } else {
                var noCrewRow = createNoCrewRow();
                noCrewRow && rows.push(noCrewRow);
            }
            showEmptyCaption(0 == members.length);
            return rows;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;