function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "confirm_dropoff";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.background = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "background"
    });
    $.__views.background && $.addTopLevelView($.__views.background);
    $.__views.shade = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "black",
        opacity: "0.8",
        id: "shade"
    });
    $.__views.background.add($.__views.shade);
    $.__views.confirmDropoff = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        backgroundColor: "black",
        top: "25%",
        height: Ti.UI.SIZE,
        borderRadius: Alloy.Globals.Style.Unit.unit1,
        borderWidth: 1,
        borderColor: "#79797c",
        layout: "vertical",
        id: "confirmDropoff"
    });
    $.__views.background.add($.__views.confirmDropoff);
    $.__views.title = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        text: L("widget_boarding_endtrip_confirm"),
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
        textAlign: "center",
        top: 15,
        left: "20dp",
        right: "20dp",
        height: "40dp",
        id: "title"
    });
    $.__views.confirmDropoff.add($.__views.title);
    $.__views.message = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "15dp"
        },
        text: L("widget_boarding_endtrip_message"),
        left: "20dp",
        right: "20dp",
        bottom: "10dp",
        id: "message"
    });
    $.__views.confirmDropoff.add($.__views.message);
    $.__views.freeRideContainer = Ti.UI.createView({
        top: 0,
        height: "50dp",
        left: "0dp",
        id: "freeRideContainer"
    });
    $.__views.confirmDropoff.add($.__views.freeRideContainer);
    $.__views.freeRide = Ti.UI.createLabel({
        color: "#fff",
        top: "10dp",
        left: "20dp",
        width: "20dp",
        height: "20dp",
        zIndex: 3,
        borderColor: Alloy.Globals.Style.Color.LightBlue,
        borderWidth: "2dp",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundImage: "none",
        id: "freeRide"
    });
    $.__views.freeRideContainer.add($.__views.freeRide);
    $.__views.freeRideTicker = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontFamily: "splinico",
            fontSize: "14dp"
        },
        text: "c",
        visible: false,
        top: "10dp",
        left: "23dp",
        width: "20dp",
        height: "20dp",
        zIndex: 5,
        id: "freeRideTicker"
    });
    $.__views.freeRideContainer.add($.__views.freeRideTicker);
    $.__views.freeRideHint = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        left: "50dp",
        width: Alloy.Globals.Style.Size.Width.pct70,
        height: "20dp",
        text: L("widget_boarding_choose_free_ride"),
        id: "freeRideHint"
    });
    $.__views.freeRideContainer.add($.__views.freeRideHint);
    $.__views.isRider = Ti.UI.createLabel({
        color: "white",
        font: {
            fontSize: "15dp"
        },
        top: 0,
        height: "50dp",
        left: "20dp",
        right: "20dp",
        text: L("widget_boarding_choose_free_ride_rider"),
        id: "isRider"
    });
    $.__views.confirmDropoff.add($.__views.isRider);
    $.__views.buttonsContainer = Ti.UI.createView({
        top: "10dp",
        left: 0,
        right: 0,
        height: "50dp",
        width: Ti.UI.FILL,
        id: "buttonsContainer"
    });
    $.__views.confirmDropoff.add($.__views.buttonsContainer);
    $.__views.sep_hz = Ti.UI.createView({
        top: 0,
        bottom: 0,
        left: 0,
        right: 0,
        backgroundColor: "#969a9c",
        id: "sep_hz"
    });
    $.__views.buttonsContainer.add($.__views.sep_hz);
    $.__views.sep_vz = Ti.UI.createView({
        visible: "false",
        id: "sep_vz"
    });
    $.__views.buttonsContainer.add($.__views.sep_vz);
    $.__views.cancel = Ti.UI.createLabel({
        color: "black",
        font: {
            fontSize: "18dp"
        },
        top: "6dp",
        bottom: "6dp",
        left: "6dp",
        width: "46%",
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        backgroundColor: "#f4f4f4",
        textAlign: "center",
        text: L("btn_cancel"),
        id: "cancel"
    });
    $.__views.buttonsContainer.add($.__views.cancel);
    $.__views.confirm = Ti.UI.createLabel({
        color: "black",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: "6dp",
        bottom: "6dp",
        right: "6dp",
        width: "46%",
        verticalAlign: Titanium.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        backgroundColor: "#f4f4f4",
        textAlign: "center",
        text: L("btn_confirm"),
        id: "confirm"
    });
    $.__views.buttonsContainer.add($.__views.confirm);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var isRider = arguments[0].isRider || false;
    $.freeRideContainer.addEventListener("touchstart", function handler() {
        $.freeRideTicker.applyProperties({
            visible: !$.freeRideTicker.visible
        });
    });
    exports = {
        init: function(driverName) {
            $.freeRideTicker.applyProperties({
                visible: false
            });
            $.message.applyProperties({
                text: String.format(L("widget_boarding_endtrip_message"), driverName)
            });
            $.confirmDropoff.remove($.freeRideContainer);
            $.confirmDropoff.remove($.isRider);
        }
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;