function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "summaryShare";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.window = Ti.UI.createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        id: "window"
    });
    $.__views.window && $.addTopLevelView($.__views.window);
    $.__views.ShareContent = Ti.UI.createView({
        top: "0dp",
        bottom: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        zIndex: 1,
        id: "ShareContent"
    });
    $.__views.window.add($.__views.ShareContent);
    $.__views.ShareContentBg = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "#CCCCCC",
        opacity: 1,
        id: "ShareContentBg"
    });
    $.__views.ShareContent.add($.__views.ShareContentBg);
    $.__views.ShareContentContainer = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: "100%",
        height: "100%",
        id: "ShareContentContainer"
    });
    $.__views.ShareContent.add($.__views.ShareContentContainer);
    $.__views.cancelArrow = Ti.UI.createView({
        left: 0,
        top: "10dp",
        height: "50dp",
        width: "70dp",
        id: "cancelArrow"
    });
    $.__views.ShareContentContainer.add($.__views.cancelArrow);
    $.__views.cancelArrowLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontWeight: "bold",
            fontSize: "24dp"
        },
        text: "h",
        left: "10dp",
        height: "50dp",
        width: "60dp",
        id: "cancelArrowLabel"
    });
    $.__views.cancelArrow.add($.__views.cancelArrowLabel);
    $.__views.shareImageContainer = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: "75%",
        id: "shareImageContainer"
    });
    $.__views.ShareContentContainer.add($.__views.shareImageContainer);
    $.__views.shareImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: 0,
        width: "80%",
        height: "auto",
        id: "shareImage"
    });
    $.__views.shareImageContainer.add($.__views.shareImage);
    $.__views.subShareImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "30dp",
        width: "80%",
        height: "auto",
        id: "subShareImage"
    });
    $.__views.shareImageContainer.add($.__views.subShareImage);
    $.__views.changeShareImage = Ti.UI.createView({
        bottom: "10dp",
        width: Ti.UI.FILL,
        height: "30dp",
        id: "changeShareImage"
    });
    $.__views.shareImageContainer.add($.__views.changeShareImage);
    $.__views.changeShareImageLbl = Ti.UI.createLabel({
        color: "#666666",
        font: {
            fontSize: "18dp"
        },
        bottom: 0,
        text: L("widget_summary_share_hide_detail"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: "100%",
        height: "40dp",
        id: "changeShareImageLbl"
    });
    $.__views.changeShareImage.add($.__views.changeShareImageLbl);
    $.__views.btnShareImage = require("/ui/common/custom_button").createButton({
        width: "90%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        bottom: "15dp",
        title: "",
        id: "btnShareImage"
    });
    $.__views.ShareContentContainer.add($.__views.btnShareImage);
    $.__views.__alloyId65 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId65"
    });
    $.__views.btnShareImage.add($.__views.__alloyId65);
    $.__views.__alloyId66 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId66"
    });
    $.__views.__alloyId65.add($.__views.__alloyId66);
    $.__views.lblShareImage = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_share_choose_friends_button"),
        id: "lblShareImage"
    });
    $.__views.__alloyId66.add($.__views.lblShareImage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), i18n = require("i18n/i18n"), Utils = require("utils/utils"), Controller = require("/v6/infrastructure/Controller");
    var SUMMARY_IMG_NAME = "CarmaTripSummary.png";
    var SUMMARY_SMALL_IMG_NAME = "CarmaTripSummarySub.png";
    var getScreenshotFile = function(filename) {
        return Titanium.Filesystem.getFile(Titanium.Filesystem.tempDirectory, filename);
    };
    var generateInvitationId = function() {
        var dfd = Q.defer();
        Alloy.createModel("invitation").generate({
            method: "UNKNOWN",
            entity: "user"
        }).then(function(data) {
            dfd.resolve(data.id);
        });
        return dfd.promise;
    };
    var SummaryShareController = function($, args) {
        var screenWidth = null, screenHeight = null;
        var shareContent = null, shareSubject = null;
        var animate = function(control, options) {
            var dfd = Q.defer();
            control.animate(options, function() {
                dfd.resolve();
            });
            return dfd.promise;
        };
        var setPopupControlsVisibility = function(visible) {
            $.cancelArrow.visible = $.btnShareImage.visible = $.changeShareImage.visible = true;
        };
        var self = {
            events: {
                "click cancelArrow": "onCloseClick",
                "click changeShareImage": "onShowLessClick",
                "click btnShareImage": "onShareClick"
            },
            initialize: function() {
                _.bindAll(this, "onCloseClick", "onShowLessClick", "onShareClick");
                screenWidth = Utils.pixelToDp(Ti.Platform.displayCaps.platformWidth);
                screenHeight = Utils.pixelToDp(Ti.Platform.displayCaps.platformHeight);
                setPopupControlsVisibility(false);
                var matrix2d = Ti.UI.create2DMatrix().rotate(0);
                $.ShareContentContainer.applyProperties({
                    top: 0,
                    transform: matrix2d
                });
                $.shareImage.visible = true;
                $.subShareImage.visible = false;
                Ti.App.addEventListener("carma.share.success", this.onCloseClick);
            },
            show: function(options) {
                options = options || {};
                options.getScreenshot = "function" == typeof options.getScreenshot ? options.getScreenshot : function() {};
                options.getSmallScreenshot = "function" == typeof options.getSmallScreenshot ? options.getSmallScreenshot : function() {};
                options.getBadge = "function" == typeof options.getBadge ? options.getBadge : function() {
                    return {};
                };
                shareContent = options.getBadge().shareContent || "";
                shareSubject = options.getBadge().shareSubject || "";
                var blob = options.getScreenshot();
                blob = blob.media;
                $.shareImage.setDefaultImage(blob);
                $.shareImage.setImage(blob);
                animate($.shareImageContainer, {
                    top: "60dp",
                    duration: 500
                }).timeout(1e3).catch(function() {
                    $.shareImageContainer.top = "60dp";
                }).then(function() {
                    setPopupControlsVisibility(true);
                }).then(function() {
                    var subf = getScreenshotFile(SUMMARY_IMG_NAME);
                    subf.write(blob);
                    $.shareImage.setImage(subf.nativePath);
                    $.shareImage.setDefaultImage(subf.nativePath);
                }).then(function() {
                    var blob = options.getSmallScreenshot();
                    blob = blob.media;
                    var subf = getScreenshotFile(SUMMARY_SMALL_IMG_NAME);
                    subf.write(blob);
                    $.subShareImage.setImage(subf.nativePath);
                    $.subShareImage.setDefaultImage(subf.nativePath);
                }).then(function() {
                    blob = null;
                }).done();
            },
            destroy: function() {
                Ti.App.removeEventListener("carma.share.success", this.onCloseClick);
            },
            onCloseClick: function() {
                TM.push(function() {
                    $.window.close();
                });
            },
            onShowLessClick: function() {
                if ($.subShareImage.visible) {
                    $.subShareImage.visible = false;
                    $.shareImage.visible = true;
                } else {
                    $.shareImage.visible = false;
                    $.subShareImage.visible = true;
                }
                $.changeShareImageLbl.text = L($.shareImage.visible ? "widget_summary_share_hide_detail" : "widget_summary_share_show_detail");
            },
            onShareClick: function() {
                var userservice = require("services/user_service"), inviteCode = null;
                Q().then(function() {
                    return userservice.getReferralCode();
                }).then(function(data) {
                    userservice.cachReferralCode(data.referralCode);
                    inviteCode = data.referralCode;
                }).then(function() {
                    return generateInvitationId();
                }).then(function(inviteId) {
                    var shareImageName = $.subShareImage.visible ? SUMMARY_SMALL_IMG_NAME : SUMMARY_IMG_NAME;
                    var shareImagePath = getScreenshotFile(shareImageName).getNativePath();
                    var inviteUrl = " " + require("bootstrap/env").getInviteURL() + inviteId;
                    var fullShareContent = shareContent + inviteUrl;
                    require("/ui/common/sharing").shareByNative(fullShareContent, shareImageName, shareImagePath, shareSubject);
                }).done();
            }
        };
        return self;
    };
    SummaryShareController.$inject = [ "View", "Arguments" ];
    Controller.initialize(SummaryShareController, $, arguments);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;