function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.boardingv6/" + s : s.substring(0, index) + "/ma.car.app.boardingv6/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.boardingv6");
    this.__widgetId = "ma.car.app.boardingv6";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.boardingDecision = Ti.UI.createView({
        width: Ti.UI.FILL,
        top: 0,
        left: 0,
        height: Ti.UI.FILL,
        backgroundColor: "white",
        id: "boardingDecision"
    });
    $.__views.boardingDecision && $.addTopLevelView($.__views.boardingDecision);
    $.__views.foreground = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "foreground"
    });
    $.__views.boardingDecision.add($.__views.foreground);
    $.__views.navBar = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "50dp",
        backgroundColor: "white",
        id: "navBar"
    });
    $.__views.foreground.add($.__views.navBar);
    $.__views.navBarTitle = Ti.UI.createLabel({
        color: "#000",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        height: "24dp",
        bottom: "11dp",
        left: "72dp",
        right: "72dp",
        ellipsize: true,
        wordWrap: false,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("start_trip_title"),
        minimumFontSize: "10dp",
        id: "navBarTitle"
    });
    $.__views.navBar.add($.__views.navBarTitle);
    $.__views.content = Ti.UI.createView({
        width: Ti.UI.FILL,
        top: "70dp",
        height: "360dp",
        backgroundColor: "white",
        id: "content"
    });
    $.__views.foreground.add($.__views.content);
    $.__views.main = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "main"
    });
    $.__views.content.add($.__views.main);
    $.__views.__alloyId67 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        layout: "horizontal",
        height: Ti.UI.SIZE,
        top: "50dp",
        id: "__alloyId67"
    });
    $.__views.main.add($.__views.__alloyId67);
    $.__views.ridingContainer = Ti.UI.createView({
        top: "0dp",
        width: "49.9%",
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "ridingContainer"
    });
    $.__views.__alloyId67.add($.__views.ridingContainer);
    $.__views.ridingLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        text: L("start_trip_role_rider"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "ridingLabel"
    });
    $.__views.ridingContainer.add($.__views.ridingLabel);
    $.__views.ridingImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "126dp",
        height: "126dp",
        top: "19dp",
        image: "/images/rider-active.png",
        id: "ridingImage"
    });
    $.__views.ridingContainer.add($.__views.ridingImage);
    $.__views.drivingContainer = Ti.UI.createView({
        top: "0dp",
        width: "49.9%",
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "drivingContainer"
    });
    $.__views.__alloyId67.add($.__views.drivingContainer);
    $.__views.drivingLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        text: L("start_trip_role_driver"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "drivingLabel"
    });
    $.__views.drivingContainer.add($.__views.drivingLabel);
    $.__views.drivingImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "126dp",
        height: "126dp",
        top: "19dp",
        image: "/images/driver-active.png",
        opacity: .3,
        id: "drivingImage"
    });
    $.__views.drivingContainer.add($.__views.drivingImage);
    $.__views.buttonsContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "50dp",
        height: "95dp",
        id: "buttonsContainer"
    });
    $.__views.main.add($.__views.buttonsContainer);
    $.__views.ridingAction = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "ridingAction"
    });
    $.__views.buttonsContainer.add($.__views.ridingAction);
    $.__views.btnRider = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("start_trip_choose_driver"),
        width: "100%",
        id: "btnRider"
    });
    $.__views.ridingAction.add($.__views.btnRider);
    $.__views.drivingAction = Ti.UI.createView({
        width: "100%",
        height: 0,
        layout: "vertical",
        opacity: 0,
        id: "drivingAction"
    });
    $.__views.buttonsContainer.add($.__views.drivingAction);
    $.__views.askRiderLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("start_trip_ask_rider_join"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        height: "40dp",
        top: 0,
        id: "askRiderLabel"
    });
    $.__views.drivingAction.add($.__views.askRiderLabel);
    $.__views.btnDriver = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontSize: "15dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("start_trip_start_solo_trip"),
        top: "12dp",
        height: "40dp",
        id: "btnDriver"
    });
    $.__views.drivingAction.add($.__views.btnDriver);
    $.__views.connectionIndicatorWrapper = Ti.UI.createView({
        top: "70dp",
        width: Ti.UI.FILL,
        height: "30dp",
        id: "connectionIndicatorWrapper"
    });
    $.__views.foreground.add($.__views.connectionIndicatorWrapper);
    $.__views.connectionIndicator = require("/ui/common/connection_indicator").createView({
        id: "connectionIndicator"
    });
    $.__views.connectionIndicatorWrapper.add($.__views.connectionIndicator);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("/vendor/q"), trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), errorCodes = require("services/error_codes"), appSound = require("/utils/appSound"), UIMessageTypes = require("/v6/uiMessenger/entity/UIMessageTypes"), BoardingLogMessages = require("/v6/boarding/helpers/BoardingLogMessages"), errorHandler = require("/utils/errorHandler"), networkService = require("/bootstrap/network"), SummaryWidgetHelper = require(WPATH("SummaryWidgetHelper")), Controller = require("/v6/infrastructure/Controller"), GlobalEvents = require("/v6/common/GlobalEvents");
    var BoardingController = function($, args, currentUserService, boardingService, boardingBgService, UIMessengerService, summaryService, loggingService) {
        args = args[0] || {};
        var tabScreen = args.tabScreen, BoardingMissingGPSCompiler = require("/v6/boarding/helpers/BoardingMissingGPSCompiler")(boardingService), sm = null, logger = loggingService.logger("boarding"), summaryWidgetHelper = new SummaryWidgetHelper(summaryService, boardingBgService, logger);
        return {
            _ROLES: {
                RIDER: 0,
                DRIVER: 1
            },
            blueScreen: null,
            carmaCrew: null,
            carmaCrewVisible: false,
            onboardView: null,
            _roleAnimationStarted: false,
            _selectedRole: null,
            _currentState: 0,
            _isProcessingBoardingSync: false,
            _foregroundHeight: null,
            events: {
                "click btnDriver": "_startDriving",
                "click btnRider": "_startRiding",
                "click ridingImage": "_roleClicked",
                "click drivingImage": "_roleClicked"
            },
            _slideBluescreenUp: function() {
                var deferred = Q.defer();
                var view = this.blueScreen.getView();
                view.animate({
                    top: 0,
                    duration: 300
                });
                setTimeout(function() {
                    deferred.resolve();
                }, 400);
                return deferred.promise;
            },
            _slideBluescreenDown: function() {
                var deferred = Q.defer();
                var view = this.blueScreen.getView();
                var self = this;
                true && require(WPATH("BoardingPopupState")).isPopupOpen() ? view.top = Ti.Platform.displayCaps.platformHeight : view.animate({
                    top: Ti.Platform.displayCaps.platformHeight,
                    duration: 300
                });
                setTimeout(function() {
                    deferred.resolve();
                }, 400);
                return deferred.promise;
            },
            transitionOpenCarmaCrew: function() {
                LOGGER.info("START RIDING");
                var self = this;
                this.carmaCrew.setup();
                this.onboardView.getView().top = 0;
                this.carmaCrew.getView().top = 0;
                this.carmaCrewVisible = true;
                this.blueScreen.setTitle(L("widget_crew_title1"));
                this.blueScreen.enableBack(true);
                TM.push(function() {
                    analytics.track(trackingEvent.PAGE_HIT, {
                        view: "boarding"
                    });
                });
                return this._slideBluescreenUp();
            },
            transitionOnExternalJoinCar: function() {
                this.onboardView.getView().top = 0;
                this.carmaCrew.getView().top = Ti.Platform.displayCaps.platformHeight;
                this.carmaCrewVisible = false;
                this.blueScreen.setTitle();
                this.blueScreen.enableBack(false);
                this.onboardView.setup(this._ROLES.DRIVER, true);
                this.onboardView._startTrip();
                this.blueScreen.getView().top = 0;
                return Q();
            },
            transitionOnExternalPickup: function() {
                this.onboardView.getView().top = 0;
                this.carmaCrew.getView().top = Ti.Platform.displayCaps.platformHeight;
                this.carmaCrewVisible = false;
                this.blueScreen.setTitle();
                this.blueScreen.enableBack(false);
                this.onboardView.setup(this._ROLES.RIDER, true);
                this.onboardView._startTrip();
                this.blueScreen.getView().top = 0;
                appSound.play("joincar");
                return Q();
            },
            transitionOpenDriveTimer: function() {
                LOGGER.info("START DRIVING");
                this.onboardView.getView().top = 0;
                this.carmaCrew.getView().top = $.boardingDecision.rect.height;
                this.blueScreen.setTitle(L("widget_recording_solo"));
                this.blueScreen.enableBack(false);
                var view = this.blueScreen.getView();
                view.top = $.boardingDecision.rect.height;
                view.height = view.rect.height;
                this.onboardView.setup(this._selectedRole, false);
                TM.push(function() {
                    Ti.Media.vibrate();
                });
                TM.push(function() {
                    analytics.track(trackingEvent.PAGE_HIT, {
                        view: "boarding"
                    });
                });
                return this._slideBluescreenUp();
            },
            manualLocationInput: function(drivesToProcess, question) {
                var deferred = Q.defer();
                var myUserId = currentUserService.id;
                var isDriver = myUserId == drivesToProcess[0].driverId;
                var trip;
                if (question.buddies.length > 1) {
                    trip = [];
                    question.buddies.forEach(function(buddy) {
                        trip.push(Alloy.createModel("trip_state", {
                            startTimestamp: question.timestamp,
                            endTimestamp: question.timestamp,
                            role: "DRIVER",
                            rider: buddy
                        }));
                    });
                } else trip = Alloy.createModel("trip_state", {
                    startTimestamp: question.timestamp,
                    endTimestamp: question.timestamp,
                    role: isDriver ? "DRIVER" : "RIDER",
                    driver: isDriver ? drivesToProcess[0].driverId : question.buddies[0],
                    rider: isDriver ? question.buddies[0] : null
                });
                var self = this;
                var ctrl = Alloy.createWidget("ma.car.app.boardingv6", "location", {
                    trip: trip,
                    type: question.errorCode,
                    timestamp: question.timestamp,
                    darkTheme: true
                });
                var view = ctrl.getView();
                var location = null;
                view.addEventListener("close", function(data) {
                    deferred.resolve(location);
                });
                view.addEventListener("location", function(data) {
                    location = data.location;
                    if (!location) return;
                    location.accuracy = 0;
                    location.timestamp = question.timestamp;
                    location.userGenerated = true;
                    location.lon = location.lon || location.longitude;
                    location.lat = location.lat || location.latitude;
                    location.longitude = location.lon || location.longitude;
                    location.latitude = location.lat || location.latitude;
                });
                view.open();
                return deferred.promise;
            },
            processBoardingSync: function(attempt) {
                if (this._isProcessingBoardingSync) return;
                this._isProcessingBoardingSync = true;
                var processBoardingSyncReturnValue = false;
                try {
                    if (this.onboardView.isDriving()) return;
                    if (sm.isInTransition()) {
                        attempt = (attempt || 0) + 1;
                        if (5 > attempt) {
                            var self = this;
                            setTimeout(function() {
                                self.processBoardingSync(attempt);
                            }, 1e3);
                        }
                        return;
                    }
                    processBoardingSyncReturnValue = true;
                    self = this;
                    Q().then(function() {
                        return boardingBgService.sync();
                    }).finally(function() {
                        if (!self.onboardView.isRiding() && !require(WPATH("BoardingPopupState")).isPopupOpen()) return summaryWidgetHelper.showSummaries().then(function() {
                            GlobalEvents.fireTripFinished();
                        });
                    }).finally(function() {
                        if (!networkService.isConnectionGood()) {
                            self._isProcessingBoardingSync = false;
                            return;
                        }
                        if (require(WPATH("BoardingPopupState")).isPopupOpen()) {
                            self._isProcessingBoardingSync = false;
                            return;
                        }
                        var drivesToProcess = boardingService.getDrivesWithMissingGPS();
                        if (null == drivesToProcess || 0 === drivesToProcess.length) {
                            self._isProcessingBoardingSync = false;
                            return;
                        }
                        var tryAgainNow = false;
                        var setPopupOpenFlag = false;
                        return Q().then(function() {
                            if (require(WPATH("BoardingPopupState")).isPopupOpen()) return false;
                            require(WPATH("BoardingPopupState")).setPopupOpen();
                            setPopupOpenFlag = true;
                            return BoardingMissingGPSCompiler.handleMissingGPS(currentUserService.id, drivesToProcess, self.manualLocationInput);
                        }).then(function(success) {
                            success && (tryAgainNow = true);
                        }).catch(function(e) {
                            LOGGER.error("Could not process missing GPS locations: " + JSON.stringify(e));
                        }).finally(function() {
                            if (setPopupOpenFlag) {
                                require(WPATH("BoardingPopupState")).setPopupClosed();
                                setPopupOpenFlag = false;
                            }
                            self._isProcessingBoardingSync = false;
                            tryAgainNow && self.processBoardingSync(0);
                        });
                    }).done();
                } finally {
                    this._isProcessingBoardingSync = processBoardingSyncReturnValue;
                }
            },
            transitionDisplayDecision: function() {
                this.carmaCrew._closeBoardByNumber();
                var deferred = Q.defer();
                var self = this;
                this.carmaCrewVisible = false;
                this._slideBluescreenDown().finally(function() {
                    deferred.resolve();
                    if (!require(WPATH("BoardingPopupState")).isPopupOpen()) {
                        var completedDrive = self.onboardView.popCompletedDrive();
                        if (completedDrive) {
                            var widget = summaryWidgetHelper.initSummaryWidget();
                            return summaryWidgetHelper.showDriveSummary(completedDrive.id, widget).finally(function() {
                                summaryWidgetHelper.showSummaries(widget);
                            }).finally(function() {
                                GlobalEvents.fireTripFinished();
                            });
                        }
                    }
                }).done();
                return deferred.promise;
            },
            transitionOnDriverSelected: function() {
                this.onboardView.setup(this._selectedRole, false);
                this.carmaCrewVisible = false;
                return this.blueScreen.slideContentOutDownwards(this.carmaCrew.getView());
            },
            transitionStartRiding: function() {
                appSound.play("joincar");
                return this.onboardView.ShowOnBoardClock();
            },
            transitionStartDriving: function() {
                appSound.play("joincar");
                return this.onboardView.ShowOnBoardClock();
            },
            transitionOnJoinCarCancelled: function() {
                this.onboardView._stopAnimation();
                this.carmaCrewVisible = true;
                return this.blueScreen.slideContentInUpwards(this.carmaCrew.getView());
            },
            _startRiding: function() {
                if (this._selectedRole !== this._ROLES.RIDER) return;
                sm.transition(sm._TRANSITIONS.OPEN_CREW);
            },
            _startDriving: function() {
                if (this._selectedRole !== this._ROLES.DRIVER) return;
                var self = this;
                Q().then(function() {
                    if (self._selectedRole !== self._ROLES.DRIVER) throw new Error();
                    return self.onboardView.setupDriving();
                }).then(function() {
                    if (self._selectedRole !== self._ROLES.DRIVER) throw new Error();
                    sm.transition(sm._TRANSITIONS.START_DRIVE_TIMER);
                }).catch(function(e) {
                    if (self._selectedRole !== self._ROLES.DRIVER) return;
                    LOGGER.error(e);
                    e.message !== errorCodes.ERROR_INVALID_LOCATION && errorHandler.noticeError({
                        action: "start_solo_drive",
                        errorCode: e.message
                    });
                });
            },
            _roleClicked: function(event) {
                if (this._roleAnimationStarted) return;
                if (event.source == $.ridingImage && this._selectedRole === this._ROLES.RIDER || event.source == $.drivingImage && this._selectedRole === this._ROLES.DRIVER) return;
                this._roleAnimationStarted = true;
                this._selectedRole = event.source == $.ridingImage ? this._ROLES.RIDER : this._ROLES.DRIVER;
                var self = this;
                this._toggleDrivingAction(this._selectedRole === this._ROLES.DRIVER);
                this._toggleRidingAction(this._selectedRole === this._ROLES.RIDER);
                setTimeout(function() {
                    self._roleAnimationStarted = false;
                }, 150);
            },
            _toggleDrivingAction: function(enable) {
                $.drivingImage.animate({
                    opacity: enable ? 1 : .3,
                    duration: 150
                }, function() {
                    $.drivingImage.opacity = enable ? 1 : .3;
                });
                if (enable) {
                    $.drivingAction.height = Ti.UI.SIZE;
                    $.drivingAction.animate({
                        opacity: 1,
                        duration: 150
                    }, function() {
                        $.drivingAction.opacity = 1;
                    });
                    return;
                }
                $.drivingAction.applyProperties({
                    opacity: 0,
                    height: 0
                });
            },
            _toggleRidingAction: function(enable) {
                var self = this;
                $.ridingImage.animate({
                    opacity: enable ? 1 : .3,
                    duration: 150
                }, function() {
                    $.ridingImage.opacity = enable ? 1 : .3;
                    self._roleAnimationStarted = false;
                });
                if (enable) {
                    $.ridingAction.height = Ti.UI.SIZE;
                    $.ridingAction.animate({
                        opacity: 1,
                        duration: 150
                    }, function() {
                        $.ridingAction.opacity = 1;
                    });
                    return;
                }
                $.ridingAction.applyProperties({
                    opacity: 0,
                    height: 0
                });
            },
            _handleDriveChangeEvent: function(drive) {
                drive = boardingService.getDrive(drive.id);
                if (!drive) return;
                var currentState = sm.getCurrentState();
                if (currentState === sm._STATES.RIDING || currentState === sm._STATES.DRIVING_SOLO || currentState === sm._STATES.DRIVING) {
                    var currentDrive = this.onboardView.getCurrentDrive();
                    if (!currentDrive || currentDrive.id != drive.id) {
                        LOGGER.error("Unexpected drive received with ID " + drive.Id + " where current drive Id is " + (currentDrive ? currentDrive.id : "null"));
                        return;
                    }
                }
                var myUserId = currentUserService.id;
                var driveHelper = require("/v6/boarding/helpers/DriveHelper");
                if (driveHelper.isDriveFinished(myUserId, drive)) {
                    currentState === sm._STATES.RIDING || currentState === sm._STATES.DRIVING_SOLO || currentState === sm._STATES.DRIVING ? this.onboardView.completeCurrentDrive(drive) : this.transitionDisplayDecision();
                    return;
                }
                if (currentState === sm._STATES.DECISION) {
                    driveHelper.isDriving(myUserId, drive) ? this.onboardView.setCurrentDriverDrive(drive) : this.onboardView.setCurrentRiderDrive(drive);
                    setTimeout(function() {
                        Ti.App.fireEvent("carma:starttrip.tab", {});
                    }, 400);
                    return;
                }
                driveHelper.isDriving(myUserId, drive) ? this.onboardView.updateCurrentDriverDrive(drive) : this.onboardView.updateCurrentRiderDrive(drive);
                TM.push(function() {
                    Ti.App.fireEvent("carma:starttrip.tab", {});
                });
            },
            onDriveChangeEvent: function(data) {
                if (!data) return;
                var drive = data.drive;
                if (!drive) return;
                if (sm.isInTransition()) {
                    var self = this;
                    setTimeout(function() {
                        self.onDriveChangeEvent(data);
                    }, 500);
                    return;
                }
                var currentState = sm.getCurrentState();
                if (currentState === sm._STATES.RIDE_TIMER || currentState === sm._STATES.DRIVE_TIMER || currentState === sm._STATES.CARMA_CREW) {
                    sm.transition(sm._TRANSITIONS.BACK);
                    var self = this;
                    setTimeout(function() {
                        self.onDriveChangeEvent(data);
                    }, 500);
                    return;
                }
                logger.log("UI onDriveChangeEvent");
                logger.log(function() {
                    return BoardingLogMessages.fullDriveStatusLogMessage(data.drive);
                });
                this._handleDriveChangeEvent(drive);
            },
            _validateLocation: function(location) {
                return location.lon && location.lat && location.accuracy;
            },
            _getCurrentLocation: function(timestamp, ilocation, isLeaveCar) {
                var deferred = Q.defer();
                var trip = Alloy.createModel("trip_state", {
                    startTimestamp: isLeaveCar ? null : timestamp,
                    endTimestamp: isLeaveCar ? timestamp : null,
                    role: "RIDER"
                });
                this._validateLocation(ilocation) ? deferred.resolve(ilocation) : require(WPATH("location")).getContactLocation(trip, true).then(function(location) {
                    if (location) {
                        location.latitude = location.latitude || location.lat;
                        location.longitude = location.longitude || location.lon;
                        delete location.lat;
                        delete location.lon;
                        deferred.resolve({
                            lat: location.latitude,
                            lon: location.longitude,
                            accuracy: location.accuracy
                        });
                    } else deferred.reject({
                        reson: "didn't find current location!"
                    });
                }).catch(function(e) {
                    deferred.reject(e);
                });
                return deferred.promise;
            },
            joinCarByBeacon: function(beaconId, ilocation, isSynced) {
                if (!beaconId) {
                    LOGGER.error("join car by beacon without beaconId");
                    return;
                }
                LOGGER.error("[joinCarByBeacon] - ilocation: " + JSON.stringify(ilocation));
                if (isSynced) boardingBgService.sync(); else {
                    var resourceOwner = require("/services/resource_owner_service").singleton();
                    myUserId = resourceOwner.get("userId"), timestamp = Date.now(), self = this;
                    this._getCurrentLocation(timestamp, ilocation).then(function(location) {
                        var drive = boardingService.joinCar(_.extend({
                            beaconId: beaconId,
                            riderId: myUserId,
                            timestamp: timestamp
                        }, location));
                        self.onDriveChangeEvent({
                            drive: drive
                        });
                        LOGGER.error("[joinCarByBeacon] - drive: " + JSON.stringify(drive));
                        boardingBgService.sync();
                    }).catch(function(e) {
                        LOGGER.error("[joinCarByBeacon] - error: " + JSON.stringify(e));
                    }).finally(function() {
                        LOGGER.error("[joinCarByBeacon] - finally");
                    }).done();
                }
            },
            leaveCarByBeacon: function(beaconId, ilocation, isSynced) {
                if (!beaconId) {
                    LOGGER.error("[leaveCarByBeacon] - leave car without beacon id!");
                    return;
                }
                LOGGER.error("[leaveCarByBeacon] - ilocation: " + JSON.stringify(ilocation));
                if (isSynced) boardingBgService.sync(); else {
                    var resourceOwner = require("/services/resource_owner_service").singleton();
                    myUserId = resourceOwner.get("userId"), timestamp = Date.now(), self = this;
                    this._getCurrentLocation(timestamp, ilocation, true).then(function(location) {
                        var drive = boardingService.leaveCar(_.extend({
                            beaconId: beaconId,
                            riderId: myUserId,
                            timestamp: timestamp
                        }, location));
                        self.onDriveChangeEvent({
                            drive: drive
                        });
                        LOGGER.error("[leaveCarByBeacon] - drive: " + JSON.stringify(drive));
                        boardingBgService.sync();
                    }).catch(function(e) {
                        LOGGER.error("[leaveCarByBeacon] - error: " + JSON.stringify(e));
                    }).finally(function() {
                        LOGGER.error("[leaveCarByBeacon] - finally");
                    }).done();
                }
            },
            startSoloDriveByBeacon: function(beaconId, ilocation, isSynced) {
                if (!beaconId) {
                    LOGGER.error("start solo drive by beacon without beaconId");
                    return;
                }
                if (isSynced) boardingBgService.sync(); else {
                    var resourceOwner = require("/services/resource_owner_service").singleton();
                    myUserId = resourceOwner.get("userId"), timestamp = Date.now(), self = this;
                    this._getCurrentLocation(timestamp, ilocation).then(function(location) {
                        var drive = boardingService.startDrive(_.extend({
                            beaconId: beaconId,
                            driverId: myUserId,
                            timestamp: timestamp
                        }, location));
                        self.onDriveChangeEvent({
                            drive: drive
                        });
                        boardingBgService.sync();
                    }).catch(function(e) {
                        LOGGER.error("[startSoloDriveByBeacon] - error: " + JSON.stringify(e));
                    }).finally(function() {}).done();
                }
            },
            endSoloDriveByBeacon: function(beaconId, ilocation, isSynced) {
                if (!beaconId) {
                    LOGGER.error("[endSoloDriveByBeacon] - end drive without beacon id!");
                    return;
                }
                if (isSynced) boardingBgService.sync(); else {
                    var resourceOwner = require("/services/resource_owner_service").singleton();
                    myUserId = resourceOwner.get("userId"), timestamp = Date.now(), self = this;
                    this._getCurrentLocation(timestamp, ilocation, true).then(function(location) {
                        var drive = boardingService.endDrive(_.extend({
                            beaconId: beaconId,
                            driverId: myUserId,
                            timestamp: timestamp
                        }, location));
                        self.onDriveChangeEvent({
                            drive: drive
                        });
                        boardingBgService.sync();
                    }).catch(function(e) {
                        LOGGER.error("[endSoloDriveByBeacon] - error: " + JSON.stringify(e));
                    }).finally(function() {}).done();
                }
            },
            initialize: function() {
                _.bindAll(this, "_startRiding", "_startDriving", "_roleClicked", "_toggleDrivingAction", "_toggleRidingAction", "transitionOpenCarmaCrew", "transitionOpenDriveTimer", "transitionDisplayDecision", "transitionOnDriverSelected", "transitionOnJoinCarCancelled", "transitionStartRiding", "transitionStartDriving", "transitionOnExternalJoinCar", "transitionOnExternalPickup", "processBoardingSync", "onDriveChangeEvent");
                this.blueScreen = Alloy.createWidget("ma.car.app.boardingv6", "blueScreen", {
                    __parentSymbol: $.getView(),
                    __parentController: this
                });
                this.carmaCrew = Alloy.createWidget("ma.car.app.boardingv6", "carmaCrew", {
                    __parentSymbol: $.getView(),
                    __parentController: this
                });
                this.onboardView = Alloy.createWidget("ma.car.app.boardingv6", "onboard", {
                    __parentSymbol: $.getView(),
                    __parentController: this
                });
                var view = this.blueScreen.getView();
                this.blueScreen.addView(this.onboardView.getView());
                this.blueScreen.addView(this.carmaCrew.getView());
                view.top = Ti.Platform.displayCaps.platformHeight;
                this.blueScreen.setBack(function() {
                    sm.transition(sm._TRANSITIONS.BACK);
                });
                $.boardingDecision.add(view);
                sm = require(WPATH("sm"))({
                    boardingWidget: this,
                    bluescreen: this.bluescreen,
                    carmaCrew: this.carmaCrew,
                    onboardView: this.onboardView
                });
                this._selectedRole = this._ROLES.RIDER;
                this.blueScreen.setStateMachine(sm);
                this.carmaCrew.setStateMachine(sm);
                this.onboardView.setStateMachine(sm);
                this.onboardView.setCarmaCrew(this.carmaCrew);
                this.onboardView.setBlueScreen(this.blueScreen);
                this.onboardView.setContainer(this.blueScreen.getView());
                if (true && tabScreen) {
                    var self = this;
                    tabScreen.getView().addEventListener("androidback", function() {
                        tabScreen.isOnStartTripTab() && sm.transition(sm._TRANSITIONS.ANDROID_BACK);
                    });
                }
                TABS_HELPER.rootWindow().addAppEventListener("carma:network.change", this.processBoardingSync);
                TABS_HELPER.rootWindow().addAppEventListener("carma:life.cycle.refresh", this.processBoardingSync);
                this.processBoardingSync();
                this._checkCoachMark();
                Ti.App.fireEvent("carma:boarding.sync");
                Alloy.Globals.setUnderline($.btnDriver, true);
                var aop = require("/vendor/meld");
                aop.after(this, "_startDriving", function() {
                    analytics.track(trackingEvent.START_TRIP, {
                        role: "driver"
                    });
                });
                aop.after(this, "_startRiding", function() {
                    analytics.track(trackingEvent.START_TRIP, {
                        role: "rider"
                    });
                });
                var self = this;
                TABS_HELPER.rootWindow().addAppEventListener("carma:network.change", handler = function(data) {
                    if (networkService.isConnected()) {
                        if ($.connectionIndicator.isBarVisible()) {
                            $.connectionIndicator.handleNetwork(data);
                            self.blueScreen.handleNetwork(data);
                        }
                    } else {
                        $.connectionIndicator.handleNetwork(data);
                        self.blueScreen.handleNetwork(data);
                    }
                });
                TABS_HELPER.rootWindow().addAppEventListener("carma:trips.changed", function() {
                    boardingBgService.sync();
                });
                UIMessengerService.on(UIMessageTypes.DriveStatusUpdated, this.onDriveChangeEvent);
                var self = this;
                var currentDrive = boardingService.getCurrentDrive();
                currentDrive && self.onDriveChangeEvent({
                    drive: currentDrive
                });
                $.foreground.addEventListener("postlayout", function onPostLayout() {
                    $.foreground.removeEventListener("postlayout", onPostLayout);
                    self._foregroundHeight = $.foreground.rect.height;
                });
                TABS_HELPER.rootWindow().addAppEventListener("carma:logout", function() {
                    self.resetAllState(true);
                });
            },
            _checkCoachMark: function() {
                if (!require("services/action_record_service").get("boarding")) {
                    require("services/action_record_service").set("boarding", true);
                    TM.push(function() {
                        Ti.App.fireEvent("carma:coachmark", {
                            name: "starttrip"
                        });
                    });
                }
            },
            reset: function() {
                LOGGER.error("Reset new ma.car.app.boardingv6 views...");
                sm.getCurrentState() === sm._STATES.CARMA_CREW && sm.transition(sm._TRANSITIONS.BACK);
            },
            resetAllState: function(dontSync) {
                LOGGER.error("Resetting boarding state");
                boardingService.resetAllState();
                boardingBgService.resetAllState();
                this.blueScreen.getView().top = Ti.Platform.displayCaps.platformHeight;
                this.transitionDisplayDecision();
                this.onboardView.reset();
                dontSync || boardingBgService.sync();
            }
        };
    };
    BoardingController.$inject = [ "View", "Arguments", "CurrentUserService", "BoardingService", "BoardingBgService", "UIMessengerService", "SummaryService", "LoggingService" ];
    BoardingController.$isRevealingModule = true;
    Controller.initialize(BoardingController, $, arguments);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;