function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.carmaCompleteness/" + s : s.substring(0, index) + "/ma.car.app.carmaCompleteness/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.carmaCompleteness");
    this.__widgetId = "ma.car.app.carmaCompleteness";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "completeness_window";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.completenessWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        height: "100%",
        top: Alloy.Globals.Style.Size.Height.pct99,
        visible: false,
        backgroundColor: "#FFF",
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "completenessWindow"
    });
    $.__views.completenessWindow && $.addTopLevelView($.__views.completenessWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, data = args.data || {};
    !function() {
        var navigation = Alloy.Globals.Nav.Completeness = Alloy.createController("navigation");
        var widget = Alloy.createWidget("ma.car.app.carmaCompleteness", "completedList", {
            data: data
        });
        $.completenessWindow.addEventListener("open", function handler() {
            $.completenessWindow.removeEventListener("open", handler);
            setTimeout(function() {
                widget.init();
                $.completenessWindow.addEventListener("close", function handler() {
                    Alloy.Globals.Nav.Completeness = null;
                    $.completenessWindow.removeEventListener("close", handler);
                });
            }, 500);
        });
        navigation.init({
            index: widget,
            historyLimit: 20,
            mainWindow: $.completenessWindow,
            modal: true,
            handleClose: args.handleClose,
            transition: "none",
            title: String.format(L("widget_completeness_list_title"), Math.round(100 * data.ratio))
        });
    }();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;