function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.coachmarks/" + s : s.substring(0, index) + "/ma.car.app.coachmarks/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.coachmarks");
    this.__widgetId = "ma.car.app.coachmarks";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "coach_bonus";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.wrapper = Ti.UI.createView({
        height: "100%",
        width: "100%",
        backgroundColor: "transparent",
        opacity: 1,
        id: "wrapper"
    });
    $.__views.wrapper && $.addTopLevelView($.__views.wrapper);
    $.__views.inner = Ti.UI.createView({
        top: "50dp",
        width: "200dp",
        height: "210dp",
        id: "inner",
        layout: "vertical"
    });
    $.__views.wrapper.add($.__views.inner);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        width: "100%",
        text: L("widget_coachmark_bonus_title"),
        textAlign: "center",
        font: {
            fontSize: "26dp"
        },
        id: "lblTitle"
    });
    $.__views.inner.add($.__views.lblTitle);
    $.__views.lblCaption = Ti.UI.createLabel({
        color: "#fff",
        top: "5dp",
        width: "100%",
        text: L("widget_coachmark_bonus_caption"),
        textAlign: "center",
        font: {
            fontSize: "16dp"
        },
        id: "lblCaption"
    });
    $.__views.inner.add($.__views.lblCaption);
    $.__views.lblBonus = Ti.UI.createLabel({
        color: "#fff",
        top: "0",
        width: "100%",
        text: "$5",
        textAlign: "center",
        font: {
            fontSize: "30dp"
        },
        id: "lblBonus"
    });
    $.__views.inner.add($.__views.lblBonus);
    $.__views.btnDone = Ti.UI.createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        title: L("widget_coachmark_button_done"),
        top: "40dp",
        width: "80dp",
        height: "35dp",
        id: "btnDone"
    });
    $.__views.inner.add($.__views.btnDone);
    handleDone ? $.__views.btnDone.addEventListener("click", handleDone) : __defers["$.__views.btnDone!click!handleDone"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, funClose = args.close, utils = require("utils/utils");
    var handleDone = function() {
        dissmiss();
    };
    var dissmiss = function() {
        $.wrapper.animate({
            opacity: 0,
            duration: 600
        }, function() {
            funClose();
        });
    };
    !function() {
        var screenWidth = utils.pixelToDp(Ti.Platform.displayCaps.platformWidth), screenHeight = utils.pixelToDp(Ti.Platform.displayCaps.platformHeight);
        $.inner.left = (screenWidth - parseFloat($.inner.width)) / 2 + "dp";
        $.inner.top = (screenHeight - parseFloat($.inner.height)) / 2 + "dp";
    }();
    __defers["$.__views.btnDone!click!handleDone"] && $.__views.btnDone.addEventListener("click", handleDone);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;