function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.coachmarks/" + s : s.substring(0, index) + "/ma.car.app.coachmarks/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.coachmarks");
    this.__widgetId = "ma.car.app.coachmarks";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "coach_milestone";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.wrapper = Ti.UI.createView({
        height: "100%",
        width: "100%",
        backgroundColor: "transparent",
        opacity: 1,
        id: "wrapper"
    });
    $.__views.wrapper && $.addTopLevelView($.__views.wrapper);
    $.__views.__alloyId608 = Ti.UI.createView({
        layout: "composite",
        top: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId608"
    });
    $.__views.wrapper.add($.__views.__alloyId608);
    $.__views.__alloyId609 = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "100%",
        image: "/images/topbanner.png",
        left: "0dp",
        right: "0dp",
        top: "0dp",
        id: "__alloyId609"
    });
    $.__views.__alloyId608.add($.__views.__alloyId609);
    $.__views.lblTop = Ti.UI.createLabel({
        color: "#ff6600",
        width: "90%",
        text: "ONE LAST PUSH",
        textAlign: "center",
        font: {
            fontSize: "30dp"
        },
        zIndex: 100,
        top: "50dp",
        id: "lblTop"
    });
    $.__views.__alloyId608.add($.__views.lblTop);
    $.__views.__alloyId610 = Ti.UI.createView({
        layout: "vertical",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId610"
    });
    $.__views.wrapper.add($.__views.__alloyId610);
    $.__views.imgAchievement = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/medal.png",
        id: "imgAchievement"
    });
    $.__views.__alloyId610.add($.__views.imgAchievement);
    $.__views.lblCaption = Ti.UI.createLabel({
        color: "#fff",
        width: "90%",
        top: "20dp",
        textAlign: "center",
        font: {
            fontSize: "16dp"
        },
        id: "lblCaption"
    });
    $.__views.__alloyId610.add($.__views.lblCaption);
    $.__views.__alloyId611 = Ti.UI.createView({
        layout: "composite",
        bottom: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId611"
    });
    $.__views.wrapper.add($.__views.__alloyId611);
    $.__views.__alloyId612 = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "100%",
        image: "/images/bottombanner.png",
        left: "0dp",
        right: "0dp",
        bottom: "0dp",
        id: "__alloyId612"
    });
    $.__views.__alloyId611.add($.__views.__alloyId612);
    $.__views.lblBottom = Ti.UI.createLabel({
        color: "#fff",
        width: "90%",
        text: "YOU CAN DO IT!",
        textAlign: "center",
        font: {
            fontSize: "30dp"
        },
        zIndex: 100,
        bottom: "10dp",
        id: "lblBottom"
    });
    $.__views.__alloyId611.add($.__views.lblBottom);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, funClose = args.close;
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] wrapper": "_dissmiss",
            "click[android] wrapper": "_dissmiss",
            "click lblTop": "_dissmiss",
            "click lblBottom": "_dissmiss"
        },
        initialize: function() {
            var notificationType = args.type;
            var variation = args.variation;
            var message = args.message;
            var image, header, encourage;
            if ("TRIP" === args.type) if (1 === variation) {
                header = L("widget_milestone_trips_header");
                encourage = L("widget_milestone_trips_encourage");
                image = "/images/lock.png";
            } else {
                header = L("widget_milestone_trips_alternative_header");
                encourage = L("widget_milestone_trips_alternative_encourage");
                image = "/images/bomb.png";
            }
            if ("USERS" === args.type) if (1 === variation) {
                header = L("widget_milestone_users_header");
                encourage = L("widget_milestone_users_encourage");
                image = "images/medal.png";
            } else {
                header = L("widget_milestone_users_alternative_header");
                encourage = L("widget_milestone_users_alternative_encourage");
                image = "/images/people.png";
            }
            if ("DISTANCE" === args.type) {
                header = L("widget_milestone_distance_header");
                encourage = L("widget_milestone_distance_encourage");
                image = "/images/map.png";
            }
            $.lblTop.text = header;
            $.imgAchievement.image = image;
            $.lblBottom.text = encourage;
            $.lblCaption.text = message;
        },
        _dissmiss: function() {
            $.wrapper.animate({
                opacity: 0,
                duration: 600
            }, function() {
                funClose();
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;