function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.coachmarks/" + s : s.substring(0, index) + "/ma.car.app.coachmarks/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.coachmarks");
    this.__widgetId = "ma.car.app.coachmarks";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "coach_plantrip_austin";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.wrapper = Ti.UI.createView({
        height: "100%",
        width: "100%",
        backgroundColor: "transparent",
        opacity: 1,
        id: "wrapper"
    });
    $.__views.wrapper && $.addTopLevelView($.__views.wrapper);
    $.__views.inner = Ti.UI.createView({
        top: "80dp",
        width: "280dp",
        height: "500dp",
        id: "inner",
        layout: "vertical"
    });
    $.__views.wrapper.add($.__views.inner);
    $.__views.__alloyId613 = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/Tesla_960.png",
        top: "60dp",
        width: "260dp",
        id: "__alloyId613"
    });
    $.__views.inner.add($.__views.__alloyId613);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        width: "100%",
        text: L("widget_coachmark_plantrip_austin_title"),
        textAlign: "center",
        font: {
            fontSize: "26dp"
        },
        id: "lblTitle",
        top: "20dp"
    });
    $.__views.inner.add($.__views.lblTitle);
    $.__views.lblCaption = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "20dp",
        width: "220dp",
        text: L("widget_coachmark_plantrip_austin_caption"),
        textAlign: "center",
        id: "lblCaption"
    });
    $.__views.inner.add($.__views.lblCaption);
    $.__views.__alloyId614 = Ti.UI.createView({
        top: "20dp",
        height: "40dp",
        width: "280dp",
        layout: "horizontal",
        id: "__alloyId614"
    });
    $.__views.inner.add($.__views.__alloyId614);
    $.__views.btnCancel = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00ffffff",
        selectedColor: "#70ffffff",
        backgroundImage: "none",
        borderColor: "#fff",
        borderWidth: 2,
        disableAnimation: true,
        font: {
            fontSize: "15dp"
        },
        id: "btnCancel",
        title: "Close",
        height: "40dp",
        width: "130dp"
    });
    $.__views.__alloyId614.add($.__views.btnCancel);
    handleCancel ? $.__views.btnCancel.addEventListener("click", handleCancel) : __defers["$.__views.btnCancel!click!handleCancel"] = true;
    $.__views.__alloyId615 = Ti.UI.createView({
        height: "40dp",
        width: "10dp",
        id: "__alloyId615"
    });
    $.__views.__alloyId614.add($.__views.__alloyId615);
    $.__views.btnAsk = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("widget_coachmark_plantrip_austin_ask"),
        id: "btnAsk",
        height: "40dp",
        width: "130dp"
    });
    $.__views.__alloyId614.add($.__views.btnAsk);
    handleAsk ? $.__views.btnAsk.addEventListener("click", handleAsk) : __defers["$.__views.btnAsk!click!handleAsk"] = true;
    $.__views.lblTAC = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "12dp"
        },
        text: L("widget_coachmark_plantrip_austin_tac"),
        width: "220dp",
        id: "lblTAC",
        bottom: "40dp",
        textAlign: "center"
    });
    $.__views.wrapper.add($.__views.lblTAC);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, funClose = args.close, utils = require("utils/utils");
    var handleAsk = function() {
        var userId = require("services/resource_owner_service").singleton().get("userId");
        var targetUserId = 1557820714;
        var threadId = targetUserId > userId ? targetUserId + "_" + userId : userId + "_" + targetUserId;
        Ti.App.fireEvent("carma:open.conversation", {
            threadId: threadId,
            message: L("widget_coachmark_plantrip_austin_ask_msg")
        });
        dissmiss();
    };
    var handleCancel = function() {
        dissmiss();
    };
    var dissmiss = function() {
        $.wrapper.animate({
            opacity: 0,
            duration: 600
        }, function() {
            funClose();
        });
    };
    !function() {
        var screenWidth = utils.pixelToDp(Ti.Platform.displayCaps.platformWidth), screenHeight = utils.pixelToDp(Ti.Platform.displayCaps.platformHeight);
        $.inner.left = (screenWidth - parseFloat($.inner.width)) / 2 + "dp";
        $.inner.top = (screenHeight - parseFloat($.inner.height)) / 2 + "dp";
    }();
    __defers["$.__views.btnCancel!click!handleCancel"] && $.__views.btnCancel.addEventListener("click", handleCancel);
    __defers["$.__views.btnAsk!click!handleAsk"] && $.__views.btnAsk.addEventListener("click", handleAsk);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;