function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.coachmarks/" + s : s.substring(0, index) + "/ma.car.app.coachmarks/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.coachmarks");
    this.__widgetId = "ma.car.app.coachmarks";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        height: "100%",
        width: "100%",
        navBarHidden: true,
        backgroundColor: "transparent",
        backgroundImage: null,
        modal: true,
        id: "win"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.winWrapper = Ti.UI.createView({
        backgroundColor: "#000",
        opacity: .9,
        id: "winWrapper"
    });
    $.__views.win.add($.__views.winWrapper);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    var name = args.name;
    var params = args.params || {};
    params.close = function() {
        $.win.close();
        Ti.App.fireEvent("carma:coachmark.close", {
            name: name
        });
    };
    var isOneTimeFlag = args.oneTime;
    $.win.addEventListener("open", function _open() {
        $.win.removeEventListener("open", _open);
        var disabledKey = "coach_" + name + "_disabled", isDisabled = Ti.App.Properties.getInt(disabledKey);
        if (isDisabled) {
            $.win.close();
            return;
        }
        isOneTimeFlag && Ti.App.Properties.setInt(disabledKey, 1);
        var ctrl = Alloy.createWidget("ma.car.app.coachmarks", "coach_" + name, params);
        $.win.opacity = 0;
        $.win.add(ctrl.getView());
        $.win.animate({
            opacity: 1,
            duration: 600
        }, function() {
            $.winWrapper.opacity = .8;
        });
    });
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;