function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "bottomBarActions";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.bottomBar = Ti.UI.createView({
        backgroundColor: Alloy.Globals.Style.Color.Grey,
        height: "55dp",
        width: "100%",
        left: 0,
        bottom: 0,
        id: "bottomBar"
    });
    $.__views.bottomBar && $.addTopLevelView($.__views.bottomBar);
    $.__views.__alloyId1085 = Ti.UI.createView({
        width: "100%",
        height: "1px",
        left: 0,
        top: 0,
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId1085"
    });
    $.__views.bottomBar.add($.__views.__alloyId1085);
    $.__views.filterButton = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        title: L("widget_future_filters_title"),
        height: "40dp",
        id: "filterButton"
    });
    $.__views.bottomBar.add($.__views.filterButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var exploreController = require("/v6/common/ExploreController");
    exports = new (require("/carmalib/controller").extend($, {
        _filtersWidget: null,
        events: {
            "click filterButton": "_openFiltersScreen"
        },
        initialize: function() {},
        initWidget: function() {
            this._initFiltersUI();
        },
        _initFiltersUI: function() {
            this._filtersWidget = Widget.createController("filters");
        },
        _openFiltersScreen: function() {
            var wrapperWindow = Alloy.createController("simpleWindow", {
                title: L("widget_future_filters_title")
            });
            wrapperWindow.open({
                view: this._filtersWidget.getView()
            });
            exploreController.once(exploreController.FILTERS_CLOSE, function() {
                wrapperWindow.close();
                wrapperWindow = null;
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;