function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "nextTrip";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.headerBar = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        backgroundColor: Alloy.Globals.Style.Color.Orange,
        top: 0,
        left: 0,
        height: "50dp",
        id: "headerBar"
    });
    $.__views.headerBar && $.addTopLevelView($.__views.headerBar);
    $.__views.nextTripContainer = Ti.UI.createView({
        width: "83.33333333333334%",
        left: 0,
        id: "nextTripContainer"
    });
    $.__views.headerBar.add($.__views.nextTripContainer);
    $.__views.tripInfoContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        id: "tripInfoContainer"
    });
    $.__views.nextTripContainer.add($.__views.tripInfoContainer);
    $.__views.tripTime = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        left: "28dp",
        top: "6dp",
        id: "tripTime"
    });
    $.__views.tripInfoContainer.add($.__views.tripTime);
    $.__views.tripRole = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        left: "28dp",
        top: "23dp",
        id: "tripRole"
    });
    $.__views.tripInfoContainer.add($.__views.tripRole);
    $.__views.tripOrigin = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        left: "94dp",
        right: "12dp",
        top: "6dp",
        height: "19dp",
        ellipsize: true,
        horizontalWrap: false,
        wordWrap: false,
        id: "tripOrigin"
    });
    $.__views.tripInfoContainer.add($.__views.tripOrigin);
    $.__views.tripDestination = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        left: "94dp",
        right: "12dp",
        top: "23dp",
        height: "19dp",
        ellipsize: true,
        horizontalWrap: false,
        wordWrap: false,
        id: "tripDestination"
    });
    $.__views.tripInfoContainer.add($.__views.tripDestination);
    $.__views.menuContainer = Ti.UI.createView({
        width: "16.666666666666664%",
        right: 0,
        id: "menuContainer"
    });
    $.__views.headerBar.add($.__views.menuContainer);
    $.__views.__alloyId1089 = Ti.UI.createView({
        left: 0,
        width: "1px",
        height: "80%",
        backgroundColor: "#fff",
        id: "__alloyId1089"
    });
    $.__views.menuContainer.add($.__views.__alloyId1089);
    $.__views.menuIcon = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "36dp"
        },
        text: "L",
        title: "L",
        id: "menuIcon"
    });
    $.__views.menuContainer.add($.__views.menuIcon);
    $.__views.enableTrips = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        text: L("widget_future_enable_trips"),
        visible: false,
        id: "enableTrips"
    });
    $.__views.headerBar.add($.__views.enableTrips);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("/vendor/q"), Globals = require("/v6/infrastructure/Globals"), exploreService = Globals.IOC.get("exploreService"), moment = require("/vendor/moment"), exploreController = require("/v6/common/ExploreController");
    exports = new (require("/carmalib/controller").extend($, {
        _loading: false,
        _menuButton: null,
        _direction: "down",
        _batchData: null,
        events: {
            "click headerBar": "_menuButtonClicked"
        },
        initialize: function() {
            _.bindAll(this, "_populateTrip", "loadNextTrip", "_loadNextTripDone", "_handleNextTripError", "_getData");
        },
        initWidget: function() {
            return this.loadNextTrip({
                localOnly: true
            });
        },
        setBatchData: function(data) {
            this._batchData = data;
            this.loadNextTrip();
        },
        loadNextTrip: function(options) {
            if (this._loading) return;
            var self = this;
            this._prepareLoadNextTrip();
            return Q().then(function() {
                return self._getData(options);
            }).then(this._populateTrip).catch(this._handleNextTripError).finally(this._loadNextTripDone);
        },
        _getData: function(options) {
            if (this._batchData) {
                var batchData = this._batchData;
                this._batchData = null;
                return batchData;
            }
            return exploreService.nextTrip(options);
        },
        _prepareLoadNextTrip: function() {
            this._loading = true;
        },
        _populateTrip: function(data) {
            if (!data) return;
            if (data.status && data.status > 400) {
                this._handleNextTripError(data);
                return;
            }
            $.tripInfoContainer.visible = true;
            $.enableTrips.visible = false;
            $.tripTime.text = require("i18n/i18n").formatTime(moment(data.schedule.effectiveTime));
            $.tripRole.text = L("RIDE" === data.userRole ? "widget_future_riding" : "widget_future_driving");
            $.tripOrigin.text = data.origin.alias || data.origin.address;
            $.tripDestination.text = String.format(L("widget_future_to_destination"), data.destination.alias || data.destination.address);
        },
        _handleNextTripError: function(error) {
            if (!error) return;
            $.tripInfoContainer.visible = false;
            $.enableTrips.visible = true;
            switch (error.errorCode) {
              case "no_trips":
                $.enableTrips.text = L("widget_future_add_trip");
                break;

              case "all_trips_disabled":
                $.enableTrips.text = L("widget_future_enable_trips");
                break;

              default:
                $.enableTrips.visible = false;
                LOGGER.error("[nextTrip.js] - Not handled error: " + error.errorCode);
            }
        },
        _loadNextTripDone: function() {
            this._loading = false;
        },
        _menuButtonClicked: function() {
            if (exploreController.isSliding()) return;
            exploreController.setSliding(true);
            exploreController.emit(exploreController.MENU_BUTTON_CLICK, {
                open: "down" === this._direction
            });
            "down" === this._direction ? this.pointArrowUp() : this.pointArrowDown();
            setTimeout(function() {
                exploreController.setSliding(false);
            }, exploreController.SLIDE_DOWN_ANIMATION_TIME);
        },
        pointArrowUp: function() {
            if ("up" === this._direction) return;
            $.menuIcon.animate({
                duration: 125,
                transform: Ti.UI.create2DMatrix().rotate(180)
            }, function() {
                $.menuIcon.transform = Ti.UI.create2DMatrix().rotate(180);
            });
            this._direction = "up";
        },
        pointArrowDown: function() {
            if ("down" === this._direction) return;
            $.menuIcon.animate({
                duration: 125,
                transform: Ti.UI.create2DMatrix().rotate(0)
            }, function() {
                $.menuIcon.transform = Ti.UI.create2DMatrix().rotate(0);
            });
            this._direction = "down";
        },
        _customizeUI: function() {
            var path_animator = require("path.animator");
            var labelContainerView = path_animator.createView({
                width: "100%",
                height: "100%",
                top: 0,
                left: 0
            });
            $.menuIconContainer.add(labelContainerView);
            var label = Ti.UI.createLabel({
                font: {
                    fontFamily: "splinico",
                    fontSize: "36dp"
                },
                text: "L",
                color: "white"
            });
            labelContainerView.add(label);
            this._menuButton = labelContainerView;
        },
        refreshBookingsForNextTrip: function() {
            if (this._loading) return;
            exploreService.nextTrip({
                fields: "BOOKINGS"
            });
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;