function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.future2/" + s : s.substring(0, index) + "/ma.car.app.future2/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.future2");
    this.__widgetId = "ma.car.app.future2";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripsList";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripListWindow = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: 0,
        top: 0,
        left: 0,
        zIndex: 1,
        id: "tripListWindow"
    });
    $.__views.tripListWindow && $.addTopLevelView($.__views.tripListWindow);
    $.__views.tripListBackground = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: "100%",
        backgroundColor: "white",
        opacity: 0,
        id: "tripListBackground"
    });
    $.__views.tripListWindow.add($.__views.tripListBackground);
    $.__views.tripListAnimationContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: "70dp",
        height: Ti.UI.FILL,
        id: "tripListAnimationContainer"
    });
    $.__views.tripListWindow.add($.__views.tripListAnimationContainer);
    $.__views.tripsListContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        height: "97%",
        backgroundColor: "white",
        top: "-1000dp",
        id: "tripsListContainer"
    });
    $.__views.tripListAnimationContainer.add($.__views.tripsListContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    exports = new (require("/carmalib/controller").extend($, {
        _tripListOpen: false,
        initialize: function() {
            this._initUI();
        },
        initWidget: function() {
            var widget = Alloy.createWidget("ma.car.app.trip");
            $.tripsListContainer.add(widget.getView());
        },
        _initUI: function() {
            $.tripsListContainer.top = -1 * require("/platform/units").SystemUnitToDip(Ti.Platform.displayCaps.platformHeight) + "dp";
        },
        openTripsList: function() {
            if (this._tripListOpen) return;
            $.tripListWindow.height = "100%";
            $.tripsListContainer.animate({
                top: 0,
                duration: 300
            }, function() {
                $.tripsListContainer.top = 0;
            });
            $.tripListBackground.animate({
                opacity: 1,
                duration: 300
            }, function() {
                $.tripListBackground.opacity = 1;
            });
            this._tripListOpen = true;
        },
        closeTripsList: function() {
            if (!this._tripListOpen) return;
            var top = -1 * require("/platform/units").SystemUnitToDip(Ti.Platform.displayCaps.platformHeight) + "dp";
            $.tripsListContainer.animate({
                top: top,
                duration: 300
            }, function() {
                $.tripsListContainer.top = top;
                $.tripListWindow.height = 0;
            });
            $.tripListBackground.animate({
                opacity: 0,
                duration: 300
            }, function() {
                $.tripListBackground.opacity = 0;
            });
            this._tripListOpen = false;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;