function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.invites/" + s : s.substring(0, index) + "/ma.car.app.invites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.invites");
    this.__widgetId = "ma.car.app.invites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "inviteCard";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.inviteTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_invite_card_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "inviteTitle"
    });
    $.__views.layoutContainer.add($.__views.inviteTitle);
    $.__views.cardContainer = Ti.UI.createView({
        backgroundColor: "#FFF",
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        height: Ti.UI.SIZE,
        width: "100%",
        id: "cardContainer"
    });
    $.__views.layoutContainer.add($.__views.cardContainer);
    $.__views.__alloyId1064 = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        id: "__alloyId1064"
    });
    $.__views.cardContainer.add($.__views.__alloyId1064);
    $.__views.iconImage = Ti.UI.createImageView({
        defaultImage: "/images/invites.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        image: "/images/invites.png",
        height: "auto",
        id: "iconImage"
    });
    $.__views.__alloyId1064.add($.__views.iconImage);
    $.__views.__alloyId1065 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1065"
    });
    $.__views.cardContainer.add($.__views.__alloyId1065);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_invite_how_it_works_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId1065.add($.__views.labelTitle);
    $.__views.__alloyId1066 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1066"
    });
    $.__views.cardContainer.add($.__views.__alloyId1066);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_invite_how_it_works_description"),
        id: "labelMessage"
    });
    $.__views.__alloyId1066.add($.__views.labelMessage);
    $.__views.bannerContainer = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "composite",
        id: "bannerContainer"
    });
    $.__views.cardContainer.add($.__views.bannerContainer);
    $.__views.banner = Ti.UI.createImageView({
        defaultImage: "/images/invite_banner.png",
        top: "10dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/invite_banner.png",
        id: "banner",
        zIndex: "1"
    });
    $.__views.bannerContainer.add($.__views.banner);
    $.__views.yourCode = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: "20dp",
        height: "20dp",
        id: "yourCode",
        zIndex: "2"
    });
    $.__views.bannerContainer.add($.__views.yourCode);
    $.__views.buttonContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        bottom: "15dp",
        id: "buttonContainer"
    });
    $.__views.cardContainer.add($.__views.buttonContainer);
    $.__views.okBtn = require("/ui/common/custom_button").createButton({
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        left: "0dp",
        width: "99%",
        visible: true,
        title: "",
        id: "okBtn",
        indicator: "true"
    });
    $.__views.buttonContainer.add($.__views.okBtn);
    $.__views.__alloyId1067 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1067"
    });
    $.__views.okBtn.add($.__views.__alloyId1067);
    $.__views.__alloyId1068 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1068"
    });
    $.__views.__alloyId1067.add($.__views.__alloyId1068);
    $.__views.okBtnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_share_invite_button"),
        id: "okBtnLabel"
    });
    $.__views.__alloyId1068.add($.__views.okBtnLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), photoURL = require("/utils/photoURL"), photoCache = require("/utils/photoCache"), analytics = require("/tracking/tracking_manager");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click okBtn": "_handleSubmit"
        },
        _inviteId: null,
        _inviteCode: null,
        _openingShare: false,
        _shareOpening: false,
        initialize: function() {
            _.bindAll(this, "_handleSubmit", "_openShare");
            this.display();
        },
        onDestroy: function() {
            $.okBtn.buttonCleanUp();
        },
        display: function() {
            var self = this;
            this._inviteCode = require("services/user_service").getCachReferralCode();
            this._inviteCode ? this.updateBannerCode(this._inviteCode) : require("services/user_service").getReferralCode().then(function(data) {
                require("services/user_service").cachReferralCode(data.referralCode);
                self._inviteCode = data.referralCode;
                self.updateBannerCode(self._inviteCode);
            });
            var profile = require("services/resource_owner_service").singleton().toJSON();
            var url = photoURL.toURL(profile.photoUrl, {
                width: 120,
                height: 120
            });
            var photoPath = photoCache.getCached(url);
            photoPath || photoCache.downloadAvatar(url);
        },
        updateBannerCode: function(inviteCode) {
            var self = this;
            self.inviteCode = inviteCode.toUpperCase();
            $.yourCode.text = self.inviteCode;
        },
        _handleSubmit: function() {
            $.okBtn.stopIndicator();
            if (!this._inviteCode) return;
            if (this.__openingShare) return;
            this._openingShare = true;
            var self = this;
            this._inviteId ? this._openShare() : Alloy.createModel("invitation").generate({
                method: "UNKNOWN",
                entity: "user"
            }).then(function(data) {
                self._inviteId = data.id;
                self._openShare();
            });
        },
        _openShare: function() {
            this._openingShare = false;
            TM.push(function() {
                analytics.track(trackingEvent.INVITE_STARTED, {
                    inviteCode: this._inviteCode,
                    source: "profile"
                });
            }, process.backgroundDomain);
            require("ui/common/sharing").openShare({
                type: "invitefriends",
                inviteId: this._inviteId,
                inviteCode: this._inviteCode
            }, this);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;