function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.invites/" + s : s.substring(0, index) + "/ma.car.app.invites/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.invites");
    this.__widgetId = "ma.car.app.invites";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "inviteFriends";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.referralContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        backgroundColor: "#FFF",
        id: "referralContainer"
    });
    $.__views.referralContainer && $.addTopLevelView($.__views.referralContainer);
    $.__views.referralWrapper = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "100%",
        id: "referralWrapper"
    });
    $.__views.referralContainer.add($.__views.referralWrapper);
    $.__views.invitecode = Ti.UI.createScrollView({
        width: "100%",
        top: 0,
        layout: "vertical",
        height: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        scrollType: "vertical",
        id: "invitecode"
    });
    $.__views.referralWrapper.add($.__views.invitecode);
    $.__views.__alloyId1069 = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        id: "__alloyId1069"
    });
    $.__views.invitecode.add($.__views.__alloyId1069);
    $.__views.iconImage = Ti.UI.createImageView({
        defaultImage: "/images/txtag.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        id: "iconImage"
    });
    $.__views.__alloyId1069.add($.__views.iconImage);
    $.__views.howWorksDescripTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        top: "20dp",
        text: L("widget_invite_how_it_works_title"),
        id: "howWorksDescripTitle"
    });
    $.__views.invitecode.add($.__views.howWorksDescripTitle);
    $.__views.howWorkDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        width: "100%",
        text: L("widget_invite_how_it_works_description"),
        id: "howWorkDetails"
    });
    $.__views.invitecode.add($.__views.howWorkDetails);
    $.__views.bannerContainer = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "composite",
        id: "bannerContainer"
    });
    $.__views.invitecode.add($.__views.bannerContainer);
    $.__views.banner = Ti.UI.createImageView({
        defaultImage: "/images/invite_banner.png",
        top: "10dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/invite_banner.png",
        id: "banner",
        zIndex: "1"
    });
    $.__views.bannerContainer.add($.__views.banner);
    $.__views.yourCode = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: "20dp",
        height: "20dp",
        id: "yourCode",
        zIndex: "2"
    });
    $.__views.bannerContainer.add($.__views.yourCode);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "100%",
        bottom: "15dp",
        top: "10dp",
        title: L("widget_share_invite_button"),
        id: "submit"
    });
    $.__views.invitecode.add($.__views.submit);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, utils = require("utils/utils"), navigation = args.navigation || Alloy.Globals.Nav.Profile, trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click submit": "_handleSubmit"
        },
        inviteId: null,
        inviteCode: null,
        url: null,
        TAG: "Invites",
        SHARE_URL: require("bootstrap/env").getWebURL() + "/i/",
        _shareOpening: false,
        initialize: function() {
            var self = this;
            $.iconImage.image = "/images/invites.png";
            $.iconImage.defaultImage = "/images/invites.png";
            $.banner.image = "/images/invite_banner.png";
            self.inviteCode = require("services/user_service").getCachReferralCode();
            if (self.inviteCode) {
                self.inviteCode = self.inviteCode.toUpperCase();
                $.yourCode.text = self.inviteCode;
            }
        },
        onDestroy: function() {
            $.submit.buttonCleanUp();
            args.navigation;
        },
        _handleSubmit: function() {
            if (!this.inviteId || !this.inviteCode) return;
            TM.push(function() {
                analytics.track(trackingEvent.INVITE_STARTED, {
                    inviteCode: this.inviteCode,
                    source: "profile"
                });
            }, process.backgroundDomain);
            require("ui/common/sharing").openShare({
                type: "invitefriends",
                inviteId: this.inviteId,
                inviteCode: this.inviteCode
            }, this);
        },
        showInviteCode: function(inviteCode, inviteId) {
            if (!inviteCode || !inviteId) return;
            this.inviteId = inviteId;
            this.inviteCode = inviteCode.toUpperCase();
            $.yourCode.text = this.inviteCode;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;