function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.locationcard/" + s : s.substring(0, index) + "/ma.car.app.locationcard/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.locationcard");
    this.__widgetId = "ma.car.app.locationcard";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        visible: false,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundColor: "#FFF",
        top: "10dp",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.__alloyId1001 = Ti.UI.createView({
        width: "100%",
        height: Ti.UI.SIZE,
        id: "__alloyId1001"
    });
    $.__views.layout.add($.__views.__alloyId1001);
    $.__views.iconImage = Ti.UI.createImageView({
        defaultImage: "/images/txtag.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        id: "iconImage"
    });
    $.__views.__alloyId1001.add($.__views.iconImage);
    $.__views.__alloyId1002 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1002"
    });
    $.__views.layout.add($.__views.__alloyId1002);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_nomatches_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId1002.add($.__views.labelTitle);
    $.__views.__alloyId1003 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId1003"
    });
    $.__views.layout.add($.__views.__alloyId1003);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_nomatches_message"),
        id: "labelMessage"
    });
    $.__views.__alloyId1003.add($.__views.labelMessage);
    $.__views.buttonContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        bottom: "15dp",
        id: "buttonContainer"
    });
    $.__views.layout.add($.__views.buttonContainer);
    $.__views.noBtn = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "noBtn",
        indicator: "true"
    });
    $.__views.buttonContainer.add($.__views.noBtn);
    $.__views.__alloyId1004 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1004"
    });
    $.__views.noBtn.add($.__views.__alloyId1004);
    $.__views.__alloyId1005 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1005"
    });
    $.__views.__alloyId1004.add($.__views.__alloyId1005);
    $.__views.noBtnLabel = Ti.UI.createLabel({
        color: "#666",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_not_now"),
        id: "noBtnLabel"
    });
    $.__views.__alloyId1005.add($.__views.noBtnLabel);
    $.__views.yesBtn = require("/ui/common/custom_button").createButton({
        right: 0,
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        title: "",
        id: "yesBtn",
        indicator: "true"
    });
    $.__views.buttonContainer.add($.__views.yesBtn);
    $.__views.__alloyId1006 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1006"
    });
    $.__views.yesBtn.add($.__views.__alloyId1006);
    $.__views.__alloyId1007 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1007"
    });
    $.__views.__alloyId1006.add($.__views.__alloyId1007);
    $.__views.yesBtnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_yes"),
        id: "yesBtnLabel"
    });
    $.__views.__alloyId1007.add($.__views.yesBtnLabel);
    $.__views.okBtn = require("/ui/common/custom_button").createButton({
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        top: "-44dp",
        left: "0dp",
        width: "99%",
        visible: false,
        title: "",
        id: "okBtn",
        indicator: "true"
    });
    $.__views.buttonContainer.add($.__views.okBtn);
    $.__views.__alloyId1008 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1008"
    });
    $.__views.okBtn.add($.__views.__alloyId1008);
    $.__views.__alloyId1009 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1009"
    });
    $.__views.__alloyId1008.add($.__views.__alloyId1009);
    $.__views.okBtnLabel = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_ok"),
        id: "okBtnLabel"
    });
    $.__views.__alloyId1009.add($.__views.okBtnLabel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, preferences = require("services/preferences_service"), deepLinker = require("/bootstrap/deepLinker"), gps = require("gps/gps_manager");
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "locationSpecific",
        currentIndex: 0,
        displayCards: null,
        yesUrl: null,
        currentId: null,
        bBlock: false,
        options: {},
        showLocationCards: null,
        events: {
            "click noBtn": "_handleNoAction",
            "click yesBtn": "_handleYesAction",
            "click okBtn": "_handleNoAction"
        },
        initialize: function() {
            var self = this;
            gps.lastLocation() ? this._loadLocationCard(this.options) : require("gps/gps_service").isLocationServiceEnabled() && Ti.App.addAppEventListener("carma:valid.location.update", function checkLocationCard() {
                Ti.App.removeAppEventListener("carma:valid.location.update", checkLocationCard);
                self._loadLocationCard(self.options);
            });
        },
        _loadLocationCard: function(options) {
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), self = this, lastLocation = gps.lastLocation() || {};
            true === self.showLocationCards && null != self.displayCards && self.displayCards.length > 0 ? self.display() : null === self.showLocationCards && require("/services/user_service").getInformationCards(myUserId, lastLocation.lat, lastLocation.lon).then(function(data) {
                var cachedPreferences = require("services/cached_preferences_service").singleton();
                if (cachedPreferences.has("preference")) self._checkLocationPreference(data, cachedPreferences, options); else {
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    Alloy.createModel("preferences", {
                        urlParams: {
                            userId: resourceOwner.get("userId")
                        }
                    }).fetch().then(function(preferences) {
                        if (preferences) {
                            cachedPreferences.save(preferences);
                            self._checkLocationPreference(data, cachedPreferences, options);
                        }
                    });
                }
            });
        },
        _checkLocationPreference: function(data, cachedPreferences, options) {
            var self = this, displayCards = [];
            _.each(data.cards, function(card) {
                cachedPreferences.has("preference") && null == cachedPreferences.getLocationSpecificCard(card.id) && displayCards.push(card);
            });
            if (displayCards.length > 0) {
                self.displayCards = displayCards;
                self.currentIndex = 0;
                self.display();
                self.showLocationCards = true;
            }
        },
        _handleNoAction: function(options) {
            if (this.bBlock || this.currentIndex >= this.displayCards.length) return;
            this.bBlock = true;
            var self = this;
            this.currentIndex++;
            if (null != this.currentId) {
                if (!options.sentFromYesAction && 29 === self.currentId) {
                    var alertDialog = Titanium.UI.createAlertDialog({
                        title: L("widget_fastrak_not_now_title"),
                        message: L("widget_fastrak_not_now_message"),
                        buttonNames: [ L("widget_fastrak_not_now_got_it_label") ],
                        cancel: 0
                    });
                    alertDialog.show();
                }
                preferences.updateLocationSpecific(this.currentId).then(function() {
                    var resourceOwner = require("services/resource_owner_service").singleton();
                    Alloy.createModel("preferences", {
                        urlParams: {
                            userId: resourceOwner.get("userId")
                        }
                    }).fetch().then(function(data) {
                        if (data) {
                            var cachedPreferences = require("services/cached_preferences_service").singleton();
                            cachedPreferences.save(data);
                            if (self.currentIndex < self.displayCards.length) self.updateContent(self.displayCards[self.currentIndex]); else {
                                Ti.App.fireEvent("app.carma.preferences.changes");
                                self.disappear();
                            }
                            self.bBlock = false;
                            $.noBtn.stopIndicator();
                            $.yesBtn.stopIndicator();
                            $.okBtn.stopIndicator();
                        }
                    });
                });
            }
        },
        _handleYesAction: function(options) {
            _.extend(options, {
                sentFromYesAction: true
            });
            this._handleNoAction(options);
            this.yesUrl && (deepLinker.handleUrl(this.yesUrl) || Ti.Platform.openURL(this.yesUrl));
        },
        display: function() {
            this.updateContent(this.displayCards[this.currentIndex]);
            $.layout.show();
            $.trigger("locationCard.show");
        },
        disappear: function() {
            $.layout.hide();
            $.trigger("locationCard.hide");
        },
        updateContent: function(card) {
            $.labelTitle.setText(card.title);
            $.labelMessage.setText(card.body);
            $.iconImage.image = card.iconUrl;
            $.iconImage.defaultImage = card.iconUrl;
            this.yesUrl = card.confirmUrl;
            if (this.yesUrl) {
                $.yesBtn.show();
                $.noBtn.show();
                $.okBtn.hide();
            } else {
                $.yesBtn.hide();
                $.noBtn.hide();
                $.okBtn.show();
            }
            this.currentId = card.id;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;