function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.login/" + s : s.substring(0, index) + "/ma.car.app.login/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.login");
    this.__widgetId = "ma.car.app.login";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "login";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.loginContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "loginContainer"
    });
    $.__views.loginContainer && $.addTopLevelView($.__views.loginContainer);
    $.__views.devInfo = Alloy.createWidget("ma.car.app.devinfo", "widget", {
        id: "devInfo",
        __parentSymbol: $.__views.loginContainer
    });
    $.__views.devInfo.setParent($.__views.loginContainer);
    $.__views.__alloyId1 = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "1px",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS,
        id: "__alloyId1"
    });
    $.__views.loginContainer.add($.__views.__alloyId1);
    $.__views.__alloyId2 = Ti.UI.createScrollView({
        scrollType: "vertical",
        id: "__alloyId2"
    });
    $.__views.loginContainer.add($.__views.__alloyId2);
    $.__views.loginView = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        bottom: 0,
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: "380dp",
        id: "loginView"
    });
    $.__views.__alloyId2.add($.__views.loginView);
    $.__views.email = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "90dp",
        hintText: L("widget_login_input_hint_email"),
        keyboardType: Ti.UI.KEYBOARD_EMAIL,
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "email"
    });
    $.__views.loginView.add($.__views.email);
    $.__views.password = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: "160dp",
        hintText: L("widget_login_input_hint_password"),
        passwordMask: true,
        returnKeyType: Ti.UI.RETURNKEY_GO,
        id: "password"
    });
    $.__views.loginView.add($.__views.password);
    $.__views.showPasswordContainer = Ti.UI.createView({
        top: "220dp",
        left: 0,
        height: "50dp",
        id: "showPasswordContainer"
    });
    $.__views.loginView.add($.__views.showPasswordContainer);
    $.__views.showPassword = Ti.UI.createLabel({
        color: "#fff",
        top: "10dp",
        left: 0,
        width: "20dp",
        height: "20dp",
        zIndex: 3,
        backgroundColor: "transparent",
        borderColor: "#fff",
        borderWidth: "2dp",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "showPassword"
    });
    $.__views.showPasswordContainer.add($.__views.showPassword);
    $.__views.showPasswordTicker = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontFamily: "splinico",
            fontSize: "14dp"
        },
        text: "c",
        visible: false,
        top: "10dp",
        left: "3dp",
        width: "20dp",
        height: "20dp",
        zIndex: 5,
        id: "showPasswordTicker"
    });
    $.__views.showPasswordContainer.add($.__views.showPasswordTicker);
    $.__views.showPasswordHint = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "12dp"
        },
        top: "13dp",
        left: "30dp",
        width: Alloy.Globals.Style.Size.Width.pct70,
        text: L("widget_login_checkbox_hint_showpassword"),
        id: "showPasswordHint"
    });
    $.__views.showPasswordContainer.add($.__views.showPasswordHint);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        width: Alloy.Globals.Style.Size.Width.grid11,
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: "270dp",
        left: 0,
        title: L("widget_login_button_login"),
        id: "submit"
    });
    $.__views.loginView.add($.__views.submit);
    $.__views.forgotPassword = Ti.UI.createLabel({
        color: "#003366",
        font: {
            fontSize: "12dp"
        },
        top: "342dp",
        right: 0,
        text: L("widget_login_link_forgotpassword"),
        id: "forgotPassword"
    });
    $.__views.loginView.add($.__views.forgotPassword);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Q = require("vendor/q"), AnimatedBottomView = require("/ui/common/animated_bottom_view"), FieldsRoller = require("/ui/common/fields_roller"), Validator = require("/validator/validator_factory"), ErrorDialog = require("/ui/common/validation_error"), link = require("/ui/link"), PasswordToggle = require("/ui/common/password_toggle"), navigation = Alloy.Globals.Nav.Login || Alloy.createController("navigation");
    exports = new (require("/carmalib/controller").extend($, {
        _idRequest: null,
        _oauthToken: null,
        events: {
            "click[ios] submit": "_validateLogin",
            "click[android] submit": "_validateLogin",
            "return password": "_validateLogin",
            "click[ios] forgotPassword": "_passwordReset",
            "click[android] forgotPassword": "_passwordReset",
            "click showPasswordContainer": "_trackShowPassword"
        },
        initialize: function() {
            _.bindAll(this, "_login", "_getOAuthToken", "_saveUser", "_loginSuccess", "_loginError", "_stopSpinner", "_validateLogin", "_passwordReset", "_fetchUser");
            this._initModels();
            this._setupViewAnimation();
            this._setupFieldsRoller();
            this._setupPasswordToggle();
            var _window = require("utils/ui").getWindow($.loginContainer);
            _window.addEventListener("postlayout", function onPostLayout() {
                _window.removeEventListener("postlayout", onPostLayout);
                link.makeUnderlinedLink($.forgotPassword);
            });
        },
        configure: function() {
            require("/vendor/meld").after(this, "_loginSuccess", function() {
                var event = require("/tracking/tracking_event");
                require("/tracking/tracking_manager").track(event.LOGIN, {
                    source: "Email"
                });
            });
        },
        _initModels: function() {
            this._idRequest = Widget.createModel("idrequest");
            this._oauthToken = Widget.createModel("oauthtoken");
        },
        _setupViewAnimation: function() {
            return;
        },
        _setupFieldsRoller: function() {
            new FieldsRoller([ {
                from: $.email,
                to: $.password
            } ]);
        },
        _setupPasswordToggle: function() {
            new PasswordToggle($.showPasswordContainer, $.password, $.showPassword, $.showPasswordTicker);
        },
        _validateLogin: function() {
            this._clearError();
            var email = $.email.getValue();
            if ("9876543210" === email) {
                Carma.Window.Tools || Alloy.createWidget("ma.car.app.tools").getView().open();
                return;
            }
            if (!Ti.Network.online) {
                Ti.UI.createAlertDialog({
                    message: L("widget_login_error_offline")
                }).show();
                return;
            }
            if (Validator.form().checkCustomTextFieldsEmpty([ $.email, $.password ])) {
                ErrorDialog.show();
                return;
            }
            email = $.email.value;
            if (!Validator.string().isEmpty(email) && !Validator.email().isEmail(email)) {
                $.email.showError(L("widget_signup_error_invalid_email"));
                ErrorDialog.show();
                return;
            }
            this._startSpinner().then(this._login).then(this._getOAuthToken).then(this._saveUser).then(this._fetchUser).then(this._loginSuccess).catch(this._loginError).finally(this._stopSpinner);
        },
        _clearError: function() {
            $.email.clearError();
            $.password.clearError();
            $.email.blur();
            $.password.blur();
        },
        _startSpinner: function() {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return true;
            });
        },
        _login: function() {
            var email = $.email.value, password = $.password.value;
            this._idRequest.clear();
            return this._idRequest.save({
                identity: {
                    type: "PRIMARY_EMAIL",
                    key: email
                },
                password: password
            });
        },
        _getOAuthToken: function() {
            this._oauthToken.clear();
            var email = $.email.value, password = $.password.value;
            return this._oauthToken.requestToken(email, password);
        },
        _saveUser: function() {
            var resourceOwner = require("services/resource_owner_service").singleton(), token = this._oauthToken.get("token");
            resourceOwner.save({
                userId: this._idRequest.get("userId"),
                token: {
                    token: token,
                    expiresIn: this._oauthToken.get("expiresIn")
                }
            });
            return true;
        },
        _fetchUser: function() {
            return require("services/user_service").findOwn().then(function(data) {
                Ti.App.fireEvent("app.carma.profile.change", data);
            });
        },
        _loginSuccess: function() {
            var self = this;
            var defer = require("vendor/q").defer();
            Ti.App.fireEvent("carma:login.success", {
                callback: function() {
                    defer.resolve({});
                    self.closeWindow();
                }
            });
            var invite = Ti.App.Properties.getObject("invite");
            if (invite && invite.id) {
                var inviteModel = Alloy.createModel("invite_code");
                inviteModel.trackInviteEvent({
                    inviteId: invite.id,
                    eventType: inviteModel.ALREADY_REGISTERED
                });
            }
            require("services/preferences_service").fetchPreferences();
            return defer.promise;
        },
        _loginError: function(error) {
            LOGGER.error("Error to be handled....");
            LOGGER.error(JSON.stringify(error));
            LOGGER.error(false);
            if (404 === error.status) {
                ErrorDialog.showSimple(L("widget_home_msg_login_error_unknown"));
                return;
            }
            if (401 === error.status) {
                if ("unauthorized" === error.errorCode) {
                    ErrorDialog.showSimple(L("widget_login_error_unauthorized"));
                    return;
                }
            } else {
                if ("missing_password" === error.errorCode) {
                    $.password.setErrorText($.password.hintText);
                    return;
                }
                if ("missing_identity_key" === error.errorCode) {
                    $.email.showError($.email.hintText);
                    return;
                }
            }
            if (error.description) {
                ErrorDialog.showSimple(String.format(L("widget_home_msg_login_error_with_info"), error.description));
                return;
            }
            if (error.errorCode) {
                ErrorDialog.showSimple(String.format(L("widget_home_msg_login_error_with_info"), error.errorCode));
                return;
            }
            ErrorDialog.showSimple(L("widget_home_msg_login_error_unknown"));
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _passwordReset: function() {
            $.email.blur();
            $.password.blur();
            var passwordResetView = Alloy.createWidget("ma.car.app.login", "forgotPassword", {
                email: $.email.value
            });
            navigation.open(passwordResetView, {
                title: L("widget_login_title_forgotpassword")
            });
        },
        _trackShowPassword: function() {
            var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager");
            analytics.track(trackingEvent.LOGIN_SHOW_PASSWORD);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;