function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.login/" + s : s.substring(0, index) + "/ma.car.app.login/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.login");
    this.__widgetId = "ma.car.app.login";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.loginWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "loginWindow"
    });
    $.__views.loginWindow && $.addTopLevelView($.__views.loginWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    !function() {
        require("/ui/windowManager").trackWindow($.loginWindow);
        var navigation = Alloy.Globals.Nav.Login = Alloy.createController("navigation"), widget = null, title = L("widget_login_title_login"), interval = null;
        if (args.hasOwnProperty("path")) {
            title = L("widget_login_resetpassword_title");
            widget = Alloy.createWidget("ma.car.app.login", "resetPassword", args);
        } else widget = Alloy.createWidget("ma.car.app.login", "login");
        $.loginWindow.addEventListener("close", function() {
            Alloy.Globals.Nav.Login = null;
            clearInterval(interval);
            interval = null;
        });
        navigation.init({
            index: widget,
            historyLimit: 20,
            mainWindow: $.loginWindow,
            coverImage: "/images/background.png",
            title: title,
            theme: "white"
        });
    }();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;