function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "account_summary";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.accountSummary = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: Alloy.Globals.Style.Size.Width.pct4,
        layout: "vertical",
        height: Ti.UI.SIZE,
        backgroundColor: "transparent",
        id: "accountSummary"
    });
    $.__views.accountSummary && $.addTopLevelView($.__views.accountSummary);
    $.__views.txtag = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: 0,
        visible: false,
        id: "txtag"
    });
    $.__views.accountSummary.add($.__views.txtag);
    $.__views.txttagIconContainer = Ti.UI.createView({
        width: "48dp",
        height: "48dp",
        left: 0,
        id: "txttagIconContainer"
    });
    $.__views.txtag.add($.__views.txttagIconContainer);
    $.__views.txtagIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/icon-txtag.png",
        width: "24dp",
        height: "24dp",
        id: "txtagIcon"
    });
    $.__views.txttagIconContainer.add($.__views.txtagIcon);
    $.__views.txtagTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_txtag_title"),
        id: "txtagTitle"
    });
    $.__views.txtag.add($.__views.txtagTitle);
    $.__views.txtagCount = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "txtagCount"
    });
    $.__views.txtag.add($.__views.txtagCount);
    $.__views.__alloyId519 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "__alloyId519"
    });
    $.__views.txtag.add($.__views.__alloyId519);
    $.__views.fastrak = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "fastrak"
    });
    $.__views.accountSummary.add($.__views.fastrak);
    $.__views.txttagIconContainer = Ti.UI.createView({
        width: "48dp",
        height: "48dp",
        left: 0,
        id: "txttagIconContainer"
    });
    $.__views.fastrak.add($.__views.txttagIconContainer);
    $.__views.fastrakIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/icon-fastrak.png",
        width: "24dp",
        height: "24dp",
        id: "fastrakIcon"
    });
    $.__views.txttagIconContainer.add($.__views.fastrakIcon);
    $.__views.fastrakTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_fastrak_title"),
        id: "fastrakTitle"
    });
    $.__views.fastrak.add($.__views.fastrakTitle);
    $.__views.fastrakCount = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "fastrakCount"
    });
    $.__views.fastrak.add($.__views.fastrakCount);
    $.__views.__alloyId520 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "__alloyId520"
    });
    $.__views.fastrak.add($.__views.__alloyId520);
    $.__views.txtagHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: 0,
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        visible: false,
        id: "txtagHr"
    });
    $.__views.accountSummary.add($.__views.txtagHr);
    $.__views.myCredit = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "myCredit"
    });
    $.__views.accountSummary.add($.__views.myCredit);
    $.__views.__alloyId521 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "26dp"
        },
        text: "t",
        top: 0,
        left: 0,
        width: "44dp",
        height: "48dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "__alloyId521"
    });
    $.__views.myCredit.add($.__views.__alloyId521);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_carma_credit"),
        id: "totalBalance"
    });
    $.__views.myCredit.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "balanceDetails"
    });
    $.__views.myCredit.add($.__views.balanceDetails);
    $.__views.__alloyId522 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "__alloyId522"
    });
    $.__views.myCredit.add($.__views.__alloyId522);
    $.__views.myCreditHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "myCreditHr"
    });
    $.__views.accountSummary.add($.__views.myCreditHr);
    $.__views.favourites = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        visible: false,
        id: "favourites"
    });
    $.__views.accountSummary.add($.__views.favourites);
    $.__views.__alloyId523 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "j",
        top: 0,
        left: 0,
        width: "44dp",
        height: "48dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "__alloyId523"
    });
    $.__views.favourites.add($.__views.__alloyId523);
    $.__views.__alloyId524 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_favourite_title"),
        id: "__alloyId524"
    });
    $.__views.favourites.add($.__views.__alloyId524);
    $.__views.favouriteCount = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        text: L("widget_profile_summary_favourite_description"),
        id: "favouriteCount"
    });
    $.__views.favourites.add($.__views.favouriteCount);
    $.__views.favouriteArrow = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "favouriteArrow"
    });
    $.__views.favourites.add($.__views.favouriteArrow);
    $.__views.favouritesHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "favouritesHr"
    });
    $.__views.accountSummary.add($.__views.favouritesHr);
    $.__views.promoCode = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "promoCode"
    });
    $.__views.accountSummary.add($.__views.promoCode);
    $.__views.txttagIconContainer = Ti.UI.createView({
        width: "48dp",
        height: "48dp",
        left: 0,
        id: "txttagIconContainer"
    });
    $.__views.promoCode.add($.__views.txttagIconContainer);
    $.__views.promoCodeIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/icon-promocode.png",
        width: "24dp",
        height: "24dp",
        id: "promoCodeIcon"
    });
    $.__views.txttagIconContainer.add($.__views.promoCodeIcon);
    $.__views.promoCodeTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_promocode_title"),
        id: "promoCodeTitle"
    });
    $.__views.promoCode.add($.__views.promoCodeTitle);
    $.__views.promoCodeSubtitle = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        text: L("widget_profile_summary_promocode_subtitle"),
        id: "promoCodeSubtitle"
    });
    $.__views.promoCode.add($.__views.promoCodeSubtitle);
    $.__views.__alloyId525 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "__alloyId525"
    });
    $.__views.promoCode.add($.__views.__alloyId525);
    $.__views.promoCodeHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "promoCodeHr"
    });
    $.__views.accountSummary.add($.__views.promoCodeHr);
    $.__views.invite = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "invite"
    });
    $.__views.accountSummary.add($.__views.invite);
    $.__views.txttagIconContainer = Ti.UI.createView({
        width: "48dp",
        height: "48dp",
        left: 0,
        id: "txttagIconContainer"
    });
    $.__views.invite.add($.__views.txttagIconContainer);
    $.__views.inviteIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/icon-invitefriends.png",
        width: "24dp",
        height: "24dp",
        id: "inviteIcon"
    });
    $.__views.txttagIconContainer.add($.__views.inviteIcon);
    $.__views.inviteTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_invite_friends_title"),
        id: "inviteTitle"
    });
    $.__views.invite.add($.__views.inviteTitle);
    $.__views.inviteDetails = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        text: L("widget_profile_invite_friends_subtitle"),
        id: "inviteDetails"
    });
    $.__views.invite.add($.__views.inviteDetails);
    $.__views.__alloyId526 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "__alloyId526"
    });
    $.__views.invite.add($.__views.__alloyId526);
    $.__views.inviteHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "inviteHr"
    });
    $.__views.accountSummary.add($.__views.inviteHr);
    $.__views.rating = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "rating"
    });
    $.__views.accountSummary.add($.__views.rating);
    $.__views.__alloyId527 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "p",
        top: 0,
        left: 0,
        width: "44dp",
        height: "48dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "__alloyId527"
    });
    $.__views.rating.add($.__views.__alloyId527);
    $.__views.__alloyId528 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_rating_title"),
        id: "__alloyId528"
    });
    $.__views.rating.add($.__views.__alloyId528);
    $.__views.ratingDetails = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "ratingDetails"
    });
    $.__views.rating.add($.__views.ratingDetails);
    $.__views.ratingStars = require("/ui/common/rating_stars").createView({
        text: "p",
        right: "25dp",
        width: "50dp",
        height: "10dp",
        layout: "horizontal",
        font: {
            fontFamily: "splinico",
            fontSize: "10dp"
        },
        id: "ratingStars"
    });
    $.__views.rating.add($.__views.ratingStars);
    $.__views.ratingHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "ratingHr"
    });
    $.__views.accountSummary.add($.__views.ratingHr);
    $.__views.groups = require("/ma.car.app.profile/tactile_row").createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "groups"
    });
    $.__views.accountSummary.add($.__views.groups);
    $.__views.__alloyId529 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "q",
        top: 0,
        left: 0,
        width: "44dp",
        height: "48dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "__alloyId529"
    });
    $.__views.groups.add($.__views.__alloyId529);
    $.__views.__alloyId530 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_group_title"),
        id: "__alloyId530"
    });
    $.__views.groups.add($.__views.__alloyId530);
    $.__views.groupsCount = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "groupsCount"
    });
    $.__views.groups.add($.__views.groupsCount);
    $.__views.__alloyId531 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "16dp",
        right: "5dp",
        id: "__alloyId531"
    });
    $.__views.groups.add($.__views.__alloyId531);
    $.__views.groupsHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "groupsHr"
    });
    $.__views.accountSummary.add($.__views.groupsHr);
    $.__views.rides = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "rides"
    });
    $.__views.accountSummary.add($.__views.rides);
    $.__views.__alloyId532 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "r",
        top: 0,
        left: 0,
        width: "44dp",
        height: "48dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "__alloyId532"
    });
    $.__views.rides.add($.__views.__alloyId532);
    $.__views.__alloyId533 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_ride_title"),
        id: "__alloyId533"
    });
    $.__views.rides.add($.__views.__alloyId533);
    $.__views.rideCount = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "rideCount"
    });
    $.__views.rides.add($.__views.rideCount);
    $.__views.ridesHr = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "ridesHr"
    });
    $.__views.accountSummary.add($.__views.ridesHr);
    $.__views.verifications = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: 0,
        height: "48dp",
        id: "verifications"
    });
    $.__views.accountSummary.add($.__views.verifications);
    $.__views.__alloyId534 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "c",
        top: 0,
        left: 0,
        width: "44dp",
        height: "48dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "__alloyId534"
    });
    $.__views.verifications.add($.__views.__alloyId534);
    $.__views.__alloyId535 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "8dp",
        left: "44dp",
        font: {
            fontSize: "17dp"
        },
        text: L("widget_profile_summary_verification_title"),
        id: "__alloyId535"
    });
    $.__views.verifications.add($.__views.__alloyId535);
    $.__views.verificationCount = Ti.UI.createLabel({
        color: "#a4a4a4",
        font: {
            fontSize: "12dp"
        },
        top: "26dp",
        left: "44dp",
        id: "verificationCount"
    });
    $.__views.verifications.add($.__views.verificationCount);
    $.__views.addVerification = require("/ui/common/tactile_label").createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "36dp"
        },
        text: "+",
        right: 0,
        top: 0,
        width: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        visible: false,
        id: "addVerification"
    });
    $.__views.verifications.add($.__views.addVerification);
    $.__views.verificationList = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "verificationList"
    });
    $.__views.accountSummary.add($.__views.verificationList);
    $.__views.__alloyId536 = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: "30dp",
        id: "__alloyId536"
    });
    $.__views.verificationList.add($.__views.__alloyId536);
    $.__views.__alloyId537 = Ti.UI.createView({
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        id: "__alloyId537"
    });
    $.__views.__alloyId536.add($.__views.__alloyId537);
    $.__views.__alloyId538 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: "3dp",
        text: L("widget_profile_summary_verification_item_phone"),
        id: "__alloyId538"
    });
    $.__views.__alloyId536.add($.__views.__alloyId538);
    $.__views.phoneVerification = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "10dp"
        },
        right: "3dp",
        id: "phoneVerification"
    });
    $.__views.__alloyId536.add($.__views.phoneVerification);
    $.__views.__alloyId539 = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: "30dp",
        id: "__alloyId539"
    });
    $.__views.verificationList.add($.__views.__alloyId539);
    $.__views.__alloyId540 = Ti.UI.createView({
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        id: "__alloyId540"
    });
    $.__views.__alloyId539.add($.__views.__alloyId540);
    $.__views.__alloyId541 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: "3dp",
        text: L("widget_profile_summary_verification_item_email"),
        id: "__alloyId541"
    });
    $.__views.__alloyId539.add($.__views.__alloyId541);
    $.__views.emailVerification = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "10dp"
        },
        right: "3dp",
        id: "emailVerification"
    });
    $.__views.__alloyId539.add($.__views.emailVerification);
    $.__views.__alloyId542 = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: "30dp",
        id: "__alloyId542"
    });
    $.__views.verificationList.add($.__views.__alloyId542);
    $.__views.__alloyId543 = Ti.UI.createView({
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        id: "__alloyId543"
    });
    $.__views.__alloyId542.add($.__views.__alloyId543);
    $.__views.__alloyId544 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: "3dp",
        text: L("widget_profile_summary_verification_item_facebook"),
        id: "__alloyId544"
    });
    $.__views.__alloyId542.add($.__views.__alloyId544);
    $.__views.facebookVerification = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "10dp"
        },
        right: "3dp",
        id: "facebookVerification"
    });
    $.__views.__alloyId542.add($.__views.facebookVerification);
    $.__views.affiliateList = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "affiliateList"
    });
    $.__views.verificationList.add($.__views.affiliateList);
    $.__views.__alloyId545 = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: "30dp",
        id: "__alloyId545"
    });
    $.__views.verificationList.add($.__views.__alloyId545);
    $.__views.__alloyId546 = Ti.UI.createView({
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        id: "__alloyId546"
    });
    $.__views.__alloyId545.add($.__views.__alloyId546);
    $.__views.positiveReviewCount = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: "3dp",
        id: "positiveReviewCount"
    });
    $.__views.__alloyId545.add($.__views.positiveReviewCount);
    $.__views.positiveReviewVerification = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "10dp"
        },
        right: "3dp",
        id: "positiveReviewVerification"
    });
    $.__views.__alloyId545.add($.__views.positiveReviewVerification);
    $.__views.replyRateSection = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: "30dp",
        id: "replyRateSection"
    });
    $.__views.verificationList.add($.__views.replyRateSection);
    $.__views.__alloyId547 = Ti.UI.createView({
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        id: "__alloyId547"
    });
    $.__views.replyRateSection.add($.__views.__alloyId547);
    $.__views.__alloyId548 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: "3dp",
        text: L("widget_profile_summary_reply_rate_title"),
        id: "__alloyId548"
    });
    $.__views.replyRateSection.add($.__views.__alloyId548);
    $.__views.replyRate = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        right: "3dp",
        id: "replyRate"
    });
    $.__views.replyRateSection.add($.__views.replyRate);
    $.__views.replyTimeSection = Ti.UI.createView({
        width: "90%",
        top: 0,
        left: "5%",
        height: "30dp",
        id: "replyTimeSection"
    });
    $.__views.verificationList.add($.__views.replyTimeSection);
    $.__views.__alloyId549 = Ti.UI.createView({
        backgroundImage: "/images/dotted.png",
        backgroundRepeat: true,
        height: "1px",
        width: "100%",
        top: 0,
        left: 0,
        id: "__alloyId549"
    });
    $.__views.replyTimeSection.add($.__views.__alloyId549);
    $.__views.__alloyId550 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        left: "3dp",
        text: L("widget_profile_summary_reply_time_title"),
        id: "__alloyId550"
    });
    $.__views.replyTimeSection.add($.__views.__alloyId550);
    $.__views.replyTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        right: "3dp",
        id: "replyTime"
    });
    $.__views.replyTimeSection.add($.__views.replyTime);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, moment = require("/vendor/moment"), navigation = args.navigation || Alloy.Globals.Nav.Profile, rootWindow = TABS_HELPER.rootWindow(), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService");
    var Q = require("vendor/q");
    exports = new (require("/carmalib/controller").extend($, {
        _isMyProfile: args.isMyProfile,
        _rowsIds: [ "rating", "groups", "favourites", "rides" ],
        _userId: args.userId,
        _profile: null,
        _affiliates: [],
        _inviteCode: null,
        _txtags: null,
        _isLoadingTxtags: true,
        _registeredEventForTxtagRefresh: false,
        _shouldHandleTolls: false,
        _tollToHandle: false,
        _firstTagMenuLoad: false,
        _opening: false,
        events: {
            "click[ios] myTrips": "_handleMyTripsAction",
            "click[ios] myCredit": "_handleMyCreditAction",
            "click[ios] rating": "_handleRatingAction",
            "click[ios] groups": "_handleGroupsAction",
            "click[ios] favourites": "_handleFavouritesAction",
            "click[ios] addVerification": "_handleMoreVerificationAction",
            "click[ios] txtag": "_handleTxtagAction",
            "click[ios] fastrak": "_handleFastrakAction",
            "click[ios] promoCode": "_handlePromoCodeAction",
            "click[ios] invite": "_handleInviteAction",
            "click[android] myTrips": "_handleMyTripsAction",
            "click[android] myCredit": "_handleMyCreditAction",
            "click[android] rating": "_handleRatingAction",
            "click[android] groups": "_handleGroupsAction",
            "click[android] favourites": "_handleFavouritesAction",
            "click[android] addVerification": "_handleMoreVerificationAction",
            "click[android] txtag": "_handleTxtagAction",
            "click[android] fastrak": "_handleFastrakAction",
            "click[android] promoCode": "_handlePromoCodeAction",
            "click[android] invite": "_handleInviteAction"
        },
        initialize: function() {
            _.bindAll(this, "_syncTollTag", "showProfile", "_backFromFavoritesAction", "updateRideCount", "openTollTagPopup", "_handleMyTripsAction", "_handleMyCreditAction", "_handleRatingAction", "_handleGroupsAction", "_handleFavouritesAction", "_handleMoreVerificationAction", "_handleTxtagAction", "_handleFastrakAction", "_handlePromoCodeAction");
            this._initEventListeners();
        },
        _initEventListeners: function() {
            if (!this._isMyProfile || require("services/action_record_service").get("freeride")) return;
            var self = this;
            rootWindow.addAppEventListener("carma:coachmark.close", function handler(data) {
                rootWindow.removeAppEventListener("carma:coachmark.close", handler);
                "freeride" === data.name && self._handleFavouritesAction();
            });
            rootWindow.addAppEventListener("carma:favourite.users.toggle", this._backFromFavoritesAction);
            rootWindow.addAppEventListener("carma:favourite.add", this._backFromFavoritesAction);
            rootWindow.addAppEventListener("carma:ride.count.update", this.updateRideCount);
            rootWindow.addAppEventListener("carma:openTollTagPopup", this.openTollTagPopup);
            rootWindow.addAppEventListener("carma:openVerifyContactData", this._handleMoreVerificationAction);
            rootWindow.addAppEventListener("carma:openInviteFriends", this._handleInviteAction);
        },
        onDestroy: function() {
            $.txtag.cleanUp();
            $.fastrak.cleanUp();
            $.myCredit.cleanUp();
            $.favourites.cleanUp();
            $.promoCode.cleanUp();
            $.invite.cleanUp();
            $.rating.cleanUp();
            $.groups.cleanUp();
        },
        showProfile: function(profile) {
            this._profile = profile;
            this._showTollTags(profile);
            this._showMyCreditBalance(profile.creditBalance, profile.credit);
            this._showRating(profile.avgUserRating, profile.numUserRatings, profile.numUserComments);
            this._showGroups(profile.groups);
            this._showFavourites(profile.numFavourites);
            this._showRideHistory(profile.totalRides);
            this._showVerifications(profile);
            this._showInvite(profile);
        },
        _showTollTags: function(profile) {
            var userId = profile.userId;
            var resourceOwner = require("services/resource_owner_service").singleton();
            if (resourceOwner.get("userId") !== userId) {
                $.txtag.applyProperties({
                    visible: false,
                    height: 0
                });
                $.fastrak.applyProperties({
                    visible: false,
                    height: 0
                });
                $.txtagHr.applyProperties({
                    visible: false,
                    height: "1px"
                });
                return;
            }
            if (this._firstTagMenuLoad) this._firstTagMenuLoad = false; else {
                var lastLocation = require("gps/gps_manager").lastLocation(), locationValidator = require("/validator/validator_factory").currentLocation(), isValid = locationValidator.isGPSPositionValid(lastLocation, true);
                if (!isValid) {
                    $.txtag.applyProperties({
                        visible: false,
                        height: 0
                    });
                    $.fastrak.applyProperties({
                        visible: false,
                        height: 0
                    });
                    $.txtagHr.applyProperties({
                        visible: false,
                        height: "1px"
                    });
                    return;
                }
            }
            var inSFBay = require("utils/location_check").checkWithinSFBay();
            var inAustin = require("utils/location_check").checkWithinAustin();
            var tagVisible = false;
            if (inAustin) tagVisible = true; else {
                $.txtag.applyProperties({
                    visible: false,
                    height: 0
                });
                $.txtagHr.applyProperties({
                    visible: false,
                    height: "1px"
                });
            }
            var bayBridgeTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("bayBridgeTollRewards");
            var goldenGateTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("enableGoldenGateTollRefund");
            var allSFTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("enableSFBridgeTollRefunds");
            inSFBay && (bayBridgeTollRewardsOn || goldenGateTollRewardsOn || allSFTollRewardsOn) ? tagVisible = true : $.fastrak.applyProperties({
                visible: false,
                height: 0
            });
            tagVisible ? this._syncTollTag(profile) : $.txtagHr.applyProperties({
                visible: false,
                height: "1px"
            });
        },
        _syncTollTag: function(profile, invalidate) {
            var invalidateProfile = true === invalidate;
            if (invalidateProfile) {
                var self = this;
                Q().then(function() {
                    return ProfileService.getProfile(self._userId, ProfileService.FULL_DETAIL, true);
                }).then(function(profile) {
                    self._profile = profile;
                    self._syncTollTag(profile, false);
                }).catch(function(e) {}).done();
            }
            var inSFBay = require("utils/location_check").checkWithinSFBay();
            var inAustin = require("utils/location_check").checkWithinAustin();
            var listItem = inAustin ? $.txtag : $.fastrak;
            listItem.applyProperties({
                visible: true,
                height: "48dp"
            });
            $.txtagHr.applyProperties({
                visible: true,
                height: "1px"
            });
            var self = this;
            if (profile && profile.vehicles) {
                self._txtags = profile.vehicles;
                var message = "";
                if (inSFBay) {
                    message = 1 === profile.vehicles.length ? L("widget_profile_summary_fastrak_subtitle_singular") : String.format(L("widget_profile_summary_fastrak_subtitle_plural"), profile.vehicles.length);
                    $.fastrakCount.text = message;
                } else {
                    message = 1 === profile.vehicles.length ? L("widget_profile_summary_txtag_subtitle_singular") : String.format(L("widget_profile_summary_txtag_subtitle_plural"), profile.vehicles.length);
                    $.txtagCount.text = message;
                }
                self._isLoadingTxtags = false;
                navigation.fireEvent("txtag.refreshed", {
                    txtags: profile.vehicles
                });
                if (self._shouldHandleTolls) {
                    self._shouldHandleTolls = false;
                    Ti.App.fireEvent("carma:progress.stop");
                    self._handleTolls(this._tollToHandle);
                }
            }
        },
        _showMyTrips: function(userId) {
            if (!this._isMyProfile) {
                $.accountSummary.remove($.myTrips);
                $.accountSummary.remove($.myTripsHr);
                return;
            }
            var render = function(count) {
                $.myTripsCount.text = 1 === count ? L("widget_profile_summary_trip_subtitle_singular") : String.format(L("widget_profile_summary_trip_subtitle_plural"), count);
            };
            var count = require("services/user_service").cachedCount("trips", userId);
            null != count && render(count);
            _.delay(function() {
                require("services/user_service").countTrips(userId).then(render);
            }, 200);
        },
        _showInvite: function(profile) {
            var self = this;
            var allowInvites = require("featuretoggles/featuretoggles").getValue("allowInvites", 0);
            if (this._isMyProfile) {
                if (0 === allowInvites) {
                    $.accountSummary.remove($.invite);
                    $.accountSummary.remove($.inviteHr);
                }
            } else {
                $.accountSummary.remove($.invite);
                $.accountSummary.remove($.inviteHr);
            }
        },
        _showMyCreditBalance: function(creditBalance, credit) {
            if (!this._isMyProfile) {
                $.accountSummary.remove($.myCredit);
                $.accountSummary.remove($.myCreditHr);
                $.accountSummary.remove($.promoCode);
                $.accountSummary.remove($.promoCodeHr);
                return;
            }
            if (creditBalance) {
                var currencySymbol = creditBalance.currencySymbol, totalBalance = parseFloat(creditBalance.totalBalance).toFixed(2), payableBalance = parseFloat(creditBalance.payableBalance).toFixed(2), bonusBalance = parseFloat(creditBalance.bonusBalance).toFixed(2);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
            } else if (credit) {
                var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
            }
        },
        _showRating: function(avgRating, numRatings, numReviews) {
            var ratingMessage = "", reviewMessage = "";
            if ("undefined" == typeof avgRating) {
                if (numRatings) {
                    ratingMessage = String.format(L("widget_profile_summary_rating_count_plural"), numRatings);
                    $.ratingDetails.text = ratingMessage;
                    $.ratingDetails.applyProperties({
                        visible: true
                    });
                }
                numRatings && numReviews || $.ratingStars.applyProperties({
                    visible: false
                });
                return;
            }
            numRatings && (ratingMessage = 1 === numRatings ? L("widget_profile_summary_rating_count_singular") : String.format(L("widget_profile_summary_rating_count_plural"), numRatings));
            numReviews && (reviewMessage = 1 === numReviews ? L("widget_profile_summary_review_count_singular") : String.format(L("widget_profile_summary_review_count_plural"), numReviews));
            ratingMessage && ($.ratingDetails.text = String.format(L("widget_profile_summary_rating_details"), ratingMessage, reviewMessage));
            avgRating && $.ratingStars.setRating(avgRating);
            $.ratingDetails.applyProperties({
                visible: true
            });
            $.ratingStars.applyProperties({
                visible: true
            });
        },
        _showGroups: function(count) {
            $.groupsCount.text = 1 === count ? L("widget_profile_summary_group_subtitle_singular") : count >= 0 ? String.format(L("widget_profile_summary_group_subtitle_plural"), count) : "";
        },
        _showFavourites: function(count) {
            if (this._isMyProfile) {
                $.favouriteArrow.visible = true;
                $.favourites.applyProperties({
                    visible: true,
                    height: "48dp"
                });
                $.favouritesHr.applyProperties({
                    visible: true,
                    height: "1px"
                });
            } else {
                $.favouriteArrow.visible = false;
                $.favourites.applyProperties({
                    visible: false,
                    height: 0
                });
                $.favouritesHr.applyProperties({
                    visible: false,
                    height: 0
                });
            }
        },
        _showRideHistory: function(count) {
            $.rideCount.text = 1 === count ? L("widget_profile_summary_ride_subtitle_singular") : count >= 0 ? String.format(L("widget_profile_summary_ride_subtitle_plural"), count) : "";
        },
        updateRideCount: function() {
            if (this._isMyProfile) {
                var resourceOwner = require("services/resource_owner_service").singleton();
                var render = function(count) {
                    $.rideCount.text = 1 === count ? L("widget_profile_summary_ride_subtitle_singular") : String.format(L("widget_profile_summary_ride_subtitle_plural"), count);
                };
                require("services/user_service").countRides(resourceOwner.get("userId")).then(render);
            }
        },
        _showVerifications: function(profile) {
            var verifications = profile.validations;
            if (!verifications) {
                $.verifications.applyProperties({
                    height: 0,
                    visible: false
                });
                $.verificationList.applyProperties({
                    height: 0,
                    visible: false
                });
                return;
            }
            $.verifications.applyProperties({
                height: Ti.UI.SIZE,
                visible: true
            });
            $.verificationList.applyProperties({
                height: Ti.UI.SIZE,
                visible: true
            });
            var count = profile.affiliateNames ? profile.affiliateNames.length : 0;
            for (var key in verifications) true === verifications[key] && count++;
            verifications.numPositiveReviews > 0 && count++;
            $.verificationCount.text = 1 === count ? L("widget_profile_summary_verification_subtitle_singular") : String.format(L("widget_profile_summary_verification_subtitle_plural"), count);
            $.phoneVerification.text = verifications.phoneValidated ? "c" : "h";
            $.emailVerification.text = verifications.emailValidated ? "c" : "h";
            $.facebookVerification.text = verifications.connectedFacebook ? "c" : "h";
            $.positiveReviewVerification.text = verifications.numPositiveReviews > 0 ? "c" : "h";
            var shouldDisplayAdd = !(verifications.phoneValidated && verifications.emailValidated && verifications.connectedFacebook && verifications.numPositiveReviews);
            this._isMyProfile && shouldDisplayAdd && ($.addVerification.visible = true);
            $.positiveReviewCount.text = 1 === verifications.numPositiveReviews ? L("widget_profile_summary_verification_item_positive_review_singular") : String.format(L("widget_profile_summary_verification_item_positive_review_plural"), verifications.numPositiveReviews);
            if (profile.affiliateNames && 0 !== profile.affiliateNames.length) for (var i = 0; i < profile.affiliateNames.length; i++) {
                var affiliateName = profile.affiliateNames[i];
                if (!_.contains(this._affiliates, affiliateName)) {
                    this._affiliates.push(affiliateName);
                    $.affiliateList.add(Widget.createWidget("ma.car.app.profile", "affiliate_row", {
                        name: affiliateName
                    }).getView());
                }
            } else $.accountSummary.remove($.affiliateList);
            var shouldDisplayReplyRate = require("featuretoggles/featuretoggles").getValue("displayReplyRate");
            if (shouldDisplayReplyRate) {
                var self = this;
                if (profile.messagingStats) {
                    if (profile.messagingStats.firstResponsePercentage) {
                        var replyRate = Math.max(0, Math.round(profile.messagingStats.firstResponsePercentage));
                        $.replyRate.text = 0 === replyRate ? "-" : replyRate + "%";
                        $.replyRateSection.applyProperties({
                            height: "30dp",
                            visible: true
                        });
                    } else $.replyRateSection.applyProperties({
                        height: 0,
                        visible: false
                    });
                    if (profile.messagingStats.averageResponseTimeInMilliseconds) {
                        var replyTime = profile.messagingStats.averageResponseTimeInMilliseconds;
                        $.replyTime.text = 0 === replyTime ? "-" : moment.duration(profile.messagingStats.averageResponseTimeInMilliseconds, "milliseconds").humanize();
                        $.replyTimeSection.applyProperties({
                            height: "30dp",
                            visible: true
                        });
                    } else $.replyTimeSection.applyProperties({
                        height: 0,
                        visible: false
                    });
                }
            } else {
                $.replyRateSection.applyProperties({
                    height: 0,
                    visible: false
                });
                $.replyTimeSection.applyProperties({
                    height: 0,
                    visible: false
                });
            }
        },
        _handleMyTripsAction: function() {
            if (this._opening) return;
            this._opening = true;
            var self = this;
            setTimeout(function() {
                self._opening = false;
            }, 5e3);
            var tripView = Alloy.createWidget("ma.car.app.trip", "tripsList", {
                __parentSymbol: $.getView(),
                navigation: navigation
            });
            navigation.hideEditButton();
            navigation.open(tripView, {
                title: L("widget_future_btn_my_trips").toUpperCase()
            }, function() {
                self._opening = false;
            });
        },
        _handleMyCreditAction: function() {
            if (this._opening) return;
            this._opening = true;
            var self = this;
            setTimeout(function() {
                self._opening = false;
            }, 5e3);
            var stripeView = Alloy.createWidget("ma.car.app.stripePayments", "widget", {
                __parentSymbol: $.getView()
            });
            navigation.hideEditButton();
            navigation.open(stripeView, {
                title: L("widget_profile_credit_tabtitle").toUpperCase()
            }, function() {
                self._opening = false;
            });
            stripeView.showProfile(this._profile);
        },
        _handlePromoCodeAction: function() {
            if (this._opening) return;
            this._opening = true;
            var self = this;
            setTimeout(function() {
                self._opening = false;
            }, 5e3);
            var promoCodeView = Alloy.createWidget("ma.car.app.stripePayments", "promo_code", {
                __parentSymbol: $.getView(),
                navigation: navigation
            });
            navigation.hideEditButton();
            navigation.open(promoCodeView, {
                title: L("widget_profile_summary_redeemcode_title").toUpperCase()
            }, function() {
                self._opening = false;
            });
            promoCodeView.showPromoCode(this._profile);
        },
        _handleInviteAction: function() {
            if (this._opening) return;
            this._opening = true;
            var self = this;
            setTimeout(function() {
                self._opening = false;
            }, 5e3);
            var inviteId = null;
            var referralCode = null;
            var inviteView = Alloy.createWidget("ma.car.app.invites", "inviteFriends", {
                __parentSymbol: $.getView(),
                navigation: navigation
            });
            navigation.hideEditButton();
            navigation.open(inviteView, {
                title: L("widget_invite_window_title").toUpperCase()
            }, function() {
                self._opening = false;
            });
            self._inviteCode = require("services/user_service").getCachReferralCode();
            Alloy.createModel("invitation").generate({
                method: "UNKNOWN",
                entity: "user"
            }).then(function(data) {
                inviteId = data.id;
                self._inviteCode ? inviteView.showInviteCode(self._inviteCode, inviteId) : require("services/user_service").getReferralCode().then(function(data) {
                    self._inviteCode = data.referralCode;
                    require("services/user_service").cachReferralCode(data.referralCode);
                    inviteView.showInviteCode(data.referralCode, inviteId);
                });
            });
        },
        _handleRatingAction: function() {
            return;
        },
        _handleGroupsAction: function() {
            var path = "group";
            this._isMyProfile || (path = "#userprofile/" + this._userId + "/groups");
            this._openWebViewPageInNewWindow(path, L("widget_profile_groups_tabtitle").toUpperCase());
        },
        _handleFavouritesAction: function() {
            if (this._isMyProfile) {
                if (this._opening) return;
                this._opening = true;
                var self = this;
                setTimeout(function() {
                    self._opening = false;
                }, 5e3);
                var favoriteView = Alloy.createWidget("ma.car.app.favorites", {
                    userId: this._userId
                });
                navigation.hideEditButton();
                navigation.open(favoriteView, {
                    title: L("widget_profile_favorite_title").toUpperCase()
                }, function() {
                    self._opening = false;
                });
            }
        },
        _handleMoreVerificationAction: function() {
            var path = "settings?internal=true#share/onlyNonValidated";
            this._openWebViewPage(path, L("widget_profile_verifications_tabtitle").toUpperCase());
        },
        _handleFastrakAction: function() {
            this._handleTolls(false);
        },
        _handleTxtagAction: function() {
            this._handleTolls(true);
        },
        openTollTagPopup: function() {
            var inAustin = require("utils/location_check").checkWithinAustin();
            this._handleTolls(inAustin);
        },
        _handleTolls: function(isTxTag) {
            if (this._isLoadingTxtags) {
                this._shouldHandleTolls = true;
                this._tollToHandle = isTxTag;
                Ti.App.fireEvent("carma:progress.start");
                return;
            }
            if (!this._registeredEventForTxtagRefresh) {
                var self = this;
                navigation.addEventListener("txtag.refresh", function() {
                    self._syncTollTag(self._profile, true);
                });
                this._registeredEventForTxtagRefresh = true;
            }
            navigation.hideEditButton();
            Alloy.createWidget("ma.car.app.tolltag", "widget", {
                txtags: this._txtags,
                isTxTag: isTxTag
            });
        },
        _openWebViewPage: function(path, pageTitle) {
            var controllerOptions = {
                path: path,
                navigation: navigation
            };
            navigation.hideEditButton();
            var navigationOptions = {};
            pageTitle && (navigationOptions.title = pageTitle);
            navigation.open(Alloy.createController("internalShell", controllerOptions), navigationOptions);
        },
        _openWebViewPageInNewWindow: function(path, pageTitle) {
            Alloy.createController("shell", {
                path: path
            }).getView().open();
        },
        _backFromFavoritesAction: function(data) {
            this._profile = ProfileService.getCachedProfile(this._profile.userId);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;