function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "trophy_row";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.trophyRow = Ti.UI.createTableViewRow({
        backgroundColor: "#80333333",
        id: "trophyRow"
    });
    $.__views.trophyRow && $.addTopLevelView($.__views.trophyRow);
    $.__views.trophyContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        backgroundColor: "transparent",
        id: "trophyContainer"
    });
    $.__views.trophyRow.add($.__views.trophyContainer);
    $.__views.trophy = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "44dp",
        height: "38dp",
        left: "10dp",
        top: "10dp",
        bottom: "10dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
        id: "trophy"
    });
    $.__views.trophyContainer.add($.__views.trophy);
    $.__views.trophyMessage = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "17dp"
        },
        left: "64dp",
        top: "-45dp",
        height: "20dp",
        id: "trophyMessage"
    });
    $.__views.trophyContainer.add($.__views.trophyMessage);
    $.__views.subtitle = Ti.UI.createLabel({
        color: "#ccc",
        font: {
            fontSize: "12dp"
        },
        top: "-3dp",
        left: "64dp",
        height: "30dp",
        id: "subtitle"
    });
    $.__views.trophyContainer.add($.__views.subtitle);
    $.__views.__alloyId557 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        left: 0,
        top: "59dp",
        height: "1px",
        backgroundColor: "#ccc",
        id: "__alloyId557"
    });
    $.__views.trophyRow.add($.__views.__alloyId557);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var achievement = arguments[0] || {}, CACHE_FOLDER = Ti.Filesystem.getFile(Ti.Filesystem.applicationCacheDirectory, "trophy-cache"), localFileName = function(imageURL) {
        return Ti.Utils.md5HexDigest(imageURL + "");
    };
    var Globals = require("/v6/infrastructure/Globals"), LoggingService = Globals.IOC.get("LoggingService");
    exports = new (require("/carmalib/controller").extend($, {
        events: {},
        initialize: function() {
            CACHE_FOLDER.exists() || CACHE_FOLDER.createDirectory();
            this.rendTrophyRow();
        },
        rendTrophyRow: function() {
            LOGGER.info("***********", "***********");
            var dynamicURL = require("/carmalib/url")["USER_ACHIEVENMENTS"] + achievement.type + ".png";
            LOGGER.info("achievement url = " + dynamicURL);
            this._downloadPhoto(dynamicURL);
            $.trophyMessage.text = achievement.timestamp;
            $.subtitle.text = "this is subtitle";
        },
        _downloadPhoto: function(url) {
            var self = this;
            if (!url) {
                var defaultImage = "/images/USER_TRIPS_3.png";
                $.trophy.image = defaultImage;
                return;
            }
            var file = Ti.Filesystem.getFile(CACHE_FOLDER.resolve(), localFileName(url));
            if (file.exists()) $.trophy.image = file.getNativePath(); else {
                var client = Ti.Network.createHTTPClient({
                    timeout: 12e4,
                    cache: true
                });
                client.onload = function() {
                    file.write(this.responseData);
                    $.trophy.image = client.responseData;
                };
                client.open("GET", url);
                LoggingService.log("network", url);
                client.send();
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;