function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.profile/" + s : s.substring(0, index) + "/ma.car.app.profile/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.profile");
    this.__widgetId = "ma.car.app.profile";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "user_info";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.user_info = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "90dp",
        id: "user_info"
    });
    $.__views.user_info && $.addTopLevelView($.__views.user_info);
    $.__views.freeRiderIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "12dp",
        right: "12dp",
        width: "25dp",
        height: "25dp",
        image: "/images/freetripscoin.png",
        zIndex: 1,
        visible: false,
        id: "freeRiderIcon"
    });
    $.__views.user_info.add($.__views.freeRiderIcon);
    $.__views.favourite = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Grey,
        font: {
            fontFamily: "splinico",
            fontSize: "26dp"
        },
        text: "i",
        top: 0,
        right: 0,
        width: "50dp",
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
        zIndex: 1,
        visible: false,
        id: "favourite"
    });
    $.__views.user_info.add($.__views.favourite);
    $.__views.__alloyId558 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        left: Alloy.Globals.Style.Size.Width.pct4,
        height: "90dp",
        id: "__alloyId558"
    });
    $.__views.user_info.add($.__views.__alloyId558);
    $.__views.photo = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        borderColor: "#fff",
        borderWidth: 1,
        top: 0,
        left: 0,
        width: "90dp",
        height: "90dp",
        borderRadius: Alloy.Globals.Style.Unit.unit45,
        id: "photo"
    });
    $.__views.__alloyId558.add($.__views.photo);
    $.__views.name = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: 0,
        left: "100dp",
        height: "30dp",
        id: "name"
    });
    $.__views.__alloyId558.add($.__views.name);
    $.__views.homeCity = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: "24dp",
        left: "100dp",
        height: "16dp",
        id: "homeCity"
    });
    $.__views.__alloyId558.add($.__views.homeCity);
    $.__views.regTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "10dp"
        },
        top: "38dp",
        left: "100dp",
        height: "16dp",
        id: "regTime"
    });
    $.__views.__alloyId558.add($.__views.regTime);
    $.__views.__alloyId559 = Ti.UI.createView({
        bottom: 0,
        left: "100dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId559"
    });
    $.__views.__alloyId558.add($.__views.__alloyId559);
    $.__views.locationPointer = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontFamily: "splinico",
            fontSize: "12dp"
        },
        text: "k",
        top: 0,
        left: 0,
        width: "12dp",
        height: "12dp",
        visible: false,
        id: "locationPointer"
    });
    $.__views.__alloyId559.add($.__views.locationPointer);
    $.__views.lastLocation = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "10dp"
        },
        top: 0,
        left: "4dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "lastLocation"
    });
    $.__views.__alloyId559.add($.__views.lastLocation);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, avatarUtils = require("/ui/common/Avatar"), moment = require("/vendor/moment"), photoURL = require("/utils/photoURL"), geocoder = require("/gps/location"), Globals = require("/v6/infrastructure/Globals"), favouriteUserService = Globals.IOC.get("favoriteUserService"), freeRiderService = Globals.IOC.get("freeRiderService"), photoCache = require("/utils/photoCache"), ProfileService = Globals.IOC.get("ProfileService"), CurrentUserService = Globals.IOC.get("CurrentUserService");
    exports = new (require("/carmalib/controller").extend($, {
        _isMyProfile: args.isMyProfile,
        _userId: args.userId,
        _profile: null,
        _PHOTO_WIDTH_DP: 90,
        _PHOTO_HEIGHT_DP: 90,
        events: {},
        initialize: function() {
            _.bindAll(this, "_checkFavouriteUsers", "_toggleFavouriteUserIcon");
        },
        onDestroy: function() {},
        showProfile: function(profile) {
            this._profile = profile;
            this._showUserPhoto(profile.photoUrl);
            this._showUserName(profile);
            this._showRegTime(profile.registrationTime);
            var self = this;
            TM.push(function() {
                self._showHomeCity(profile);
                self._showLastKnownLocation(profile);
                self._checkFavouriteUsers(profile);
            });
        },
        _showUserPhoto: function(image) {
            var url = photoURL.toURL(image, {
                width: this._PHOTO_WIDTH_DP,
                height: this._PHOTO_HEIGHT_DP
            });
            var photoPath = photoCache.getCached(url);
            if (photoPath) $.photo.image = photoPath; else {
                $.photo.image = avatarUtils.getDefaultPhoto(this._profile);
                photoCache.downloadAvatar(url).then(function(url) {
                    $.photo.image = url;
                });
            }
        },
        _showUserName: function(profile) {
            $.name.text = profile.alias;
        },
        _showHomeCity: function(profile) {
            if (!profile.homeCity) return;
            var city = profile.homeCity;
            city.name && (city = city.name);
            var country = profile.homeCountry;
            country || (country = profile.homeCity.country.name);
            $.homeCity.text = country ? city + "," + country : city;
        },
        _showRegTime: function(regTime) {
            if (!regTime) return;
            $.regTime.text = String.format(L("widget_profile_reg_time"), moment(0 + regTime).fromNow());
        },
        _showLastKnownLocation: function(profile) {
            if (!profile.lastKnownLocation) return;
            $.locationPointer.visible = true;
            var lastLocationTimestamp = moment(0 + profile.lastSeen);
            var lastLocation = profile.lastKnownLocation;
            lastLocation.address && (lastLocation = lastLocation.address);
            $.lastLocation.text = String.format(L("widget_profile_last_location"), lastLocation, lastLocationTimestamp.fromNow());
        },
        _checkFavouriteUsers: function(profile) {
            var self = this;
            if (this._isMyProfile) return;
            self._toggleFavouriteUserIcon(profile.isFavourite, profile.canUserTakeFreeRide);
        },
        _toggleFavouriteUserIcon: function(isFavourite, isFreeRider) {
            $.favourite.isFavourite = isFavourite;
            isFreeRider ? this._applyFreeRiderStyle() : isFavourite ? this._applyFavouriteStyle() : this._applyUnFavouriteStyle();
        },
        _applyFreeRiderStyle: function() {
            $.freeRiderIcon.visible = true;
            $.favourite.visible = false;
        },
        _applyFavouriteStyle: function() {
            $.freeRiderIcon.visible = false;
            $.favourite.visible = true;
            $.favourite.applyProperties({
                text: "j",
                color: "#6699ff"
            });
        },
        _applyUnFavouriteStyle: function() {
            $.freeRiderIcon.visible = false;
            $.favourite.visible = true;
            $.favourite.applyProperties({
                text: "i",
                color: Alloy.Globals.Style.Color.Grey
            });
        },
        _toggleFavouriteUser: function() {
            LOGGER.error("Toggling favourite user...");
            var promise = null, self = this;
            if ($.favourite.isFavourite) {
                this._applyUnFavouriteStyle();
                promise = favouriteUserService.removeFavouriteUser(this._userId);
            } else {
                this._applyFavouriteStyle();
                promise = favouriteUserService.addFavouriteUser(this._profile);
            }
            promise.then(function() {
                $.favourite.isFavourite = !$.favourite.isFavourite;
                Ti.App.fireEvent("carma:favourite.users.toggle", {
                    action: $.favourite.isFavourite ? "add" : "remove",
                    user: self._profile
                });
            }).catch(function() {
                LOGGER.error("Unknown favorite toggle error : " + JSON.stringify(e));
            }).finally(function() {
                LOGGER.error("Toggle favorite user done.");
            }).done();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;