function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "acceptedTrip";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        font: {
            fontSize: "12dp"
        },
        top: 0,
        left: 0,
        bottom: "52dp",
        layout: "vertical",
        visible: "false",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.myTripAwesomeAnimationContainer = Ti.UI.createView({
        height: "60dp",
        top: 0,
        id: "myTripAwesomeAnimationContainer"
    });
    $.__views.layoutContainer.add($.__views.myTripAwesomeAnimationContainer);
    $.__views.myTripContainer = Ti.UI.createView({
        height: "55dp",
        layout: "vertical",
        top: 0,
        borderRadius: "3dp",
        id: "myTripContainer"
    });
    $.__views.myTripAwesomeAnimationContainer.add($.__views.myTripContainer);
    $.__views.myTripBriefContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "55dp",
        backgroundColor: "#fff",
        layout: "horizontal",
        id: "myTripBriefContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripBriefContainer);
    $.__views.__alloyId883 = Ti.UI.createView({
        width: "86dp",
        id: "__alloyId883"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId883);
    $.__views.myTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "10dp",
        id: "myTripDepartureTime"
    });
    $.__views.__alloyId883.add($.__views.myTripDepartureTime);
    $.__views.myTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        bottom: "10dp",
        id: "myTripRole"
    });
    $.__views.__alloyId883.add($.__views.myTripRole);
    $.__views.__alloyId884 = Ti.UI.createView({
        width: Ti.UI.FILL,
        id: "__alloyId884"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId884);
    $.__views.myTripOrigin = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        left: "0",
        top: "10dp",
        id: "myTripOrigin"
    });
    $.__views.__alloyId884.add($.__views.myTripOrigin);
    $.__views.myTripDestination = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        left: "0",
        bottom: "10dp",
        id: "myTripDestination"
    });
    $.__views.__alloyId884.add($.__views.myTripDestination);
    $.__views.myTripMapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        backgroundColor: "#fff",
        height: "60dp",
        id: "myTripMapWrapper"
    });
    $.__views.myTripContainer.add($.__views.myTripMapWrapper);
    $.__views.myTripMap = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "myTripMap"
    });
    $.__views.myTripMapWrapper.add($.__views.myTripMap);
    $.__views.myTripActionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        backgroundColor: "#fff",
        id: "myTripActionsContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripActionsContainer);
    $.__views.myTripActions = Ti.UI.createView({
        height: "50dp",
        top: "35dp",
        id: "myTripActions"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActions);
    $.__views.changeDetailsButton = require("/ui/common/custom_button").createButton({
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "0",
        title: L("widget_samantha_trip_edit_trip"),
        id: "changeDetailsButton"
    });
    $.__views.myTripActions.add($.__views.changeDetailsButton);
    $.__views.cancelRequestButton = require("/ui/common/custom_button").createButton({
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        font: {
            fontSize: "14dp"
        },
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        right: "10dp",
        top: "0",
        title: L("widget_accepted_trip_cancel_request"),
        id: "cancelRequestButton"
    });
    $.__views.myTripActions.add($.__views.cancelRequestButton);
    $.__views.tripMatchIndicator = Ti.UI.createView({
        height: "40dp",
        color: "#fff",
        top: "-6dp",
        id: "tripMatchIndicator"
    });
    $.__views.layoutContainer.add($.__views.tripMatchIndicator);
    $.__views.downArrowWrapper = Ti.UI.createLabel({
        color: "#ffffff",
        text: "L",
        title: "L",
        font: {
            fontFamily: "splinico",
            fontSize: "56dp"
        },
        top: "-28dp",
        id: "downArrowWrapper"
    });
    $.__views.tripMatchIndicator.add($.__views.downArrowWrapper);
    $.__views.indicatorMessage = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "14dp"
        },
        top: "20dp",
        id: "indicatorMessage"
    });
    $.__views.tripMatchIndicator.add($.__views.indicatorMessage);
    $.__views.tripRequestedContainer = Ti.UI.createView({
        height: "55dp",
        backgroundColor: "#fff",
        layout: "vertical",
        borderRadius: "3dp",
        id: "tripRequestedContainer"
    });
    $.__views.layoutContainer.add($.__views.tripRequestedContainer);
    $.__views.tripBriefContainer = Ti.UI.createView({
        height: "75dp",
        top: 0,
        layout: "horizontal",
        id: "tripBriefContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.tripBriefContainer);
    $.__views.__alloyId885 = Ti.UI.createView({
        width: "25%",
        id: "__alloyId885"
    });
    $.__views.tripBriefContainer.add($.__views.__alloyId885);
    $.__views.matchedTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "15dp"
        },
        left: "10dp",
        top: "10dp",
        id: "matchedTripDepartureTime"
    });
    $.__views.__alloyId885.add($.__views.matchedTripDepartureTime);
    $.__views.matchedTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "15dp"
        },
        top: "28dp",
        left: "10dp",
        id: "matchedTripRole"
    });
    $.__views.__alloyId885.add($.__views.matchedTripRole);
    $.__views.__alloyId886 = Ti.UI.createView({
        width: "75%",
        id: "__alloyId886"
    });
    $.__views.tripBriefContainer.add($.__views.__alloyId886);
    $.__views.matchedTripOwner = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        top: 0,
        left: "10dp",
        height: 0,
        visible: false,
        id: "matchedTripOwner"
    });
    $.__views.__alloyId886.add($.__views.matchedTripOwner);
    $.__views.matchedTripOrigin = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        left: "10dp",
        id: "matchedTripOrigin"
    });
    $.__views.__alloyId886.add($.__views.matchedTripOrigin);
    $.__views.matchedTripDestination = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        top: "27dp",
        left: "10dp",
        id: "matchedTripDestination"
    });
    $.__views.__alloyId886.add($.__views.matchedTripDestination);
    $.__views.userPhoto = require("/ui/common/profile").createView({
        top: "10dp",
        right: "5dp",
        visible: false,
        touchEnabled: false,
        id: "userPhoto"
    });
    $.__views.__alloyId886.add($.__views.userPhoto);
    $.__views.mapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        height: "60dp",
        id: "mapWrapper"
    });
    $.__views.tripRequestedContainer.add($.__views.mapWrapper);
    $.__views.map = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "map"
    });
    $.__views.mapWrapper.add($.__views.map);
    $.__views.actionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        id: "actionsContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.actionsContainer);
    $.__views.actionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "12dp"
        },
        height: "40dp",
        id: "actionsBrief"
    });
    $.__views.actionsContainer.add($.__views.actionsBrief);
    $.__views.actions = Ti.UI.createView({
        height: "60dp",
        id: "actions"
    });
    $.__views.actionsContainer.add($.__views.actions);
    $.__views.denyTripRequestButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        left: "10dp",
        top: "0",
        title: L("btn_no"),
        id: "denyTripRequestButton"
    });
    $.__views.actions.add($.__views.denyTripRequestButton);
    $.__views.approveTripRequestButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "45%",
        right: "10dp",
        top: "0",
        height: "44dp",
        title: L("btn_yes"),
        id: "approveTripRequestButton"
    });
    $.__views.actions.add($.__views.approveTripRequestButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), args = arguments[0] || {}, utils = require("utils/utils"), moment = require("/vendor/moment"), samantha = args.samantha;
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "acceptedTrip",
        customAnimation: false,
        _isMyTripCollapsed: false,
        _isTripRequestCollapsed: true,
        _availableScreenHeight: 0,
        _trip: null,
        _booking: null,
        events: {
            "click[ios] mapWrapper": "_openMapEvent",
            "click[android] mapWrapper": "_openMapEvent",
            "click[ios] myTripMapWrapper": "_openMymapEvent",
            "click[android] myTripMapWrapper": "_openMymapEvent",
            "click[ios] myTripBriefContainer": "_expandMyTrip",
            "click[ios] tripRequestedContainer": "_expandTripRequest",
            "click[android] myTripBriefContainer": "_expandMyTrip",
            "click[android] tripRequestedContainer": "_expandTripRequest",
            "click[ios] changeDetailsButton": "_changeTripDetails",
            "click[android] changeDetailsButton": "_changeTripDetails",
            "click[ios] cancelRequestButton": "_cancelRequest",
            "click[android] cancelRequestButton": "_cancelRequest"
        },
        initialize: function() {
            _.bindAll(this, "_getNextBooking", "_renderBookingInfo", "_openMapEvent");
        },
        configure: function() {
            samantha.on("samantha.show.ErrorDialog", this._restoreButtonsState);
        },
        _restoreButtonsState: function() {
            $.cancelRequestButton.stopIndicator();
            $.cancelRequestButton.applyProperties({
                touchEnabled: true
            });
        },
        prepareView: function(options) {
            var trip = options.trip, dateMoment = moment(options.trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.myTripDepartureTime.setText(dateTime);
            $.myTripRole.setText(L("widget_decision_samantha_" + trip.type));
            $.myTripOrigin.setText(trip.origin.address);
            $.myTripDestination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            this._availableScreenHeight = options.availableScreenHeight;
            var mapHeight = this._calculateMapHeight(options.availableScreenHeight, false);
            $.mapWrapper.height = mapHeight + "dp";
            mapHeight = this._calculateMapHeight(options.availableScreenHeight, true);
            $.myTripMapWrapper.height = mapHeight + "dp";
            this._renderMap(trip, $.myTripMapWrapper, $.myTripMap);
            this._renderBookingInfo();
            this._showMyTripByCardType("detailed");
            this._restoreButtonsState();
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this._booking = options.booking;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
        },
        disappear: function() {
            $.layoutContainer.hide();
            samantha.removeCard(this.cardName);
        },
        _calculateMapHeight: function(availableHeight, isMyTripMap) {
            if (!availableHeight) return;
            var mapHeight;
            if (isMyTripMap) {
                var visibleHeight = 2 * parseFloat($.myTripBriefContainer.height, 10) + parseFloat($.tripMatchIndicator.height, 10) + parseFloat($.myTripActionsContainer.height, 10);
                mapHeight = availableHeight - visibleHeight;
            } else {
                var visibleHeight = parseFloat($.tripBriefContainer.height, 10) + parseFloat($.tripMatchIndicator.height, 10) + parseFloat($.myTripBriefContainer.height, 10) + parseFloat($.actionsContainer.height, 10);
                mapHeight = availableHeight - visibleHeight;
            }
            return mapHeight;
        },
        _loadBookingData: function() {
            require("/services/samantha_service").findBookings(false).then(this._getNextBooking).then(this._renderBookingInfo);
        },
        _getNextBooking: function(bookings) {
            var self = this;
            _.each(bookings.rideBookings, function(booking) {
                (!self._booking || booking.bookingDate < self._booking.bookingDate) && (self._booking = booking);
            });
        },
        _renderBookingInfo: function() {
            if (!Alloy.Globals.Map) return;
            if (!this._booking) return;
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = this._booking.rider.userId === myUserId ? this._booking.driver : this._booking.rider;
            var trip = this._booking.trip.ownerUid.toString() === myUserId.toString() ? this._booking.sourceTrip.baseTrip : this._booking.trip.baseTrip;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.matchedTripDepartureTime.setText(dateTime);
            $.matchedTripRole.setText(L("widget_decision_samantha_" + trip.type));
            $.matchedTripOwner.setText(coordinator.alias);
            $.matchedTripOrigin.setText(trip.origin.address);
            $.matchedTripDestination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            $.indicatorMessage.text = String.format(L("widget_samantha_trip_waiting_respond"), coordinator.firstName.toUpperCase());
            $.actionsBrief.setText(String.format(L("widget_samantha_trip_request_note"), coordinator.alias));
            $.userPhoto.setUser(_.extend({}, coordinator, {
                layout: "circular-tiny"
            }));
            this._renderMap(trip, $.mapWrapper, $.map);
        },
        _renderMap: function(trip, mapWrapper, mapView) {
            var self = this;
            if (0 === parseFloat(mapWrapper.size.width)) {
                _.delay(function() {
                    self._renderMap(trip, mapWrapper, mapView);
                }, 2e3);
                return;
            }
            var mapWidth = mapWrapper.rect.width, mapHeight = parseFloat(mapWrapper.height), units = require("/platform/units");
            utils.createMapUrl(trip, units.pixelToDip(mapWidth), mapHeight).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
                mapView.applyProperties({
                    height: mapHeight + "dp",
                    image: localPath
                });
            }).catch(function(e) {});
        },
        _openMymapEvent: function(e) {
            if (!Alloy.Globals.Map) return;
            if (!this._trip) return;
            samantha.whisper("samantha.open.map", {
                trip: this._trip
            });
        },
        _openMapEvent: function(e) {
            if (!Alloy.Globals.Map) return;
            if (!this._booking) return;
            samantha.whisper("samantha.open.map", {
                trip: this._booking.trip.baseTrip
            });
        },
        _changeTripDetails: function() {
            samantha.whisper("samantha.editTripAction.dialog");
        },
        _cancelRequest: function() {
            $.cancelRequestButton.applyProperties({
                touchEnabled: false
            });
            var requestor = this._booking[this._booking.initiator.toLowerCase()];
            require("/services/samantha_service").declineBooking(this._booking.id, requestor.alias).then(function() {
                Ti.App.fireEvent("carma:booking.changed");
                var Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService");
                bookingService.emit(bookingService.BOOKING_UPDATED);
            }).catch(function(e) {
                samantha.whisper("samantha.show.ErrorDialog", _.extend({
                    action: "USER_RIDE_BOOKING_CANCEL"
                }, e));
            });
        },
        _expandMyTrip: function() {
            if (!this._isMyTripCollapsed) return;
            this._isMyTripCollapsed = false;
            this._isTripRequestCollapsed = true;
            this._showTripRequestByCardType("simple");
            this._showMyTripByCardType("detailed");
        },
        _expandTripRequest: function() {
            if (!this._isTripRequestCollapsed) return;
            this._isMyTripCollapsed = true;
            this._isTripRequestCollapsed = false;
            this._showMyTripByCardType("simple");
            this._showTripRequestByCardType("detailed");
        },
        _playBounceAnimation: function(element, extremePoint) {
            element.animate({
                top: extremePoint + "dp",
                duration: 100
            }, function() {
                element.applyProperties({
                    top: extremePoint + "dp"
                });
                element.animate({
                    top: 0,
                    duration: 100
                }, function() {
                    element.applyProperties({
                        top: 0
                    });
                });
            });
        },
        _showMyTripByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.myTripContainer.applyProperties({
                    height: "55dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: "60dp"
                });
            } else {
                var visibleHeight = parseFloat($.tripMatchIndicator.height, 10) + parseFloat($.tripRequestedContainer.height, 10);
                var height = this._availableScreenHeight - visibleHeight - 5;
                $.myTripContainer.applyProperties({
                    height: height + "dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: height + 5 + "dp"
                });
            }
        },
        _showTripRequestByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.matchedTripOwner.applyProperties({
                    top: 0,
                    height: 0,
                    visible: false
                });
                $.matchedTripOrigin.applyProperties({
                    top: "10dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "27dp"
                });
                $.tripRequestedContainer.applyProperties({
                    height: "55dp"
                });
                $.userPhoto.applyProperties({
                    visible: false,
                    touchEnabled: false
                });
            } else {
                $.matchedTripOwner.applyProperties({
                    top: "10dp",
                    height: Ti.UI.SIZE,
                    visible: true
                });
                $.matchedTripOrigin.applyProperties({
                    top: "25dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "40dp"
                });
                var visibleHeight = parseFloat($.tripMatchIndicator.height, 10) + parseFloat($.myTripContainer.height, 10);
                var height = this._availableScreenHeight - visibleHeight - 5;
                $.tripRequestedContainer.applyProperties({
                    height: height + "dp"
                });
                $.userPhoto.applyProperties({
                    visible: true,
                    touchEnabled: true
                });
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;