function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "autoSearchStatus";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.carmaCard = Ti.UI.createView({
        visible: "false",
        height: Ti.UI.SIZE,
        top: 0,
        left: "8dp",
        right: "8dp",
        layout: "vertical",
        borderRadius: "3dp",
        backgroundColor: "#fff",
        id: "carmaCard"
    });
    $.__views.carmaCard && $.addTopLevelView($.__views.carmaCard);
    $.__views.__alloyId887 = Ti.UI.createView({
        height: "33dp",
        backgroundColor: "#727272",
        layout: "horizontal",
        id: "__alloyId887"
    });
    $.__views.carmaCard.add($.__views.__alloyId887);
    $.__views.__alloyId888 = Ti.UI.createLabel({
        color: "#fff",
        text: "c",
        left: 0,
        width: "80dp",
        height: Ti.UI.FILL,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp",
            fontWeight: "bold"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        id: "__alloyId888"
    });
    $.__views.__alloyId887.add($.__views.__alloyId888);
    $.__views.carmaCardHeaderTitle = Ti.UI.createLabel({
        color: "#fff",
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_autosearchresult_title"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        id: "carmaCardHeaderTitle"
    });
    $.__views.__alloyId887.add($.__views.carmaCardHeaderTitle);
    $.__views.__alloyId889 = Ti.UI.createView({
        height: "1dp",
        backgroundColor: "#5c92ff",
        id: "__alloyId889"
    });
    $.__views.carmaCard.add($.__views.__alloyId889);
    $.__views.__alloyId890 = Ti.UI.createView({
        height: "1dp",
        backgroundColor: "#8cb2ff",
        id: "__alloyId890"
    });
    $.__views.carmaCard.add($.__views.__alloyId890);
    $.__views.__alloyId891 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId891"
    });
    $.__views.carmaCard.add($.__views.__alloyId891);
    $.__views.tripTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId891.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "origin"
    });
    $.__views.__alloyId891.add($.__views.origin);
    $.__views.__alloyId892 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId892"
    });
    $.__views.carmaCard.add($.__views.__alloyId892);
    $.__views.tripType = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId892.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "destination"
    });
    $.__views.__alloyId892.add($.__views.destination);
    $.__views.buddyWrapper = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        id: "buddyWrapper"
    });
    $.__views.carmaCard.add($.__views.buddyWrapper);
    $.__views.askedBuddies = Ti.UI.createView({
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: "70dp",
        id: "askedBuddies"
    });
    $.__views.buddyWrapper.add($.__views.askedBuddies);
    $.__views.__alloyId893 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId893"
    });
    $.__views.carmaCard.add($.__views.__alloyId893);
    $.__views.samanthaStatus1 = Ti.UI.createLabel({
        color: "#666",
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp",
            fontFamily: "HelveticaNeue-Italic"
        },
        id: "samanthaStatus1"
    });
    $.__views.__alloyId893.add($.__views.samanthaStatus1);
    $.__views.__alloyId894 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId894"
    });
    $.__views.carmaCard.add($.__views.__alloyId894);
    $.__views.samanthaStatus2 = Ti.UI.createLabel({
        color: "#666",
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp",
            fontFamily: "HelveticaNeue-Italic"
        },
        text: L("widget_samantha_autosearchresult_willgetbacksoon"),
        id: "samanthaStatus2"
    });
    $.__views.__alloyId894.add($.__views.samanthaStatus2);
    $.__views.__alloyId895 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId895"
    });
    $.__views.carmaCard.add($.__views.__alloyId895);
    $.__views.__alloyId896 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "__alloyId896"
    });
    $.__views.carmaCard.add($.__views.__alloyId896);
    $.__views.btnFirstContainer = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnFirstContainer"
    });
    $.__views.__alloyId896.add($.__views.btnFirstContainer);
    $.__views.__alloyId897 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId897"
    });
    $.__views.btnFirstContainer.add($.__views.__alloyId897);
    $.__views.__alloyId898 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId898"
    });
    $.__views.__alloyId897.add($.__views.__alloyId898);
    $.__views.__alloyId899 = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "u",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "__alloyId899"
    });
    $.__views.__alloyId898.add($.__views.__alloyId899);
    $.__views.__alloyId900 = Ti.UI.createView({
        width: "16dp",
        height: "44dp",
        id: "__alloyId900"
    });
    $.__views.__alloyId898.add($.__views.__alloyId900);
    $.__views.btnFirstLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_trip_edit_trip_singular"),
        id: "btnFirstLabel"
    });
    $.__views.__alloyId898.add($.__views.btnFirstLabel);
    $.__views.btnSecondContainer = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        right: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnSecondContainer"
    });
    $.__views.__alloyId896.add($.__views.btnSecondContainer);
    $.__views.__alloyId901 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId901"
    });
    $.__views.btnSecondContainer.add($.__views.__alloyId901);
    $.__views.__alloyId902 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId902"
    });
    $.__views.__alloyId901.add($.__views.__alloyId902);
    $.__views.__alloyId903 = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "h",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "__alloyId903"
    });
    $.__views.__alloyId902.add($.__views.__alloyId903);
    $.__views.__alloyId904 = Ti.UI.createView({
        width: "16dp",
        height: "44dp",
        id: "__alloyId904"
    });
    $.__views.__alloyId902.add($.__views.__alloyId904);
    $.__views.btnSecondLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_cancel"),
        id: "btnSecondLabel"
    });
    $.__views.__alloyId902.add($.__views.btnSecondLabel);
    $.__views.__alloyId905 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId905"
    });
    $.__views.carmaCard.add($.__views.__alloyId905);
    $.__views.__alloyId906 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId906"
    });
    $.__views.carmaCard.add($.__views.__alloyId906);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), args = arguments[0] || {}, samantha = args.samantha;
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "autoSearchStatus",
        options: null,
        events: {
            "click btnFirstContainer": "_editTrip",
            "click btnSecondContainer": "_cancelSamantha"
        },
        configure: function() {
            _.bindAll(this, "_editTrip", "_cancelSamantha");
        },
        _editTrip: function() {
            alert("TODO");
        },
        _cancelSamantha: function() {
            alert("TODO");
        },
        prepareView: function(trip) {
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.address);
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            var askedBuddies = 0;
            require("services/samantha_service").getRideRequests(trip.autoRideMatchId).then(function(data) {
                data.asks = _.sortBy(data.asks, function(ask) {
                    return -ask.askTimestamp;
                });
                askedBuddies = data.asks.length;
                var totalAsks = 0;
                _.each(data.asks, function(ask) {
                    if (++totalAsks <= 3) {
                        var buddy = require("/ui/common/profile").createView({
                            width: "70dp",
                            height: "70dp",
                            id: "ask_" + ask.askId
                        });
                        $.askedBuddies.add(buddy);
                        buddy.setUser(_.extend({}, {
                            hideStatus: true,
                            layout: "circular-large",
                            gender: "MALE",
                            photoUrl: ask.askedUser.photoUrl
                        }));
                    }
                    $.askedBuddies.applyProperties({
                        height: "70dp"
                    });
                });
            }).catch(function(e) {
                $.askedBuddies.applyProperties({
                    height: 0
                });
                LOGGER.error("########### SAMANTHA ERROR: " + JSON.stringify(e));
            }).finally(function() {
                var checkingStringId = "widget_samantha_autosearchresult_asking_" + (0 === askedBuddies ? "0" : 1 === askedBuddies ? "1" : "n") + "_" + trip.type;
                $.samanthaStatus1.setText(String.format(L(checkingStringId), "" + askedBuddies));
            });
        },
        display: function(options) {
            if (!options.trip) return;
            this.options = options;
            this.prepareView(options.trip);
            $.carmaCard.show();
        },
        displayWithAnimation: function() {},
        disappear: function() {
            $.carmaCard.hide();
            samantha.removeCard(this.cardName);
        },
        disappearWithAnimation: function() {}
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;