function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "findMatchPopup";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.bottomCardSpace = Ti.UI.createView({
        top: "20%",
        height: 0,
        visible: false,
        id: "bottomCardSpace"
    });
    $.__views.bottomCardSpace && $.addTopLevelView($.__views.bottomCardSpace);
    $.__views.layout = Ti.UI.createView({
        visible: "true",
        height: Ti.UI.SIZE,
        bottom: 0,
        left: "8dp",
        right: "8dp",
        borderRadius: "3dp",
        id: "layout"
    });
    $.__views.bottomCardSpace.add($.__views.layout);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        borderRadius: "3dp",
        backgroundColor: "#fff",
        id: "layoutInner"
    });
    $.__views.layout.add($.__views.layoutInner);
    $.__views.__alloyId909 = Ti.UI.createView({
        height: "88dp",
        id: "__alloyId909"
    });
    $.__views.layoutInner.add($.__views.__alloyId909);
    $.__views.__alloyId910 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId910"
    });
    $.__views.layoutInner.add($.__views.__alloyId910);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: "#333",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "22dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        text: L("widget_samantha_confirmtip_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId910.add($.__views.labelTitle);
    $.__views.__alloyId911 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId911"
    });
    $.__views.layoutInner.add($.__views.__alloyId911);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#aaa",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "13dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        text: L("widget_samantha_confirmtip_message"),
        id: "labelMessage"
    });
    $.__views.__alloyId911.add($.__views.labelMessage);
    $.__views.__alloyId912 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId912"
    });
    $.__views.layoutInner.add($.__views.__alloyId912);
    $.__views.__alloyId913 = Ti.UI.createView({
        top: "30dp",
        width: "140dp",
        height: "140dp",
        id: "__alloyId913"
    });
    $.__views.bottomCardSpace.add($.__views.__alloyId913);
    $.__views.__alloyId914 = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        image: "/images/Samantha-Celebrates.png",
        id: "__alloyId914"
    });
    $.__views.__alloyId913.add($.__views.__alloyId914);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), args = arguments[0] || {}, callback = args.callback, samantha = args.samantha;
    exports = new (require("/carmalib/controller").extend($, {
        initialize: function() {
            if (0 !== $.bottomCardSpace.opacity) {
                $.bottomCardSpace.applyProperties({
                    height: "225dp"
                });
                _.delay(function() {
                    $.bottomCardSpace.show();
                    _.delay(function() {
                        $.bottomCardSpace.animate({
                            opacity: 0,
                            duration: 200
                        }, function() {
                            callback && _.isFunction(callback) && callback();
                        });
                    }, 5e3);
                }, 4e3);
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;