function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "matchFoundPop";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.popWindow = Ti.UI.createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        left: 0,
        backgroundColor: "#fff",
        navBarHidden: true,
        id: "popWindow"
    });
    $.__views.popWindow && $.addTopLevelView($.__views.popWindow);
    $.__views.layoutContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#fff",
        id: "layoutContainer"
    });
    $.__views.popWindow.add($.__views.layoutContainer);
    $.__views.layoutTopContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutTopContainer"
    });
    $.__views.layoutContainer.add($.__views.layoutTopContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#555",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: "20dp",
        width: Ti.UI.SIZE,
        height: "40dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        id: "lblTitle"
    });
    $.__views.layoutTopContainer.add($.__views.lblTitle);
    $.__views.header = Ti.UI.createView({
        backgroundColor: "#003333",
        width: "90%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "header"
    });
    $.__views.layoutTopContainer.add($.__views.header);
    $.__views.date = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.header.add($.__views.date);
    $.__views.__alloyId915 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId915"
    });
    $.__views.header.add($.__views.__alloyId915);
    $.__views.tripTime = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId915.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#fff",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        width: "72%",
        id: "origin"
    });
    $.__views.__alloyId915.add($.__views.origin);
    $.__views.headerRow2 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        bottom: "6dp",
        id: "headerRow2"
    });
    $.__views.header.add($.__views.headerRow2);
    $.__views.tripType = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.headerRow2.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#fff",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        width: "72%",
        id: "destination"
    });
    $.__views.headerRow2.add($.__views.destination);
    $.__views.downArrowWrapper = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkBlue,
        text: "L",
        title: "L",
        font: {
            fontFamily: "splinico",
            fontSize: "56dp"
        },
        top: "-28dp",
        id: "downArrowWrapper"
    });
    $.__views.layoutTopContainer.add($.__views.downArrowWrapper);
    $.__views.matchUserName = Ti.UI.createView({
        top: "-10dp",
        width: Ti.UI.FILL,
        height: "20dp",
        id: "matchUserName"
    });
    $.__views.layoutTopContainer.add($.__views.matchUserName);
    $.__views.matchUserNameContainer = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: "20dp",
        layout: "horizontal",
        id: "matchUserNameContainer"
    });
    $.__views.matchUserName.add($.__views.matchUserNameContainer);
    $.__views.userIcon = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp",
            fontWeight: "bold",
            fontFamily: "splinico"
        },
        height: "20dp",
        width: "20dp",
        id: "userIcon"
    });
    $.__views.matchUserNameContainer.add($.__views.userIcon);
    $.__views.lblSubTitle = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        height: "20dp",
        text: L("widget_samantha_your_next_trip_title"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        id: "lblSubTitle"
    });
    $.__views.matchUserNameContainer.add($.__views.lblSubTitle);
    $.__views.avatar = require("/ui/common/profile").createView({
        top: "5dp",
        width: "80dp",
        height: "80dp",
        id: "avatar"
    });
    $.__views.layoutTopContainer.add($.__views.avatar);
    $.__views.matchTripBriefContainer = Ti.UI.createView({
        top: "5dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "matchTripBriefContainer"
    });
    $.__views.layoutTopContainer.add($.__views.matchTripBriefContainer);
    $.__views.matchedTripOwner = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "matchedTripOwner"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripOwner);
    $.__views.matchedTripOrigin = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        id: "matchedTripOrigin",
        text: "Penrose Wharf, Cork"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripOrigin);
    $.__views.matchedTripDestination = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        id: "matchedTripDestination",
        text: "to Compass Quary, Kinsale, Cork"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripDestination);
    $.__views.mapWrapper = Ti.UI.createView({
        top: "10dp",
        width: Ti.UI.FILL,
        height: "80dp",
        borderRadius: 0,
        id: "mapWrapper"
    });
    $.__views.layoutTopContainer.add($.__views.mapWrapper);
    $.__views.map = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: Ti.UI.FILL,
        height: "80dp",
        image: "/images/map_background.png",
        id: "map"
    });
    $.__views.mapWrapper.add($.__views.map);
    $.__views.layoutBottomContainer = Ti.UI.createView({
        bottom: "10dp",
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutBottomContainer"
    });
    $.__views.layoutContainer.add($.__views.layoutBottomContainer);
    $.__views.actionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: "98%",
        id: "actionsBrief"
    });
    $.__views.layoutBottomContainer.add($.__views.actionsBrief);
    $.__views.actions = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "actions"
    });
    $.__views.layoutBottomContainer.add($.__views.actions);
    $.__views.noButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        top: "10dp",
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        left: "10dp",
        title: L("widget_samantha_booking_ignore_btn"),
        id: "noButton"
    });
    $.__views.actions.add($.__views.noButton);
    $.__views.yesButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        top: "10dp",
        width: "45%",
        height: "44dp",
        right: "10dp",
        title: L("btn_yes"),
        id: "yesButton"
    });
    $.__views.actions.add($.__views.yesButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, units = require("/platform/units"), utils = require("utils/utils"), samantha = args.samantha, css = require("/ui/css"), i18n = require("i18n/i18n");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click noButton": "_denyRequest",
            "click yesButton": "_acceptRequest",
            "click mapWrapper": "_openMapEvent"
        },
        _trip: null,
        _booking: null,
        _opening: false,
        _restoreButtonsState: function() {
            $.noButton.stopIndicator();
            $.yesButton.stopIndicator();
            $.noButton.applyProperties({
                touchEnabled: true
            });
            $.yesButton.applyProperties({
                touchEnabled: true
            });
        },
        configure: function() {
            $.popWindow.addEventListener("androidback", this._handleBack);
            samantha.on("samantha.show.ErrorDialog", this._restoreButtonsState);
            var bookings = args.bookings, booking = args.booking || bookings[0], trip = args.trip, bookedTrip = booking && booking.trip && booking.trip.baseTrip || null;
            this._trip = trip;
            this._booking = booking;
            if (!trip || !bookedTrip) throw new Error("no booking trip found!");
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.date.text = dateMoment.format("Do MMM");
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.address);
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = booking.rider.userId === myUserId ? booking.driver : booking.rider;
            $.lblSubTitle.text = coordinator.alias;
            $.avatar.setUser(_.extend({}, coordinator, {}));
            var isDriver = booking.driver.userId === myUserId ? true : false;
            if (isDriver) {
                $.lblTitle.text = L("widget_samantha_trip_matched_rider").toUpperCase();
                $.userIcon.text = "C";
            } else {
                $.lblTitle.text = L("widget_samantha_trip_matched_driver").toUpperCase();
                $.userIcon.text = "B";
            }
            var screenHeight = units.SystemUnitToDip(Ti.Platform.displayCaps.platformHeight);
            if (screenHeight > 530) {
                var mapHeight = screenHeight - 520 + "dp";
                $.avatar.imageView.applyProperties({
                    width: "140dp",
                    height: "140dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit70
                });
                $.avatar.applyProperties({
                    width: "140dp",
                    height: "140dp"
                });
                $.mapWrapper.applyProperties({
                    height: mapHeight
                });
                $.map.applyProperties({
                    height: mapHeight
                });
            } else {
                var mapHeight = screenHeight - 460 + "dp";
                $.avatar.imageView.applyProperties({
                    width: "80dp",
                    height: "80dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit40
                });
                $.avatar.applyProperties({
                    width: "80dp",
                    height: "80dp"
                });
                $.mapWrapper.applyProperties({
                    height: mapHeight
                });
                $.map.applyProperties({
                    height: mapHeight
                });
            }
            var matchTrip = booking.trip.ownerUid === myUserId ? booking.sourceTrip.baseTrip : booking.trip.baseTrip;
            dateMoment = moment(matchTrip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.matchedTripOwner.setText(dateTime);
            $.matchedTripOrigin.setText(matchTrip.origin.address);
            $.matchedTripDestination.setText(String.format(L("widget_decision_samantha_destination"), matchTrip.destination.address));
            $.actionsBrief.setText(String.format(L("widget_samantha_trip_request_message"), coordinator.alias));
            this._trip.schedule.confirmed ? css.setStyle($, {
                "#header": "dark-blue-background",
                "#downArrowWrapper": "dark-blue"
            }) : css.setStyle($, {
                "#header": "gray-background",
                "#downArrowWrapper": {
                    color: Alloy.Globals.Style.Color.Grey
                }
            });
            if (booking.driver.userId === myUserId) {
                $.matchedTripOwner.visible = false;
                $.matchedTripOwner.height = 0;
            }
            this._renderMap(trip, $.mapWrapper, $.map);
            TM.push(function() {
                _.delay(function() {
                    require("/utils/appSound").play("snuffle");
                }, 300);
            });
        },
        _renderMap: function(trip, mapWrapper, mapView) {
            var self = this;
            if (0 === parseFloat(mapWrapper.size.width)) {
                _.delay(function() {
                    self._renderMap(trip, mapWrapper, mapView);
                }, 2e3);
                return;
            }
            var mapWidth = mapWrapper.rect.width, mapHeight = parseFloat(mapWrapper.height), units = require("/platform/units");
            utils.createMapUrl(trip, units.pixelToDip(mapWidth), mapHeight).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
                mapView.applyProperties({
                    height: mapHeight + "dp",
                    image: localPath
                });
            }).catch(function(e) {});
        },
        _denyRequest: function() {
            $.popWindow.close();
            args.samanthaCard && args.samanthaCard._declineBooking();
        },
        _acceptRequest: function() {
            $.popWindow.close();
            args.samanthaCard && args.samanthaCard._acceptBooking();
        },
        _openMapEvent: function(e) {
            if (!this._trip || !this._booking) return;
            if (this._opening) return;
            this._opening = true;
            var self = this;
            setTimeout(function() {
                self._opening = false;
            }, 1e3);
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), isForMyTrip = false, booking = this._booking, amIARider = booking.rider.userId === myUserId, requestedTrip = amIARider ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            samantha.whisper("samantha.open.map", {
                trip: isForMyTrip ? this._trip : requestedTrip,
                dontUseTime: false
            });
        },
        presentModalView: function(options) {
            var options = options || {};
            if (options.animated) var screen;
            $.getView().open();
        },
        _handleBack: function(argument) {}
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;