function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "newMatchFoundPop";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.popWindow = Ti.UI.createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        left: 0,
        backgroundColor: "#aaa",
        navBarHidden: true,
        layout: "vertical",
        id: "popWindow"
    });
    $.__views.popWindow && $.addTopLevelView($.__views.popWindow);
    $.__views.layoutContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundColor: "#fff",
        id: "layoutContainer"
    });
    $.__views.popWindow.add($.__views.layoutContainer);
    $.__views.layoutTopContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutTopContainer"
    });
    $.__views.layoutContainer.add($.__views.layoutTopContainer);
    $.__views.imageTitle = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "20dp",
        width: "95%",
        height: "auto",
        image: "/images/DriverMatchBanner.png",
        id: "imageTitle"
    });
    $.__views.layoutTopContainer.add($.__views.imageTitle);
    $.__views.avatar = require("/ui/common/profile").createView({
        top: "-30dp",
        width: "80dp",
        height: "80dp",
        id: "avatar"
    });
    $.__views.layoutTopContainer.add($.__views.avatar);
    $.__views.matchTripBriefContainer = Ti.UI.createView({
        top: "5dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "matchTripBriefContainer"
    });
    $.__views.layoutTopContainer.add($.__views.matchTripBriefContainer);
    $.__views.matchedTripOwner = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        id: "matchedTripOwner"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripOwner);
    $.__views.matchedTripTime = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "matchedTripTime"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripTime);
    $.__views.matchedTripOrigin = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        id: "matchedTripOrigin",
        text: "Penrose Wharf, Cork"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripOrigin);
    $.__views.matchedTripDestination = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        id: "matchedTripDestination",
        text: "to Compass Quary, Kinsale, Cork"
    });
    $.__views.matchTripBriefContainer.add($.__views.matchedTripDestination);
    $.__views.mapButton = require("/ui/common/custom_button").createButton({
        width: "144dp",
        color: "#555",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        top: "10dp",
        title: "",
        id: "mapButton"
    });
    $.__views.layoutTopContainer.add($.__views.mapButton);
    $.__views.mapButtonContainer = Ti.UI.createView({
        width: "100%",
        height: "44dp",
        id: "mapButtonContainer"
    });
    $.__views.mapButton.add($.__views.mapButtonContainer);
    $.__views.mapIcon = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        left: "20dp",
        image: "/images/LocationPin.png",
        height: "auto",
        width: "20dp",
        id: "mapIcon"
    });
    $.__views.mapButtonContainer.add($.__views.mapIcon);
    $.__views.mapBtnLabel = Ti.UI.createLabel({
        color: "#666",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        left: "50dp",
        text: "View Map",
        id: "mapBtnLabel"
    });
    $.__views.mapButtonContainer.add($.__views.mapBtnLabel);
    $.__views.layoutBottomContainer = Ti.UI.createView({
        bottom: "10dp",
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutBottomContainer"
    });
    $.__views.layoutContainer.add($.__views.layoutBottomContainer);
    $.__views.actionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: "98%",
        id: "actionsBrief"
    });
    $.__views.layoutBottomContainer.add($.__views.actionsBrief);
    $.__views.actions = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "actions"
    });
    $.__views.layoutBottomContainer.add($.__views.actions);
    $.__views.noButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        top: "10dp",
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        left: "10dp",
        title: L("widget_samantha_booking_ignore_btn"),
        id: "noButton"
    });
    $.__views.actions.add($.__views.noButton);
    $.__views.yesButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        top: "10dp",
        width: "45%",
        height: "44dp",
        right: "10dp",
        title: L("btn_yes"),
        id: "yesButton"
    });
    $.__views.actions.add($.__views.yesButton);
    $.__views.tickContainer = Ti.UI.createView({
        width: "70%",
        height: "210dp",
        visible: false,
        id: "tickContainer"
    });
    $.__views.layoutContainer.add($.__views.tickContainer);
    $.__views.tickBg = Ti.UI.createView({
        width: "100%",
        height: "100%",
        backgroundColor: "#000",
        opacity: .8,
        borderRadius: Alloy.Globals.Style.Unit.unit16,
        id: "tickBg"
    });
    $.__views.tickContainer.add($.__views.tickBg);
    $.__views.tickImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "40dp",
        width: "60%",
        height: "auto",
        image: "/images/tick.png",
        id: "tickImage"
    });
    $.__views.tickContainer.add($.__views.tickImage);
    $.__views.tickLabel = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_request_sent_msg"),
        bottom: "20dp",
        id: "tickLabel"
    });
    $.__views.tickContainer.add($.__views.tickLabel);
    $.__views.shadow1 = Ti.UI.createView({
        visible: false,
        backgroundColor: "#fff",
        height: "10dp",
        width: "85%",
        id: "shadow1"
    });
    $.__views.popWindow.add($.__views.shadow1);
    $.__views.__alloyId916 = Ti.UI.createView({
        top: 0,
        height: "5dp",
        width: "100%",
        opacity: .3,
        backgroundGradient: {
            type: "linear",
            startPoint: {
                x: "50%",
                y: "0%"
            },
            endPoint: {
                x: "50%",
                y: "100%"
            },
            colors: [ {
                color: "#000"
            }, {
                color: "#fff"
            } ]
        },
        id: "__alloyId916"
    });
    $.__views.shadow1.add($.__views.__alloyId916);
    $.__views.shadow2 = Ti.UI.createView({
        visible: false,
        backgroundColor: "#fff",
        height: "10dp",
        width: "80%",
        id: "shadow2"
    });
    $.__views.popWindow.add($.__views.shadow2);
    $.__views.__alloyId917 = Ti.UI.createView({
        top: 0,
        height: "5dp",
        width: "100%",
        opacity: .3,
        backgroundGradient: {
            type: "linear",
            startPoint: {
                x: "50%",
                y: "0%"
            },
            endPoint: {
                x: "50%",
                y: "100%"
            },
            colors: [ {
                color: "#000"
            }, {
                color: "#fff"
            } ]
        },
        id: "__alloyId917"
    });
    $.__views.shadow2.add($.__views.__alloyId917);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, units = require("/platform/units"), utils = require("utils/utils"), samantha = args.samantha, css = require("/ui/css"), i18n = require("i18n/i18n");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click noButton": "_denyRequest",
            "click yesButton": "_acceptRequest",
            "click mapButton": "_openMapEvent"
        },
        _trip: null,
        _booking: null,
        _opening: false,
        _restoreButtonsState: function() {
            $.noButton.stopIndicator();
            $.yesButton.stopIndicator();
            $.noButton.applyProperties({
                touchEnabled: true
            });
            $.yesButton.applyProperties({
                touchEnabled: true
            });
        },
        configure: function() {
            $.popWindow.addEventListener("androidback", this._handleBack);
            samantha.on("samantha.show.ErrorDialog", this._restoreButtonsState);
            var bookings = args.bookings, booking = args.booking || bookings[0], trip = args.trip, bookedTrip = booking && booking.trip && booking.trip.baseTrip || null;
            this._trip = trip;
            this._booking = booking;
            if (!trip || !bookedTrip) throw new Error("no booking trip found!");
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = booking.rider.userId === myUserId ? booking.driver : booking.rider;
            $.avatar.setUser(_.extend({}, coordinator, {}));
            var isDriver = booking.driver.userId === myUserId ? true : false;
            var isMultipleMaches = args.numOfMatches && args.numOfMatches > 1 ? true : false;
            $.imageTitle.image = isDriver ? isMultipleMaches ? "/images/RiderMatchesBanner.png" : "/images/RiderMatchBanner.png" : isMultipleMaches ? "/images/DriverMatchesBanner.png" : "/images/DriverMatchBanner.png";
            var screenHeight = units.SystemUnitToDip(Ti.Platform.displayCaps.platformHeight);
            var mapHeight = screenHeight - 520 + "dp";
            if (screenHeight > 480) {
                $.avatar.imageView.applyProperties({
                    width: "140dp",
                    height: "140dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit70
                });
                $.avatar.applyProperties({
                    width: "140dp",
                    height: "140dp"
                });
            } else {
                $.avatar.imageView.applyProperties({
                    width: "120dp",
                    height: "120dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit60
                });
                $.avatar.applyProperties({
                    width: "120dp",
                    height: "120dp"
                });
            }
            var matchTrip = booking.trip.ownerUid === myUserId ? booking.sourceTrip.baseTrip : booking.trip.baseTrip;
            dateMoment = moment(bookedTrip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.matchedTripOwner.setText(coordinator.alias);
            $.matchedTripTime.setText(dateTime);
            $.matchedTripOrigin.setText(matchTrip.origin.address);
            $.matchedTripDestination.setText(String.format(L("widget_decision_samantha_destination"), matchTrip.destination.address));
            $.actionsBrief.setText(String.format(L("widget_samantha_trip_request_message"), coordinator.alias));
            this._trip.schedule.confirmed ? css.setStyle($, {
                "#header": "dark-blue-background",
                "#downArrowWrapper": "dark-blue"
            }) : css.setStyle($, {
                "#header": "gray-background",
                "#downArrowWrapper": {
                    color: Alloy.Globals.Style.Color.Grey
                }
            });
        },
        _renderMap: function(trip, mapWrapper, mapView) {
            var self = this;
            if (0 === parseFloat(mapWrapper.size.width)) {
                _.delay(function() {
                    self._renderMap(trip, mapWrapper, mapView);
                }, 2e3);
                return;
            }
            var mapWidth = mapWrapper.rect.width, mapHeight = parseFloat(mapWrapper.height), units = require("/platform/units");
            utils.createMapUrl(trip, units.pixelToDip(mapWidth), mapHeight).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
                mapView.applyProperties({
                    height: mapHeight + "dp",
                    image: localPath
                });
            }).catch(function(e) {});
        },
        _denyRequest: function() {
            if (this._opening) return;
            this._opening = true;
            $.popWindow.close();
            args.samanthaCard && args.samanthaCard._declineBooking();
        },
        _acceptRequest: function() {
            if (this._opening) return;
            this._opening = true;
            $.noButton.applyProperties({
                touchEnabled: false
            });
            $.yesButton.applyProperties({
                touchEnabled: false
            });
            args.samanthaCard && args.samanthaCard._acceptBooking();
            $.tickContainer.transform = Ti.UI.create2DMatrix().scale(.1);
            $.tickContainer.visible = true;
            var animation = Ti.UI.createAnimation({
                transform: Ti.UI.create2DMatrix().scale(1),
                duration: 200
            });
            $.tickContainer.animate(animation, function() {
                $.tickContainer.transform = Ti.UI.create2DMatrix().scale(1);
            });
            setTimeout(function() {
                $.tickContainer.transform = Ti.UI.create2DMatrix().scale(1);
                $.popWindow.close();
            }, 1200);
        },
        _openMapEvent: function(e) {
            if (!this._trip || !this._booking) return;
            if (this._opening) return;
            this._opening = true;
            var self = this;
            setTimeout(function() {
                self._opening = false;
            }, 1e3);
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), isForMyTrip = false, booking = this._booking, amIARider = booking.rider.userId === myUserId, requestedTrip = amIARider ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            samantha.whisper("samantha.open.map", {
                trip: isForMyTrip ? this._trip : requestedTrip,
                dontUseTime: false
            });
        },
        presentModalView: function(options) {
            var options = options || {};
            if (options.numOfMatches && options.numOfMatches > 1 || args.numOfMatches && args.numOfMatches > 1) {
                var screenHeight = units.SystemUnitToDip(Ti.Platform.displayCaps.platformHeight);
                530 > screenHeight && ($.mapButton.visible = false);
                $.layoutContainer.applyProperties({
                    top: "7%",
                    width: "90%",
                    height: "85%"
                });
                $.shadow1.visible = true;
                (options.numOfMatches > 2 || args.numOfMatches > 2) && ($.shadow2.visible = true);
            }
            if (options.animated) var screen;
            $.getView().open();
            TM.push(function() {
                _.delay(function() {
                    require("/utils/appSound").play("snuffle");
                }, 300);
            });
        },
        _handleBack: function(argument) {},
        isTripMatch: function() {
            return true;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;