function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "noInternet";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        visible: "false",
        layout: "vertical",
        top: "20dp",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.__alloyId918 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        backgroundColor: "#fff",
        id: "__alloyId918"
    });
    $.__views.layout.add($.__views.__alloyId918);
    $.__views.__alloyId919 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        backgroundColor: "#fff",
        id: "__alloyId919"
    });
    $.__views.__alloyId918.add($.__views.__alloyId919);
    $.__views.__alloyId920 = Ti.UI.createImageView({
        defaultImage: "/images/offline.png",
        top: "5dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/offline.png",
        id: "__alloyId920"
    });
    $.__views.__alloyId919.add($.__views.__alloyId920);
    $.__views.layoutInner = Ti.UI.createView({
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "layoutInner"
    });
    $.__views.__alloyId918.add($.__views.layoutInner);
    $.__views.__alloyId921 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "10dp",
        left: "10dp",
        right: "10dp",
        id: "__alloyId921"
    });
    $.__views.layoutInner.add($.__views.__alloyId921);
    $.__views.labelTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_no_internet_title"),
        id: "labelTitle"
    });
    $.__views.__alloyId921.add($.__views.labelTitle);
    $.__views.messageContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        id: "messageContainer"
    });
    $.__views.layoutInner.add($.__views.messageContainer);
    $.__views.labelMessage = Ti.UI.createLabel({
        color: "#666",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_samantha_no_internet_label"),
        id: "labelMessage"
    });
    $.__views.messageContainer.add($.__views.labelMessage);
    $.__views.__alloyId922 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "16dp",
        id: "__alloyId922"
    });
    $.__views.layoutInner.add($.__views.__alloyId922);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var MessageController = require(WPATH("messageControllerBuilder")), args = arguments[0] || {}, samantha = args.samantha;
    exports = MessageController.create($, samantha, "noInternet");
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;