function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripConfirmation";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        visible: "false",
        height: Ti.UI.SIZE,
        top: 0,
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_your_next_trip_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        top: 0,
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.__alloyId958 = Ti.UI.createView({
        top: "50dp",
        left: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundColor: "#fff",
        id: "__alloyId958"
    });
    $.__views.layoutContainer.add($.__views.__alloyId958);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "70dp",
        width: Ti.UI.FILL,
        zIndex: 100,
        layout: "vertical",
        id: "header"
    });
    $.__views.__alloyId958.add($.__views.header);
    $.__views.date = Ti.UI.createLabel({
        color: "#666",
        left: "10dp",
        width: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.header.add($.__views.date);
    $.__views.__alloyId959 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId959"
    });
    $.__views.header.add($.__views.__alloyId959);
    $.__views.tripTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId959.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#666",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "origin"
    });
    $.__views.__alloyId959.add($.__views.origin);
    $.__views.__alloyId960 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId960"
    });
    $.__views.header.add($.__views.__alloyId960);
    $.__views.tripType = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId960.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#666",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "destination"
    });
    $.__views.__alloyId960.add($.__views.destination);
    $.__views.container = Ti.UI.createView({
        top: "70dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "container"
    });
    $.__views.__alloyId958.add($.__views.container);
    $.__views.mapWrapper = Ti.UI.createView({
        top: 0,
        width: Ti.UI.FILL,
        height: "90dp",
        borderRadius: 0,
        id: "mapWrapper"
    });
    $.__views.container.add($.__views.mapWrapper);
    $.__views.mapImage = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: Ti.UI.FILL,
        height: "90dp",
        image: "/images/map_background.png",
        id: "mapImage"
    });
    $.__views.mapWrapper.add($.__views.mapImage);
    $.__views.__alloyId961 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId961"
    });
    $.__views.container.add($.__views.__alloyId961);
    $.__views.__alloyId962 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId962"
    });
    $.__views.container.add($.__views.__alloyId962);
    $.__views.__alloyId963 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId963"
    });
    $.__views.container.add($.__views.__alloyId963);
    $.__views.lblCaption = Ti.UI.createLabel({
        color: "#666",
        width: "90%",
        font: {
            fontSize: "15dp"
        },
        left: "10dp",
        right: "10dp",
        wordwrap: true,
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "lblCaption"
    });
    $.__views.__alloyId963.add($.__views.lblCaption);
    $.__views.__alloyId964 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        top: "6dp",
        id: "__alloyId964"
    });
    $.__views.container.add($.__views.__alloyId964);
    $.__views.__alloyId965 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "__alloyId965"
    });
    $.__views.container.add($.__views.__alloyId965);
    $.__views.btnEditTrip = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: 0,
        width: "48%",
        color: "#555",
        backgroundColor: "#00444444",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnEditTrip"
    });
    $.__views.__alloyId965.add($.__views.btnEditTrip);
    $.__views.__alloyId966 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId966"
    });
    $.__views.btnEditTrip.add($.__views.__alloyId966);
    $.__views.__alloyId967 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId967"
    });
    $.__views.__alloyId966.add($.__views.__alloyId967);
    $.__views.btnFirstLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_trip_edit_trip"),
        id: "btnFirstLabel"
    });
    $.__views.__alloyId967.add($.__views.btnFirstLabel);
    $.__views.btnConfirm = require("/ui/common/custom_button").createButton({
        right: 0,
        width: "48%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        title: "",
        id: "btnConfirm"
    });
    $.__views.__alloyId965.add($.__views.btnConfirm);
    $.__views.__alloyId968 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId968"
    });
    $.__views.btnConfirm.add($.__views.__alloyId968);
    $.__views.__alloyId969 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId969"
    });
    $.__views.__alloyId968.add($.__views.__alloyId969);
    $.__views.btnSecondLabel = Ti.UI.createLabel({
        color: "white",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("btn_yes"),
        id: "btnSecondLabel"
    });
    $.__views.__alloyId969.add($.__views.btnSecondLabel);
    $.__views.btnEnableTrip = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: "2%",
        width: "96%",
        color: "#555",
        borderRadius: Alloy.Globals.Style.Unit.unit2,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        disableAnimation: true,
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        visible: false,
        title: L("widget_samantha_trip_re_enable_button"),
        id: "btnEnableTrip"
    });
    $.__views.__alloyId965.add($.__views.btnEnableTrip);
    $.__views.findingMatchContainer = Ti.UI.createView({
        top: "80dp",
        visible: "false",
        layout: "vertical",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "findingMatchContainer"
    });
    $.__views.__alloyId958.add($.__views.findingMatchContainer);
    $.__views.spinnerImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "10dp",
        width: "60dp",
        height: "60dp",
        image: "/images/SamanthaProgressRing.png",
        id: "spinnerImage"
    });
    $.__views.findingMatchContainer.add($.__views.spinnerImage);
    $.__views.findingMatchTitle = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: "20dp",
        text: L("widget_samantha_confirmtip_title"),
        id: "findingMatchTitle"
    });
    $.__views.findingMatchContainer.add($.__views.findingMatchTitle);
    $.__views.findingMatchMessage = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp"
        },
        width: "90%",
        text: L("widget_samantha_confirmtip_message"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        bottom: "20dp",
        id: "findingMatchMessage"
    });
    $.__views.findingMatchContainer.add($.__views.findingMatchMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), utils = require("utils/utils"), appSound = require("/utils/appSound"), args = arguments[0] || {}, samantha = args.samantha;
    exports = new (require(WPATH("cardTemplate")).extend($, {
        samantha: samantha,
        cardName: "tripConfirmation",
        customAnimation: false,
        stopSpinner: false,
        opening: false,
        _trip: null,
        _curState: null,
        events: {
            "click btnConfirm": "_confirmEvent",
            "click btnEnableTrip": "_reEnableTrip",
            "click btnEditTrip": "_editEvent",
            "click mapWrapper": "_openMapEvent"
        },
        configure: function() {
            TM.push(function() {
                appSound.prepare("confirmed", "aac");
            });
            samantha.on("samantha.show.ErrorDialog", this._restoreButtonState);
        },
        _restoreButtonState: function() {
            $.btnConfirm.applyProperties({
                touchEnabled: true
            });
            $.btnEditTrip.applyProperties({
                touchEnabled: true
            });
            $.btnConfirm.stopIndicator();
        },
        _openMapEvent: function(e) {
            if (this.opening) return;
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            samantha.whisper("samantha.open.map", {
                trip: this._trip
            });
        },
        _editEvent: function(e) {
            if (this.opening) return;
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            samantha.whisper("samantha.editTripAction.dialog");
        },
        _reEnableTrip: function(e) {
            var buttons = [ L("btn_no"), L("btn_yes") ], cancelIndex = 0;
            buttons = [ L("btn_yes"), L("btn_no") ];
            cancelIndex = 1;
            var dialog = Ti.UI.createAlertDialog({
                title: "",
                message: L("widget_samantha_trip_confirm_msg"),
                buttonNames: buttons,
                cancel: cancelIndex
            });
            var self = this;
            dialog.addEventListener("click", function clickHandler(e) {
                dialog.removeEventListener("click", clickHandler);
                e.index !== cancelIndex ? self._confirmEvent() : $.btnEnableTrip.stopIndicator();
            });
            dialog.show();
        },
        _confirmEvent: function(e) {
            appSound.play("confirmed");
            this._confirmTrip();
        },
        _minimizeContent: function() {
            var self = this;
            var matrix = Ti.UI.create2DMatrix();
            matrix = matrix.scale(.01);
            $.mapImage.animate({
                transform: matrix,
                duration: 100
            }, function() {
                $.mapImage.visible = false;
            });
            $.lblCaption.visible = false;
            $.btnEditTrip.animate({
                transform: matrix,
                duration: 100
            }, function() {
                $.btnEditTrip.visible = false;
            });
            $.btnConfirm.visible = false;
            $.btnConfirm.animate({
                transform: matrix,
                duration: 100
            }, function() {
                $.btnConfirm.visible = false;
                $.btnConfirm.hide();
            });
            this.startTripConfirmTransition();
        },
        _confirmTrip: function() {
            $.btnConfirm.applyProperties({
                touchEnabled: false
            });
            $.btnEditTrip.applyProperties({
                touchEnabled: false
            });
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            samantha.whisper("samantha.confirm.trip", {
                trip: this._trip
            });
            var self = this;
            TM.push(function() {
                analytics.track(trackingEvent.SAMANTHA_CONFIRM_TRIP, {
                    tripId: self._trip.id
                });
            }, process.backgroundDomain);
        },
        prepareView: function(options) {
            var trip = options.trip, availableScreenHeight = options.availableScreenHeight;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.date.text = moment(trip.schedule.effectiveTime).format("Do MMM");
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.origin.setText(trip.origin.alias && trip.origin.alias.length > 0 ? trip.origin.alias : trip.origin.address);
            var des = trip.destination.alias && trip.destination.alias.length > 0 ? trip.destination.alias : trip.destination.address;
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), des));
            var roleCaption = L("DRIVE" === trip.type ? "widget_samantha_trip_confirm_driver_caption" : "widget_samantha_trip_confirm_rider_caption");
            $.lblCaption.setText(String.format(roleCaption, des, dateTime));
            this.requestStaticMapImgAndResizeMap(trip, availableScreenHeight);
            this._restoreButtonState();
            "CANCELED" === options.state ? this._displayCancelledState() : this._displayNormalState();
        },
        _displayCancelledState: function() {
            if ("Normal" === this._curState) {
                this._curState = "Cancel";
                $.btnConfirm.animate({
                    opacity: 0,
                    duration: 300
                }, function() {
                    $.btnConfirm.visible = false;
                });
                $.btnEditTrip.animate({
                    opacity: 0,
                    duration: 300
                }, function() {
                    $.btnEditTrip.visible = false;
                });
                $.header.animate({
                    opacity: .5,
                    duration: 300
                });
                $.mapWrapper.animate({
                    opacity: .5,
                    duration: 300
                });
                $.lblCaption.animate({
                    opacity: 0,
                    duration: 300
                }, function() {
                    $.lblTitle.setText(L("widget_samantha_canceled_trip_title"));
                    $.lblCaption.setText(L("widget_samantha_trip_re_enable_message"));
                    $.btnEnableTrip.visible = true;
                    $.btnEnableTrip.opacity = .2;
                    $.lblCaption.animate({
                        opacity: 1,
                        duration: 300
                    });
                    $.btnEnableTrip.animate({
                        opacity: 1,
                        duration: 300
                    }, function() {
                        $.btnEnableTrip.opacity = 1;
                    });
                });
            } else {
                this._curState = "Cancel";
                $.btnConfirm.visible = false;
                $.btnEditTrip.visible = false;
                $.btnEnableTrip.visible = true;
                $.header.opacity = .5;
                $.mapWrapper.opacity = .5;
                $.lblCaption.setText(L("widget_samantha_trip_re_enable_message"));
            }
        },
        _displayNormalState: function() {
            this._curState = "Normal";
            $.lblTitle.setText(L("widget_samantha_your_next_trip_title"));
            $.header.opacity = 1;
            $.mapWrapper.opacity = 1;
            $.btnConfirm.opacity = 1;
            $.btnEditTrip.opacity = 1;
            $.btnConfirm.visible = true;
            $.btnEditTrip.visible = true;
            $.btnEnableTrip.visible = false;
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
        },
        disappear: function(callback) {
            this.stopSpinner = true;
            var self = this;
            self.layoutContainer.hide();
            self.samantha.removeCard(self.cardName);
            self.cleanUp && self.cleanUp();
            callback && _.isFunction(callback) && callback();
        },
        disappearWithAnimation: function(callback) {
            var self = this;
            $.container.animate({
                top: "-" + $.container.size.height + "dp"
            }, function() {
                $.container.applyProperties({
                    top: "-" + $.container.size.height + "dp"
                });
                $.layoutContainer.hide();
                callback && _.isFunction(callback) && callback();
                samantha.removeCard(self.cardName);
            });
        },
        cleanUp: function() {
            samantha.off("samantha.show.ErrorDialog", this._restoreButtonState);
            args = null;
            samantha = null;
            appSound = null;
            utils = null;
            i18n = null;
            analytics = null;
            trackingEvent = null;
            $ = null;
        },
        startTripConfirmTransition: function() {
            this.stopSpinner = false;
            var t = Ti.UI.create2DMatrix();
            var spin = Titanium.UI.createAnimation();
            var self = this;
            var spin = function() {
                if (self.stopSpinner) return;
                t = t.rotate(20);
                $.spinnerImage.animate({
                    transform: t,
                    duration: 50
                }, spin);
                $.findingMatchContainer.applyProperties({
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    })
                });
            };
            var matrix = Ti.UI.create2DMatrix();
            matrix = matrix.scale(.01);
            $.findingMatchContainer.applyProperties({
                visible: true,
                transform: matrix
            });
            $.findingMatchContainer.visible = true;
            $.findingMatchContainer.animate({
                transform: Ti.UI.create2DMatrix({
                    scale: 1
                }),
                duration: 200
            }, spin);
        },
        delayTripTime: function(deviationMins) {
            this._trip.schedule.effectiveTime += 60 * deviationMins * 1e3;
            var dateTime = i18n.formatTime(moment(this._trip.schedule.effectiveTime));
            $.tripTime.setText(dateTime);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;