function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripConfirmed";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        top: 0,
        visible: "false",
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_your_next_trip_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.containerWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "containerWrapper"
    });
    $.__views.layoutContainer.add($.__views.containerWrapper);
    $.__views.header = Ti.UI.createView({
        backgroundColor: "#003333",
        top: 0,
        left: 0,
        height: "72dp",
        width: Ti.UI.FILL,
        zIndex: 100,
        borderRadius: "3dp",
        id: "header"
    });
    $.__views.containerWrapper.add($.__views.header);
    $.__views.headerContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        right: "50dp",
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "headerContainer"
    });
    $.__views.header.add($.__views.headerContainer);
    $.__views.date = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: Ti.UI.FILL,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.headerContainer.add($.__views.date);
    $.__views.__alloyId970 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "__alloyId970"
    });
    $.__views.headerContainer.add($.__views.__alloyId970);
    $.__views.tripTime = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripTime"
    });
    $.__views.__alloyId970.add($.__views.tripTime);
    $.__views.origin = Ti.UI.createLabel({
        color: "#fff",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "origin"
    });
    $.__views.__alloyId970.add($.__views.origin);
    $.__views.__alloyId971 = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        bottom: "6dp",
        id: "__alloyId971"
    });
    $.__views.headerContainer.add($.__views.__alloyId971);
    $.__views.tripType = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "tripType"
    });
    $.__views.__alloyId971.add($.__views.tripType);
    $.__views.destination = Ti.UI.createLabel({
        color: "#fff",
        left: "82dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        id: "destination"
    });
    $.__views.__alloyId971.add($.__views.destination);
    $.__views.pointerView = Ti.UI.createView({
        top: 0,
        right: "10dp",
        width: "50dp",
        height: "70dp",
        id: "pointerView"
    });
    $.__views.header.add($.__views.pointerView);
    $.__views.lblPointer = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "40dp",
            fontWeight: "bold"
        },
        text: "K",
        left: 0,
        width: "50dp",
        height: "70dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        top: 0,
        visible: true,
        id: "lblPointer"
    });
    $.__views.pointerView.add($.__views.lblPointer);
    $.__views.spinnerImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "30dp",
        height: "30dp",
        image: "/images/SamanthaProgressRing.png",
        visible: false,
        id: "spinnerImage"
    });
    $.__views.pointerView.add($.__views.spinnerImage);
    $.__views.dotSpinner = Ti.UI.createView({
        top: "4dp",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        visible: false,
        id: "dotSpinner"
    });
    $.__views.pointerView.add($.__views.dotSpinner);
    $.__views.dot0 = Ti.UI.createView({
        width: "8dp",
        height: "8dp",
        backgroundColor: "#fff",
        borderRadius: "4dp",
        bottom: "2dp",
        id: "dot0"
    });
    $.__views.dotSpinner.add($.__views.dot0);
    $.__views.dot1 = Ti.UI.createView({
        width: "8dp",
        height: "8dp",
        backgroundColor: "#fff",
        borderRadius: "4dp",
        bottom: "2dp",
        id: "dot1"
    });
    $.__views.dotSpinner.add($.__views.dot1);
    $.__views.dot2 = Ti.UI.createView({
        width: "8dp",
        height: "8dp",
        backgroundColor: "#fff",
        borderRadius: "4dp",
        bottom: "2dp",
        id: "dot2"
    });
    $.__views.dotSpinner.add($.__views.dot2);
    $.__views.dot3 = Ti.UI.createView({
        width: "8dp",
        height: "8dp",
        backgroundColor: "#fff",
        borderRadius: "4dp",
        bottom: "2dp",
        id: "dot3"
    });
    $.__views.dotSpinner.add($.__views.dot3);
    $.__views.dot4 = Ti.UI.createView({
        width: "8dp",
        height: "8dp",
        backgroundColor: "#fff",
        borderRadius: "4dp",
        bottom: "2dp",
        id: "dot4"
    });
    $.__views.dotSpinner.add($.__views.dot4);
    $.__views.container = Ti.UI.createView({
        top: "-100%",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        backgroundColor: "#fff",
        borderRadius: "3dp",
        id: "container"
    });
    $.__views.containerWrapper.add($.__views.container);
    $.__views.mapWrapper = Ti.UI.createView({
        top: "3dp",
        bottom: "6dp",
        width: Ti.UI.FILL,
        height: "60dp",
        id: "mapWrapper"
    });
    $.__views.container.add($.__views.mapWrapper);
    $.__views.mapImage = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "mapImage"
    });
    $.__views.mapWrapper.add($.__views.mapImage);
    $.__views.buttonWrapper = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "composite",
        top: "6dp",
        left: "10dp",
        right: "10dp",
        bottom: "10dp",
        id: "buttonWrapper"
    });
    $.__views.container.add($.__views.buttonWrapper);
    $.__views.btnEdit = require("/ui/common/custom_button").createButton({
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        left: "2%",
        width: "96%",
        color: "#555",
        borderRadius: Alloy.Globals.Style.Unit.unit2,
        height: "44dp",
        disableAnimation: true,
        title: "",
        id: "btnEdit"
    });
    $.__views.buttonWrapper.add($.__views.btnEdit);
    $.__views.__alloyId972 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId972"
    });
    $.__views.btnEdit.add($.__views.__alloyId972);
    $.__views.__alloyId973 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId973"
    });
    $.__views.__alloyId972.add($.__views.__alloyId973);
    $.__views.btnFirstLabel = Ti.UI.createLabel({
        color: "#555",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_samantha_trip_edit_trip"),
        id: "btnFirstLabel"
    });
    $.__views.__alloyId973.add($.__views.btnFirstLabel);
    $.__views.loadingContainer = Ti.UI.createView({
        top: "70dp",
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        backgroundColor: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "loadingContainer"
    });
    $.__views.containerWrapper.add($.__views.loadingContainer);
    $.__views.imageContainer = Ti.UI.createView({
        height: "210dp",
        width: "90%",
        layout: "horizontal",
        id: "imageContainer"
    });
    $.__views.loadingContainer.add($.__views.imageContainer);
    $.__views.findingMatchTitle = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        top: "10dp",
        text: L("widget_samantha_confirmtip_title"),
        id: "findingMatchTitle"
    });
    $.__views.loadingContainer.add($.__views.findingMatchTitle);
    $.__views.findingMatchMessage = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        width: "90%",
        text: L("widget_samantha_confirmtip_message_rider"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        bottom: "20dp",
        id: "findingMatchMessage"
    });
    $.__views.loadingContainer.add($.__views.findingMatchMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), units = require("platform/units"), css = require("/ui/css"), Q = require("/vendor/q"), args = arguments[0] || {}, samantha = args.samantha;
    exports = new (require(WPATH("cardTemplate")).extend($, {
        samantha: samantha,
        cardName: "tripConfirmed",
        customAnimation: false,
        stopSpinner: false,
        startSpinner: false,
        _availableScreenHeight: 0,
        dotAnimInterval: null,
        loadingAvatars: null,
        avatarWidth: 50,
        avatorGap: 10,
        loadingAnimInterval: 0,
        loadingCount: 0,
        _trip: null,
        events: {
            "click mapWrapper": "_openMapEvent",
            "click header": "_triggerLoadingAnim",
            "click btnEdit": "_editEvent"
        },
        _openMapEvent: function(e) {
            samantha.whisper("samantha.open.map", {
                trip: this._trip
            });
        },
        _editEvent: function(e) {
            samantha.whisper("samantha.editTripAction.dialog");
        },
        _expandOrCollapse: function(e) {
            parseFloat($.container.top) > 0 ? $.container.animate({
                top: -$.container.size.height,
                duration: 200
            }, function() {
                $.container.top = -$.container.size.height;
                $.addClass($.lblPointer, "icon-vertical-collapse");
                $.removeClass($.lblPointer, "icon-vertical-expand");
                $.header.applyProperties({
                    borderRadius: "3dp"
                });
                $.containerWrapper.applyProperties({
                    height: "55dp"
                });
            }) : css.setStyle($, {
                "#containerWrapper": {
                    height: this._availableScreenHeight - 40 + "dp"
                }
            }, {
                waitUntilUpdated: true
            }).then(function() {
                $.container.animate({
                    top: units.dipToSystemUnit(52),
                    duration: 200
                }, function() {
                    $.container.top = units.dipToSystemUnit(52);
                    $.addClass($.lblPointer, "icon-vertical-expand");
                    $.removeClass($.lblPointer, "icon-vertical-collapse");
                    $.header.applyProperties({
                        borderRadius: "0"
                    });
                });
            });
        },
        _triggerLoadingAnim: function(e) {
            var self = this;
            if (parseFloat($.loadingContainer.top) > 0) $.loadingContainer.animate({
                top: -$.loadingContainer.size.height,
                duration: 200
            }, function() {
                $.loadingContainer.top = -$.loadingContainer.size.height;
                $.addClass($.lblPointer, "icon-vertical-collapse");
                $.removeClass($.lblPointer, "icon-vertical-expand");
                $.header.applyProperties({
                    borderRadius: "3dp"
                });
                $.containerWrapper.applyProperties({
                    height: Ti.UI.SIZE
                });
                clearInterval(self.loadingAnimInterval);
                for (var i = 0; i < self.loadingAvators.length; i++) self.loadingAvators[i].visible = false;
            }); else {
                for (var i = 0; i < this.loadingAvators.length; i++) this.loadingAvators[i].visible = false;
                css.setStyle($, {
                    "#containerWrapper": {
                        height: this._availableScreenHeight + 40 + "dp"
                    }
                }, {
                    waitUntilUpdated: true
                }).then(function() {
                    $.loadingContainer.animate({
                        top: units.dipToSystemUnit(70),
                        duration: 200
                    }, function() {
                        $.loadingContainer.top = units.dipToSystemUnit(70);
                        $.addClass($.lblPointer, "icon-vertical-expand");
                        $.removeClass($.lblPointer, "icon-vertical-collapse");
                        $.header.applyProperties({
                            borderRadius: "0"
                        });
                        self.loadingCount = 0;
                        self.startAvatarLoadingAnim1();
                    });
                });
            }
        },
        configure: function() {
            _.bindAll(this, "startAvatarLoadingAnim", "startAvatarLoadingAnim1", "restartAvatarLoadingAnim1", "_triggerLoadingAnim");
            this.initLoadingContianer();
        },
        calculateLayoutContainerHeight: function() {
            return $.header.size.height + $.container.size.height + 20;
        },
        prepareView: function(options) {
            var trip = options.trip, availableScreenHeight = options.availableScreenHeight - 30;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.date.text = dateMoment.format("Do MMM");
            $.tripTime.setText(dateTime);
            $.tripType.setText(L("widget_decision_samantha_" + trip.type));
            $.findingMatchMessage.setText(L("RIDE" === trip.type ? "widget_samantha_confirmtip_message_rider" : "widget_samantha_confirmtip_message_driver"));
            $.origin.setText(trip.origin.alias && trip.origin.alias.length > 0 ? trip.origin.alias : trip.origin.address);
            var des = trip.destination.alias && trip.destination.alias.length > 0 ? trip.destination.alias : trip.destination.address;
            $.destination.setText(String.format(L("widget_decision_samantha_destination"), des));
            availableScreenHeight > 0 && (this._availableScreenHeight = availableScreenHeight);
            var self = this;
            setTimeout(function() {
                self.loadingCount = 0;
                parseFloat($.loadingContainer.top) < 0 && self._triggerLoadingAnim();
                self.startAvatarLoadingAnim1(true);
            }, 200);
        },
        initLoadingContianer: function() {
            var screenWidth = require("utils/utils").pixelToDp(Ti.Platform.displayCaps.platformWidth);
            this.loadingAvators = [];
            var startLeft = Math.floor((.9 * screenWidth * .9 - 4 * this.avatarWidth - 3 * this.avatorGap) / 2);
            for (var i = 0; 3 > i; i++) for (var j = 0; 4 > j; j++) {
                var loadingAvatorImage = Ti.UI.createImageView({
                    width: this.avatarWidth + "dp",
                    height: this.avatarWidth + "dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit25,
                    top: 0 == i ? "20dp" : "10dp",
                    bottom: 2 == i ? "20dp" : 0,
                    left: 0 == j ? startLeft + "dp" : this.avatorGap + "dp",
                    image: "/images/loadingAvatar/" + (4 * i + j + 1) + ".jpg",
                    defaultImage: "/images/loadingAvatar/" + (4 * i + j + 1) + ".jpg",
                    opacity: .3,
                    visible: false
                });
                loadingAvatorImage.index = 4 * i + j + 1;
                $.imageContainer.add(loadingAvatorImage);
                this.loadingAvators.push(loadingAvatorImage);
            }
        },
        startAvatarLoadingAnim: function() {
            var index = 0, size = this.loadingAvators.length, self = this;
            this.loadingAnimInterval = setInterval(function() {
                var cur = index % size, prev = 0 == cur ? size - 1 : cur - 1;
                self.loadingAvators[prev].animate({
                    opacity: .3,
                    duration: 300
                });
                self.loadingAvators[cur].applyProperties({
                    image: "/images/loadingAvatar/" + (cur + size * self.loadingCount + 1) + ".jpg",
                    defaultImage: "/images/loadingAvatar/" + (cur + size * self.loadingCount + 1) + ".jpg"
                });
                self.loadingAvators[cur].visible = true;
                self.loadingAvators[cur].animate({
                    opacity: 1,
                    duration: 300
                });
                index = ++index % size;
            }, 500);
        },
        startAvatarLoadingAnim1: function(restart) {
            var index = 0, size = this.loadingAvators.length, self = this;
            if (restart && this.loadingAnimInterval > 0) return;
            clearInterval(this.loadingAnimInterval);
            this.loadingAnimInterval = 0;
            if (restart) for (var i = 0; i < this.loadingAvators.length; i++) this.loadingAvators[i].visible = false;
            if (this.loadingCount >= 2) {
                this.loadingCount = 0;
                setTimeout(this._triggerLoadingAnim, 500);
                return;
            }
            this.loadingCount++;
            this.loadingAnimInterval = setInterval(function() {
                $.imageContainer.visible = true;
                var cur = index % size, prev = 0 == cur ? cur : cur - 1;
                size - 1 > prev && self.loadingAvators[prev].animate({
                    opacity: .3,
                    duration: 300
                });
                self.loadingAvators[cur].applyProperties({
                    image: "/images/loadingAvatar/" + (cur + size * (self.loadingCount - 1) + 1) + ".jpg",
                    defaultImage: "/images/loadingAvatar/" + (cur + size * (self.loadingCount - 1) + 1) + ".jpg"
                });
                self.loadingAvators[cur].visible = true;
                self.loadingAvators[cur].animate({
                    opacity: 1,
                    duration: 300
                });
                index = ++index % size;
                if (0 == index) {
                    clearInterval(self.loadingAnimInterval);
                    setTimeout(self.restartAvatarLoadingAnim1, 500);
                }
            }, 500);
        },
        restartAvatarLoadingAnim1: function() {
            var self = this;
            for (var i = 0; i < this.loadingAvators.length; i++) {
                var index = i;
                this.loadingAvators[i].animate({
                    opacity: 0,
                    duration: 400
                });
            }
            setTimeout(this.startAvatarLoadingAnim1, 200);
        },
        startDotAnim: function() {
            var index = 0;
            this.dotAnimInterval = setInterval(function() {
                var cur = index > 4 ? 9 - index : index;
                $.dotSpinner.children[cur].animate({
                    opacity: index > 4 ? 1 : 0,
                    duration: 200
                });
                index = ++index % 10;
            }, 200);
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
            samantha.setTripMatchFound(false);
        },
        disappear: function(callback) {
            clearInterval(this.loadingAnimInterval);
            this.stopSpinner = true;
            this.layoutContainer.hide();
            this.samantha.removeCard(this.cardName);
            this.cleanUp && this.cleanUp();
            callback && _.isFunction(callback) && callback();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;