function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripMatchPop";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripMatchPop = Ti.UI.createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        left: 0,
        backgroundColor: "#fff",
        navBarHidden: true,
        id: "tripMatchPop"
    });
    $.__views.tripMatchPop && $.addTopLevelView($.__views.tripMatchPop);
    $.__views.__alloyId974 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "__alloyId974"
    });
    $.__views.tripMatchPop.add($.__views.__alloyId974);
    $.__views.layoutTopContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutTopContainer"
    });
    $.__views.__alloyId974.add($.__views.layoutTopContainer);
    $.__views.titleContainer = Ti.UI.createView({
        top: "40dp",
        width: "100%",
        height: Ti.UI.SIZE,
        zIndex: 10,
        id: "titleContainer"
    });
    $.__views.layoutTopContainer.add($.__views.titleContainer);
    $.__views.imageContainer = Ti.UI.createView({
        top: "110dp",
        width: "210dp",
        height: "100dp",
        zIndex: 0,
        id: "imageContainer"
    });
    $.__views.titleContainer.add($.__views.imageContainer);
    $.__views.selfAvatar = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        left: 0,
        width: "100dp",
        height: "100dp",
        borderRadius: Alloy.Globals.Style.Unit.unit50,
        borderWidth: "1dp",
        borderColor: "#fff",
        preventDefaultImage: true,
        zIndex: 1,
        id: "selfAvatar"
    });
    $.__views.imageContainer.add($.__views.selfAvatar);
    $.__views.avatar = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        left: "110dp",
        width: "100dp",
        height: "100dp",
        borderRadius: Alloy.Globals.Style.Unit.unit50,
        borderWidth: "1dp",
        borderColor: "#fff",
        preventDefaultImage: true,
        id: "avatar"
    });
    $.__views.imageContainer.add($.__views.avatar);
    $.__views.logo = Ti.UI.createImageView({
        defaultImage: "/images/itonbanner.png",
        top: 0,
        width: "90%",
        height: "auto",
        image: "/images/itonbanner.png",
        zIndex: 10,
        id: "logo"
    });
    $.__views.titleContainer.add($.__views.logo);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "30dp",
            fontWeight: "bold"
        },
        top: "10dp",
        left: 0,
        wordwrap: true,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "lblTitle"
    });
    $.__views.layoutTopContainer.add($.__views.lblTitle);
    $.__views.lblSubtitle = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        top: 0,
        left: 0,
        wordwrap: true,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "lblSubtitle"
    });
    $.__views.layoutTopContainer.add($.__views.lblSubtitle);
    $.__views.lblSubtitle1 = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        top: "30dp",
        left: 0,
        wordwrap: true,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        id: "lblSubtitle1"
    });
    $.__views.layoutTopContainer.add($.__views.lblSubtitle1);
    $.__views.layoutBottomContainer = Ti.UI.createView({
        bottom: "10dp",
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "layoutBottomContainer"
    });
    $.__views.__alloyId974.add($.__views.layoutBottomContainer);
    $.__views.bottomContainer = Ti.UI.createView({
        top: "20dp",
        left: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        layout: "vertical",
        id: "bottomContainer"
    });
    $.__views.layoutBottomContainer.add($.__views.bottomContainer);
    $.__views.btnDone = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        color: "#fff",
        backgroundColor: "#ff6600",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        disableAnimation: true,
        top: "10dp",
        left: "10dp",
        right: "10dp",
        caption: L("widget_samantha_trip_match_button_got_it"),
        title: "",
        id: "btnDone"
    });
    $.__views.bottomContainer.add($.__views.btnDone);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), args = arguments[0] || {}, units = require("/platform/units"), isDriver = args.isDriver, samantha = args.samantha;
    profile = args.profile;
    exports = new (require("/carmalib/controller").extend($, {
        _backgroundWidth: 0,
        _space: 0,
        events: {
            "click[ios] btnDone": "_dismiss",
            "click[android] btnDone": "_dismiss"
        },
        configure: function() {
            var resourceOwner = require("services/resource_owner_service").singleton();
            var userObject = resourceOwner.toJSON();
            this.setUserImage(profile, $.avatar);
            this.setUserImage(userObject, $.selfAvatar);
            $.lblTitle.setText(profile.firstName);
            var subtitle = L("widget_samantha_trip_match_pop_subtitle_rider");
            isDriver && (subtitle = L("widget_samantha_trip_match_pop_subtitle_driver"));
            $.lblSubtitle.setText(String.format(subtitle, ""));
            $.lblSubtitle1.setText(String.format(L("widget_samantha_trip_match_pop_description"), profile.firstName));
            var screenHeight = units.SystemUnitToDip(Ti.Platform.displayCaps.platformHeight);
            var screenWidth = units.SystemUnitToDip(Ti.Platform.displayCaps.platformWidth);
            this._space = (screenHeight - 50 - 150 - 80 - 50) / 2;
            screenWidth > 320 && $.logo.applyProperties({
                width: "320dp",
                height: "128dp"
            });
            if (screenHeight > 480) {
                $.imageContainer.applyProperties({
                    width: "290dp",
                    height: "150dp"
                });
                $.selfAvatar.applyProperties({
                    width: "140dp",
                    height: "140dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit70
                });
                $.avatar.applyProperties({
                    left: "150dp",
                    width: "140dp",
                    height: "140dp",
                    borderRadius: Alloy.Globals.Style.Unit.unit70
                });
            }
            samantha.checkBookingStatus() ? $.logo.image = "/images/itonbanner.png" : samantha.setBookingStatus(true);
        },
        setUserImage: function(user, imageView) {
            var CACHE_FOLDER = Ti.Filesystem.getFile(Ti.Filesystem.applicationCacheDirectory, "profile-cache");
            CACHE_FOLDER.exists() || CACHE_FOLDER.createDirectory();
            var localFileName = function(imageURL) {
                return Ti.Utils.md5HexDigest(imageURL + "");
            };
            var size = 60, url = require("utils/photoURL").toURL(user.photoUrl, {
                width: size,
                height: size
            }), file = Ti.Filesystem.getFile(CACHE_FOLDER.resolve(), localFileName(url));
            if (file.exists()) imageView.applyProperties({
                image: file.getNativePath()
            }); else {
                var defaultImage = require("ui/common/Avatar").getDefaultPhoto(user);
                imageView.defaultImage = defaultImage;
                imageView.image = user.photoUrl;
            }
        },
        _getAnimationOptions: function() {
            var options = null;
            options = {
                modal: true,
                activityEnterAnimation: Ti.Android.R.anim.fade_in,
                activityExitAnimation: Ti.Android.R.anim.fade_out
            };
            return options;
        },
        _dismiss: function() {
            $.getView().close();
            samantha.checkPopUps();
            $.trigger("dismiss");
        },
        presentModalView: function(options) {
            var options = options || {};
            if (options.animated) var screen;
            $.getView().open();
            TM.push(function() {
                _.delay(function() {
                    require("/utils/appSound").play("snuffle");
                }, 300);
            });
        },
        isTripMatch: function() {
            return false;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;