function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripRequestForDriver";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        font: {
            fontSize: "12dp"
        },
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        visible: "false",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_autosearchresult_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.containerWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "containerWrapper"
    });
    $.__views.layoutContainer.add($.__views.containerWrapper);
    $.__views.myTripAwesomeAnimationContainer = Ti.UI.createView({
        height: "70dp",
        top: 0,
        zIndex: 2,
        id: "myTripAwesomeAnimationContainer"
    });
    $.__views.containerWrapper.add($.__views.myTripAwesomeAnimationContainer);
    $.__views.myTripContainer = Ti.UI.createView({
        height: "65dp",
        layout: "vertical",
        top: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "myTripContainer"
    });
    $.__views.myTripAwesomeAnimationContainer.add($.__views.myTripContainer);
    $.__views.myTripBriefContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "65dp",
        backgroundColor: "#fff",
        layout: "horizontal",
        id: "myTripBriefContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripBriefContainer);
    $.__views.date = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        left: "10dp",
        width: Ti.UI.FILL,
        font: {
            fontSize: "14dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.myTripBriefContainer.add($.__views.date);
    $.__views.__alloyId978 = Ti.UI.createView({
        width: "86dp",
        id: "__alloyId978"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId978);
    $.__views.myTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: 0,
        id: "myTripDepartureTime"
    });
    $.__views.__alloyId978.add($.__views.myTripDepartureTime);
    $.__views.myTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "17dp",
        id: "myTripRole"
    });
    $.__views.__alloyId978.add($.__views.myTripRole);
    $.__views.__alloyId979 = Ti.UI.createView({
        width: Ti.UI.FILL,
        id: "__alloyId979"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId979);
    $.__views.myTripOrigin = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        left: 0,
        top: 0,
        id: "myTripOrigin"
    });
    $.__views.__alloyId979.add($.__views.myTripOrigin);
    $.__views.myTripDestination = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        left: 0,
        top: "17dp",
        id: "myTripDestination"
    });
    $.__views.__alloyId979.add($.__views.myTripDestination);
    $.__views.myTripMapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        backgroundColor: "#fff",
        height: "60dp",
        id: "myTripMapWrapper"
    });
    $.__views.myTripContainer.add($.__views.myTripMapWrapper);
    $.__views.myTripMap = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "myTripMap"
    });
    $.__views.myTripMapWrapper.add($.__views.myTripMap);
    $.__views.myTripActionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        backgroundColor: "#fff",
        id: "myTripActionsContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripActionsContainer);
    $.__views.myTripActionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        text: L("widget_samantha_driver_trip_note"),
        top: "10dp",
        id: "myTripActionsBrief"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActionsBrief);
    $.__views.myTripActions = Ti.UI.createView({
        height: "50dp",
        top: "10dp",
        id: "myTripActions"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActions);
    $.__views.changeDetailsButton = require("/ui/common/custom_button").createButton({
        width: "45%",
        color: "#555",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        bottom: "10dp",
        left: "10dp",
        top: "0",
        title: "",
        id: "changeDetailsButton"
    });
    $.__views.myTripActions.add($.__views.changeDetailsButton);
    $.__views.changeDetailsLabel = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        text: L("widget_samantha_trip_edit_trip"),
        id: "changeDetailsLabel"
    });
    $.__views.changeDetailsButton.add($.__views.changeDetailsLabel);
    $.__views.confirmTripButton = require("/ui/common/custom_button").createButton({
        width: "45%",
        color: "#555",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        height: "44dp",
        bottom: "10dp",
        right: "10dp",
        top: "0",
        title: "",
        id: "confirmTripButton"
    });
    $.__views.myTripActions.add($.__views.confirmTripButton);
    $.__views.__alloyId980 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "14dp"
        },
        text: L("btn_yes"),
        id: "__alloyId980"
    });
    $.__views.confirmTripButton.add($.__views.__alloyId980);
    $.__views.tripMatchIndicator = Ti.UI.createView({
        height: 0,
        color: "#fff",
        top: "-5dp",
        zIndex: 1,
        visible: false,
        id: "tripMatchIndicator"
    });
    $.__views.containerWrapper.add($.__views.tripMatchIndicator);
    $.__views.downArrowWrapper = Ti.UI.createLabel({
        color: "#ffffff",
        text: "L",
        title: "L",
        font: {
            fontFamily: "splinico",
            fontSize: "56dp"
        },
        top: "-28dp",
        id: "downArrowWrapper"
    });
    $.__views.tripMatchIndicator.add($.__views.downArrowWrapper);
    $.__views.indicatorMessage = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_trip_match"),
        width: Ti.UI.SIZE,
        height: "20dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        top: "8dp",
        opacity: 0,
        id: "indicatorMessage"
    });
    $.__views.tripMatchIndicator.add($.__views.indicatorMessage);
    $.__views.tripRequestedContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: 0,
        layout: "vertical",
        backgroundColor: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        visible: false,
        id: "tripRequestedContainer"
    });
    $.__views.containerWrapper.add($.__views.tripRequestedContainer);
    $.__views.tripBriefContainer = Ti.UI.createView({
        height: "75dp",
        top: 0,
        layout: "horizontal",
        id: "tripBriefContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.tripBriefContainer);
    $.__views.tripBriefContainerLeftColumn = Ti.UI.createView({
        width: "25%",
        id: "tripBriefContainerLeftColumn"
    });
    $.__views.tripBriefContainer.add($.__views.tripBriefContainerLeftColumn);
    $.__views.matchedTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightGrey,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "10dp",
        id: "matchedTripDepartureTime"
    });
    $.__views.tripBriefContainerLeftColumn.add($.__views.matchedTripDepartureTime);
    $.__views.matchedTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightGrey,
        font: {
            fontSize: "14dp"
        },
        top: "27dp",
        left: "10dp",
        text: L("widget_decision_samantha_RIDE"),
        id: "matchedTripRole"
    });
    $.__views.tripBriefContainerLeftColumn.add($.__views.matchedTripRole);
    $.__views.tripBriefContainerRightColumn = Ti.UI.createView({
        width: "74%",
        id: "tripBriefContainerRightColumn"
    });
    $.__views.tripBriefContainer.add($.__views.tripBriefContainerRightColumn);
    $.__views.matchedTripOwner = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp",
            fontWeight: "bold"
        },
        top: "10dp",
        left: "10dp",
        id: "matchedTripOwner"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripOwner);
    $.__views.matchedTripOrigin = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        top: "27dp",
        left: "10dp",
        id: "matchedTripOrigin",
        text: "Penrose Wharf, Cork"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripOrigin);
    $.__views.matchedTripDestination = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        top: "45dp",
        left: "10dp",
        id: "matchedTripDestination",
        text: "to Compass Quary, Kinsale, Cork"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripDestination);
    $.__views.imgAvatar = require("/ui/common/profile").createView({
        height: "50dp",
        width: "50dp",
        id: "imgAvatar"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.imgAvatar);
    $.__views.mapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        height: "60dp",
        id: "mapWrapper"
    });
    $.__views.tripRequestedContainer.add($.__views.mapWrapper);
    $.__views.map = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "map"
    });
    $.__views.mapWrapper.add($.__views.map);
    $.__views.actionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        id: "actionsContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.actionsContainer);
    $.__views.actionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        height: "40dp",
        id: "actionsBrief"
    });
    $.__views.actionsContainer.add($.__views.actionsBrief);
    $.__views.actions = Ti.UI.createView({
        height: "60dp",
        id: "actions"
    });
    $.__views.actionsContainer.add($.__views.actions);
    $.__views.denyTripRequestButton = require("/ui/common/custom_button").createButton({
        color: "#555",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        bottom: "10dp",
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        left: "10dp",
        top: "0",
        title: "",
        id: "denyTripRequestButton"
    });
    $.__views.actions.add($.__views.denyTripRequestButton);
    $.__views.__alloyId981 = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp",
            fontWeight: "bold"
        },
        text: L("btn_no"),
        id: "__alloyId981"
    });
    $.__views.denyTripRequestButton.add($.__views.__alloyId981);
    $.__views.approveTripRequestButton = require("/ui/common/custom_button").createButton({
        color: "#555",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        bottom: "10dp",
        right: "10dp",
        top: "0",
        title: "",
        id: "approveTripRequestButton"
    });
    $.__views.actions.add($.__views.approveTripRequestButton);
    $.__views.__alloyId982 = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "14dp",
            fontWeight: "bold"
        },
        text: L("btn_yes"),
        id: "__alloyId982"
    });
    $.__views.approveTripRequestButton.add($.__views.__alloyId982);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), samanthaService = require("services/samantha_service"), i18n = require("i18n/i18n"), utils = require("utils/utils"), css = require("/ui/css"), executor = require("utils/executor"), args = arguments[0] || {}, samantha = args.samantha;
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "tripRequestForDriver",
        customAnimation: false,
        _tripRequests: null,
        _trip: null,
        _isMyTripCollapsed: true,
        _isTripRequestCollapsed: false,
        _availableScreenHeight: 265,
        _isTripMatchDriver: false,
        _opening: false,
        _initialised: false,
        _openPopup: false,
        waitUntilReady: true,
        events: {
            "click[ios] mapWrapper": "_openMapEvent",
            "click[android] mapWrapper": "_openMapEvent",
            "click[ios] myTripMapWrapper": "_openMapEvent",
            "click[android] myTripMapWrapper": "_openMapEvent",
            "click denyTripRequestButton": "_declineBooking",
            "click approveTripRequestButton": "_acceptBooking",
            "click changeDetailsButton": "_changeMyTripDetails",
            "click confirmTripButton": "_confirmMyTrip"
        },
        configure: function() {
            samantha.on("samantha.show.ErrorDialog", this._restoreButtonsState);
        },
        _restoreButtonsState: function() {
            $.approveTripRequestButton.stopIndicator();
            $.denyTripRequestButton.stopIndicator();
            $.approveTripRequestButton.applyProperties({
                touchEnabled: true
            });
            $.denyTripRequestButton.applyProperties({
                touchEnabled: true
            });
        },
        prepareView: function(options) {
            this._isMyTripCollapsed = true;
            this._isTripRequestCollapsed = false;
            $.layoutContainer.applyProperties({
                height: Ti.UI.SIZE
            });
            var dateMoment = moment(options.trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment), booking = this._tripRequests[0];
            bookingTrip = null, myTrip = null;
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = booking.rider.userId === myUserId ? booking.driver : booking.rider;
            this._isTripMatchDriver = booking.rider.userId === myUserId;
            if (booking.trip.ownerUid === myUserId) {
                bookingTrip = booking.sourceTrip.baseTrip;
                myTrip = booking.trip.baseTrip;
            } else {
                bookingTrip = booking.trip.baseTrip;
                myTrip = booking.sourceTrip.baseTrip;
            }
            this._availableScreenHeight = options.availableScreenHeight;
            $.date.text = dateMoment.format("Do MMM");
            $.myTripDepartureTime.setText(dateTime);
            $.myTripRole.setText(L("widget_decision_samantha_" + myTrip.type));
            $.myTripOrigin.setText(options.trip.origin.address);
            $.myTripDestination.setText(String.format(L("widget_decision_samantha_destination"), options.trip.destination.address));
            $.matchedTripDepartureTime.setText(i18n.formatTime(moment(bookingTrip.schedule.effectiveTime)));
            $.matchedTripRole.setText(L("widget_decision_samantha_" + bookingTrip.type));
            $.matchedTripOwner.setText(i18n.formatTime(moment(bookingTrip.schedule.effectiveTime)) + " - " + coordinator.alias);
            $.matchedTripOrigin.setText(bookingTrip.origin.address);
            $.matchedTripDestination.setText(String.format(L("widget_decision_samantha_destination"), bookingTrip.destination.address));
            $.imgAvatar.setUser(_.extend({}, coordinator, {
                layout: "circular-small"
            }));
            $.actionsBrief.setText(String.format(L("widget_samantha_trip_request_note"), coordinator.alias));
            require("ui/animate").tactile($.imgAvatar);
            $.indicatorMessage.text = L(this._isTripMatchDriver ? "widget_samantha_trip_matched_driver" : "widget_samantha_trip_matched_rider");
            this._layoutTripMatch(this._isTripMatchDriver);
            myTrip.schedule.confirmed && this._markTripConfirmed();
            this._restoreButtonsState();
            options.availableScreenHeight > 0 && $.containerWrapper.applyProperties({
                height: options.availableScreenHeight + "dp"
            });
            this._showTripMaps(bookingTrip, myTrip, options.availableScreenHeight);
            $.layoutContainer.applyProperties({
                height: "120dp"
            });
            $.tripMatchIndicator.show();
            this._initialised || (this._initialised = true);
            var self = this;
            if (!this._openPopup) {
                this._openPopup = true;
                setTimeout(function() {
                    self._openMatchPopup(options);
                }, 500);
            }
        },
        _openMatchPopup: function(options) {
            options.samanthaCard = this;
            options.samantha = samantha;
            var tripMatchPop = Alloy.createWidget("ma.car.app.samantha", "matchFoundPop", options);
            tripMatchPop.getView().open();
        },
        _layoutTripMatch: function(isDriver) {
            $.matchedTripDepartureTime.hide();
            $.matchedTripRole.hide();
            $.tripBriefContainerRightColumn.remove($.imgAvatar);
            $.tripBriefContainerLeftColumn.add($.imgAvatar);
            $.imgAvatar.setPadding({
                align: "left"
            });
            $.imgAvatar.applyProperties({
                left: null,
                right: null
            });
        },
        _animateTripRequest: function() {
            $.tripRequestedContainer.visible = true;
            $.indicatorMessage.animate({
                opacity: 1,
                duration: 300
            });
            return;
        },
        _animateInTripMatch: function() {},
        _markTripConfirmed: function() {
            css.setStyle($, {
                "#myTripBriefContainer": {
                    classes: "dark-blue-background",
                    "#date": "white",
                    "#myTripDepartureTime": "white",
                    "#myTripRole": "white",
                    "#myTripOrigin": "white carmaCardText",
                    "#myTripDestination": "white carmaCardText"
                },
                "#myTripActionsContainer": {
                    visible: false,
                    height: 0
                },
                "#downArrowWrapper": "dark-blue"
            });
        },
        finishDisplay: function() {
            this._animateInTripMatch();
            $.layoutContainer.show();
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this._tripRequests = options.bookings;
            this._params = options;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
        },
        displayWithAnimation: function() {},
        disappear: function(callback) {
            $.layoutContainer.hide();
            samantha.removeCard(this.cardName);
            callback && _.isFunction(callback) && callback();
        },
        disappearWithAnimation: function() {},
        _expandMyTrip: function() {
            if (!this._isMyTripCollapsed) return;
            css.setStyle($, {
                "#downArrowWrapper": "white"
            });
            this._isMyTripCollapsed = false;
            this._isTripRequestCollapsed = true;
            this._showTripRequestByCardType("simple");
            this._showMyTripByCardType("detailed");
        },
        _expandTripRequest: function() {
            if (!this._isTripRequestCollapsed) return;
            var colorClass = "white";
            this._trip.schedule.confirmed && (colorClass = "orange");
            css.setStyle($, {
                "#downArrowWrapper": colorClass
            });
            this._isMyTripCollapsed = true;
            this._isTripRequestCollapsed = false;
            this._showMyTripByCardType("simple");
            this._showTripRequestByCardType("detailed");
        },
        _playBounceAnimation: function(element, extremePoint) {
            element.animate({
                top: extremePoint + "dp",
                duration: 100
            }, function() {
                element.applyProperties({
                    top: extremePoint + "dp"
                });
                element.animate({
                    top: 0,
                    duration: 100
                }, function() {
                    element.applyProperties({
                        top: 0
                    });
                });
            });
        },
        _showMyTripByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.myTripContainer.applyProperties({
                    height: "55dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: "60dp"
                });
            } else {
                var tempHeight = parseFloat($.tripMatchIndicator.height, 10) + parseFloat($.tripRequestedContainer.height, 10);
                tempHeight = require("utils/utils").pixelToDp(parseFloat($.tripMatchIndicator.size.height, 10) + parseFloat($.tripRequestedContainer.size.height, 10));
                var height = this._availableScreenHeight - tempHeight - 5;
                $.myTripContainer.applyProperties({
                    height: height + "dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: height + 5 + "dp"
                });
            }
        },
        _showTripRequestByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.matchedTripOwner.applyProperties({
                    top: 0,
                    height: 0,
                    visible: false
                });
                this._isTripMatchDriver && $.imgAvatar.applyProperties({
                    visible: false,
                    enabled: false
                });
                $.matchedTripOrigin.applyProperties({
                    top: "10dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "27dp"
                });
                $.tripRequestedContainer.applyProperties({
                    height: "65dp"
                });
            } else {
                $.matchedTripOwner.applyProperties({
                    top: "10dp",
                    height: Ti.UI.SIZE,
                    visible: true
                });
                $.imgAvatar.applyProperties({
                    visible: true,
                    enabled: true
                });
                $.matchedTripOrigin.applyProperties({
                    top: "27dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "45dp"
                });
                var tempHeight = parseFloat($.tripMatchIndicator.height, 10) + parseFloat($.myTripContainer.height, 10);
                tempHeight = require("utils/utils").pixelToDp(parseFloat($.tripMatchIndicator.size.height, 10) + parseFloat($.myTripContainer.size.height, 10));
                var height = this._availableScreenHeight - tempHeight - 5;
                $.tripRequestedContainer.applyProperties({
                    height: height + "dp"
                });
            }
        },
        _openMapEvent: function(e) {
            if ("myTripMap" === e.source.id && !this._trip || "map" === e.source.id && (!this._tripRequests || 1 != this._tripRequests.length)) return;
            if (this.opening) return;
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), isForMyTrip = "myTripMap" === e.source.id, booking = this._tripRequests[0], amIARider = booking.rider.userId === myUserId, requestedTrip = amIARider ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            samantha.whisper("samantha.open.map", {
                trip: isForMyTrip ? this._trip : requestedTrip,
                dontUseTime: !isForMyTrip && !amIARider
            });
        },
        _getUserTripMapHeight: function(availableHeight) {
            if (!availableHeight) return;
            var visibleHeight = parseFloat($.myTripBriefContainer.size.height, 10) + parseFloat($.tripMatchIndicator.size.height, 10) + parseFloat($.tripBriefContainer.size.height, 10) + parseFloat($.actionsContainer.size.height, 10);
            visibleHeight = require("utils/utils").pixelToDp(visibleHeight);
            var mapHeight = availableHeight - visibleHeight;
            return mapHeight;
        },
        _getMyTripMapHeight: function(availableHeight) {
            if (!availableHeight) return;
            var visibleHeight = 2 * parseFloat($.myTripBriefContainer.size.height, 10) + parseFloat($.tripMatchIndicator.size.height, 10);
            visibleHeight = require("utils/utils").pixelToDp(visibleHeight);
            var mapHeight = availableHeight - visibleHeight - parseFloat($.myTripActionsContainer.height, 10);
            return mapHeight;
        },
        _declineBooking: function() {
            samantha.whisper("samantha.deny.booking", {
                booking: this._tripRequests[0]
            });
            this._openPopup = false;
            return;
            var self;
            var animationParam;
        },
        _acceptBooking: function() {
            samantha.whisper("samantha.accept.booking", {
                booking: this._tripRequests[0],
                confirmTrip: true,
                trip: this._trip
            });
            this._openPopup = false;
            return;
            var self;
        },
        _changeMyTripDetails: function() {
            samantha.whisper("samantha.editTripAction.dialog");
        },
        _confirmMyTrip: function() {
            var booking = this._tripRequests[0], myUserId = require("services/resource_owner_service").singleton().get("userId"), trip = booking.trip.ownerUid === myUserId ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            samantha.whisper("samantha.confirm.trip", {
                trip: trip,
                callback: function() {}
            });
            var self = this;
            TM.push(function() {
                analytics.track(trackingEvent.SAMANTHA_CONFIRM_TRIP, {
                    tripId: trip.id
                });
            }, process.backgroundDomain);
        },
        _showTripMaps: function(bookingTrip, myTrip, availableScreenHeight) {
            var self = this;
            if (0 === parseFloat($.mapWrapper.size.width) || 0 === parseFloat($.myTripMapWrapper.size.width)) {
                _.delay(function() {
                    self._showTripMaps(bookingTrip, myTrip, availableScreenHeight);
                }, 2e3);
                return;
            }
            this._showTripOnMap($.map, bookingTrip, this._getUserTripMapHeight(availableScreenHeight), $.mapWrapper);
            this._showTripOnMap($.myTripMap, myTrip, this._getMyTripMapHeight(availableScreenHeight), $.myTripMapWrapper);
        },
        _showTripOnMap: function(element, trip, height, elementWrapper) {
            var mapHeight = height;
            elementWrapper.height = mapHeight + "dp";
            if (!Alloy.Globals.Map || !this._trip) return;
            var mapWidth = elementWrapper.size.width;
            var units = require("/platform/units");
            utils.createMapUrl(trip, units.pixelToDip(mapWidth), height).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
                element.applyProperties({
                    height: mapHeight + "dp",
                    image: localPath
                });
            }).catch(function(e) {});
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;