function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.samantha/" + s : s.substring(0, index) + "/ma.car.app.samantha/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.samantha");
    this.__widgetId = "ma.car.app.samantha";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripRequestForRider";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layoutContainer = Ti.UI.createView({
        font: {
            fontSize: "12dp"
        },
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        layout: "vertical",
        visible: "false",
        id: "layoutContainer"
    });
    $.__views.layoutContainer && $.addTopLevelView($.__views.layoutContainer);
    $.__views.lblTitle = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_autosearchresult_title"),
        width: Ti.UI.SIZE,
        height: "50dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        id: "lblTitle"
    });
    $.__views.layoutContainer.add($.__views.lblTitle);
    $.__views.containerWrapper = Ti.UI.createView({
        top: 0,
        left: 0,
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        layout: "vertical",
        id: "containerWrapper"
    });
    $.__views.layoutContainer.add($.__views.containerWrapper);
    $.__views.myTripAwesomeAnimationContainer = Ti.UI.createView({
        height: "70dp",
        top: 0,
        zIndex: 2,
        id: "myTripAwesomeAnimationContainer"
    });
    $.__views.containerWrapper.add($.__views.myTripAwesomeAnimationContainer);
    $.__views.myTripContainer = Ti.UI.createView({
        height: "65dp",
        layout: "vertical",
        top: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "myTripContainer"
    });
    $.__views.myTripAwesomeAnimationContainer.add($.__views.myTripContainer);
    $.__views.myTripBriefContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "65dp",
        backgroundColor: "#fff",
        layout: "horizontal",
        id: "myTripBriefContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripBriefContainer);
    $.__views.date = Ti.UI.createLabel({
        color: "#fff",
        left: "10dp",
        width: Ti.UI.FILL,
        font: {
            fontSize: "14dp"
        },
        top: "5dp",
        id: "date"
    });
    $.__views.myTripBriefContainer.add($.__views.date);
    $.__views.__alloyId983 = Ti.UI.createView({
        width: "86dp",
        id: "__alloyId983"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId983);
    $.__views.myTripDepartureTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: 0,
        id: "myTripDepartureTime"
    });
    $.__views.__alloyId983.add($.__views.myTripDepartureTime);
    $.__views.myTripRole = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Orange,
        font: {
            fontSize: "14dp"
        },
        left: "10dp",
        top: "17dp",
        id: "myTripRole"
    });
    $.__views.__alloyId983.add($.__views.myTripRole);
    $.__views.__alloyId984 = Ti.UI.createView({
        width: Ti.UI.FILL,
        id: "__alloyId984"
    });
    $.__views.myTripBriefContainer.add($.__views.__alloyId984);
    $.__views.myTripOrigin = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        left: "0",
        top: 0,
        id: "myTripOrigin"
    });
    $.__views.__alloyId984.add($.__views.myTripOrigin);
    $.__views.myTripDestination = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        left: "0",
        top: "17dp",
        id: "myTripDestination"
    });
    $.__views.__alloyId984.add($.__views.myTripDestination);
    $.__views.myTripMapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        backgroundColor: "#fff",
        height: "60dp",
        id: "myTripMapWrapper"
    });
    $.__views.myTripContainer.add($.__views.myTripMapWrapper);
    $.__views.myTripMap = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "myTripMap"
    });
    $.__views.myTripMapWrapper.add($.__views.myTripMap);
    $.__views.myTripActionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        backgroundColor: "#fff",
        id: "myTripActionsContainer"
    });
    $.__views.myTripContainer.add($.__views.myTripActionsContainer);
    $.__views.myTripActionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "14dp"
        },
        text: L("widget_samantha_driver_trip_note"),
        top: "10dp",
        id: "myTripActionsBrief"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActionsBrief);
    $.__views.myTripActions = Ti.UI.createView({
        height: "50dp",
        top: "10dp",
        id: "myTripActions"
    });
    $.__views.myTripActionsContainer.add($.__views.myTripActions);
    $.__views.changeDetailsButton = require("/ui/common/custom_button").createButton({
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        font: {
            fontSize: "14dp"
        },
        bottom: "10dp",
        left: "10dp",
        top: "0",
        title: L("widget_samantha_trip_edit_trip"),
        id: "changeDetailsButton"
    });
    $.__views.myTripActions.add($.__views.changeDetailsButton);
    $.__views.confirmTripButton = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        font: {
            fontSize: "14dp"
        },
        width: "45%",
        bottom: "10dp",
        right: "10dp",
        top: "0",
        title: L("btn_yes"),
        height: "44dp",
        id: "confirmTripButton"
    });
    $.__views.myTripActions.add($.__views.confirmTripButton);
    $.__views.tripMatchIndicator = Ti.UI.createView({
        height: 0,
        color: "#fff",
        top: "-6dp",
        zIndex: 1,
        visible: false,
        id: "tripMatchIndicator"
    });
    $.__views.containerWrapper.add($.__views.tripMatchIndicator);
    $.__views.downArrowWrapper = Ti.UI.createLabel({
        color: "#ffffff",
        text: "L",
        title: "L",
        font: {
            fontFamily: "splinico",
            fontSize: "56dp"
        },
        top: "-28dp",
        id: "downArrowWrapper"
    });
    $.__views.tripMatchIndicator.add($.__views.downArrowWrapper);
    $.__views.indicatorMessage = Ti.UI.createLabel({
        color: "#fff",
        text: L("widget_samantha_trip_match"),
        width: Ti.UI.SIZE,
        height: "20dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        backgroundColor: "transparent",
        top: "8dp",
        opacity: 0,
        id: "indicatorMessage"
    });
    $.__views.tripMatchIndicator.add($.__views.indicatorMessage);
    $.__views.tripRequestedContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        height: 0,
        backgroundColor: "#fff",
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        zIndex: 0,
        visible: false,
        id: "tripRequestedContainer"
    });
    $.__views.containerWrapper.add($.__views.tripRequestedContainer);
    $.__views.tripBriefContainer = Ti.UI.createView({
        height: "75dp",
        top: 0,
        layout: "horizontal",
        id: "tripBriefContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.tripBriefContainer);
    $.__views.tripBriefContainerLeftColumn = Ti.UI.createView({
        width: "25%",
        id: "tripBriefContainerLeftColumn"
    });
    $.__views.tripBriefContainer.add($.__views.tripBriefContainerLeftColumn);
    $.__views.userPhoto = require("/ui/common/profile").createView({
        height: "50dp",
        width: "50dp",
        id: "userPhoto"
    });
    $.__views.tripBriefContainerLeftColumn.add($.__views.userPhoto);
    $.__views.tripBriefContainerRightColumn = Ti.UI.createView({
        width: "74%",
        id: "tripBriefContainerRightColumn"
    });
    $.__views.tripBriefContainer.add($.__views.tripBriefContainerRightColumn);
    $.__views.matchedTripOwner = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        top: "10dp",
        left: 0,
        id: "matchedTripOwner"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripOwner);
    $.__views.matchedTripOrigin = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "25dp",
        left: 0,
        id: "matchedTripOrigin"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripOrigin);
    $.__views.matchedTripDestination = Ti.UI.createLabel({
        color: "#666",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_MIDDLE,
        height: "20dp",
        wordwrap: false,
        ellipsize: true,
        font: {
            fontSize: "15dp"
        },
        top: "40dp",
        left: 0,
        id: "matchedTripDestination"
    });
    $.__views.tripBriefContainerRightColumn.add($.__views.matchedTripDestination);
    $.__views.mapWrapper = Ti.UI.createView({
        width: "100%",
        borderRadius: 0,
        height: "60dp",
        id: "mapWrapper"
    });
    $.__views.tripRequestedContainer.add($.__views.mapWrapper);
    $.__views.map = Ti.UI.createImageView({
        defaultImage: "/images/map_background.png",
        width: "100%",
        height: Ti.UI.SIZE,
        image: "/images/map_background.png",
        id: "map"
    });
    $.__views.mapWrapper.add($.__views.map);
    $.__views.actionsContainer = Ti.UI.createView({
        height: "100dp",
        bottom: "0",
        layout: "vertical",
        id: "actionsContainer"
    });
    $.__views.tripRequestedContainer.add($.__views.actionsContainer);
    $.__views.actionsBrief = Ti.UI.createLabel({
        color: "#666",
        font: {
            fontSize: "15dp"
        },
        height: "40dp",
        id: "actionsBrief"
    });
    $.__views.actionsContainer.add($.__views.actionsBrief);
    $.__views.actions = Ti.UI.createView({
        height: "60dp",
        id: "actions"
    });
    $.__views.actionsContainer.add($.__views.actions);
    $.__views.denyTripRequestButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#666",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        width: "45%",
        normalColor: "#00444444",
        selectedColor: "#70444444",
        backgroundColor: "#00444444",
        backgroundImage: "none",
        borderColor: "#444",
        borderWidth: Alloy.Globals.Style.Unit.unit1,
        height: "44dp",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        bottom: "10dp",
        indicatorStyle: Ti.UI.ActivityIndicatorStyle.DARK,
        left: "10dp",
        title: L("btn_no"),
        id: "denyTripRequestButton"
    });
    $.__views.actions.add($.__views.denyTripRequestButton);
    $.__views.approveTripRequestButton = require("/ui/common/custom_button").createButton({
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        indicator: "true",
        hideSubviewsWhenShowIndicator: "true",
        width: "45%",
        bottom: "10dp",
        right: "10dp",
        height: "44dp",
        title: L("btn_yes"),
        id: "approveTripRequestButton"
    });
    $.__views.actions.add($.__views.approveTripRequestButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var trackingEvent = require("/tracking/tracking_event"), analytics = require("/tracking/tracking_manager"), i18n = require("i18n/i18n"), args = arguments[0] || {}, utils = require("utils/utils"), moment = require("/vendor/moment"), css = require("/ui/css"), samantha = args.samantha, Globals = require("/v6/infrastructure/Globals"), bookingService = Globals.IOC.get("bookingService");
    exports = new (require("/carmalib/controller").extend($, {
        cardName: "tripRequestForRider",
        customAnimation: false,
        _isMyTripCollapsed: true,
        _isTripRequestCollapsed: false,
        _availableScreenHeight: 0,
        _isTripMatchDriver: false,
        _trip: null,
        _booking: null,
        _opening: false,
        _initialised: false,
        _openPopup: false,
        waitUntilReady: true,
        events: {
            "click[ios] mapWrapper": "_openMapEvent",
            "click[android] mapWrapper": "_openMapEvent",
            "click myTripMapWrapper": "_openMyMapEvent",
            "click[ios] denyTripRequestButton": "_declineBooking",
            "click[android] denyTripRequestButton": "_declineBooking",
            "click[ios] approveTripRequestButton": "_acceptBooking",
            "click[android] approveTripRequestButton": "_acceptBooking"
        },
        initialize: function() {
            _.bindAll(this, "_getNextBooking", "_renderBookingInfo", "_openMapEvent");
        },
        configure: function() {
            samantha.on("samantha.show.ErrorDialog", this._restoreButtonsState);
        },
        _restoreButtonsState: function() {
            $.approveTripRequestButton.stopIndicator();
            $.denyTripRequestButton.stopIndicator();
            $.approveTripRequestButton.applyProperties({
                touchEnabled: true
            });
            $.denyTripRequestButton.applyProperties({
                touchEnabled: true
            });
        },
        prepareView: function(options) {
            this._isMyTripCollapsed = true;
            this._isTripRequestCollapsed = false;
            $.layoutContainer.applyProperties({
                height: Ti.UI.SIZE
            });
            var trip = options.trip, dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment), myUserId = require("services/resource_owner_service").singleton().get("userId");
            $.date.text = dateMoment.format("Do MMM");
            $.myTripDepartureTime.setText(dateTime);
            $.myTripRole.setText(L("widget_decision_samantha_" + trip.type));
            $.myTripOrigin.setText(trip.origin.address);
            $.myTripDestination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            this._availableScreenHeight = options.availableScreenHeight;
            this._isTripMatchDriver = this._booking.rider.userId === myUserId;
            $.indicatorMessage.text = L(this._isTripMatchDriver ? "widget_samantha_trip_matched_driver" : "widget_samantha_trip_matched_rider");
            this._layoutTripMatch(this._isTripMatchDriver);
            trip.schedule.confirmed && this._markTripConfirmed();
            var mapHeight = this._calculateMapHeight(options.availableScreenHeight, false);
            $.mapWrapper.height = mapHeight + "dp";
            mapHeight = this._calculateMapHeight(options.availableScreenHeight, true);
            $.myTripMapWrapper.height = mapHeight + "dp";
            this._renderBookingInfo();
            this._restoreButtonsState();
            options.availableScreenHeight > 0 && $.containerWrapper.applyProperties({
                height: options.availableScreenHeight + "dp"
            });
            this._renderMap(trip, $.myTripMapWrapper, $.myTripMap);
            $.layoutContainer.applyProperties({
                height: "120dp"
            });
            $.tripMatchIndicator.show();
            this._initialised || (this._initialised = true);
            var self = this;
            if (!this._openPopup) {
                this._openPopup = true;
                setTimeout(function() {
                    self._openMatchPopup(options);
                }, 500);
            }
        },
        _openMatchPopup: function(options) {
            options.samanthaCard = this;
            options.samantha = samantha;
            var tripMatchPop = Alloy.createWidget("ma.car.app.samantha", "matchFoundPop", options);
            tripMatchPop.getView().open();
        },
        _layoutTripMatch: function(isDriver) {
            $.tripBriefContainerRightColumn.remove($.userPhoto);
            $.tripBriefContainerLeftColumn.add($.userPhoto);
            $.userPhoto.setPadding({
                align: "left"
            });
            $.userPhoto.applyProperties({
                left: null,
                right: null
            });
        },
        _animateInTripMatch: function() {},
        _animateTripRequest: function() {
            $.tripRequestedContainer.visible = true;
            $.indicatorMessage.animate({
                opacity: 1,
                duration: 300
            });
            return;
        },
        _markTripConfirmed: function() {
            css.setStyle($, {
                "#myTripBriefContainer": {
                    classes: "dark-blue-background",
                    "#myTripDepartureTime": "white",
                    "#myTripRole": "white",
                    "#myTripOrigin": "carmaCardText white",
                    "#myTripDestination": "carmaCardText white"
                },
                "#myTripActionsContainer": {
                    visible: false,
                    height: 0
                },
                "#downArrowWrapper": "dark-blue"
            });
        },
        finishDisplay: function() {
            this._animateInTripMatch();
            $.layoutContainer.show();
        },
        display: function(options, callback) {
            if (!options.trip) return;
            this._trip = options.trip;
            this._booking = options.booking;
            this.prepareView(options);
            callback && _.isFunction(callback) ? callback() : $.layoutContainer.show();
        },
        displayWithAnimation: function() {},
        disappear: function() {
            $.layoutContainer.hide();
            samantha.removeCard(this.cardName);
        },
        disappearWithAnimation: function() {},
        _calculateMapHeight: function(availableHeight, isMyTripMap) {
            if (!availableHeight) return;
            var mapHeight;
            mapHeight = isMyTripMap ? availableHeight - 2 * parseFloat($.myTripBriefContainer.height, 10) - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.myTripActionsContainer.height, 10) : availableHeight - parseFloat($.tripBriefContainer.height, 10) - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.myTripBriefContainer.height, 10) - parseFloat($.actionsContainer.height, 10);
            return mapHeight;
        },
        _loadBookingData: function() {
            require("/services/samantha_service").findBookings(false).then(this._getNextBooking).then(this._renderBookingInfo);
        },
        _getNextBooking: function(bookings) {
            var self = this;
            _.each(bookings.rideBookings, function(booking) {
                "AUTOMATIC" === booking.trigger && (!self._booking || booking.bookingDate < self._booking.bookingDate) && (self._booking = booking);
            });
        },
        _renderBookingInfo: function() {
            if (!Alloy.Globals.Map) return;
            if (!this._booking) return;
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = this._booking.rider.userId === myUserId ? this._booking.driver : this._booking.rider;
            var trip = this._booking.trip.ownerUid === myUserId ? this._booking.sourceTrip.baseTrip : this._booking.trip.baseTrip;
            var dateMoment = moment(trip.schedule.effectiveTime), dateTime = i18n.formatTime(dateMoment);
            $.matchedTripOwner.setText(dateTime + " - " + coordinator.alias);
            $.matchedTripOrigin.setText(trip.origin.address);
            $.matchedTripDestination.setText(String.format(L("widget_decision_samantha_destination"), trip.destination.address));
            $.actionsBrief.setText(String.format(L("widget_samantha_trip_request_note"), coordinator.alias));
            $.userPhoto.setUser(_.extend({}, coordinator, {
                layout: "circular-small"
            }));
            this._renderMap(trip, $.mapWrapper, $.map);
        },
        _renderMap: function(trip, mapWrapper, mapView) {
            var self = this;
            if (0 === parseFloat(mapWrapper.size.width)) {
                _.delay(function() {
                    self._renderMap(trip, mapWrapper, mapView);
                }, 2e3);
                return;
            }
            var mapWidth = mapWrapper.rect.width, mapHeight = parseFloat(mapWrapper.height), units = require("/platform/units");
            utils.createMapUrl(trip, units.pixelToDip(mapWidth), mapHeight).then(require("/utils/photoCache").getRemoteFile).then(function(localPath) {
                mapView.applyProperties({
                    height: mapHeight + "dp",
                    image: localPath
                });
            }).catch(function(e) {});
        },
        _openMyMapEvent: function(e) {
            if (!this._trip) return;
            samantha.whisper("samantha.open.map", {
                trip: this._trip
            });
        },
        _openMapEvent: function(e) {
            if (!this._booking) return;
            if (this.opening) return;
            this.opening = true;
            var self = this;
            setTimeout(function() {
                self.opening = false;
            }, 1e3);
            var myUserId = require("services/resource_owner_service").singleton().get("userId"), booking = this._booking, amIARider = booking.rider.userId === myUserId, requestedTrip = amIARider ? booking.trip.baseTrip : booking.sourceTrip.baseTrip;
            samantha.whisper("samantha.open.map", {
                trip: requestedTrip,
                dontUseTime: !amIARider
            });
        },
        _acceptBooking: function() {
            var requestor = this._booking[this._booking.initiator.toLowerCase()], myUserId = require("services/resource_owner_service").singleton().get("userId"), coordinator = this._booking.rider.userId === myUserId ? this._booking.driver : this._booking.rider;
            self = this;
            require("/services/samantha_service").acceptBooking(this._booking.id, requestor.alias).then(function() {
                self._openPopup = false;
                self._tripMatchPop(coordinator, self._booking.rider.userId === myUserId);
                Ti.App.fireEvent("carma:booking.changed");
                bookingService.emit(bookingService.BOOKING_UPDATED);
                TM.push(function() {
                    analytics.track(trackingEvent.SAMANTHA_TRIP_REQUEST_ACCEPTED_BY_RIDER, {
                        bookingId: self._booking.id
                    });
                }, process.backgroundDomain);
            }).catch(function(e) {
                self._restoreButtonsState();
                samantha.whisper("samantha.show.ErrorDialog", _.extend({
                    action: "USER_RIDE_BOOKING_ACCEPT"
                }, e));
            });
        },
        _tripMatchPop: function(profile, isDriver) {
            Alloy.createWidget("ma.car.app.samantha", "tripMatchPop", {
                profile: profile,
                isDriver: isDriver
            }).presentModalView({
                animated: true
            });
        },
        _declineBooking: function() {
            var requestor = this._booking[this._booking.initiator.toLowerCase()], self = this;
            require("/services/samantha_service").declineBooking(this._booking.id, requestor.alias).then(function() {
                self._openPopup = false;
                Ti.App.fireEvent("carma:booking.changed");
                bookingService.emit(bookingService.BOOKING_UPDATED);
                TM.push(function() {
                    analytics.track(trackingEvent.SAMANTHA_TRIP_REQUEST_DENIED_BY_RIDER, {
                        bookingId: self._booking.id
                    });
                }, process.backgroundDomain);
            }).catch(function(e) {
                self._restoreButtonsState();
                samantha.whisper("samantha.show.ErrorDialog", _.extend({
                    action: "USER_RIDE_BOOKING_CANCEL"
                }, e));
            });
        },
        _expandMyTrip: function() {
            if (!this._isMyTripCollapsed) return;
            css.setStyle($, {
                "#downArrowWrapper": "white"
            });
            this._isMyTripCollapsed = false;
            this._isTripRequestCollapsed = true;
            this._showTripRequestByCardType("simple");
            this._showMyTripByCardType("detailed");
            this._playBounceAnimation($.myTripContainer, 5);
        },
        _expandTripRequest: function() {
            if (!this._isTripRequestCollapsed) return;
            var colorClass = "white";
            this._trip.schedule.confirmed && (colorClass = "orange");
            css.setStyle($, {
                "#downArrowWrapper": colorClass
            });
            this._isMyTripCollapsed = true;
            this._isTripRequestCollapsed = false;
            this._showMyTripByCardType("simple");
            this._showTripRequestByCardType("detailed");
            this._playBounceAnimation($.tripRequestedContainer, 5);
        },
        _playBounceAnimation: function(element, extremePoint) {
            element.animate({
                top: extremePoint + "dp",
                duration: 100
            }, function() {
                element.applyProperties({
                    top: extremePoint + "dp"
                });
                element.animate({
                    top: 0,
                    duration: 100
                }, function() {
                    element.applyProperties({
                        top: 0
                    });
                });
            });
        },
        _showMyTripByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.myTripContainer.applyProperties({
                    height: "55dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: "60dp"
                });
            } else {
                var height = this._availableScreenHeight - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.tripRequestedContainer.height, 10) - 5;
                $.myTripContainer.applyProperties({
                    height: height + "dp"
                });
                $.myTripAwesomeAnimationContainer.applyProperties({
                    height: height + 5 + "dp"
                });
            }
        },
        _showTripRequestByCardType: function(type) {
            if (1 === type || "simple" === type) {
                $.matchedTripOwner.applyProperties({
                    top: 0,
                    height: 0,
                    visible: false
                });
                $.matchedTripOrigin.applyProperties({
                    top: "10dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "27dp"
                });
                $.tripRequestedContainer.applyProperties({
                    height: "55dp"
                });
                this._isTripMatchDriver && $.userPhoto.applyProperties({
                    visible: false,
                    touchEnabled: false
                });
            } else {
                $.matchedTripOwner.applyProperties({
                    top: "10dp",
                    height: Ti.UI.SIZE,
                    visible: true
                });
                $.matchedTripOrigin.applyProperties({
                    top: "27dp"
                });
                $.matchedTripDestination.applyProperties({
                    top: "45dp"
                });
                var height = this._availableScreenHeight - parseFloat($.tripMatchIndicator.height, 10) - parseFloat($.myTripContainer.height, 10) - 5;
                $.tripRequestedContainer.applyProperties({
                    height: height + "dp"
                });
                $.userPhoto.applyProperties({
                    visible: true,
                    touchEnabled: true
                });
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;