function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.share/" + s : s.substring(0, index) + "/ma.car.app.share/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.share");
    this.__widgetId = "ma.car.app.share";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.shareWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        navBarHidden: true,
        transparentBackground: true,
        opacity: 1,
        backgroundColor: "transparent",
        id: "shareWindow"
    });
    $.__views.shareWindow && $.addTopLevelView($.__views.shareWindow);
    $.__views.ShareContainer = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        visible: false,
        zIndex: 1,
        opacity: 1,
        transparentBackground: true,
        backgroundColor: "transparent",
        id: "ShareContainer"
    });
    $.__views.shareWindow.add($.__views.ShareContainer);
    $.__views.ShareContentBg = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "#CCCCCC",
        opacity: 1,
        id: "ShareContentBg"
    });
    $.__views.ShareContainer.add($.__views.ShareContentBg);
    $.__views.ShareContentContainer = Ti.UI.createView({
        top: 0,
        bottom: 0,
        width: "100%",
        height: "100%",
        id: "ShareContentContainer"
    });
    $.__views.ShareContainer.add($.__views.ShareContentContainer);
    $.__views.cancelArrow = Ti.UI.createView({
        left: 0,
        top: "0dp",
        height: "50dp",
        width: "70dp",
        visible: false,
        id: "cancelArrow"
    });
    $.__views.ShareContentContainer.add($.__views.cancelArrow);
    $.__views.cancelArrowLabel = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontWeight: "bold",
            fontSize: "24dp"
        },
        text: "h",
        left: "10dp",
        top: "0dp",
        height: "50dp",
        width: "60dp",
        id: "cancelArrowLabel"
    });
    $.__views.cancelArrow.add($.__views.cancelArrowLabel);
    $.__views.shareImageContainer = Ti.UI.createView({
        top: 0,
        width: "80%",
        height: "75%",
        id: "shareImageContainer"
    });
    $.__views.ShareContentContainer.add($.__views.shareImageContainer);
    $.__views.shareTripCardContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        backgroundColor: "#fff",
        layout: "vertical",
        visible: false,
        id: "shareTripCardContainer"
    });
    $.__views.shareImageContainer.add($.__views.shareTripCardContainer);
    $.__views.shareTripCardTopContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        backgroundColor: Alloy.Globals.Style.Color.Orange,
        id: "shareTripCardTopContainer"
    });
    $.__views.shareTripCardContainer.add($.__views.shareTripCardTopContainer);
    $.__views.tripShareTitile = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "20dp",
            fontWeight: "bold"
        },
        top: "10dp",
        id: "tripShareTitile"
    });
    $.__views.shareTripCardTopContainer.add($.__views.tripShareTitile);
    $.__views.tripShareDes = Ti.UI.createLabel({
        color: "#ffcc99",
        font: {
            fontSize: "15dp"
        },
        top: "4dp",
        text: L("widget_tripcard_share_des_msg"),
        id: "tripShareDes"
    });
    $.__views.shareTripCardTopContainer.add($.__views.tripShareDes);
    $.__views.profileImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "10dp",
        bottom: "10dp",
        width: "120dp",
        height: "120dp",
        borderRadius: Alloy.Globals.Style.Unit.unit60,
        id: "profileImage"
    });
    $.__views.shareTripCardTopContainer.add($.__views.profileImage);
    $.__views.tripHeaderImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        bottom: "4dp",
        id: "tripHeaderImage"
    });
    $.__views.shareTripCardContainer.add($.__views.tripHeaderImage);
    $.__views.tripMapImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        bottom: "10dp",
        id: "tripMapImage"
    });
    $.__views.shareTripCardContainer.add($.__views.tripMapImage);
    $.__views.__alloyId1078 = Ti.UI.createView({
        width: "100%",
        height: "60dp",
        layout: "horizontal",
        id: "__alloyId1078"
    });
    $.__views.shareTripCardContainer.add($.__views.__alloyId1078);
    $.__views.__alloyId1079 = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        left: "0dp",
        height: "60dp",
        width: "auto",
        image: "/images/ShareCarmaLogo.png",
        id: "__alloyId1079"
    });
    $.__views.__alloyId1078.add($.__views.__alloyId1079);
    $.__views.shareNoMatchesContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        layout: "vertical",
        visible: false,
        id: "shareNoMatchesContainer"
    });
    $.__views.shareImageContainer.add($.__views.shareNoMatchesContainer);
    $.__views.nomatchesImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        width: "100%",
        image: "/images/logo.png",
        id: "nomatchesImage"
    });
    $.__views.shareNoMatchesContainer.add($.__views.nomatchesImage);
    $.__views.shareInviteFriendsContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        visible: false,
        backgroundColor: "#fff",
        id: "shareInviteFriendsContainer"
    });
    $.__views.shareImageContainer.add($.__views.shareInviteFriendsContainer);
    $.__views.shareInviteFriendsTopContainer = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "vertical",
        backgroundColor: "#1FA086",
        id: "shareInviteFriendsTopContainer"
    });
    $.__views.shareInviteFriendsContainer.add($.__views.shareInviteFriendsTopContainer);
    $.__views.inviteFriendsTitile = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "20dp",
            fontWeight: "bold"
        },
        top: "10dp",
        id: "inviteFriendsTitile"
    });
    $.__views.shareInviteFriendsTopContainer.add($.__views.inviteFriendsTitile);
    $.__views.inviteFriendsDes = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "2dp",
        text: L("native_share_invite_friends_des"),
        id: "inviteFriendsDes"
    });
    $.__views.shareInviteFriendsTopContainer.add($.__views.inviteFriendsDes);
    $.__views.inviteFriendsProfileImage = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        top: "10dp",
        bottom: "10dp",
        width: "120dp",
        height: "120dp",
        borderRadius: Alloy.Globals.Style.Unit.unit60,
        id: "inviteFriendsProfileImage"
    });
    $.__views.shareInviteFriendsTopContainer.add($.__views.inviteFriendsProfileImage);
    $.__views.bannerContainer = Ti.UI.createView({
        top: "10dp",
        bottom: "10dp",
        width: "100%",
        height: Ti.UI.SIZE,
        layout: "composite",
        id: "bannerContainer"
    });
    $.__views.shareInviteFriendsContainer.add($.__views.bannerContainer);
    $.__views.banner = Ti.UI.createImageView({
        defaultImage: "/images/invite_banner.png",
        top: "10dp",
        left: "5dp",
        right: "5dp",
        height: "auto",
        image: "/images/invite_banner.png",
        id: "banner"
    });
    $.__views.bannerContainer.add($.__views.banner);
    $.__views.yourCode = Ti.UI.createLabel({
        color: "#333",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        top: "20dp",
        height: "20dp",
        id: "yourCode"
    });
    $.__views.bannerContainer.add($.__views.yourCode);
    $.__views.__alloyId1080 = Ti.UI.createView({
        width: "100%",
        height: "60dp",
        layout: "horizontal",
        id: "__alloyId1080"
    });
    $.__views.shareInviteFriendsContainer.add($.__views.__alloyId1080);
    $.__views.__alloyId1081 = Ti.UI.createImageView({
        defaultImage: "/images/none.png",
        left: "0dp",
        height: "60dp",
        width: "auto",
        image: "/images/ShareCarmaLogo.png",
        id: "__alloyId1081"
    });
    $.__views.__alloyId1080.add($.__views.__alloyId1081);
    $.__views.btnShareImage = require("/ui/common/custom_button").createButton({
        width: "90%",
        color: "#555",
        normalColor: "#ff6600",
        selectedColor: "#70444444",
        backgroundColor: "#ff6600",
        backgroundImage: "none",
        borderColor: "transparent",
        borderWidth: 0,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "44dp",
        bottom: "15dp",
        visible: false,
        title: "",
        id: "btnShareImage"
    });
    $.__views.ShareContentContainer.add($.__views.btnShareImage);
    $.__views.__alloyId1082 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId1082"
    });
    $.__views.btnShareImage.add($.__views.__alloyId1082);
    $.__views.__alloyId1083 = Ti.UI.createView({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        layout: "horizontal",
        id: "__alloyId1083"
    });
    $.__views.__alloyId1082.add($.__views.__alloyId1083);
    $.__views.lblShareImage = Ti.UI.createLabel({
        color: "#fff",
        width: Ti.UI.SIZE,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_share_choose_friends_button"),
        id: "lblShareImage"
    });
    $.__views.__alloyId1083.add($.__views.lblShareImage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, photoURL = require("/utils/photoURL"), avatarUtils = require("/ui/common/Avatar"), photoCache = require("/utils/photoCache");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click cancelArrow": "_closeShare",
            "click btnShareImage": "_handleShare"
        },
        _screenHeight: 0,
        _shareImageName: null,
        _imagePath: null,
        _shareContent: null,
        _shareSubject: null,
        _profile: null,
        _inviteId: 0,
        _PHOTO_WIDTH_DP: 120,
        initialize: function() {
            _.bindAll(this, "_startOpen", "_closeShare", "_handleShare");
            LOGGER.error("inti share widget!");
            this._screenHeight = require("utils/utils").pixelToDp(Ti.Platform.displayCaps.platformHeight);
            "tripCard" === args.type ? this._displayTripCardShare() : "nomatches" === args.type ? this._displayNoMatchesShare() : "invitefriends" === args.type && this._displayInviteFriendsShare();
            $.shareWindow.addAppEventListener("carma.share.success", this._closeShare);
        },
        onDestroy: function() {
            $.shareWindow.removeAppEventListener("carma.share.success", this._closeShare);
        },
        _displayInviteFriendsShare: function() {
            this._shareContent = L("native_share_invite_friends") + args.inviteCode + " " + require("bootstrap/env").getInviteURL() + args.inviteId;
            this._shareSubject = args.subject ? args.subject : L("native_share_invite_friends_subject");
            var profile = require("services/resource_owner_service").singleton().toJSON();
            this._profile = profile;
            $.inviteFriendsTitile.text = L("native_share_invite_friends_title");
            this._showUserPhoto(profile.photoUrl, $.inviteFriendsProfileImage);
            $.yourCode.text = args.inviteCode.toUpperCase();
            $.shareInviteFriendsContainer.visible = true;
            $.shareWindow.addEventListener("open", this._startOpen);
        },
        _displayNoMatchesShare: function() {
            $.shareNoMatchesContainer.visible = true;
            $.shareWindow.addEventListener("open", this._startOpen);
        },
        _displayTripCardShare: function() {
            this._shareContent = String.format(L("native_share_trip_card"), args.tripDate) + " " + require("bootstrap/env").getInviteURL() + args.inviteId;
            this._shareSubject = L("native_share_trip_card_subject");
            var profile = require("services/resource_owner_service").singleton().toJSON();
            this._profile = profile;
            $.tripShareTitile.text = String.format(L("widget_tripcard_share_title_msg"), profile.alias);
            this._showUserPhoto(profile.photoUrl, $.profileImage);
            $.tripHeaderImage.setImage(args.headerData);
            $.tripMapImage.setImage(args.mapData);
            $.shareTripCardContainer.visible = true;
            $.shareWindow.addEventListener("open", this._startOpen);
        },
        _showUserPhoto: function(image, profile) {
            var url = photoURL.toURL(image, {
                width: this._PHOTO_WIDTH_DP,
                height: this._PHOTO_WIDTH_DP
            });
            var photoPath = photoCache.getCached(url);
            if (photoPath) profile.image = photoPath; else {
                profile.image = avatarUtils.getDefaultPhoto(this._profile);
                photoCache.downloadAvatar(url).then(function(url) {
                    profile.image = url;
                });
            }
        },
        _startOpen: function() {
            $.shareWindow.removeEventListener("open", this._startOpen);
            var self = this;
            $.ShareContentBg.applyProperties({
                opacity: 1
            });
            $.ShareContentBg.opacity = 1;
            var matrix2d = Ti.UI.create2DMatrix();
            matrix2d = matrix2d.rotate(0);
            $.ShareContentContainer.applyProperties({
                top: "0dp",
                transform: matrix2d
            });
            $.ShareContentContainer.top = 0;
            $.shareImageContainer.top = this._screenHeight - 5 + "dp";
            $.ShareContainer.visible = true;
            $.shareImageContainer.animate({
                top: "20dp",
                duration: 500
            }, function() {
                $.shareImageContainer.animate({
                    top: "50dp",
                    duration: 300
                }, function() {
                    $.cancelArrow.visible = true;
                    $.btnShareImage.visible = true;
                    self._resizeImageContianer();
                });
            });
        },
        _closeShare: function() {
            var matrix2d = Ti.UI.create2DMatrix();
            matrix2d = matrix2d.rotate(45);
            $.ShareContentBg.animate({
                duration: 600,
                opacity: .05
            });
            $.ShareContentContainer.animate({
                duration: 600,
                top: this._screenHeight - 5 + "dp",
                transform: matrix2d
            }, function() {
                $.cancelArrow.visible = false;
                $.ShareContainer.visible = false;
                $.btnShareImage.visible = false;
                $.ShareContentBg.opacity = 1;
                var matrix2d = Ti.UI.create2DMatrix();
                matrix2d = matrix2d.rotate(0);
                $.ShareContentContainer.applyProperties({
                    top: 0,
                    transform: matrix2d
                });
                $.ShareContentContainer.top = 0;
                $.shareWindow.close();
            });
        },
        _resizeImageContianer: function() {
            "invitefriends" === args.type && $.shareInviteFriendsContainer.getSize().height > 0 && ($.shareImageContainer.height = $.shareInviteFriendsContainer.getSize().height);
            "tripCard" === args.type && $.shareTripCardContainer.getSize().height > 0 && ($.shareImageContainer.height = $.shareTripCardContainer.getSize().height);
        },
        _handleShare: function() {
            var imageData = $.shareImageContainer.toImage(null, true);
            var f = Titanium.Filesystem.getFile(Titanium.Filesystem.tempDirectory, "CarmaTripCard.png");
            f.write(imageData.media);
            this._imagePath = f.getNativePath();
            this._shareImageName = "CarmaTripCard.png";
            require("/ui/common/sharing").shareByNative(this._shareContent, this._shareImageName, this._imagePath, this._shareSubject);
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;