function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.signup/" + s : s.substring(0, index) + "/ma.car.app.signup/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.signup");
    this.__widgetId = "ma.car.app.signup";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.signupWindow = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        navBarHidden: true,
        windowSoftInputMode: Alloy.Globals.Style.KeyboardStateResize,
        id: "signupWindow"
    });
    $.__views.signupWindow && $.addTopLevelView($.__views.signupWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var navigation = Alloy.Globals.Nav.Signup = Alloy.createController("navigation");
    $.signupWindow.addEventListener("close", function closeHandler() {
        $.signupWindow.removeEventListener("close", closeHandler);
        Alloy.Globals.Nav.Signup = null;
    });
    navigation.init({
        index: Alloy.createWidget("ma.car.app.signup", "signup"),
        historyLimit: 20,
        mainWindow: $.signupWindow,
        coverImage: "/images/background.png",
        title: L("widget_signup_title_signup"),
        theme: "white"
    });
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;