function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "card_form";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.formWrapper = Ti.UI.createView({
        width: "100%",
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "formWrapper"
    });
    $.__views.formWrapper && $.addTopLevelView($.__views.formWrapper);
    $.__views.addCardTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        height: "auto",
        text: L("widget_stripe_add_card_title"),
        id: "addCardTitle"
    });
    $.__views.formWrapper.add($.__views.addCardTitle);
    $.__views.__alloyId706 = Ti.UI.createView({
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        top: "20dp",
        layout: "vertical",
        height: Ti.UI.SIZE,
        borderColor: "#a4a4a4",
        borderWidth: "1px",
        id: "__alloyId706"
    });
    $.__views.formWrapper.add($.__views.__alloyId706);
    $.__views.firstName = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: 0,
        width: "100%",
        hintText: L("widget_signup_input_hint_first_name"),
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "firstName"
    });
    $.__views.__alloyId706.add($.__views.firstName);
    $.__views.__alloyId707 = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#a4a4a4",
        id: "__alloyId707"
    });
    $.__views.__alloyId706.add($.__views.__alloyId707);
    $.__views.lastName = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: 0,
        width: "100%",
        hintText: L("widget_signup_input_hint_last_name"),
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        id: "lastName"
    });
    $.__views.__alloyId706.add($.__views.lastName);
    $.__views.__alloyId708 = Ti.UI.createView({
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        top: "20dp",
        layout: "vertical",
        height: Ti.UI.SIZE,
        borderColor: "#a4a4a4",
        borderWidth: "1px",
        id: "__alloyId708"
    });
    $.__views.formWrapper.add($.__views.__alloyId708);
    $.__views.cardNum = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: 0,
        width: "100%",
        hintText: L("widget_stripe_credit_card_number"),
        keyboardType: Ti.UI.KEYBOARD_NUMBER_PAD,
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        maxLength: 16,
        id: "cardNum"
    });
    $.__views.__alloyId708.add($.__views.cardNum);
    $.__views.__alloyId709 = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#a4a4a4",
        id: "__alloyId709"
    });
    $.__views.__alloyId708.add($.__views.__alloyId709);
    $.__views.__alloyId710 = Ti.UI.createView({
        top: 0,
        backgroundColor: "#fff",
        height: Ti.UI.SIZE,
        id: "__alloyId710"
    });
    $.__views.__alloyId708.add($.__views.__alloyId710);
    $.__views.expiry = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: 0,
        color: "#aaa",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: 0,
        width: "50%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        hintText: L("widget_stripe_card_expiry_hinttext"),
        keyboardType: Ti.UI.KEYBOARD_NUMBER_PAD,
        maxLength: 5,
        id: "expiry"
    });
    $.__views.__alloyId710.add($.__views.expiry);
    $.__views.__alloyId711 = Ti.UI.createView({
        top: 0,
        left: "50%",
        width: "1px",
        backgroundColor: "#a4a4a4",
        height: "60dp",
        zIndex: 10,
        id: "__alloyId711"
    });
    $.__views.__alloyId710.add($.__views.__alloyId711);
    $.__views.cVV = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: "50%",
        width: "50%",
        hintText: "CVV",
        keyboardType: Ti.UI.KEYBOARD_NUMBER_PAD,
        returnKeyType: Ti.UI.RETURNKEY_NEXT,
        maxLength: 4,
        id: "cVV"
    });
    $.__views.__alloyId710.add($.__views.cVV);
    $.__views.saveMyCard = Ti.UI.createView({
        top: "10dp",
        left: 0,
        height: "50dp",
        id: "saveMyCard"
    });
    $.__views.formWrapper.add($.__views.saveMyCard);
    $.__views.saveMyCardCheckBox = Ti.UI.createView({
        top: "10dp",
        left: 0,
        width: "20dp",
        height: "20dp",
        zIndex: 3,
        borderColor: Alloy.Globals.Style.Color.LightBlue,
        borderWidth: "2dp",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        id: "saveMyCardCheckBox"
    });
    $.__views.saveMyCard.add($.__views.saveMyCardCheckBox);
    $.__views.saveMyCardTicker = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontFamily: "splinico",
            fontSize: "14dp"
        },
        text: "c",
        top: "10dp",
        left: "3dp",
        width: "20dp",
        height: "20dp",
        visible: false,
        zIndex: 5,
        id: "saveMyCardTicker"
    });
    $.__views.saveMyCard.add($.__views.saveMyCardTicker);
    $.__views.saveMyCardHint = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        top: "10dp",
        left: "30dp",
        width: Alloy.Globals.Style.Size.Width.pct70,
        text: L("widget_stripe_save_dard_details"),
        id: "saveMyCardHint"
    });
    $.__views.saveMyCard.add($.__views.saveMyCardHint);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, FieldsRoller = require("/ui/common/fields_roller"), ErrorDialog = require("/ui/common/validation_error"), Validator = require("/validator/validator_factory"), pickerDateController = require(WPATH("/pickerDateController")), moment = require("/vendor/moment"), ui = require("utils/ui");
    exports = new (require("/carmalib/controller").extend($, {
        _isSaveCardDetails: false,
        _prevExpiryValue: "",
        events: {
            "click[ios] profileOuterContainer": "_blurFields",
            "click[android] profileOuterContainer": "_blurFields",
            "click[ios] saveMyCard": "_selectSaveMyCard",
            "click[android] saveMyCard": "_selectSaveMyCard",
            "click[ios] expiry": "_showDatePicker",
            "focus[android] expiry": "_expiryFieldFocused",
            "blur[android] expiry": "_expiryFieldBlured",
            "change[android] expiry": "_expiryFieldChange",
            "change cVV": "_filterCVVField"
        },
        initialize: function() {
            _.bindAll(this, "_showDatePicker", "getFieldValues");
            this._setupFieldsRoller();
            args && args.saveCard && $.saveMyCard.applyProperties({
                visible: false,
                height: 0
            });
        },
        getFieldValues: function() {
            var date = $.expiry.value.split("/"), month = parseInt(date[0], 10), year = parseInt(date[1], 10);
            2 === year.length && (year = moment(year, "YY").year());
            return {
                number: $.cardNum.value,
                exp_month: month,
                exp_year: year,
                name: $.firstName.value + $.lastName.value,
                cvc: $.cVV.value,
                storePaymentDetails: this._isSaveCardDetails
            };
        },
        _setupFieldsRoller: function() {
            new FieldsRoller([ {
                from: $.firstName,
                to: $.lastName
            }, {
                from: $.lastName,
                to: $.cardNum
            }, {
                from: $.cardNum,
                to: $.expiry,
                next: null
            }, {
                from: $.expiry,
                to: $.cVV
            } ]);
        },
        _createExpiryYearsArray: function() {
            var currentTime = new Date(), year = currentTime.getFullYear(), expiryYears = [];
            expiryYears.push(year.toString());
            for (var i = 0; 10 >= i; i++) {
                ++year;
                expiryYears.push(year.toString());
            }
            return expiryYears;
        },
        _showDatePicker: function() {
            this.blurFields({
                source: "justblur"
            });
            var data = {
                0: [ "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12" ],
                1: this._createExpiryYearsArray()
            };
            var parentWindow = ui.getWindow($.formWrapper);
            var picker = new pickerDateController(parentWindow, data, {
                selectedIndex: this._getSelectedIndex()
            });
            picker.addEventListener("change", function(data) {
                $.expiry.applyProperties({
                    color: "#666",
                    value: data.value[0] + "/" + data.value[1]
                });
            });
            picker.show();
        },
        _getSelectedIndex: function() {
            if (!$.expiry.value) return [ 0, 0 ];
            var date = $.expiry.value.split("/"), month = date[0], year = date[1];
            var monthArray = [ "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12" ], yearArray = this._createExpiryYearsArray();
            var selectedIndex = [];
            selectedIndex.push(monthArray.indexOf(month));
            selectedIndex.push(yearArray.indexOf(year));
            return selectedIndex;
        },
        _selectSaveMyCard: function() {
            if (this._isSaveCardDetails) {
                this._isSaveCardDetails = false;
                $.saveMyCardCheckBox.backgroundColor = "transparent";
                $.saveMyCardTicker.visible = false;
            } else {
                $.saveMyCardTicker.visible = true;
                $.saveMyCardCheckBox.backgroundColor = "#fff";
                this._isSaveCardDetails = true;
            }
        },
        validateAddCard: function() {
            this._clearError();
            if (!Ti.Network.online) {
                Ti.UI.createAlertDialog({
                    message: L("widget_signup_error_offline")
                }).show();
                return false;
            }
            var isValidSignup = !Validator.form().checkCustomTextFieldsEmpty([ $.firstName, $.lastName, $.cardNum, $.cVV ]);
            var expiryValue = $.expiry.value;
            isValidSignup = isValidSignup && this._validateExpiryDate(expiryValue);
            if (!isValidSignup) {
                ErrorDialog.show();
                return false;
            }
            return true;
        },
        _clearError: function() {
            $.firstName.clearError();
            $.lastName.clearError();
            $.cardNum.clearError();
            $.cVV.clearError();
            "" === $.expiry.value && $.expiry.applyProperties({
                color: "#aaa"
            });
        },
        blurFields: function(e) {
            if (e && e.source && "firstName" !== e.source.id && "lastName" !== e.source.id && "cardNum" !== e.source.id && "cVV" !== e.source.id && "expiry" !== e.source.id) {
                $.firstName.blur();
                $.lastName.blur();
                $.cardNum.blur();
                $.cVV.blur();
                $.expiry.blur();
                Ti.UI.Android.hideSoftKeyboard();
            }
        },
        _expiryFieldFocused: function() {
            $.expiry.applyProperties({
                hintText: L("widget_stripe_card_expiry_mmyy"),
                value: ""
            });
        },
        _expiryFieldBlured: function() {
            $.expiry.value || $.expiry.hintText !== L("widget_stripe_card_expiry_mmyy") || ($.expiry.hintText = L("widget_stripe_card_expiry_hinttext"));
        },
        _expiryFieldChange: function() {
            var value = $.expiry.value, modified = false;
            if (2 === value.length && 3 !== this._prevExpiryValue.length) {
                "/" === value.slice(-1) ? value = "0" + value : value += "/";
                modified = true;
            } else if (value.length >= 3 && "/" !== value.substr(2, 1) && -1 === value.indexOf("/")) {
                value = value.substr(0, 2) + "/" + value.substr(2);
                modified = true;
            }
            this._prevExpiryValue = value;
            if (modified) {
                $.expiry.value = value;
                $.expiry.setSelection(value.length, value.length);
            }
            this._validateExpiryDate(value) && $.cVV.focus();
        },
        _validateExpiryDate: function(value) {
            if (value.length < 5) return;
            var validation = this._checkFormat(value) && this._validateDate(value);
            validation && ($.expiry.color = "#666");
            return validation;
        },
        _checkFormat: function(value) {
            var regexpFormat = /^[0-9]{1,2}\/[0-9]{1,2}$/;
            if (!value.match(regexpFormat)) {
                $.expiry.color = "red";
                return false;
            }
            return true;
        },
        _validateDate: function(value) {
            var fields = value.split("/"), month = parseInt(fields[0], 10), year = "" + moment(parseInt(fields[1], 10), "YY").year(), validYearsArray = this._createExpiryYearsArray();
            if (0 >= month || month > 12) {
                $.expiry.color = "red";
                return false;
            }
            if (-1 === _.indexOf(validYearsArray, year, true)) {
                $.expiry.color = "red";
                return false;
            }
            year = parseInt(year, 10);
            var currentYear = new Date().getFullYear(), currentMonth = new Date().getMonth() + 1;
            if (currentYear > year || currentYear === year && currentMonth > month) {
                $.expiry.color = "red";
                return false;
            }
            return true;
        },
        _filterCVVField: require("/bootstrap/patch").debounce(function() {
            var value = $.cVV.value;
            $.cVV.value = value.replace(/\D/g, "");
            $.cVV.setSelection(value.length, value.length);
        }, 250)
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;