function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "cash_out";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.cashOutContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        top: 0,
        left: 0,
        height: "100%",
        id: "cashOutContainer"
    });
    $.__views.cashOutContainer && $.addTopLevelView($.__views.cashOutContainer);
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        height: "100%",
        width: "100%",
        id: "scrollView"
    });
    $.__views.cashOutContainer.add($.__views.scrollView);
    $.__views.__alloyId712 = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        top: 0,
        layout: "vertical",
        height: Ti.UI.SIZE,
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "transparent",
        id: "__alloyId712"
    });
    $.__views.scrollView.add($.__views.__alloyId712);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: "#ff6600",
        font: {
            fontSize: "36dp"
        },
        width: "100%",
        height: "auto",
        textAlign: "center",
        id: "totalBalance"
    });
    $.__views.__alloyId712.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        height: "auto",
        textAlign: "center",
        id: "balanceDetails"
    });
    $.__views.__alloyId712.add($.__views.balanceDetails);
    $.__views.balanceHr = Ti.UI.createView({
        top: "20dp",
        width: "100%",
        height: "2px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "balanceHr"
    });
    $.__views.__alloyId712.add($.__views.balanceHr);
    $.__views.cashingOutDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "15dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: L("widget_stripe_payments_cashing_out_details"),
        id: "cashingOutDetails"
    });
    $.__views.__alloyId712.add($.__views.cashingOutDetails);
    $.__views.cashOut = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "100%",
        top: "15dp",
        title: L("widget_stripe_payments_cash_out_title"),
        id: "cashOut"
    });
    $.__views.__alloyId712.add($.__views.cashOut);
    $.__views.howWorksDescripTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        width: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        top: "20dp",
        text: L("widget_stripe_payments_cash_out_descrip_title"),
        id: "howWorksDescripTitle"
    });
    $.__views.__alloyId712.add($.__views.howWorksDescripTitle);
    $.__views.howWorkDetailsOne = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        width: "100%",
        text: L("widget_stripe_payments_how_work_details_one"),
        id: "howWorkDetailsOne"
    });
    $.__views.__alloyId712.add($.__views.howWorkDetailsOne);
    $.__views.howWorkDetailsTwo = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        top: "5dp",
        width: "100%",
        text: L("widget_stripe_payments_how_work_details_two"),
        id: "howWorkDetailsTwo"
    });
    $.__views.__alloyId712.add($.__views.howWorkDetailsTwo);
    $.__views.howWorkEMail = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        top: "5dp",
        width: "100%",
        text: L("widget_stripe_payments_how_work_email"),
        id: "howWorkEMail"
    });
    $.__views.__alloyId712.add($.__views.howWorkEMail);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var popupWindow = require("/ui/common/popupWindow");
    exports = new (require("/carmalib/controller").extend($, {
        _profile: null,
        events: {
            "click howWorkEMail": "_onShowEmail",
            "click[ios] cashOut": "_cashOutAction",
            "click[android] cashOut": "_cashOutAction"
        },
        initialize: function() {
            _.bindAll(this, "showCashout", "_cashOutError", "_cashOutSuccess", "_cashOutAction", "_onShowEmail");
        },
        _onShowEmail: function() {
            var url = "mailto:" + $.howWorkEMail.text;
            Ti.API.info("EMAIL " + url);
            Ti.Platform.openURL(url);
        },
        showCashout: function(profile) {
            this._profile = profile;
            this._showMyCreditBalance(profile.creditBalance, profile.credit);
        },
        _showMyCreditBalance: function(creditBalance, credit) {
            if (creditBalance && 0 !== creditBalance.length) {
                var balance = creditBalance, currencySymbol = balance.currencySymbol, totalBalance = parseFloat(balance.totalBalance).toFixed(2), payableBalance = parseFloat(balance.payableBalance).toFixed(2), bonusBalance = parseFloat(balance.bonusBalance).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_details"), currencySymbol, payableBalance, bonusBalance);
            } else {
                var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = "";
            }
        },
        _cashOutAction: function() {
            var preferredCurrency = "USD";
            var userPreferences = require("services/cached_preferences_service").singleton();
            userPreferences.getPreferredCurrency() && (preferredCurrency = userPreferences.getPreferredCurrency());
            var featureToggleName = "minCashOut." + preferredCurrency;
            var minPayableAmount = require("featuretoggles/featuretoggles").getValue(featureToggleName);
            null == minPayableAmount && (minPayableAmount = 10);
            var balance = this._profile.creditBalance, payableBalance = parseFloat(balance.payableBalance, 10);
            if (minPayableAmount > payableBalance) {
                Ti.UI.createAlertDialog({
                    title: L("error_title"),
                    message: String.format(L("widget_stripe_payments_no_payable_credit_perc"), minPayableAmount + "")
                }).show();
                return;
            }
            this._startSpinner();
            Alloy.createModel("credit_withdrawal").cashOut().then(this._cashOutSuccess).catch(this._cashOutError);
        },
        _cashOutSuccess: function() {
            LOGGER.info("[cash out] success");
            var callback = function() {
                Alloy.Globals.Nav.Profile.back();
            };
            this._stopSpinner();
            new popupWindow().show(true, L("widget_stripe_payments_cash_out_great"), {
                callback: callback,
                details: L("widget_stripe_payments_cash_out_success")
            });
        },
        _cashOutError: function(e) {
            LOGGER.info("[cash out] erro is" + e.description);
            this._stopSpinner();
            new popupWindow().show(false, L("widget_stripe_payments_cash_out_sorry"));
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;