function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.stripePayments/" + s : s.substring(0, index) + "/ma.car.app.stripePayments/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.stripePayments");
    this.__widgetId = "ma.car.app.stripePayments";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.stripeWrapper = Ti.UI.createView({
        width: "100%",
        height: "100%",
        left: 0,
        top: 0,
        id: "stripeWrapper"
    });
    $.__views.stripeWrapper && $.addTopLevelView($.__views.stripeWrapper);
    $.__views.stripeList = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "100%",
        top: 0,
        layout: "vertical",
        backgroundColor: "transparent",
        id: "stripeList"
    });
    $.__views.stripeWrapper.add($.__views.stripeList);
    $.__views.totalBalance = Ti.UI.createLabel({
        color: "#ff6600",
        font: {
            fontSize: "36dp"
        },
        textAlign: "center",
        id: "totalBalance"
    });
    $.__views.stripeList.add($.__views.totalBalance);
    $.__views.balanceDetails = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        height: "auto",
        textAlign: "center",
        id: "balanceDetails"
    });
    $.__views.stripeList.add($.__views.balanceDetails);
    $.__views.topUp = require("/ma.car.app.profile/tactile_row").createView({
        top: "20dp",
        left: 0,
        width: "100%",
        height: "65dp",
        id: "topUp"
    });
    $.__views.stripeList.add($.__views.topUp);
    $.__views.__alloyId715 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "20dp",
        left: "10dp",
        text: L("widget_stripe_payments_top_up_title"),
        id: "__alloyId715"
    });
    $.__views.topUp.add($.__views.__alloyId715);
    $.__views.__alloyId716 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "24dp",
        right: 0,
        id: "__alloyId716"
    });
    $.__views.topUp.add($.__views.__alloyId716);
    $.__views.__alloyId717 = Ti.UI.createView({
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        width: "100%",
        id: "__alloyId717"
    });
    $.__views.stripeList.add($.__views.__alloyId717);
    $.__views.cashOut = require("/ma.car.app.profile/tactile_row").createView({
        top: 0,
        left: 0,
        width: "100%",
        height: "65dp",
        id: "cashOut"
    });
    $.__views.stripeList.add($.__views.cashOut);
    $.__views.__alloyId718 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "20dp",
        left: "10dp",
        text: L("widget_stripe_payments_cash_out_title"),
        id: "__alloyId718"
    });
    $.__views.cashOut.add($.__views.__alloyId718);
    $.__views.__alloyId719 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "24dp",
        right: 0,
        id: "__alloyId719"
    });
    $.__views.cashOut.add($.__views.__alloyId719);
    $.__views.__alloyId720 = Ti.UI.createView({
        left: 0,
        height: "1px",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        width: "100%",
        id: "__alloyId720"
    });
    $.__views.stripeList.add($.__views.__alloyId720);
    $.__views.myCard = require("/ma.car.app.profile/tactile_row").createView({
        top: 0,
        left: 0,
        width: "100%",
        height: "65dp",
        id: "myCard"
    });
    $.__views.stripeList.add($.__views.myCard);
    $.__views.__alloyId721 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: "20dp",
        left: "10dp",
        text: L("widget_stripe_payments_my_card_title"),
        id: "__alloyId721"
    });
    $.__views.myCard.add($.__views.__alloyId721);
    $.__views.__alloyId722 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "18dp"
        },
        text: "d",
        top: "24dp",
        right: 0,
        id: "__alloyId722"
    });
    $.__views.myCard.add($.__views.__alloyId722);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var navigation = Alloy.Globals.Nav.Profile, args = arguments[0] || {}, ui = require("/utils/ui"), parentWindow = TABS_HELPER.isUsingNativeTabs() ? TABS_HELPER.rootWindow() : ui.getWindow(args.__parentSymbol), appSound = require("/utils/appSound"), Globals = require("/v6/infrastructure/Globals"), ProfileService = Globals.IOC.get("ProfileService");
    exports = new (require("/carmalib/controller").extend($, {
        _rowsIds: [ "rating", "groups", "favourites", "rides" ],
        _profile: null,
        _topupWidget: null,
        _promoCodeWidget: null,
        _cashOutWidget: null,
        _myCardWidget: null,
        events: {
            "click[ios] topUp": "_handleMyCreditAction",
            "click[ios] cashOut": "_handleCashOutAction",
            "click[ios] myCard": "_handleMyCardAction",
            "click[android] topUp": "_handleMyCreditAction",
            "click[android] cashOut": "_handleCashOutAction",
            "click[android] myCard": "_handleMyCardAction"
        },
        _refreshMyProfile: function(profile) {
            this._profile = profile;
            var resourceOwner = require("/services/resource_owner_service").singleton();
            var myUserId = resourceOwner.get("userId");
            profile.userId === myUserId && this._showMyCreditBalance(profile.creditBalance, profile.credit);
        },
        initialize: function() {
            _.bindAll(this, "showProfile", "_refreshBalance", "_refreshProfile", "_refreshMyProfile", "_updateMyProfile");
            parentWindow.addAppEventListener("app.carma.profile.change", this._refreshMyProfile);
        },
        showProfile: function(profile) {
            this._profile = profile;
            this._showMyCreditBalance(profile.creditBalance, profile.credit);
            parentWindow.addAppEventListener("paymentRefreshBalance", this._refreshBalance);
            parentWindow.addAppEventListener("paymentRefreshProfile", this._refreshProfile);
        },
        _updateMyProfile: function() {
            this._profile = ProfileService.getCachedProfile(this._profile.userId);
        },
        _refreshProfile: function(option) {
            this._profile = option.profile;
        },
        _refreshBalance: function(option) {
            var self = this;
            if (!this._profile || !this._profile.creditBalance) return;
            _.delay(function() {
                appSound.play("recharge");
                var cashBalance = "cashBalance" in option ? true : false, addBalance = cashBalance ? parseInt(option.cashBalance, 10) : parseInt(option.bonusBalance, 10), step = addBalance / 10, counter = 0;
                var currentCredit = parseFloat(self._profile.credit.toFixed(2), 10), balance = self._profile.creditBalance, currentBonusBalance = parseFloat(balance.bonusBalance.toFixed(2), 10), currentPayableBalance = parseFloat(balance.payableBalance.toFixed(2), 10), currencySymbol = balance.currencySymbol, totalBalanceString = L("widget_profile_summary_balance_total"), detailsString = L("widget_profile_summary_balance_details");
                var updateCredit = function() {
                    if (addBalance > counter) {
                        counter += step;
                        var total = currentCredit + counter, newPayable = cashBalance ? currentPayableBalance + counter : currentPayableBalance, newBonus = cashBalance ? currentBonusBalance : currentBonusBalance + counter;
                        ProfileService.updateCredit(self._profile.userId, total, newPayable, newBonus);
                        $.totalBalance.text = String.format(totalBalanceString, currencySymbol, total.toFixed(2));
                        $.balanceDetails.text = String.format(detailsString, currencySymbol, newPayable.toFixed(2), newBonus.toFixed(2));
                    } else {
                        clearInterval(interval);
                        Ti.App.fireEvent("profileWidgetReloadProfile");
                    }
                };
                var interval = setInterval(updateCredit, 100);
            }, 500);
        },
        _showMyCreditBalance: function(creditBalance, credit) {
            if (creditBalance) {
                var currencySymbol = creditBalance.currencySymbol, totalBalance = parseFloat(creditBalance.totalBalance).toFixed(2), payableBalance = parseFloat(creditBalance.payableBalance).toFixed(2), bonusBalance = parseFloat(creditBalance.bonusBalance).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = String.format(L("widget_profile_summary_balance_details"), currencySymbol, payableBalance, bonusBalance);
            } else {
                var currencySymbol = "$", totalBalance = parseFloat(credit).toFixed(2);
                $.totalBalance.text = String.format(L("widget_profile_summary_balance_total"), currencySymbol, totalBalance);
                $.balanceDetails.text = "";
            }
        },
        _handleMyCreditAction: function() {
            this._topupWidget = this._topupWidget || Alloy.createWidget("ma.car.app.stripePayments", "topup", {
                __parentSymbol: parentWindow
            });
            navigation.open(this._topupWidget);
            this._topupWidget.showTopup(this._profile);
        },
        _handleCashOutAction: function() {
            this._cashOutWidget = this._cashOutWidget || Alloy.createWidget("ma.car.app.stripePayments", "cash_out", {
                __parentSymbol: parentWindow
            });
            navigation.open(this._cashOutWidget);
            this._cashOutWidget.showCashout(this._profile);
        },
        _handleMyCardAction: function() {
            this._myCardWidget = this._myCardWidget || Alloy.createWidget("ma.car.app.stripePayments", "my_card", {
                __parentSymbol: parentWindow
            });
            navigation.open(this._myCardWidget);
            this._myCardWidget.showMyCards(this._profile);
        },
        onOpened: function() {
            navigation.hideEditButton();
        },
        onDestroy: function() {
            parentWindow.removeAppEventListener("paymentRefreshBalance", this._refreshBalance);
            parentWindow.removeAppEventListener("paymentRefreshProfile", this._refreshProfile);
            parentWindow.removeAppEventListener("app.carma.profile.change", this._refreshMyProfile);
        },
        _openWebViewPage: function(path) {
            Alloy.createController("shell", {
                path: path
            }).getView().open();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;