function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tabgroup/" + s : s.substring(0, index) + "/ma.car.app.tabgroup/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tabgroup");
    this.__widgetId = "ma.car.app.tabgroup";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "home";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.layout = Ti.UI.createView({
        top: 0,
        left: 0,
        layout: "vertical",
        id: "layout"
    });
    $.__views.layout && $.addTopLevelView($.__views.layout);
    $.__views.top = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: 0,
        id: "top"
    });
    $.__views.layout.add($.__views.top);
    $.__views.homeScrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        top: 0,
        left: 0,
        width: "100%",
        layout: "vertical",
        scrollType: "vertical",
        backgroundColor: "transparent",
        needPullRefresh: true,
        id: "homeScrollView"
    });
    $.__views.layout.add($.__views.homeScrollView);
    $.__views.locationCardContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: 0,
        visible: true,
        id: "locationCardContainer"
    });
    $.__views.homeScrollView.add($.__views.locationCardContainer);
    $.__views.locationCard = Alloy.createWidget("ma.car.app.locationcard", "widget", {
        id: "locationCard",
        __parentSymbol: $.__views.locationCardContainer
    });
    $.__views.locationCard.setParent($.__views.locationCardContainer);
    $.__views.tripCardContainer = Ti.UI.createView({
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE,
        visible: true,
        id: "tripCardContainer"
    });
    $.__views.homeScrollView.add($.__views.tripCardContainer);
    $.__views.tripCard = Alloy.createWidget("ma.car.app.tripcard", "widget", {
        id: "tripCard",
        __parentSymbol: $.__views.tripCardContainer
    });
    $.__views.tripCard.setParent($.__views.tripCardContainer);
    $.__views.samanthaContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE,
        visible: true,
        id: "samanthaContainer"
    });
    $.__views.homeScrollView.add($.__views.samanthaContainer);
    $.__views.samantha = Alloy.createWidget("ma.car.app.samantha", "widget", {
        id: "samantha",
        __parentSymbol: $.__views.samanthaContainer
    });
    $.__views.samantha.setParent($.__views.samanthaContainer);
    $.__views.activityFeed = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE,
        visible: false,
        id: "activityFeed"
    });
    $.__views.homeScrollView.add($.__views.activityFeed);
    $.__views.nearbyActivity = Alloy.createWidget("ma.car.app.activity", "widget", {
        id: "nearbyActivity",
        __parentSymbol: $.__views.activityFeed
    });
    $.__views.nearbyActivity.setParent($.__views.activityFeed);
    $.__views.completenessCardContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE,
        visible: false,
        id: "completenessCardContainer"
    });
    $.__views.homeScrollView.add($.__views.completenessCardContainer);
    $.__views.completenessCard = Alloy.createWidget("ma.car.app.carmaCompleteness", "widget", {
        id: "completenessCard",
        __parentSymbol: $.__views.completenessCardContainer
    });
    $.__views.completenessCard.setParent($.__views.completenessCardContainer);
    $.__views.inviteContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE,
        visible: false,
        id: "inviteContainer"
    });
    $.__views.homeScrollView.add($.__views.inviteContainer);
    $.__views.inviteCard = Alloy.createWidget("ma.car.app.invites", "inviteCard", {
        id: "inviteCard",
        __parentSymbol: $.__views.inviteContainer
    });
    $.__views.inviteCard.setParent($.__views.inviteContainer);
    $.__views.tipsCardContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: Ti.UI.SIZE,
        visible: false,
        id: "tipsCardContainer"
    });
    $.__views.homeScrollView.add($.__views.tipsCardContainer);
    $.__views.tipsCard = Alloy.createWidget("ma.car.app.helpcard", "widget", {
        id: "tipsCard",
        __parentSymbol: $.__views.tipsCardContainer
    });
    $.__views.tipsCard.setParent($.__views.tipsCardContainer);
    $.__views.bottom = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "40dp",
        visible: true,
        id: "bottom"
    });
    $.__views.homeScrollView.add($.__views.bottom);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var Controller = require("/v6/infrastructure/Controller"), ui = require("/utils/ui");
    var HomeController = function($, args, TripService, BookingService) {
        args = args[0] || {};
        var parentWindow = ui.getWindow(args.__parentSymbol) || TABS_HELPER.rootWindow();
        return {
            _samanthaScreenHeightOptions: null,
            _txtagCardHeight: 0,
            events: {
                "click[ios] txtagCardNo": "_dismissCard",
                "click[ios] txtagCardYes": "_openProfile",
                "click[android] txtagCardNo": "_dismissCard",
                "click[android] txtagCardYes": "_openProfile"
            },
            initialize: function() {
                _.bindAll(this, "_updateHomeScreenElements", "_updateSamanthaContent", "_showCard", "_showTripCard", "_tripCardHidden", "_cardsShowed", "_samanthaHidden");
                this._initEventListeners();
                this._updateHomeScreenElements();
            },
            _initEventListeners: function() {
                parentWindow.addAppEventListener("carma:feature.toggles", this._updateHomeScreenElements);
                parentWindow.addAppEventListener("carma:initialized", this._updateSamanthaContent);
                parentWindow.addAppEventListener("carma:booking.changed", this._updateSamanthaContent);
                parentWindow.addAppEventListener("app.carma.preferences.changes", this._updateSamanthaContent);
                parentWindow.addAppEventListener("carma:network.change", this._updateSamanthaContent);
                parentWindow.addAppEventListener("carma:booking.changed", this._updateSamanthaContent);
                BookingService.on(BookingService.BOOKING_UPDATED, this._updateSamanthaContent);
                $.samantha.on("samantha.slideupdown.animation", this._slideUpDownAnimation);
                $.samantha.on("samantha.showCard", this._showCard);
                $.samantha.on("samantha.show", this._samanthaShown);
                $.samantha.on("samantha.hided", this._samanthaHidden);
                $.tripCard.on("tripcard.slideupdown.animation", this._tripCardSlideUpDownAnimation);
                $.tripCard.on("tripcard.showCard", this._showTripCard);
                $.tripCard.on("tripcard.show", this._tripCardShown);
                $.tripCard.on("tripcard.hided", this._tripCardHidden);
                $.tripCard.on("tripcard.show.noMatches", this._hideInviteFriendsCard);
                $.tripCard.on("tripcard.show.inviteFriend", this._showInviteFriendsCard);
                $.tripCard.outerScrollView = $.homeScrollView;
                $.locationCard.on("locationCard.show", this._locationCardShow);
                $.locationCard.on("locationCard.hide", this._locationCardHide);
                var self = this;
                $.homeScrollView.addEventListener("postlayout", function handler() {
                    $.homeScrollView.removeEventListener("postlayout", handler);
                    self._updateSamanthaContent({
                        update: true
                    });
                });
                $.homeScrollView.addEventListener("didTriggeredRefresh", function() {
                    self._refreshContents({
                        update: true
                    }).finally(function() {
                        $.homeScrollView.cmMarkRefreshFinished && $.homeScrollView.cmMarkRefreshFinished();
                    }).done();
                    $.completenessCard.reload();
                });
                $.tripCard.on("slide.animation.started", function() {
                    $.homeScrollView.refreshable = false;
                });
                $.tripCard.on("slide.animation.end", function() {
                    $.homeScrollView.refreshable = true;
                });
                TripService.on(TripService.TRIP_UPDATED_EVENT, this._updateSamanthaContent);
                parentWindow.addAppEventListener("carma:logout", function logoutHandler() {
                    BookingService.removeAllListeners();
                    TripService.removeAllListeners();
                });
                setTimeout(this._cardsShowed, 6e4);
            },
            _hideInviteFriendsCard: function() {
                _.delay(function() {
                    $.inviteContainer.applyProperties({
                        height: 0,
                        visible: false
                    });
                }, 800);
            },
            _showInviteFriendsCard: function() {
                _.delay(function() {
                    $.inviteContainer.applyProperties({
                        height: Ti.UI.SIZE,
                        visible: true
                    });
                }, 800);
            },
            _cardsShowed: function() {
                var self = this;
                _.delay(function() {
                    $.activityFeed.visible = true;
                    $.tipsCardContainer.visible = true;
                    $.completenessCardContainer.visible = true;
                    self._showInviteFriendsCard();
                }, 800);
            },
            _showNextCardSequentially: function() {
                if (this._showSequenceIndex < this._showSequence.length) {
                    var view = this._showSequence[this._showSequenceIndex], self = this;
                    this._showSequenceIndex++;
                    if (view.sequenceMark) {
                        view.show();
                        self._showNextCardSequentially();
                    } else {
                        view.addEventListener("markLoaded", function onMarkLoaded(e) {
                            view.removeEventListener("markLoaded", onMarkLoaded);
                            self._showNextCardSequentially();
                        });
                        view.show();
                    }
                }
            },
            _updateHomeScreenElements: function() {
                $.samantha.updateSamanthaVisibility();
                $.tripCard.updateTripCardVisibility();
            },
            _updateSamanthaContent: function(options) {
                LOGGER.info("home.js _updateSamanthaContent!");
                options = options || {};
                if (!this._samanthaScreenHeightOptions || options.update) {
                    var units = require("platform/units"), availableScreenHeight = units.SystemUnitToDip(parseFloat(.6 * $.homeScrollView.rect.height)), minimumHeight = 350;
                    minimumHeight > availableScreenHeight && (availableScreenHeight = minimumHeight);
                    if (0 >= availableScreenHeight) return;
                    this._samanthaScreenHeightOptions = {
                        availableScreenHeight: availableScreenHeight
                    };
                }
                $.samantha.updateSamanthaContent(this._samanthaScreenHeightOptions);
                LOGGER.info("home.js updateTripCardContent!");
                $.tripCard.updateTripCardContent(this._samanthaScreenHeightOptions);
                $.inviteCard.display();
            },
            _refreshContents: function(options) {
                options = options || {};
                var promise;
                if (!this._samanthaScreenHeightOptions || options.update) {
                    var units = require("platform/units"), availableScreenHeight = units.SystemUnitToDip(parseFloat(.6 * $.homeScrollView.rect.height)), minimumHeight = 350;
                    this._samanthaScreenHeightOptions = {
                        availableScreenHeight: Math.max(minimumHeight, availableScreenHeight)
                    };
                    $.samantha.updateSamanthaContent(this._samanthaScreenHeightOptions);
                    promise = $.tripCard.refreshContent(this._samanthaScreenHeightOptions);
                    $.inviteCard.display();
                } else promise = Q.fcall(function() {
                    return true;
                });
                return promise;
            },
            _slideUpDownAnimation: function(options) {
                options = options || {};
                var utils = require("utils/utils"), top = 0, containerHeight = utils.defaultToDp($.samanthaContainer.size.height), animateSlideup = options.animateSlideup, callback = options.callback;
                var slideUp = function(_callback) {
                    if (animateSlideup) $.samanthaContainer.animate({
                        top: top + 10 + "dp",
                        animate: true
                    }, function() {
                        $.samanthaContainer.applyProperties({
                            top: top + 10 + "dp"
                        });
                        $.samanthaContainer.animate({
                            top: "-" + containerHeight + "dp",
                            animate: true
                        }, function() {
                            _callback && _.isFunction(_callback) && _callback();
                        });
                    }); else {
                        $.samanthaContainer.applyProperties({
                            top: "-" + containerHeight + "dp"
                        });
                        _callback && _.isFunction(_callback) && _callback();
                    }
                };
                var slideDown = function(_callback) {
                    $.samanthaContainer.animate({
                        top: top + 10 + "dp",
                        animate: true
                    }, function() {
                        $.samanthaContainer.animate({
                            top: top + "dp"
                        }, function() {
                            _callback && _.isFunction(_callback) && _callback();
                        });
                    });
                };
                slideUp(function() {
                    $.samanthaContainer.applyProperties({
                        top: "-" + containerHeight + "dp"
                    });
                    callback && _.isFunction(callback) && callback();
                    slideDown();
                });
            },
            _showCard: function(params) {
                var utils = require("utils/utils");
                parseFloat($.samanthaContainer.top) <= 0 && $.samanthaContainer.applyProperties({
                    top: 0
                });
                this._cardsShowed();
            },
            _samanthaShown: function() {
                $.samanthaContainer.applyProperties({
                    top: 0,
                    height: Ti.UI.SIZE,
                    visible: true
                });
            },
            _samanthaHidden: function() {
                $.samanthaContainer.applyProperties({
                    height: 0,
                    visible: false
                });
            },
            _locationCardShow: function() {
                $.locationCardContainer.applyProperties({
                    height: Ti.UI.SIZE,
                    visible: true
                });
            },
            _locationCardHide: function() {
                $.locationCardContainer.applyProperties({
                    height: 0,
                    visible: false
                });
            },
            _initAustinTxtag: function() {
                var self = this;
                $.txtag.addEventListener("postlayout", function handler() {
                    $.txtag.removeEventListener("postlayout", handler);
                    self._txtagCardHeight = $.txtag.rect.height;
                    $.txtag.applyProperties({
                        height: 0,
                        visible: true
                    });
                    self._checkAustinTxtagCard();
                });
            },
            _checkAustinTxtagCard: function() {
                var self = this;
                if (require("gps/gps_manager").lastLocation()) {
                    if (require("utils/location_check").checkWithinAustin() && !require("services/action_record_service").get("txtagshown")) {
                        require("services/action_record_service").set("txtagshown", true);
                        TM.push(function() {
                            self._showTxtagCard();
                        });
                    }
                } else require("gps/gps_service").isLocationServiceEnabled() && Ti.App.addAppEventListener("carma:valid.location.update", function checkLocation() {
                    Ti.App.removeEventListener("carma:valid.location.update", checkLocation);
                    self._checkAustinTxtagCard();
                });
            },
            _showTxtagCard: function() {
                $.txtag.height = this._txtagCardHeight;
            },
            _dismissCard: function() {
                $.txtag.animate({
                    height: 0,
                    duration: 200
                }, function() {
                    $.homeScrollView.remove($.txtag);
                });
            },
            _openProfile: function() {
                Ti.App.fireEvent("carma:profile.open");
            },
            _tripCardSlideUpDownAnimation: function(options) {
                options = options || {};
                var utils = require("utils/utils"), top = 0, containerHeight = utils.defaultToDp($.tripCardContainer.size.height), animateSlideup = options.animateSlideup, callback = options.callback;
                var slideUp = function(_callback) {
                    if (animateSlideup) $.tripCardContainer.animate({
                        top: top + 10 + "dp",
                        animate: true
                    }, function() {
                        $.tripCardContainer.applyProperties({
                            top: top + 10 + "dp"
                        });
                        $.tripCardContainer.animate({
                            top: "-" + containerHeight + "dp",
                            animate: true
                        }, function() {
                            _callback && _.isFunction(_callback) && _callback();
                        });
                    }); else {
                        $.tripCardContainer.applyProperties({
                            top: "-" + containerHeight + "dp"
                        });
                        _callback && _.isFunction(_callback) && _callback();
                    }
                };
            },
            _showTripCard: function() {
                this._cardsShowed();
            },
            _tripCardShown: function() {
                $.tripCardContainer.applyProperties({
                    height: Ti.UI.SIZE
                });
            },
            _tripCardHidden: function() {
                $.tripCardContainer.applyProperties({
                    height: 0
                });
            },
            reset: function() {
                $.homeScrollView.scrollTo(0, 0);
            }
        };
    };
    HomeController.$inject = [ "View", "Arguments", "tripService", "bookingService" ];
    Controller.initialize(HomeController, $, arguments);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;