function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tabgroup/" + s : s.substring(0, index) + "/ma.car.app.tabgroup/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tabgroup");
    this.__widgetId = "ma.car.app.tabgroup";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    var __alloyId1084 = [];
    $.__views.activityWin = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        navBarHidden: true,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        backgroundImage: "/images/background.png",
        id: "activityWin"
    });
    $.__views.activity = Alloy.createWidget("ma.car.app.tabgroup", "home", {
        id: "activity",
        __parentSymbol: $.__views.activityWin
    });
    $.__views.activity.setParent($.__views.activityWin);
    $.__views.activityTab = Ti.UI.createTab({
        navBarHidden: true,
        iconIsMask: false,
        activeIconIsMask: false,
        backgroundColor: "#fff",
        opacity: .4,
        color: "black",
        selectedColor: "orange",
        imageTextualColor: "black",
        imageTextualSelectedColor: "white",
        title: L("widget_tabs_home"),
        icon: "/images/home_normal.png",
        activeIcon: "/images/home_selected.png",
        window: $.__views.activityWin,
        id: "activityTab"
    });
    __alloyId1084.push($.__views.activityTab);
    $.__views.planTripWin = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        navBarHidden: true,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "planTripWin"
    });
    $.__views.planTripTab = Ti.UI.createTab({
        navBarHidden: true,
        iconIsMask: false,
        activeIconIsMask: false,
        backgroundColor: "#fff",
        opacity: .4,
        color: "black",
        selectedColor: "orange",
        imageTextualColor: "black",
        imageTextualSelectedColor: "white",
        title: L("widget_tabs_plan_trip"),
        icon: "/images/plantrip_normal.png",
        activeIcon: "/images/plantrip_selected.png",
        window: $.__views.planTripWin,
        id: "planTripTab"
    });
    __alloyId1084.push($.__views.planTripTab);
    $.__views.startTripWin = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        navBarHidden: true,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "startTripWin"
    });
    $.__views.startTripTab = Ti.UI.createTab({
        navBarHidden: true,
        iconIsMask: false,
        activeIconIsMask: false,
        backgroundColor: "#fff",
        opacity: .4,
        color: "black",
        selectedColor: "orange",
        imageTextualColor: "black",
        imageTextualSelectedColor: "white",
        rollingActive: false,
        title: L("widget_tabs_start_trip"),
        icon: "/images/starttrip_normal.png",
        activeIcon: "/images/starttrip_selected.png",
        animatable: true,
        window: $.__views.startTripWin,
        id: "startTripTab"
    });
    __alloyId1084.push($.__views.startTripTab);
    $.__views.messageWin = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        navBarHidden: true,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "messageWin"
    });
    $.__views.messageTab = Ti.UI.createTab({
        navBarHidden: true,
        iconIsMask: false,
        activeIconIsMask: false,
        backgroundColor: "#fff",
        opacity: .4,
        color: "black",
        selectedColor: "orange",
        imageTextualColor: "black",
        imageTextualSelectedColor: "white",
        icon: "/images/messages_normal.png",
        activeIcon: "/images/messages_selected.png",
        text: "0",
        title: L("widget_tabs_messages"),
        window: $.__views.messageWin,
        id: "messageTab"
    });
    __alloyId1084.push($.__views.messageTab);
    $.__views.profileWin = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        top: 0,
        navBarHidden: true,
        width: Ti.UI.FILL,
        height: Ti.UI.FILL,
        id: "profileWin"
    });
    $.__views.profileTab = Ti.UI.createTab({
        navBarHidden: true,
        iconIsMask: false,
        activeIconIsMask: false,
        backgroundColor: "#fff",
        opacity: .4,
        color: "black",
        selectedColor: "orange",
        imageTextualColor: "black",
        imageTextualSelectedColor: "white",
        title: L("widget_tabs_profile"),
        icon: "/images/profile_normal.png",
        activeIcon: "/images/profile_selected.png",
        window: $.__views.profileWin,
        id: "profileTab"
    });
    __alloyId1084.push($.__views.profileTab);
    $.__views.tabGroup = Ti.UI.createTabGroup({
        top: 0,
        backgroundColor: "#fff",
        separatorColor: "lightgray",
        separatorWidth: "1px",
        tabs: __alloyId1084,
        id: "tabGroup"
    });
    $.__views.tabGroup && $.addTopLevelView($.__views.tabGroup);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    TABS_HELPER.setRootWindow($.activityWin);
    TAB_GROUP = $.tabGroup;
    var args = arguments[0] || {}, rootWindow = TABS_HELPER.rootWindow(), appSound = null, GlobalEvents = require("/v6/common/GlobalEvents"), beaconsHelper = require("/utils/beaconsHelper"), geofenceHelper = require("/utils/GeofenceHelper");
    exports = new (require("/carmalib/controller").extend($, {
        _bckgHnadler: null,
        _openingProfile: false,
        _initialLiveTripChecked: false,
        _lastOpenedProfile: null,
        initialize: function() {
            _.bindAll(this, "_checkLiveTrips", "_processProfileEvent", "_processTopupEvent", "_openMessages", "_navTostartTripTab", "_handleBack", "_processMessagesEvent", "_openMyTrips");
            this._initEventListeners();
            var Globals = require("/v6/infrastructure/Globals");
            Globals.IOC.register("TabGroup", this, "singleton");
            $.startTrip = Alloy.createWidget("ma.car.app.boardingv6", {
                tabScreen: this,
                handleClose: this._handleClose,
                around: {
                    exit: function() {
                        return true;
                    }
                }
            });
            $.startTripWin.add($.startTrip.getView());
            require("widget/messenger/messages_refresh").init();
            this._startBeaconService();
            this._startGeofences();
        },
        _initEventListeners: function() {
            var self = this;
            rootWindow.addAppEventListener("carma:messages.change", this._processMessagesEvent);
            rootWindow.addAppEventListener("carma:notifications.change", this._processNotificationEvent);
            rootWindow.addAppEventListener("carma:logout", this.cleanUp);
            rootWindow.addAppEventListener("carma:overall.count.change", this._onMessageCountChanged);
            rootWindow.addAppEventListener("carma:home.tab", this._navToHomeTab);
            rootWindow.addAppEventListener("carma:plantrip.tab", this._navToPlanTripTab);
            rootWindow.addAppEventListener("carma:starttrip.tab", this._navTostartTripTab);
            rootWindow.addAppEventListener("carma:open.conversation", this._openMessages);
            rootWindow.addAppEventListener("carma:profile.open", this._processProfileEvent);
            rootWindow.addAppEventListener("carma:topup.open", this._processTopupEvent);
            rootWindow.addAppEventListener("carma:trips.changed", this._navTostartTripTab);
            rootWindow.addAppEventListener("carma:trips.trip_started", this._startTripIconUpdate);
            rootWindow.addAppEventListener("carma:boarding.driver.starttrip", this._startTripIconUpdate);
            rootWindow.addAppEventListener("carma:boarding.solo.endtrip", this._endTripIconUpdate);
            rootWindow.addAppEventListener("carma:boarding.trip_ended", this._endTripIconUpdate);
            rootWindow.addAppEventListener("carma:boarding.trip_completed", this._endTripIconUpdate);
            rootWindow.addAppEventListener("carma:boarding.dropoff", this._endTripIconUpdate);
            rootWindow.addAppEventListener("carma:end.trip.icon.update", this._endTripIconUpdate);
            rootWindow.addAppEventListener("carma:feature.toggles", this._startBeaconService);
            rootWindow.addAppEventListener("carma:feature.toggles", this._startGeofences);
            $.planTripWin.addEventListener("focus", function openPlanTrip() {
                $.planTripWin.removeEventListener("focus", openPlanTrip);
                self._planTripWidget();
            });
            $.startTripWin.addEventListener("open", function openStartTrip() {
                $.startTripWin.removeEventListener("open", openStartTrip);
                self._startTripWidget() && self._startTripWidget().getView && self._startTripWidget().getView().open && self._startTripWidget().getView().open();
            });
            $.messageWin.addEventListener("focus", function openMesage() {
                $.messageWin.removeEventListener("focus", openMesage);
                self._messengerWidget().getView().open();
            });
            $.profileWin.addEventListener("focus", function openProfile() {
                $.profileWin.removeEventListener("focus", openProfile);
                self._profileWidget().getView().open();
                $.profileTab.addEventListener("focus", function focusProfile() {
                    self._profileWidget().focus();
                });
            });
            $.tabGroup.addEventListener("androidback", this._handleBack);
            var onTabReset = function() {
                self._resetTab(this);
            };
            $.activityTab.addEventListener("tabreset", onTabReset);
            $.planTripTab.addEventListener("tabreset", onTabReset);
            $.startTripTab.addEventListener("tabreset", onTabReset);
            $.messageTab.addEventListener("tabreset", onTabReset);
            $.profileTab.addEventListener("tabreset", onTabReset);
            GlobalEvents.onOpenMyTrips(this._openMyTrips);
        },
        _startBeaconService: function() {},
        _startGeofences: function() {
            geofenceHelper.startGeofences();
        },
        _resetTab: function(tab) {
            var widget = null;
            switch (tab) {
              case $.activityTab:
                widget = $.activity;
                break;

              case $.planTripTab:
                widget = $.planTrip;
                break;

              case $.startTripTab:
                widget = $.startTrip;
                break;

              case $.messageTab:
                widget = $.messages;
                break;

              case $.profileTab:
                widget = $.profile;
            }
            null != widget && widget.reset && widget.reset();
        },
        _planTripWidget: function() {
            if (!$.planTrip) {
                $.planTrip = Alloy.createWidget("ma.car.app.future2", {
                    around: {
                        exit: function() {
                            return true;
                        }
                    }
                });
                $.planTripWin.add($.planTrip.getView());
                $.planTripWin.addEventListener("close", function closePlanTrip() {
                    $.planTripWin.removeEventListener("close", closePlanTrip);
                    $.planTrip.onDestroy();
                    $.planTrip = null;
                });
            }
            return $.planTrip;
        },
        _startTripWidget: function() {
            return $.startTrip;
        },
        _messengerWidget: function() {
            if (!$.messages) {
                $.messages = Alloy.createWidget("ma.car.app.messenger", {
                    handleClose: this._handleClose,
                    around: {
                        exit: function() {
                            return true;
                        }
                    }
                });
                $.messageWin.add($.messages.getView());
            }
            return $.messages;
        },
        _profileWidget: function() {
            if (!$.profile) {
                $.profile = Alloy.createWidget("ma.car.app.profile", {
                    handleClose: this._handleClose,
                    around: {
                        exit: function() {
                            return true;
                        }
                    }
                });
                $.profileWin.add($.profile.getView());
            }
            return $.profile;
        },
        _startTripIconUpdate: function() {
            $.startTripTab.applyProperties($.createStyle({
                classes: "startTrip_active",
                apiName: "Tab"
            }));
            return;
        },
        _endTripIconUpdate: function() {
            $.startTripTab.applyProperties($.createStyle({
                classes: "startTrip_inactive",
                apiName: "Tab"
            }));
            return;
        },
        _navToHomeTab: function() {
            $.tabGroup.setActiveTab($.activityTab);
        },
        _navToPlanTripTab: function() {
            $.tabGroup.setActiveTab($.planTripTab);
        },
        _navTostartTripTab: function(params) {
            params = params || {};
            $.tabGroup.setActiveTab($.startTripTab);
            params.driving && this._startTripWidget().startDrive();
            params.riding && this._startTripWidget().startRide(params);
            params.boarding && this._startTripWidget().openCarmaCrew();
        },
        _checkLiveTrips: function() {
            rootWindow.removeAppEventListener("carma:initialized", this._checkLiveTrips);
        },
        _onMessageCountChanged: function(data) {
            data = data || {};
            data.count || (data.count = 0);
            var count = parseInt(data.count, 10);
            0 > count && (count = parseInt($.messageTab.badge, 10) + count);
            isNaN(count) && (count = 0);
            count = 0 > count ? 0 : count;
            var styleName = "messages_hollow";
            count > 0 && (styleName = "messages_solid");
            $.messageTab.applyProperties($.createStyle({
                classes: styleName,
                apiName: "Tab",
                text: count
            }));
        },
        _openProfile: function(options) {
            this._profileWidget().open(options);
            $.tabGroup.setActiveTab($.profileTab);
        },
        _openMessages: function(params) {
            params = params || {};
            this._messengerWidget().open(params);
            $.tabGroup.setActiveTab($.messageTab);
        },
        _processProfileEvent: function(user) {
            user = user || {};
            var resourceOwner = require("/services/resource_owner_service").singleton(), myUserId = resourceOwner.get("userId");
            var userId = user.userId || user.id;
            var self = this;
            if (this._lastOpenedProfile && this._lastOpenedProfile === userId) return;
            if (this._openingProfile) return;
            this._openingProfile = true;
            setTimeout(function() {
                self._openingProfile = false;
                self._lastOpenedProfile = null;
            }, 1500);
            if (userId === myUserId || !userId) {
                this._lastOpenedProfile = myUserId;
                this._openProfile(user);
                return;
            }
            this._lastOpenedProfile = userId;
            var profileController = Alloy.createWidget("ma.car.app.profile", user), profileView = profileController.getWindow();
            profileView.addEventListener("close", function handler() {
                profileView.removeEventListener("close", handler);
                self._lastOpenedProfile = null;
                self._openingProfile = false;
            });
            try {
                profileController.open();
            } catch (e) {
                this._openingProfile = false;
            }
        },
        _processTopupEvent: function(params) {
            params = params || {};
            var options = {};
            "startTrip" === params.tab && (options = {
                topup: true,
                callback: this._navTostartTripTab
            });
            this._openProfile(options);
        },
        _processMessagesEvent: function(data) {
            appSound = appSound || require("/utils/appSound");
            data = data || {};
            var isFromNotification = "notification" === data.source, threadId = data.threadId;
            isFromNotification || Ti.App.fireEvent("carma:open.conversation", {
                threadId: threadId
            });
            var isInsideThread = threadId && Alloy.Globals.currentMessageThreadId === threadId && $.tabGroup.getActiveTab() === $.messageTab;
            Ti.App.fireEvent("carma:update.overall.counter", {
                silent: false,
                isInsideThread: isInsideThread
            });
        },
        _processNotificationEvent: function(data) {
            Ti.App.fireEvent("carma:update.overall.counter", {
                silent: false
            });
            if (false || Ti.App.Properties.getBool("com.activate.gcm.app.inforeground", false)) {
                appSound = appSound || require("/utils/appSound");
                appSound.play("snuffle");
            }
            var isFromNotification = "notification" === data.source;
            isFromNotification || $.tabGroup.setActiveTab($.messageTab);
        },
        _openMyTrips: function() {
            $.tabGroup.setActiveTab($.planTripTab);
            $.planTrip ? $.planTrip.openMyTripsMenu() : $.planTripWin.addEventListener("focus", function openPlanTrip() {
                $.planTripWin.removeEventListener("focus", openPlanTrip);
                TM.push(function() {
                    $.planTrip.openMyTripsMenu();
                });
            });
        },
        _handleClose: function() {
            Ti.App.fireEvent("carma:home.tab");
        },
        isOnStartTripTab: function() {
            return $.tabGroup.getActiveTab() === $.startTripTab;
        },
        _handleBack: function(argument) {
            var nav = null;
            switch ($.tabGroup.getActiveTab()) {
              case $.activityTab:
                require("ma.car.ti.module.android.utils").moveTaskToBack(true);
                return;

              case $.planTripTab:
                $.planTrip && $.planTrip.handleBack();
                return;

              case $.profileTab:
                nav = Alloy.Globals.Nav.Profile;
                break;

              case $.messageTab:
                nav = Alloy.Globals.Nav.Messages;
                break;

              case $.startTripTab:
                nav = Alloy.Globals.Nav.Decision;
            }
            if (!nav) return;
            nav.canGoBack() ? nav.back() : this._handleClose();
        },
        cleanUp: function() {
            if (beaconsHelper) {
                beaconsHelper.stopService();
                beaconsHelper = null;
            }
            if (geofenceHelper) {
                geofenceHelper.shutdownGeofences();
                geofenceHelper = null;
            }
            Alloy.Globals.Nav.Profile = null;
            Alloy.Globals.Nav.Decision = null;
            Alloy.Globals.Nav.Messages = null;
            $.startTrip = null;
            $.messages = null;
            $.profile = null;
            $.activityWin.fireEvent("close");
            $.messageWin.fireEvent("close");
            $.startTripWin.fireEvent("close");
            $.planTripWin.fireEvent("close");
            $.profileWin.fireEvent("close");
            $.tabGroup.close();
            $.tabGroup.removeTab($.activityTab);
            $.tabGroup.removeTab($.messageTab);
            $.tabGroup.removeTab($.startTripTab);
            $.tabGroup.removeTab($.planTripTab);
            $.tabGroup.removeTab($.profileTab);
            TABS_HELPER.cleanUp();
            TAB_GROUP = null;
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;