function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.textfield/" + s : s.substring(0, index) + "/ma.car.app.textfield/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function _processArguments(args) {
        $.error.setVisible(false);
        $.textfield.applyProperties(args);
        validator.isEmpty(args.height) || $.error.setHeight(args.height);
        validator.isEmpty(args.width) || $.error.setWidth(args.width);
        $.textfield.addEventListener("focus", $.clearError);
        $.textfield.addEventListener("click", $.clearError);
    }
    var Widget = new (require("alloy/widget"))("ma.car.app.textfield");
    this.__widgetId = "ma.car.app.textfield";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.textfield = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        id: "textfield",
        zIndex: "5"
    });
    $.__views.textfield && $.addTopLevelView($.__views.textfield);
    $.__views.error = Ti.UI.createLabel({
        color: "red",
        font: {
            fontSize: "18dp"
        },
        text: "Error",
        touchEnabled: false,
        id: "error",
        zIndex: "10"
    });
    $.__views.error && $.addTopLevelView($.__views.error);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, validator = require("/validator/validator_factory").object();
    $.setErrorText = function(text) {
        $.error.left = $.textfield.rect.x + 10;
        $.error.top = $.textfield.rect.y;
        $.error.setText(text);
        $.textfield.hint = $.textfield.getHintText();
        $.textfield.setHintText("");
        $.error.setVisible(true);
    };
    $.clearError = function() {
        $.error.setVisible(false);
        $.error.setText("");
        $.textfield.hint && $.textfield.setHintText($.textfield.hint);
    };
    _processArguments(args);
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;