function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tolltag/" + s : s.substring(0, index) + "/ma.car.app.tolltag/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tolltag");
    this.__widgetId = "ma.car.app.tolltag";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "toll_tag_detail";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.toll_tag_detail = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.pct100,
        id: "toll_tag_detail"
    });
    $.__views.toll_tag_detail && $.addTopLevelView($.__views.toll_tag_detail);
    $.__views.scrollView = Ti.UI.createScrollView({
        layout: "vertical",
        id: "scrollView"
    });
    $.__views.toll_tag_detail.add($.__views.scrollView);
    $.__views.formContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "formContainer"
    });
    $.__views.scrollView.add($.__views.formContainer);
    $.__views.txtagIntro = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "12dp"
        },
        text: L("widget_txtag_intro"),
        bottom: "10dp",
        id: "txtagIntro"
    });
    $.__views.formContainer.add($.__views.txtagIntro);
    $.__views.txtagFormTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        left: "5dp",
        top: 0,
        id: "txtagFormTitle"
    });
    $.__views.formContainer.add($.__views.txtagFormTitle);
    $.__views.platesContainer = Ti.UI.createView({
        layout: "vertical",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        width: "100%",
        height: "120dp",
        top: "5dp",
        bottom: "16dp",
        borderColor: "#a4a4a4",
        borderWidth: 1,
        id: "platesContainer"
    });
    $.__views.formContainer.add($.__views.platesContainer);
    $.__views.licenseNumber = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: 0,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        hintText: L("widget_txtag_license_number_placeholder"),
        id: "licenseNumber"
    });
    $.__views.platesContainer.add($.__views.licenseNumber);
    $.__views.__alloyId630 = Ti.UI.createView({
        width: "100%",
        top: 0,
        left: 0,
        height: "1px",
        backgroundColor: "#a4a4a4",
        id: "__alloyId630"
    });
    $.__views.platesContainer.add($.__views.__alloyId630);
    $.__views.licenseState = Ti.UI.createView({
        backgroundColor: "#fff",
        width: "100%",
        height: "60dp",
        id: "licenseState"
    });
    $.__views.platesContainer.add($.__views.licenseState);
    $.__views.licenseStateLabel = require("/ui/common/custom_label").createLabel({
        color: "#777",
        text: L("widget_txtag_license_state_placeholder"),
        font: {
            fontSize: "18dp"
        },
        left: "10dp",
        id: "licenseStateLabel"
    });
    $.__views.licenseState.add($.__views.licenseStateLabel);
    var __alloyId632 = [];
    __alloyId632.push("AL - Alabama");
    __alloyId632.push("AK - Alaska");
    __alloyId632.push("AZ - Arizona");
    __alloyId632.push("AR - Arkansas");
    __alloyId632.push("CA - California");
    __alloyId632.push("CO - Colorado");
    __alloyId632.push("CT - Connecticut");
    __alloyId632.push("DE - Delaware");
    __alloyId632.push("DC - District Of Columbia");
    __alloyId632.push("FL - Florida");
    __alloyId632.push("GA - Georgia");
    __alloyId632.push("HI - Hawaii");
    __alloyId632.push("ID - Idaho");
    __alloyId632.push("IL - Illinois");
    __alloyId632.push("IN - Indiana");
    __alloyId632.push("IA - Iowa");
    __alloyId632.push("KS - Kansas");
    __alloyId632.push("KY - Kentucky");
    __alloyId632.push("LA - Louisiana");
    __alloyId632.push("ME - Maine");
    __alloyId632.push("MD - Maryland");
    __alloyId632.push("MA - Massachusetts");
    __alloyId632.push("MI - Michigan");
    __alloyId632.push("MN - Minnesota");
    __alloyId632.push("MS - Mississippi");
    __alloyId632.push("MO - Missouri");
    __alloyId632.push("MT - Montana");
    __alloyId632.push("NE - Nebraska");
    __alloyId632.push("NV - Nevada");
    __alloyId632.push("NH - New Hampshire");
    __alloyId632.push("NJ - New Jersey");
    __alloyId632.push("NM - New Mexico");
    __alloyId632.push("NY - New York");
    __alloyId632.push("NC - North Carolina");
    __alloyId632.push("ND - North Dakota");
    __alloyId632.push("OH - Ohio");
    __alloyId632.push("OK - Oklahoma");
    __alloyId632.push("OR - Oregon");
    __alloyId632.push("PA - Pennsylvania");
    __alloyId632.push("RI - Rhode Island");
    __alloyId632.push("SC - South Carolina");
    __alloyId632.push("SD - South Dakota");
    __alloyId632.push("TN - Tennessee");
    __alloyId632.push("TX - Texas");
    __alloyId632.push("UT - Utah");
    __alloyId632.push("VT - Vermont");
    __alloyId632.push("VA - Virginia");
    __alloyId632.push("WA - Washington");
    __alloyId632.push("WV - West Virginia");
    __alloyId632.push("WI - Wisconsin");
    __alloyId632.push("WY - Wyoming");
    $.__views.licenseStateDialog = Ti.UI.createOptionDialog({
        cancel: -1,
        selectedIndex: 43,
        options: __alloyId632,
        id: "licenseStateDialog"
    });
    $.__views.txtagNumberTitle = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: L("widget_txtag_textfield_title"),
        width: "100%",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "18dp",
            fontWeight: "bold"
        },
        left: "5dp",
        top: 0,
        id: "txtagNumberTitle"
    });
    $.__views.formContainer.add($.__views.txtagNumberTitle);
    $.__views.noTxtag = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: 0,
        left: "5dp",
        bottom: "10dp",
        text: L("widget_txtag_no_tag"),
        width: "100%",
        height: Ti.UI.SIZE,
        font: {
            fontSize: "11dp"
        },
        id: "noTxtag"
    });
    $.__views.formContainer.add($.__views.noTxtag);
    $.__views.__alloyId684 = Ti.UI.createView({
        bottom: "5dp",
        height: "60dp",
        id: "__alloyId684"
    });
    $.__views.formContainer.add($.__views.__alloyId684);
    $.__views.txtagPrefix = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "18dp"
        },
        top: 0,
        left: 0,
        width: "50dp",
        height: "60dp",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        text: "TEX",
        id: "txtagPrefix"
    });
    $.__views.__alloyId684.add($.__views.txtagPrefix);
    $.__views.txtagNumber = require("/ui/common/custom_textfield").createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: Ti.UI.FILL,
        top: 0,
        hintText: L("widget_txtag_number_placeholder"),
        keyboardType: Ti.UI.KEYBOARD_NUMBER_PAD,
        borderColor: "#a4a4a4",
        id: "txtagNumber"
    });
    $.__views.__alloyId684.add($.__views.txtagNumber);
    $.__views.txtagNumberError = Ti.UI.createLabel({
        color: "red",
        top: 0,
        left: "60dp",
        height: 0,
        visibility: false,
        font: {
            fontSize: "11dp"
        },
        id: "txtagNumberError"
    });
    $.__views.formContainer.add($.__views.txtagNumberError);
    $.__views.verifyContainer = Ti.UI.createView({
        height: "50dp",
        left: 0,
        width: "100%",
        top: "5dp",
        bottom: "5dp",
        id: "verifyContainer"
    });
    $.__views.formContainer.add($.__views.verifyContainer);
    $.__views.verifyProgram = Ti.UI.createLabel({
        color: "#fff",
        top: "10dp",
        left: 0,
        width: "20dp",
        height: "20dp",
        zIndex: 3,
        borderColor: Alloy.Globals.Style.Color.LightBlue,
        borderWidth: "2dp",
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        backgroundImage: "none",
        id: "verifyProgram"
    });
    $.__views.verifyContainer.add($.__views.verifyProgram);
    $.__views.verifyProgramTicker = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.LightBlue,
        font: {
            fontFamily: "splinico",
            fontSize: "14dp"
        },
        text: "c",
        visible: false,
        top: "10dp",
        left: "3dp",
        width: "20dp",
        height: "20dp",
        zIndex: 5,
        id: "verifyProgramTicker"
    });
    $.__views.verifyContainer.add($.__views.verifyProgramTicker);
    $.__views.verifyProgramHint = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        top: "13dp",
        left: "30dp",
        width: Alloy.Globals.Style.Size.Width.pct70,
        text: L("widget_txtag_verify_program"),
        font: {
            fontSize: "12dp",
            fontWeight: "bold"
        },
        id: "verifyProgramHint"
    });
    $.__views.verifyContainer.add($.__views.verifyProgramHint);
    $.__views.buttonsContainer = Ti.UI.createView({
        layout: "horizontal",
        width: "100%",
        height: "60dp",
        bottom: "22dp",
        id: "buttonsContainer"
    });
    $.__views.formContainer.add($.__views.buttonsContainer);
    $.__views.submit = require("/ui/common/custom_button").createButton({
        width: "100%",
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        title: L("btn_submit"),
        id: "submit"
    });
    $.__views.buttonsContainer.add($.__views.submit);
    $.__views.editButtonsContainer = Ti.UI.createView({
        width: "100%",
        height: "60dp",
        top: "10dp",
        bottom: "22dp",
        id: "editButtonsContainer"
    });
    $.__views.formContainer.add($.__views.editButtonsContainer);
    $.__views.__alloyId685 = Ti.UI.createView({
        top: 0,
        left: 0,
        width: "50%",
        height: "100%",
        id: "__alloyId685"
    });
    $.__views.editButtonsContainer.add($.__views.__alloyId685);
    $.__views.btnDelete = require("/ui/common/custom_button").createButton({
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        top: 0,
        right: "5dp",
        title: L("btn_delete"),
        id: "btnDelete"
    });
    $.__views.__alloyId685.add($.__views.btnDelete);
    $.__views.__alloyId686 = Ti.UI.createView({
        top: 0,
        right: 0,
        width: "50%",
        height: "100%",
        id: "__alloyId686"
    });
    $.__views.editButtonsContainer.add($.__views.__alloyId686);
    $.__views.btnUpdate = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        top: 0,
        left: "5dp",
        title: L("btn_update"),
        id: "btnUpdate"
    });
    $.__views.__alloyId686.add($.__views.btnUpdate);
    $.__views.howItWorks = Alloy.createWidget("ma.car.app.tolltag", "toll_tag_howitworks", {
        top: 0,
        id: "howItWorks",
        __parentSymbol: $.__views.scrollView
    });
    $.__views.howItWorks.setParent($.__views.scrollView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var navigation = Alloy.Globals.Nav.Profile, Validator = require("/validator/validator_factory"), Q = require("vendor/q"), args = arguments[0] || {};
    exports = new (require("/carmalib/controller").extend($, {
        _selectedState: null,
        _txtag: null,
        _isTxTag: true,
        events: {
            "click[ios] licenseState": "_openStatesDialog",
            "click[android] licenseState": "_openStatesDialog",
            "click[ios] verifyProgram": "_toggleTicker",
            "click[android] verifyProgram": "_toggleTicker",
            "click[ios] verifyProgramHint": "_toggleTicker",
            "click[android] verifyProgramHint": "_toggleTicker",
            "click licenseStateDialog": "_getSelectedItem",
            "click[android] submit": "_validateForm",
            "click[ios] submit": "_validateForm",
            "click[android] btnDelete": "_delete",
            "click[ios] btnDelete": "_delete",
            "click[android] btnUpdate": "_validateForm",
            "click[ios] btnUpdate": "_validateForm",
            "click scrollView": "_dismissKeyboard"
        },
        initialize: function() {
            _.bindAll(this, "_handleSubmitError");
            args.isTxTag || (this._isTxTag = false);
            this._getSelectedItem(this._isTxTag ? {
                index: 43
            } : {
                index: 4
            });
            if (args.isTxTag) {
                $.txtagNumber.applyProperties({
                    left: "60dp"
                });
                $.txtagFormTitle.text = L(args.isSecondOne ? "widget_txtag_second_registration_title" : "widget_txtag_first_registration_title");
            } else this._fasTrakAppearance(args.isSecondOne);
            this._txtag = args.txtag;
            this._appearanceFor(this._txtag);
        },
        _fasTrakAppearance: function() {
            var bayBridgeTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("bayBridgeTollRewards");
            var goldenGateBridgeTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("enableGoldenGateTollRefund");
            var allSFTollRewardsOn = 1 === require("featuretoggles/featuretoggles").getValue("enableSFBridgeTollRefunds");
            $.txtagIntro.applyProperties({
                text: L(allSFTollRewardsOn ? "widget_fastrak_how_it_works_desc_all_bridges" : bayBridgeTollRewardsOn && goldenGateBridgeTollRewardsOn ? "widget_fastrak_how_it_works_desc_baybridge_goldengate" : bayBridgeTollRewardsOn ? "widget_fastrak_how_it_works_desc" : "widget_fastrak_how_it_works_desc_goldengate")
            });
            var regTitle = L("widget_fastrak_first_registration_title");
            args.isSecondOne && (regTitle = L("widget_fastrak_second_registration_title"));
            $.txtagFormTitle.applyProperties({
                text: regTitle
            });
            $.txtagNumberTitle.applyProperties({
                text: L("widget_fastrak_textfield_title")
            });
            $.noTxtag.applyProperties({
                text: L("widget_fastrak_no_tag")
            });
            $.verifyContainer.applyProperties({
                visible: false,
                height: 0
            });
            $.txtagPrefix.applyProperties({
                visible: false,
                width: 0
            });
            $.txtagNumber.updateProperties({
                left: "0dp",
                hintText: L("widget_fastrak_number_placeholder")
            });
            $.txtagNumberError.applyProperties({
                right: "0dp",
                textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT
            });
            $.howItWorks.fastrakText();
        },
        _openStatesDialog: function() {
            $.licenseStateDialog.show();
        },
        _toggleTicker: function() {
            var bckgColor = $.verifyProgram.backgroundColor;
            $.verifyProgram.applyProperties({
                backgroundColor: "transparent" !== bckgColor && bckgColor ? "transparent" : "#fff",
                borderColor: Alloy.Globals.Style.Color.LightBlue
            });
            $.verifyProgramTicker.visible = !$.verifyProgramTicker.visible;
        },
        _getSelectedItem: function(data) {
            if (data.index === $.licenseStateDialog.cancel || data.index < 0) return;
            var options = $.licenseStateDialog.getOptions();
            this._selectedState = options[data.index].substr(0, 2);
            $.licenseStateLabel.applyProperties({
                text: options[data.index],
                color: "#666"
            });
        },
        _scrollToElement: function(el) {
            if (el) {
                var point = el.convertPointToView({
                    x: 0,
                    y: 0
                }, $.scrollView);
                $.scrollView.scrollTo(0, $.scrollView.contentOffset.y + point.y);
            }
        },
        _validateForm: function() {
            this._clearError();
            var error = false, shouldScrollTo = null;
            if (Validator.form().checkCustomTextFieldsEmpty([ $.licenseNumber ])) {
                error = true;
                shouldScrollTo || (shouldScrollTo = $.licenseNumber);
            }
            if (!this._selectedState) {
                $.licenseStateLabel.showError(L("widget_txtag_license_state_placeholder"));
                error = true;
                shouldScrollTo || (shouldScrollTo = $.licenseStateLabel);
            }
            var requiredLength = this._isTxTag ? [ 8 ] : [ 9, 10, 11 ];
            var tagErrorMessage = L(this._isTxTag ? "widget_txtag_textfield_error" : "widget_fastrak_textfield_error");
            if (Validator.form().checkCustomTextFieldsEmpty([ $.txtagNumber ]) || !Validator.number().isNumber($.txtagNumber.value) || -1 === requiredLength.indexOf($.txtagNumber.value.length)) {
                $.txtagNumber.applyProperties({
                    borderColor: "red",
                    color: "red"
                });
                $.txtagNumberError.applyProperties({
                    visibility: true,
                    height: "20dp",
                    text: tagErrorMessage
                });
                error = true;
                shouldScrollTo || (shouldScrollTo = $.txtagNumber);
            }
            if (this._isTxTag && !$.verifyProgramTicker.visible && !this._txtag) {
                $.verifyProgram.borderColor = "red";
                error = true;
                shouldScrollTo || (shouldScrollTo = $.verifyProgramTicker);
            }
            if (error) {
                var self = this;
                TM.push(function() {
                    self._scrollToElement(shouldScrollTo);
                });
                return;
            }
            this._submitForm();
        },
        _clearError: function() {
            $.licenseNumber.clearError();
            $.txtagNumber.applyProperties({
                borderColor: "transparent",
                color: "#666"
            });
            $.txtagNumber.clearError();
            $.txtagNumberError.applyProperties({
                visibility: false,
                height: 0,
                text: ""
            });
        },
        _submitForm: function() {
            var attrs = {}, self = this;
            attrs.licensePlateRegion = this._selectedState;
            attrs.licensePlateNumber = $.licenseNumber.getValue();
            attrs.tollTagId = $.txtagNumber.getValue();
            var tagType = self._isTxTag ? "txtag" : "fastrak";
            attrs.tollTagType = tagType;
            this._startSpinner().then(function() {
                return self._txtag && self._txtag.id ? require("services/toll_tag_service").updateTag(attrs, self._txtag.id) : require("services/toll_tag_service").saveTag(attrs);
            }).then(function() {
                navigation.fireEvent("txtag.refresh");
                navigation.back();
            }).catch(this._handleSubmitError).finally(this._stopSpinner);
        },
        _handleSubmitError: function(data) {
            var message = "";
            switch (data.status) {
              case 409:
                message = L("widget_txtag_duplicated_plate");
            }
            var errorTitle = L(this._isTxTag ? "widget_txtag_error_dialog_title" : "widget_fastrak_error_dialog_title");
            Ti.UI.createAlertDialog({
                message: message,
                ok: L("btn_ok"),
                title: errorTitle
            }).show();
        },
        _startSpinner: function() {
            return Q.fcall(function() {
                Ti.App.fireEvent("carma:progress.start");
                return true;
            });
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        },
        _delete: function(e) {
            var self = this;
            var buttons = [ L("btn_cancel"), L("btn_ok") ], cancelIndex = 0;
            buttons = [ L("btn_ok"), L("btn_cancel") ];
            cancelIndex = 1;
            var dialogTitle = L(self._isTxTag ? "widget_txtag_delete_confirm_title" : "widget_fastrak_delete_confirm_title");
            var dialogMsg = L(self._isTxTag ? "widget_txtag_delete_confirm_message" : "widget_fastrak_delete_confirm_message");
            var dialog = Ti.UI.createAlertDialog({
                cancel: cancelIndex,
                buttonNames: buttons,
                title: dialogTitle,
                message: dialogMsg
            });
            dialog.addEventListener("click", function(e) {
                e.index !== cancelIndex && self._startSpinner().then(function() {
                    var tagType = self._isTxTag ? "txtag" : "fastrak";
                    return require("services/toll_tag_service").deleteTag({
                        tollTagType: tagType
                    }, self._txtag.id);
                }).then(function() {
                    navigation.fireEvent("txtag.refresh");
                    navigation.back();
                }).catch(function() {
                    self._handleSubmitError();
                }).finally(self._stopSpinner);
            });
            dialog.show();
        },
        _appearanceFor: function(txtag) {
            if (txtag) {
                $.formContainer.remove($.txtagIntro);
                $.formContainer.remove($.txtagNumberTitle);
                $.formContainer.remove($.noTxtag);
                this._isTxTag && $.formContainer.remove($.verifyContainer);
                $.licenseNumber.value = txtag.licensePlateNumber;
                this._selectedState = txtag.licensePlateRegion;
                $.licenseStateLabel.text = function(licenseStates, selectedState) {
                    return _.find(licenseStates, function(state) {
                        return state.substr(0, 2) === selectedState;
                    });
                }($.licenseStateDialog.getOptions(), txtag.licensePlateRegion);
                $.txtagNumber.value = txtag.tollTagId;
                $.formContainer.remove($.buttonsContainer);
            } else $.formContainer.remove($.editButtonsContainer);
        },
        _dismissKeyboard: function(e) {
            if (e && e.source && "txtagNumber" !== e.source.id && "licenseNumber" !== e.source.id) {
                $.txtagNumber.blur();
                $.licenseNumber.blur();
            }
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;