function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "debug/viewer";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = Ti.UI.createScrollView({
        backgroundColor: "#fff",
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        id: "win"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.lblDateTime = Ti.UI.createLabel({
        color: "#fff",
        id: "lblDateTime"
    });
    $.__views.win.add($.__views.lblDateTime);
    $.__views.lblLevel = Ti.UI.createLabel({
        color: "#fff",
        id: "lblLevel"
    });
    $.__views.win.add($.__views.lblLevel);
    $.__views.lblMessage = Ti.UI.createLabel({
        color: "#fff",
        id: "lblMessage",
        text: "Empty..."
    });
    $.__views.win.add($.__views.lblMessage);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var record = arguments[0];
    $.lblDateTime.text = record.id;
    $.lblLevel.text = record.level;
    $.lblMessage.text = record.message;
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;