function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.tools/" + s : s.substring(0, index) + "/ma.car.app.tools/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.tools");
    this.__widgetId = "ma.car.app.tools";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "debug/widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win = require("/ui/common/custom_window").createWindow({
        orientationModes: [ Ti.UI.PORTRAIT ],
        backgroundColor: "#fff",
        fullscreen: false,
        navBarHidden: "true",
        layout: "vertical",
        id: "win",
        modal: "true"
    });
    $.__views.win && $.addTopLevelView($.__views.win);
    $.__views.header = Ti.UI.createView({
        top: 0,
        left: 0,
        height: "60dp",
        width: Ti.UI.FILL,
        backgroundColor: "#34495e",
        id: "header"
    });
    $.__views.win.add($.__views.header);
    $.__views.title = Ti.UI.createLabel({
        color: "#fff",
        top: "30dp",
        width: Ti.UI.FILL,
        textAlign: "center",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        id: "title",
        text: "Tools"
    });
    $.__views.header.add($.__views.title);
    $.__views.back = require("/ui/common/tactile_label").createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp"
        },
        top: "10dp",
        left: "10dp",
        height: "60dp",
        id: "back",
        text: "Back"
    });
    $.__views.header.add($.__views.back);
    $.__views.edit = require("/ui/common/tactile_label").createLabel({
        color: "#fff",
        font: {
            fontSize: "18dp",
            fontFamily: "splinico"
        },
        text: "u",
        top: "10dp",
        right: "10dp",
        height: "60dp",
        id: "edit"
    });
    $.__views.header.add($.__views.edit);
    $.__views.tableView = Ti.UI.createTableView({
        top: "0dp",
        left: "0dp",
        separatorStyle: Titanium.UI.iPhone.TableViewSeparatorStyle.NONE,
        allowsSelection: false,
        id: "tableView"
    });
    $.__views.win.add($.__views.tableView);
    var __alloyId588 = [];
    __alloyId588.push("Email");
    __alloyId588.push("Delete All");
    __alloyId588.push("Cancel");
    $.__views.dialog = Ti.UI.createOptionDialog({
        options: __alloyId588,
        id: "dialog"
    });
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var self = this;
    var args = arguments[0] || {};
    var records;
    $.header.remove($.back);
    $.win.addEventListener("androidback", function() {
        if ($.win) {
            $.win.close();
            args.onClose();
        }
    });
    $.edit.addEventListener("click", function() {
        $.dialog.show();
    });
    $.dialog.addEventListener("click", function(params) {
        switch (params.index) {
          case 0:
            var emailDialog = Ti.UI.createEmailDialog();
            emailDialog.subject = "Carma Splinter";
            emailDialog.messageBody = JSON.stringify(records);
            emailDialog.open();
            break;

          case 1:
            require("services/local_log_service").deleteAll(args.query);
            self.load();
        }
    });
    self.load = function() {
        var count = require("services/local_log_service").count(args.query);
        $.title.text = "Logs (" + count + ")";
        var tableData = [];
        collection = require("services/local_log_service");
        collection.findAll(args.query).then(function(data) {
            records = data;
            _.each(records, function(record) {
                var ctrl = Widget.createController("debug/tblRow", record);
                var view = ctrl.getView();
                tableData.push(view);
            });
            $.tableView.setData(tableData);
        });
    };
    self.load();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;