function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.trip/" + s : s.substring(0, index) + "/ma.car.app.trip/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.trip");
    this.__widgetId = "ma.car.app.trip";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "editTrip";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.editTripWrapper = Ti.UI.createView({
        width: "100%",
        height: "100%",
        top: 0,
        left: 0,
        id: "editTripWrapper"
    });
    $.__views.editTripWrapper && $.addTopLevelView($.__views.editTripWrapper);
    $.__views.scrollView = Ti.UI.createScrollView({
        showVerticalScrollIndicator: false,
        showHorizontalScrollIndicator: false,
        backgroundColor: "transparent",
        width: "100%",
        layout: "vertical",
        id: "scrollView"
    });
    $.__views.editTripWrapper.add($.__views.scrollView);
    $.__views.timePickerContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit5,
        height: "60dp",
        top: "15dp",
        bottom: "15dp",
        id: "timePickerContainer"
    });
    $.__views.scrollView.add($.__views.timePickerContainer);
    $.__views.lblTime = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "36dp"
        },
        height: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "lblTime"
    });
    $.__views.timePickerContainer.add($.__views.lblTime);
    $.__views.__alloyId797 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        right: "15dp",
        font: {
            fontSize: "24dp",
            fontFamily: "splinico"
        },
        transform: Alloy.Globals.Style.Rotate.rt90,
        id: "__alloyId797"
    });
    $.__views.timePickerContainer.add($.__views.__alloyId797);
    $.__views.__alloyId798 = Ti.UI.createView({
        height: "1px",
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId798"
    });
    $.__views.scrollView.add($.__views.__alloyId798);
    $.__views.datePickerContainer = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1dp",
        borderRadius: Alloy.Globals.Style.Unit.unit5,
        height: "60dp",
        top: 0,
        bottom: 0,
        visible: false,
        id: "datePickerContainer"
    });
    $.__views.scrollView.add($.__views.datePickerContainer);
    $.__views.lblDate = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "36dp"
        },
        height: "100%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        id: "lblDate"
    });
    $.__views.datePickerContainer.add($.__views.lblDate);
    $.__views.__alloyId799 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        right: "15dp",
        font: {
            fontSize: "24dp",
            fontFamily: "splinico"
        },
        transform: Alloy.Globals.Style.Rotate.rt90,
        id: "__alloyId799"
    });
    $.__views.datePickerContainer.add($.__views.__alloyId799);
    $.__views.weekContainer = Ti.UI.createView({
        layout: "horizontal",
        width: "100%",
        height: "70dp",
        id: "weekContainer"
    });
    $.__views.scrollView.add($.__views.weekContainer);
    $.__views.__alloyId800 = Ti.UI.createView({
        width: "14%",
        id: "__alloyId800"
    });
    $.__views.weekContainer.add($.__views.__alloyId800);
    $.__views.sunday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        title: L("sunday_single_capital"),
        selected: false,
        id: "sunday"
    });
    $.__views.__alloyId800.add($.__views.sunday);
    $.__views.__alloyId801 = Ti.UI.createView({
        width: "14%",
        id: "__alloyId801"
    });
    $.__views.weekContainer.add($.__views.__alloyId801);
    $.__views.monday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none",
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        title: L("monday_single_capital"),
        selected: true,
        id: "monday"
    });
    $.__views.__alloyId801.add($.__views.monday);
    $.__views.__alloyId802 = Ti.UI.createView({
        width: "14%",
        id: "__alloyId802"
    });
    $.__views.weekContainer.add($.__views.__alloyId802);
    $.__views.tuesday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none",
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        title: L("tuesday_single_capital"),
        selected: true,
        id: "tuesday"
    });
    $.__views.__alloyId802.add($.__views.tuesday);
    $.__views.__alloyId803 = Ti.UI.createView({
        width: "14%",
        id: "__alloyId803"
    });
    $.__views.weekContainer.add($.__views.__alloyId803);
    $.__views.wednesday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none",
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        title: L("wednesday_single_capital"),
        selected: true,
        id: "wednesday"
    });
    $.__views.__alloyId803.add($.__views.wednesday);
    $.__views.__alloyId804 = Ti.UI.createView({
        width: "14%",
        id: "__alloyId804"
    });
    $.__views.weekContainer.add($.__views.__alloyId804);
    $.__views.thursday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none",
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        title: L("thursday_single_capital"),
        selected: true,
        id: "thursday"
    });
    $.__views.__alloyId804.add($.__views.thursday);
    $.__views.__alloyId805 = Ti.UI.createView({
        width: "14%",
        id: "__alloyId805"
    });
    $.__views.weekContainer.add($.__views.__alloyId805);
    $.__views.friday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none",
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        title: L("friday_single_capital"),
        selected: true,
        id: "friday"
    });
    $.__views.__alloyId805.add($.__views.friday);
    $.__views.__alloyId806 = Ti.UI.createView({
        width: "14%",
        right: 0,
        id: "__alloyId806"
    });
    $.__views.weekContainer.add($.__views.__alloyId806);
    $.__views.saturday = Ti.UI.createButton({
        font: {
            fontSize: "12dp"
        },
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        width: Alloy.Globals.Style.Size.Width.pct12,
        height: Alloy.Globals.Style.Size.Width.pct12,
        right: 0,
        title: L("saturday_single_capital"),
        selected: false,
        id: "saturday"
    });
    $.__views.__alloyId806.add($.__views.saturday);
    $.__views.__alloyId807 = Ti.UI.createView({
        height: "1px",
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId807"
    });
    $.__views.scrollView.add($.__views.__alloyId807);
    $.__views.repeatField = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "44dp",
        id: "repeatField"
    });
    $.__views.scrollView.add($.__views.repeatField);
    $.__views.lblRepeat = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_trip_repeat"),
        left: 0,
        id: "lblRepeat"
    });
    $.__views.repeatField.add($.__views.lblRepeat);
    $.__views.lblRepeatDefault = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_trip_repeat_weekly"),
        right: "30dp",
        id: "lblRepeatDefault"
    });
    $.__views.repeatField.add($.__views.lblRepeatDefault);
    $.__views.__alloyId808 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        right: "-8dp",
        font: {
            fontSize: "30dp",
            fontFamily: "splinico"
        },
        id: "__alloyId808"
    });
    $.__views.repeatField.add($.__views.__alloyId808);
    $.__views.__alloyId809 = Ti.UI.createView({
        height: "1px",
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId809"
    });
    $.__views.scrollView.add($.__views.__alloyId809);
    $.__views.addressesContainer = Ti.UI.createView({
        height: "89dp",
        id: "addressesContainer"
    });
    $.__views.scrollView.add($.__views.addressesContainer);
    $.__views.originField = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "44dp",
        top: 0,
        id: "originField"
    });
    $.__views.addressesContainer.add($.__views.originField);
    $.__views.lblOriginHeader = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_trip_origin_header"),
        left: 0,
        id: "lblOriginHeader"
    });
    $.__views.originField.add($.__views.lblOriginHeader);
    $.__views.lblOrigin = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Grey,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_trip_origin_hinttext"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
        left: "50dp",
        right: "30dp",
        ellipsize: true,
        id: "lblOrigin"
    });
    $.__views.originField.add($.__views.lblOrigin);
    $.__views.__alloyId810 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        right: "-8dp",
        font: {
            fontSize: "30dp",
            fontFamily: "splinico"
        },
        id: "__alloyId810"
    });
    $.__views.originField.add($.__views.__alloyId810);
    $.__views.addressesHr = Ti.UI.createView({
        height: "1px",
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        top: "44dp",
        left: 0,
        id: "addressesHr"
    });
    $.__views.addressesContainer.add($.__views.addressesHr);
    $.__views.destinationField = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "44dp",
        top: "45dp",
        id: "destinationField"
    });
    $.__views.addressesContainer.add($.__views.destinationField);
    $.__views.lblDestinationHeader = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_trip_destination_header"),
        left: 0,
        id: "lblDestinationHeader"
    });
    $.__views.destinationField.add($.__views.lblDestinationHeader);
    $.__views.lblDestination = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.Grey,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_trip_destination_hinttext"),
        textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
        left: "30dp",
        right: "30dp",
        ellipsize: true,
        id: "lblDestination"
    });
    $.__views.destinationField.add($.__views.lblDestination);
    $.__views.__alloyId811 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        right: "-8dp",
        font: {
            fontSize: "30dp",
            fontFamily: "splinico"
        },
        id: "__alloyId811"
    });
    $.__views.destinationField.add($.__views.__alloyId811);
    $.__views.__alloyId812 = Ti.UI.createView({
        height: "1px",
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId812"
    });
    $.__views.scrollView.add($.__views.__alloyId812);
    $.__views.tripNameField = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "44dp",
        id: "tripNameField"
    });
    $.__views.scrollView.add($.__views.tripNameField);
    $.__views.lblTripName = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("widget_trip_name"),
        left: 0,
        id: "lblTripName"
    });
    $.__views.tripNameField.add($.__views.lblTripName);
    $.__views.lblTripNameDefault = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp"
        },
        text: L("widget_trip_name_default"),
        right: "30dp",
        ellipsize: true,
        width: "50%",
        textAlign: Ti.UI.TEXT_ALIGNMENT_RIGHT,
        id: "lblTripNameDefault"
    });
    $.__views.tripNameField.add($.__views.lblTripNameDefault);
    $.__views.__alloyId813 = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        text: "d",
        right: "-8dp",
        font: {
            fontSize: "30dp",
            fontFamily: "splinico"
        },
        id: "__alloyId813"
    });
    $.__views.tripNameField.add($.__views.__alloyId813);
    $.__views.__alloyId814 = Ti.UI.createView({
        height: "1px",
        width: "100%",
        backgroundColor: Alloy.Globals.Style.Color.DarkGray,
        id: "__alloyId814"
    });
    $.__views.scrollView.add($.__views.__alloyId814);
    $.__views.roleField = Ti.UI.createView({
        width: Alloy.Globals.Style.Size.Width.grid11,
        height: "82dp",
        id: "roleField"
    });
    $.__views.scrollView.add($.__views.roleField);
    $.__views.driverBtn = Ti.UI.createView({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: Alloy.Globals.Style.Color.LightBlue,
        selectedColor: "#0061E6",
        backgroundImage: "none",
        backgroundColor: Alloy.Globals.Style.Color.LightBlue,
        width: "47%",
        left: 0,
        top: "11dp",
        bottom: "30dp",
        selected: true,
        id: "driverBtn"
    });
    $.__views.roleField.add($.__views.driverBtn);
    $.__views.__alloyId815 = Ti.UI.createView({
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId815"
    });
    $.__views.driverBtn.add($.__views.__alloyId815);
    $.__views.driverIcon = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "B",
        right: "6dp",
        id: "driverIcon"
    });
    $.__views.__alloyId815.add($.__views.driverIcon);
    $.__views.driverText = Ti.UI.createLabel({
        color: "#fff",
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("mode_driver"),
        id: "driverText"
    });
    $.__views.__alloyId815.add($.__views.driverText);
    $.__views.riderBtn = Ti.UI.createView({
        color: Alloy.Globals.Style.Color.DarkGray,
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#00333333",
        selectedColor: "#70333333",
        backgroundImage: "none",
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: 2,
        width: "47%",
        right: 0,
        top: "11dp",
        bottom: "30dp",
        selected: false,
        id: "riderBtn"
    });
    $.__views.roleField.add($.__views.riderBtn);
    $.__views.__alloyId816 = Ti.UI.createView({
        layout: "horizontal",
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        id: "__alloyId816"
    });
    $.__views.riderBtn.add($.__views.__alloyId816);
    $.__views.riderIcon = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontFamily: "splinico",
            fontSize: "20dp"
        },
        text: "C",
        right: "6dp",
        id: "riderIcon"
    });
    $.__views.__alloyId816.add($.__views.riderIcon);
    $.__views.riderText = Ti.UI.createLabel({
        color: Alloy.Globals.Style.Color.DarkGray,
        font: {
            fontSize: "15dp",
            fontWeight: "bold"
        },
        text: L("mode_rider"),
        id: "riderText"
    });
    $.__views.__alloyId816.add($.__views.riderText);
    $.__views.timePicker = Alloy.createWidget("ma.car.app.picker", "widget", {
        id: "timePicker",
        pickerType: Ti.UI.PICKER_TYPE_TIME,
        __parentSymbol: $.__views.editTripWrapper
    });
    $.__views.timePicker.setParent($.__views.editTripWrapper);
    $.__views.datePicker = Alloy.createWidget("ma.car.app.picker", "widget", {
        id: "datePicker",
        pickerType: Ti.UI.PICKER_TYPE_DATE,
        __parentSymbol: $.__views.editTripWrapper
    });
    $.__views.datePicker.setParent($.__views.editTripWrapper);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, navigation = args.navigation || Alloy.Globals.Nav.Trip, moment = require("vendor/moment"), ErrorDialog = require("/ui/common/validation_error"), Q = require("/vendor/q"), popupWindow = require("/ui/common/popupWindow"), Globals = require("/v6/infrastructure/Globals"), TripService = Globals.IOC.get("tripService");
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] timePickerContainer": "_openTimePicker",
            "click[android] timePickerContainer": "_openTimePicker",
            "click[ios] datePickerContainer": "_openDatePicker",
            "click[android] datePickerContainer": "_openDatePicker",
            "click[ios] weekContainer": "_toggleBtnDay",
            "click[android] weekContainer": "_toggleBtnDay",
            "click[ios] driverBtn": "_driverBtnClicked",
            "click[android] driverBtn": "_driverBtnClicked",
            "click[ios] riderBtn": "_riderBtnClicked",
            "click[android] riderBtn": "_riderBtnClicked",
            "click[ios] repeatField": "_openRepeatDialog",
            "click[android] repeatField": "_openRepeatDialog",
            "click[ios] tripNameField": "_openTripNameEdit",
            "click[android] tripNameField": "_openTripNameEdit",
            "click[ios] originField": "_openOriginSelection",
            "click[android] originField": "_openOriginSelection",
            "click[ios] destinationField": "_openDestinationSelection",
            "click[android] destinationField": "_openDestinationSelection"
        },
        TAG: "EDIT_TRIP",
        _selectedDate: new Date(),
        _originLocation: null,
        _destinationLocation: null,
        _selectedDays: [ false, true, true, true, true, true, false ],
        _tripTypes: [ "DRIVE", "RIDE" ],
        _tripType: "DRIVE",
        _repeatingTypes: [ "REPEATING_WEEKLY", "ONE_OFF" ],
        _repeatingType: "REPEATING_WEEKLY",
        _askForReturnTrip: true,
        _originalDate: null,
        _loading: false,
        initialize: function() {
            _.bindAll(this, "_updateSelectedTime", "_updateSelectedDate", "_validForm", "_backAction", "_populateTrip", "onDestroy");
            this._initLblTime();
            this._initDoneButton();
            if (args.tripId) {
                $.scrollView.hide();
                this._startSpinner();
                this._askForReturnTrip = false;
                this._loadAndPopulateTrip(args.tripId);
            } else this._datePickerDownArrowFix();
        },
        _initLblTime: function() {
            this._updateLblTime();
            this._updateLblDate();
            var _event = "close";
            $.timePicker.addEventListener(_event, this._updateSelectedTime);
            $.datePicker.addEventListener(_event, this._updateSelectedDate);
        },
        _updateSelectedTime: function(data) {
            var value;
            value = data && data.value || $.timePicker.getValue();
            this._selectedDate = new Date(value);
            this._updateLblTime();
        },
        _updateSelectedDate: function(data) {
            var value;
            value = data && data.value || $.datePicker.getValue();
            var date = new Date(value);
            this._selectedDate.setDate(date.getDate());
            this._selectedDate.setMonth(date.getMonth());
            this._selectedDate.setFullYear(date.getFullYear());
            this._updateLblDate();
        },
        _openTimePicker: function() {
            var preferences = require("services/cached_preferences_service").singleton(), is24h = "MILITARY" === preferences.getPreferredTimeFormat();
            $.timePicker.applyProperties({
                format24: is24h
            });
            $.timePicker.open(this._selectedDate);
        },
        _updateLblTime: function() {
            var preferences = require("services/cached_preferences_service").singleton(), is24h = "MILITARY" === preferences.getPreferredTimeFormat();
            var date = this._selectedDate, hour = date.getHours(), minutes = date.getMinutes();
            if (60 === minutes) {
                minutes = 0;
                hour = ++hour % 24;
                this._selectedDate.setHours(hour);
            }
            minutes = ("0" + minutes).slice(-2);
            this._selectedDate.setMinutes(parseInt(minutes, 10));
            var ampm = is24h ? "" : hour >= 12 ? "PM" : "AM";
            if (!is24h) {
                hour = hour > 12 ? hour - 12 : hour;
                hour = 0 === hour ? 12 : hour;
            }
            $.lblTime.text = hour + ":" + minutes + " " + ampm;
            $.timePickerContainer.backgroundColor = "transparent";
        },
        _openDatePicker: function() {
            $.datePicker.applyProperties({
                format24: false
            });
            $.datePicker.open(this._selectedDate);
        },
        _updateLblDate: function() {
            var date = moment(this._selectedDate), todayAM = moment("00:00:00:000", "HH:mm:ss:SSS"), todayPM = moment("23:59:59:999", "HH:mm:ss:SSS"), tomorrowPM = todayPM.clone().add("days", 1), dateString = "";
            dateString = date.isAfter(todayAM) && date.isBefore(todayPM) ? L("date_today") : date.isAfter(todayPM) && date.isBefore(tomorrowPM) ? L("date_tomorrow") : L("week_three_" + date.day()) + " " + date.date() + " " + L("month_three_" + date.month());
            $.lblDate.text = dateString;
        },
        _datePickerDownArrowFix: function() {
            $.datePickerContainer.height = 0;
        },
        _initDoneButton: function() {
            if (navigation) {
                navigation.addEventListener("done.click", this._validForm);
                navigation.addEventListener("nav.backcomplete", this._backAction);
            }
        },
        onOpened: function() {
            if (navigation) {
                navigation.setDoneButtonText(L("btn_done"));
                navigation.showDoneButton();
            }
        },
        onDestroy: function() {
            if (navigation) {
                navigation.removeEventListener("done.click", this._validForm);
                navigation.removeEventListener("nav.backcomplete", this._backAction);
            }
        },
        _backAction: function(data) {
            if (data.tag === this.TAG && navigation) {
                navigation.setDoneButtonText(L("btn_done"));
                navigation.showDoneButton();
            }
        },
        _loadAndPopulateTrip: function(tripId) {
            var self = this;
            TripService.getTrip(tripId).then(this._populateTrip).catch(function() {
                self._datePickerDownArrowFix();
                self._stopSpinner();
                LOGGER.debug("[endTrip] - Couldn't fetch trip data for trip: " + tripId);
            });
        },
        _populateTrip: function(data) {
            this._originLocation = data.baseTrip.origin;
            this._destinationLocation = data.baseTrip.destination;
            this._selectedDays = data.baseTrip.schedule.daysOfOperationv2;
            this._selectedDate = new Date(data.baseTrip.schedule.effectiveTime);
            this._repeatingType = data.baseTrip.schedule.type;
            this._originalDate = new Date(data.baseTrip.schedule.baseEffectiveTime);
            this._updateRepeatUI();
            this._updateLblTime();
            this._updateLblDate();
            data.baseTrip.type === this._tripTypes[0] ? this._driverBtnClicked() : this._riderBtnClicked();
            this._repeatingType === this._repeatingTypes[0] && this._updateWeekDays();
            $.lblTripNameDefault.text = data.baseTrip.alias;
            $.lblOrigin.applyProperties({
                text: this._originLocation.address,
                color: Alloy.Globals.Style.Color.DarkGray
            });
            $.lblDestination.applyProperties({
                text: this._destinationLocation.address,
                color: Alloy.Globals.Style.Color.DarkGray
            });
            var self = this;
            _.delay(function() {
                $.scrollView.show();
                self._stopSpinner();
            }, 300);
        },
        _toggleBtnDay: function(data) {
            var source = data.source, selected = source.selected, dayBtnIds = [ "sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday" ], dayIndex = dayBtnIds.indexOf(source.id);
            if (-1 === dayIndex) return;
            source.applyProperties({
                color: selected ? Alloy.Globals.Style.Color.DarkGray : "#fff",
                backgroundColor: selected ? "transparent" : Alloy.Globals.Style.Color.LightBlue,
                borderColor: selected ? Alloy.Globals.Style.Color.DarkGray : "transparent",
                borderWidth: selected ? 1 : 0
            });
            source.selected = !selected;
            this._selectedDays[dayIndex] = !selected;
        },
        _driverBtnClicked: function() {
            if ($.driverBtn.selected) return;
            $.driverBtn.applyProperties({
                backgroundColor: Alloy.Globals.Style.Color.LightBlue,
                borderWidth: 0,
                borderColor: "transparent"
            });
            $.driverIcon.color = "white";
            $.driverText.color = "white";
            $.riderBtn.applyProperties({
                backgroundColor: "transparent",
                borderWidth: 1,
                borderColor: Alloy.Globals.Style.Color.DarkGray,
                color: Alloy.Globals.Style.Color.DarkGray
            });
            $.riderIcon.color = Alloy.Globals.Style.Color.DarkGray;
            $.riderText.color = Alloy.Globals.Style.Color.DarkGray;
            $.driverBtn.selected = true;
            $.riderBtn.selected = false;
            this._tripType = this._tripTypes[0];
        },
        _riderBtnClicked: function() {
            if ($.riderBtn.selected) return;
            $.driverBtn.applyProperties({
                backgroundColor: "transparent",
                borderWidth: 1,
                borderColor: Alloy.Globals.Style.Color.DarkGray,
                color: Alloy.Globals.Style.Color.DarkGray
            });
            $.driverIcon.color = Alloy.Globals.Style.Color.DarkGray;
            $.driverText.color = Alloy.Globals.Style.Color.DarkGray;
            $.riderBtn.applyProperties({
                backgroundColor: Alloy.Globals.Style.Color.LightBlue,
                borderWidth: 0,
                borderColor: "transparent"
            });
            $.riderIcon.color = "white";
            $.riderText.color = "white";
            $.driverBtn.selected = false;
            $.riderBtn.selected = true;
            this._tripType = this._tripTypes[1];
        },
        _openRepeatDialog: function() {
            var opts = {
                cancel: 2,
                options: [ L("widget_trip_repeat_weekly"), L("widget_trip_repeat_once"), L("btn_cancel") ],
                selectedIndex: 2,
                title: L("widget_trip_repeat")
            };
            var dialog = Ti.UI.createOptionDialog(opts), self = this;
            dialog.addEventListener("click", function clickEvent(e) {
                dialog.removeEventListener("click", clickEvent);
                if (e.index === e.source.cancel) return;
                self._repeatingType = self._repeatingTypes[e.index];
                self._updateRepeatUI();
            });
            dialog.show();
        },
        _toggleWeeklyUI: function(enable) {
            if (enable) {
                $.weekContainer.applyProperties({
                    visible: true,
                    height: "70dp"
                });
                $.datePickerContainer.applyProperties({
                    visible: false,
                    height: 0,
                    top: 0,
                    bottom: 0
                });
            } else {
                $.datePickerContainer.applyProperties({
                    visible: true,
                    height: "60dp",
                    top: "15dp",
                    bottom: "15dp"
                });
                $.weekContainer.applyProperties({
                    visible: false,
                    height: 0
                });
            }
        },
        _updateRepeatUI: function() {
            if (this._repeatingType === this._repeatingTypes[0]) {
                this._updateWeekDays();
                this._toggleWeeklyUI(true);
                $.lblRepeatDefault.text = L("widget_trip_repeat_weekly");
            } else if (this._repeatingType === this._repeatingTypes[1]) {
                this._toggleWeeklyUI(false);
                $.lblRepeatDefault.text = L("widget_trip_repeat_once");
                $.datePicker.applyProperties({
                    minDate: new Date()
                });
            }
        },
        _updateWeekDays: function() {
            var weekDays = [ $.sunday, $.monday, $.tuesday, $.wednesday, $.thursday, $.friday, $.saturday ];
            for (var i = 0; i < this._selectedDays.length; ++i) if (this._selectedDays[i] && !weekDays[i].selected || !this._selectedDays[i] && weekDays[i].selected) {
                weekDays[i].applyProperties({
                    color: this._selectedDays[i] ? "#fff" : Alloy.Globals.Style.Color.DarkGray,
                    backgroundColor: this._selectedDays[i] ? Alloy.Globals.Style.Color.LightBlue : "transparent",
                    borderColor: this._selectedDays[i] ? "transparent" : Alloy.Globals.Style.Color.DarkGray,
                    borderWidth: this._selectedDays[i] ? 0 : 1
                });
                weekDays[i].selected = this._selectedDays[i];
            }
        },
        _openTripNameEdit: function() {
            var callback = function(name) {
                $.lblTripNameDefault.text = name;
            };
            var widget = Alloy.createWidget("ma.car.app.trip", "tripName", {
                callback: callback,
                currentValue: $.lblTripNameDefault.text,
                navigation: navigation
            });
            navigation.open(widget, {
                title: L("widget_trip_name_title")
            });
        },
        _openOriginSelection: function() {
            var self = this;
            var callback = function(location) {
                $.lblOrigin.applyProperties({
                    text: location.address,
                    color: Alloy.Globals.Style.Color.DarkGray
                });
                self._originLocation = {
                    latitude: location.lat,
                    longitude: location.lon,
                    address: location.address,
                    timestamp: location.timestamp
                };
            };
            var currentValue = $.lblOrigin.text;
            currentValue = currentValue === L("widget_trip_origin_hinttext") ? "" : currentValue;
            var widget = Alloy.createWidget("ma.car.app.trip", "locationSelector", {
                callback: callback,
                currentValue: currentValue,
                origin: true,
                darkTheme: true,
                navigation: navigation
            });
            navigation.open(widget, {
                title: L("widget_trip_origin_title")
            });
        },
        _openDestinationSelection: function() {
            var self = this;
            var callback = function(location) {
                $.lblDestination.applyProperties({
                    text: location.address,
                    color: Alloy.Globals.Style.Color.DarkGray
                });
                self._destinationLocation = {
                    latitude: location.lat,
                    longitude: location.lon,
                    address: location.address,
                    timestamp: location.timestamp
                };
            };
            var currentValue = $.lblDestination.text;
            currentValue = currentValue === L("widget_trip_destination_hinttext") ? "" : currentValue;
            var widget = Alloy.createWidget("ma.car.app.trip", "locationSelector", {
                callback: callback,
                currentValue: currentValue,
                origin: false,
                darkTheme: true,
                navigation: navigation
            });
            navigation.open(widget, {
                title: L("widget_trip_destination_title")
            });
        },
        _validForm: function(event) {
            if (event.tag !== this.TAG) return;
            if (this._loading) return;
            this._loading = true;
            if (!this._originLocation || !this._destinationLocation) {
                ErrorDialog.showSimple(L("widget_trip_no_location"));
                this._loading = false;
                return;
            }
            if (this._repeatingType === this._repeatingTypes[0] && -1 === this._selectedDays.indexOf(true)) {
                ErrorDialog.showSimple(L("widget_trip_no_week_days"));
                this._loading = false;
                return;
            }
            if (this._repeatingType === this._repeatingTypes[1] && this._selectedDate.getTime() < Date.now()) {
                ErrorDialog.showSimple(L("widget_trip_past_date"));
                this._loading = false;
                return;
            }
            this._saveTrip();
        },
        _isTimeChanged: function() {
            return !this._originalDate || !this._selectedDate || this._originalDate.getHours() !== this._selectedDate.getHours() || this._originalDate.getMinutes() !== this._selectedDate.getMinutes();
        },
        _saveTrip: function() {
            this._startSpinner();
            var schedule = this._repeatingType === this._repeatingTypes[0] ? TripService.createSchedule(this._selectedDays, this._selectedDate) : TripService.createOneOffSchedule(this._selectedDate), self = this;
            TripService.saveTrip({
                id: args.tripId,
                type: this._tripType,
                alias: $.lblTripNameDefault.text,
                origin: this._originLocation,
                destination: this._destinationLocation,
                schedule: schedule,
                enabled: true
            }, {
                clearDeviation: true
            }).then(function() {
                LOGGER.info("[editTrip] - Trip created");
                if (self._askForReturnTrip) {
                    self._showReturnTripDialog();
                    return;
                }
                self._stopSpinner();
                self._loading = false;
                navigation.back();
            }).catch(function() {
                self._stopSpinner();
                ErrorDialog.showSimple(L("widget_trip_save_error"));
            });
        },
        _showReturnTripDialog: function() {
            this._askForReturnTrip = false;
            var self = this;
            var dialog = Ti.UI.createAlertDialog({
                cancel: 1,
                buttonNames: [ L("btn_ok"), L("btn_no") ],
                message: L("widget_trip_setup_return"),
                title: L("widget_trip_setup_return_title")
            });
            dialog.addEventListener("click", function clickEvent(e) {
                dialog.removeEventListener("click", clickEvent);
                self._stopSpinner();
                self._loading = false;
                if (e.index === e.source.cancel) {
                    navigation.back();
                    return;
                }
                self._setupReturnTrip();
            });
            dialog.show();
        },
        _setupReturnTrip: function() {
            var origin = this._originLocation;
            this._originLocation = this._destinationLocation;
            this._destinationLocation = origin;
            $.timePickerContainer.backgroundColor = Alloy.Globals.Style.Color.LightBlue;
            navigation.setTitle((L("widget_trip_navigation_title") || "").toUpperCase());
            this._playAnimation();
            $.lblTripNameDefault.text = $.lblTripNameDefault.text + " " + L("widget_trip_setup_return_trip_title");
        },
        _playAnimation: function() {
            var scaleDown = function() {
                var deferred = Q.defer();
                $.originField.animate({
                    transform: Ti.UI.create2DMatrix({
                        scale: .8
                    }),
                    duration: 500
                }, function() {
                    deferred.resolve();
                });
                return deferred.promise;
            };
            var switchFields = function() {
                var deferred = Q.defer();
                $.originField.animate({
                    top: "45dp",
                    duration: 500
                });
                $.destinationField.animate({
                    top: "0",
                    duration: 500
                }, function() {
                    deferred.resolve();
                });
                return deferred.promise;
            };
            var scaleUp = function() {
                var deferred = Q.defer();
                $.originField.animate({
                    transform: Ti.UI.create2DMatrix({
                        scale: 1
                    }),
                    duration: 500
                }, function() {
                    deferred.resolve();
                });
                return deferred.promise;
            };
            var self = this;
            var resetFields = function() {
                $.originField.top = 0;
                $.destinationField.top = "45dp";
                $.lblOrigin.text = self._originLocation.address;
                $.lblDestination.text = self._destinationLocation.address;
            };
            scaleDown().then(switchFields).then(scaleUp).then(resetFields);
        },
        _startSpinner: function() {
            Ti.App.fireEvent("carma:progress.start");
        },
        _stopSpinner: function() {
            Ti.App.fireEvent("carma:progress.stop");
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;