function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.trip/" + s : s.substring(0, index) + "/ma.car.app.trip/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.trip");
    this.__widgetId = "ma.car.app.trip";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "tripName";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripNameContainer = Ti.UI.createView({
        width: "100%",
        height: "100%",
        top: 0,
        left: 0,
        id: "tripNameContainer"
    });
    $.__views.tripNameContainer && $.addTopLevelView($.__views.tripNameContainer);
    $.__views.tripNameWrapper = Ti.UI.createView({
        width: "91.66666666666666%",
        height: "100%",
        top: "15dp",
        id: "tripNameWrapper"
    });
    $.__views.tripNameContainer.add($.__views.tripNameWrapper);
    $.__views.tripName = Ti.UI.createTextField({
        paddingLeft: "10dp",
        height: "60dp",
        clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderRadius: Alloy.Globals.Style.Unit.unit4,
        color: "#666",
        backgroundColor: "#fff",
        font: {
            fontSize: "18dp"
        },
        width: "100%",
        hintText: L("widget_trip_name_default"),
        top: 0,
        borderColor: Alloy.Globals.Style.Color.DarkGray,
        borderWidth: "1px",
        softKeyboardOnFocus: Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS,
        id: "tripName"
    });
    $.__views.tripNameWrapper.add($.__views.tripName);
    $.__views.doneButton = require("/ui/common/custom_button").createButton({
        color: "#fff",
        borderRadius: Alloy.Globals.Style.Unit.unit3,
        height: "60dp",
        font: {
            fontSize: "18dp"
        },
        normalColor: "#ff6600",
        selectedColor: "#de5900",
        backgroundImage: "none",
        width: "100%",
        top: "75dp",
        title: L("btn_done"),
        id: "doneButton"
    });
    $.__views.tripNameWrapper.add($.__views.doneButton);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {}, navigation = args.navigation || Alloy.Globals.Nav.Trip;
    exports = new (require("/carmalib/controller").extend($, {
        events: {
            "click[ios] doneButton": "_saveTripName",
            "click[android] doneButton": "_saveTripName"
        },
        initialize: function() {
            var length;
            if (args.currentValue && args.currentValue !== L("widget_trip_name_default")) {
                $.tripName.value = args.currentValue;
                length = args.currentValue.length;
            } else length = $.tripName.value.length;
            $.tripName.setSelection(length, length);
            setTimeout(function() {
                $.tripName.focus();
            }, 200);
        },
        _saveTripName: function() {
            $.tripName.blur();
            args.callback && args.callback($.tripName.value);
            navigation.back();
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;