function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.trip/" + s : s.substring(0, index) + "/ma.car.app.trip/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.trip");
    this.__widgetId = "ma.car.app.trip";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.tripWindow = require("/ui/common/child_window").createView({
        width: "100%",
        height: "100%",
        top: 0,
        left: 0,
        backgroundColor: "white",
        id: "tripWindow"
    });
    $.__views.tripWindow && $.addTopLevelView($.__views.tripWindow);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var args = arguments[0] || {};
    exports = new (require("/carmalib/controller").extend($, {
        initialize: function() {
            if (args.tripId || args.addTrip) this._openWidgetInsidePopup(); else {
                var widget = Alloy.createWidget("ma.car.app.trip", "tripsList", {
                    __parentSymbol: $.getView()
                });
                $.tripWindow.add(widget.getView());
            }
        },
        _openWidgetInsidePopup: function() {
            var popupWindowController = Alloy.createController("simpleWindow"), popupWindowView = popupWindowController.getView();
            popupWindowView.backgroundColor = "#fff";
            var self = this;
            popupWindowView.addEventListener("open", function handler() {
                popupWindowView.removeEventListener("open", handler);
                setTimeout(function() {
                    self._initWidget(popupWindowView);
                }, 300);
            });
            popupWindowController.open();
        },
        _initWidget: function(popupWindowView) {
            var navigation = Alloy.createController("navigation");
            var tripId = args.tripId || null;
            var widget = Alloy.createWidget("ma.car.app.trip", "editTrip", {
                tripId: tripId,
                __parentSymbol: $.getView(),
                navigation: navigation
            });
            navigation.init({
                index: widget,
                historyLimit: 20,
                mainWindow: popupWindowView,
                transition: "none",
                navBarVisible: true,
                modal: true,
                skipModalOpening: false
            });
            popupWindowView.fireEvent("open");
            $.tripWindow.add(widget.getView());
        }
    }))();
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;