function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "ma.car.app.webview/" + s : s.substring(0, index) + "/ma.car.app.webview/" + s.substring(index + 1);
    return true && 0 !== path.indexOf("/") ? "/" + path : path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("ma.car.app.webview");
    this.__widgetId = "ma.car.app.webview";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    if (arguments[0]) {
        var __parentSymbol = __processArg(arguments[0], "__parentSymbol");
        var $model = __processArg(arguments[0], "$model");
        var __itemTemplate = __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.webviewContainer = Ti.UI.createView({
        layout: "composite",
        top: 0,
        left: 0,
        width: "100%",
        backgroundColor: "#fff",
        showHorizontalScrollIndicator: false,
        showVerticalScrollIndicator: false,
        id: "webviewContainer"
    });
    $.__views.webviewContainer && $.addTopLevelView($.__views.webviewContainer);
    exports.destroy = function() {};
    _.extend($, $.__views);
    "use strict";
    var webview = null;
    !function() {
        var os = require("/platform/os"), dimension = require("/platform/dimension"), statusBarHeight = dimension.statusBarHeightInSystemUnit(), windowHeight = dimension.windowHeightInSystemUnit();
        var platformConfig = function() {
            androidConfig();
        };
        var iosConfig = function() {
            os.isIOS7Plus() && ($.shell.top = statusBarHeight);
            $.shell.height = windowHeight + 1;
            webview = $.webview;
            webview.addEventListener("load", function(e) {
                webview.fireEvent("carma:webview.load", e);
            });
        };
        var androidConfig = function() {
            var webviewModule = require("ma.car.ti.module.webview.android");
            var carmaWebView = webviewModule.createCarmaWebView({
                enableZoomControls: false
            });
            $.webviewContainer.add(carmaWebView);
            webview = carmaWebView;
        };
        var listenToWebViewEvents = function() {
            webview.addEventListener("carma:webview.load", function(e) {
                webview.focus();
                LOGGER.info("after load: " + e.url);
            });
        };
        platformConfig();
        listenToWebViewEvents();
    }();
    exports.webview = webview;
    exports.openURL = function(url) {
        webview.url = url;
    };
    _.extend($, exports);
    $.postConstruct && $.postConstruct();
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;