"use strict";

module.exports = {
    current: function() {
        var user = require("services/resource_owner_service").singleton().toJSON();
        var current = Alloy.createModel("action_record", {
            id: user.userId
        });
        current.fetch();
        return current;
    },
    get: function(key) {
        return this.current().get(key);
    },
    set: function(key, value) {
        var current = this.current();
        current.set(key, value);
        current.save();
    }
};