"use strict";

module.exports = {
    saveTag: function(attrs) {
        var resourceOwner = require("services/resource_owner_service").singleton();
        return Alloy.createModel("toll_tag").saveTag(attrs, resourceOwner.get("userId"));
    },
    getTags: function() {
        var resourceOwner = require("services/resource_owner_service").singleton();
        return Alloy.createModel("toll_tag").getTags({
            userId: resourceOwner.get("userId")
        });
    },
    deleteTag: function(attrs, tagId) {
        var resourceOwner = require("services/resource_owner_service").singleton();
        return Alloy.createModel("toll_tag", {
            id: tagId
        }).deleteTag(attrs, resourceOwner.get("userId"), tagId);
    },
    updateTag: function(attrs, tagId) {
        var resourceOwner = require("services/resource_owner_service").singleton();
        return Alloy.createModel("toll_tag").updateTag(attrs, resourceOwner.get("userId"), tagId);
    }
};