"use strict";

exports.createLabel = function(args) {
    var label = Ti.UI.createLabel(args);
    var touchHandler = function() {
        label.animate({
            autoreverse: true,
            duration: 50,
            transform: Ti.UI.create2DMatrix({
                scale: .7
            })
        });
    };
    label.addEventListener("touchstart", touchHandler);
    label.cleanUp = function() {
        label.removeEventListener("touchstart", touchHandler);
        label = null;
    };
    return label;
};