"use strict";

var helper = {
    isNativeTabs: false,
    initTabs: function(data) {
        this.isNativeTabs = true;
        Alloy.createWidget("ma.car.app.tabgroup", "widget", data).getView().open();
    },
    isUsingNativeTabs: function() {
        return this.isNativeTabs;
    },
    rootWindow: function() {
        Alloy.Globals.Window || (Alloy.Globals.Window = {});
        Alloy.Globals.Window.EventRootWindow || (Alloy.Globals.Window.EventRootWindow = Ti.App);
        return Alloy.Globals.Window.EventRootWindow;
    },
    setRootWindow: function(rootWindow) {
        if (!rootWindow) return;
        Alloy.Globals.Window || (Alloy.Globals.Window = {});
        Alloy.Globals.Window.EventRootWindow = rootWindow;
    },
    cleanUp: function() {
        Alloy.Globals.Window.EventRootWindow = null;
    }
};

module.exports = helper;