"use strict";

function pump() {
    if (deferredList.length > 0) {
        isTaskRunning = true;
        _.defer(function() {
            if (deferredList.length > 0) {
                var item = deferredList.shift();
                var deferred = item[0];
                deferred();
                pump();
            } else isTaskRunning = false;
        });
    } else isTaskRunning = false;
}

var deferredList = [];

var isTaskRunning = false;

module.exports = {
    push: function(deferred, key) {
        deferredList.push([ deferred, key ]);
        isTaskRunning || pump();
    },
    remove: function(key) {
        deferredList = key ? _.reject(deferredList, function(item) {
            return item[1] === key;
        }) : [];
    }
};