"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend");

var LocalServerStatus = Backbone.ExtendedModel.extend({
    config: {
        sync: require("/v6/infrastructure/backbone/wORM/Sync")
    },
    wORM: {
        module: "boarding",
        name: "LocalServerStatus"
    },
    initialize: function(attr) {
        attr = attr || {};
    },
    id: function() {
        return this.get("id") || "";
    },
    updatedOn: function() {
        return this.get("updatedOn") || null;
    },
    validate: function() {}
});

module.exports = LocalServerStatus;