"use strict";

var Backbone = require("/v6/infrastructure/backbone/BackboneExtend");

var RideCollection = Backbone.Collection.extend({
    config: {},
    wORM: {
        module: "boarding",
        name: "RideCollection",
        cascadeDelete: true
    },
    initialize: function() {
        this.comparator = function(ride) {
            return ride.get("startTimestamp");
        };
    },
    model: require("/v6/boarding/models/Ride"),
    validate: function() {}
});

module.exports = RideCollection;