"use strict";

var _ = require("/vendor/underscore"), EventEmitter = require("/v6/infrastructure/EventEmitter/Extend");

var CompletenessService = function() {};

CompletenessService.prototype = new EventEmitter();

CompletenessService.prototype.constructor = CompletenessService;

_.extend(CompletenessService.prototype, {
    REFRESH_EVENT: "completeness_refresh",
    refresh: function() {
        this.emitEvent(this.REFRESH_EVENT);
    },
    destroy: function() {
        this.removeEvent();
    }
});

module.exports = CompletenessService;