"use strict";

var ConfigurationService = function() {
    Object.defineProperty(this, "carma_oauth_client", {
        get: function() {
            return "";
        },
        set: function() {
            throw new Error("Invalid operation!");
        }
    });
    Object.defineProperty(this, "carma_oauth_secret", {
        get: function() {
            return "";
        },
        set: function() {
            throw new Error("Invalid operation!");
        }
    });
    Object.defineProperty(this, "profile", {
        get: function() {
            var env = require("/bootstrap/env");
            return env.getProfile();
        },
        set: function() {
            throw new Error("Invalid operation!");
        }
    });
    Object.defineProperty(this, "baseUrl", {
        get: function() {
            var env = require("/bootstrap/env");
            return env.getApiURL();
        },
        set: function() {
            throw new Error("Invalid operation!");
        }
    });
    Object.defineProperty(this, "logsBaseUrl", {
        get: function() {
            return "http://log-dev.car.ma:82";
        },
        set: function() {
            throw new Error("Invalid operation!");
        }
    });
    this.isDev = function() {
        if (this.profile) return "development" == this.profile.id;
        return false;
    };
};

module.exports = ConfigurationService;