"use strict";

var _ = require("/vendor/underscore"), EventEmitter = require("/v6/infrastructure/EventEmitter/Extend");

var ExploreController = function() {};

ExploreController.prototype = new EventEmitter();

ExploreController.prototype.constructor = ExploreController;

_.extend(ExploreController.prototype, {
    FILTERS_CLOSE: "filters_close",
    MENU_BUTTON_CLICK: "menu_button_click",
    SLIDE_DOWN_ANIMATION_TIME: 500,
    _sliding: false,
    setSliding: function(sliding) {
        this._sliding = sliding;
    },
    isSliding: function() {
        return this._sliding;
    }
});

module.exports = new ExploreController();