"use strict";

var _ = require("/vendor/underscore");

var InvalidArguments = function(args) {
    args instanceof Array && (args = args.join(","));
    this.message = _.template("Invalid Arguments: <%= args %>", {
        args: args.toString()
    });
};

InvalidArguments.prototype = new Error();

InvalidArguments.prototype.constructor = InvalidArguments;

module.exports = InvalidArguments;