"use strict";

var EventEmitter = require("/vendor/EventEmitter");

var EventEmitterExtend = function() {};

EventEmitterExtend.prototype = new EventEmitter();

EventEmitterExtend.prototype.constructor = EventEmitterExtend;

var emitEvent = EventEmitterExtend.prototype.emitEvent;

EventEmitterExtend.prototype.emitEvent = function(evt, args, isAsync) {
    if (!(args instanceof Array) && "boolean" == typeof args) {
        isAsync = args;
        args = [];
    }
    if (isAsync) {
        var self = this;
        return TM.push(function() {
            return emitEvent.apply(self, [ evt, args ]);
        });
    }
    return emitEvent.apply(this, [ evt, args ]);
};

module.exports = EventEmitterExtend;