"use strict";

var StringValidator = require("/validator/string_validator");

module.exports = {
    checkCustomTextFieldsEmpty: function(fields) {
        var isEmpty = false;
        for (var i = 0; i < fields.length; i++) {
            var field = fields[i], fieldValue = field.value;
            StringValidator.isEmpty(fieldValue) && (fieldValue = field.text);
            if (StringValidator.isEmpty(fieldValue)) {
                field.showError(field.hintText);
                isEmpty = true;
            }
        }
        return isEmpty;
    }
};