"use strict";

var BaseListItem = require("widget/messenger/MessageBookingRequestListItem");

var ListItem = function(message, options) {
    options = options || {};
    options.showDate = true;
    BaseListItem.apply(this, [ message, options ]);
    this.template = "bookingCancelledMessageTemplate";
};

ListItem.prototype.defaultsStyle = function(previous) {
    return {
        showDate: true,
        showAvatar: true
    };
};

ListItem.prototype = BaseListItem.prototype;

ListItem.prototype.constructor = ListItem;

module.exports = ListItem;